/**
 * @licstart The following is the entire license notice for the
 * JavaScript code in this page
 *
 * Copyright 2023 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * JavaScript code in this page
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=e.pdfjsWorker=t():"function"==typeof define&&define.amd?define("pdfjs-dist/build/pdf.worker",[],(()=>e.pdfjsWorker=t())):"object"==typeof exports?exports["pdfjs-dist/build/pdf.worker"]=e.pdfjsWorker=t():e["pdfjs-dist/build/pdf.worker"]=e.pdfjsWorker=t()}(globalThis,(()=>(()=>{"use strict";var e=[,(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.WorkerTask=t.WorkerMessageHandler=void 0;var n,r=a(2),i=a(3),s=a(4),o=a(6),c=a(10),l=a(68),h=a(73),u=a(104),d=a(105),f=a(72);class g{constructor(e){this.name=e,this.terminated=!1,this._capability=new r.PromiseCapability}get finished(){return this._capability.promise}finish(){this._capability.resolve()}terminate(){this.terminated=!0}ensureNotTerminated(){if(this.terminated)throw new Error("Worker task was terminated")}}t.WorkerTask=g;class p{static setup(e,t){let a=!1;e.on("test",(function(t){a||(a=!0,e.send("test",t instanceof Uint8Array))})),e.on("configure",(function(e){(0,r.setVerbosityLevel)(e.verbosity)})),e.on("GetDocRequest",(function(e){return p.createDocumentHandler(e,t)}))}static createDocumentHandler(e,t){let a,n=!1,p=null;const m=new Set,b=(0,r.getVerbosityLevel)(),{docId:y,apiVersion:w}=e,x="3.11.174";if(w!==x)throw new Error(`The API version "${w}" does not match the Worker version "${x}".`);const S=[];for(const e in[])S.push(e);if(S.length)throw new Error("The `Array.prototype` contains unexpected enumerable properties: "+S.join(", ")+"; thus breaking e.g. `for...in` iteration of `Array`s.");const A=y+"_worker";let k=new u.MessageHandler(A,y,t);function C(){if(n)throw new Error("Worker was terminated")}function v(e){m.add(e)}function F(e){e.finish(),m.delete(e)}async function O(e){await a.ensureDoc("checkHeader"),await a.ensureDoc("parseStartXRef"),await a.ensureDoc("parse",[e]),await a.ensureDoc("checkFirstPage",[e]),await a.ensureDoc("checkLastPage",[e]);const t=await a.ensureDoc("isPureXfa");if(t){const e=new g("loadXfaFonts");v(e),await Promise.all([a.loadXfaFonts(k,e).catch((e=>{})).then((()=>F(e))),a.loadXfaImages()])}const[n,r]=await Promise.all([a.ensureDoc("numPages"),a.ensureDoc("fingerprints")]);return{numPages:n,fingerprints:r,htmlForXfa:t?await a.ensureDoc("htmlForXfa"):null}}function I({data:e,password:t,disableAutoFetch:a,rangeChunkSize:n,length:s,docBaseUrl:c,enableXfa:l,evaluatorOptions:h}){const u={source:null,disableAutoFetch:a,docBaseUrl:c,docId:y,enableXfa:l,evaluatorOptions:h,handler:k,length:s,password:t,rangeChunkSize:n},f=new r.PromiseCapability;let g;if(e){try{u.source=e,g=new o.LocalPdfManager(u),f.resolve(g)}catch(e){f.reject(e)}return f.promise}let m,b=[];try{m=new d.PDFWorkerStream(k)}catch(e){return f.reject(e),f.promise}const w=m.getFullReader();w.headersReady.then((function(){if(w.isRangeSupported){u.source=m,u.length=w.contentLength,u.disableAutoFetch||=w.isStreamingSupported,g=new o.NetworkPdfManager(u);for(const e of b)g.sendProgressiveData(e);b=[],f.resolve(g),p=null}})).catch((function(e){f.reject(e),p=null}));let x=0;return new Promise((function(e,t){const a=function({value:e,done:n}){try{if(C(),n)return g||function(){const e=(0,i.arrayBuffersToBytes)(b);s&&e.length!==s&&(0,r.warn)("reported HTTP length is different from actual");try{u.source=e,g=new o.LocalPdfManager(u),f.resolve(g)}catch(e){f.reject(e)}b=[]}(),void(p=null);x+=e.byteLength,w.isStreamingSupported||k.send("DocProgress",{loaded:x,total:Math.max(x,w.contentLength||0)}),g?g.sendProgressiveData(e):b.push(e),w.read().then(a,t)}catch(e){t(e)}};w.read().then(a,t)})).catch((function(e){f.reject(e),p=null})),p=function(e){m.cancelAllRequests(e)},f.promise}return k.on("GetPage",(function(e){return a.getPage(e.pageIndex).then((function(e){return Promise.all([a.ensure(e,"rotate"),a.ensure(e,"ref"),a.ensure(e,"userUnit"),a.ensure(e,"view")]).then((function([e,t,a,n]){return{rotate:e,ref:t,userUnit:a,view:n}}))}))})),k.on("GetPageIndex",(function(e){const t=s.Ref.get(e.num,e.gen);return a.ensureCatalog("getPageIndex",[t])})),k.on("GetDestinations",(function(e){return a.ensureCatalog("destinations")})),k.on("GetDestination",(function(e){return a.ensureCatalog("getDestination",[e.id])})),k.on("GetPageLabels",(function(e){return a.ensureCatalog("pageLabels")})),k.on("GetPageLayout",(function(e){return a.ensureCatalog("pageLayout")})),k.on("GetPageMode",(function(e){return a.ensureCatalog("pageMode")})),k.on("GetViewerPreferences",(function(e){return a.ensureCatalog("viewerPreferences")})),k.on("GetOpenAction",(function(e){return a.ensureCatalog("openAction")})),k.on("GetAttachments",(function(e){return a.ensureCatalog("attachments")})),k.on("GetDocJSActions",(function(e){return a.ensureCatalog("jsActions")})),k.on("GetPageJSActions",(function({pageIndex:e}){return a.getPage(e).then((function(e){return a.ensure(e,"jsActions")}))})),k.on("GetOutline",(function(e){return a.ensureCatalog("documentOutline")})),k.on("GetOptionalContentConfig",(function(e){return a.ensureCatalog("optionalContentConfig")})),k.on("GetPermissions",(function(e){return a.ensureCatalog("permissions")})),k.on("GetMetadata",(function(e){return Promise.all([a.ensureDoc("documentInfo"),a.ensureCatalog("metadata")])})),k.on("GetMarkInfo",(function(e){return a.ensureCatalog("markInfo")})),k.on("GetData",(function(e){return a.requestLoadedStream().then((function(e){return e.bytes}))})),k.on("GetAnnotations",(function({pageIndex:e,intent:t}){return a.getPage(e).then((function(a){const n=new g(`GetAnnotations: page ${e}`);return v(n),a.getAnnotationsData(k,n,t).then((e=>(F(n),e)),(e=>{throw F(n),e}))}))})),k.on("GetFieldObjects",(function(e){return a.ensureDoc("fieldObjects")})),k.on("HasJSActions",(function(e){return a.ensureDoc("hasJSActions")})),k.on("GetCalculationOrderIds",(function(e){return a.ensureDoc("calculationOrderIds")})),k.on("SaveDocument",(async function({isPureXfa:e,numPages:t,annotationStorage:n,filename:o}){const l=[a.requestLoadedStream(),a.ensureCatalog("acroForm"),a.ensureCatalog("acroFormRef"),a.ensureDoc("startXRef"),a.ensureDoc("xref"),a.ensureDoc("linearization"),a.ensureCatalog("structTreeRoot")],u=[],d=e?null:(0,i.getNewAnnotationsMap)(n),[p,m,b,y,w,x,S]=await Promise.all(l),A=w.trailer.getRaw("Root")||null;let C;if(d){S?await S.canUpdateStructTree({pdfManager:a,newAnnotationsByPage:d})&&(C=S):await f.StructTreeRoot.canCreateStructureTree({catalogRef:A,pdfManager:a,newAnnotationsByPage:d})&&(C=null);const e=c.AnnotationFactory.generateImages(n.values(),w,a.evaluatorOptions.isOffscreenCanvasSupported),t=void 0===C?u:[];for(const[n,r]of d)t.push(a.getPage(n).then((t=>{const a=new g(`Save (editor): page ${n}`);return t.saveNewAnnotations(k,a,r,e).finally((function(){F(a)}))})));null===C?u.push(Promise.all(t).then((async e=>(await f.StructTreeRoot.createStructureTree({newAnnotationsByPage:d,xref:w,catalogRef:A,pdfManager:a,newRefs:e}),e)))):C&&u.push(Promise.all(t).then((async e=>(await C.updateStructureTree({newAnnotationsByPage:d,pdfManager:a,newRefs:e}),e))))}if(e)u.push(a.serializeXfaData(n));else for(let e=0;e<t;e++)u.push(a.getPage(e).then((function(t){const a=new g(`Save: page ${e}`);return t.save(k,a,n).finally((function(){F(a)}))})));const v=await Promise.all(u);let O=[],I=null;if(e){if(I=v[0],!I)return p.bytes}else if(O=v.flat(2),0===O.length)return p.bytes;const T=b&&m instanceof s.Dict&&O.some((e=>e.needAppearances)),M=m instanceof s.Dict&&m.get("XFA")||null;let P=null,N=!1;if(Array.isArray(M)){for(let e=0,t=M.length;e<t;e+=2)"datasets"===M[e]&&(P=M[e+1],N=!0);null===P&&(P=w.getNewTemporaryRef())}else M&&(0,r.warn)("Unsupported XFA type.");let D=Object.create(null);if(w.trailer){const e=Object.create(null),t=w.trailer.get("Info")||null;t instanceof s.Dict&&t.forEach(((t,a)=>{"string"==typeof a&&(e[t]=(0,r.stringToPDFString)(a))})),D={rootRef:A,encryptRef:w.trailer.getRaw("Encrypt")||null,newRef:w.getNewTemporaryRef(),infoRef:w.trailer.getRaw("Info")||null,info:e,fileIds:w.trailer.get("ID")||null,startXRef:x?y:w.lastXRefStreamPos??y,filename:o}}return(0,h.incrementalUpdate)({originalData:p.bytes,xrefInfo:D,newRefs:O,xref:w,hasXfa:!!M,xfaDatasetsRef:P,hasXfaDatasetsEntry:N,needAppearances:T,acroFormRef:b,acroForm:m,xfaData:I}).finally((()=>{w.resetNewTemporaryRef()}))})),k.on("GetOperatorList",(function(e,t){const n=e.pageIndex;a.getPage(n).then((function(a){const i=new g(`GetOperatorList: page ${n}`);v(i);const s=b>=r.VerbosityLevel.INFOS?Date.now():0;a.getOperatorList({handler:k,sink:t,task:i,intent:e.intent,cacheKey:e.cacheKey,annotationStorage:e.annotationStorage}).then((function(e){F(i),s&&(0,r.info)(`page=${n+1} - getOperatorList: time=${Date.now()-s}ms, len=${e.length}`),t.close()}),(function(e){F(i),i.terminated||t.error(e)}))}))})),k.on("GetTextContent",(function(e,t){const{pageIndex:n,includeMarkedContent:i,disableNormalization:s}=e;a.getPage(n).then((function(e){const a=new g("GetTextContent: page "+n);v(a);const o=b>=r.VerbosityLevel.INFOS?Date.now():0;e.extractTextContent({handler:k,task:a,sink:t,includeMarkedContent:i,disableNormalization:s}).then((function(){F(a),o&&(0,r.info)(`page=${n+1} - getTextContent: time=`+(Date.now()-o)+"ms"),t.close()}),(function(e){F(a),a.terminated||t.error(e)}))}))})),k.on("GetStructTree",(function(e){return a.getPage(e.pageIndex).then((function(e){return a.ensure(e,"getStructTree")}))})),k.on("FontFallback",(function(e){return a.fontFallback(e.id,k)})),k.on("Cleanup",(function(e){return a.cleanup(!0)})),k.on("Terminate",(function(e){n=!0;const t=[];if(a){a.terminate(new r.AbortException("Worker was terminated."));const e=a.cleanup();t.push(e),a=null}else(0,l.clearGlobalCaches)();p&&p(new r.AbortException("Worker was terminated."));for(const e of m)t.push(e.finished),e.terminate();return Promise.all(t).then((function(){k.destroy(),k=null}))})),k.on("Ready",(function(t){!function(e){function t(e){C(),k.send("GetDoc",{pdfInfo:e})}function s(e){if(C(),e instanceof r.PasswordException){const t=new g(`PasswordException: response ${e.code}`);v(t),k.sendWithPromise("PasswordRequest",e).then((function({password:e}){F(t),a.updatePassword(e),o()})).catch((function(){F(t),k.send("DocException",e)}))}else e instanceof r.InvalidPDFException||e instanceof r.MissingPDFException||e instanceof r.UnexpectedResponseException||e instanceof r.UnknownErrorException?k.send("DocException",e):k.send("DocException",new r.UnknownErrorException(e.message,e.toString()))}function o(){C(),O(!1).then(t,(function(e){C(),e instanceof i.XRefParseException?a.requestLoadedStream().then((function(){C(),O(!0).then(t,s)})):s(e)}))}C(),I(e).then((function(e){if(n)throw e.terminate(new r.AbortException("Worker was terminated.")),new Error("Worker was terminated");a=e,a.requestLoadedStream(!0).then((e=>{k.send("DataLoaded",{length:e.bytes.byteLength})}))})).then(o,s)}(e),e=null})),A}static initializeFromPort(e){const t=new u.MessageHandler("worker","main",e);p.setup(t,e),t.send("ready",null)}}t.WorkerMessageHandler=p,"undefined"==typeof window&&!r.isNodeJS&&"undefined"!=typeof self&&("function"==typeof(n=self).postMessage&&"onmessage"in n)&&p.initializeFromPort(self)},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.VerbosityLevel=t.Util=t.UnknownErrorException=t.UnexpectedResponseException=t.TextRenderingMode=t.RenderingIntentFlag=t.PromiseCapability=t.PermissionFlag=t.PasswordResponses=t.PasswordException=t.PageActionEventType=t.OPS=t.MissingPDFException=t.MAX_IMAGE_SIZE_TO_CACHE=t.LINE_FACTOR=t.LINE_DESCENT_FACTOR=t.InvalidPDFException=t.ImageKind=t.IDENTITY_MATRIX=t.FormatError=t.FeatureTest=t.FONT_IDENTITY_MATRIX=t.DocumentActionEventType=t.CMapCompressionType=t.BaseException=t.BASELINE_FACTOR=t.AnnotationType=t.AnnotationReplyType=t.AnnotationPrefix=t.AnnotationMode=t.AnnotationFlag=t.AnnotationFieldFlag=t.AnnotationEditorType=t.AnnotationEditorPrefix=t.AnnotationEditorParamsType=t.AnnotationBorderStyleType=t.AnnotationActionEventType=t.AbortException=void 0,t.assert=function(e,t){e||s(t)},t.bytesToString=l,t.createValidAbsoluteUrl=function(e,t=null,a=null){if(!e)return null;try{if(a&&"string"==typeof e){if(a.addDefaultProtocol&&e.startsWith("www.")){const t=e.match(/\./g);t?.length>=2&&(e=`http://${e}`)}if(a.tryConvertEncoding)try{e=f(e)}catch{}}const n=t?new URL(e,t):new URL(e);if(function(e){switch(e?.protocol){case"http:":case"https:":case"ftp:":case"mailto:":case"tel:":return!0;default:return!1}}(n))return n}catch{}return null},t.getModificationDate=function(e=new Date){return[e.getUTCFullYear().toString(),(e.getUTCMonth()+1).toString().padStart(2,"0"),e.getUTCDate().toString().padStart(2,"0"),e.getUTCHours().toString().padStart(2,"0"),e.getUTCMinutes().toString().padStart(2,"0"),e.getUTCSeconds().toString().padStart(2,"0")].join("")},t.getUuid=function(){if("undefined"!=typeof crypto&&"function"==typeof crypto?.randomUUID)return crypto.randomUUID();const e=new Uint8Array(32);if("undefined"!=typeof crypto&&"function"==typeof crypto?.getRandomValues)crypto.getRandomValues(e);else for(let t=0;t<32;t++)e[t]=Math.floor(255*Math.random());return l(e)},t.getVerbosityLevel=function(){return r},t.info=function(e){r>=n.INFOS&&console.log(`Info: ${e}`)},t.isArrayBuffer=function(e){return"object"==typeof e&&void 0!==e?.byteLength},t.isArrayEqual=function(e,t){if(e.length!==t.length)return!1;for(let a=0,n=e.length;a<n;a++)if(e[a]!==t[a])return!1;return!0},t.isNodeJS=void 0,t.normalizeUnicode=function(e){g||(g=/([\u00a0\u00b5\u037e\u0eb3\u2000-\u200a\u202f\u2126\ufb00-\ufb04\ufb06\ufb20-\ufb36\ufb38-\ufb3c\ufb3e\ufb40-\ufb41\ufb43-\ufb44\ufb46-\ufba1\ufba4-\ufba9\ufbae-\ufbb1\ufbd3-\ufbdc\ufbde-\ufbe7\ufbea-\ufbf8\ufbfc-\ufbfd\ufc00-\ufc5d\ufc64-\ufcf1\ufcf5-\ufd3d\ufd88\ufdf4\ufdfa-\ufdfb\ufe71\ufe77\ufe79\ufe7b\ufe7d]+)|(\ufb05+)/gu,p=new Map([["ﬅ","ſt"]]));return e.replaceAll(g,((e,t,a)=>t?t.normalize("NFKC"):p.get(a)))},t.objectFromMap=function(e){const t=Object.create(null);for(const[a,n]of e)t[a]=n;return t},t.objectSize=function(e){return Object.keys(e).length},t.setVerbosityLevel=function(e){Number.isInteger(e)&&(r=e)},t.shadow=o,t.string32=function(e){return String.fromCharCode(e>>24&255,e>>16&255,e>>8&255,255&e)},t.stringToBytes=h,t.stringToPDFString=function(e){if(e[0]>="ï"){let t;if("þ"===e[0]&&"ÿ"===e[1]?t="utf-16be":"ÿ"===e[0]&&"þ"===e[1]?t="utf-16le":"ï"===e[0]&&"»"===e[1]&&"¿"===e[2]&&(t="utf-8"),t)try{const a=new TextDecoder(t,{fatal:!0}),n=h(e);return a.decode(n)}catch(e){i(`stringToPDFString: "${e}".`)}}const t=[];for(let a=0,n=e.length;a<n;a++){const n=d[e.charCodeAt(a)];t.push(n?String.fromCharCode(n):e.charAt(a))}return t.join("")},t.stringToUTF8String=f,t.unreachable=s,t.utf8StringToString=function(e){return unescape(encodeURIComponent(e))},t.warn=i;const a=!("object"!=typeof process||process+""!="[object process]"||process.versions.nw||process.versions.electron&&process.type&&"browser"!==process.type);t.isNodeJS=a;t.IDENTITY_MATRIX=[1,0,0,1,0,0];t.FONT_IDENTITY_MATRIX=[.001,0,0,.001,0,0];t.MAX_IMAGE_SIZE_TO_CACHE=1e7;t.LINE_FACTOR=1.35;t.LINE_DESCENT_FACTOR=.35;t.BASELINE_FACTOR=.25925925925925924;t.RenderingIntentFlag={ANY:1,DISPLAY:2,PRINT:4,SAVE:8,ANNOTATIONS_FORMS:16,ANNOTATIONS_STORAGE:32,ANNOTATIONS_DISABLE:64,OPLIST:256};t.AnnotationMode={DISABLE:0,ENABLE:1,ENABLE_FORMS:2,ENABLE_STORAGE:3};t.AnnotationEditorPrefix="pdfjs_internal_editor_";t.AnnotationEditorType={DISABLE:-1,NONE:0,FREETEXT:3,STAMP:13,INK:15};t.AnnotationEditorParamsType={RESIZE:1,CREATE:2,FREETEXT_SIZE:11,FREETEXT_COLOR:12,FREETEXT_OPACITY:13,INK_COLOR:21,INK_THICKNESS:22,INK_OPACITY:23};t.PermissionFlag={PRINT:4,MODIFY_CONTENTS:8,COPY:16,MODIFY_ANNOTATIONS:32,FILL_INTERACTIVE_FORMS:256,COPY_FOR_ACCESSIBILITY:512,ASSEMBLE:1024,PRINT_HIGH_QUALITY:2048};t.TextRenderingMode={FILL:0,STROKE:1,FILL_STROKE:2,INVISIBLE:3,FILL_ADD_TO_PATH:4,STROKE_ADD_TO_PATH:5,FILL_STROKE_ADD_TO_PATH:6,ADD_TO_PATH:7,FILL_STROKE_MASK:3,ADD_TO_PATH_FLAG:4};t.ImageKind={GRAYSCALE_1BPP:1,RGB_24BPP:2,RGBA_32BPP:3};t.AnnotationType={TEXT:1,LINK:2,FREETEXT:3,LINE:4,SQUARE:5,CIRCLE:6,POLYGON:7,POLYLINE:8,HIGHLIGHT:9,UNDERLINE:10,SQUIGGLY:11,STRIKEOUT:12,STAMP:13,CARET:14,INK:15,POPUP:16,FILEATTACHMENT:17,SOUND:18,MOVIE:19,WIDGET:20,SCREEN:21,PRINTERMARK:22,TRAPNET:23,WATERMARK:24,THREED:25,REDACT:26};t.AnnotationReplyType={GROUP:"Group",REPLY:"R"};t.AnnotationFlag={INVISIBLE:1,HIDDEN:2,PRINT:4,NOZOOM:8,NOROTATE:16,NOVIEW:32,READONLY:64,LOCKED:128,TOGGLENOVIEW:256,LOCKEDCONTENTS:512};t.AnnotationFieldFlag={READONLY:1,REQUIRED:2,NOEXPORT:4,MULTILINE:4096,PASSWORD:8192,NOTOGGLETOOFF:16384,RADIO:32768,PUSHBUTTON:65536,COMBO:131072,EDIT:262144,SORT:524288,FILESELECT:1048576,MULTISELECT:2097152,DONOTSPELLCHECK:4194304,DONOTSCROLL:8388608,COMB:16777216,RICHTEXT:33554432,RADIOSINUNISON:33554432,COMMITONSELCHANGE:67108864};t.AnnotationBorderStyleType={SOLID:1,DASHED:2,BEVELED:3,INSET:4,UNDERLINE:5};t.AnnotationActionEventType={E:"Mouse Enter",X:"Mouse Exit",D:"Mouse Down",U:"Mouse Up",Fo:"Focus",Bl:"Blur",PO:"PageOpen",PC:"PageClose",PV:"PageVisible",PI:"PageInvisible",K:"Keystroke",F:"Format",V:"Validate",C:"Calculate"};t.DocumentActionEventType={WC:"WillClose",WS:"WillSave",DS:"DidSave",WP:"WillPrint",DP:"DidPrint"};t.PageActionEventType={O:"PageOpen",C:"PageClose"};const n={ERRORS:0,WARNINGS:1,INFOS:5};t.VerbosityLevel=n;t.CMapCompressionType={NONE:0,BINARY:1};t.OPS={dependency:1,setLineWidth:2,setLineCap:3,setLineJoin:4,setMiterLimit:5,setDash:6,setRenderingIntent:7,setFlatness:8,setGState:9,save:10,restore:11,transform:12,moveTo:13,lineTo:14,curveTo:15,curveTo2:16,curveTo3:17,closePath:18,rectangle:19,stroke:20,closeStroke:21,fill:22,eoFill:23,fillStroke:24,eoFillStroke:25,closeFillStroke:26,closeEOFillStroke:27,endPath:28,clip:29,eoClip:30,beginText:31,endText:32,setCharSpacing:33,setWordSpacing:34,setHScale:35,setLeading:36,setFont:37,setTextRenderingMode:38,setTextRise:39,moveText:40,setLeadingMoveText:41,setTextMatrix:42,nextLine:43,showText:44,showSpacedText:45,nextLineShowText:46,nextLineSetSpacingShowText:47,setCharWidth:48,setCharWidthAndBounds:49,setStrokeColorSpace:50,setFillColorSpace:51,setStrokeColor:52,setStrokeColorN:53,setFillColor:54,setFillColorN:55,setStrokeGray:56,setFillGray:57,setStrokeRGBColor:58,setFillRGBColor:59,setStrokeCMYKColor:60,setFillCMYKColor:61,shadingFill:62,beginInlineImage:63,beginImageData:64,endInlineImage:65,paintXObject:66,markPoint:67,markPointProps:68,beginMarkedContent:69,beginMarkedContentProps:70,endMarkedContent:71,beginCompat:72,endCompat:73,paintFormXObjectBegin:74,paintFormXObjectEnd:75,beginGroup:76,endGroup:77,beginAnnotation:80,endAnnotation:81,paintImageMaskXObject:83,paintImageMaskXObjectGroup:84,paintImageXObject:85,paintInlineImageXObject:86,paintInlineImageXObjectGroup:87,paintImageXObjectRepeat:88,paintImageMaskXObjectRepeat:89,paintSolidColorImageMask:90,constructPath:91};t.PasswordResponses={NEED_PASSWORD:1,INCORRECT_PASSWORD:2};let r=n.WARNINGS;function i(e){r>=n.WARNINGS&&console.log(`Warning: ${e}`)}function s(e){throw new Error(e)}function o(e,t,a,n=!1){return Object.defineProperty(e,t,{value:a,enumerable:!n,configurable:!0,writable:!1}),a}const c=function(){function e(t,a){this.constructor===e&&s("Cannot initialize BaseException."),this.message=t,this.name=a}return e.prototype=new Error,e.constructor=e,e}();t.BaseException=c;t.PasswordException=class extends c{constructor(e,t){super(e,"PasswordException"),this.code=t}};t.UnknownErrorException=class extends c{constructor(e,t){super(e,"UnknownErrorException"),this.details=t}};t.InvalidPDFException=class extends c{constructor(e){super(e,"InvalidPDFException")}};t.MissingPDFException=class extends c{constructor(e){super(e,"MissingPDFException")}};t.UnexpectedResponseException=class extends c{constructor(e,t){super(e,"UnexpectedResponseException"),this.status=t}};t.FormatError=class extends c{constructor(e){super(e,"FormatError")}};function l(e){"object"==typeof e&&void 0!==e?.length||s("Invalid argument for bytesToString");const t=e.length,a=8192;if(t<a)return String.fromCharCode.apply(null,e);const n=[];for(let r=0;r<t;r+=a){const i=Math.min(r+a,t),s=e.subarray(r,i);n.push(String.fromCharCode.apply(null,s))}return n.join("")}function h(e){"string"!=typeof e&&s("Invalid argument for stringToBytes");const t=e.length,a=new Uint8Array(t);for(let n=0;n<t;++n)a[n]=255&e.charCodeAt(n);return a}t.AbortException=class extends c{constructor(e){super(e,"AbortException")}};t.FeatureTest=class{static get isLittleEndian(){return o(this,"isLittleEndian",function(){const e=new Uint8Array(4);return e[0]=1,1===new Uint32Array(e.buffer,0,1)[0]}())}static get isEvalSupported(){return o(this,"isEvalSupported",function(){try{return new Function(""),!0}catch{return!1}}())}static get isOffscreenCanvasSupported(){return o(this,"isOffscreenCanvasSupported","undefined"!=typeof OffscreenCanvas)}static get platform(){return"undefined"==typeof navigator?o(this,"platform",{isWin:!1,isMac:!1}):o(this,"platform",{isWin:navigator.platform.includes("Win"),isMac:navigator.platform.includes("Mac")})}static get isCSSRoundSupported(){return o(this,"isCSSRoundSupported",globalThis.CSS?.supports?.("width: round(1.5px, 1px)"))}};const u=[...Array(256).keys()].map((e=>e.toString(16).padStart(2,"0")));t.Util=class{static makeHexColor(e,t,a){return`#${u[e]}${u[t]}${u[a]}`}static scaleMinMax(e,t){let a;e[0]?(e[0]<0&&(a=t[0],t[0]=t[1],t[1]=a),t[0]*=e[0],t[1]*=e[0],e[3]<0&&(a=t[2],t[2]=t[3],t[3]=a),t[2]*=e[3],t[3]*=e[3]):(a=t[0],t[0]=t[2],t[2]=a,a=t[1],t[1]=t[3],t[3]=a,e[1]<0&&(a=t[2],t[2]=t[3],t[3]=a),t[2]*=e[1],t[3]*=e[1],e[2]<0&&(a=t[0],t[0]=t[1],t[1]=a),t[0]*=e[2],t[1]*=e[2]),t[0]+=e[4],t[1]+=e[4],t[2]+=e[5],t[3]+=e[5]}static transform(e,t){return[e[0]*t[0]+e[2]*t[1],e[1]*t[0]+e[3]*t[1],e[0]*t[2]+e[2]*t[3],e[1]*t[2]+e[3]*t[3],e[0]*t[4]+e[2]*t[5]+e[4],e[1]*t[4]+e[3]*t[5]+e[5]]}static applyTransform(e,t){return[e[0]*t[0]+e[1]*t[2]+t[4],e[0]*t[1]+e[1]*t[3]+t[5]]}static applyInverseTransform(e,t){const a=t[0]*t[3]-t[1]*t[2];return[(e[0]*t[3]-e[1]*t[2]+t[2]*t[5]-t[4]*t[3])/a,(-e[0]*t[1]+e[1]*t[0]+t[4]*t[1]-t[5]*t[0])/a]}static getAxialAlignedBoundingBox(e,t){const a=this.applyTransform(e,t),n=this.applyTransform(e.slice(2,4),t),r=this.applyTransform([e[0],e[3]],t),i=this.applyTransform([e[2],e[1]],t);return[Math.min(a[0],n[0],r[0],i[0]),Math.min(a[1],n[1],r[1],i[1]),Math.max(a[0],n[0],r[0],i[0]),Math.max(a[1],n[1],r[1],i[1])]}static inverseTransform(e){const t=e[0]*e[3]-e[1]*e[2];return[e[3]/t,-e[1]/t,-e[2]/t,e[0]/t,(e[2]*e[5]-e[4]*e[3])/t,(e[4]*e[1]-e[5]*e[0])/t]}static singularValueDecompose2dScale(e){const t=[e[0],e[2],e[1],e[3]],a=e[0]*t[0]+e[1]*t[2],n=e[0]*t[1]+e[1]*t[3],r=e[2]*t[0]+e[3]*t[2],i=e[2]*t[1]+e[3]*t[3],s=(a+i)/2,o=Math.sqrt((a+i)**2-4*(a*i-r*n))/2,c=s+o||1,l=s-o||1;return[Math.sqrt(c),Math.sqrt(l)]}static normalizeRect(e){const t=e.slice(0);return e[0]>e[2]&&(t[0]=e[2],t[2]=e[0]),e[1]>e[3]&&(t[1]=e[3],t[3]=e[1]),t}static intersect(e,t){const a=Math.max(Math.min(e[0],e[2]),Math.min(t[0],t[2])),n=Math.min(Math.max(e[0],e[2]),Math.max(t[0],t[2]));if(a>n)return null;const r=Math.max(Math.min(e[1],e[3]),Math.min(t[1],t[3])),i=Math.min(Math.max(e[1],e[3]),Math.max(t[1],t[3]));return r>i?null:[a,r,n,i]}static bezierBoundingBox(e,t,a,n,r,i,s,o){const c=[],l=[[],[]];let h,u,d,f,g,p,m,b;for(let l=0;l<2;++l)if(0===l?(u=6*e-12*a+6*r,h=-3*e+9*a-9*r+3*s,d=3*a-3*e):(u=6*t-12*n+6*i,h=-3*t+9*n-9*i+3*o,d=3*n-3*t),Math.abs(h)<1e-12){if(Math.abs(u)<1e-12)continue;f=-d/u,0<f&&f<1&&c.push(f)}else m=u*u-4*d*h,b=Math.sqrt(m),m<0||(g=(-u+b)/(2*h),0<g&&g<1&&c.push(g),p=(-u-b)/(2*h),0<p&&p<1&&c.push(p));let y,w=c.length;const x=w;for(;w--;)f=c[w],y=1-f,l[0][w]=y*y*y*e+3*y*y*f*a+3*y*f*f*r+f*f*f*s,l[1][w]=y*y*y*t+3*y*y*f*n+3*y*f*f*i+f*f*f*o;return l[0][x]=e,l[1][x]=t,l[0][x+1]=s,l[1][x+1]=o,l[0].length=l[1].length=x+2,[Math.min(...l[0]),Math.min(...l[1]),Math.max(...l[0]),Math.max(...l[1])]}};const d=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,728,711,710,729,733,731,730,732,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8226,8224,8225,8230,8212,8211,402,8260,8249,8250,8722,8240,8222,8220,8221,8216,8217,8218,8482,64257,64258,321,338,352,376,381,305,322,339,353,382,0,8364];function f(e){return decodeURIComponent(escape(e))}t.PromiseCapability=class{#e=!1;constructor(){this.promise=new Promise(((e,t)=>{this.resolve=t=>{this.#e=!0,e(t)},this.reject=e=>{this.#e=!0,t(e)}}))}get settled(){return this.#e}};let g=null,p=null;t.AnnotationPrefix="pdfjs_internal_id_"},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XRefParseException=t.XRefEntryException=t.ParserEOFException=t.PDF_VERSION_REGEXP=t.MissingDataException=void 0,t.arrayBuffersToBytes=function(e){const t=e.length;if(0===t)return new Uint8Array(0);if(1===t)return new Uint8Array(e[0]);let a=0;for(let n=0;n<t;n++)a+=e[n].byteLength;const n=new Uint8Array(a);let r=0;for(let a=0;a<t;a++){const t=new Uint8Array(e[a]);n.set(t,r),r+=t.byteLength}return n},t.collectActions=function(e,t,a){const i=Object.create(null),s=h({dict:t,key:"AA",stopWhenFound:!1});if(s)for(let t=s.length-1;t>=0;t--){const n=s[t];if(n instanceof r.Dict)for(const t of n.getKeys()){const s=a[t];if(!s)continue;const o=[];d(n.getRaw(t),e,o,new r.RefSet),o.length>0&&(i[s]=o)}}if(t.has("A")){const a=[];d(t.get("A"),e,a,new r.RefSet),a.length>0&&(i.Action=a)}return(0,n.objectSize)(i)>0?i:null},t.encodeToXmlString=function(e){const t=[];let a=0;for(let n=0,r=e.length;n<r;n++){const r=e.codePointAt(n);if(32<=r&&r<=126){const i=f[r];i&&(a<n&&t.push(e.substring(a,n)),t.push(i),a=n+1)}else a<n&&t.push(e.substring(a,n)),t.push(`&#x${r.toString(16).toUpperCase()};`),r>55295&&(r<57344||r>65533)&&n++,a=n+1}if(0===t.length)return e;a<e.length&&t.push(e.substring(a,e.length));return t.join("")},t.escapePDFName=function(e){const t=[];let a=0;for(let n=0,r=e.length;n<r;n++){const r=e.charCodeAt(n);(r<33||r>126||35===r||40===r||41===r||60===r||62===r||91===r||93===r||123===r||125===r||47===r||37===r)&&(a<n&&t.push(e.substring(a,n)),t.push(`#${r.toString(16)}`),a=n+1)}if(0===t.length)return e;a<e.length&&t.push(e.substring(a,e.length));return t.join("")},t.escapeString=function(e){return e.replaceAll(/([()\\\n\r])/g,(e=>"\n"===e?"\\n":"\r"===e?"\\r":`\\${e}`))},t.getInheritableProperty=h,t.getLookupTableFactory=function(e){let t;return function(){return e&&(t=Object.create(null),e(t),e=null),t}},t.getNewAnnotationsMap=function(e){if(!e)return null;const t=new Map;for(const[a,r]of e){if(!a.startsWith(n.AnnotationEditorPrefix))continue;let e=t.get(r.pageIndex);e||(e=[],t.set(r.pageIndex,e)),e.push(r)}return t.size>0?t:null},t.getRotationMatrix=function(e,t,a){switch(e){case 90:return[0,1,-1,0,t,0];case 180:return[-1,0,0,-1,t,a];case 270:return[0,-1,1,0,0,a];default:throw new Error("Invalid rotation")}},t.isAscii=function(e){return/^[\x00-\x7F]*$/.test(e)},t.isWhiteSpace=function(e){return 32===e||9===e||13===e||10===e},t.log2=function(e){if(e<=0)return 0;return Math.ceil(Math.log2(e))},t.numberToString=function(e){if(Number.isInteger(e))return e.toString();const t=Math.round(100*e);if(t%100==0)return(t/100).toString();if(t%10==0)return e.toFixed(1);return e.toFixed(2)},t.parseXFAPath=function(e){const t=/(.+)\[(\d+)\]$/;return e.split(".").map((e=>{const a=e.match(t);return a?{name:a[1],pos:parseInt(a[2],10)}:{name:e,pos:0}}))},t.readInt8=function(e,t){return e[t]<<24>>24},t.readUint16=function(e,t){return e[t]<<8|e[t+1]},t.readUint32=function(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0},t.recoverJsURL=function(e){const t=new RegExp("^\\s*("+["app.launchURL","window.open","xfa.host.gotoURL"].join("|").replaceAll(".","\\.")+")\\((?:'|\")([^'\"]*)(?:'|\")(?:,\\s*(\\w+)\\)|\\))","i").exec(e);if(t?.[2]){const e=t[2];let a=!1;return"true"===t[3]&&"app.launchURL"===t[1]&&(a=!0),{url:e,newWindow:a}}return null},t.stringToUTF16HexString=function(e){const t=[];for(let a=0,n=e.length;a<n;a++){const n=e.charCodeAt(a);t.push((n>>8&255).toString(16).padStart(2,"0"),(255&n).toString(16).padStart(2,"0"))}return t.join("")},t.stringToUTF16String=function(e,t=!1){const a=[];t&&a.push("þÿ");for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);a.push(String.fromCharCode(n>>8&255),String.fromCharCode(255&n))}return a.join("")},t.toRomanNumerals=function(e,t=!1){(0,n.assert)(Number.isInteger(e)&&e>0,"The number should be a positive integer.");const a=[];let r;for(;e>=1e3;)e-=1e3,a.push("M");r=e/100|0,e%=100,a.push(u[r]),r=e/10|0,e%=10,a.push(u[10+r]),a.push(u[20+e]);const i=a.join("");return t?i.toLowerCase():i},t.validateCSSFont=function(e){const t=new Set(["100","200","300","400","500","600","700","800","900","1000","normal","bold","bolder","lighter"]),{fontFamily:a,fontWeight:n,italicAngle:r}=e;if(!g(a,!0))return!1;const i=n?n.toString():"";e.fontWeight=t.has(i)?i:"400";const s=parseFloat(r);return e.italicAngle=isNaN(s)||s<-90||s>90?"14":r.toString(),!0},t.validateFontName=g;var n=a(2),r=a(4),i=a(5);t.PDF_VERSION_REGEXP=/^[1-9]\.\d$/;class s extends n.BaseException{constructor(e,t){super(`Missing data [${e}, ${t})`,"MissingDataException"),this.begin=e,this.end=t}}t.MissingDataException=s;class o extends n.BaseException{constructor(e){super(e,"ParserEOFException")}}t.ParserEOFException=o;class c extends n.BaseException{constructor(e){super(e,"XRefEntryException")}}t.XRefEntryException=c;class l extends n.BaseException{constructor(e){super(e,"XRefParseException")}}function h({dict:e,key:t,getArray:a=!1,stopWhenFound:n=!0}){let i;const s=new r.RefSet;for(;e instanceof r.Dict&&(!e.objId||!s.has(e.objId));){e.objId&&s.put(e.objId);const r=a?e.getArray(t):e.get(t);if(void 0!==r){if(n)return r;(i||=[]).push(r)}e=e.get("Parent")}return i}t.XRefParseException=l;const u=["","C","CC","CCC","CD","D","DC","DCC","DCCC","CM","","X","XX","XXX","XL","L","LX","LXX","LXXX","XC","","I","II","III","IV","V","VI","VII","VIII","IX"];function d(e,t,a,s){if(!e)return;let o=null;if(e instanceof r.Ref){if(s.has(e))return;o=e,s.put(o),e=t.fetch(e)}if(Array.isArray(e))for(const n of e)d(n,t,a,s);else if(e instanceof r.Dict){if((0,r.isName)(e.get("S"),"JavaScript")){const t=e.get("JS");let r;t instanceof i.BaseStream?r=t.getString():"string"==typeof t&&(r=t),r&&=(0,n.stringToPDFString)(r).replaceAll("\0",""),r&&a.push(r)}d(e.getRaw("Next"),t,a,s)}o&&s.remove(o)}const f={60:"&lt;",62:"&gt;",38:"&amp;",34:"&quot;",39:"&apos;"};function g(e,t=!1){const a=/^("|').*("|')$/.exec(e);if(a&&a[1]===a[2]){if(new RegExp(`[^\\\\]${a[1]}`).test(e.slice(1,-1)))return t&&(0,n.warn)(`FontFamily contains unescaped ${a[1]}: ${e}.`),!1}else for(const a of e.split(/[ \t]+/))if(/^(\d|(-(\d|-)))/.test(a)||!/^[\w-\\]+$/.test(a))return t&&(0,n.warn)(`FontFamily contains invalid <custom-ident>: ${e}.`),!1;return!0}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.RefSetCache=t.RefSet=t.Ref=t.Name=t.EOF=t.Dict=t.Cmd=t.CIRCULAR_REF=void 0,t.clearPrimitiveCaches=function(){s=Object.create(null),o=Object.create(null),c=Object.create(null)},t.isCmd=function(e,t){return e instanceof h&&(void 0===t||e.cmd===t)},t.isDict=function(e,t){return e instanceof d&&(void 0===t||m(e.get("Type"),t))},t.isName=m,t.isRefsEqual=function(e,t){return e.num===t.num&&e.gen===t.gen};var n=a(2);const r=Symbol("CIRCULAR_REF");t.CIRCULAR_REF=r;const i=Symbol("EOF");t.EOF=i;let s=Object.create(null),o=Object.create(null),c=Object.create(null);class l{constructor(e){this.name=e}static get(e){return o[e]||=new l(e)}}t.Name=l;class h{constructor(e){this.cmd=e}static get(e){return s[e]||=new h(e)}}t.Cmd=h;const u=function(){return u};class d{constructor(e=null){this._map=Object.create(null),this.xref=e,this.objId=null,this.suppressEncryption=!1,this.__nonSerializable__=u}assignXref(e){this.xref=e}get size(){return Object.keys(this._map).length}get(e,t,a){let n=this._map[e];return void 0===n&&void 0!==t&&(n=this._map[t],void 0===n&&void 0!==a&&(n=this._map[a])),n instanceof f&&this.xref?this.xref.fetch(n,this.suppressEncryption):n}async getAsync(e,t,a){let n=this._map[e];return void 0===n&&void 0!==t&&(n=this._map[t],void 0===n&&void 0!==a&&(n=this._map[a])),n instanceof f&&this.xref?this.xref.fetchAsync(n,this.suppressEncryption):n}getArray(e,t,a){let n=this._map[e];if(void 0===n&&void 0!==t&&(n=this._map[t],void 0===n&&void 0!==a&&(n=this._map[a])),n instanceof f&&this.xref&&(n=this.xref.fetch(n,this.suppressEncryption)),Array.isArray(n)){n=n.slice();for(let e=0,t=n.length;e<t;e++)n[e]instanceof f&&this.xref&&(n[e]=this.xref.fetch(n[e],this.suppressEncryption))}return n}getRaw(e){return this._map[e]}getKeys(){return Object.keys(this._map)}getRawValues(){return Object.values(this._map)}set(e,t){this._map[e]=t}has(e){return void 0!==this._map[e]}forEach(e){for(const t in this._map)e(t,this.get(t))}static get empty(){const e=new d(null);return e.set=(e,t)=>{(0,n.unreachable)("Should not call `set` on the empty dictionary.")},(0,n.shadow)(this,"empty",e)}static merge({xref:e,dictArray:t,mergeSubDicts:a=!1}){const n=new d(e),r=new Map;for(const e of t)if(e instanceof d)for(const[t,n]of Object.entries(e._map)){let e=r.get(t);if(void 0===e)e=[],r.set(t,e);else if(!(a&&n instanceof d))continue;e.push(n)}for(const[t,a]of r){if(1===a.length||!(a[0]instanceof d)){n._map[t]=a[0];continue}const r=new d(e);for(const e of a)for(const[t,a]of Object.entries(e._map))void 0===r._map[t]&&(r._map[t]=a);r.size>0&&(n._map[t]=r)}return r.clear(),n.size>0?n:d.empty}clone(){const e=new d(this.xref);for(const t of this.getKeys())e.set(t,this.getRaw(t));return e}}t.Dict=d;class f{constructor(e,t){this.num=e,this.gen=t}toString(){return 0===this.gen?`${this.num}R`:`${this.num}R${this.gen}`}static fromString(e){const t=c[e];if(t)return t;const a=/^(\d+)R(\d*)$/.exec(e);return a&&"0"!==a[1]?c[e]=new f(parseInt(a[1]),a[2]?parseInt(a[2]):0):null}static get(e,t){const a=0===t?`${e}R`:`${e}R${t}`;return c[a]||=new f(e,t)}}t.Ref=f;class g{constructor(e=null){this._set=new Set(e?._set)}has(e){return this._set.has(e.toString())}put(e){this._set.add(e.toString())}remove(e){this._set.delete(e.toString())}[Symbol.iterator](){return this._set.values()}clear(){this._set.clear()}}t.RefSet=g;class p{constructor(){this._map=new Map}get size(){return this._map.size}get(e){return this._map.get(e.toString())}has(e){return this._map.has(e.toString())}put(e,t){this._map.set(e.toString(),t)}putAlias(e,t){this._map.set(e.toString(),this.get(t))}[Symbol.iterator](){return this._map.values()}clear(){this._map.clear()}}function m(e,t){return e instanceof l&&(void 0===t||e.name===t)}t.RefSetCache=p},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.BaseStream=void 0;var n=a(2);class r{constructor(){this.constructor===r&&(0,n.unreachable)("Cannot initialize BaseStream.")}get length(){(0,n.unreachable)("Abstract getter `length` accessed")}get isEmpty(){(0,n.unreachable)("Abstract getter `isEmpty` accessed")}get isDataLoaded(){return(0,n.shadow)(this,"isDataLoaded",!0)}getByte(){(0,n.unreachable)("Abstract method `getByte` called")}getBytes(e){(0,n.unreachable)("Abstract method `getBytes` called")}peekByte(){const e=this.getByte();return-1!==e&&this.pos--,e}peekBytes(e){const t=this.getBytes(e);return this.pos-=t.length,t}getUint16(){const e=this.getByte(),t=this.getByte();return-1===e||-1===t?-1:(e<<8)+t}getInt32(){return(this.getByte()<<24)+(this.getByte()<<16)+(this.getByte()<<8)+this.getByte()}getByteRange(e,t){(0,n.unreachable)("Abstract method `getByteRange` called")}getString(e){return(0,n.bytesToString)(this.getBytes(e))}skip(e){this.pos+=e||1}reset(){(0,n.unreachable)("Abstract method `reset` called")}moveStart(){(0,n.unreachable)("Abstract method `moveStart` called")}makeSubStream(e,t,a=null){(0,n.unreachable)("Abstract method `makeSubStream` called")}getBaseStreams(){return null}}t.BaseStream=r},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.NetworkPdfManager=t.LocalPdfManager=void 0;var n=a(2),r=a(7),i=a(3),s=a(9),o=a(8);class c{constructor(e){this.constructor===c&&(0,n.unreachable)("Cannot initialize BasePdfManager."),this._docBaseUrl=function(e){if(e){const t=(0,n.createValidAbsoluteUrl)(e);if(t)return t.href;(0,n.warn)(`Invalid absolute docBaseUrl: "${e}".`)}return null}(e.docBaseUrl),this._docId=e.docId,this._password=e.password,this.enableXfa=e.enableXfa,e.evaluatorOptions.isOffscreenCanvasSupported&&=n.FeatureTest.isOffscreenCanvasSupported,this.evaluatorOptions=e.evaluatorOptions}get docId(){return this._docId}get password(){return this._password}get docBaseUrl(){return this._docBaseUrl}get catalog(){return this.pdfDocument.catalog}ensureDoc(e,t){return this.ensure(this.pdfDocument,e,t)}ensureXRef(e,t){return this.ensure(this.pdfDocument.xref,e,t)}ensureCatalog(e,t){return this.ensure(this.pdfDocument.catalog,e,t)}getPage(e){return this.pdfDocument.getPage(e)}fontFallback(e,t){return this.pdfDocument.fontFallback(e,t)}loadXfaFonts(e,t){return this.pdfDocument.loadXfaFonts(e,t)}loadXfaImages(){return this.pdfDocument.loadXfaImages()}serializeXfaData(e){return this.pdfDocument.serializeXfaData(e)}cleanup(e=!1){return this.pdfDocument.cleanup(e)}async ensure(e,t,a){(0,n.unreachable)("Abstract method `ensure` called")}requestRange(e,t){(0,n.unreachable)("Abstract method `requestRange` called")}requestLoadedStream(e=!1){(0,n.unreachable)("Abstract method `requestLoadedStream` called")}sendProgressiveData(e){(0,n.unreachable)("Abstract method `sendProgressiveData` called")}updatePassword(e){this._password=e}terminate(e){(0,n.unreachable)("Abstract method `terminate` called")}}t.LocalPdfManager=class extends c{constructor(e){super(e);const t=new o.Stream(e.source);this.pdfDocument=new s.PDFDocument(this,t),this._loadedStreamPromise=Promise.resolve(t)}async ensure(e,t,a){const n=e[t];return"function"==typeof n?n.apply(e,a):n}requestRange(e,t){return Promise.resolve()}requestLoadedStream(e=!1){return this._loadedStreamPromise}terminate(e){}};t.NetworkPdfManager=class extends c{constructor(e){super(e),this.streamManager=new r.ChunkedStreamManager(e.source,{msgHandler:e.handler,length:e.length,disableAutoFetch:e.disableAutoFetch,rangeChunkSize:e.rangeChunkSize}),this.pdfDocument=new s.PDFDocument(this,this.streamManager.getStream())}async ensure(e,t,a){try{const n=e[t];return"function"==typeof n?n.apply(e,a):n}catch(n){if(!(n instanceof i.MissingDataException))throw n;return await this.requestRange(n.begin,n.end),this.ensure(e,t,a)}}requestRange(e,t){return this.streamManager.requestRange(e,t)}requestLoadedStream(e=!1){return this.streamManager.requestAllChunks(e)}sendProgressiveData(e){this.streamManager.onReceiveData({chunk:e})}terminate(e){this.streamManager.abort(e)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ChunkedStreamManager=t.ChunkedStream=void 0;var n=a(3),r=a(2),i=a(8);class s extends i.Stream{constructor(e,t,a){super(new Uint8Array(e),0,e,null),this.chunkSize=t,this._loadedChunks=new Set,this.numChunks=Math.ceil(e/t),this.manager=a,this.progressiveDataLength=0,this.lastSuccessfulEnsureByteChunk=-1}getMissingChunks(){const e=[];for(let t=0,a=this.numChunks;t<a;++t)this._loadedChunks.has(t)||e.push(t);return e}get numChunksLoaded(){return this._loadedChunks.size}get isDataLoaded(){return this.numChunksLoaded===this.numChunks}onReceiveData(e,t){const a=this.chunkSize;if(e%a!=0)throw new Error(`Bad begin offset: ${e}`);const n=e+t.byteLength;if(n%a!=0&&n!==this.bytes.length)throw new Error(`Bad end offset: ${n}`);this.bytes.set(new Uint8Array(t),e);const r=Math.floor(e/a),i=Math.floor((n-1)/a)+1;for(let e=r;e<i;++e)this._loadedChunks.add(e)}onReceiveProgressiveData(e){let t=this.progressiveDataLength;const a=Math.floor(t/this.chunkSize);this.bytes.set(new Uint8Array(e),t),t+=e.byteLength,this.progressiveDataLength=t;const n=t>=this.end?this.numChunks:Math.floor(t/this.chunkSize);for(let e=a;e<n;++e)this._loadedChunks.add(e)}ensureByte(e){if(e<this.progressiveDataLength)return;const t=Math.floor(e/this.chunkSize);if(!(t>this.numChunks)&&t!==this.lastSuccessfulEnsureByteChunk){if(!this._loadedChunks.has(t))throw new n.MissingDataException(e,e+1);this.lastSuccessfulEnsureByteChunk=t}}ensureRange(e,t){if(e>=t)return;if(t<=this.progressiveDataLength)return;const a=Math.floor(e/this.chunkSize);if(a>this.numChunks)return;const r=Math.min(Math.floor((t-1)/this.chunkSize)+1,this.numChunks);for(let i=a;i<r;++i)if(!this._loadedChunks.has(i))throw new n.MissingDataException(e,t)}nextEmptyChunk(e){const t=this.numChunks;for(let a=0;a<t;++a){const n=(e+a)%t;if(!this._loadedChunks.has(n))return n}return null}hasChunk(e){return this._loadedChunks.has(e)}getByte(){const e=this.pos;return e>=this.end?-1:(e>=this.progressiveDataLength&&this.ensureByte(e),this.bytes[this.pos++])}getBytes(e){const t=this.bytes,a=this.pos,n=this.end;if(!e)return n>this.progressiveDataLength&&this.ensureRange(a,n),t.subarray(a,n);let r=a+e;return r>n&&(r=n),r>this.progressiveDataLength&&this.ensureRange(a,r),this.pos=r,t.subarray(a,r)}getByteRange(e,t){return e<0&&(e=0),t>this.end&&(t=this.end),t>this.progressiveDataLength&&this.ensureRange(e,t),this.bytes.subarray(e,t)}makeSubStream(e,t,a=null){function n(){}t?e+t>this.progressiveDataLength&&this.ensureRange(e,e+t):e>=this.progressiveDataLength&&this.ensureByte(e),n.prototype=Object.create(this),n.prototype.getMissingChunks=function(){const e=this.chunkSize,t=Math.floor(this.start/e),a=Math.floor((this.end-1)/e)+1,n=[];for(let e=t;e<a;++e)this._loadedChunks.has(e)||n.push(e);return n},Object.defineProperty(n.prototype,"isDataLoaded",{get(){return this.numChunksLoaded===this.numChunks||0===this.getMissingChunks().length},configurable:!0});const r=new n;return r.pos=r.start=e,r.end=e+t||this.end,r.dict=a,r}getBaseStreams(){return[this]}}t.ChunkedStream=s;t.ChunkedStreamManager=class{constructor(e,t){this.length=t.length,this.chunkSize=t.rangeChunkSize,this.stream=new s(this.length,this.chunkSize,this),this.pdfNetworkStream=e,this.disableAutoFetch=t.disableAutoFetch,this.msgHandler=t.msgHandler,this.currRequestId=0,this._chunksNeededByRequest=new Map,this._requestsByChunk=new Map,this._promisesByRequest=new Map,this.progressiveDataLength=0,this.aborted=!1,this._loadedStreamCapability=new r.PromiseCapability}sendRequest(e,t){const a=this.pdfNetworkStream.getRangeReader(e,t);a.isStreamingSupported||(a.onProgress=this.onProgress.bind(this));let r=[],i=0;return new Promise(((e,t)=>{const s=({value:o,done:c})=>{try{if(c){const t=(0,n.arrayBuffersToBytes)(r);return r=null,void e(t)}i+=o.byteLength,a.isStreamingSupported&&this.onProgress({loaded:i}),r.push(o),a.read().then(s,t)}catch(e){t(e)}};a.read().then(s,t)})).then((t=>{this.aborted||this.onReceiveData({chunk:t,begin:e})}))}requestAllChunks(e=!1){if(!e){const e=this.stream.getMissingChunks();this._requestChunks(e)}return this._loadedStreamCapability.promise}_requestChunks(e){const t=this.currRequestId++,a=new Set;this._chunksNeededByRequest.set(t,a);for(const t of e)this.stream.hasChunk(t)||a.add(t);if(0===a.size)return Promise.resolve();const n=new r.PromiseCapability;this._promisesByRequest.set(t,n);const i=[];for(const e of a){let a=this._requestsByChunk.get(e);a||(a=[],this._requestsByChunk.set(e,a),i.push(e)),a.push(t)}if(i.length>0){const e=this.groupChunks(i);for(const t of e){const e=t.beginChunk*this.chunkSize,a=Math.min(t.endChunk*this.chunkSize,this.length);this.sendRequest(e,a).catch(n.reject)}}return n.promise.catch((e=>{if(!this.aborted)throw e}))}getStream(){return this.stream}requestRange(e,t){t=Math.min(t,this.length);const a=this.getBeginChunk(e),n=this.getEndChunk(t),r=[];for(let e=a;e<n;++e)r.push(e);return this._requestChunks(r)}requestRanges(e=[]){const t=[];for(const a of e){const e=this.getBeginChunk(a.begin),n=this.getEndChunk(a.end);for(let a=e;a<n;++a)t.includes(a)||t.push(a)}return t.sort((function(e,t){return e-t})),this._requestChunks(t)}groupChunks(e){const t=[];let a=-1,n=-1;for(let r=0,i=e.length;r<i;++r){const i=e[r];a<0&&(a=i),n>=0&&n+1!==i&&(t.push({beginChunk:a,endChunk:n+1}),a=i),r+1===e.length&&t.push({beginChunk:a,endChunk:i+1}),n=i}return t}onProgress(e){this.msgHandler.send("DocProgress",{loaded:this.stream.numChunksLoaded*this.chunkSize+e.loaded,total:this.length})}onReceiveData(e){const t=e.chunk,a=void 0===e.begin,n=a?this.progressiveDataLength:e.begin,r=n+t.byteLength,i=Math.floor(n/this.chunkSize),s=r<this.length?Math.floor(r/this.chunkSize):Math.ceil(r/this.chunkSize);a?(this.stream.onReceiveProgressiveData(t),this.progressiveDataLength=r):this.stream.onReceiveData(n,t),this.stream.isDataLoaded&&this._loadedStreamCapability.resolve(this.stream);const o=[];for(let e=i;e<s;++e){const t=this._requestsByChunk.get(e);if(t){this._requestsByChunk.delete(e);for(const a of t){const t=this._chunksNeededByRequest.get(a);t.has(e)&&t.delete(e),t.size>0||o.push(a)}}}if(!this.disableAutoFetch&&0===this._requestsByChunk.size){let e;if(1===this.stream.numChunksLoaded){const t=this.stream.numChunks-1;this.stream.hasChunk(t)||(e=t)}else e=this.stream.nextEmptyChunk(s);Number.isInteger(e)&&this._requestChunks([e])}for(const e of o){const t=this._promisesByRequest.get(e);this._promisesByRequest.delete(e),t.resolve()}this.msgHandler.send("DocProgress",{loaded:this.stream.numChunksLoaded*this.chunkSize,total:this.length})}onError(e){this._loadedStreamCapability.reject(e)}getBeginChunk(e){return Math.floor(e/this.chunkSize)}getEndChunk(e){return Math.floor((e-1)/this.chunkSize)+1}abort(e){this.aborted=!0,this.pdfNetworkStream?.cancelAllRequests(e);for(const t of this._promisesByRequest.values())t.reject(e)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.StringStream=t.Stream=t.NullStream=void 0;var n=a(5),r=a(2);class i extends n.BaseStream{constructor(e,t,a,n){super(),this.bytes=e instanceof Uint8Array?e:new Uint8Array(e),this.start=t||0,this.pos=this.start,this.end=t+a||this.bytes.length,this.dict=n}get length(){return this.end-this.start}get isEmpty(){return 0===this.length}getByte(){return this.pos>=this.end?-1:this.bytes[this.pos++]}getBytes(e){const t=this.bytes,a=this.pos,n=this.end;if(!e)return t.subarray(a,n);let r=a+e;return r>n&&(r=n),this.pos=r,t.subarray(a,r)}getByteRange(e,t){return e<0&&(e=0),t>this.end&&(t=this.end),this.bytes.subarray(e,t)}reset(){this.pos=this.start}moveStart(){this.start=this.pos}makeSubStream(e,t,a=null){return new i(this.bytes.buffer,e,t,a)}}t.Stream=i;t.StringStream=class extends i{constructor(e){super((0,r.stringToBytes)(e))}};t.NullStream=class extends i{constructor(){super(new Uint8Array(0))}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Page=t.PDFDocument=void 0;var n=a(2),r=a(10),i=a(3),s=a(4),o=a(51),c=a(5),l=a(74),h=a(66),u=a(68),d=a(102),f=a(16),g=a(8),p=a(76),m=a(64),b=a(13),y=a(18),w=a(72),x=a(73),S=a(77),A=a(103);const k=[0,0,612,792];class C{constructor({pdfManager:e,xref:t,pageIndex:a,pageDict:n,ref:r,globalIdFactory:i,fontCache:s,builtInCMapCache:o,standardFontDataCache:c,globalImageCache:l,systemFontCache:h,nonBlendModesSet:u,xfaFactory:d}){this.pdfManager=e,this.pageIndex=a,this.pageDict=n,this.xref=t,this.ref=r,this.fontCache=s,this.builtInCMapCache=o,this.standardFontDataCache=c,this.globalImageCache=l,this.systemFontCache=h,this.nonBlendModesSet=u,this.evaluatorOptions=e.evaluatorOptions,this.resourcesPromise=null,this.xfaFactory=d;const f={obj:0};this._localIdFactory=class extends i{static createObjId(){return`p${a}_${++f.obj}`}static getPageObjId(){return`p${r.toString()}`}}}_getInheritableProperty(e,t=!1){const a=(0,i.getInheritableProperty)({dict:this.pageDict,key:e,getArray:t,stopWhenFound:!1});return Array.isArray(a)?1!==a.length&&a[0]instanceof s.Dict?s.Dict.merge({xref:this.xref,dictArray:a}):a[0]:a}get content(){return this.pageDict.getArray("Contents")}get resources(){const e=this._getInheritableProperty("Resources");return(0,n.shadow)(this,"resources",e instanceof s.Dict?e:s.Dict.empty)}_getBoundingBox(e){if(this.xfaData)return this.xfaData.bbox;let t=this._getInheritableProperty(e,!0);if(Array.isArray(t)&&4===t.length){if(t=n.Util.normalizeRect(t),t[2]-t[0]>0&&t[3]-t[1]>0)return t;(0,n.warn)(`Empty, or invalid, /${e} entry.`)}return null}get mediaBox(){return(0,n.shadow)(this,"mediaBox",this._getBoundingBox("MediaBox")||k)}get cropBox(){return(0,n.shadow)(this,"cropBox",this._getBoundingBox("CropBox")||this.mediaBox)}get userUnit(){let e=this.pageDict.get("UserUnit");return("number"!=typeof e||e<=0)&&(e=1),(0,n.shadow)(this,"userUnit",e)}get view(){const{cropBox:e,mediaBox:t}=this;if(e!==t&&!(0,n.isArrayEqual)(e,t)){const a=n.Util.intersect(e,t);if(a&&a[2]-a[0]>0&&a[3]-a[1]>0)return(0,n.shadow)(this,"view",a);(0,n.warn)("Empty /CropBox and /MediaBox intersection.")}return(0,n.shadow)(this,"view",t)}get rotate(){let e=this._getInheritableProperty("Rotate")||0;return e%90!=0?e=0:e>=360?e%=360:e<0&&(e=(e%360+360)%360),(0,n.shadow)(this,"rotate",e)}_onSubStreamError(e,t){if(!this.evaluatorOptions.ignoreErrors)throw e;(0,n.warn)(`getContentStream - ignoring sub-stream (${t}): "${e}".`)}getContentStream(){return this.pdfManager.ensure(this,"content").then((e=>e instanceof c.BaseStream?e:Array.isArray(e)?new y.StreamsSequenceStream(e,this._onSubStreamError.bind(this)):new g.NullStream))}get xfaData(){return(0,n.shadow)(this,"xfaData",this.xfaFactory?{bbox:this.xfaFactory.getBoundingBox(this.pageIndex)}:null)}#t(e,t,a){for(const r of e)if(r.id){const e=s.Ref.fromString(r.id);if(!e){(0,n.warn)(`A non-linked annotation cannot be modified: ${r.id}`);continue}if(r.deleted){t.put(e);continue}a?.put(e),r.ref=e,delete r.id}}async saveNewAnnotations(e,t,a,n){if(this.xfaFactory)throw new Error("XFA: Cannot save new annotations.");const i=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,systemFontCache:this.systemFontCache,options:this.evaluatorOptions}),o=new s.RefSet,c=new s.RefSet;this.#t(a,o,c);const l=this.pageDict,h=this.annotations.filter((e=>!(e instanceof s.Ref&&o.has(e)))),u=await r.AnnotationFactory.saveNewAnnotations(i,t,a,n);for(const{ref:e}of u.annotations)e instanceof s.Ref&&!c.has(e)&&h.push(e);const d=l.get("Annots");l.set("Annots",h);const f=[];await(0,x.writeObject)(this.ref,l,f,this.xref),d&&l.set("Annots",d);const g=u.dependencies;return g.push({ref:this.ref,data:f.join("")},...u.annotations),g}save(e,t,a){const r=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,systemFontCache:this.systemFontCache,options:this.evaluatorOptions});return this._parsedAnnotations.then((function(e){const i=[];for(const s of e)s.mustBePrinted(a)&&i.push(s.save(r,t,a).catch((function(e){return(0,n.warn)(`save - ignoring annotation data during "${t.name}" task: "${e}".`),null})));return Promise.all(i).then((function(e){return e.filter((e=>!!e))}))}))}loadResources(e){return this.resourcesPromise||(this.resourcesPromise=this.pdfManager.ensure(this,"resources")),this.resourcesPromise.then((()=>new p.ObjectLoader(this.resources,e,this.xref).load()))}getOperatorList({handler:e,sink:t,task:a,intent:o,cacheKey:c,annotationStorage:l=null}){const h=this.getContentStream(),u=this.loadResources(["ColorSpace","ExtGState","Font","Pattern","Properties","Shading","XObject"]),d=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,systemFontCache:this.systemFontCache,options:this.evaluatorOptions}),f=this.xfaFactory?null:(0,i.getNewAnnotationsMap)(l);let g=null,p=Promise.resolve(null);if(f){const e=f.get(this.pageIndex);if(e){const t=this.pdfManager.ensureDoc("annotationGlobals");let i;const o=new Set;for(const{bitmapId:t,bitmap:a}of e)!t||a||o.has(t)||o.add(t);const{isOffscreenCanvasSupported:c}=this.evaluatorOptions;if(o.size>0){const t=e.slice();for(const[e,a]of l)e.startsWith(n.AnnotationEditorPrefix)&&a.bitmap&&o.has(a.bitmapId)&&t.push(a);i=r.AnnotationFactory.generateImages(t,this.xref,c)}else i=r.AnnotationFactory.generateImages(e,this.xref,c);g=new s.RefSet,this.#t(e,g,null),p=t.then((t=>t?r.AnnotationFactory.printNewAnnotations(t,d,a,e,i):null))}}const y=Promise.all([h,u]).then((([n])=>{const r=new m.OperatorList(o,t);return e.send("StartRenderPage",{transparency:d.hasBlendModes(this.resources,this.nonBlendModesSet),pageIndex:this.pageIndex,cacheKey:c}),d.getOperatorList({stream:n,task:a,resources:this.resources,operatorList:r}).then((function(){return r}))}));return Promise.all([y,this._parsedAnnotations,p]).then((function([e,t,r]){if(r){t=t.filter((e=>!(e.ref&&g.has(e.ref))));for(let e=0,a=r.length;e<a;e++){const n=r[e];if(n.refToReplace){const i=t.findIndex((e=>e.ref&&(0,s.isRefsEqual)(e.ref,n.refToReplace)));i>=0&&(t.splice(i,1,n),r.splice(e--,1),a--)}}t=t.concat(r)}if(0===t.length||o&n.RenderingIntentFlag.ANNOTATIONS_DISABLE)return e.flush(!0),{length:e.totalLength};const i=!!(o&n.RenderingIntentFlag.ANNOTATIONS_FORMS),c=!!(o&n.RenderingIntentFlag.ANY),h=!!(o&n.RenderingIntentFlag.DISPLAY),u=!!(o&n.RenderingIntentFlag.PRINT),f=[];for(const e of t)(c||h&&e.mustBeViewed(l,i)||u&&e.mustBePrinted(l))&&f.push(e.getOperatorList(d,a,o,i,l).catch((function(e){return(0,n.warn)(`getOperatorList - ignoring annotation data during "${a.name}" task: "${e}".`),{opList:null,separateForm:!1,separateCanvas:!1}})));return Promise.all(f).then((function(t){let a=!1,n=!1;for(const{opList:r,separateForm:i,separateCanvas:s}of t)e.addOpList(r),a||=i,n||=s;return e.flush(!0,{form:a,canvas:n}),{length:e.totalLength}}))}))}extractTextContent({handler:e,task:t,includeMarkedContent:a,disableNormalization:n,sink:r}){const i=this.getContentStream(),s=this.loadResources(["ExtGState","Font","Properties","XObject"]);return Promise.all([i,s]).then((([i])=>new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,systemFontCache:this.systemFontCache,options:this.evaluatorOptions}).getTextContent({stream:i,task:t,resources:this.resources,includeMarkedContent:a,disableNormalization:n,sink:r,viewBox:this.view})))}async getStructTree(){const e=await this.pdfManager.ensureCatalog("structTreeRoot");if(!e)return null;await this._parsedAnnotations;return(await this.pdfManager.ensure(this,"_parseStructTree",[e])).serializable}_parseStructTree(e){const t=new w.StructTreePage(e,this.pageDict);return t.parse(this.ref),t}async getAnnotationsData(e,t,a){const r=await this._parsedAnnotations;if(0===r.length)return r;const i=[],s=[];let o;const c=!!(a&n.RenderingIntentFlag.ANY),l=!!(a&n.RenderingIntentFlag.DISPLAY),h=!!(a&n.RenderingIntentFlag.PRINT);for(const a of r){const r=c||l&&a.viewable;(r||h&&a.printable)&&i.push(a.data),a.hasTextContent&&r&&(o||=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:this.pageIndex,idFactory:this._localIdFactory,fontCache:this.fontCache,builtInCMapCache:this.builtInCMapCache,standardFontDataCache:this.standardFontDataCache,globalImageCache:this.globalImageCache,systemFontCache:this.systemFontCache,options:this.evaluatorOptions}),s.push(a.extractTextContent(o,t,[-1/0,-1/0,1/0,1/0]).catch((function(e){(0,n.warn)(`getAnnotationsData - ignoring textContent during "${t.name}" task: "${e}".`)}))))}return await Promise.all(s),i}get annotations(){const e=this._getInheritableProperty("Annots");return(0,n.shadow)(this,"annotations",Array.isArray(e)?e:[])}get _parsedAnnotations(){const e=this.pdfManager.ensure(this,"annotations").then((async e=>{if(0===e.length)return e;const t=await this.pdfManager.ensureDoc("annotationGlobals");if(!t)return[];const a=[];for(const i of e)a.push(r.AnnotationFactory.create(this.xref,i,t,this._localIdFactory,!1,this.ref).catch((function(e){return(0,n.warn)(`_parsedAnnotations: "${e}".`),null})));const i=[];let s;for(const e of await Promise.all(a))e&&(e instanceof r.PopupAnnotation?(s||=[]).push(e):i.push(e));return s&&i.push(...s),i}));return(0,n.shadow)(this,"_parsedAnnotations",e)}get jsActions(){const e=(0,i.collectActions)(this.xref,this.pageDict,n.PageActionEventType);return(0,n.shadow)(this,"jsActions",e)}}t.Page=C;const v=new Uint8Array([37,80,68,70,45]),F=new Uint8Array([115,116,97,114,116,120,114,101,102]),O=new Uint8Array([101,110,100,111,98,106]);function I(e,t,a=1024,n=!1){const r=t.length,i=e.peekBytes(a),s=i.length-r;if(s<=0)return!1;if(n){const a=r-1;let n=i.length-1;for(;n>=a;){let s=0;for(;s<r&&i[n-s]===t[a-s];)s++;if(s>=r)return e.pos+=n-a,!0;n--}}else{let a=0;for(;a<=s;){let n=0;for(;n<r&&i[a+n]===t[n];)n++;if(n>=r)return e.pos+=a,!0;a++}}return!1}t.PDFDocument=class{constructor(e,t){if(t.length<=0)throw new n.InvalidPDFException("The PDF file is empty, i.e. its size is zero bytes.");this.pdfManager=e,this.stream=t,this.xref=new A.XRef(t,e),this._pagePromises=new Map,this._version=null;const a={font:0};this._globalIdFactory=class{static getDocId(){return`g_${e.docId}`}static createFontId(){return"f"+ ++a.font}static createObjId(){(0,n.unreachable)("Abstract method `createObjId` called.")}static getPageObjId(){(0,n.unreachable)("Abstract method `getPageObjId` called.")}}}parse(e){this.xref.parse(e),this.catalog=new h.Catalog(this.pdfManager,this.xref)}get linearization(){let e=null;try{e=f.Linearization.create(this.stream)}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.info)(e)}return(0,n.shadow)(this,"linearization",e)}get startXRef(){const e=this.stream;let t=0;if(this.linearization)e.reset(),I(e,O)&&(t=e.pos+6-e.start);else{const a=1024,n=F.length;let r=!1,s=e.end;for(;!r&&s>0;)s-=a-n,s<0&&(s=0),e.pos=s,r=I(e,F,a,!0);if(r){let a;e.skip(9);do{a=e.getByte()}while((0,i.isWhiteSpace)(a));let n="";for(;a>=32&&a<=57;)n+=String.fromCharCode(a),a=e.getByte();t=parseInt(n,10),isNaN(t)&&(t=0)}}return(0,n.shadow)(this,"startXRef",t)}checkHeader(){const e=this.stream;if(e.reset(),!I(e,v))return;e.moveStart(),e.skip(v.length);let t,a="";for(;(t=e.getByte())>32&&a.length<7;)a+=String.fromCharCode(t);i.PDF_VERSION_REGEXP.test(a)?this._version=a:(0,n.warn)(`Invalid PDF header version: ${a}`)}parseStartXRef(){this.xref.setStartXRef(this.startXRef)}get numPages(){let e=0;return e=this.catalog.hasActualNumPages?this.catalog.numPages:this.xfaFactory?this.xfaFactory.getNumPages():this.linearization?this.linearization.numPages:this.catalog.numPages,(0,n.shadow)(this,"numPages",e)}_hasOnlyDocumentSignatures(e,t=0){return!!Array.isArray(e)&&e.every((e=>{if(!((e=this.xref.fetchIfRef(e))instanceof s.Dict))return!1;if(e.has("Kids"))return++t>10?((0,n.warn)("_hasOnlyDocumentSignatures: maximum recursion depth reached"),!1):this._hasOnlyDocumentSignatures(e.get("Kids"),t);const a=(0,s.isName)(e.get("FT"),"Sig"),r=e.get("Rect"),i=Array.isArray(r)&&r.every((e=>0===e));return a&&i}))}get _xfaStreams(){const e=this.catalog.acroForm;if(!e)return null;const t=e.get("XFA"),a={"xdp:xdp":"",template:"",datasets:"",config:"",connectionSet:"",localeSet:"",stylesheet:"","/xdp:xdp":""};if(t instanceof c.BaseStream&&!t.isEmpty)return a["xdp:xdp"]=t,a;if(!Array.isArray(t)||0===t.length)return null;for(let e=0,n=t.length;e<n;e+=2){let r;if(r=0===e?"xdp:xdp":e===n-2?"/xdp:xdp":t[e],!a.hasOwnProperty(r))continue;const i=this.xref.fetchIfRef(t[e+1]);i instanceof c.BaseStream&&!i.isEmpty&&(a[r]=i)}return a}get xfaDatasets(){const e=this._xfaStreams;if(!e)return(0,n.shadow)(this,"xfaDatasets",null);for(const t of["datasets","xdp:xdp"]){const a=e[t];if(a)try{const e={[t]:(0,n.stringToUTF8String)(a.getString())};return(0,n.shadow)(this,"xfaDatasets",new d.DatasetReader(e))}catch{(0,n.warn)("XFA - Invalid utf-8 string.");break}}return(0,n.shadow)(this,"xfaDatasets",null)}get xfaData(){const e=this._xfaStreams;if(!e)return null;const t=Object.create(null);for(const[a,r]of Object.entries(e))if(r)try{t[a]=(0,n.stringToUTF8String)(r.getString())}catch{return(0,n.warn)("XFA - Invalid utf-8 string."),null}return t}get xfaFactory(){let e;return this.pdfManager.enableXfa&&this.catalog.needsRendering&&this.formInfo.hasXfa&&!this.formInfo.hasAcroForm&&(e=this.xfaData),(0,n.shadow)(this,"xfaFactory",e?new S.XFAFactory(e):null)}get isPureXfa(){return!!this.xfaFactory&&this.xfaFactory.isValid()}get htmlForXfa(){return this.xfaFactory?this.xfaFactory.getPages():null}async loadXfaImages(){const e=await this.pdfManager.ensureCatalog("xfaImages");if(!e)return;const t=e.getKeys(),a=new p.ObjectLoader(e,t,this.xref);await a.load();const n=new Map;for(const a of t){const t=e.get(a);t instanceof c.BaseStream&&n.set(a,t.getBytes())}this.xfaFactory.setImages(n)}async loadXfaFonts(e,t){const a=await this.pdfManager.ensureCatalog("acroForm");if(!a)return;const r=await a.getAsync("DR");if(!(r instanceof s.Dict))return;const c=new p.ObjectLoader(r,["Font"],this.xref);await c.load();const l=r.get("Font");if(!(l instanceof s.Dict))return;const h=Object.assign(Object.create(null),this.pdfManager.evaluatorOptions);h.useSystemFonts=!1;const u=new b.PartialEvaluator({xref:this.xref,handler:e,pageIndex:-1,idFactory:this._globalIdFactory,fontCache:this.catalog.fontCache,builtInCMapCache:this.catalog.builtInCMapCache,standardFontDataCache:this.catalog.standardFontDataCache,options:h}),d=new m.OperatorList,f=[],g={get font(){return f.at(-1)},set font(e){f.push(e)},clone(){return this}},y=new Map;l.forEach(((e,t)=>{y.set(e,t)}));const w=[];for(const[e,a]of y){const o=a.get("FontDescriptor");if(!(o instanceof s.Dict))continue;let c=o.get("FontFamily");c=c.replaceAll(/[ ]+(\d)/g,"$1");const l={fontFamily:c,fontWeight:o.get("FontWeight"),italicAngle:-o.get("ItalicAngle")};(0,i.validateCSSFont)(l)&&w.push(u.handleSetFont(r,[s.Name.get(e),1],null,d,t,g,null,l).catch((function(e){return(0,n.warn)(`loadXfaFonts: "${e}".`),null})))}await Promise.all(w);const x=this.xfaFactory.setFonts(f);if(!x)return;h.ignoreErrors=!0,w.length=0,f.length=0;const S=new Set;for(const e of x)(0,o.getXfaFontName)(`${e}-Regular`)||S.add(e);S.size&&x.push("PdfJS-Fallback");for(const e of x)if(!S.has(e))for(const a of[{name:"Regular",fontWeight:400,italicAngle:0},{name:"Bold",fontWeight:700,italicAngle:0},{name:"Italic",fontWeight:400,italicAngle:12},{name:"BoldItalic",fontWeight:700,italicAngle:12}]){const i=`${e}-${a.name}`,c=(0,o.getXfaFontDict)(i);w.push(u.handleSetFont(r,[s.Name.get(i),1],null,d,t,g,c,{fontFamily:e,fontWeight:a.fontWeight,italicAngle:a.italicAngle}).catch((function(e){return(0,n.warn)(`loadXfaFonts: "${e}".`),null})))}await Promise.all(w),this.xfaFactory.appendFonts(f,S)}async serializeXfaData(e){return this.xfaFactory?this.xfaFactory.serializeData(e):null}get version(){return this.catalog.version||this._version}get formInfo(){const e={hasFields:!1,hasAcroForm:!1,hasXfa:!1,hasSignatures:!1},t=this.catalog.acroForm;if(!t)return(0,n.shadow)(this,"formInfo",e);try{const a=t.get("Fields"),n=Array.isArray(a)&&a.length>0;e.hasFields=n;const r=t.get("XFA");e.hasXfa=Array.isArray(r)&&r.length>0||r instanceof c.BaseStream&&!r.isEmpty;const i=!!(1&t.get("SigFlags")),s=i&&this._hasOnlyDocumentSignatures(a);e.hasAcroForm=n&&!s,e.hasSignatures=i}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.warn)(`Cannot fetch form information: "${e}".`)}return(0,n.shadow)(this,"formInfo",e)}get documentInfo(){const e={PDFFormatVersion:this.version,Language:this.catalog.lang,EncryptFilterName:this.xref.encrypt?this.xref.encrypt.filterName:null,IsLinearized:!!this.linearization,IsAcroFormPresent:this.formInfo.hasAcroForm,IsXFAPresent:this.formInfo.hasXfa,IsCollectionPresent:!!this.catalog.collection,IsSignaturesPresent:this.formInfo.hasSignatures};let t;try{t=this.xref.trailer.get("Info")}catch(e){if(e instanceof i.MissingDataException)throw e;(0,n.info)("The document information dictionary is invalid.")}if(!(t instanceof s.Dict))return(0,n.shadow)(this,"documentInfo",e);for(const a of t.getKeys()){const r=t.get(a);switch(a){case"Title":case"Author":case"Subject":case"Keywords":case"Creator":case"Producer":case"CreationDate":case"ModDate":if("string"==typeof r){e[a]=(0,n.stringToPDFString)(r);continue}break;case"Trapped":if(r instanceof s.Name){e[a]=r;continue}break;default:let t;switch(typeof r){case"string":t=(0,n.stringToPDFString)(r);break;case"number":case"boolean":t=r;break;default:r instanceof s.Name&&(t=r)}if(void 0===t){(0,n.warn)(`Bad value, for custom key "${a}", in Info: ${r}.`);continue}e.Custom||(e.Custom=Object.create(null)),e.Custom[a]=t;continue}(0,n.warn)(`Bad value, for key "${a}", in Info: ${r}.`)}return(0,n.shadow)(this,"documentInfo",e)}get fingerprints(){function e(e){return"string"==typeof e&&e.length>0&&"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"!==e}function t(e){const t=[];for(const a of e){const e=a.toString(16);t.push(e.padStart(2,"0"))}return t.join("")}const a=this.xref.trailer.get("ID");let r,i;return Array.isArray(a)&&e(a[0])?(r=(0,n.stringToBytes)(a[0]),a[1]!==a[0]&&e(a[1])&&(i=(0,n.stringToBytes)(a[1]))):r=(0,l.calculateMD5)(this.stream.getByteRange(0,1024),0,1024),(0,n.shadow)(this,"fingerprints",[t(r),i?t(i):null])}async _getLinearizationPage(e){const{catalog:t,linearization:a,xref:r}=this,i=s.Ref.get(a.objectNumberFirst,0);try{const e=await r.fetchAsync(i);if(e instanceof s.Dict){let a=e.getRaw("Type");if(a instanceof s.Ref&&(a=await r.fetchAsync(a)),(0,s.isName)(a,"Page")||!e.has("Type")&&!e.has("Kids"))return t.pageKidsCountCache.has(i)||t.pageKidsCountCache.put(i,1),t.pageIndexCache.has(i)||t.pageIndexCache.put(i,0),[e,i]}throw new n.FormatError("The Linearization dictionary doesn't point to a valid Page dictionary.")}catch(a){return(0,n.warn)(`_getLinearizationPage: "${a.message}".`),t.getPageDict(e)}}getPage(e){const t=this._pagePromises.get(e);if(t)return t;const{catalog:a,linearization:n,xfaFactory:r}=this;let i;return i=r?Promise.resolve([s.Dict.empty,null]):n?.pageFirst===e?this._getLinearizationPage(e):a.getPageDict(e),i=i.then((([t,n])=>new C({pdfManager:this.pdfManager,xref:this.xref,pageIndex:e,pageDict:t,ref:n,globalIdFactory:this._globalIdFactory,fontCache:a.fontCache,builtInCMapCache:a.builtInCMapCache,standardFontDataCache:a.standardFontDataCache,globalImageCache:a.globalImageCache,systemFontCache:a.systemFontCache,nonBlendModesSet:a.nonBlendModesSet,xfaFactory:r}))),this._pagePromises.set(e,i),i}async checkFirstPage(e=!1){if(!e)try{await this.getPage(0)}catch(e){if(e instanceof i.XRefEntryException)throw this._pagePromises.delete(0),await this.cleanup(),new i.XRefParseException}}async checkLastPage(e=!1){const{catalog:t,pdfManager:a}=this;let r;t.setActualNumPages();try{if(await Promise.all([a.ensureDoc("xfaFactory"),a.ensureDoc("linearization"),a.ensureCatalog("numPages")]),this.xfaFactory)return;if(r=this.linearization?this.linearization.numPages:t.numPages,!Number.isInteger(r))throw new n.FormatError("Page count is not an integer.");if(r<=1)return;await this.getPage(r-1)}catch(s){if(this._pagePromises.delete(r-1),await this.cleanup(),s instanceof i.XRefEntryException&&!e)throw new i.XRefParseException;let o;(0,n.warn)(`checkLastPage - invalid /Pages tree /Count: ${r}.`);try{o=await t.getAllPageDicts(e)}catch(a){if(a instanceof i.XRefEntryException&&!e)throw new i.XRefParseException;return void t.setActualNumPages(1)}for(const[e,[n,r]]of o){let i;n instanceof Error?(i=Promise.reject(n),i.catch((()=>{}))):i=Promise.resolve(new C({pdfManager:a,xref:this.xref,pageIndex:e,pageDict:n,ref:r,globalIdFactory:this._globalIdFactory,fontCache:t.fontCache,builtInCMapCache:t.builtInCMapCache,standardFontDataCache:t.standardFontDataCache,globalImageCache:t.globalImageCache,systemFontCache:t.systemFontCache,nonBlendModesSet:t.nonBlendModesSet,xfaFactory:null})),this._pagePromises.set(e,i)}t.setActualNumPages(o.size)}}fontFallback(e,t){return this.catalog.fontFallback(e,t)}async cleanup(e=!1){return this.catalog?this.catalog.cleanup(e):(0,u.clearGlobalCaches)()}#a(e,t,a,i){const s=this.xref.fetchIfRef(t);if(s.has("T")){const t=(0,n.stringToPDFString)(s.get("T"));e=""===e?t:`${e}.${t}`}if(a.has(e)||a.set(e,[]),a.get(e).push(r.AnnotationFactory.create(this.xref,t,i,this._localIdFactory,!0,null).then((e=>e?.getFieldObject())).catch((function(e){return(0,n.warn)(`#collectFieldObjects: "${e}".`),null}))),s.has("Kids"))for(const t of s.get("Kids"))this.#a(e,t,a,i)}get fieldObjects(){if(!this.formInfo.hasFields)return(0,n.shadow)(this,"fieldObjects",Promise.resolve(null));const e=this.pdfManager.ensureDoc("annotationGlobals").then((async e=>{if(!e)return null;const t=Object.create(null),a=new Map;for(const t of this.catalog.acroForm.get("Fields"))this.#a("",t,a,e);const n=[];for(const[e,r]of a)n.push(Promise.all(r).then((a=>{(a=a.filter((e=>!!e))).length>0&&(t[e]=a)})));return await Promise.all(n),t}));return(0,n.shadow)(this,"fieldObjects",e)}get hasJSActions(){const e=this.pdfManager.ensureDoc("_parseHasJSActions");return(0,n.shadow)(this,"hasJSActions",e)}async _parseHasJSActions(){const[e,t]=await Promise.all([this.pdfManager.ensureCatalog("jsActions"),this.pdfManager.ensureDoc("fieldObjects")]);return!!e||!!t&&Object.values(t).some((e=>e.some((e=>null!==e.actions))))}get calculationOrderIds(){const e=this.catalog.acroForm;if(!e?.has("CO"))return(0,n.shadow)(this,"calculationOrderIds",null);const t=e.get("CO");if(!Array.isArray(t)||0===t.length)return(0,n.shadow)(this,"calculationOrderIds",null);const a=[];for(const e of t)e instanceof s.Ref&&a.push(e.toString());return 0===a.length?(0,n.shadow)(this,"calculationOrderIds",null):(0,n.shadow)(this,"calculationOrderIds",a)}get annotationGlobals(){return(0,n.shadow)(this,"annotationGlobals",r.AnnotationFactory.createGlobals(this.pdfManager))}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PopupAnnotation=t.MarkupAnnotation=t.AnnotationFactory=t.AnnotationBorderStyle=t.Annotation=void 0,t.getQuadPoints=x;var n=a(2),r=a(3),i=a(11),s=a(4),o=a(8),c=a(5),l=a(60),h=a(66),u=a(12),d=a(69),f=a(26),g=a(76),p=a(64),m=a(73),b=a(77);function y(e,t=new Uint8ClampedArray(3)){if(!Array.isArray(e))return t;const a=t||new Uint8ClampedArray(3);switch(e.length){case 0:return null;case 1:return u.ColorSpace.singletons.gray.getRgbItem(e,0,a,0),a;case 3:return u.ColorSpace.singletons.rgb.getRgbItem(e,0,a,0),a;case 4:return u.ColorSpace.singletons.cmyk.getRgbItem(e,0,a,0),a;default:return t}}function w(e){return Array.from(e,(e=>e/255))}function x(e,t){const a=e.getArray("QuadPoints");if(!Array.isArray(a)||0===a.length||a.length%8>0)return null;const n=[];for(let e=0,r=a.length/8;e<r;e++){let r=1/0,i=-1/0,s=1/0,o=-1/0;for(let t=8*e,n=8*e+8;t<n;t+=2){const e=a[t],n=a[t+1];r=Math.min(e,r),i=Math.max(e,i),s=Math.min(n,s),o=Math.max(n,o)}if(null!==t&&(r<t[0]||i>t[2]||s<t[1]||o>t[3]))return null;n.push([{x:r,y:o},{x:i,y:o},{x:r,y:s},{x:i,y:s}])}return n}function S(e,t,a){const[r,i,s,o]=n.Util.getAxialAlignedBoundingBox(t,a);if(r===s||i===o)return[1,0,0,1,e[0],e[1]];const c=(e[2]-e[0])/(s-r),l=(e[3]-e[1])/(o-i);return[c,0,0,l,e[0]-r*c,e[1]-i*l]}t.AnnotationFactory=class{static createGlobals(e){return Promise.all([e.ensureCatalog("acroForm"),e.ensureDoc("xfaDatasets"),e.ensureCatalog("structTreeRoot"),e.ensureCatalog("baseUrl"),e.ensureCatalog("attachments")]).then((([t,a,n,r,i])=>({pdfManager:e,acroForm:t instanceof s.Dict?t:s.Dict.empty,xfaDatasets:a,structTreeRoot:n,baseUrl:r,attachments:i})),(e=>((0,n.warn)(`createGlobals: "${e}".`),null)))}static async create(e,t,a,n,r,i){const s=r?await this._getPageIndex(e,t,a.pdfManager):null;return a.pdfManager.ensure(this,"_create",[e,t,a,n,r,s,i])}static _create(e,t,a,i,o=!1,c=null,l=null){const h=e.fetchIfRef(t);if(!(h instanceof s.Dict))return;const{acroForm:u,pdfManager:d}=a,f=t instanceof s.Ref?t.toString():`annot_${i.createObjId()}`;let g=h.get("Subtype");g=g instanceof s.Name?g.name:null;const p={xref:e,ref:t,dict:h,subtype:g,id:f,annotationGlobals:a,collectFields:o,needAppearances:!o&&!0===u.get("NeedAppearances"),pageIndex:c,evaluatorOptions:d.evaluatorOptions,pageRef:l};switch(g){case"Link":return new P(p);case"Text":return new M(p);case"Widget":let e=(0,r.getInheritableProperty)({dict:h,key:"FT"});switch(e=e instanceof s.Name?e.name:null,e){case"Tx":return new F(p);case"Btn":return new O(p);case"Ch":return new I(p);case"Sig":return new T(p)}return(0,n.warn)(`Unimplemented widget field type "${e}", falling back to base field type.`),new v(p);case"Popup":return new N(p);case"FreeText":return new D(p);case"Line":return new R(p);case"Square":return new E(p);case"Circle":return new B(p);case"PolyLine":return new $(p);case"Polygon":return new L(p);case"Caret":return new _(p);case"Ink":return new j(p);case"Highlight":return new U(p);case"Underline":return new X(p);case"Squiggly":return new H(p);case"StrikeOut":return new q(p);case"Stamp":return new z(p);case"FileAttachment":return new G(p);default:return o||(g?(0,n.warn)(`Unimplemented annotation type "${g}", falling back to base annotation.`):(0,n.warn)("Annotation is missing the required /Subtype.")),new A(p)}}static async _getPageIndex(e,t,a){try{const r=await e.fetchIfRefAsync(t);if(!(r instanceof s.Dict))return-1;const i=r.getRaw("P");if(i instanceof s.Ref)try{return await a.ensureCatalog("getPageIndex",[i])}catch(e){(0,n.info)(`_getPageIndex -- not a valid page reference: "${e}".`)}if(r.has("Kids"))return-1;const o=await a.ensureDoc("numPages");for(let e=0;e<o;e++){const n=await a.getPage(e),r=await a.ensure(n,"annotations");for(const a of r)if(a instanceof s.Ref&&(0,s.isRefsEqual)(a,t))return e}}catch(e){(0,n.warn)(`_getPageIndex: "${e}".`)}return-1}static generateImages(e,t,a){if(!a)return(0,n.warn)("generateImages: OffscreenCanvas is not supported, cannot save or print some annotations with images."),null;let r;for(const{bitmapId:a,bitmap:n}of e)n&&(r||=new Map,r.set(a,z.createImage(n,t)));return r}static async saveNewAnnotations(e,t,a,r){const i=e.xref;let o;const c=[],l=[],{isOffscreenCanvasSupported:h}=e.options;for(const u of a)if(!u.deleted)switch(u.annotationType){case n.AnnotationEditorType.FREETEXT:if(!o){const e=new s.Dict(i);e.set("BaseFont",s.Name.get("Helvetica")),e.set("Type",s.Name.get("Font")),e.set("Subtype",s.Name.get("Type1")),e.set("Encoding",s.Name.get("WinAnsiEncoding"));const t=[];o=i.getNewTemporaryRef(),await(0,m.writeObject)(o,e,t,i),c.push({ref:o,data:t.join("")})}l.push(D.createNewAnnotation(i,u,c,{evaluator:e,task:t,baseFontRef:o}));break;case n.AnnotationEditorType.INK:l.push(j.createNewAnnotation(i,u,c));break;case n.AnnotationEditorType.STAMP:if(!h)break;const a=await r.get(u.bitmapId);if(a.imageStream){const{imageStream:e,smaskStream:t}=a,n=[];if(t){const a=i.getNewTemporaryRef();await(0,m.writeObject)(a,t,n,i),c.push({ref:a,data:n.join("")}),e.dict.set("SMask",a),n.length=0}const r=a.imageRef=i.getNewTemporaryRef();await(0,m.writeObject)(r,e,n,i),c.push({ref:r,data:n.join("")}),a.imageStream=a.smaskStream=null}l.push(z.createNewAnnotation(i,u,c,{image:a}))}return{annotations:await Promise.all(l),dependencies:c}}static async printNewAnnotations(e,t,a,r,i){if(!r)return null;const{options:s,xref:o}=t,c=[];for(const l of r)if(!l.deleted)switch(l.annotationType){case n.AnnotationEditorType.FREETEXT:c.push(D.createNewPrintAnnotation(e,o,l,{evaluator:t,task:a,evaluatorOptions:s}));break;case n.AnnotationEditorType.INK:c.push(j.createNewPrintAnnotation(e,o,l,{evaluatorOptions:s}));break;case n.AnnotationEditorType.STAMP:if(!s.isOffscreenCanvasSupported)break;const r=await i.get(l.bitmapId);if(r.imageStream){const{imageStream:e,smaskStream:t}=r;t&&e.dict.set("SMask",t),r.imageRef=new f.JpegStream(e,e.length),r.imageStream=r.smaskStream=null}c.push(z.createNewPrintAnnotation(e,o,l,{image:r,evaluatorOptions:s}))}return Promise.all(c)}};class A{constructor(e){const{dict:t,xref:a,annotationGlobals:i}=e;this.setTitle(t.get("T")),this.setContents(t.get("Contents")),this.setModificationDate(t.get("M")),this.setFlags(t.get("F")),this.setRectangle(t.getArray("Rect")),this.setColor(t.getArray("C")),this.setBorderStyle(t),this.setAppearance(t),this.setOptionalContent(t);const o=t.get("MK");this.setBorderAndBackgroundColors(o),this.setRotation(o,t),this.ref=e.ref instanceof s.Ref?e.ref:null,this._streams=[],this.appearance&&this._streams.push(this.appearance);const c=!!(this.flags&n.AnnotationFlag.LOCKED),l=!!(this.flags&n.AnnotationFlag.LOCKEDCONTENTS);if(i.structTreeRoot){let a=t.get("StructParent");a=Number.isInteger(a)&&a>=0?a:-1,i.structTreeRoot.addAnnotationIdToPage(e.pageRef,a)}if(this.data={annotationFlags:this.flags,borderStyle:this.borderStyle,color:this.color,backgroundColor:this.backgroundColor,borderColor:this.borderColor,rotation:this.rotation,contentsObj:this._contents,hasAppearance:!!this.appearance,id:e.id,modificationDate:this.modificationDate,rect:this.rectangle,subtype:e.subtype,hasOwnCanvas:!1,noRotate:!!(this.flags&n.AnnotationFlag.NOROTATE),noHTML:c&&l},e.collectFields){const i=t.get("Kids");if(Array.isArray(i)){const e=[];for(const t of i)t instanceof s.Ref&&e.push(t.toString());0!==e.length&&(this.data.kidIds=e)}this.data.actions=(0,r.collectActions)(a,t,n.AnnotationActionEventType),this.data.fieldName=this._constructFieldName(t),this.data.pageIndex=e.pageIndex}this._isOffscreenCanvasSupported=e.evaluatorOptions.isOffscreenCanvasSupported,this._fallbackFontDict=null,this._needAppearances=!1}_hasFlag(e,t){return!!(e&t)}_isViewable(e){return!this._hasFlag(e,n.AnnotationFlag.INVISIBLE)&&!this._hasFlag(e,n.AnnotationFlag.NOVIEW)}_isPrintable(e){return this._hasFlag(e,n.AnnotationFlag.PRINT)&&!this._hasFlag(e,n.AnnotationFlag.HIDDEN)&&!this._hasFlag(e,n.AnnotationFlag.INVISIBLE)}mustBeViewed(e,t){const a=e?.get(this.data.id)?.noView;return void 0!==a?!a:this.viewable&&!this._hasFlag(this.flags,n.AnnotationFlag.HIDDEN)}mustBePrinted(e){const t=e?.get(this.data.id)?.noPrint;return void 0!==t?!t:this.printable}get viewable(){return null!==this.data.quadPoints&&(0===this.flags||this._isViewable(this.flags))}get printable(){return null!==this.data.quadPoints&&(0!==this.flags&&this._isPrintable(this.flags))}_parseStringHelper(e){const t="string"==typeof e?(0,n.stringToPDFString)(e):"";return{str:t,dir:t&&"rtl"===(0,l.bidi)(t).dir?"rtl":"ltr"}}setDefaultAppearance(e){const{dict:t,annotationGlobals:a}=e,n=(0,r.getInheritableProperty)({dict:t,key:"DA"})||a.acroForm.get("DA");this._defaultAppearance="string"==typeof n?n:"",this.data.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance)}setTitle(e){this._title=this._parseStringHelper(e)}setContents(e){this._contents=this._parseStringHelper(e)}setModificationDate(e){this.modificationDate="string"==typeof e?e:null}setFlags(e){this.flags=Number.isInteger(e)&&e>0?e:0}hasFlag(e){return this._hasFlag(this.flags,e)}setRectangle(e){this.rectangle=Array.isArray(e)&&4===e.length?n.Util.normalizeRect(e):[0,0,0,0]}setColor(e){this.color=y(e)}setLineEndings(e){if(this.lineEndings=["None","None"],Array.isArray(e)&&2===e.length)for(let t=0;t<2;t++){const a=e[t];if(a instanceof s.Name)switch(a.name){case"None":continue;case"Square":case"Circle":case"Diamond":case"OpenArrow":case"ClosedArrow":case"Butt":case"ROpenArrow":case"RClosedArrow":case"Slash":this.lineEndings[t]=a.name;continue}(0,n.warn)(`Ignoring invalid lineEnding: ${a}`)}}setRotation(e,t){this.rotation=0;let a=e instanceof s.Dict?e.get("R")||0:t.get("Rotate")||0;Number.isInteger(a)&&0!==a&&(a%=360,a<0&&(a+=360),a%90==0&&(this.rotation=a))}setBorderAndBackgroundColors(e){e instanceof s.Dict?(this.borderColor=y(e.getArray("BC"),null),this.backgroundColor=y(e.getArray("BG"),null)):this.borderColor=this.backgroundColor=null}setBorderStyle(e){if(this.borderStyle=new k,e instanceof s.Dict)if(e.has("BS")){const t=e.get("BS"),a=t.get("Type");a&&!(0,s.isName)(a,"Border")||(this.borderStyle.setWidth(t.get("W"),this.rectangle),this.borderStyle.setStyle(t.get("S")),this.borderStyle.setDashArray(t.getArray("D")))}else if(e.has("Border")){const t=e.getArray("Border");Array.isArray(t)&&t.length>=3&&(this.borderStyle.setHorizontalCornerRadius(t[0]),this.borderStyle.setVerticalCornerRadius(t[1]),this.borderStyle.setWidth(t[2],this.rectangle),4===t.length&&this.borderStyle.setDashArray(t[3],!0))}else this.borderStyle.setWidth(0)}setAppearance(e){this.appearance=null;const t=e.get("AP");if(!(t instanceof s.Dict))return;const a=t.get("N");if(a instanceof c.BaseStream)return void(this.appearance=a);if(!(a instanceof s.Dict))return;const n=e.get("AS");if(!(n instanceof s.Name&&a.has(n.name)))return;const r=a.get(n.name);r instanceof c.BaseStream&&(this.appearance=r)}setOptionalContent(e){this.oc=null;const t=e.get("OC");t instanceof s.Name?(0,n.warn)("setOptionalContent: Support for /Name-entry is not implemented."):t instanceof s.Dict&&(this.oc=t)}loadResources(e,t){return t.dict.getAsync("Resources").then((t=>{if(!t)return;return new g.ObjectLoader(t,e,t.xref).load().then((function(){return t}))}))}async getOperatorList(e,t,a,r,i){const c=this.data;let l=this.appearance;const h=!!(this.data.hasOwnCanvas&&a&n.RenderingIntentFlag.DISPLAY);if(!l){if(!h)return{opList:new p.OperatorList,separateForm:!1,separateCanvas:!1};l=new o.StringStream(""),l.dict=new s.Dict}const u=l.dict,d=await this.loadResources(["ExtGState","ColorSpace","Pattern","Shading","XObject","Font"],l),f=u.getArray("BBox")||[0,0,1,1],g=u.getArray("Matrix")||[1,0,0,1,0,0],m=S(c.rect,f,g),b=new p.OperatorList;let y;return this.oc&&(y=await e.parseMarkedContentProps(this.oc,null)),void 0!==y&&b.addOp(n.OPS.beginMarkedContentProps,["OC",y]),b.addOp(n.OPS.beginAnnotation,[c.id,c.rect,m,g,h]),await e.getOperatorList({stream:l,task:t,resources:d,operatorList:b,fallbackFontDict:this._fallbackFontDict}),b.addOp(n.OPS.endAnnotation,[]),void 0!==y&&b.addOp(n.OPS.endMarkedContent,[]),this.reset(),{opList:b,separateForm:!1,separateCanvas:h}}async save(e,t,a){return null}get hasTextContent(){return!1}async extractTextContent(e,t,a){if(!this.appearance)return;const r=await this.loadResources(["ExtGState","Font","Properties","XObject"],this.appearance),i=[],s=[];let o=null;const c={desiredSize:Math.Infinity,ready:!0,enqueue(e,t){for(const t of e.items)void 0!==t.str&&(o||=t.transform.slice(-2),s.push(t.str),t.hasEOL&&(i.push(s.join("")),s.length=0))}};if(await e.getTextContent({stream:this.appearance,task:t,resources:r,includeMarkedContent:!0,sink:c,viewBox:a}),this.reset(),s.length&&i.push(s.join("")),i.length>1||i[0]){const e=this.appearance.dict,t=e.getArray("BBox")||[0,0,1,1],a=e.getArray("Matrix")||[1,0,0,1,0,0],r=this.data.rect,s=S(r,t,a);s[4]-=r[0],s[5]-=r[1],o=n.Util.applyTransform(o,s),o=n.Util.applyTransform(o,a),this.data.textPosition=o,this.data.textContent=i}}getFieldObject(){return this.data.kidIds?{id:this.data.id,actions:this.data.actions,name:this.data.fieldName,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,type:"",kidIds:this.data.kidIds,page:this.data.pageIndex,rotation:this.rotation}:null}reset(){for(const e of this._streams)e.reset()}_constructFieldName(e){if(!e.has("T")&&!e.has("Parent"))return(0,n.warn)("Unknown field name, falling back to empty field name."),"";if(!e.has("Parent"))return(0,n.stringToPDFString)(e.get("T"));const t=[];e.has("T")&&t.unshift((0,n.stringToPDFString)(e.get("T")));let a=e;const r=new s.RefSet;for(e.objId&&r.put(e.objId);a.has("Parent")&&(a=a.get("Parent"),a instanceof s.Dict&&(!a.objId||!r.has(a.objId)));)a.objId&&r.put(a.objId),a.has("T")&&t.unshift((0,n.stringToPDFString)(a.get("T")));return t.join(".")}}t.Annotation=A;class k{constructor(){this.width=1,this.style=n.AnnotationBorderStyleType.SOLID,this.dashArray=[3],this.horizontalCornerRadius=0,this.verticalCornerRadius=0}setWidth(e,t=[0,0,0,0]){if(e instanceof s.Name)this.width=0;else if("number"==typeof e){if(e>0){const a=(t[2]-t[0])/2,r=(t[3]-t[1])/2;a>0&&r>0&&(e>a||e>r)&&((0,n.warn)(`AnnotationBorderStyle.setWidth - ignoring width: ${e}`),e=1)}this.width=e}}setStyle(e){if(e instanceof s.Name)switch(e.name){case"S":this.style=n.AnnotationBorderStyleType.SOLID;break;case"D":this.style=n.AnnotationBorderStyleType.DASHED;break;case"B":this.style=n.AnnotationBorderStyleType.BEVELED;break;case"I":this.style=n.AnnotationBorderStyleType.INSET;break;case"U":this.style=n.AnnotationBorderStyleType.UNDERLINE}}setDashArray(e,t=!1){if(Array.isArray(e)&&e.length>0){let a=!0,n=!0;for(const t of e){if(!(+t>=0)){a=!1;break}t>0&&(n=!1)}a&&!n?(this.dashArray=e,t&&this.setStyle(s.Name.get("D"))):this.width=0}else e&&(this.width=0)}setHorizontalCornerRadius(e){Number.isInteger(e)&&(this.horizontalCornerRadius=e)}setVerticalCornerRadius(e){Number.isInteger(e)&&(this.verticalCornerRadius=e)}}t.AnnotationBorderStyle=k;class C extends A{constructor(e){super(e);const{dict:t}=e;if(t.has("IRT")){const e=t.getRaw("IRT");this.data.inReplyTo=e instanceof s.Ref?e.toString():null;const a=t.get("RT");this.data.replyType=a instanceof s.Name?a.name:n.AnnotationReplyType.REPLY}let a=null;if(this.data.replyType===n.AnnotationReplyType.GROUP){const e=t.get("IRT");this.setTitle(e.get("T")),this.data.titleObj=this._title,this.setContents(e.get("Contents")),this.data.contentsObj=this._contents,e.has("CreationDate")?(this.setCreationDate(e.get("CreationDate")),this.data.creationDate=this.creationDate):this.data.creationDate=null,e.has("M")?(this.setModificationDate(e.get("M")),this.data.modificationDate=this.modificationDate):this.data.modificationDate=null,a=e.getRaw("Popup"),e.has("C")?(this.setColor(e.getArray("C")),this.data.color=this.color):this.data.color=null}else this.data.titleObj=this._title,this.setCreationDate(t.get("CreationDate")),this.data.creationDate=this.creationDate,a=t.getRaw("Popup"),t.has("C")||(this.data.color=null);this.data.popupRef=a instanceof s.Ref?a.toString():null,t.has("RC")&&(this.data.richText=b.XFAFactory.getRichTextAsHtml(t.get("RC")))}setCreationDate(e){this.creationDate="string"==typeof e?e:null}_setDefaultAppearance({xref:e,extra:t,strokeColor:a,fillColor:n,blendMode:r,strokeAlpha:i,fillAlpha:c,pointsCallback:l}){let h=Number.MAX_VALUE,u=Number.MAX_VALUE,d=Number.MIN_VALUE,f=Number.MIN_VALUE;const g=["q"];t&&g.push(t),a&&g.push(`${a[0]} ${a[1]} ${a[2]} RG`),n&&g.push(`${n[0]} ${n[1]} ${n[2]} rg`);let p=this.data.quadPoints;p||(p=[[{x:this.rectangle[0],y:this.rectangle[3]},{x:this.rectangle[2],y:this.rectangle[3]},{x:this.rectangle[0],y:this.rectangle[1]},{x:this.rectangle[2],y:this.rectangle[1]}]]);for(const e of p){const[t,a,n,r]=l(g,e);h=Math.min(h,t),d=Math.max(d,a),u=Math.min(u,n),f=Math.max(f,r)}g.push("Q");const m=new s.Dict(e),b=new s.Dict(e);b.set("Subtype",s.Name.get("Form"));const y=new o.StringStream(g.join(" "));y.dict=b,m.set("Fm0",y);const w=new s.Dict(e);r&&w.set("BM",s.Name.get(r)),"number"==typeof i&&w.set("CA",i),"number"==typeof c&&w.set("ca",c);const x=new s.Dict(e);x.set("GS0",w);const S=new s.Dict(e);S.set("ExtGState",x),S.set("XObject",m);const A=new s.Dict(e);A.set("Resources",S);const k=this.data.rect=[h,u,d,f];A.set("BBox",k),this.appearance=new o.StringStream("/GS0 gs /Fm0 Do"),this.appearance.dict=A,this._streams.push(this.appearance,y)}static async createNewAnnotation(e,t,a,n){const r=t.ref||=e.getNewTemporaryRef(),i=await this.createNewAppearanceStream(t,e,n),s=[];let o;if(i){const n=e.getNewTemporaryRef();o=this.createNewDict(t,e,{apRef:n}),await(0,m.writeObject)(n,i,s,e),a.push({ref:n,data:s.join("")})}else o=this.createNewDict(t,e,{});return Number.isInteger(t.parentTreeId)&&o.set("StructParent",t.parentTreeId),s.length=0,await(0,m.writeObject)(r,o,s,e),{ref:r,data:s.join("")}}static async createNewPrintAnnotation(e,t,a,n){const r=await this.createNewAppearanceStream(a,t,n),i=this.createNewDict(a,t,{ap:r}),s=new this.prototype.constructor({dict:i,xref:t,annotationGlobals:e,evaluatorOptions:n.evaluatorOptions});return a.ref&&(s.ref=s.refToReplace=a.ref),s}}t.MarkupAnnotation=C;class v extends A{constructor(e){super(e);const{dict:t,xref:a,annotationGlobals:i}=e,o=this.data;this._needAppearances=e.needAppearances,o.annotationType=n.AnnotationType.WIDGET,void 0===o.fieldName&&(o.fieldName=this._constructFieldName(t)),void 0===o.actions&&(o.actions=(0,r.collectActions)(a,t,n.AnnotationActionEventType));let c=(0,r.getInheritableProperty)({dict:t,key:"V",getArray:!0});o.fieldValue=this._decodeFormValue(c);const l=(0,r.getInheritableProperty)({dict:t,key:"DV",getArray:!0});if(o.defaultFieldValue=this._decodeFormValue(l),void 0===c&&i.xfaDatasets){const e=this._title.str;e&&(this._hasValueFromXFA=!0,o.fieldValue=c=i.xfaDatasets.getValue(e))}void 0===c&&null!==o.defaultFieldValue&&(o.fieldValue=o.defaultFieldValue),o.alternativeText=(0,n.stringToPDFString)(t.get("TU")||""),this.setDefaultAppearance(e),o.hasAppearance||=this._needAppearances&&void 0!==o.fieldValue&&null!==o.fieldValue;const h=(0,r.getInheritableProperty)({dict:t,key:"FT"});o.fieldType=h instanceof s.Name?h.name:null;const u=(0,r.getInheritableProperty)({dict:t,key:"DR"}),d=i.acroForm.get("DR"),f=this.appearance?.dict.get("Resources");this._fieldResources={localResources:u,acroFormResources:d,appearanceResources:f,mergedResources:s.Dict.merge({xref:a,dictArray:[u,f,d],mergeSubDicts:!0})},o.fieldFlags=(0,r.getInheritableProperty)({dict:t,key:"Ff"}),(!Number.isInteger(o.fieldFlags)||o.fieldFlags<0)&&(o.fieldFlags=0),o.readOnly=this.hasFieldFlag(n.AnnotationFieldFlag.READONLY),o.required=this.hasFieldFlag(n.AnnotationFieldFlag.REQUIRED),o.hidden=this._hasFlag(o.annotationFlags,n.AnnotationFlag.HIDDEN)||this._hasFlag(o.annotationFlags,n.AnnotationFlag.NOVIEW)}_decodeFormValue(e){return Array.isArray(e)?e.filter((e=>"string"==typeof e)).map((e=>(0,n.stringToPDFString)(e))):e instanceof s.Name?(0,n.stringToPDFString)(e.name):"string"==typeof e?(0,n.stringToPDFString)(e):null}hasFieldFlag(e){return!!(this.data.fieldFlags&e)}_isViewable(e){return!this._hasFlag(e,n.AnnotationFlag.INVISIBLE)}mustBeViewed(e,t){return t?this.viewable:super.mustBeViewed(e,t)&&!this._hasFlag(this.flags,n.AnnotationFlag.NOVIEW)}getRotationMatrix(e){let t=e?.get(this.data.id)?.rotation;if(void 0===t&&(t=this.rotation),0===t)return n.IDENTITY_MATRIX;const a=this.data.rect[2]-this.data.rect[0],i=this.data.rect[3]-this.data.rect[1];return(0,r.getRotationMatrix)(t,a,i)}getBorderAndBackgroundAppearances(e){let t=e?.get(this.data.id)?.rotation;if(void 0===t&&(t=this.rotation),!this.backgroundColor&&!this.borderColor)return"";const a=this.data.rect[2]-this.data.rect[0],n=this.data.rect[3]-this.data.rect[1],r=0===t||180===t?`0 0 ${a} ${n} re`:`0 0 ${n} ${a} re`;let s="";if(this.backgroundColor&&(s=`${(0,i.getPdfColor)(this.backgroundColor,!0)} ${r} f `),this.borderColor){s+=`${this.borderStyle.width||1} w ${(0,i.getPdfColor)(this.borderColor,!1)} ${r} S `}return s}async getOperatorList(e,t,a,r,i){if(r&&!(this instanceof T)&&!this.data.noHTML&&!this.data.hasOwnCanvas)return{opList:new p.OperatorList,separateForm:!0,separateCanvas:!1};if(!this._hasText)return super.getOperatorList(e,t,a,r,i);const s=await this._getAppearance(e,t,a,i);if(this.appearance&&null===s)return super.getOperatorList(e,t,a,r,i);const c=new p.OperatorList;if(!this._defaultAppearance||null===s)return{opList:c,separateForm:!1,separateCanvas:!1};const l=!!(this.data.hasOwnCanvas&&a&n.RenderingIntentFlag.DISPLAY),h=[0,0,this.data.rect[2]-this.data.rect[0],this.data.rect[3]-this.data.rect[1]],u=S(this.data.rect,h,[1,0,0,1,0,0]);let d;this.oc&&(d=await e.parseMarkedContentProps(this.oc,null)),void 0!==d&&c.addOp(n.OPS.beginMarkedContentProps,["OC",d]),c.addOp(n.OPS.beginAnnotation,[this.data.id,this.data.rect,u,this.getRotationMatrix(i),l]);const f=new o.StringStream(s);return await e.getOperatorList({stream:f,task:t,resources:this._fieldResources.mergedResources,operatorList:c}),c.addOp(n.OPS.endAnnotation,[]),void 0!==d&&c.addOp(n.OPS.endMarkedContent,[]),{opList:c,separateForm:!1,separateCanvas:l}}_getMKDict(e){const t=new s.Dict(null);return e&&t.set("R",e),this.borderColor&&t.set("BC",w(this.borderColor)),this.backgroundColor&&t.set("BG",w(this.backgroundColor)),t.size>0?t:null}amendSavedDict(e,t){}async save(e,t,a){const i=a?.get(this.data.id);let c=i?.value,l=i?.rotation;if(c===this.data.fieldValue||void 0===c){if(!this._hasValueFromXFA&&void 0===l)return null;c||=this.data.fieldValue}if(void 0===l&&!this._hasValueFromXFA&&Array.isArray(c)&&Array.isArray(this.data.fieldValue)&&c.length===this.data.fieldValue.length&&c.every(((e,t)=>e===this.data.fieldValue[t])))return null;void 0===l&&(l=this.rotation);let h=null;if(!this._needAppearances&&(h=await this._getAppearance(e,t,n.RenderingIntentFlag.SAVE,a),null===h))return null;let u=!1;h?.needAppearances&&(u=!0,h=null);const{xref:d}=e,f=d.fetchIfRef(this.ref);if(!(f instanceof s.Dict))return null;const g=new s.Dict(d);for(const e of f.getKeys())"AP"!==e&&g.set(e,f.getRaw(e));const p={path:this.data.fieldName,value:c},b=e=>(0,r.isAscii)(e)?e:(0,r.stringToUTF16String)(e,!0);g.set("V",Array.isArray(c)?c.map(b):b(c)),this.amendSavedDict(a,g);const y=this._getMKDict(l);y&&g.set("MK",y);const w=[],x=[{ref:this.ref,data:"",xfa:p,needAppearances:u}];if(null!==h){const e=d.getNewTemporaryRef(),t=new s.Dict(d);g.set("AP",t),t.set("N",e);const r=this._getSaveFieldResources(d),i=new o.StringStream(h),c=i.dict=new s.Dict(d);c.set("Subtype",s.Name.get("Form")),c.set("Resources",r),c.set("BBox",[0,0,this.data.rect[2]-this.data.rect[0],this.data.rect[3]-this.data.rect[1]]);const l=this.getRotationMatrix(a);l!==n.IDENTITY_MATRIX&&c.set("Matrix",l),await(0,m.writeObject)(e,i,w,d),x.push({ref:e,data:w.join(""),xfa:null,needAppearances:!1}),w.length=0}return g.set("M",`D:${(0,n.getModificationDate)()}`),await(0,m.writeObject)(this.ref,g,w,d),x[0].data=w.join(""),x}async _getAppearance(e,t,a,s){if(this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD))return null;const o=s?.get(this.data.id);let c,l;if(o&&(c=o.formattedValue||o.value,l=o.rotation),void 0===l&&void 0===c&&!this._needAppearances&&(!this._hasValueFromXFA||this.appearance))return null;const h=this.getBorderAndBackgroundAppearances(s);if(void 0===c&&(c=this.data.fieldValue,!c))return`/Tx BMC q ${h}Q EMC`;if(Array.isArray(c)&&1===c.length&&(c=c[0]),(0,n.assert)("string"==typeof c,"Expected `value` to be a string."),c=c.trim(),this.data.combo){const e=this.data.options.find((({exportValue:e})=>c===e));c=e?.displayValue||c}if(""===c)return`/Tx BMC q ${h}Q EMC`;void 0===l&&(l=this.rotation);let u,d=-1;this.data.multiLine?(u=c.split(/\r\n?|\n/).map((e=>e.normalize("NFC"))),d=u.length):u=[c.replace(/\r\n?|\n/,"").normalize("NFC")];let f=this.data.rect[3]-this.data.rect[1],g=this.data.rect[2]-this.data.rect[0];90!==l&&270!==l||([g,f]=[f,g]),this._defaultAppearance||(this.data.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance="/Helvetica 0 Tf 0 g"));let p,m,b,y=await v._getFontData(e,t,this.data.defaultAppearanceData,this._fieldResources.mergedResources);const w=[];let x=!1;for(const e of u){const t=y.encodeString(e);t.length>1&&(x=!0),w.push(t.join(""))}if(x&&a&n.RenderingIntentFlag.SAVE)return{needAppearances:!0};if(x&&this._isOffscreenCanvasSupported){const a=this.data.comb?"monospace":"sans-serif",n=new i.FakeUnicodeFont(e.xref,a),s=n.createFontResources(u.join("")),o=s.getRaw("Font");if(this._fieldResources.mergedResources.has("Font")){const e=this._fieldResources.mergedResources.get("Font");for(const t of o.getKeys())e.set(t,o.getRaw(t))}else this._fieldResources.mergedResources.set("Font",o);const l=n.fontName.name;y=await v._getFontData(e,t,{fontName:l,fontSize:0},s);for(let e=0,t=w.length;e<t;e++)w[e]=(0,r.stringToUTF16String)(u[e]);const h=Object.assign(Object.create(null),this.data.defaultAppearanceData);this.data.defaultAppearanceData.fontSize=0,this.data.defaultAppearanceData.fontName=l,[p,m,b]=this._computeFontSize(f-2,g-4,c,y,d),this.data.defaultAppearanceData=h}else this._isOffscreenCanvasSupported||(0,n.warn)("_getAppearance: OffscreenCanvas is not supported, annotation may not render correctly."),[p,m,b]=this._computeFontSize(f-2,g-4,c,y,d);let S=y.descent;S=isNaN(S)?n.BASELINE_FACTOR*b:Math.max(n.BASELINE_FACTOR*b,Math.abs(S)*m);const A=Math.min(Math.floor((f-m)/2),1),k=this.data.textAlignment;if(this.data.multiLine)return this._getMultilineAppearance(p,w,y,m,g,f,k,2,A,S,b,s);if(this.data.comb)return this._getCombAppearance(p,y,w[0],m,g,f,2,A,S,b,s);const C=A+S;if(0===k||k>2)return`/Tx BMC q ${h}BT `+p+` 1 0 0 1 ${(0,r.numberToString)(2)} ${(0,r.numberToString)(C)} Tm (${(0,r.escapeString)(w[0])}) Tj ET Q EMC`;return`/Tx BMC q ${h}BT `+p+` 1 0 0 1 0 0 Tm ${this._renderText(w[0],y,m,g,k,{shift:0},2,C)} ET Q EMC`}static async _getFontData(e,t,a,n){const r=new p.OperatorList,i={font:null,clone(){return this}},{fontName:o,fontSize:c}=a;return await e.handleSetFont(n,[o&&s.Name.get(o),c],null,r,t,i,null),i.font}_getTextWidth(e,t){return t.charsToGlyphs(e).reduce(((e,t)=>e+t.width),0)/1e3}_computeFontSize(e,t,a,r,s){let{fontSize:o}=this.data.defaultAppearanceData,c=(o||12)*n.LINE_FACTOR,l=Math.round(e/c);if(!o){const h=e=>Math.floor(100*e)/100;if(-1===s){const i=this._getTextWidth(a,r);o=h(Math.min(e/n.LINE_FACTOR,i>t?t/i:1/0)),l=1}else{const i=a.split(/\r\n?|\n/),u=[];for(const e of i){const t=r.encodeString(e).join(""),a=r.charsToGlyphs(t),n=r.getCharPositions(t);u.push({line:t,glyphs:a,positions:n})}const d=a=>{let n=0;for(const i of u){if(n+=this._splitLine(null,r,a,t,i).length*a,n>e)return!0}return!1};for(l=Math.max(l,s);c=e/l,o=h(c/n.LINE_FACTOR),d(o);)l++}const{fontName:u,fontColor:d}=this.data.defaultAppearanceData;this._defaultAppearance=(0,i.createDefaultAppearance)({fontSize:o,fontName:u,fontColor:d})}return[this._defaultAppearance,o,e/l]}_renderText(e,t,a,n,i,s,o,c){let l;if(1===i){l=(n-this._getTextWidth(e,t)*a)/2}else if(2===i){l=n-this._getTextWidth(e,t)*a-o}else l=o;const h=(0,r.numberToString)(l-s.shift);return s.shift=l,`${h} ${c=(0,r.numberToString)(c)} Td (${(0,r.escapeString)(e)}) Tj`}_getSaveFieldResources(e){const{localResources:t,appearanceResources:a,acroFormResources:n}=this._fieldResources,r=this.data.defaultAppearanceData?.fontName;if(!r)return t||s.Dict.empty;for(const e of[t,a])if(e instanceof s.Dict){const t=e.get("Font");if(t instanceof s.Dict&&t.has(r))return e}if(n instanceof s.Dict){const a=n.get("Font");if(a instanceof s.Dict&&a.has(r)){const n=new s.Dict(e);n.set(r,a.getRaw(r));const i=new s.Dict(e);return i.set("Font",n),s.Dict.merge({xref:e,dictArray:[i,t],mergeSubDicts:!0})}}return t||s.Dict.empty}getFieldObject(){return null}}class F extends v{constructor(e){super(e),this.data.hasOwnCanvas=this.data.readOnly&&!this.data.noHTML,this._hasText=!0;const t=e.dict;"string"!=typeof this.data.fieldValue&&(this.data.fieldValue="");let a=(0,r.getInheritableProperty)({dict:t,key:"Q"});(!Number.isInteger(a)||a<0||a>2)&&(a=null),this.data.textAlignment=a;let i=(0,r.getInheritableProperty)({dict:t,key:"MaxLen"});(!Number.isInteger(i)||i<0)&&(i=0),this.data.maxLen=i,this.data.multiLine=this.hasFieldFlag(n.AnnotationFieldFlag.MULTILINE),this.data.comb=this.hasFieldFlag(n.AnnotationFieldFlag.COMB)&&!this.hasFieldFlag(n.AnnotationFieldFlag.MULTILINE)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD)&&!this.hasFieldFlag(n.AnnotationFieldFlag.FILESELECT)&&0!==this.data.maxLen,this.data.doNotScroll=this.hasFieldFlag(n.AnnotationFieldFlag.DONOTSCROLL)}get hasTextContent(){return!!this.appearance&&!this._needAppearances}_getCombAppearance(e,t,a,n,i,s,o,c,l,h,u){const d=i/this.data.maxLen,f=this.getBorderAndBackgroundAppearances(u),g=[],p=t.getCharPositions(a);for(const[e,t]of p)g.push(`(${(0,r.escapeString)(a.substring(e,t))}) Tj`);const m=g.join(` ${(0,r.numberToString)(d)} 0 Td `);return`/Tx BMC q ${f}BT `+e+` 1 0 0 1 ${(0,r.numberToString)(o)} ${(0,r.numberToString)(c+l)} Tm ${m} ET Q EMC`}_getMultilineAppearance(e,t,a,n,i,s,o,c,l,h,u,d){const f=[],g=i-2*c,p={shift:0};for(let e=0,r=t.length;e<r;e++){const r=t[e],s=this._splitLine(r,a,n,g);for(let t=0,r=s.length;t<r;t++){const r=s[t],d=0===e&&0===t?-l-(u-h):-u;f.push(this._renderText(r,a,n,i,o,p,c,d))}}const m=this.getBorderAndBackgroundAppearances(d),b=f.join("\n");return`/Tx BMC q ${m}BT `+e+` 1 0 0 1 0 ${(0,r.numberToString)(s)} Tm ${b} ET Q EMC`}_splitLine(e,t,a,n,r={}){e=r.line||e;const i=r.glyphs||t.charsToGlyphs(e);if(i.length<=1)return[e];const s=r.positions||t.getCharPositions(e),o=a/1e3,c=[];let l=-1,h=-1,u=-1,d=0,f=0;for(let t=0,a=i.length;t<a;t++){const[a,r]=s[t],g=i[t],p=g.width*o;" "===g.unicode?f+p>n?(c.push(e.substring(d,a)),d=a,f=p,l=-1,u=-1):(f+=p,l=a,h=r,u=t):f+p>n?-1!==l?(c.push(e.substring(d,h)),d=h,t=u+1,l=-1,f=0):(c.push(e.substring(d,a)),d=a,f=p):f+=p}return d<e.length&&c.push(e.substring(d,e.length)),c}getFieldObject(){return{id:this.data.id,value:this.data.fieldValue,defaultValue:this.data.defaultFieldValue||"",multiline:this.data.multiLine,password:this.hasFieldFlag(n.AnnotationFieldFlag.PASSWORD),charLimit:this.data.maxLen,comb:this.data.comb,editable:!this.data.readOnly,hidden:this.data.hidden,name:this.data.fieldName,rect:this.data.rect,actions:this.data.actions,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,rotation:this.rotation,type:"text"}}}class O extends v{constructor(e){super(e),this.checkedAppearance=null,this.uncheckedAppearance=null,this.data.checkBox=!this.hasFieldFlag(n.AnnotationFieldFlag.RADIO)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON),this.data.radioButton=this.hasFieldFlag(n.AnnotationFieldFlag.RADIO)&&!this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON),this.data.pushButton=this.hasFieldFlag(n.AnnotationFieldFlag.PUSHBUTTON),this.data.isTooltipOnly=!1,this.data.checkBox?this._processCheckBox(e):this.data.radioButton?this._processRadioButton(e):this.data.pushButton?(this.data.hasOwnCanvas=!0,this._processPushButton(e)):(0,n.warn)("Invalid field flags for button widget annotation")}async getOperatorList(e,t,a,r,i){if(this.data.pushButton)return super.getOperatorList(e,t,a,!1,i);let s=null,o=null;if(i){const e=i.get(this.data.id);s=e?e.value:null,o=e?e.rotation:null}if(null===s&&this.appearance)return super.getOperatorList(e,t,a,r,i);null==s&&(s=this.data.checkBox?this.data.fieldValue===this.data.exportValue:this.data.fieldValue===this.data.buttonValue);const c=s?this.checkedAppearance:this.uncheckedAppearance;if(c){const s=this.appearance,l=c.dict.getArray("Matrix")||n.IDENTITY_MATRIX;o&&c.dict.set("Matrix",this.getRotationMatrix(i)),this.appearance=c;const h=super.getOperatorList(e,t,a,r,i);return this.appearance=s,c.dict.set("Matrix",l),h}return{opList:new p.OperatorList,separateForm:!1,separateCanvas:!1}}async save(e,t,a){return this.data.checkBox?this._saveCheckbox(e,t,a):this.data.radioButton?this._saveRadioButton(e,t,a):null}async _saveCheckbox(e,t,a){if(!a)return null;const r=a.get(this.data.id);let i=r?.rotation,o=r?.value;if(void 0===i){if(void 0===o)return null;if(this.data.fieldValue===this.data.exportValue===o)return null}const c=e.xref.fetchIfRef(this.ref);if(!(c instanceof s.Dict))return null;void 0===i&&(i=this.rotation),void 0===o&&(o=this.data.fieldValue===this.data.exportValue);const l={path:this.data.fieldName,value:o?this.data.exportValue:""},h=s.Name.get(o?this.data.exportValue:"Off");c.set("V",h),c.set("AS",h),c.set("M",`D:${(0,n.getModificationDate)()}`);const u=this._getMKDict(i);u&&c.set("MK",u);const d=[];return await(0,m.writeObject)(this.ref,c,d,e.xref),[{ref:this.ref,data:d.join(""),xfa:l}]}async _saveRadioButton(e,t,a){if(!a)return null;const r=a.get(this.data.id);let i=r?.rotation,o=r?.value;if(void 0===i){if(void 0===o)return null;if(this.data.fieldValue===this.data.buttonValue===o)return null}const c=e.xref.fetchIfRef(this.ref);if(!(c instanceof s.Dict))return null;void 0===o&&(o=this.data.fieldValue===this.data.buttonValue),void 0===i&&(i=this.rotation);const l={path:this.data.fieldName,value:o?this.data.buttonValue:""},h=s.Name.get(o?this.data.buttonValue:"Off"),u=[];let d=null;if(o)if(this.parent instanceof s.Ref){const t=e.xref.fetch(this.parent);t.set("V",h),await(0,m.writeObject)(this.parent,t,u,e.xref),d=u.join(""),u.length=0}else this.parent instanceof s.Dict&&this.parent.set("V",h);c.set("AS",h),c.set("M",`D:${(0,n.getModificationDate)()}`);const f=this._getMKDict(i);f&&c.set("MK",f),await(0,m.writeObject)(this.ref,c,u,e.xref);const g=[{ref:this.ref,data:u.join(""),xfa:l}];return d&&g.push({ref:this.parent,data:d,xfa:null}),g}_getDefaultCheckedAppearance(e,t){const a=this.data.rect[2]-this.data.rect[0],i=this.data.rect[3]-this.data.rect[1],c=[0,0,a,i],l=.8*Math.min(a,i);let h,u;"check"===t?(h={width:.755*l,height:.705*l},u="3"):"disc"===t?(h={width:.791*l,height:.705*l},u="l"):(0,n.unreachable)(`_getDefaultCheckedAppearance - unsupported type: ${t}`);const d=`q BT /PdfJsZaDb ${l} Tf 0 g ${(0,r.numberToString)((a-h.width)/2)} ${(0,r.numberToString)((i-h.height)/2)} Td (${u}) Tj ET Q`,f=new s.Dict(e.xref);f.set("FormType",1),f.set("Subtype",s.Name.get("Form")),f.set("Type",s.Name.get("XObject")),f.set("BBox",c),f.set("Matrix",[1,0,0,1,0,0]),f.set("Length",d.length);const g=new s.Dict(e.xref),p=new s.Dict(e.xref);p.set("PdfJsZaDb",this.fallbackFontDict),g.set("Font",p),f.set("Resources",g),this.checkedAppearance=new o.StringStream(d),this.checkedAppearance.dict=f,this._streams.push(this.checkedAppearance)}_processCheckBox(e){const t=e.dict.get("AP");if(!(t instanceof s.Dict))return;const a=t.get("N");if(!(a instanceof s.Dict))return;const n=this._decodeFormValue(e.dict.get("AS"));"string"==typeof n&&(this.data.fieldValue=n);const r=null!==this.data.fieldValue&&"Off"!==this.data.fieldValue?this.data.fieldValue:"Yes",i=a.getKeys();if(0===i.length)i.push("Off",r);else if(1===i.length)"Off"===i[0]?i.push(r):i.unshift("Off");else if(i.includes(r))i.length=0,i.push("Off",r);else{const e=i.find((e=>"Off"!==e));i.length=0,i.push("Off",e)}i.includes(this.data.fieldValue)||(this.data.fieldValue="Off"),this.data.exportValue=i[1];const o=a.get(this.data.exportValue);this.checkedAppearance=o instanceof c.BaseStream?o:null;const l=a.get("Off");this.uncheckedAppearance=l instanceof c.BaseStream?l:null,this.checkedAppearance?this._streams.push(this.checkedAppearance):this._getDefaultCheckedAppearance(e,"check"),this.uncheckedAppearance&&this._streams.push(this.uncheckedAppearance),this._fallbackFontDict=this.fallbackFontDict,null===this.data.defaultFieldValue&&(this.data.defaultFieldValue="Off")}_processRadioButton(e){this.data.fieldValue=this.data.buttonValue=null;const t=e.dict.get("Parent");if(t instanceof s.Dict){this.parent=e.dict.getRaw("Parent");const a=t.get("V");a instanceof s.Name&&(this.data.fieldValue=this._decodeFormValue(a))}const a=e.dict.get("AP");if(!(a instanceof s.Dict))return;const n=a.get("N");if(!(n instanceof s.Dict))return;for(const e of n.getKeys())if("Off"!==e){this.data.buttonValue=this._decodeFormValue(e);break}const r=n.get(this.data.buttonValue);this.checkedAppearance=r instanceof c.BaseStream?r:null;const i=n.get("Off");this.uncheckedAppearance=i instanceof c.BaseStream?i:null,this.checkedAppearance?this._streams.push(this.checkedAppearance):this._getDefaultCheckedAppearance(e,"disc"),this.uncheckedAppearance&&this._streams.push(this.uncheckedAppearance),this._fallbackFontDict=this.fallbackFontDict,null===this.data.defaultFieldValue&&(this.data.defaultFieldValue="Off")}_processPushButton(e){const{dict:t,annotationGlobals:a}=e;t.has("A")||t.has("AA")||this.data.alternativeText?(this.data.isTooltipOnly=!t.has("A")&&!t.has("AA"),h.Catalog.parseDestDictionary({destDict:t,resultObj:this.data,docBaseUrl:a.baseUrl,docAttachments:a.attachments})):(0,n.warn)("Push buttons without action dictionaries are not supported")}getFieldObject(){let e,t="button";return this.data.checkBox?(t="checkbox",e=this.data.exportValue):this.data.radioButton&&(t="radiobutton",e=this.data.buttonValue),{id:this.data.id,value:this.data.fieldValue||"Off",defaultValue:this.data.defaultFieldValue,exportValues:e,editable:!this.data.readOnly,name:this.data.fieldName,rect:this.data.rect,hidden:this.data.hidden,actions:this.data.actions,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,rotation:this.rotation,type:t}}get fallbackFontDict(){const e=new s.Dict;return e.set("BaseFont",s.Name.get("ZapfDingbats")),e.set("Type",s.Name.get("FallbackType")),e.set("Subtype",s.Name.get("FallbackType")),e.set("Encoding",s.Name.get("ZapfDingbatsEncoding")),(0,n.shadow)(this,"fallbackFontDict",e)}}class I extends v{constructor(e){super(e);const{dict:t,xref:a}=e;this.indices=t.getArray("I"),this.hasIndices=Array.isArray(this.indices)&&this.indices.length>0,this.data.options=[];const i=(0,r.getInheritableProperty)({dict:t,key:"Opt"});if(Array.isArray(i))for(let e=0,t=i.length;e<t;e++){const t=a.fetchIfRef(i[e]),n=Array.isArray(t);this.data.options[e]={exportValue:this._decodeFormValue(n?a.fetchIfRef(t[0]):t),displayValue:this._decodeFormValue(n?a.fetchIfRef(t[1]):t)}}if(this.hasIndices){this.data.fieldValue=[];const e=this.data.options.length;for(const t of this.indices)Number.isInteger(t)&&t>=0&&t<e&&this.data.fieldValue.push(this.data.options[t].exportValue)}else"string"==typeof this.data.fieldValue?this.data.fieldValue=[this.data.fieldValue]:this.data.fieldValue||(this.data.fieldValue=[]);this.data.combo=this.hasFieldFlag(n.AnnotationFieldFlag.COMBO),this.data.multiSelect=this.hasFieldFlag(n.AnnotationFieldFlag.MULTISELECT),this._hasText=!0}getFieldObject(){const e=this.data.combo?"combobox":"listbox",t=this.data.fieldValue.length>0?this.data.fieldValue[0]:null;return{id:this.data.id,value:t,defaultValue:this.data.defaultFieldValue,editable:!this.data.readOnly,name:this.data.fieldName,rect:this.data.rect,numItems:this.data.fieldValue.length,multipleSelection:this.data.multiSelect,hidden:this.data.hidden,actions:this.data.actions,items:this.data.options,page:this.data.pageIndex,strokeColor:this.data.borderColor,fillColor:this.data.backgroundColor,rotation:this.rotation,type:e}}amendSavedDict(e,t){if(!this.hasIndices)return;let a=e?.get(this.data.id)?.value;Array.isArray(a)||(a=[a]);const n=[],{options:r}=this.data;for(let e=0,t=0,i=r.length;e<i;e++)r[e].exportValue===a[t]&&(n.push(e),t+=1);t.set("I",n)}async _getAppearance(e,t,a,r){if(this.data.combo)return super._getAppearance(e,t,a,r);let s,o;const c=r?.get(this.data.id);if(c&&(o=c.rotation,s=c.value),void 0===o&&void 0===s&&!this._needAppearances)return null;void 0===s?s=this.data.fieldValue:Array.isArray(s)||(s=[s]);let l=this.data.rect[3]-this.data.rect[1],h=this.data.rect[2]-this.data.rect[0];90!==o&&270!==o||([h,l]=[l,h]);const u=this.data.options.length,d=[];for(let e=0;e<u;e++){const{exportValue:t}=this.data.options[e];s.includes(t)&&d.push(e)}this._defaultAppearance||(this.data.defaultAppearanceData=(0,i.parseDefaultAppearance)(this._defaultAppearance="/Helvetica 0 Tf 0 g"));const f=await v._getFontData(e,t,this.data.defaultAppearanceData,this._fieldResources.mergedResources);let g,{fontSize:p}=this.data.defaultAppearanceData;if(p)g=this._defaultAppearance;else{const e=(l-1)/u;let t,a=-1;for(const{displayValue:e}of this.data.options){const n=this._getTextWidth(e,f);n>a&&(a=n,t=e)}[g,p]=this._computeFontSize(e,h-4,t,f,-1)}const m=p*n.LINE_FACTOR,b=(m-p)/2,y=Math.floor(l/m);let w=0;if(d.length>0){const e=Math.min(...d),t=Math.max(...d);w=Math.max(0,t-y+1),w>e&&(w=e)}const x=Math.min(w+y+1,u),S=["/Tx BMC q",`1 1 ${h} ${l} re W n`];if(d.length){S.push("0.600006 0.756866 0.854904 rg");for(const e of d)w<=e&&e<x&&S.push(`1 ${l-(e-w+1)*m} ${h} ${m} re f`)}S.push("BT",g,`1 0 0 1 0 ${l} Tm`);const A={shift:0};for(let e=w;e<x;e++){const{displayValue:t}=this.data.options[e],a=e===w?b:0;S.push(this._renderText(t,f,p,h,0,A,2,-m+a))}return S.push("ET Q EMC"),S.join("\n")}}class T extends v{constructor(e){super(e),this.data.fieldValue=null,this.data.hasOwnCanvas=this.data.noRotate}getFieldObject(){return{id:this.data.id,value:null,page:this.data.pageIndex,type:"signature"}}}class M extends C{constructor(e){super(e),this.data.noRotate=!0,this.data.hasOwnCanvas=this.data.noRotate;const{dict:t}=e;this.data.annotationType=n.AnnotationType.TEXT,this.data.hasAppearance?this.data.name="NoIcon":(this.data.rect[1]=this.data.rect[3]-22,this.data.rect[2]=this.data.rect[0]+22,this.data.name=t.has("Name")?t.get("Name").name:"Note"),t.has("State")?(this.data.state=t.get("State")||null,this.data.stateModel=t.get("StateModel")||null):(this.data.state=null,this.data.stateModel=null)}}class P extends A{constructor(e){super(e);const{dict:t,annotationGlobals:a}=e;this.data.annotationType=n.AnnotationType.LINK;const r=x(t,this.rectangle);r&&(this.data.quadPoints=r),this.data.borderColor||=this.data.color,h.Catalog.parseDestDictionary({destDict:t,resultObj:this.data,docBaseUrl:a.baseUrl,docAttachments:a.attachments})}}class N extends A{constructor(e){super(e);const{dict:t}=e;this.data.annotationType=n.AnnotationType.POPUP,this.data.rect[0]!==this.data.rect[2]&&this.data.rect[1]!==this.data.rect[3]||(this.data.rect=null);let a=t.get("Parent");if(!a)return void(0,n.warn)("Popup annotation has a missing or invalid parent annotation.");const r=a.getArray("Rect");this.data.parentRect=Array.isArray(r)&&4===r.length?n.Util.normalizeRect(r):null;const i=a.get("RT");if((0,s.isName)(i,n.AnnotationReplyType.GROUP)&&(a=a.get("IRT")),a.has("M")?(this.setModificationDate(a.get("M")),this.data.modificationDate=this.modificationDate):this.data.modificationDate=null,a.has("C")?(this.setColor(a.getArray("C")),this.data.color=this.color):this.data.color=null,!this.viewable){const e=a.get("F");this._isViewable(e)&&this.setFlags(e)}this.setTitle(a.get("T")),this.data.titleObj=this._title,this.setContents(a.get("Contents")),this.data.contentsObj=this._contents,a.has("RC")&&(this.data.richText=b.XFAFactory.getRichTextAsHtml(a.get("RC"))),this.data.open=!!t.get("Open")}}t.PopupAnnotation=N;class D extends C{constructor(e){super(e),this.data.hasOwnCanvas=!0;const{evaluatorOptions:t,xref:a}=e;if(this.data.annotationType=n.AnnotationType.FREETEXT,this.setDefaultAppearance(e),this.appearance){const{fontColor:e,fontSize:n}=(0,i.parseAppearanceStream)(this.appearance,t,a);this.data.defaultAppearanceData.fontColor=e,this.data.defaultAppearanceData.fontSize=n||10}else if(this._isOffscreenCanvasSupported){const t=e.dict.get("CA"),n=new i.FakeUnicodeFont(a,"sans-serif");this.data.defaultAppearanceData.fontSize||=10;const{fontColor:r,fontSize:s}=this.data.defaultAppearanceData;this.appearance=n.createAppearance(this._contents.str,this.rectangle,this.rotation,s,r,t),this._streams.push(this.appearance,i.FakeUnicodeFont.toUnicodeStream)}else(0,n.warn)("FreeTextAnnotation: OffscreenCanvas is not supported, annotation may not render correctly.")}get hasTextContent(){return!!this.appearance}static createNewDict(e,t,{apRef:a,ap:o}){const{color:c,fontSize:l,rect:h,rotation:u,user:d,value:f}=e,g=new s.Dict(t);g.set("Type",s.Name.get("Annot")),g.set("Subtype",s.Name.get("FreeText")),g.set("CreationDate",`D:${(0,n.getModificationDate)()}`),g.set("Rect",h);const p=`/Helv ${l} Tf ${(0,i.getPdfColor)(c,!0)}`;if(g.set("DA",p),g.set("Contents",(0,r.isAscii)(f)?f:(0,r.stringToUTF16String)(f,!0)),g.set("F",4),g.set("Border",[0,0,0]),g.set("Rotate",u),d&&g.set("T",(0,r.isAscii)(d)?d:(0,r.stringToUTF16String)(d,!0)),a||o){const e=new s.Dict(t);g.set("AP",e),a?e.set("N",a):e.set("N",o)}return g}static async createNewAppearanceStream(e,t,a){const{baseFontRef:c,evaluator:l,task:h}=a,{color:u,fontSize:d,rect:f,rotation:g,value:p}=e,m=new s.Dict(t),b=new s.Dict(t);if(c)b.set("Helv",c);else{const e=new s.Dict(t);e.set("BaseFont",s.Name.get("Helvetica")),e.set("Type",s.Name.get("Font")),e.set("Subtype",s.Name.get("Type1")),e.set("Encoding",s.Name.get("WinAnsiEncoding")),b.set("Helv",e)}m.set("Font",b);const y=await v._getFontData(l,h,{fontName:"Helv",fontSize:d},m),[w,x,S,A]=f;let k=S-w,C=A-x;g%180!=0&&([k,C]=[C,k]);const F=p.split("\n"),O=d/1e3;let I=-1/0;const T=[];for(let e of F){const t=y.encodeString(e);if(t.length>1)return null;e=t.join(""),T.push(e);let a=0;const n=y.charsToGlyphs(e);for(const e of n)a+=e.width*O;I=Math.max(I,a)}let M=1;I>k&&(M=k/I);let P=1;const N=n.LINE_FACTOR*d,D=(n.LINE_FACTOR-n.LINE_DESCENT_FACTOR)*d,R=N*F.length;R>C&&(P=C/R);const E=d*Math.min(M,P);let B,$,L;switch(g){case 0:L=[1,0,0,1],$=[f[0],f[1],k,C],B=[f[0],f[3]-D];break;case 90:L=[0,1,-1,0],$=[f[1],-f[2],k,C],B=[f[1],-f[0]-D];break;case 180:L=[-1,0,0,-1],$=[-f[2],-f[3],k,C],B=[-f[2],-f[1]-D];break;case 270:L=[0,-1,1,0],$=[-f[3],f[0],k,C],B=[-f[3],f[2]-D]}const _=["q",`${L.join(" ")} 0 0 cm`,`${$.join(" ")} re W n`,"BT",`${(0,i.getPdfColor)(u,!0)}`,`0 Tc /Helv ${(0,r.numberToString)(E)} Tf`];_.push(`${B.join(" ")} Td (${(0,r.escapeString)(T[0])}) Tj`);const j=(0,r.numberToString)(N);for(let e=1,t=T.length;e<t;e++){const t=T[e];_.push(`0 -${j} Td (${(0,r.escapeString)(t)}) Tj`)}_.push("ET","Q");const U=_.join("\n"),X=new s.Dict(t);X.set("FormType",1),X.set("Subtype",s.Name.get("Form")),X.set("Type",s.Name.get("XObject")),X.set("BBox",f),X.set("Resources",m),X.set("Matrix",[1,0,0,1,-f[0],-f[1]]);const H=new o.StringStream(U);return H.dict=X,H}}class R extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.LINE,this.data.hasOwnCanvas=this.data.noRotate;const r=t.getArray("L");if(this.data.lineCoordinates=n.Util.normalizeRect(r),this.setLineEndings(t.getArray("LE")),this.data.lineEndings=this.lineEndings,!this.appearance){const e=this.color?w(this.color):[0,0,0],i=t.get("CA"),s=y(t.getArray("IC"),null),o=s?w(s):null,c=o?i:null,l=this.borderStyle.width||1,h=2*l,u=[this.data.lineCoordinates[0]-h,this.data.lineCoordinates[1]-h,this.data.lineCoordinates[2]+h,this.data.lineCoordinates[3]+h];n.Util.intersect(this.rectangle,u)||(this.rectangle=u),this._setDefaultAppearance({xref:a,extra:`${l} w`,strokeColor:e,fillColor:o,strokeAlpha:i,fillAlpha:c,pointsCallback:(e,t)=>(e.push(`${r[0]} ${r[1]} m`,`${r[2]} ${r[3]} l`,"S"),[t[0].x-l,t[1].x+l,t[3].y-l,t[1].y+l])})}}}class E extends C{constructor(e){super(e);const{dict:t,xref:a}=e;if(this.data.annotationType=n.AnnotationType.SQUARE,this.data.hasOwnCanvas=this.data.noRotate,!this.appearance){const e=this.color?w(this.color):[0,0,0],n=t.get("CA"),r=y(t.getArray("IC"),null),i=r?w(r):null,s=i?n:null;if(0===this.borderStyle.width&&!i)return;this._setDefaultAppearance({xref:a,extra:`${this.borderStyle.width} w`,strokeColor:e,fillColor:i,strokeAlpha:n,fillAlpha:s,pointsCallback:(e,t)=>{const a=t[2].x+this.borderStyle.width/2,n=t[2].y+this.borderStyle.width/2,r=t[3].x-t[2].x-this.borderStyle.width,s=t[1].y-t[3].y-this.borderStyle.width;return e.push(`${a} ${n} ${r} ${s} re`),i?e.push("B"):e.push("S"),[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}class B extends C{constructor(e){super(e);const{dict:t,xref:a}=e;if(this.data.annotationType=n.AnnotationType.CIRCLE,!this.appearance){const e=this.color?w(this.color):[0,0,0],n=t.get("CA"),r=y(t.getArray("IC"),null),i=r?w(r):null,s=i?n:null;if(0===this.borderStyle.width&&!i)return;const o=4/3*Math.tan(Math.PI/8);this._setDefaultAppearance({xref:a,extra:`${this.borderStyle.width} w`,strokeColor:e,fillColor:i,strokeAlpha:n,fillAlpha:s,pointsCallback:(e,t)=>{const a=t[0].x+this.borderStyle.width/2,n=t[0].y-this.borderStyle.width/2,r=t[3].x-this.borderStyle.width/2,s=t[3].y+this.borderStyle.width/2,c=a+(r-a)/2,l=n+(s-n)/2,h=(r-a)/2*o,u=(s-n)/2*o;return e.push(`${c} ${s} m`,`${c+h} ${s} ${r} ${l+u} ${r} ${l} c`,`${r} ${l-u} ${c+h} ${n} ${c} ${n} c`,`${c-h} ${n} ${a} ${l-u} ${a} ${l} c`,`${a} ${l+u} ${c-h} ${s} ${c} ${s} c`,"h"),i?e.push("B"):e.push("S"),[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}class $ extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.POLYLINE,this.data.hasOwnCanvas=this.data.noRotate,this.data.vertices=[],this instanceof L||(this.setLineEndings(t.getArray("LE")),this.data.lineEndings=this.lineEndings);const r=t.getArray("Vertices");if(Array.isArray(r)){for(let e=0,t=r.length;e<t;e+=2)this.data.vertices.push({x:r[e],y:r[e+1]});if(!this.appearance){const e=this.color?w(this.color):[0,0,0],r=t.get("CA"),i=this.borderStyle.width||1,s=2*i,o=[1/0,1/0,-1/0,-1/0];for(const e of this.data.vertices)o[0]=Math.min(o[0],e.x-s),o[1]=Math.min(o[1],e.y-s),o[2]=Math.max(o[2],e.x+s),o[3]=Math.max(o[3],e.y+s);n.Util.intersect(this.rectangle,o)||(this.rectangle=o),this._setDefaultAppearance({xref:a,extra:`${i} w`,strokeColor:e,strokeAlpha:r,pointsCallback:(e,t)=>{const a=this.data.vertices;for(let t=0,n=a.length;t<n;t++)e.push(`${a[t].x} ${a[t].y} ${0===t?"m":"l"}`);return e.push("S"),[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}}class L extends ${constructor(e){super(e),this.data.annotationType=n.AnnotationType.POLYGON}}class _ extends C{constructor(e){super(e),this.data.annotationType=n.AnnotationType.CARET}}class j extends C{constructor(e){super(e),this.data.hasOwnCanvas=this.data.noRotate;const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.INK,this.data.inkLists=[];const r=t.getArray("InkList");if(Array.isArray(r)){for(let e=0,t=r.length;e<t;++e){this.data.inkLists.push([]);for(let t=0,n=r[e].length;t<n;t+=2)this.data.inkLists[e].push({x:a.fetchIfRef(r[e][t]),y:a.fetchIfRef(r[e][t+1])})}if(!this.appearance){const e=this.color?w(this.color):[0,0,0],r=t.get("CA"),i=this.borderStyle.width||1,s=2*i,o=[1/0,1/0,-1/0,-1/0];for(const e of this.data.inkLists)for(const t of e)o[0]=Math.min(o[0],t.x-s),o[1]=Math.min(o[1],t.y-s),o[2]=Math.max(o[2],t.x+s),o[3]=Math.max(o[3],t.y+s);n.Util.intersect(this.rectangle,o)||(this.rectangle=o),this._setDefaultAppearance({xref:a,extra:`${i} w`,strokeColor:e,strokeAlpha:r,pointsCallback:(e,t)=>{for(const t of this.data.inkLists){for(let a=0,n=t.length;a<n;a++)e.push(`${t[a].x} ${t[a].y} ${0===a?"m":"l"}`);e.push("S")}return[t[0].x,t[1].x,t[3].y,t[1].y]}})}}}static createNewDict(e,t,{apRef:a,ap:r}){const{color:i,opacity:o,paths:c,rect:l,rotation:h,thickness:u}=e,d=new s.Dict(t);d.set("Type",s.Name.get("Annot")),d.set("Subtype",s.Name.get("Ink")),d.set("CreationDate",`D:${(0,n.getModificationDate)()}`),d.set("Rect",l),d.set("InkList",c.map((e=>e.points))),d.set("F",4),d.set("Rotate",h);const f=new s.Dict(t);d.set("BS",f),f.set("W",u),d.set("C",Array.from(i,(e=>e/255))),d.set("CA",o);const g=new s.Dict(t);return d.set("AP",g),a?g.set("N",a):g.set("N",r),d}static async createNewAppearanceStream(e,t,a){const{color:n,rect:c,paths:l,thickness:h,opacity:u}=e,d=[`${h} w 1 J 1 j`,`${(0,i.getPdfColor)(n,!1)}`];1!==u&&d.push("/R0 gs");const f=[];for(const{bezier:e}of l){f.length=0,f.push(`${(0,r.numberToString)(e[0])} ${(0,r.numberToString)(e[1])} m`);for(let t=2,a=e.length;t<a;t+=6){const a=e.slice(t,t+6).map(r.numberToString).join(" ");f.push(`${a} c`)}f.push("S"),d.push(f.join("\n"))}const g=d.join("\n"),p=new s.Dict(t);if(p.set("FormType",1),p.set("Subtype",s.Name.get("Form")),p.set("Type",s.Name.get("XObject")),p.set("BBox",c),p.set("Length",g.length),1!==u){const e=new s.Dict(t),a=new s.Dict(t),n=new s.Dict(t);n.set("CA",u),n.set("Type",s.Name.get("ExtGState")),a.set("R0",n),e.set("ExtGState",a),p.set("Resources",e)}const m=new o.StringStream(g);return m.dict=p,m}}class U extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.HIGHLIGHT;if(this.data.quadPoints=x(t,null)){const e=this.appearance?.dict.get("Resources");if(!this.appearance||!e?.has("ExtGState")){this.appearance&&(0,n.warn)("HighlightAnnotation - ignoring built-in appearance stream.");const e=this.color?w(this.color):[1,1,0],r=t.get("CA");this._setDefaultAppearance({xref:a,fillColor:e,blendMode:"Multiply",fillAlpha:r,pointsCallback:(e,t)=>(e.push(`${t[0].x} ${t[0].y} m`,`${t[1].x} ${t[1].y} l`,`${t[3].x} ${t[3].y} l`,`${t[2].x} ${t[2].y} l`,"f"),[t[0].x,t[1].x,t[3].y,t[1].y])})}}else this.data.popupRef=null}}class X extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.UNDERLINE;if(this.data.quadPoints=x(t,null)){if(!this.appearance){const e=this.color?w(this.color):[0,0,0],n=t.get("CA");this._setDefaultAppearance({xref:a,extra:"[] 0 d 0.571 w",strokeColor:e,strokeAlpha:n,pointsCallback:(e,t)=>(e.push(`${t[2].x} ${t[2].y+1.3} m`,`${t[3].x} ${t[3].y+1.3} l`,"S"),[t[0].x,t[1].x,t[3].y,t[1].y])})}}else this.data.popupRef=null}}class H extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.SQUIGGLY;if(this.data.quadPoints=x(t,null)){if(!this.appearance){const e=this.color?w(this.color):[0,0,0],n=t.get("CA");this._setDefaultAppearance({xref:a,extra:"[] 0 d 1 w",strokeColor:e,strokeAlpha:n,pointsCallback:(e,t)=>{const a=(t[0].y-t[2].y)/6;let n=a,r=t[2].x;const i=t[2].y,s=t[3].x;e.push(`${r} ${i+n} m`);do{r+=2,n=0===n?a:0,e.push(`${r} ${i+n} l`)}while(r<s);return e.push("S"),[t[2].x,s,i-2*a,i+2*a]}})}}else this.data.popupRef=null}}class q extends C{constructor(e){super(e);const{dict:t,xref:a}=e;this.data.annotationType=n.AnnotationType.STRIKEOUT;if(this.data.quadPoints=x(t,null)){if(!this.appearance){const e=this.color?w(this.color):[0,0,0],n=t.get("CA");this._setDefaultAppearance({xref:a,extra:"[] 0 d 1 w",strokeColor:e,strokeAlpha:n,pointsCallback:(e,t)=>(e.push((t[0].x+t[2].x)/2+" "+(t[0].y+t[2].y)/2+" m",(t[1].x+t[3].x)/2+" "+(t[1].y+t[3].y)/2+" l","S"),[t[0].x,t[1].x,t[3].y,t[1].y])})}}else this.data.popupRef=null}}class z extends C{constructor(e){super(e),this.data.annotationType=n.AnnotationType.STAMP,this.data.hasOwnCanvas=this.data.noRotate}static async createImage(e,t){const{width:a,height:r}=e,i=new OffscreenCanvas(a,r),c=i.getContext("2d",{alpha:!0});c.drawImage(e,0,0);const l=c.getImageData(0,0,a,r).data,h=new Uint32Array(l.buffer),u=h.some(n.FeatureTest.isLittleEndian?e=>e>>>24!=255:e=>255!=(255&e));u&&(c.fillStyle="white",c.fillRect(0,0,a,r),c.drawImage(e,0,0));const d=i.convertToBlob({type:"image/jpeg",quality:1}).then((e=>e.arrayBuffer())),f=s.Name.get("XObject"),g=s.Name.get("Image"),p=new s.Dict(t);p.set("Type",f),p.set("Subtype",g),p.set("BitsPerComponent",8),p.set("ColorSpace",s.Name.get("DeviceRGB")),p.set("Filter",s.Name.get("DCTDecode")),p.set("BBox",[0,0,a,r]),p.set("Width",a),p.set("Height",r);let m=null;if(u){const e=new Uint8Array(h.length);if(n.FeatureTest.isLittleEndian)for(let t=0,a=h.length;t<a;t++)e[t]=h[t]>>>24;else for(let t=0,a=h.length;t<a;t++)e[t]=255&h[t];const i=new s.Dict(t);i.set("Type",f),i.set("Subtype",g),i.set("BitsPerComponent",8),i.set("ColorSpace",s.Name.get("DeviceGray")),i.set("Width",a),i.set("Height",r),m=new o.Stream(e,0,0,i)}return{imageStream:new o.Stream(await d,0,0,p),smaskStream:m,width:a,height:r}}static createNewDict(e,t,{apRef:a,ap:i}){const{rect:o,rotation:c,user:l}=e,h=new s.Dict(t);if(h.set("Type",s.Name.get("Annot")),h.set("Subtype",s.Name.get("Stamp")),h.set("CreationDate",`D:${(0,n.getModificationDate)()}`),h.set("Rect",o),h.set("F",4),h.set("Border",[0,0,0]),h.set("Rotate",c),l&&h.set("T",(0,r.isAscii)(l)?l:(0,r.stringToUTF16String)(l,!0)),a||i){const e=new s.Dict(t);h.set("AP",e),a?e.set("N",a):e.set("N",i)}return h}static async createNewAppearanceStream(e,t,a){const{rotation:n}=e,{imageRef:i,width:c,height:l}=a.image,h=new s.Dict(t),u=new s.Dict(t);h.set("XObject",u),u.set("Im0",i);const d=`q ${c} 0 0 ${l} 0 0 cm /Im0 Do Q`,f=new s.Dict(t);if(f.set("FormType",1),f.set("Subtype",s.Name.get("Form")),f.set("Type",s.Name.get("XObject")),f.set("BBox",[0,0,c,l]),f.set("Resources",h),n){const e=(0,r.getRotationMatrix)(n,c,l);f.set("Matrix",e)}const g=new o.StringStream(d);return g.dict=f,g}}class G extends C{constructor(e){super(e);const{dict:t,xref:a}=e,r=new d.FileSpec(t.get("FS"),a);this.data.annotationType=n.AnnotationType.FILEATTACHMENT,this.data.hasOwnCanvas=this.data.noRotate,this.data.file=r.serializable;const i=t.get("Name");this.data.name=i instanceof s.Name?(0,n.stringToPDFString)(i.name):"PushPin";const o=t.get("ca");this.data.fillAlpha="number"==typeof o&&o>=0&&o<=1?o:null}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.FakeUnicodeFont=void 0,t.createDefaultAppearance=function({fontSize:e,fontName:t,fontColor:a}){return`/${(0,r.escapePDFName)(t)} ${e} Tf ${f(a,!0)}`},t.getPdfColor=f,t.parseAppearanceStream=function(e,t,a){return new d(e,t,a).parse()},t.parseDefaultAppearance=function(e){return new u(e).parse()};var n=a(4),r=a(3),i=a(2),s=a(12),o=a(13),c=a(59),l=a(57),h=a(8);class u extends o.EvaluatorPreprocessor{constructor(e){super(new h.StringStream(e))}parse(){const e={fn:0,args:[]},t={fontSize:0,fontName:"",fontColor:new Uint8ClampedArray(3)};try{for(;e.args.length=0,this.read(e);){if(0!==this.savedStatesDepth)continue;const{fn:a,args:r}=e;switch(0|a){case i.OPS.setFont:const[e,a]=r;e instanceof n.Name&&(t.fontName=e.name),"number"==typeof a&&a>0&&(t.fontSize=a);break;case i.OPS.setFillRGBColor:s.ColorSpace.singletons.rgb.getRgbItem(r,0,t.fontColor,0);break;case i.OPS.setFillGray:s.ColorSpace.singletons.gray.getRgbItem(r,0,t.fontColor,0);break;case i.OPS.setFillCMYKColor:s.ColorSpace.singletons.cmyk.getRgbItem(r,0,t.fontColor,0)}}}catch(e){(0,i.warn)(`parseDefaultAppearance - ignoring errors: "${e}".`)}return t}}class d extends o.EvaluatorPreprocessor{constructor(e,t,a){super(e),this.stream=e,this.evaluatorOptions=t,this.xref=a,this.resources=e.dict?.get("Resources")}parse(){const e={fn:0,args:[]};let t={scaleFactor:1,fontSize:0,fontName:"",fontColor:new Uint8ClampedArray(3),fillColorSpace:s.ColorSpace.singletons.gray},a=!1;const r=[];try{for(;e.args.length=0,!a&&this.read(e);){const{fn:o,args:c}=e;switch(0|o){case i.OPS.save:r.push({scaleFactor:t.scaleFactor,fontSize:t.fontSize,fontName:t.fontName,fontColor:t.fontColor.slice(),fillColorSpace:t.fillColorSpace});break;case i.OPS.restore:t=r.pop()||t;break;case i.OPS.setTextMatrix:t.scaleFactor*=Math.hypot(c[0],c[1]);break;case i.OPS.setFont:const[e,o]=c;e instanceof n.Name&&(t.fontName=e.name),"number"==typeof o&&o>0&&(t.fontSize=o*t.scaleFactor);break;case i.OPS.setFillColorSpace:t.fillColorSpace=s.ColorSpace.parse({cs:c[0],xref:this.xref,resources:this.resources,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:this._localColorSpaceCache});break;case i.OPS.setFillColor:t.fillColorSpace.getRgbItem(c,0,t.fontColor,0);break;case i.OPS.setFillRGBColor:s.ColorSpace.singletons.rgb.getRgbItem(c,0,t.fontColor,0);break;case i.OPS.setFillGray:s.ColorSpace.singletons.gray.getRgbItem(c,0,t.fontColor,0);break;case i.OPS.setFillCMYKColor:s.ColorSpace.singletons.cmyk.getRgbItem(c,0,t.fontColor,0);break;case i.OPS.showText:case i.OPS.showSpacedText:case i.OPS.nextLineShowText:case i.OPS.nextLineSetSpacingShowText:a=!0}}}catch(e){(0,i.warn)(`parseAppearanceStream - ignoring errors: "${e}".`)}return this.stream.reset(),delete t.scaleFactor,delete t.fillColorSpace,t}get _localColorSpaceCache(){return(0,i.shadow)(this,"_localColorSpaceCache",new c.LocalColorSpaceCache)}get _pdfFunctionFactory(){const e=new l.PDFFunctionFactory({xref:this.xref,isEvalSupported:this.evaluatorOptions.isEvalSupported});return(0,i.shadow)(this,"_pdfFunctionFactory",e)}}function f(e,t){if(e[0]===e[1]&&e[1]===e[2]){const a=e[0]/255;return`${(0,r.numberToString)(a)} ${t?"g":"G"}`}return Array.from(e,(e=>(0,r.numberToString)(e/255))).join(" ")+" "+(t?"rg":"RG")}class g{constructor(e,t){this.xref=e,this.widths=null,this.firstChar=1/0,this.lastChar=-1/0,this.fontFamily=t;const a=new OffscreenCanvas(1,1);this.ctxMeasure=a.getContext("2d"),g._fontNameId||(g._fontNameId=1),this.fontName=n.Name.get(`InvalidPDFjsFont_${t}_${g._fontNameId++}`)}get toUnicodeRef(){if(!g._toUnicodeRef){const e="/CIDInit /ProcSet findresource begin\n12 dict begin\nbegincmap\n/CIDSystemInfo\n<< /Registry (Adobe)\n/Ordering (UCS) /Supplement 0 >> def\n/CMapName /Adobe-Identity-UCS def\n/CMapType 2 def\n1 begincodespacerange\n<0000> <FFFF>\nendcodespacerange\n1 beginbfrange\n<0000> <FFFF> <0000>\nendbfrange\nendcmap CMapName currentdict /CMap defineresource pop end end",t=g.toUnicodeStream=new h.StringStream(e),a=new n.Dict(this.xref);t.dict=a,a.set("Length",e.length),g._toUnicodeRef=this.xref.getNewPersistentRef(t)}return g._toUnicodeRef}get fontDescriptorRef(){if(!g._fontDescriptorRef){const e=new n.Dict(this.xref);e.set("Type",n.Name.get("FontDescriptor")),e.set("FontName",this.fontName),e.set("FontFamily","MyriadPro Regular"),e.set("FontBBox",[0,0,0,0]),e.set("FontStretch",n.Name.get("Normal")),e.set("FontWeight",400),e.set("ItalicAngle",0),g._fontDescriptorRef=this.xref.getNewPersistentRef(e)}return g._fontDescriptorRef}get descendantFontRef(){const e=new n.Dict(this.xref);e.set("BaseFont",this.fontName),e.set("Type",n.Name.get("Font")),e.set("Subtype",n.Name.get("CIDFontType0")),e.set("CIDToGIDMap",n.Name.get("Identity")),e.set("FirstChar",this.firstChar),e.set("LastChar",this.lastChar),e.set("FontDescriptor",this.fontDescriptorRef),e.set("DW",1e3);const t=[],a=[...this.widths.entries()].sort();let r=null,i=null;for(const[e,n]of a)r?e===r+i.length?i.push(n):(t.push(r,i),r=e,i=[n]):(r=e,i=[n]);r&&t.push(r,i),e.set("W",t);const s=new n.Dict(this.xref);return s.set("Ordering","Identity"),s.set("Registry","Adobe"),s.set("Supplement",0),e.set("CIDSystemInfo",s),this.xref.getNewPersistentRef(e)}get baseFontRef(){const e=new n.Dict(this.xref);return e.set("BaseFont",this.fontName),e.set("Type",n.Name.get("Font")),e.set("Subtype",n.Name.get("Type0")),e.set("Encoding",n.Name.get("Identity-H")),e.set("DescendantFonts",[this.descendantFontRef]),e.set("ToUnicode",this.toUnicodeRef),this.xref.getNewPersistentRef(e)}get resources(){const e=new n.Dict(this.xref),t=new n.Dict(this.xref);return t.set(this.fontName.name,this.baseFontRef),e.set("Font",t),e}_createContext(){return this.widths=new Map,this.ctxMeasure.font=`1000px ${this.fontFamily}`,this.ctxMeasure}createFontResources(e){const t=this._createContext();for(const a of e.split(/\r\n?|\n/))for(const e of a.split("")){const a=e.charCodeAt(0);if(this.widths.has(a))continue;const n=t.measureText(e),r=Math.ceil(n.width);this.widths.set(a,r),this.firstChar=Math.min(a,this.firstChar),this.lastChar=Math.max(a,this.lastChar)}return this.resources}createAppearance(e,t,a,s,o,c){const l=this._createContext(),u=[];let d=-1/0;for(const t of e.split(/\r\n?|\n/)){u.push(t);const e=l.measureText(t).width;d=Math.max(d,e);for(const e of t.split("")){const t=e.charCodeAt(0);let a=this.widths.get(t);if(void 0===a){const n=l.measureText(e);a=Math.ceil(n.width),this.widths.set(t,a),this.firstChar=Math.min(t,this.firstChar),this.lastChar=Math.max(t,this.lastChar)}}}d*=s/1e3;const[g,p,m,b]=t;let y=m-g,w=b-p;a%180!=0&&([y,w]=[w,y]);let x=1;d>y&&(x=y/d);let S=1;const A=i.LINE_FACTOR*s,k=i.LINE_DESCENT_FACTOR*s,C=A*u.length;C>w&&(S=w/C);const v=s*Math.min(x,S),F=["q",`0 0 ${(0,r.numberToString)(y)} ${(0,r.numberToString)(w)} re W n`,"BT",`1 0 0 1 0 ${(0,r.numberToString)(w+k)} Tm 0 Tc ${f(o,!0)}`,`/${this.fontName.name} ${(0,r.numberToString)(v)} Tf`],{resources:O}=this;if(1!==(c="number"==typeof c&&c>=0&&c<=1?c:1)){F.push("/R0 gs");const e=new n.Dict(this.xref),t=new n.Dict(this.xref);t.set("ca",c),t.set("CA",c),t.set("Type",n.Name.get("ExtGState")),e.set("R0",t),O.set("ExtGState",e)}const I=(0,r.numberToString)(A);for(const e of u)F.push(`0 -${I} Td <${(0,r.stringToUTF16HexString)(e)}> Tj`);F.push("ET","Q");const T=F.join("\n"),M=new n.Dict(this.xref);if(M.set("Subtype",n.Name.get("Form")),M.set("Type",n.Name.get("XObject")),M.set("BBox",[0,0,y,w]),M.set("Length",T.length),M.set("Resources",O),a){const e=(0,r.getRotationMatrix)(a,y,w);M.set("Matrix",e)}const P=new h.StringStream(T);return P.dict=M,P}}t.FakeUnicodeFont=g},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ColorSpace=void 0;var n=a(2),r=a(4),i=a(5),s=a(3);class o{constructor(e,t){this.constructor===o&&(0,n.unreachable)("Cannot initialize ColorSpace."),this.name=e,this.numComps=t}getRgb(e,t){const a=new Uint8ClampedArray(3);return this.getRgbItem(e,t,a,0),a}getRgbItem(e,t,a,r){(0,n.unreachable)("Should not call ColorSpace.getRgbItem")}getRgbBuffer(e,t,a,r,i,s,o){(0,n.unreachable)("Should not call ColorSpace.getRgbBuffer")}getOutputLength(e,t){(0,n.unreachable)("Should not call ColorSpace.getOutputLength")}isPassthrough(e){return!1}isDefaultDecode(e,t){return o.isDefaultDecode(e,this.numComps)}fillRgb(e,t,a,n,r,i,s,o,c){const l=t*a;let h=null;const u=1<<s,d=a!==r||t!==n;if(this.isPassthrough(s))h=o;else if(1===this.numComps&&l>u&&"DeviceGray"!==this.name&&"DeviceRGB"!==this.name){const t=s<=8?new Uint8Array(u):new Uint16Array(u);for(let e=0;e<u;e++)t[e]=e;const a=new Uint8ClampedArray(3*u);if(this.getRgbBuffer(t,0,u,a,0,s,0),d){h=new Uint8Array(3*l);let e=0;for(let t=0;t<l;++t){const n=3*o[t];h[e++]=a[n],h[e++]=a[n+1],h[e++]=a[n+2]}}else{let t=0;for(let n=0;n<l;++n){const r=3*o[n];e[t++]=a[r],e[t++]=a[r+1],e[t++]=a[r+2],t+=c}}}else d?(h=new Uint8ClampedArray(3*l),this.getRgbBuffer(o,0,l,h,0,s,0)):this.getRgbBuffer(o,0,n*i,e,0,s,c);if(h)if(d)!function(e,t,a,n,r,i,s){s=1!==s?0:s;const o=a/r,c=n/i;let l,h=0;const u=new Uint16Array(r),d=3*a;for(let e=0;e<r;e++)u[e]=3*Math.floor(e*o);for(let a=0;a<i;a++){const n=Math.floor(a*c)*d;for(let a=0;a<r;a++)l=n+u[a],t[h++]=e[l++],t[h++]=e[l++],t[h++]=e[l++],h+=s}}(h,e,t,a,n,r,c);else{let t=0,a=0;for(let r=0,s=n*i;r<s;r++)e[t++]=h[a++],e[t++]=h[a++],e[t++]=h[a++],t+=c}}get usesZeroToOneRange(){return(0,n.shadow)(this,"usesZeroToOneRange",!0)}static _cache(e,t,a,n){if(!a)throw new Error('ColorSpace._cache - expected "localColorSpaceCache" argument.');if(!n)throw new Error('ColorSpace._cache - expected "parsedColorSpace" argument.');let i,s;e instanceof r.Ref&&(s=e,e=t.fetch(e)),e instanceof r.Name&&(i=e.name),(i||s)&&a.set(i,s,n)}static getCached(e,t,a){if(!a)throw new Error('ColorSpace.getCached - expected "localColorSpaceCache" argument.');if(e instanceof r.Ref){const n=a.getByRef(e);if(n)return n;try{e=t.fetch(e)}catch(e){if(e instanceof s.MissingDataException)throw e}}if(e instanceof r.Name){const t=a.getByName(e.name);if(t)return t}return null}static async parseAsync({cs:e,xref:t,resources:a=null,pdfFunctionFactory:n,localColorSpaceCache:r}){const i=this._parse(e,t,a,n);return this._cache(e,t,r,i),i}static parse({cs:e,xref:t,resources:a=null,pdfFunctionFactory:n,localColorSpaceCache:r}){const i=this.getCached(e,t,r);if(i)return i;const s=this._parse(e,t,a,n);return this._cache(e,t,r,s),s}static _parse(e,t,a=null,i){if((e=t.fetchIfRef(e))instanceof r.Name)switch(e.name){case"G":case"DeviceGray":return this.singletons.gray;case"RGB":case"DeviceRGB":return this.singletons.rgb;case"CMYK":case"DeviceCMYK":return this.singletons.cmyk;case"Pattern":return new l(null);default:if(a instanceof r.Dict){const n=a.get("ColorSpace");if(n instanceof r.Dict){const s=n.get(e.name);if(s){if(s instanceof r.Name)return this._parse(s,t,a,i);e=s;break}}}throw new n.FormatError(`Unrecognized ColorSpace: ${e.name}`)}if(Array.isArray(e)){const r=t.fetchIfRef(e[0]).name;let s,o,u,d,f,b;switch(r){case"G":case"DeviceGray":return this.singletons.gray;case"RGB":case"DeviceRGB":return this.singletons.rgb;case"CMYK":case"DeviceCMYK":return this.singletons.cmyk;case"CalGray":return s=t.fetchIfRef(e[1]),d=s.getArray("WhitePoint"),f=s.getArray("BlackPoint"),b=s.get("Gamma"),new g(d,f,b);case"CalRGB":s=t.fetchIfRef(e[1]),d=s.getArray("WhitePoint"),f=s.getArray("BlackPoint"),b=s.getArray("Gamma");const y=s.getArray("Matrix");return new p(d,f,b,y);case"ICCBased":const w=t.fetchIfRef(e[1]).dict;o=w.get("N");const x=w.get("Alternate");if(x){const e=this._parse(x,t,a,i);if(e.numComps===o)return e;(0,n.warn)("ICCBased color space: Ignoring incorrect /Alternate entry.")}if(1===o)return this.singletons.gray;if(3===o)return this.singletons.rgb;if(4===o)return this.singletons.cmyk;break;case"Pattern":return u=e[1]||null,u&&(u=this._parse(u,t,a,i)),new l(u);case"I":case"Indexed":u=this._parse(e[1],t,a,i);const S=t.fetchIfRef(e[2])+1,A=t.fetchIfRef(e[3]);return new h(u,S,A);case"Separation":case"DeviceN":const k=t.fetchIfRef(e[1]);o=Array.isArray(k)?k.length:1,u=this._parse(e[2],t,a,i);const C=i.create(e[3]);return new c(o,u,C);case"Lab":s=t.fetchIfRef(e[1]),d=s.getArray("WhitePoint"),f=s.getArray("BlackPoint");const v=s.getArray("Range");return new m(d,f,v);default:throw new n.FormatError(`Unimplemented ColorSpace object: ${r}`)}}throw new n.FormatError(`Unrecognized ColorSpace object: ${e}`)}static isDefaultDecode(e,t){if(!Array.isArray(e))return!0;if(2*t!==e.length)return(0,n.warn)("The decode map is not the correct length"),!0;for(let t=0,a=e.length;t<a;t+=2)if(0!==e[t]||1!==e[t+1])return!1;return!0}static get singletons(){return(0,n.shadow)(this,"singletons",{get gray(){return(0,n.shadow)(this,"gray",new u)},get rgb(){return(0,n.shadow)(this,"rgb",new d)},get cmyk(){return(0,n.shadow)(this,"cmyk",new f)}})}}t.ColorSpace=o;class c extends o{constructor(e,t,a){super("Alternate",e),this.base=t,this.tintFn=a,this.tmpBuf=new Float32Array(t.numComps)}getRgbItem(e,t,a,n){const r=this.tmpBuf;this.tintFn(e,t,r,0),this.base.getRgbItem(r,0,a,n)}getRgbBuffer(e,t,a,n,r,i,s){const o=this.tintFn,c=this.base,l=1/((1<<i)-1),h=c.numComps,u=c.usesZeroToOneRange,d=(c.isPassthrough(8)||!u)&&0===s;let f=d?r:0;const g=d?n:new Uint8ClampedArray(h*a),p=this.numComps,m=new Float32Array(p),b=new Float32Array(h);let y,w;for(y=0;y<a;y++){for(w=0;w<p;w++)m[w]=e[t++]*l;if(o(m,0,b,0),u)for(w=0;w<h;w++)g[f++]=255*b[w];else c.getRgbItem(b,0,g,f),f+=h}d||c.getRgbBuffer(g,0,a,n,r,8,s)}getOutputLength(e,t){return this.base.getOutputLength(e*this.base.numComps/this.numComps,t)}}class l extends o{constructor(e){super("Pattern",null),this.base=e}isDefaultDecode(e,t){(0,n.unreachable)("Should not call PatternCS.isDefaultDecode")}}class h extends o{constructor(e,t,a){super("Indexed",1),this.base=e,this.highVal=t;const r=e.numComps*t;if(this.lookup=new Uint8Array(r),a instanceof i.BaseStream){const e=a.getBytes(r);this.lookup.set(e)}else{if("string"!=typeof a)throw new n.FormatError(`IndexedCS - unrecognized lookup table: ${a}`);for(let e=0;e<r;++e)this.lookup[e]=255&a.charCodeAt(e)}}getRgbItem(e,t,a,n){const r=this.base.numComps,i=e[t]*r;this.base.getRgbBuffer(this.lookup,i,1,a,n,8,0)}getRgbBuffer(e,t,a,n,r,i,s){const o=this.base,c=o.numComps,l=o.getOutputLength(c,s),h=this.lookup;for(let i=0;i<a;++i){const a=e[t++]*c;o.getRgbBuffer(h,a,1,n,r,8,s),r+=l}}getOutputLength(e,t){return this.base.getOutputLength(e*this.base.numComps,t)}isDefaultDecode(e,t){return!Array.isArray(e)||(2!==e.length?((0,n.warn)("Decode map length is not correct"),!0):!Number.isInteger(t)||t<1?((0,n.warn)("Bits per component is not correct"),!0):0===e[0]&&e[1]===(1<<t)-1)}}class u extends o{constructor(){super("DeviceGray",1)}getRgbItem(e,t,a,n){const r=255*e[t];a[n]=a[n+1]=a[n+2]=r}getRgbBuffer(e,t,a,n,r,i,s){const o=255/((1<<i)-1);let c=t,l=r;for(let t=0;t<a;++t){const t=o*e[c++];n[l++]=t,n[l++]=t,n[l++]=t,l+=s}}getOutputLength(e,t){return e*(3+t)}}class d extends o{constructor(){super("DeviceRGB",3)}getRgbItem(e,t,a,n){a[n]=255*e[t],a[n+1]=255*e[t+1],a[n+2]=255*e[t+2]}getRgbBuffer(e,t,a,n,r,i,s){if(8===i&&0===s)return void n.set(e.subarray(t,t+3*a),r);const o=255/((1<<i)-1);let c=t,l=r;for(let t=0;t<a;++t)n[l++]=o*e[c++],n[l++]=o*e[c++],n[l++]=o*e[c++],l+=s}getOutputLength(e,t){return e*(3+t)/3|0}isPassthrough(e){return 8===e}}class f extends o{constructor(){super("DeviceCMYK",4)}#n(e,t,a,n,r){const i=e[t]*a,s=e[t+1]*a,o=e[t+2]*a,c=e[t+3]*a;n[r]=255+i*(-4.387332384609988*i+54.48615194189176*s+18.82290502165302*o+212.25662451639585*c-285.2331026137004)+s*(1.7149763477362134*s-5.6096736904047315*o+-17.873870861415444*c-5.497006427196366)+o*(-2.5217340131683033*o-21.248923337353073*c+17.5119270841813)+c*(-21.86122147463605*c-189.48180835922747),n[r+1]=255+i*(8.841041422036149*i+60.118027045597366*s+6.871425592049007*o+31.159100130055922*c-79.2970844816548)+s*(-15.310361306967817*s+17.575251261109482*o+131.35250912493976*c-190.9453302588951)+o*(4.444339102852739*o+9.8632861493405*c-24.86741582555878)+c*(-20.737325471181034*c-187.80453709719578),n[r+2]=255+i*(.8842522430003296*i+8.078677503112928*s+30.89978309703729*o-.23883238689178934*c-14.183576799673286)+s*(10.49593273432072*s+63.02378494754052*o+50.606957656360734*c-112.23884253719248)+o*(.03296041114873217*o+115.60384449646641*c-193.58209356861505)+c*(-22.33816807309886*c-180.12613974708367)}getRgbItem(e,t,a,n){this.#n(e,t,1,a,n)}getRgbBuffer(e,t,a,n,r,i,s){const o=1/((1<<i)-1);for(let i=0;i<a;i++)this.#n(e,t,o,n,r),t+=4,r+=3+s}getOutputLength(e,t){return e/4*(3+t)|0}}class g extends o{constructor(e,t,a){if(super("CalGray",1),!e)throw new n.FormatError("WhitePoint missing - required for color space CalGray");if([this.XW,this.YW,this.ZW]=e,[this.XB,this.YB,this.ZB]=t||[0,0,0],this.G=a||1,this.XW<0||this.ZW<0||1!==this.YW)throw new n.FormatError(`Invalid WhitePoint components for ${this.name}, no fallback available`);(this.XB<0||this.YB<0||this.ZB<0)&&((0,n.info)(`Invalid BlackPoint for ${this.name}, falling back to default.`),this.XB=this.YB=this.ZB=0),0===this.XB&&0===this.YB&&0===this.ZB||(0,n.warn)(`${this.name}, BlackPoint: XB: ${this.XB}, YB: ${this.YB}, ZB: ${this.ZB}, only default values are supported.`),this.G<1&&((0,n.info)(`Invalid Gamma: ${this.G} for ${this.name}, falling back to default.`),this.G=1)}#n(e,t,a,n,r){const i=(e[t]*r)**this.G,s=this.YW*i,o=Math.max(295.8*s**.3333333333333333-40.8,0);a[n]=o,a[n+1]=o,a[n+2]=o}getRgbItem(e,t,a,n){this.#n(e,t,a,n,1)}getRgbBuffer(e,t,a,n,r,i,s){const o=1/((1<<i)-1);for(let i=0;i<a;++i)this.#n(e,t,n,r,o),t+=1,r+=3+s}getOutputLength(e,t){return e*(3+t)}}class p extends o{static#r=new Float32Array([.8951,.2664,-.1614,-.7502,1.7135,.0367,.0389,-.0685,1.0296]);static#i=new Float32Array([.9869929,-.1470543,.1599627,.4323053,.5183603,.0492912,-.0085287,.0400428,.9684867]);static#s=new Float32Array([3.2404542,-1.5371385,-.4985314,-.969266,1.8760108,.041556,.0556434,-.2040259,1.0572252]);static#o=new Float32Array([1,1,1]);static#c=new Float32Array(3);static#l=new Float32Array(3);static#h=new Float32Array(3);static#u=(24/116)**3/8;constructor(e,t,a,r){if(super("CalRGB",3),!e)throw new n.FormatError("WhitePoint missing - required for color space CalRGB");const[i,s,o]=this.whitePoint=e,[c,l,h]=this.blackPoint=t||new Float32Array(3);if([this.GR,this.GG,this.GB]=a||new Float32Array([1,1,1]),[this.MXA,this.MYA,this.MZA,this.MXB,this.MYB,this.MZB,this.MXC,this.MYC,this.MZC]=r||new Float32Array([1,0,0,0,1,0,0,0,1]),i<0||o<0||1!==s)throw new n.FormatError(`Invalid WhitePoint components for ${this.name}, no fallback available`);(c<0||l<0||h<0)&&((0,n.info)(`Invalid BlackPoint for ${this.name} [${c}, ${l}, ${h}], falling back to default.`),this.blackPoint=new Float32Array(3)),(this.GR<0||this.GG<0||this.GB<0)&&((0,n.info)(`Invalid Gamma [${this.GR}, ${this.GG}, ${this.GB}] for ${this.name}, falling back to default.`),this.GR=this.GG=this.GB=1)}#d(e,t,a){a[0]=e[0]*t[0]+e[1]*t[1]+e[2]*t[2],a[1]=e[3]*t[0]+e[4]*t[1]+e[5]*t[2],a[2]=e[6]*t[0]+e[7]*t[1]+e[8]*t[2]}#f(e,t,a){a[0]=1*t[0]/e[0],a[1]=1*t[1]/e[1],a[2]=1*t[2]/e[2]}#g(e,t,a){a[0]=.95047*t[0]/e[0],a[1]=1*t[1]/e[1],a[2]=1.08883*t[2]/e[2]}#p(e){return e<=.0031308?this.#m(0,1,12.92*e):e>=.99554525?1:this.#m(0,1,1.055*e**(1/2.4)-.055)}#m(e,t,a){return Math.max(e,Math.min(t,a))}#b(e){return e<0?-this.#b(-e):e>8?((e+16)/116)**3:e*p.#u}#y(e,t,a){if(0===e[0]&&0===e[1]&&0===e[2])return a[0]=t[0],a[1]=t[1],void(a[2]=t[2]);const n=this.#b(0),r=(1-n)/(1-this.#b(e[0])),i=1-r,s=(1-n)/(1-this.#b(e[1])),o=1-s,c=(1-n)/(1-this.#b(e[2])),l=1-c;a[0]=t[0]*r+i,a[1]=t[1]*s+o,a[2]=t[2]*c+l}#w(e,t,a){if(1===e[0]&&1===e[2])return a[0]=t[0],a[1]=t[1],void(a[2]=t[2]);const n=a;this.#d(p.#r,t,n);const r=p.#c;this.#f(e,n,r),this.#d(p.#i,r,a)}#x(e,t,a){const n=a;this.#d(p.#r,t,n);const r=p.#c;this.#g(e,n,r),this.#d(p.#i,r,a)}#n(e,t,a,n,r){const i=this.#m(0,1,e[t]*r),s=this.#m(0,1,e[t+1]*r),o=this.#m(0,1,e[t+2]*r),c=1===i?1:i**this.GR,l=1===s?1:s**this.GG,h=1===o?1:o**this.GB,u=this.MXA*c+this.MXB*l+this.MXC*h,d=this.MYA*c+this.MYB*l+this.MYC*h,f=this.MZA*c+this.MZB*l+this.MZC*h,g=p.#l;g[0]=u,g[1]=d,g[2]=f;const m=p.#h;this.#w(this.whitePoint,g,m);const b=p.#l;this.#y(this.blackPoint,m,b);const y=p.#h;this.#x(p.#o,b,y);const w=p.#l;this.#d(p.#s,y,w),a[n]=255*this.#p(w[0]),a[n+1]=255*this.#p(w[1]),a[n+2]=255*this.#p(w[2])}getRgbItem(e,t,a,n){this.#n(e,t,a,n,1)}getRgbBuffer(e,t,a,n,r,i,s){const o=1/((1<<i)-1);for(let i=0;i<a;++i)this.#n(e,t,n,r,o),t+=3,r+=3+s}getOutputLength(e,t){return e*(3+t)/3|0}}class m extends o{constructor(e,t,a){if(super("Lab",3),!e)throw new n.FormatError("WhitePoint missing - required for color space Lab");if([this.XW,this.YW,this.ZW]=e,[this.amin,this.amax,this.bmin,this.bmax]=a||[-100,100,-100,100],[this.XB,this.YB,this.ZB]=t||[0,0,0],this.XW<0||this.ZW<0||1!==this.YW)throw new n.FormatError("Invalid WhitePoint components, no fallback available");(this.XB<0||this.YB<0||this.ZB<0)&&((0,n.info)("Invalid BlackPoint, falling back to default"),this.XB=this.YB=this.ZB=0),(this.amin>this.amax||this.bmin>this.bmax)&&((0,n.info)("Invalid Range, falling back to defaults"),this.amin=-100,this.amax=100,this.bmin=-100,this.bmax=100)}#S(e){return e>=6/29?e**3:108/841*(e-4/29)}#A(e,t,a,n){return a+e*(n-a)/t}#n(e,t,a,n,r){let i=e[t],s=e[t+1],o=e[t+2];!1!==a&&(i=this.#A(i,a,0,100),s=this.#A(s,a,this.amin,this.amax),o=this.#A(o,a,this.bmin,this.bmax)),s>this.amax?s=this.amax:s<this.amin&&(s=this.amin),o>this.bmax?o=this.bmax:o<this.bmin&&(o=this.bmin);const c=(i+16)/116,l=c+s/500,h=c-o/200,u=this.XW*this.#S(l),d=this.YW*this.#S(c),f=this.ZW*this.#S(h);let g,p,m;this.ZW<1?(g=3.1339*u+-1.617*d+-.4906*f,p=-.9785*u+1.916*d+.0333*f,m=.072*u+-.229*d+1.4057*f):(g=3.2406*u+-1.5372*d+-.4986*f,p=-.9689*u+1.8758*d+.0415*f,m=.0557*u+-.204*d+1.057*f),n[r]=255*Math.sqrt(g),n[r+1]=255*Math.sqrt(p),n[r+2]=255*Math.sqrt(m)}getRgbItem(e,t,a,n){this.#n(e,t,!1,a,n)}getRgbBuffer(e,t,a,n,r,i,s){const o=(1<<i)-1;for(let i=0;i<a;i++)this.#n(e,t,o,n,r),t+=3,r+=3+s}getOutputLength(e,t){return e*(3+t)/3|0}isDefaultDecode(e,t){return!0}get usesZeroToOneRange(){return(0,n.shadow)(this,"usesZeroToOneRange",!1)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PartialEvaluator=t.EvaluatorPreprocessor=void 0;var n=a(2),r=a(14),i=a(4),s=a(34),o=a(37),c=a(41),l=a(50),h=a(51),u=a(42),d=a(57),f=a(16),g=a(59),p=a(8),m=a(5),b=a(60),y=a(12),w=a(18),x=a(38),S=a(61),A=a(39),k=a(45),C=a(40),v=a(62),F=a(63),O=a(64),I=a(65);const T=Object.freeze({maxImageSize:-1,disableFontFace:!1,ignoreErrors:!1,isEvalSupported:!0,isOffscreenCanvasSupported:!1,canvasMaxAreaInBytes:-1,fontExtraProperties:!1,useSystemFonts:!0,cMapUrl:null,standardFontDataUrl:null}),M=1,P=2,N=Promise.resolve();function D(e,t=!1){if(Array.isArray(e)){for(const t of e){const e=D(t,!0);if(e)return e}return(0,n.warn)(`Unsupported blend mode Array: ${e}`),"source-over"}if(!(e instanceof i.Name))return t?null:"source-over";switch(e.name){case"Normal":case"Compatible":return"source-over";case"Multiply":return"multiply";case"Screen":return"screen";case"Overlay":return"overlay";case"Darken":return"darken";case"Lighten":return"lighten";case"ColorDodge":return"color-dodge";case"ColorBurn":return"color-burn";case"HardLight":return"hard-light";case"SoftLight":return"soft-light";case"Difference":return"difference";case"Exclusion":return"exclusion";case"Hue":return"hue";case"Saturation":return"saturation";case"Color":return"color";case"Luminosity":return"luminosity"}return t?null:((0,n.warn)(`Unsupported blend mode: ${e.name}`),"source-over")}function R(e){e.fn===n.OPS.paintImageMaskXObject&&e.args[0]?.count>0&&e.args[0].count++}class E{static TIME_SLOT_DURATION_MS=20;static CHECK_TIME_EVERY=100;constructor(){this.reset()}check(){return!(++this.checked<E.CHECK_TIME_EVERY)&&(this.checked=0,this.endTime<=Date.now())}reset(){this.endTime=Date.now()+E.TIME_SLOT_DURATION_MS,this.checked=0}}class B{constructor({xref:e,handler:t,pageIndex:a,idFactory:n,fontCache:r,builtInCMapCache:i,standardFontDataCache:s,globalImageCache:o,systemFontCache:c,options:l=null}){this.xref=e,this.handler=t,this.pageIndex=a,this.idFactory=n,this.fontCache=r,this.builtInCMapCache=i,this.standardFontDataCache=s,this.globalImageCache=o,this.systemFontCache=c,this.options=l||T,this.parsingType3Font=!1,this._regionalImageCache=new g.RegionalImageCache,this._fetchBuiltInCMapBound=this.fetchBuiltInCMap.bind(this),v.ImageResizer.setMaxArea(this.options.canvasMaxAreaInBytes)}get _pdfFunctionFactory(){const e=new d.PDFFunctionFactory({xref:this.xref,isEvalSupported:this.options.isEvalSupported});return(0,n.shadow)(this,"_pdfFunctionFactory",e)}clone(e=null){const t=Object.create(this);return t.options=Object.assign(Object.create(null),this.options,e),t}hasBlendModes(e,t){if(!(e instanceof i.Dict))return!1;if(e.objId&&t.has(e.objId))return!1;const a=new i.RefSet(t);e.objId&&a.put(e.objId);const r=[e],s=this.xref;for(;r.length;){const e=r.shift(),t=e.get("ExtGState");if(t instanceof i.Dict)for(let e of t.getRawValues()){if(e instanceof i.Ref){if(a.has(e))continue;try{e=s.fetch(e)}catch(t){a.put(e),(0,n.info)(`hasBlendModes - ignoring ExtGState: "${t}".`);continue}}if(!(e instanceof i.Dict))continue;e.objId&&a.put(e.objId);const t=e.get("BM");if(t instanceof i.Name){if("Normal"!==t.name)return!0}else if(void 0!==t&&Array.isArray(t))for(const e of t)if(e instanceof i.Name&&"Normal"!==e.name)return!0}const o=e.get("XObject");if(o instanceof i.Dict)for(let e of o.getRawValues()){if(e instanceof i.Ref){if(a.has(e))continue;try{e=s.fetch(e)}catch(t){a.put(e),(0,n.info)(`hasBlendModes - ignoring XObject: "${t}".`);continue}}if(!(e instanceof m.BaseStream))continue;e.dict.objId&&a.put(e.dict.objId);const t=e.dict.get("Resources");t instanceof i.Dict&&(t.objId&&a.has(t.objId)||(r.push(t),t.objId&&a.put(t.objId)))}}for(const e of a)t.put(e);return!1}async fetchBuiltInCMap(e){const t=this.builtInCMapCache.get(e);if(t)return t;let a;if(null!==this.options.cMapUrl){const t=`${this.options.cMapUrl}${e}.bcmap`,r=await fetch(t);if(!r.ok)throw new Error(`fetchBuiltInCMap: failed to fetch file "${t}" with "${r.statusText}".`);a={cMapData:new Uint8Array(await r.arrayBuffer()),compressionType:n.CMapCompressionType.BINARY}}else a=await this.handler.sendWithPromise("FetchBuiltInCMap",{name:e});return a.compressionType!==n.CMapCompressionType.NONE&&this.builtInCMapCache.set(e,a),a}async fetchStandardFontData(e){const t=this.standardFontDataCache.get(e);if(t)return new p.Stream(t);if(this.options.useSystemFonts&&"Symbol"!==e&&"ZapfDingbats"!==e)return null;const a=(0,c.getFontNameToFileMap)()[e];let r;if(null!==this.options.standardFontDataUrl){const e=`${this.options.standardFontDataUrl}${a}`,t=await fetch(e);t.ok?r=await t.arrayBuffer():(0,n.warn)(`fetchStandardFontData: failed to fetch file "${e}" with "${t.statusText}".`)}else try{r=await this.handler.sendWithPromise("FetchStandardFontData",{filename:a})}catch(e){(0,n.warn)(`fetchStandardFontData: failed to fetch file "${a}" with "${e}".`)}return r?(this.standardFontDataCache.set(e,r),new p.Stream(r)):null}async buildFormXObject(e,t,a,r,s,o,c){const l=t.dict,h=l.getArray("Matrix");let u,d,f=l.getArray("BBox");f=Array.isArray(f)&&4===f.length?n.Util.normalizeRect(f):null,l.has("OC")&&(u=await this.parseMarkedContentProps(l.get("OC"),e)),void 0!==u&&r.addOp(n.OPS.beginMarkedContentProps,["OC",u]);const g=l.get("Group");if(g){d={matrix:h,bbox:f,smask:a,isolated:!1,knockout:!1};const t=g.get("S");let s=null;if((0,i.isName)(t,"Transparency")&&(d.isolated=g.get("I")||!1,d.knockout=g.get("K")||!1,g.has("CS"))){const t=g.getRaw("CS"),a=y.ColorSpace.getCached(t,this.xref,c);s=a||await this.parseColorSpace({cs:t,resources:e,localColorSpaceCache:c})}a?.backdrop&&(s||=y.ColorSpace.singletons.rgb,a.backdrop=s.getRgb(a.backdrop,0)),r.addOp(n.OPS.beginGroup,[d])}const p=g?[h,null]:[h,f];return r.addOp(n.OPS.paintFormXObjectBegin,p),this.getOperatorList({stream:t,task:s,resources:l.get("Resources")||e,operatorList:r,initialState:o}).then((function(){r.addOp(n.OPS.paintFormXObjectEnd,[]),g&&r.addOp(n.OPS.endGroup,[d]),void 0!==u&&r.addOp(n.OPS.endMarkedContent,[])}))}_sendImgData(e,t,a=!1){const n=t?[t.bitmap||t.data.buffer]:null;return this.parsingType3Font||a?this.handler.send("commonobj",[e,"Image",t],n):this.handler.send("obj",[e,this.pageIndex,"Image",t],n)}async buildPaintImageXObject({resources:e,image:t,isInline:a=!1,operatorList:r,cacheKey:i,localImageCache:s,localColorSpaceCache:o}){const c=t.dict,l=c.objId,h=c.get("W","Width"),u=c.get("H","Height");if(!h||"number"!=typeof h||!u||"number"!=typeof u)return void(0,n.warn)("Image dimensions are missing, or not numbers.");const d=this.options.maxImageSize;if(-1!==d&&h*u>d){const e="Image exceeded maximum allowed size and was removed.";if(this.options.ignoreErrors)return void(0,n.warn)(e);throw new Error(e)}let f;c.has("OC")&&(f=await this.parseMarkedContentProps(c.get("OC"),e));let g,p;if(c.get("IM","ImageMask")||!1){const e=c.get("I","Interpolate"),a=h+7>>3,o=t.getBytes(a*u),d=c.getArray("D","Decode");if(this.parsingType3Font){if(g=I.PDFImage.createRawMask({imgArray:o,width:h,height:u,imageIsFromDecodeStream:t instanceof w.DecodeStream,inverseDecode:d?.[0]>0,interpolate:e}),g.cached=!!i,p=[g],r.addImageOps(n.OPS.paintImageMaskXObject,p,f),i){const e={fn:n.OPS.paintImageMaskXObject,args:p,optionalContent:f};s.set(i,l,e),l&&this._regionalImageCache.set(null,l,e)}return}if(g=await I.PDFImage.createMask({imgArray:o,width:h,height:u,imageIsFromDecodeStream:t instanceof w.DecodeStream,inverseDecode:d?.[0]>0,interpolate:e,isOffscreenCanvasSupported:this.options.isOffscreenCanvasSupported}),g.isSingleOpaquePixel){if(r.addImageOps(n.OPS.paintSolidColorImageMask,[],f),i){const e={fn:n.OPS.paintSolidColorImageMask,args:[],optionalContent:f};s.set(i,l,e),l&&this._regionalImageCache.set(null,l,e)}return}const m=`mask_${this.idFactory.createObjId()}`;if(r.addDependency(m),this._sendImgData(m,g),p=[{data:m,width:g.width,height:g.height,interpolate:g.interpolate,count:1}],r.addImageOps(n.OPS.paintImageMaskXObject,p,f),i){const e={fn:n.OPS.paintImageMaskXObject,args:p,optionalContent:f};s.set(i,l,e),l&&this._regionalImageCache.set(null,l,e)}return}if(a&&!c.has("SMask")&&!c.has("Mask")&&h+u<200){const i=new I.PDFImage({xref:this.xref,res:e,image:t,isInline:a,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:o});return g=await i.createImageData(!0,!1),r.isOffscreenCanvasSupported=this.options.isOffscreenCanvasSupported,void r.addImageOps(n.OPS.paintInlineImageXObject,[g],f)}let m=`img_${this.idFactory.createObjId()}`,b=!1;if(this.parsingType3Font?m=`${this.idFactory.getDocId()}_type3_${m}`:l&&(b=this.globalImageCache.shouldCache(l,this.pageIndex),b&&(m=`${this.idFactory.getDocId()}_${m}`)),r.addDependency(m),p=[m,h,u],I.PDFImage.buildImage({xref:this.xref,res:e,image:t,isInline:a,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:o}).then((async e=>{if(g=await e.createImageData(!1,this.options.isOffscreenCanvasSupported),i&&l&&b){const e=g.bitmap?g.width*g.height*4:g.data.length;this.globalImageCache.addByteSize(l,e)}return this._sendImgData(m,g,b)})).catch((e=>((0,n.warn)(`Unable to decode image "${m}": "${e}".`),this._sendImgData(m,null,b)))),r.addImageOps(n.OPS.paintImageXObject,p,f),i){const e={fn:n.OPS.paintImageXObject,args:p,optionalContent:f};s.set(i,l,e),l&&(this._regionalImageCache.set(null,l,e),b&&((0,n.assert)(!a,"Cannot cache an inline image globally."),this.globalImageCache.setData(l,{objId:m,fn:n.OPS.paintImageXObject,args:p,optionalContent:f,byteSize:0})))}}handleSMask(e,t,a,n,r,i){const s=e.get("G"),o={subtype:e.get("S").name,backdrop:e.get("BC")},c=e.get("TR");if((0,d.isPDFFunction)(c)){const e=this._pdfFunctionFactory.create(c),t=new Uint8Array(256),a=new Float32Array(1);for(let n=0;n<256;n++)a[0]=n/255,e(a,0,a,0),t[n]=255*a[0]|0;o.transferMap=t}return this.buildFormXObject(t,s,o,a,n,r.state.clone(),i)}handleTransferFunction(e){let t;if(Array.isArray(e))t=e;else{if(!(0,d.isPDFFunction)(e))return null;t=[e]}const a=[];let n=0,r=0;for(const e of t){const t=this.xref.fetchIfRef(e);if(n++,(0,i.isName)(t,"Identity")){a.push(null);continue}if(!(0,d.isPDFFunction)(t))return null;const s=this._pdfFunctionFactory.create(t),o=new Uint8Array(256),c=new Float32Array(1);for(let e=0;e<256;e++)c[0]=e/255,s(c,0,c,0),o[e]=255*c[0]|0;a.push(o),r++}return 1!==n&&4!==n||0===r?null:a}handleTilingType(e,t,a,r,s,o,c,h){const u=new O.OperatorList,d=i.Dict.merge({xref:this.xref,dictArray:[s.get("Resources"),a]});return this.getOperatorList({stream:r,task:c,resources:d,operatorList:u}).then((function(){const a=u.getIR(),n=(0,l.getTilingPatternIR)(a,s,t);o.addDependencies(u.dependencies),o.addOp(e,n),s.objId&&h.set(null,s.objId,{operatorListIR:a,dict:s})})).catch((e=>{if(!(e instanceof n.AbortException)){if(!this.options.ignoreErrors)throw e;(0,n.warn)(`handleTilingType - ignoring pattern: "${e}".`)}}))}handleSetFont(e,t,a,n,r,o,c=null,l=null){const h=t?.[0]instanceof i.Name?t[0].name:null;return this.loadFont(h,a,e,c,l).then((t=>t.font.isType3Font?t.loadType3Data(this,e,r).then((function(){return n.addDependencies(t.type3Dependencies),t})).catch((e=>new $({loadedName:"g_font_error",font:new s.ErrorFont(`Type3 font load error: ${e}`),dict:t.font,evaluatorOptions:this.options}))):t)).then((e=>(o.font=e.font,e.send(this.handler),e.loadedName)))}handleText(e,t){const a=t.font,r=a.charsToGlyphs(e);if(a.data){(!!(t.textRenderingMode&n.TextRenderingMode.ADD_TO_PATH_FLAG)||"Pattern"===t.fillColorSpace.name||a.disableFontFace||this.options.disableFontFace)&&B.buildFontPaths(a,r,this.handler,this.options)}return r}ensureStateFont(e){if(e.font)return;const t=new n.FormatError("Missing setFont (Tf) operator before text rendering operator.");if(!this.options.ignoreErrors)throw t;(0,n.warn)(`ensureStateFont: "${t}".`)}async setGState({resources:e,gState:t,operatorList:a,cacheKey:r,task:s,stateManager:o,localGStateCache:c,localColorSpaceCache:l}){const h=t.objId;let u=!0;const d=[];let f=Promise.resolve();for(const r of t.getKeys()){const c=t.get(r);switch(r){case"Type":break;case"LW":case"LC":case"LJ":case"ML":case"D":case"RI":case"FL":case"CA":case"ca":d.push([r,c]);break;case"Font":u=!1,f=f.then((()=>this.handleSetFont(e,null,c[0],a,s,o.state).then((function(e){a.addDependency(e),d.push([r,[e,c[1]]])}))));break;case"BM":d.push([r,D(c)]);break;case"SMask":if((0,i.isName)(c,"None")){d.push([r,!1]);break}c instanceof i.Dict?(u=!1,f=f.then((()=>this.handleSMask(c,e,a,s,o,l))),d.push([r,!0])):(0,n.warn)("Unsupported SMask type");break;case"TR":const t=this.handleTransferFunction(c);d.push([r,t]);break;case"OP":case"op":case"OPM":case"BG":case"BG2":case"UCR":case"UCR2":case"TR2":case"HT":case"SM":case"SA":case"AIS":case"TK":(0,n.info)("graphic state operator "+r);break;default:(0,n.info)("Unknown graphic state operator "+r)}}return f.then((function(){d.length>0&&a.addOp(n.OPS.setGState,[d]),u&&c.set(r,h,d)}))}loadFont(e,t,a,r=null,o=null){const c=async()=>new $({loadedName:"g_font_error",font:new s.ErrorFont(`Font "${e}" is not available.`),dict:t,evaluatorOptions:this.options});let l;if(t)t instanceof i.Ref&&(l=t);else{const t=a.get("Font");t&&(l=t.getRaw(e))}if(l){if(this.parsingType3Font&&this.type3FontRefs.has(l))return c();if(this.fontCache.has(l))return this.fontCache.get(l);t=this.xref.fetchIfRef(l)}if(!(t instanceof i.Dict)){if(!this.options.ignoreErrors&&!this.parsingType3Font)return(0,n.warn)(`Font "${e}" is not available.`),c();(0,n.warn)(`Font "${e}" is not available -- attempting to fallback to a default font.`),t=r||B.fallbackFontDict}if(t.cacheKey&&this.fontCache.has(t.cacheKey))return this.fontCache.get(t.cacheKey);const h=new n.PromiseCapability;let u;try{u=this.preEvaluateFont(t),u.cssFontInfo=o}catch(e){return(0,n.warn)(`loadFont - preEvaluateFont failed: "${e}".`),c()}const{descriptor:d,hash:f}=u,g=l instanceof i.Ref;let p;if(f&&d instanceof i.Dict){const e=d.fontAliases||=Object.create(null);if(e[f]){const t=e[f].aliasRef;if(g&&t&&this.fontCache.has(t))return this.fontCache.putAlias(l,t),this.fontCache.get(l)}else e[f]={fontID:this.idFactory.createFontId()};g&&(e[f].aliasRef=l),p=e[f].fontID}else p=this.idFactory.createFontId();return(0,n.assert)(p?.startsWith("f"),'The "fontID" must be (correctly) defined.'),g?this.fontCache.put(l,h.promise):(t.cacheKey=`cacheKey_${p}`,this.fontCache.put(t.cacheKey,h.promise)),t.loadedName=`${this.idFactory.getDocId()}_${p}`,this.translateFont(u).then((e=>{h.resolve(new $({loadedName:t.loadedName,font:e,dict:t,evaluatorOptions:this.options}))})).catch((e=>{(0,n.warn)(`loadFont - translateFont failed: "${e}".`),h.resolve(new $({loadedName:t.loadedName,font:new s.ErrorFont(e instanceof Error?e.message:e),dict:t,evaluatorOptions:this.options}))})),h.promise}buildPath(e,t,a,r=!1){const i=e.length-1;if(a||(a=[]),i<0||e.fnArray[i]!==n.OPS.constructPath){let i;switch(r&&((0,n.warn)(`Encountered path operator "${t}" inside of a text object.`),e.addOp(n.OPS.save,null)),t){case n.OPS.rectangle:const e=a[0]+a[2],t=a[1]+a[3];i=[Math.min(a[0],e),Math.max(a[0],e),Math.min(a[1],t),Math.max(a[1],t)];break;case n.OPS.moveTo:case n.OPS.lineTo:i=[a[0],a[0],a[1],a[1]];break;default:i=[1/0,-1/0,1/0,-1/0]}e.addOp(n.OPS.constructPath,[[t],a,i]),r&&e.addOp(n.OPS.restore,null)}else{const r=e.argsArray[i];r[0].push(t),r[1].push(...a);const s=r[2];switch(t){case n.OPS.rectangle:const e=a[0]+a[2],t=a[1]+a[3];s[0]=Math.min(s[0],a[0],e),s[1]=Math.max(s[1],a[0],e),s[2]=Math.min(s[2],a[1],t),s[3]=Math.max(s[3],a[1],t);break;case n.OPS.moveTo:case n.OPS.lineTo:s[0]=Math.min(s[0],a[0]),s[1]=Math.max(s[1],a[0]),s[2]=Math.min(s[2],a[1]),s[3]=Math.max(s[3],a[1])}}}parseColorSpace({cs:e,resources:t,localColorSpaceCache:a}){return y.ColorSpace.parseAsync({cs:e,xref:this.xref,resources:t,pdfFunctionFactory:this._pdfFunctionFactory,localColorSpaceCache:a}).catch((e=>{if(e instanceof n.AbortException)return null;if(this.options.ignoreErrors)return(0,n.warn)(`parseColorSpace - ignoring ColorSpace: "${e}".`),null;throw e}))}parseShading({shading:e,resources:t,localColorSpaceCache:a,localShadingPatternCache:n}){let r=n.get(e);if(!r){const i=l.Pattern.parseShading(e,this.xref,t,this._pdfFunctionFactory,a).getIR();r=`pattern_${this.idFactory.createObjId()}`,this.parsingType3Font&&(r=`${this.idFactory.getDocId()}_type3_${r}`),n.set(e,r),this.parsingType3Font?this.handler.send("commonobj",[r,"Pattern",i]):this.handler.send("obj",[r,this.pageIndex,"Pattern",i])}return r}handleColorN(e,t,a,r,s,o,c,h,u,d){const f=a.pop();if(f instanceof i.Name){const g=s.getRaw(f.name),p=g instanceof i.Ref&&u.getByRef(g);if(p)try{const n=r.base?r.base.getRgb(a,0):null,i=(0,l.getTilingPatternIR)(p.operatorListIR,p.dict,n);return void e.addOp(t,i)}catch{}const b=this.xref.fetchIfRef(g);if(b){const i=b instanceof m.BaseStream?b.dict:b,s=i.get("PatternType");if(s===M){const n=r.base?r.base.getRgb(a,0):null;return this.handleTilingType(t,n,o,b,i,e,c,u)}if(s===P){const a=i.get("Shading"),n=i.getArray("Matrix"),r=this.parseShading({shading:a,resources:o,localColorSpaceCache:h,localShadingPatternCache:d});return void e.addOp(t,["Shading",r,n])}throw new n.FormatError(`Unknown PatternType: ${s}`)}}throw new n.FormatError(`Unknown PatternName: ${f}`)}_parseVisibilityExpression(e,t,a){if(++t>10)return void(0,n.warn)("Visibility expression is too deeply nested");const r=e.length,s=this.xref.fetchIfRef(e[0]);if(!(r<2)&&s instanceof i.Name){switch(s.name){case"And":case"Or":case"Not":a.push(s.name);break;default:return void(0,n.warn)(`Invalid operator ${s.name} in visibility expression`)}for(let n=1;n<r;n++){const r=e[n],s=this.xref.fetchIfRef(r);if(Array.isArray(s)){const e=[];a.push(e),this._parseVisibilityExpression(s,t,e)}else r instanceof i.Ref&&a.push(r.toString())}}else(0,n.warn)("Invalid visibility expression")}async parseMarkedContentProps(e,t){let a;if(e instanceof i.Name){a=t.get("Properties").get(e.name)}else{if(!(e instanceof i.Dict))throw new n.FormatError("Optional content properties malformed.");a=e}const r=a.get("Type")?.name;if("OCG"===r)return{type:r,id:a.objId};if("OCMD"===r){const e=a.get("VE");if(Array.isArray(e)){const t=[];if(this._parseVisibilityExpression(e,0,t),t.length>0)return{type:"OCMD",expression:t}}const t=a.get("OCGs");if(Array.isArray(t)||t instanceof i.Dict){const e=[];if(Array.isArray(t))for(const a of t)e.push(a.toString());else e.push(t.objId);return{type:r,ids:e,policy:a.get("P")instanceof i.Name?a.get("P").name:null,expression:null}}if(t instanceof i.Ref)return{type:r,id:t.toString()}}return null}getOperatorList({stream:e,task:t,resources:a,operatorList:r,initialState:s=null,fallbackFontDict:o=null}){if(a||=i.Dict.empty,s||=new j,!r)throw new Error('getOperatorList: missing "operatorList" parameter');const c=this,l=this.xref;let h=!1;const u=new g.LocalImageCache,d=new g.LocalColorSpaceCache,f=new g.LocalGStateCache,p=new g.LocalTilingPatternCache,b=new Map,w=a.get("XObject")||i.Dict.empty,x=a.get("Pattern")||i.Dict.empty,S=new L(s),A=new U(e,l,S),k=new E;function C(e){for(let e=0,t=A.savedStatesDepth;e<t;e++)r.addOp(n.OPS.restore,[])}return new Promise((function e(s,g){const v=function(t){Promise.all([t,r.ready]).then((function(){try{e(s,g)}catch(e){g(e)}}),g)};t.ensureNotTerminated(),k.reset();const F={};let O,I,T,M,P,D;for(;!(O=k.check())&&(F.args=null,A.read(F));){let e=F.args,s=F.fn;switch(0|s){case n.OPS.paintXObject:if(D=e[0]instanceof i.Name,P=e[0].name,D){const t=u.getByName(P);if(t){r.addImageOps(t.fn,t.args,t.optionalContent),R(t),e=null;continue}}return void v(new Promise((function(e,s){if(!D)throw new n.FormatError("XObject must be referred to by name.");let o=w.getRaw(P);if(o instanceof i.Ref){const t=u.getByRef(o)||c._regionalImageCache.getByRef(o);if(t)return r.addImageOps(t.fn,t.args,t.optionalContent),R(t),void e();const a=c.globalImageCache.getData(o,c.pageIndex);if(a)return r.addDependency(a.objId),r.addImageOps(a.fn,a.args,a.optionalContent),void e();o=l.fetch(o)}if(!(o instanceof m.BaseStream))throw new n.FormatError("XObject should be a stream");const h=o.dict.get("Subtype");if(!(h instanceof i.Name))throw new n.FormatError("XObject should have a Name subtype");if("Form"===h.name)return S.save(),void c.buildFormXObject(a,o,null,r,t,S.state.clone(),d).then((function(){S.restore(),e()}),s);if("Image"!==h.name){if("PS"!==h.name)throw new n.FormatError(`Unhandled XObject subtype ${h.name}`);(0,n.info)("Ignored XObject subtype PS"),e()}else c.buildPaintImageXObject({resources:a,image:o,operatorList:r,cacheKey:P,localImageCache:u,localColorSpaceCache:d}).then(e,s)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!c.options.ignoreErrors)throw e;(0,n.warn)(`getOperatorList - ignoring XObject: "${e}".`)}})));case n.OPS.setFont:var E=e[1];return void v(c.handleSetFont(a,e,null,r,t,S.state,o).then((function(e){r.addDependency(e),r.addOp(n.OPS.setFont,[e,E])})));case n.OPS.beginText:h=!0;break;case n.OPS.endText:h=!1;break;case n.OPS.endInlineImage:var B=e[0].cacheKey;if(B){const t=u.getByName(B);if(t){r.addImageOps(t.fn,t.args,t.optionalContent),R(t),e=null;continue}}return void v(c.buildPaintImageXObject({resources:a,image:e[0],isInline:!0,operatorList:r,cacheKey:B,localImageCache:u,localColorSpaceCache:d}));case n.OPS.showText:if(!S.state.font){c.ensureStateFont(S.state);continue}e[0]=c.handleText(e[0],S.state);break;case n.OPS.showSpacedText:if(!S.state.font){c.ensureStateFont(S.state);continue}var $=[],L=S.state;for(const t of e[0])"string"==typeof t?$.push(...c.handleText(t,L)):"number"==typeof t&&$.push(t);e[0]=$,s=n.OPS.showText;break;case n.OPS.nextLineShowText:if(!S.state.font){c.ensureStateFont(S.state);continue}r.addOp(n.OPS.nextLine),e[0]=c.handleText(e[0],S.state),s=n.OPS.showText;break;case n.OPS.nextLineSetSpacingShowText:if(!S.state.font){c.ensureStateFont(S.state);continue}r.addOp(n.OPS.nextLine),r.addOp(n.OPS.setWordSpacing,[e.shift()]),r.addOp(n.OPS.setCharSpacing,[e.shift()]),e[0]=c.handleText(e[0],S.state),s=n.OPS.showText;break;case n.OPS.setTextRenderingMode:S.state.textRenderingMode=e[0];break;case n.OPS.setFillColorSpace:{const t=y.ColorSpace.getCached(e[0],l,d);if(t){S.state.fillColorSpace=t;continue}return void v(c.parseColorSpace({cs:e[0],resources:a,localColorSpaceCache:d}).then((function(e){e&&(S.state.fillColorSpace=e)})))}case n.OPS.setStrokeColorSpace:{const t=y.ColorSpace.getCached(e[0],l,d);if(t){S.state.strokeColorSpace=t;continue}return void v(c.parseColorSpace({cs:e[0],resources:a,localColorSpaceCache:d}).then((function(e){e&&(S.state.strokeColorSpace=e)})))}case n.OPS.setFillColor:M=S.state.fillColorSpace,e=M.getRgb(e,0),s=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeColor:M=S.state.strokeColorSpace,e=M.getRgb(e,0),s=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillGray:S.state.fillColorSpace=y.ColorSpace.singletons.gray,e=y.ColorSpace.singletons.gray.getRgb(e,0),s=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeGray:S.state.strokeColorSpace=y.ColorSpace.singletons.gray,e=y.ColorSpace.singletons.gray.getRgb(e,0),s=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillCMYKColor:S.state.fillColorSpace=y.ColorSpace.singletons.cmyk,e=y.ColorSpace.singletons.cmyk.getRgb(e,0),s=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeCMYKColor:S.state.strokeColorSpace=y.ColorSpace.singletons.cmyk,e=y.ColorSpace.singletons.cmyk.getRgb(e,0),s=n.OPS.setStrokeRGBColor;break;case n.OPS.setFillRGBColor:S.state.fillColorSpace=y.ColorSpace.singletons.rgb,e=y.ColorSpace.singletons.rgb.getRgb(e,0);break;case n.OPS.setStrokeRGBColor:S.state.strokeColorSpace=y.ColorSpace.singletons.rgb,e=y.ColorSpace.singletons.rgb.getRgb(e,0);break;case n.OPS.setFillColorN:if(M=S.state.fillColorSpace,"Pattern"===M.name)return void v(c.handleColorN(r,n.OPS.setFillColorN,e,M,x,a,t,d,p,b));e=M.getRgb(e,0),s=n.OPS.setFillRGBColor;break;case n.OPS.setStrokeColorN:if(M=S.state.strokeColorSpace,"Pattern"===M.name)return void v(c.handleColorN(r,n.OPS.setStrokeColorN,e,M,x,a,t,d,p,b));e=M.getRgb(e,0),s=n.OPS.setStrokeRGBColor;break;case n.OPS.shadingFill:var _=a.get("Shading");if(!_)throw new n.FormatError("No shading resource found");var j=_.get(e[0].name);if(!j)throw new n.FormatError("No shading object found");e=[c.parseShading({shading:j,resources:a,localColorSpaceCache:d,localShadingPatternCache:b})],s=n.OPS.shadingFill;break;case n.OPS.setGState:if(D=e[0]instanceof i.Name,P=e[0].name,D){const t=f.getByName(P);if(t){t.length>0&&r.addOp(n.OPS.setGState,[t]),e=null;continue}}return void v(new Promise((function(e,s){if(!D)throw new n.FormatError("GState must be referred to by name.");const o=a.get("ExtGState");if(!(o instanceof i.Dict))throw new n.FormatError("ExtGState should be a dictionary.");const l=o.get(P);if(!(l instanceof i.Dict))throw new n.FormatError("GState should be a dictionary.");c.setGState({resources:a,gState:l,operatorList:r,cacheKey:P,task:t,stateManager:S,localGStateCache:f,localColorSpaceCache:d}).then(e,s)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!c.options.ignoreErrors)throw e;(0,n.warn)(`getOperatorList - ignoring ExtGState: "${e}".`)}})));case n.OPS.moveTo:case n.OPS.lineTo:case n.OPS.curveTo:case n.OPS.curveTo2:case n.OPS.curveTo3:case n.OPS.closePath:case n.OPS.rectangle:c.buildPath(r,s,e,h);continue;case n.OPS.markPoint:case n.OPS.markPointProps:case n.OPS.beginCompat:case n.OPS.endCompat:continue;case n.OPS.beginMarkedContentProps:if(!(e[0]instanceof i.Name)){(0,n.warn)(`Expected name for beginMarkedContentProps arg0=${e[0]}`);continue}if("OC"===e[0].name)return void v(c.parseMarkedContentProps(e[1],a).then((e=>{r.addOp(n.OPS.beginMarkedContentProps,["OC",e])})).catch((e=>{if(!(e instanceof n.AbortException)){if(!c.options.ignoreErrors)throw e;(0,n.warn)(`getOperatorList - ignoring beginMarkedContentProps: "${e}".`)}})));e=[e[0].name,e[1]instanceof i.Dict?e[1].get("MCID"):null];break;case n.OPS.beginMarkedContent:case n.OPS.endMarkedContent:default:if(null!==e){for(I=0,T=e.length;I<T&&!(e[I]instanceof i.Dict);I++);if(I<T){(0,n.warn)("getOperatorList - ignoring operator: "+s);continue}}}r.addOp(s,e)}O?v(N):(C(),s())})).catch((e=>{if(!(e instanceof n.AbortException)){if(this.options.ignoreErrors)return(0,n.warn)(`getOperatorList - ignoring errors during "${t.name}" task: "${e}".`),void C();throw e}}))}getTextContent({stream:e,task:t,resources:a,stateManager:r=null,includeMarkedContent:s=!1,sink:o,seenStyles:c=new Set,viewBox:l,markedContentData:h=null,disableNormalization:u=!1}){a||=i.Dict.empty,r||=new L(new _),s&&(h||={level:0});const d={items:[],styles:Object.create(null)},f={initialized:!1,str:[],totalWidth:0,totalHeight:0,width:0,height:0,vertical:!1,prevTransform:null,textAdvanceScale:0,spaceInFlowMin:0,spaceInFlowMax:0,trackingSpaceMin:1/0,negativeSpaceMax:-1/0,notASpace:-1/0,transform:null,fontName:null,hasEOL:!1},p=[" "," "];let y=0;function w(e){const t=(y+1)%2,a=" "!==p[y]&&" "===p[t];return p[y]=e,y=t,a}function x(){return" "!==p[y]&&" "===p[(y+1)%2]}function S(){p[0]=p[1]=" ",y=0}const A=this,k=this.xref,C=[];let v=null;const F=new g.LocalImageCache,O=new g.LocalGStateCache,I=new U(e,k,r);let T;function M({width:e=0,height:t=0,transform:a=f.prevTransform,fontName:n=f.fontName}){d.items.push({str:" ",dir:"ltr",width:e,height:t,transform:a,fontName:n,hasEOL:!1})}function P(){const e=T.font,t=[T.fontSize*T.textHScale,0,0,T.fontSize,0,T.textRise];if(e.isType3Font&&(T.fontSize<=1||e.isCharBBox)&&!(0,n.isArrayEqual)(T.fontMatrix,n.FONT_IDENTITY_MATRIX)){const a=e.bbox[3]-e.bbox[1];a>0&&(t[3]*=a*T.fontMatrix[3])}return n.Util.transform(T.ctm,n.Util.transform(T.textMatrix,t))}function D(){if(f.initialized)return f;const{font:e,loadedName:t}=T;c.has(t)||(c.add(t),d.styles[t]={fontFamily:e.fallbackName,ascent:e.ascent,descent:e.descent,vertical:e.vertical}),f.fontName=t;const a=f.transform=P();e.vertical?(f.width=f.totalWidth=Math.hypot(a[0],a[1]),f.height=f.totalHeight=0,f.vertical=!0):(f.width=f.totalWidth=0,f.height=f.totalHeight=Math.hypot(a[2],a[3]),f.vertical=!1);const n=Math.hypot(T.textLineMatrix[0],T.textLineMatrix[1]),r=Math.hypot(T.ctm[0],T.ctm[1]);f.textAdvanceScale=r*n;const{fontSize:i}=T;return f.trackingSpaceMin=.102*i,f.notASpace=.03*i,f.negativeSpaceMax=-.2*i,f.spaceInFlowMin=.102*i,f.spaceInFlowMax=.6*i,f.hasEOL=!1,f.initialized=!0,f}function R(){if(!f.initialized)return;const e=Math.hypot(T.textLineMatrix[0],T.textLineMatrix[1]),t=Math.hypot(T.ctm[0],T.ctm[1])*e;t!==f.textAdvanceScale&&(f.vertical?(f.totalHeight+=f.height*f.textAdvanceScale,f.height=0):(f.totalWidth+=f.width*f.textAdvanceScale,f.width=0),f.textAdvanceScale=t)}function B(e,r){return A.loadFont(e,r,a).then((function(e){return e.font.isType3Font?e.loadType3Data(A,a,t).catch((function(){})).then((function(){return e})):e})).then((function(e){T.loadedName=e.loadedName,T.font=e.font,T.fontMatrix=e.font.fontMatrix||n.FONT_IDENTITY_MATRIX}))}function $(e,t,a){const n=Math.hypot(a[0],a[1]);return[(a[0]*e+a[1]*t)/n,(a[2]*e+a[3]*t)/n]}function j(e){const t=P();let a=t[4],n=t[5];if(T.font?.vertical){if(a<l[0]||a>l[2]||n+e<l[1]||n>l[3])return!1}else if(a+e<l[0]||a>l[2]||n<l[1]||n>l[3])return!1;if(!T.font||!f.prevTransform)return!0;let r=f.prevTransform[4],i=f.prevTransform[5];if(r===a&&i===n)return!0;let s=-1;switch(t[0]&&0===t[1]&&0===t[2]?s=t[0]>0?0:180:t[1]&&0===t[0]&&0===t[3]&&(s=t[1]>0?90:270),s){case 0:break;case 90:[a,n]=[n,a],[r,i]=[i,r];break;case 180:[a,n,r,i]=[-a,-n,-r,-i];break;case 270:[a,n]=[-n,-a],[r,i]=[-i,-r];break;default:[a,n]=$(a,n,t),[r,i]=$(r,i,f.prevTransform)}if(T.font.vertical){const e=(i-n)/f.textAdvanceScale,t=a-r,s=Math.sign(f.height);return e<s*f.negativeSpaceMax?Math.abs(t)>.5*f.width?(H(),!0):(S(),z(),!0):Math.abs(t)>f.width?(H(),!0):(e<=s*f.notASpace&&S(),e<=s*f.trackingSpaceMin?x()?(S(),z(),M({height:Math.abs(e)})):f.height+=e:q(e,f.prevTransform,s)||(0===f.str.length?(S(),M({height:Math.abs(e)})):f.height+=e),Math.abs(t)>.25*f.width&&z(),!0)}const o=(a-r)/f.textAdvanceScale,c=n-i,h=Math.sign(f.width);return o<h*f.negativeSpaceMax?Math.abs(c)>.5*f.height?(H(),!0):(S(),z(),!0):Math.abs(c)>f.height?(H(),!0):(o<=h*f.notASpace&&S(),o<=h*f.trackingSpaceMin?x()?(S(),z(),M({width:Math.abs(o)})):f.width+=o:q(o,f.prevTransform,h)||(0===f.str.length?(S(),M({width:Math.abs(o)})):f.width+=o),Math.abs(c)>.25*f.height&&z(),!0)}function X({chars:e,extraSpacing:t}){const a=T.font;if(!e){const e=T.charSpacing+t;return void(e&&(a.vertical?T.translateTextMatrix(0,-e):T.translateTextMatrix(e*T.textHScale,0)))}const n=a.charsToGlyphs(e),r=T.fontMatrix[0]*T.fontSize;for(let e=0,i=n.length;e<i;e++){const s=n[e],{category:o}=s;if(o.isInvisibleFormatMark)continue;let c=T.charSpacing+(e+1===i?t:0),l=s.width;a.vertical&&(l=s.vmetric?s.vmetric[0]:-l);let h=l*r;if(o.isWhitespace){a.vertical?(c+=-h+T.wordSpacing,T.translateTextMatrix(0,-c)):(c+=h+T.wordSpacing,T.translateTextMatrix(c*T.textHScale,0)),w(" ");continue}if(!o.isZeroWidthDiacritic&&!j(h)){a.vertical?T.translateTextMatrix(0,h):T.translateTextMatrix(h*T.textHScale,0);continue}const u=D();o.isZeroWidthDiacritic&&(h=0),a.vertical?(T.translateTextMatrix(0,h),h=Math.abs(h),u.height+=h):(h*=T.textHScale,T.translateTextMatrix(h,0),u.width+=h),h&&(u.prevTransform=P());const d=s.unicode;w(d)&&u.str.push(" "),u.str.push(d),c&&(a.vertical?T.translateTextMatrix(0,-c):T.translateTextMatrix(c*T.textHScale,0))}}function H(){S(),f.initialized?(f.hasEOL=!0,z()):d.items.push({str:"",dir:"ltr",width:0,height:0,transform:P(),fontName:T.loadedName,hasEOL:!0})}function q(e,t,a){if(a*f.spaceInFlowMin<=e&&e<=a*f.spaceInFlowMax)return f.initialized&&(S(),f.str.push(" ")),!1;const n=f.fontName;let r=0;return f.vertical&&(r=e,e=0),z(),S(),M({width:Math.abs(e),height:Math.abs(r),transform:t||P(),fontName:n}),!0}function z(){f.initialized&&f.str&&(f.vertical?f.totalHeight+=f.height*f.textAdvanceScale:f.totalWidth+=f.width*f.textAdvanceScale,d.items.push(function(e){let t=e.str.join("");u||(t=(0,n.normalizeUnicode)(t));const a=(0,b.bidi)(t,-1,e.vertical);return{str:a.str,dir:a.dir,width:Math.abs(e.totalWidth),height:Math.abs(e.totalHeight),transform:e.transform,fontName:e.fontName,hasEOL:e.hasEOL}}(f)),f.initialized=!1,f.str.length=0)}function G(e=!1){const t=d.items.length;0!==t&&(e&&t<10||(o.enqueue(d,t),d.items=[],d.styles=Object.create(null)))}const W=new E;return new Promise((function e(f,g){const p=function(t){G(!0),Promise.all([t,o.ready]).then((function(){try{e(f,g)}catch(e){g(e)}}),g)};t.ensureNotTerminated(),W.reset();const b={};let y,w=[];for(;!(y=W.check())&&(w.length=0,b.args=w,I.read(b));){const e=T;T=r.state;const f=b.fn;switch(w=b.args,0|f){case n.OPS.setFont:var x=w[0].name,S=w[1];if(T.font&&x===T.fontName&&S===T.fontSize)break;return z(),T.fontName=x,T.fontSize=S,void p(B(x,null));case n.OPS.setTextRise:T.textRise=w[0];break;case n.OPS.setHScale:T.textHScale=w[0]/100;break;case n.OPS.setLeading:T.leading=w[0];break;case n.OPS.moveText:T.translateTextLineMatrix(w[0],w[1]),T.textMatrix=T.textLineMatrix.slice();break;case n.OPS.setLeadingMoveText:T.leading=-w[1],T.translateTextLineMatrix(w[0],w[1]),T.textMatrix=T.textLineMatrix.slice();break;case n.OPS.nextLine:T.carriageReturn();break;case n.OPS.setTextMatrix:T.setTextMatrix(w[0],w[1],w[2],w[3],w[4],w[5]),T.setTextLineMatrix(w[0],w[1],w[2],w[3],w[4],w[5]),R();break;case n.OPS.setCharSpacing:T.charSpacing=w[0];break;case n.OPS.setWordSpacing:T.wordSpacing=w[0];break;case n.OPS.beginText:T.textMatrix=n.IDENTITY_MATRIX.slice(),T.textLineMatrix=n.IDENTITY_MATRIX.slice();break;case n.OPS.showSpacedText:if(!r.state.font){A.ensureStateFont(r.state);continue}const f=(T.font.vertical?1:-1)*T.fontSize/1e3,g=w[0];for(let e=0,t=g.length;e<t;e++){const t=g[e];if("string"==typeof t)C.push(t);else if("number"==typeof t&&0!==t){const e=C.join("");C.length=0,X({chars:e,extraSpacing:t*f})}}if(C.length>0){const e=C.join("");C.length=0,X({chars:e,extraSpacing:0})}break;case n.OPS.showText:if(!r.state.font){A.ensureStateFont(r.state);continue}X({chars:w[0],extraSpacing:0});break;case n.OPS.nextLineShowText:if(!r.state.font){A.ensureStateFont(r.state);continue}T.carriageReturn(),X({chars:w[0],extraSpacing:0});break;case n.OPS.nextLineSetSpacingShowText:if(!r.state.font){A.ensureStateFont(r.state);continue}T.wordSpacing=w[0],T.charSpacing=w[1],T.carriageReturn(),X({chars:w[2],extraSpacing:0});break;case n.OPS.paintXObject:z(),v||(v=a.get("XObject")||i.Dict.empty);var M=w[0]instanceof i.Name,P=w[0].name;if(M&&F.getByName(P))break;return void p(new Promise((function(e,d){if(!M)throw new n.FormatError("XObject must be referred to by name.");let f=v.getRaw(P);if(f instanceof i.Ref){if(F.getByRef(f))return void e();if(A.globalImageCache.getData(f,A.pageIndex))return void e();f=k.fetch(f)}if(!(f instanceof m.BaseStream))throw new n.FormatError("XObject should be a stream");const g=f.dict.get("Subtype");if(!(g instanceof i.Name))throw new n.FormatError("XObject should have a Name subtype");if("Form"!==g.name)return F.set(P,f.dict.objId,!0),void e();const p=r.state.clone(),b=new L(p),y=f.dict.getArray("Matrix");Array.isArray(y)&&6===y.length&&b.transform(y),G();const w={enqueueInvoked:!1,enqueue(e,t){this.enqueueInvoked=!0,o.enqueue(e,t)},get desiredSize(){return o.desiredSize},get ready(){return o.ready}};A.getTextContent({stream:f,task:t,resources:f.dict.get("Resources")||a,stateManager:b,includeMarkedContent:s,sink:w,seenStyles:c,viewBox:l,markedContentData:h,disableNormalization:u}).then((function(){w.enqueueInvoked||F.set(P,f.dict.objId,!0),e()}),d)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!A.options.ignoreErrors)throw e;(0,n.warn)(`getTextContent - ignoring XObject: "${e}".`)}})));case n.OPS.setGState:if(M=w[0]instanceof i.Name,P=w[0].name,M&&O.getByName(P))break;return void p(new Promise((function(e,t){if(!M)throw new n.FormatError("GState must be referred to by name.");const r=a.get("ExtGState");if(!(r instanceof i.Dict))throw new n.FormatError("ExtGState should be a dictionary.");const s=r.get(P);if(!(s instanceof i.Dict))throw new n.FormatError("GState should be a dictionary.");const o=s.get("Font");if(!o)return O.set(P,s.objId,!0),void e();z(),T.fontName=null,T.fontSize=o[1],B(null,o[0]).then(e,t)})).catch((function(e){if(!(e instanceof n.AbortException)){if(!A.options.ignoreErrors)throw e;(0,n.warn)(`getTextContent - ignoring ExtGState: "${e}".`)}})));case n.OPS.beginMarkedContent:z(),s&&(h.level++,d.items.push({type:"beginMarkedContent",tag:w[0]instanceof i.Name?w[0].name:null}));break;case n.OPS.beginMarkedContentProps:if(z(),s){h.level++;let e=null;w[1]instanceof i.Dict&&(e=w[1].get("MCID")),d.items.push({type:"beginMarkedContentProps",id:Number.isInteger(e)?`${A.idFactory.getPageObjId()}_mc${e}`:null,tag:w[0]instanceof i.Name?w[0].name:null})}break;case n.OPS.endMarkedContent:if(z(),s){if(0===h.level)break;h.level--,d.items.push({type:"endMarkedContent"})}break;case n.OPS.restore:!e||e.font===T.font&&e.fontSize===T.fontSize&&e.fontName===T.fontName||z()}if(d.items.length>=o.desiredSize){y=!0;break}}y?p(N):(z(),G(),f())})).catch((e=>{if(!(e instanceof n.AbortException)){if(this.options.ignoreErrors)return(0,n.warn)(`getTextContent - ignoring errors during "${t.name}" task: "${e}".`),z(),void G();throw e}}))}extractDataStructures(e,t,a){const r=this.xref;let s;const l=this.readToUnicode(a.toUnicode||e.get("ToUnicode")||t.get("ToUnicode"));if(a.composite){const t=e.get("CIDSystemInfo");t instanceof i.Dict&&(a.cidSystemInfo={registry:(0,n.stringToPDFString)(t.get("Registry")),ordering:(0,n.stringToPDFString)(t.get("Ordering")),supplement:t.get("Supplement")});try{const t=e.get("CIDToGIDMap");t instanceof m.BaseStream&&(s=t.getBytes())}catch(e){if(!this.options.ignoreErrors)throw e;(0,n.warn)(`extractDataStructures - ignoring CIDToGIDMap data: "${e}".`)}}const h=[];let u,d=null;if(e.has("Encoding")){if(u=e.get("Encoding"),u instanceof i.Dict){if(d=u.get("BaseEncoding"),d=d instanceof i.Name?d.name:null,u.has("Differences")){const e=u.get("Differences");let t=0;for(const a of e){const e=r.fetchIfRef(a);if("number"==typeof e)t=e;else{if(!(e instanceof i.Name))throw new n.FormatError(`Invalid entry in 'Differences' array: ${e}`);h[t++]=e.name}}}}else if(u instanceof i.Name)d=u.name;else{const e="Encoding is not a Name nor a Dict";if(!this.options.ignoreErrors)throw new n.FormatError(e);(0,n.warn)(e)}"MacRomanEncoding"!==d&&"MacExpertEncoding"!==d&&"WinAnsiEncoding"!==d&&(d=null)}const f=!a.file||a.isInternalFont,g=(0,c.getSymbolsFonts)()[a.name];if(d&&f&&g&&(d=null),d)a.defaultEncoding=(0,o.getEncoding)(d);else{const e=!!(a.flags&x.FontFlags.Symbolic),t=!!(a.flags&x.FontFlags.Nonsymbolic);u=o.StandardEncoding,"TrueType"!==a.type||t||(u=o.WinAnsiEncoding),(e||g)&&(u=o.MacRomanEncoding,f&&(/Symbol/i.test(a.name)?u=o.SymbolSetEncoding:/Dingbats/i.test(a.name)?u=o.ZapfDingbatsEncoding:/Wingdings/i.test(a.name)&&(u=o.WinAnsiEncoding))),a.defaultEncoding=u}return a.differences=h,a.baseEncodingName=d,a.hasEncoding=!!d||h.length>0,a.dict=e,l.then((e=>(a.toUnicode=e,this.buildToUnicode(a)))).then((e=>(a.toUnicode=e,s&&(a.cidToGidMap=this.readCidToGidMap(s,e)),a)))}_simpleFontToUnicode(e,t=!1){(0,n.assert)(!e.composite,"Must be a simple font.");const a=[],r=e.defaultEncoding.slice(),i=e.baseEncodingName,s=e.differences;for(const e in s){const t=s[e];".notdef"!==t&&(r[e]=t)}const c=(0,A.getGlyphsUnicode)();for(const n in r){let s=r[n];if(""===s)continue;let l=c[s];if(void 0!==l){a[n]=String.fromCharCode(l);continue}let h=0;switch(s[0]){case"G":3===s.length&&(h=parseInt(s.substring(1),16));break;case"g":5===s.length&&(h=parseInt(s.substring(1),16));break;case"C":case"c":if(s.length>=3&&s.length<=4){const a=s.substring(1);if(t){h=parseInt(a,16);break}if(h=+a,Number.isNaN(h)&&Number.isInteger(parseInt(a,16)))return this._simpleFontToUnicode(e,!0)}break;case"u":l=(0,C.getUnicodeForGlyph)(s,c),-1!==l&&(h=l);break;default:switch(s){case"f_h":case"f_t":case"T_h":a[n]=s.replaceAll("_","");continue}}if(h>0&&h<=1114111&&Number.isInteger(h)){if(i&&h===+n){const e=(0,o.getEncoding)(i);if(e&&(s=e[n])){a[n]=String.fromCharCode(c[s]);continue}}a[n]=String.fromCodePoint(h)}}return a}async buildToUnicode(e){if(e.hasIncludedToUnicodeMap=e.toUnicode?.length>0,e.hasIncludedToUnicodeMap)return!e.composite&&e.hasEncoding&&(e.fallbackToUnicode=this._simpleFontToUnicode(e)),e.toUnicode;if(!e.composite)return new u.ToUnicodeMap(this._simpleFontToUnicode(e));if(e.composite&&(e.cMap.builtInCMap&&!(e.cMap instanceof r.IdentityCMap)||"Adobe"===e.cidSystemInfo.registry&&("GB1"===e.cidSystemInfo.ordering||"CNS1"===e.cidSystemInfo.ordering||"Japan1"===e.cidSystemInfo.ordering||"Korea1"===e.cidSystemInfo.ordering))){const{registry:t,ordering:a}=e.cidSystemInfo,s=i.Name.get(`${t}-${a}-UCS2`),o=await r.CMapFactory.create({encoding:s,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}),c=[],l=[];return e.cMap.forEach((function(e,t){if(t>65535)throw new n.FormatError("Max size of CID is 65,535");const a=o.lookup(t);if(a){l.length=0;for(let e=0,t=a.length;e<t;e+=2)l.push((a.charCodeAt(e)<<8)+a.charCodeAt(e+1));c[e]=String.fromCharCode(...l)}})),new u.ToUnicodeMap(c)}return new u.IdentityToUnicodeMap(e.firstChar,e.lastChar)}readToUnicode(e){return e?e instanceof i.Name?r.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}).then((function(e){return e instanceof r.IdentityCMap?new u.IdentityToUnicodeMap(0,65535):new u.ToUnicodeMap(e.getMap())})):e instanceof m.BaseStream?r.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null}).then((function(e){if(e instanceof r.IdentityCMap)return new u.IdentityToUnicodeMap(0,65535);const t=new Array(e.length);return e.forEach((function(e,a){if("number"==typeof a)return void(t[e]=String.fromCodePoint(a));const n=[];for(let e=0;e<a.length;e+=2){const t=a.charCodeAt(e)<<8|a.charCodeAt(e+1);if(55296!=(63488&t)){n.push(t);continue}e+=2;const r=a.charCodeAt(e)<<8|a.charCodeAt(e+1);n.push(((1023&t)<<10)+(1023&r)+65536)}t[e]=String.fromCodePoint(...n)})),new u.ToUnicodeMap(t)}),(e=>{if(e instanceof n.AbortException)return null;if(this.options.ignoreErrors)return(0,n.warn)(`readToUnicode - ignoring ToUnicode data: "${e}".`),null;throw e})):Promise.resolve(null):Promise.resolve(null)}readCidToGidMap(e,t){const a=[];for(let n=0,r=e.length;n<r;n++){const r=e[n++]<<8|e[n],i=n>>1;(0!==r||t.has(i))&&(a[i]=r)}return a}extractWidths(e,t,a){const n=this.xref;let r=[],s=0;const o=[];let c,l,h,u,d,f,g,p;if(a.composite){if(s=e.has("DW")?e.get("DW"):1e3,p=e.get("W"),p)for(l=0,h=p.length;l<h;l++)if(f=n.fetchIfRef(p[l++]),g=n.fetchIfRef(p[l]),Array.isArray(g))for(u=0,d=g.length;u<d;u++)r[f++]=n.fetchIfRef(g[u]);else{const e=n.fetchIfRef(p[++l]);for(u=f;u<=g;u++)r[u]=e}if(a.vertical){let t=e.getArray("DW2")||[880,-1e3];if(c=[t[1],.5*s,t[0]],t=e.get("W2"),t)for(l=0,h=t.length;l<h;l++)if(f=n.fetchIfRef(t[l++]),g=n.fetchIfRef(t[l]),Array.isArray(g))for(u=0,d=g.length;u<d;u++)o[f++]=[n.fetchIfRef(g[u++]),n.fetchIfRef(g[u++]),n.fetchIfRef(g[u])];else{const e=[n.fetchIfRef(t[++l]),n.fetchIfRef(t[++l]),n.fetchIfRef(t[++l])];for(u=f;u<=g;u++)o[u]=e}}}else{const o=a.firstChar;if(p=e.get("Widths"),p){for(u=o,l=0,h=p.length;l<h;l++)r[u++]=n.fetchIfRef(p[l]);s=parseFloat(t.get("MissingWidth"))||0}else{const t=e.get("BaseFont");if(t instanceof i.Name){const e=this.getBaseFontMetrics(t.name);r=this.buildCharCodeToWidth(e.widths,a),s=e.defaultWidth}}}let m=!0,b=s;for(const e in r){const t=r[e];if(t)if(b){if(b!==t){m=!1;break}}else b=t}m?a.flags|=x.FontFlags.FixedPitch:a.flags&=~x.FontFlags.FixedPitch,a.defaultWidth=s,a.widths=r,a.defaultVMetrics=c,a.vmetrics=o}isSerifFont(e){const t=e.split("-")[0];return t in(0,c.getSerifFonts)()||/serif/gi.test(t)}getBaseFontMetrics(e){let t=0,a=Object.create(null),n=!1;let r=(0,c.getStdFontMap)()[e]||e;const i=(0,k.getMetrics)();r in i||(r=this.isSerifFont(e)?"Times-Roman":"Helvetica");const s=i[r];return"number"==typeof s?(t=s,n=!0):a=s(),{defaultWidth:t,monospace:n,widths:a}}buildCharCodeToWidth(e,t){const a=Object.create(null),n=t.differences,r=t.defaultEncoding;for(let t=0;t<256;t++)t in n&&e[n[t]]?a[t]=e[n[t]]:t in r&&e[r[t]]&&(a[t]=e[r[t]]);return a}preEvaluateFont(e){const t=e;let a=e.get("Subtype");if(!(a instanceof i.Name))throw new n.FormatError("invalid font Subtype");let r,s,o=!1;if("Type0"===a.name){const t=e.get("DescendantFonts");if(!t)throw new n.FormatError("Descendant fonts are not specified");if(!((e=Array.isArray(t)?this.xref.fetchIfRef(t[0]):t)instanceof i.Dict))throw new n.FormatError("Descendant font is not a dictionary.");if(a=e.get("Subtype"),!(a instanceof i.Name))throw new n.FormatError("invalid font Subtype");o=!0}const c=e.get("FirstChar")||0,l=e.get("LastChar")||(o?65535:255),h=e.get("FontDescriptor");if(h){r=new F.MurmurHash3_64;const a=t.getRaw("Encoding");if(a instanceof i.Name)r.update(a.name);else if(a instanceof i.Ref)r.update(a.toString());else if(a instanceof i.Dict)for(const e of a.getRawValues())if(e instanceof i.Name)r.update(e.name);else if(e instanceof i.Ref)r.update(e.toString());else if(Array.isArray(e)){const t=e.length,a=new Array(t);for(let n=0;n<t;n++){const t=e[n];t instanceof i.Name?a[n]=t.name:("number"==typeof t||t instanceof i.Ref)&&(a[n]=t.toString())}r.update(a.join())}if(r.update(`${c}-${l}`),s=e.get("ToUnicode")||t.get("ToUnicode"),s instanceof m.BaseStream){const e=s.str||s,t=e.buffer?new Uint8Array(e.buffer.buffer,0,e.bufferLength):new Uint8Array(e.bytes.buffer,e.start,e.end-e.start);r.update(t)}else s instanceof i.Name&&r.update(s.name);const n=e.get("Widths")||t.get("Widths");if(Array.isArray(n)){const e=[];for(const t of n)("number"==typeof t||t instanceof i.Ref)&&e.push(t.toString());r.update(e.join())}if(o){r.update("compositeFont");const a=e.get("W")||t.get("W");if(Array.isArray(a)){const e=[];for(const t of a)if("number"==typeof t||t instanceof i.Ref)e.push(t.toString());else if(Array.isArray(t)){const a=[];for(const e of t)("number"==typeof e||e instanceof i.Ref)&&a.push(e.toString());e.push(`[${a.join()}]`)}r.update(e.join())}const n=e.getRaw("CIDToGIDMap")||t.getRaw("CIDToGIDMap");n instanceof i.Name?r.update(n.name):n instanceof i.Ref?r.update(n.toString()):n instanceof m.BaseStream&&r.update(n.peekBytes())}}return{descriptor:h,dict:e,baseDict:t,composite:o,type:a.name,firstChar:c,lastChar:l,toUnicode:s,hash:r?r.hexdigest():""}}async translateFont({descriptor:e,dict:t,baseDict:a,composite:o,type:l,firstChar:u,lastChar:d,toUnicode:f,cssFontInfo:g}){const m="Type3"===l;let b;if(!e){if(!m){let e=t.get("BaseFont");if(!(e instanceof i.Name))throw new n.FormatError("Base font is not specified");e=e.name.replaceAll(/[,_]/g,"-");const r=this.getBaseFontMetrics(e),o=e.split("-")[0],h=(this.isSerifFont(o)?x.FontFlags.Serif:0)|(r.monospace?x.FontFlags.FixedPitch:0)|((0,c.getSymbolsFonts)()[o]?x.FontFlags.Symbolic:x.FontFlags.Nonsymbolic);b={type:l,name:e,loadedName:a.loadedName,systemFontInfo:null,widths:r.widths,defaultWidth:r.defaultWidth,isSimulatedFlags:!0,flags:h,firstChar:u,lastChar:d,toUnicode:f,xHeight:0,capHeight:0,italicAngle:0,isType3Font:m};const g=t.get("Widths"),p=(0,c.getStandardFontName)(e);let y=null;return p&&(y=await this.fetchStandardFontData(p),b.isInternalFont=!!y),!b.isInternalFont&&this.options.useSystemFonts&&(b.systemFontInfo=(0,S.getFontSubstitution)(this.systemFontCache,this.idFactory,this.options.standardFontDataUrl,e,p)),this.extractDataStructures(t,t,b).then((t=>{if(g){const e=[];let a=u;for(const t of g)e[a++]=this.xref.fetchIfRef(t);t.widths=e}else t.widths=this.buildCharCodeToWidth(r.widths,t);return new s.Font(e,y,t)}))}(e=new i.Dict(null)).set("FontName",i.Name.get(l)),e.set("FontBBox",t.getArray("FontBBox")||[0,0,0,0])}let y=e.get("FontName"),w=t.get("BaseFont");"string"==typeof y&&(y=i.Name.get(y)),"string"==typeof w&&(w=i.Name.get(w));const A=y?.name,k=w?.name;if(m||A===k||((0,n.info)(`The FontDescriptor's FontName is "${A}" but should be the same as the Font's BaseFont "${k}".`),A&&k&&(k.startsWith(A)||!(0,c.isKnownFontName)(A)&&(0,c.isKnownFontName)(k))&&(y=null)),y||=w,!(y instanceof i.Name))throw new n.FormatError("invalid font name");let C,v,F,O,I;try{C=e.get("FontFile","FontFile2","FontFile3")}catch(e){if(!this.options.ignoreErrors)throw e;(0,n.warn)(`translateFont - fetching "${y.name}" font file: "${e}".`),C=new p.NullStream}let T=!1,M=null,P=null;if(C){if(C.dict){const e=C.dict.get("Subtype");e instanceof i.Name&&(v=e.name),F=C.dict.get("Length1"),O=C.dict.get("Length2"),I=C.dict.get("Length3")}}else if(g){const e=(0,h.getXfaFontName)(y.name);e&&(g.fontFamily=`${g.fontFamily}-PdfJS-XFA`,g.metrics=e.metrics||null,M=e.factors||null,C=await this.fetchStandardFontData(e.name),T=!!C,a=t=(0,h.getXfaFontDict)(y.name),o=!0)}else if(!m){const e=(0,c.getStandardFontName)(y.name);e&&(C=await this.fetchStandardFontData(e),T=!!C),!T&&this.options.useSystemFonts&&(P=(0,S.getFontSubstitution)(this.systemFontCache,this.idFactory,this.options.standardFontDataUrl,y.name,e))}if(b={type:l,name:y.name,subtype:v,file:C,length1:F,length2:O,length3:I,isInternalFont:T,loadedName:a.loadedName,composite:o,fixedPitch:!1,fontMatrix:t.getArray("FontMatrix")||n.FONT_IDENTITY_MATRIX,firstChar:u,lastChar:d,toUnicode:f,bbox:e.getArray("FontBBox")||t.getArray("FontBBox"),ascent:e.get("Ascent"),descent:e.get("Descent"),xHeight:e.get("XHeight")||0,capHeight:e.get("CapHeight")||0,flags:e.get("Flags"),italicAngle:e.get("ItalicAngle")||0,isType3Font:m,cssFontInfo:g,scaleFactors:M,systemFontInfo:P},o){const e=a.get("Encoding");e instanceof i.Name&&(b.cidEncoding=e.name);const t=await r.CMapFactory.create({encoding:e,fetchBuiltInCMap:this._fetchBuiltInCMapBound,useCMap:null});b.cMap=t,b.vertical=b.cMap.vertical}return this.extractDataStructures(t,a,b).then((a=>(this.extractWidths(t,e,a),new s.Font(y.name,C,a))))}static buildFontPaths(e,t,a,r){function i(t){const i=`${e.loadedName}_path_${t}`;try{if(e.renderer.hasBuiltPath(t))return;a.send("commonobj",[i,"FontPath",e.renderer.getPathJs(t)])}catch(e){if(r.ignoreErrors)return void(0,n.warn)(`buildFontPaths - ignoring ${i} glyph: "${e}".`);throw e}}for(const e of t){i(e.fontChar);const t=e.accent;t?.fontChar&&i(t.fontChar)}}static get fallbackFontDict(){const e=new i.Dict;return e.set("BaseFont",i.Name.get("Helvetica")),e.set("Type",i.Name.get("FallbackType")),e.set("Subtype",i.Name.get("FallbackType")),e.set("Encoding",i.Name.get("WinAnsiEncoding")),(0,n.shadow)(this,"fallbackFontDict",e)}}t.PartialEvaluator=B;class ${constructor({loadedName:e,font:t,dict:a,evaluatorOptions:n}){this.loadedName=e,this.font=t,this.dict=a,this._evaluatorOptions=n||T,this.type3Loaded=null,this.type3Dependencies=t.isType3Font?new Set:null,this.sent=!1}send(e){this.sent||(this.sent=!0,e.send("commonobj",[this.loadedName,"Font",this.font.exportData(this._evaluatorOptions.fontExtraProperties)]))}fallback(e){this.font.data&&(this.font.disableFontFace=!0,B.buildFontPaths(this.font,this.font.glyphCacheValues,e,this._evaluatorOptions))}loadType3Data(e,t,a){if(this.type3Loaded)return this.type3Loaded;if(!this.font.isType3Font)throw new Error("Must be a Type3 font.");const r=e.clone({ignoreErrors:!1});r.parsingType3Font=!0;const s=new i.RefSet(e.type3FontRefs);this.dict.objId&&!s.has(this.dict.objId)&&s.put(this.dict.objId),r.type3FontRefs=s;const o=this.font,c=this.type3Dependencies;let l=Promise.resolve();const h=this.dict.get("CharProcs"),u=this.dict.get("Resources")||t,d=Object.create(null),f=n.Util.normalizeRect(o.bbox||[0,0,0,0]),g=f[2]-f[0],p=f[3]-f[1],m=Math.hypot(g,p);for(const e of h.getKeys())l=l.then((()=>{const t=h.get(e),i=new O.OperatorList;return r.getOperatorList({stream:t,task:a,resources:u,operatorList:i}).then((()=>{i.fnArray[0]===n.OPS.setCharWidthAndBounds&&this._removeType3ColorOperators(i,m),d[e]=i.getIR();for(const e of i.dependencies)c.add(e)})).catch((function(t){(0,n.warn)(`Type3 font resource "${e}" is not available.`);const a=new O.OperatorList;d[e]=a.getIR()}))}));return this.type3Loaded=l.then((()=>{o.charProcOperatorList=d,this._bbox&&(o.isCharBBox=!0,o.bbox=this._bbox)})),this.type3Loaded}_removeType3ColorOperators(e,t=NaN){const a=n.Util.normalizeRect(e.argsArray[0].slice(2)),r=a[2]-a[0],i=a[3]-a[1],s=Math.hypot(r,i);0===r||0===i?(e.fnArray.splice(0,1),e.argsArray.splice(0,1)):(0===t||Math.round(s/t)>=10)&&(this._bbox||(this._bbox=[1/0,1/0,-1/0,-1/0]),this._bbox[0]=Math.min(this._bbox[0],a[0]),this._bbox[1]=Math.min(this._bbox[1],a[1]),this._bbox[2]=Math.max(this._bbox[2],a[2]),this._bbox[3]=Math.max(this._bbox[3],a[3]));let o=0,c=e.length;for(;o<c;){switch(e.fnArray[o]){case n.OPS.setCharWidthAndBounds:break;case n.OPS.setStrokeColorSpace:case n.OPS.setFillColorSpace:case n.OPS.setStrokeColor:case n.OPS.setStrokeColorN:case n.OPS.setFillColor:case n.OPS.setFillColorN:case n.OPS.setStrokeGray:case n.OPS.setFillGray:case n.OPS.setStrokeRGBColor:case n.OPS.setFillRGBColor:case n.OPS.setStrokeCMYKColor:case n.OPS.setFillCMYKColor:case n.OPS.shadingFill:case n.OPS.setRenderingIntent:e.fnArray.splice(o,1),e.argsArray.splice(o,1),c--;continue;case n.OPS.setGState:const[t]=e.argsArray[o];let a=0,r=t.length;for(;a<r;){const[e]=t[a];switch(e){case"TR":case"TR2":case"HT":case"BG":case"BG2":case"UCR":case"UCR2":t.splice(a,1),r--;continue}a++}}o++}}}class L{constructor(e=new j){this.state=e,this.stateStack=[]}save(){const e=this.state;this.stateStack.push(this.state),this.state=e.clone()}restore(){const e=this.stateStack.pop();e&&(this.state=e)}transform(e){this.state.ctm=n.Util.transform(this.state.ctm,e)}}class _{constructor(){this.ctm=new Float32Array(n.IDENTITY_MATRIX),this.fontName=null,this.fontSize=0,this.loadedName=null,this.font=null,this.fontMatrix=n.FONT_IDENTITY_MATRIX,this.textMatrix=n.IDENTITY_MATRIX.slice(),this.textLineMatrix=n.IDENTITY_MATRIX.slice(),this.charSpacing=0,this.wordSpacing=0,this.leading=0,this.textHScale=1,this.textRise=0}setTextMatrix(e,t,a,n,r,i){const s=this.textMatrix;s[0]=e,s[1]=t,s[2]=a,s[3]=n,s[4]=r,s[5]=i}setTextLineMatrix(e,t,a,n,r,i){const s=this.textLineMatrix;s[0]=e,s[1]=t,s[2]=a,s[3]=n,s[4]=r,s[5]=i}translateTextMatrix(e,t){const a=this.textMatrix;a[4]=a[0]*e+a[2]*t+a[4],a[5]=a[1]*e+a[3]*t+a[5]}translateTextLineMatrix(e,t){const a=this.textLineMatrix;a[4]=a[0]*e+a[2]*t+a[4],a[5]=a[1]*e+a[3]*t+a[5]}carriageReturn(){this.translateTextLineMatrix(0,-this.leading),this.textMatrix=this.textLineMatrix.slice()}clone(){const e=Object.create(this);return e.textMatrix=this.textMatrix.slice(),e.textLineMatrix=this.textLineMatrix.slice(),e.fontMatrix=this.fontMatrix.slice(),e}}class j{constructor(){this.ctm=new Float32Array(n.IDENTITY_MATRIX),this.font=null,this.textRenderingMode=n.TextRenderingMode.FILL,this.fillColorSpace=y.ColorSpace.singletons.gray,this.strokeColorSpace=y.ColorSpace.singletons.gray}clone(){return Object.create(this)}}class U{static get opMap(){return(0,n.shadow)(this,"opMap",{w:{id:n.OPS.setLineWidth,numArgs:1,variableArgs:!1},J:{id:n.OPS.setLineCap,numArgs:1,variableArgs:!1},j:{id:n.OPS.setLineJoin,numArgs:1,variableArgs:!1},M:{id:n.OPS.setMiterLimit,numArgs:1,variableArgs:!1},d:{id:n.OPS.setDash,numArgs:2,variableArgs:!1},ri:{id:n.OPS.setRenderingIntent,numArgs:1,variableArgs:!1},i:{id:n.OPS.setFlatness,numArgs:1,variableArgs:!1},gs:{id:n.OPS.setGState,numArgs:1,variableArgs:!1},q:{id:n.OPS.save,numArgs:0,variableArgs:!1},Q:{id:n.OPS.restore,numArgs:0,variableArgs:!1},cm:{id:n.OPS.transform,numArgs:6,variableArgs:!1},m:{id:n.OPS.moveTo,numArgs:2,variableArgs:!1},l:{id:n.OPS.lineTo,numArgs:2,variableArgs:!1},c:{id:n.OPS.curveTo,numArgs:6,variableArgs:!1},v:{id:n.OPS.curveTo2,numArgs:4,variableArgs:!1},y:{id:n.OPS.curveTo3,numArgs:4,variableArgs:!1},h:{id:n.OPS.closePath,numArgs:0,variableArgs:!1},re:{id:n.OPS.rectangle,numArgs:4,variableArgs:!1},S:{id:n.OPS.stroke,numArgs:0,variableArgs:!1},s:{id:n.OPS.closeStroke,numArgs:0,variableArgs:!1},f:{id:n.OPS.fill,numArgs:0,variableArgs:!1},F:{id:n.OPS.fill,numArgs:0,variableArgs:!1},"f*":{id:n.OPS.eoFill,numArgs:0,variableArgs:!1},B:{id:n.OPS.fillStroke,numArgs:0,variableArgs:!1},"B*":{id:n.OPS.eoFillStroke,numArgs:0,variableArgs:!1},b:{id:n.OPS.closeFillStroke,numArgs:0,variableArgs:!1},"b*":{id:n.OPS.closeEOFillStroke,numArgs:0,variableArgs:!1},n:{id:n.OPS.endPath,numArgs:0,variableArgs:!1},W:{id:n.OPS.clip,numArgs:0,variableArgs:!1},"W*":{id:n.OPS.eoClip,numArgs:0,variableArgs:!1},BT:{id:n.OPS.beginText,numArgs:0,variableArgs:!1},ET:{id:n.OPS.endText,numArgs:0,variableArgs:!1},Tc:{id:n.OPS.setCharSpacing,numArgs:1,variableArgs:!1},Tw:{id:n.OPS.setWordSpacing,numArgs:1,variableArgs:!1},Tz:{id:n.OPS.setHScale,numArgs:1,variableArgs:!1},TL:{id:n.OPS.setLeading,numArgs:1,variableArgs:!1},Tf:{id:n.OPS.setFont,numArgs:2,variableArgs:!1},Tr:{id:n.OPS.setTextRenderingMode,numArgs:1,variableArgs:!1},Ts:{id:n.OPS.setTextRise,numArgs:1,variableArgs:!1},Td:{id:n.OPS.moveText,numArgs:2,variableArgs:!1},TD:{id:n.OPS.setLeadingMoveText,numArgs:2,variableArgs:!1},Tm:{id:n.OPS.setTextMatrix,numArgs:6,variableArgs:!1},"T*":{id:n.OPS.nextLine,numArgs:0,variableArgs:!1},Tj:{id:n.OPS.showText,numArgs:1,variableArgs:!1},TJ:{id:n.OPS.showSpacedText,numArgs:1,variableArgs:!1},"'":{id:n.OPS.nextLineShowText,numArgs:1,variableArgs:!1},'"':{id:n.OPS.nextLineSetSpacingShowText,numArgs:3,variableArgs:!1},d0:{id:n.OPS.setCharWidth,numArgs:2,variableArgs:!1},d1:{id:n.OPS.setCharWidthAndBounds,numArgs:6,variableArgs:!1},CS:{id:n.OPS.setStrokeColorSpace,numArgs:1,variableArgs:!1},cs:{id:n.OPS.setFillColorSpace,numArgs:1,variableArgs:!1},SC:{id:n.OPS.setStrokeColor,numArgs:4,variableArgs:!0},SCN:{id:n.OPS.setStrokeColorN,numArgs:33,variableArgs:!0},sc:{id:n.OPS.setFillColor,numArgs:4,variableArgs:!0},scn:{id:n.OPS.setFillColorN,numArgs:33,variableArgs:!0},G:{id:n.OPS.setStrokeGray,numArgs:1,variableArgs:!1},g:{id:n.OPS.setFillGray,numArgs:1,variableArgs:!1},RG:{id:n.OPS.setStrokeRGBColor,numArgs:3,variableArgs:!1},rg:{id:n.OPS.setFillRGBColor,numArgs:3,variableArgs:!1},K:{id:n.OPS.setStrokeCMYKColor,numArgs:4,variableArgs:!1},k:{id:n.OPS.setFillCMYKColor,numArgs:4,variableArgs:!1},sh:{id:n.OPS.shadingFill,numArgs:1,variableArgs:!1},BI:{id:n.OPS.beginInlineImage,numArgs:0,variableArgs:!1},ID:{id:n.OPS.beginImageData,numArgs:0,variableArgs:!1},EI:{id:n.OPS.endInlineImage,numArgs:1,variableArgs:!1},Do:{id:n.OPS.paintXObject,numArgs:1,variableArgs:!1},MP:{id:n.OPS.markPoint,numArgs:1,variableArgs:!1},DP:{id:n.OPS.markPointProps,numArgs:2,variableArgs:!1},BMC:{id:n.OPS.beginMarkedContent,numArgs:1,variableArgs:!1},BDC:{id:n.OPS.beginMarkedContentProps,numArgs:2,variableArgs:!1},EMC:{id:n.OPS.endMarkedContent,numArgs:0,variableArgs:!1},BX:{id:n.OPS.beginCompat,numArgs:0,variableArgs:!1},EX:{id:n.OPS.endCompat,numArgs:0,variableArgs:!1},BM:null,BD:null,true:null,fa:null,fal:null,fals:null,false:null,nu:null,nul:null,null:null})}static MAX_INVALID_PATH_OPS=10;constructor(e,t,a=new L){this.parser=new f.Parser({lexer:new f.Lexer(e,U.opMap),xref:t}),this.stateManager=a,this.nonProcessedArgs=[],this._isPathOp=!1,this._numInvalidPathOPS=0}get savedStatesDepth(){return this.stateManager.stateStack.length}read(e){let t=e.args;for(;;){const a=this.parser.getObj();if(a instanceof i.Cmd){const r=a.cmd,i=U.opMap[r];if(!i){(0,n.warn)(`Unknown command "${r}".`);continue}const s=i.id,o=i.numArgs;let c=null!==t?t.length:0;if(this._isPathOp||(this._numInvalidPathOPS=0),this._isPathOp=s>=n.OPS.moveTo&&s<=n.OPS.endPath,i.variableArgs)c>o&&(0,n.info)(`Command ${r}: expected [0, ${o}] args, but received ${c} args.`);else{if(c!==o){const e=this.nonProcessedArgs;for(;c>o;)e.push(t.shift()),c--;for(;c<o&&0!==e.length;)null===t&&(t=[]),t.unshift(e.pop()),c++}if(c<o){const e=`command ${r}: expected ${o} args, but received ${c} args.`;if(this._isPathOp&&++this._numInvalidPathOPS>U.MAX_INVALID_PATH_OPS)throw new n.FormatError(`Invalid ${e}`);(0,n.warn)(`Skipping ${e}`),null!==t&&(t.length=0);continue}}return this.preprocessCommand(s,t),e.fn=s,e.args=t,!0}if(a===i.EOF)return!1;if(null!==a&&(null===t&&(t=[]),t.push(a),t.length>33))throw new n.FormatError("Too many arguments")}}preprocessCommand(e,t){switch(0|e){case n.OPS.save:this.stateManager.save();break;case n.OPS.restore:this.stateManager.restore();break;case n.OPS.transform:this.stateManager.transform(t)}}}t.EvaluatorPreprocessor=U},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.IdentityCMap=t.CMapFactory=t.CMap=void 0;var n=a(2),r=a(4),i=a(5),s=a(15),o=a(16),c=a(3),l=a(8);const h=["Adobe-GB1-UCS2","Adobe-CNS1-UCS2","Adobe-Japan1-UCS2","Adobe-Korea1-UCS2","78-EUC-H","78-EUC-V","78-H","78-RKSJ-H","78-RKSJ-V","78-V","78ms-RKSJ-H","78ms-RKSJ-V","83pv-RKSJ-H","90ms-RKSJ-H","90ms-RKSJ-V","90msp-RKSJ-H","90msp-RKSJ-V","90pv-RKSJ-H","90pv-RKSJ-V","Add-H","Add-RKSJ-H","Add-RKSJ-V","Add-V","Adobe-CNS1-0","Adobe-CNS1-1","Adobe-CNS1-2","Adobe-CNS1-3","Adobe-CNS1-4","Adobe-CNS1-5","Adobe-CNS1-6","Adobe-GB1-0","Adobe-GB1-1","Adobe-GB1-2","Adobe-GB1-3","Adobe-GB1-4","Adobe-GB1-5","Adobe-Japan1-0","Adobe-Japan1-1","Adobe-Japan1-2","Adobe-Japan1-3","Adobe-Japan1-4","Adobe-Japan1-5","Adobe-Japan1-6","Adobe-Korea1-0","Adobe-Korea1-1","Adobe-Korea1-2","B5-H","B5-V","B5pc-H","B5pc-V","CNS-EUC-H","CNS-EUC-V","CNS1-H","CNS1-V","CNS2-H","CNS2-V","ETHK-B5-H","ETHK-B5-V","ETen-B5-H","ETen-B5-V","ETenms-B5-H","ETenms-B5-V","EUC-H","EUC-V","Ext-H","Ext-RKSJ-H","Ext-RKSJ-V","Ext-V","GB-EUC-H","GB-EUC-V","GB-H","GB-V","GBK-EUC-H","GBK-EUC-V","GBK2K-H","GBK2K-V","GBKp-EUC-H","GBKp-EUC-V","GBT-EUC-H","GBT-EUC-V","GBT-H","GBT-V","GBTpc-EUC-H","GBTpc-EUC-V","GBpc-EUC-H","GBpc-EUC-V","H","HKdla-B5-H","HKdla-B5-V","HKdlb-B5-H","HKdlb-B5-V","HKgccs-B5-H","HKgccs-B5-V","HKm314-B5-H","HKm314-B5-V","HKm471-B5-H","HKm471-B5-V","HKscs-B5-H","HKscs-B5-V","Hankaku","Hiragana","KSC-EUC-H","KSC-EUC-V","KSC-H","KSC-Johab-H","KSC-Johab-V","KSC-V","KSCms-UHC-H","KSCms-UHC-HW-H","KSCms-UHC-HW-V","KSCms-UHC-V","KSCpc-EUC-H","KSCpc-EUC-V","Katakana","NWP-H","NWP-V","RKSJ-H","RKSJ-V","Roman","UniCNS-UCS2-H","UniCNS-UCS2-V","UniCNS-UTF16-H","UniCNS-UTF16-V","UniCNS-UTF32-H","UniCNS-UTF32-V","UniCNS-UTF8-H","UniCNS-UTF8-V","UniGB-UCS2-H","UniGB-UCS2-V","UniGB-UTF16-H","UniGB-UTF16-V","UniGB-UTF32-H","UniGB-UTF32-V","UniGB-UTF8-H","UniGB-UTF8-V","UniJIS-UCS2-H","UniJIS-UCS2-HW-H","UniJIS-UCS2-HW-V","UniJIS-UCS2-V","UniJIS-UTF16-H","UniJIS-UTF16-V","UniJIS-UTF32-H","UniJIS-UTF32-V","UniJIS-UTF8-H","UniJIS-UTF8-V","UniJIS2004-UTF16-H","UniJIS2004-UTF16-V","UniJIS2004-UTF32-H","UniJIS2004-UTF32-V","UniJIS2004-UTF8-H","UniJIS2004-UTF8-V","UniJISPro-UCS2-HW-V","UniJISPro-UCS2-V","UniJISPro-UTF8-V","UniJISX0213-UTF32-H","UniJISX0213-UTF32-V","UniJISX02132004-UTF32-H","UniJISX02132004-UTF32-V","UniKS-UCS2-H","UniKS-UCS2-V","UniKS-UTF16-H","UniKS-UTF16-V","UniKS-UTF32-H","UniKS-UTF32-V","UniKS-UTF8-H","UniKS-UTF8-V","V","WP-Symbol"],u=2**24-1;class d{constructor(e=!1){this.codespaceRanges=[[],[],[],[]],this.numCodespaceRanges=0,this._map=[],this.name="",this.vertical=!1,this.useCMap=null,this.builtInCMap=e}addCodespaceRange(e,t,a){this.codespaceRanges[e-1].push(t,a),this.numCodespaceRanges++}mapCidRange(e,t,a){if(t-e>u)throw new Error("mapCidRange - ignoring data above MAX_MAP_RANGE.");for(;e<=t;)this._map[e++]=a++}mapBfRange(e,t,a){if(t-e>u)throw new Error("mapBfRange - ignoring data above MAX_MAP_RANGE.");const n=a.length-1;for(;e<=t;){this._map[e++]=a;const t=a.charCodeAt(n)+1;t>255?a=a.substring(0,n-1)+String.fromCharCode(a.charCodeAt(n-1)+1)+"\0":a=a.substring(0,n)+String.fromCharCode(t)}}mapBfRangeToArray(e,t,a){if(t-e>u)throw new Error("mapBfRangeToArray - ignoring data above MAX_MAP_RANGE.");const n=a.length;let r=0;for(;e<=t&&r<n;)this._map[e]=a[r++],++e}mapOne(e,t){this._map[e]=t}lookup(e){return this._map[e]}contains(e){return void 0!==this._map[e]}forEach(e){const t=this._map,a=t.length;if(a<=65536)for(let n=0;n<a;n++)void 0!==t[n]&&e(n,t[n]);else for(const a in t)e(a,t[a])}charCodeOf(e){const t=this._map;if(t.length<=65536)return t.indexOf(e);for(const a in t)if(t[a]===e)return 0|a;return-1}getMap(){return this._map}readCharCode(e,t,a){let n=0;const r=this.codespaceRanges;for(let i=0,s=r.length;i<s;i++){n=(n<<8|e.charCodeAt(t+i))>>>0;const s=r[i];for(let e=0,t=s.length;e<t;){const t=s[e++],r=s[e++];if(n>=t&&n<=r)return a.charcode=n,void(a.length=i+1)}}a.charcode=0,a.length=1}getCharCodeLength(e){const t=this.codespaceRanges;for(let a=0,n=t.length;a<n;a++){const n=t[a];for(let t=0,r=n.length;t<r;){const r=n[t++],i=n[t++];if(e>=r&&e<=i)return a+1}}return 1}get length(){return this._map.length}get isIdentityCMap(){if("Identity-H"!==this.name&&"Identity-V"!==this.name)return!1;if(65536!==this._map.length)return!1;for(let e=0;e<65536;e++)if(this._map[e]!==e)return!1;return!0}}t.CMap=d;class f extends d{constructor(e,t){super(),this.vertical=e,this.addCodespaceRange(t,0,65535)}mapCidRange(e,t,a){(0,n.unreachable)("should not call mapCidRange")}mapBfRange(e,t,a){(0,n.unreachable)("should not call mapBfRange")}mapBfRangeToArray(e,t,a){(0,n.unreachable)("should not call mapBfRangeToArray")}mapOne(e,t){(0,n.unreachable)("should not call mapCidOne")}lookup(e){return Number.isInteger(e)&&e<=65535?e:void 0}contains(e){return Number.isInteger(e)&&e<=65535}forEach(e){for(let t=0;t<=65535;t++)e(t,t)}charCodeOf(e){return Number.isInteger(e)&&e<=65535?e:-1}getMap(){const e=new Array(65536);for(let t=0;t<=65535;t++)e[t]=t;return e}get length(){return 65536}get isIdentityCMap(){(0,n.unreachable)("should not access .isIdentityCMap")}}function g(e){let t=0;for(let a=0;a<e.length;a++)t=t<<8|e.charCodeAt(a);return t>>>0}function p(e){if("string"!=typeof e)throw new n.FormatError("Malformed CMap: expected string.")}function m(e){if(!Number.isInteger(e))throw new n.FormatError("Malformed CMap: expected int.")}function b(e,t){for(;;){let a=t.getObj();if(a===r.EOF)break;if((0,r.isCmd)(a,"endbfchar"))return;p(a);const n=g(a);a=t.getObj(),p(a);const i=a;e.mapOne(n,i)}}function y(e,t){for(;;){let a=t.getObj();if(a===r.EOF)break;if((0,r.isCmd)(a,"endbfrange"))return;p(a);const n=g(a);a=t.getObj(),p(a);const i=g(a);if(a=t.getObj(),Number.isInteger(a)||"string"==typeof a){const t=Number.isInteger(a)?String.fromCharCode(a):a;e.mapBfRange(n,i,t)}else{if(!(0,r.isCmd)(a,"["))break;{a=t.getObj();const s=[];for(;!(0,r.isCmd)(a,"]")&&a!==r.EOF;)s.push(a),a=t.getObj();e.mapBfRangeToArray(n,i,s)}}}throw new n.FormatError("Invalid bf range.")}function w(e,t){for(;;){let a=t.getObj();if(a===r.EOF)break;if((0,r.isCmd)(a,"endcidchar"))return;p(a);const n=g(a);a=t.getObj(),m(a);const i=a;e.mapOne(n,i)}}function x(e,t){for(;;){let a=t.getObj();if(a===r.EOF)break;if((0,r.isCmd)(a,"endcidrange"))return;p(a);const n=g(a);a=t.getObj(),p(a);const i=g(a);a=t.getObj(),m(a);const s=a;e.mapCidRange(n,i,s)}}function S(e,t){for(;;){let a=t.getObj();if(a===r.EOF)break;if((0,r.isCmd)(a,"endcodespacerange"))return;if("string"!=typeof a)break;const n=g(a);if(a=t.getObj(),"string"!=typeof a)break;const i=g(a);e.addCodespaceRange(a.length,n,i)}throw new n.FormatError("Invalid codespace range.")}function A(e,t){const a=t.getObj();Number.isInteger(a)&&(e.vertical=!!a)}function k(e,t){const a=t.getObj();a instanceof r.Name&&(e.name=a.name)}async function C(e,t,a,i){let s,o;e:for(;;)try{const a=t.getObj();if(a===r.EOF)break;if(a instanceof r.Name)"WMode"===a.name?A(e,t):"CMapName"===a.name&&k(e,t),s=a;else if(a instanceof r.Cmd)switch(a.cmd){case"endcmap":break e;case"usecmap":s instanceof r.Name&&(o=s.name);break;case"begincodespacerange":S(e,t);break;case"beginbfchar":b(e,t);break;case"begincidchar":w(e,t);break;case"beginbfrange":y(e,t);break;case"begincidrange":x(e,t)}}catch(e){if(e instanceof c.MissingDataException)throw e;(0,n.warn)("Invalid cMap data: "+e);continue}return!i&&o&&(i=o),i?v(e,a,i):e}async function v(e,t,a){if(e.useCMap=await F(a,t),0===e.numCodespaceRanges){const t=e.useCMap.codespaceRanges;for(let a=0;a<t.length;a++)e.codespaceRanges[a]=t[a].slice();e.numCodespaceRanges=e.useCMap.numCodespaceRanges}return e.useCMap.forEach((function(t,a){e.contains(t)||e.mapOne(t,e.useCMap.lookup(t))})),e}async function F(e,t){if("Identity-H"===e)return new f(!1,2);if("Identity-V"===e)return new f(!0,2);if(!h.includes(e))throw new Error("Unknown CMap name: "+e);if(!t)throw new Error("Built-in CMap parameters are not provided.");const{cMapData:a,compressionType:r}=await t(e),i=new d(!0);if(r===n.CMapCompressionType.BINARY)return(new s.BinaryCMapReader).process(a,i,(e=>v(i,t,e)));if(r===n.CMapCompressionType.NONE){const e=new o.Lexer(new l.Stream(a));return C(i,e,t,null)}throw new Error(`Invalid CMap "compressionType" value: ${r}`)}t.IdentityCMap=f;t.CMapFactory=class{static async create({encoding:e,fetchBuiltInCMap:t,useCMap:a}){if(e instanceof r.Name)return F(e.name,t);if(e instanceof i.BaseStream){const n=await C(new d,new o.Lexer(e),t,a);return n.isIdentityCMap?F(n.name,t):n}throw new Error("Encoding required.")}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.BinaryCMapReader=void 0;var n=a(2);function r(e,t){let a=0;for(let n=0;n<=t;n++)a=a<<8|e[n];return a>>>0}function i(e,t){return 1===t?String.fromCharCode(e[0],e[1]):3===t?String.fromCharCode(e[0],e[1],e[2],e[3]):String.fromCharCode(...e.subarray(0,t+1))}function s(e,t,a){let n=0;for(let r=a;r>=0;r--)n+=e[r]+t[r],e[r]=255&n,n>>=8}function o(e,t){let a=1;for(let n=t;n>=0&&a>0;n--)a+=e[n],e[n]=255&a,a>>=8}const c=16;class l{constructor(e){this.buffer=e,this.pos=0,this.end=e.length,this.tmpBuf=new Uint8Array(19)}readByte(){return this.pos>=this.end?-1:this.buffer[this.pos++]}readNumber(){let e,t=0;do{const a=this.readByte();if(a<0)throw new n.FormatError("unexpected EOF in bcmap");e=!(128&a),t=t<<7|127&a}while(!e);return t}readSigned(){const e=this.readNumber();return 1&e?~(e>>>1):e>>>1}readHex(e,t){e.set(this.buffer.subarray(this.pos,this.pos+t+1)),this.pos+=t+1}readHexNumber(e,t){let a;const r=this.tmpBuf;let i=0;do{const e=this.readByte();if(e<0)throw new n.FormatError("unexpected EOF in bcmap");a=!(128&e),r[i++]=127&e}while(!a);let s=t,o=0,c=0;for(;s>=0;){for(;c<8&&r.length>0;)o|=r[--i]<<c,c+=7;e[s]=255&o,s--,o>>=8,c-=8}}readHexSigned(e,t){this.readHexNumber(e,t);const a=1&e[t]?255:0;let n=0;for(let r=0;r<=t;r++)n=(1&n)<<8|e[r],e[r]=n>>1^a}readString(){const e=this.readNumber(),t=new Array(e);for(let a=0;a<e;a++)t[a]=this.readNumber();return String.fromCharCode(...t)}}t.BinaryCMapReader=class{async process(e,t,a){const n=new l(e),h=n.readByte();t.vertical=!!(1&h);let u=null;const d=new Uint8Array(c),f=new Uint8Array(c),g=new Uint8Array(c),p=new Uint8Array(c),m=new Uint8Array(c);let b,y;for(;(y=n.readByte())>=0;){const e=y>>5;if(7===e){switch(31&y){case 0:n.readString();break;case 1:u=n.readString()}continue}const a=!!(16&y),l=15&y;if(l+1>c)throw new Error("BinaryCMapReader.process: Invalid dataSize.");const h=1,w=n.readNumber();switch(e){case 0:n.readHex(d,l),n.readHexNumber(f,l),s(f,d,l),t.addCodespaceRange(l+1,r(d,l),r(f,l));for(let e=1;e<w;e++)o(f,l),n.readHexNumber(d,l),s(d,f,l),n.readHexNumber(f,l),s(f,d,l),t.addCodespaceRange(l+1,r(d,l),r(f,l));break;case 1:n.readHex(d,l),n.readHexNumber(f,l),s(f,d,l),n.readNumber();for(let e=1;e<w;e++)o(f,l),n.readHexNumber(d,l),s(d,f,l),n.readHexNumber(f,l),s(f,d,l),n.readNumber();break;case 2:n.readHex(g,l),b=n.readNumber(),t.mapOne(r(g,l),b);for(let e=1;e<w;e++)o(g,l),a||(n.readHexNumber(m,l),s(g,m,l)),b=n.readSigned()+(b+1),t.mapOne(r(g,l),b);break;case 3:n.readHex(d,l),n.readHexNumber(f,l),s(f,d,l),b=n.readNumber(),t.mapCidRange(r(d,l),r(f,l),b);for(let e=1;e<w;e++)o(f,l),a?d.set(f):(n.readHexNumber(d,l),s(d,f,l)),n.readHexNumber(f,l),s(f,d,l),b=n.readNumber(),t.mapCidRange(r(d,l),r(f,l),b);break;case 4:n.readHex(g,h),n.readHex(p,l),t.mapOne(r(g,h),i(p,l));for(let e=1;e<w;e++)o(g,h),a||(n.readHexNumber(m,h),s(g,m,h)),o(p,l),n.readHexSigned(m,l),s(p,m,l),t.mapOne(r(g,h),i(p,l));break;case 5:n.readHex(d,h),n.readHexNumber(f,h),s(f,d,h),n.readHex(p,l),t.mapBfRange(r(d,h),r(f,h),i(p,l));for(let e=1;e<w;e++)o(f,h),a?d.set(f):(n.readHexNumber(d,h),s(d,f,h)),n.readHexNumber(f,h),s(f,d,h),n.readHex(p,l),t.mapBfRange(r(d,h),r(f,h),i(p,l));break;default:throw new Error(`BinaryCMapReader.process - unknown type: ${e}`)}}return u?a(u):t}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Parser=t.Linearization=t.Lexer=void 0;var n=a(2),r=a(4),i=a(3),s=a(8),o=a(17),c=a(19),l=a(20),h=a(22),u=a(23),d=a(26),f=a(29),g=a(31),p=a(32),m=a(33);class b{constructor({lexer:e,xref:t,allowStreams:a=!1,recoveryMode:n=!1}){this.lexer=e,this.xref=t,this.allowStreams=a,this.recoveryMode=n,this.imageCache=Object.create(null),this._imageId=0,this.refill()}refill(){this.buf1=this.lexer.getObj(),this.buf2=this.lexer.getObj()}shift(){this.buf2 instanceof r.Cmd&&"ID"===this.buf2.cmd?(this.buf1=this.buf2,this.buf2=null):(this.buf1=this.buf2,this.buf2=this.lexer.getObj())}tryShift(){try{return this.shift(),!0}catch(e){if(e instanceof i.MissingDataException)throw e;return!1}}getObj(e=null){const t=this.buf1;if(this.shift(),t instanceof r.Cmd)switch(t.cmd){case"BI":return this.makeInlineImage(e);case"[":const a=[];for(;!(0,r.isCmd)(this.buf1,"]")&&this.buf1!==r.EOF;)a.push(this.getObj(e));if(this.buf1===r.EOF){if(this.recoveryMode)return a;throw new i.ParserEOFException("End of file inside array.")}return this.shift(),a;case"<<":const s=new r.Dict(this.xref);for(;!(0,r.isCmd)(this.buf1,">>")&&this.buf1!==r.EOF;){if(!(this.buf1 instanceof r.Name)){(0,n.info)("Malformed dictionary: key must be a name object"),this.shift();continue}const t=this.buf1.name;if(this.shift(),this.buf1===r.EOF)break;s.set(t,this.getObj(e))}if(this.buf1===r.EOF){if(this.recoveryMode)return s;throw new i.ParserEOFException("End of file inside dictionary.")}return(0,r.isCmd)(this.buf2,"stream")?this.allowStreams?this.makeStream(s,e):s:(this.shift(),s);default:return t}if(Number.isInteger(t)){if(Number.isInteger(this.buf1)&&(0,r.isCmd)(this.buf2,"R")){const e=r.Ref.get(t,this.buf1);return this.shift(),this.shift(),e}return t}return"string"==typeof t&&e?e.decryptString(t):t}findDefaultInlineStreamEnd(e){const{knownCommands:t}=this.lexer,a=e.pos;let o,c,l=0;for(;-1!==(o=e.getByte());)if(0===l)l=69===o?1:0;else if(1===l)l=73===o?2:0;else if(32===o||10===o||13===o){c=e.pos;const a=e.peekBytes(15),i=a.length;if(0===i)break;for(let e=0;e<i;e++)if(o=a[e],(0!==o||0===a[e+1])&&10!==o&&13!==o&&(o<32||o>127)){l=0;break}if(2!==l)continue;if(!t){(0,n.warn)("findDefaultInlineStreamEnd - `lexer.knownCommands` is undefined.");continue}const h=new x(new s.Stream(a.slice()),t);h._hexStringWarn=()=>{};let u=0;for(;;){const e=h.getObj();if(e===r.EOF){l=0;break}if(e instanceof r.Cmd){const a=t[e.cmd];if(!a){l=0;break}if(a.variableArgs?u<=a.numArgs:u===a.numArgs)break;u=0}else u++}if(2===l)break}else l=0;-1===o&&((0,n.warn)("findDefaultInlineStreamEnd: Reached the end of the stream without finding a valid EI marker"),c&&((0,n.warn)('... trying to recover by using the last "EI" occurrence.'),e.skip(-(e.pos-c))));let h=4;return e.skip(-h),o=e.peekByte(),e.skip(h),(0,i.isWhiteSpace)(o)||h--,e.pos-h-a}findDCTDecodeInlineStreamEnd(e){const t=e.pos;let a,r,i=!1;for(;-1!==(a=e.getByte());)if(255===a){switch(e.getByte()){case 0:break;case 255:e.skip(-1);break;case 217:i=!0;break;case 192:case 193:case 194:case 195:case 197:case 198:case 199:case 201:case 202:case 203:case 205:case 206:case 207:case 196:case 204:case 218:case 219:case 220:case 221:case 222:case 223:case 224:case 225:case 226:case 227:case 228:case 229:case 230:case 231:case 232:case 233:case 234:case 235:case 236:case 237:case 238:case 239:case 254:r=e.getUint16(),r>2?e.skip(r-2):e.skip(-2)}if(i)break}const s=e.pos-t;return-1===a?((0,n.warn)("Inline DCTDecode image stream: EOI marker not found, searching for /EI/ instead."),e.skip(-s),this.findDefaultInlineStreamEnd(e)):(this.inlineStreamSkipEI(e),s)}findASCII85DecodeInlineStreamEnd(e){const t=e.pos;let a;for(;-1!==(a=e.getByte());)if(126===a){const t=e.pos;for(a=e.peekByte();(0,i.isWhiteSpace)(a);)e.skip(),a=e.peekByte();if(62===a){e.skip();break}if(e.pos>t){const t=e.peekBytes(2);if(69===t[0]&&73===t[1])break}}const r=e.pos-t;return-1===a?((0,n.warn)("Inline ASCII85Decode image stream: EOD marker not found, searching for /EI/ instead."),e.skip(-r),this.findDefaultInlineStreamEnd(e)):(this.inlineStreamSkipEI(e),r)}findASCIIHexDecodeInlineStreamEnd(e){const t=e.pos;let a;for(;-1!==(a=e.getByte())&&62!==a;);const r=e.pos-t;return-1===a?((0,n.warn)("Inline ASCIIHexDecode image stream: EOD marker not found, searching for /EI/ instead."),e.skip(-r),this.findDefaultInlineStreamEnd(e)):(this.inlineStreamSkipEI(e),r)}inlineStreamSkipEI(e){let t,a=0;for(;-1!==(t=e.getByte());)if(0===a)a=69===t?1:0;else if(1===a)a=73===t?2:0;else if(2===a)break}makeInlineImage(e){const t=this.lexer,a=t.stream,i=Object.create(null);let s;for(;!(0,r.isCmd)(this.buf1,"ID")&&this.buf1!==r.EOF;){if(!(this.buf1 instanceof r.Name))throw new n.FormatError("Dictionary key must be a name object");const t=this.buf1.name;if(this.shift(),this.buf1===r.EOF)break;i[t]=this.getObj(e)}-1!==t.beginInlineImagePos&&(s=a.pos-t.beginInlineImagePos);const o=this.xref.fetchIfRef(i.F||i.Filter);let c;if(o instanceof r.Name)c=o.name;else if(Array.isArray(o)){const e=this.xref.fetchIfRef(o[0]);e instanceof r.Name&&(c=e.name)}const l=a.pos;let h,u;switch(c){case"DCT":case"DCTDecode":h=this.findDCTDecodeInlineStreamEnd(a);break;case"A85":case"ASCII85Decode":h=this.findASCII85DecodeInlineStreamEnd(a);break;case"AHx":case"ASCIIHexDecode":h=this.findASCIIHexDecodeInlineStreamEnd(a);break;default:h=this.findDefaultInlineStreamEnd(a)}if(h<1e3&&s>0){const e=a.pos;a.pos=t.beginInlineImagePos,u=function(e){const t=[],a=e.length;let n=0;for(;n<a-1;)t.push(e[n++]<<8|e[n++]);return n<a&&t.push(e[n]),a+"_"+String.fromCharCode.apply(null,t)}(a.getBytes(s+h)),a.pos=e;const n=this.imageCache[u];if(void 0!==n)return this.buf2=r.Cmd.get("EI"),this.shift(),n.reset(),n}const d=new r.Dict(this.xref);for(const e in i)d.set(e,i[e]);let f=a.makeSubStream(l,h,d);return e&&(f=e.createStream(f,h)),f=this.filter(f,d,h),f.dict=d,void 0!==u&&(f.cacheKey="inline_img_"+ ++this._imageId,this.imageCache[u]=f),this.buf2=r.Cmd.get("EI"),this.shift(),f}_findStreamLength(e,t){const{stream:a}=this.lexer;a.pos=e;const n=t.length;for(;a.pos<a.end;){const r=a.peekBytes(2048),i=r.length-n;if(i<=0)break;let s=0;for(;s<i;){let i=0;for(;i<n&&r[s+i]===t[i];)i++;if(i>=n)return a.pos+=s,a.pos-e;s++}a.pos+=i}return-1}makeStream(e,t){const a=this.lexer;let s=a.stream;a.skipToNextLine();const o=s.pos-1;let c=e.get("Length");if(Number.isInteger(c)||((0,n.info)(`Bad length "${c&&c.toString()}" in stream.`),c=0),s.pos=o+c,a.nextChar(),this.tryShift()&&(0,r.isCmd)(this.buf2,"endstream"))this.shift();else{const e=new Uint8Array([101,110,100,115,116,114,101,97,109]);let t=this._findStreamLength(o,e);if(t<0){const a=1;for(let r=1;r<=a;r++){const a=e.length-r,c=e.slice(0,a),l=this._findStreamLength(o,c);if(l>=0){const e=s.peekBytes(a+1)[a];if(!(0,i.isWhiteSpace)(e))break;(0,n.info)(`Found "${(0,n.bytesToString)(c)}" when searching for endstream command.`),t=l;break}}if(t<0)throw new n.FormatError("Missing endstream command.")}c=t,a.nextChar(),this.shift(),this.shift()}return this.shift(),s=s.makeSubStream(o,c,e),t&&(s=t.createStream(s,c)),s=this.filter(s,e,c),s.dict=e,s}filter(e,t,a){let i=t.get("F","Filter"),s=t.get("DP","DecodeParms");if(i instanceof r.Name)return Array.isArray(s)&&(0,n.warn)("/DecodeParms should not be an Array, when /Filter is a Name."),this.makeFilter(e,i.name,a,s);let o=a;if(Array.isArray(i)){const t=i,a=s;for(let c=0,l=t.length;c<l;++c){if(i=this.xref.fetchIfRef(t[c]),!(i instanceof r.Name))throw new n.FormatError(`Bad filter name "${i}"`);s=null,Array.isArray(a)&&c in a&&(s=this.xref.fetchIfRef(a[c])),e=this.makeFilter(e,i.name,o,s),o=null}}return e}makeFilter(e,t,a,r){if(0===a)return(0,n.warn)(`Empty "${t}" stream.`),new s.NullStream;try{switch(t){case"Fl":case"FlateDecode":return r?new p.PredictorStream(new h.FlateStream(e,a),a,r):new h.FlateStream(e,a);case"LZW":case"LZWDecode":let t=1;return r?(r.has("EarlyChange")&&(t=r.get("EarlyChange")),new p.PredictorStream(new g.LZWStream(e,a,t),a,r)):new g.LZWStream(e,a,t);case"DCT":case"DCTDecode":return new d.JpegStream(e,a,r);case"JPX":case"JPXDecode":return new f.JpxStream(e,a,r);case"A85":case"ASCII85Decode":return new o.Ascii85Stream(e,a);case"AHx":case"ASCIIHexDecode":return new c.AsciiHexStream(e,a);case"CCF":case"CCITTFaxDecode":return new l.CCITTFaxStream(e,a,r);case"RL":case"RunLengthDecode":return new m.RunLengthStream(e,a);case"JBIG2Decode":return new u.Jbig2Stream(e,a,r)}return(0,n.warn)(`Filter "${t}" is not supported.`),e}catch(e){if(e instanceof i.MissingDataException)throw e;return(0,n.warn)(`Invalid stream: "${e}"`),new s.NullStream}}}t.Parser=b;const y=[1,0,0,0,0,0,0,0,0,1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,2,0,0,2,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];function w(e){return e>=48&&e<=57?15&e:e>=65&&e<=70||e>=97&&e<=102?9+(15&e):-1}class x{constructor(e,t=null){this.stream=e,this.nextChar(),this.strBuf=[],this.knownCommands=t,this._hexStringNumWarn=0,this.beginInlineImagePos=-1}nextChar(){return this.currentChar=this.stream.getByte()}peekChar(){return this.stream.peekByte()}getNumber(){let e=this.currentChar,t=!1,a=0,r=1;if(45===e?(r=-1,e=this.nextChar(),45===e&&(e=this.nextChar())):43===e&&(e=this.nextChar()),10===e||13===e)do{e=this.nextChar()}while(10===e||13===e);if(46===e&&(a=10,e=this.nextChar()),e<48||e>57){const t=`Invalid number: ${String.fromCharCode(e)} (charCode ${e})`;if((0,i.isWhiteSpace)(e)||-1===e)return(0,n.info)(`Lexer.getNumber - "${t}".`),0;throw new n.FormatError(t)}let s=e-48,o=0,c=1;for(;(e=this.nextChar())>=0;)if(e>=48&&e<=57){const n=e-48;t?o=10*o+n:(0!==a&&(a*=10),s=10*s+n)}else if(46===e){if(0!==a)break;a=1}else if(45===e)(0,n.warn)("Badly formatted number: minus sign in the middle");else{if(69!==e&&101!==e)break;if(e=this.peekChar(),43===e||45===e)c=45===e?-1:1,this.nextChar();else if(e<48||e>57)break;t=!0}return 0!==a&&(s/=a),t&&(s*=10**(c*o)),r*s}getString(){let e=1,t=!1;const a=this.strBuf;a.length=0;let r=this.nextChar();for(;;){let i=!1;switch(0|r){case-1:(0,n.warn)("Unterminated string"),t=!0;break;case 40:++e,a.push("(");break;case 41:0==--e?(this.nextChar(),t=!0):a.push(")");break;case 92:switch(r=this.nextChar(),r){case-1:(0,n.warn)("Unterminated string"),t=!0;break;case 110:a.push("\n");break;case 114:a.push("\r");break;case 116:a.push("\t");break;case 98:a.push("\b");break;case 102:a.push("\f");break;case 92:case 40:case 41:a.push(String.fromCharCode(r));break;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:let e=15&r;r=this.nextChar(),i=!0,r>=48&&r<=55&&(e=(e<<3)+(15&r),r=this.nextChar(),r>=48&&r<=55&&(i=!1,e=(e<<3)+(15&r))),a.push(String.fromCharCode(e));break;case 13:10===this.peekChar()&&this.nextChar();break;case 10:break;default:a.push(String.fromCharCode(r))}break;default:a.push(String.fromCharCode(r))}if(t)break;i||(r=this.nextChar())}return a.join("")}getName(){let e,t;const a=this.strBuf;for(a.length=0;(e=this.nextChar())>=0&&!y[e];)if(35===e){if(e=this.nextChar(),y[e]){(0,n.warn)("Lexer_getName: NUMBER SIGN (#) should be followed by a hexadecimal number."),a.push("#");break}const r=w(e);if(-1!==r){t=e,e=this.nextChar();const i=w(e);if(-1===i){if((0,n.warn)(`Lexer_getName: Illegal digit (${String.fromCharCode(e)}) in hexadecimal number.`),a.push("#",String.fromCharCode(t)),y[e])break;a.push(String.fromCharCode(e));continue}a.push(String.fromCharCode(r<<4|i))}else a.push("#",String.fromCharCode(e))}else a.push(String.fromCharCode(e));return a.length>127&&(0,n.warn)(`Name token is longer than allowed by the spec: ${a.length}`),r.Name.get(a.join(""))}_hexStringWarn(e){5!=this._hexStringNumWarn++?this._hexStringNumWarn>5||(0,n.warn)(`getHexString - ignoring invalid character: ${e}`):(0,n.warn)("getHexString - ignoring additional invalid characters.")}getHexString(){const e=this.strBuf;e.length=0;let t,a,r=this.currentChar,i=!0;for(this._hexStringNumWarn=0;;){if(r<0){(0,n.warn)("Unterminated hex string");break}if(62===r){this.nextChar();break}if(1!==y[r]){if(i){if(t=w(r),-1===t){this._hexStringWarn(r),r=this.nextChar();continue}}else{if(a=w(r),-1===a){this._hexStringWarn(r),r=this.nextChar();continue}e.push(String.fromCharCode(t<<4|a))}i=!i,r=this.nextChar()}else r=this.nextChar()}return e.join("")}getObj(){let e=!1,t=this.currentChar;for(;;){if(t<0)return r.EOF;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(1!==y[t])break;t=this.nextChar()}switch(0|t){case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:case 43:case 45:case 46:return this.getNumber();case 40:return this.getString();case 47:return this.getName();case 91:return this.nextChar(),r.Cmd.get("[");case 93:return this.nextChar(),r.Cmd.get("]");case 60:return t=this.nextChar(),60===t?(this.nextChar(),r.Cmd.get("<<")):this.getHexString();case 62:return t=this.nextChar(),62===t?(this.nextChar(),r.Cmd.get(">>")):r.Cmd.get(">");case 123:return this.nextChar(),r.Cmd.get("{");case 125:return this.nextChar(),r.Cmd.get("}");case 41:throw this.nextChar(),new n.FormatError(`Illegal character: ${t}`)}let a=String.fromCharCode(t);if(t<32||t>127){const e=this.peekChar();if(e>=32&&e<=127)return this.nextChar(),r.Cmd.get(a)}const i=this.knownCommands;let s=void 0!==i?.[a];for(;(t=this.nextChar())>=0&&!y[t];){const e=a+String.fromCharCode(t);if(s&&void 0===i[e])break;if(128===a.length)throw new n.FormatError(`Command token too long: ${a.length}`);a=e,s=void 0!==i?.[a]}return"true"===a||"false"!==a&&("null"===a?null:("BI"===a&&(this.beginInlineImagePos=this.stream.pos),r.Cmd.get(a)))}skipToNextLine(){let e=this.currentChar;for(;e>=0;){if(13===e){e=this.nextChar(),10===e&&this.nextChar();break}if(10===e){this.nextChar();break}e=this.nextChar()}}}t.Lexer=x;t.Linearization=class{static create(e){function t(e,t,a=!1){const n=e.get(t);if(Number.isInteger(n)&&(a?n>=0:n>0))return n;throw new Error(`The "${t}" parameter in the linearization dictionary is invalid.`)}const a=new b({lexer:new x(e),xref:null}),n=a.getObj(),i=a.getObj(),s=a.getObj(),o=a.getObj();let c,l;if(!(Number.isInteger(n)&&Number.isInteger(i)&&(0,r.isCmd)(s,"obj")&&o instanceof r.Dict&&"number"==typeof(c=o.get("Linearized"))&&c>0))return null;if((l=t(o,"L"))!==e.length)throw new Error('The "L" parameter in the linearization dictionary does not equal the stream length.');return{length:l,hints:function(e){const t=e.get("H");let a;if(Array.isArray(t)&&(2===(a=t.length)||4===a)){for(let e=0;e<a;e++){const a=t[e];if(!(Number.isInteger(a)&&a>0))throw new Error(`Hint (${e}) in the linearization dictionary is invalid.`)}return t}throw new Error("Hint array in the linearization dictionary is invalid.")}(o),objectNumberFirst:t(o,"O"),endFirst:t(o,"E"),numPages:t(o,"N"),mainXRefEntriesOffset:t(o,"T"),pageFirst:o.has("P")?t(o,"P",!0):0}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Ascii85Stream=void 0;var n=a(18),r=a(3);class i extends n.DecodeStream{constructor(e,t){t&&(t*=.8),super(t),this.str=e,this.dict=e.dict,this.input=new Uint8Array(5)}readBlock(){const e=this.str;let t=e.getByte();for(;(0,r.isWhiteSpace)(t);)t=e.getByte();if(-1===t||126===t)return void(this.eof=!0);const a=this.bufferLength;let n,i;if(122===t){for(n=this.ensureBuffer(a+4),i=0;i<4;++i)n[a+i]=0;this.bufferLength+=4}else{const s=this.input;for(s[0]=t,i=1;i<5;++i){for(t=e.getByte();(0,r.isWhiteSpace)(t);)t=e.getByte();if(s[i]=t,-1===t||126===t)break}if(n=this.ensureBuffer(a+i-1),this.bufferLength+=i-1,i<5){for(;i<5;++i)s[i]=117;this.eof=!0}let o=0;for(i=0;i<5;++i)o=85*o+(s[i]-33);for(i=3;i>=0;--i)n[a+i]=255&o,o>>=8}}}t.Ascii85Stream=i},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.StreamsSequenceStream=t.DecodeStream=void 0;var n=a(5),r=a(8);const i=new Uint8Array(0);class s extends n.BaseStream{constructor(e){if(super(),this._rawMinBufferLength=e||0,this.pos=0,this.bufferLength=0,this.eof=!1,this.buffer=i,this.minBufferLength=512,e)for(;this.minBufferLength<e;)this.minBufferLength*=2}get isEmpty(){for(;!this.eof&&0===this.bufferLength;)this.readBlock();return 0===this.bufferLength}ensureBuffer(e){const t=this.buffer;if(e<=t.byteLength)return t;let a=this.minBufferLength;for(;a<e;)a*=2;const n=new Uint8Array(a);return n.set(t),this.buffer=n}getByte(){const e=this.pos;for(;this.bufferLength<=e;){if(this.eof)return-1;this.readBlock()}return this.buffer[this.pos++]}getBytes(e){const t=this.pos;let a;if(e){for(this.ensureBuffer(t+e),a=t+e;!this.eof&&this.bufferLength<a;)this.readBlock();const n=this.bufferLength;a>n&&(a=n)}else{for(;!this.eof;)this.readBlock();a=this.bufferLength}return this.pos=a,this.buffer.subarray(t,a)}reset(){this.pos=0}makeSubStream(e,t,a=null){if(void 0===t)for(;!this.eof;)this.readBlock();else{const a=e+t;for(;this.bufferLength<=a&&!this.eof;)this.readBlock()}return new r.Stream(this.buffer,e,t,a)}getBaseStreams(){return this.str?this.str.getBaseStreams():null}}t.DecodeStream=s;t.StreamsSequenceStream=class extends s{constructor(e,t=null){let a=0;for(const t of e)a+=t instanceof s?t._rawMinBufferLength:t.length;super(a),this.streams=e,this._onError=t}readBlock(){const e=this.streams;if(0===e.length)return void(this.eof=!0);const t=e.shift();let a;try{a=t.getBytes()}catch(e){if(this._onError)return void this._onError(e,t.dict?.objId);throw e}const n=this.bufferLength,r=n+a.length;this.ensureBuffer(r).set(a,n),this.bufferLength=r}getBaseStreams(){const e=[];for(const t of this.streams){const a=t.getBaseStreams();a&&e.push(...a)}return e.length>0?e:null}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.AsciiHexStream=void 0;var n=a(18);class r extends n.DecodeStream{constructor(e,t){t&&(t*=.5),super(t),this.str=e,this.dict=e.dict,this.firstDigit=-1}readBlock(){const e=this.str.getBytes(8e3);if(!e.length)return void(this.eof=!0);const t=e.length+1>>1,a=this.ensureBuffer(this.bufferLength+t);let n=this.bufferLength,r=this.firstDigit;for(const t of e){let e;if(t>=48&&t<=57)e=15&t;else{if(!(t>=65&&t<=70||t>=97&&t<=102)){if(62===t){this.eof=!0;break}continue}e=9+(15&t)}r<0?r=e:(a[n++]=r<<4|e,r=-1)}r>=0&&this.eof&&(a[n++]=r<<4,r=-1),this.firstDigit=r,this.bufferLength=n}}t.AsciiHexStream=r},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CCITTFaxStream=void 0;var n=a(21),r=a(18),i=a(4);class s extends r.DecodeStream{constructor(e,t,a){super(t),this.str=e,this.dict=e.dict,a instanceof i.Dict||(a=i.Dict.empty);const r={next:()=>e.getByte()};this.ccittFaxDecoder=new n.CCITTFaxDecoder(r,{K:a.get("K"),EndOfLine:a.get("EndOfLine"),EncodedByteAlign:a.get("EncodedByteAlign"),Columns:a.get("Columns"),Rows:a.get("Rows"),EndOfBlock:a.get("EndOfBlock"),BlackIs1:a.get("BlackIs1")})}readBlock(){for(;!this.eof;){const e=this.ccittFaxDecoder.readNextChar();if(-1===e)return void(this.eof=!0);this.ensureBuffer(this.bufferLength+1),this.buffer[this.bufferLength++]=e}}}t.CCITTFaxStream=s},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CCITTFaxDecoder=void 0;var n=a(2);const r=-1,i=[[-1,-1],[-1,-1],[7,8],[7,7],[6,6],[6,6],[6,5],[6,5],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[4,0],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[3,3],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2],[1,2]],s=[[-1,-1],[12,-2],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[11,1792],[11,1792],[12,1984],[12,2048],[12,2112],[12,2176],[12,2240],[12,2304],[11,1856],[11,1856],[11,1920],[11,1920],[12,2368],[12,2432],[12,2496],[12,2560]],o=[[-1,-1],[-1,-1],[-1,-1],[-1,-1],[8,29],[8,29],[8,30],[8,30],[8,45],[8,45],[8,46],[8,46],[7,22],[7,22],[7,22],[7,22],[7,23],[7,23],[7,23],[7,23],[8,47],[8,47],[8,48],[8,48],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[6,13],[7,20],[7,20],[7,20],[7,20],[8,33],[8,33],[8,34],[8,34],[8,35],[8,35],[8,36],[8,36],[8,37],[8,37],[8,38],[8,38],[7,19],[7,19],[7,19],[7,19],[8,31],[8,31],[8,32],[8,32],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,1],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[6,12],[8,53],[8,53],[8,54],[8,54],[7,26],[7,26],[7,26],[7,26],[8,39],[8,39],[8,40],[8,40],[8,41],[8,41],[8,42],[8,42],[8,43],[8,43],[8,44],[8,44],[7,21],[7,21],[7,21],[7,21],[7,28],[7,28],[7,28],[7,28],[8,61],[8,61],[8,62],[8,62],[8,63],[8,63],[8,0],[8,0],[8,320],[8,320],[8,384],[8,384],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,10],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[5,11],[7,27],[7,27],[7,27],[7,27],[8,59],[8,59],[8,60],[8,60],[9,1472],[9,1536],[9,1600],[9,1728],[7,18],[7,18],[7,18],[7,18],[7,24],[7,24],[7,24],[7,24],[8,49],[8,49],[8,50],[8,50],[8,51],[8,51],[8,52],[8,52],[7,25],[7,25],[7,25],[7,25],[8,55],[8,55],[8,56],[8,56],[8,57],[8,57],[8,58],[8,58],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,192],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[6,1664],[8,448],[8,448],[8,512],[8,512],[9,704],[9,768],[8,640],[8,640],[8,576],[8,576],[9,832],[9,896],[9,960],[9,1024],[9,1088],[9,1152],[9,1216],[9,1280],[9,1344],[9,1408],[7,256],[7,256],[7,256],[7,256],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,2],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[4,3],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,128],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,8],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[5,9],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,16],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[6,17],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,4],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[4,5],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,14],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[6,15],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[5,64],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,6],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7],[4,7]],c=[[-1,-1],[-1,-1],[12,-2],[12,-2],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[-1,-1],[11,1792],[11,1792],[11,1792],[11,1792],[12,1984],[12,1984],[12,2048],[12,2048],[12,2112],[12,2112],[12,2176],[12,2176],[12,2240],[12,2240],[12,2304],[12,2304],[11,1856],[11,1856],[11,1856],[11,1856],[11,1920],[11,1920],[11,1920],[11,1920],[12,2368],[12,2368],[12,2432],[12,2432],[12,2496],[12,2496],[12,2560],[12,2560],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[10,18],[12,52],[12,52],[13,640],[13,704],[13,768],[13,832],[12,55],[12,55],[12,56],[12,56],[13,1280],[13,1344],[13,1408],[13,1472],[12,59],[12,59],[12,60],[12,60],[13,1536],[13,1600],[11,24],[11,24],[11,24],[11,24],[11,25],[11,25],[11,25],[11,25],[13,1664],[13,1728],[12,320],[12,320],[12,384],[12,384],[12,448],[12,448],[13,512],[13,576],[12,53],[12,53],[12,54],[12,54],[13,896],[13,960],[13,1024],[13,1088],[13,1152],[13,1216],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64],[10,64]],l=[[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[8,13],[11,23],[11,23],[12,50],[12,51],[12,44],[12,45],[12,46],[12,47],[12,57],[12,58],[12,61],[12,256],[10,16],[10,16],[10,16],[10,16],[10,17],[10,17],[10,17],[10,17],[12,48],[12,49],[12,62],[12,63],[12,30],[12,31],[12,32],[12,33],[12,40],[12,41],[11,22],[11,22],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[8,14],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,10],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[7,11],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[9,15],[12,128],[12,192],[12,26],[12,27],[12,28],[12,29],[11,19],[11,19],[11,20],[11,20],[12,34],[12,35],[12,36],[12,37],[12,38],[12,39],[11,21],[11,21],[12,42],[12,43],[10,0],[10,0],[10,0],[10,0],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12],[7,12]],h=[[-1,-1],[-1,-1],[-1,-1],[-1,-1],[6,9],[6,8],[5,7],[5,7],[4,6],[4,6],[4,6],[4,6],[4,5],[4,5],[4,5],[4,5],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,1],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[3,4],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,3],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2],[2,2]];t.CCITTFaxDecoder=class{constructor(e,t={}){if(!e||"function"!=typeof e.next)throw new Error('CCITTFaxDecoder - invalid "source" parameter.');let a;for(this.source=e,this.eof=!1,this.encoding=t.K||0,this.eoline=t.EndOfLine||!1,this.byteAlign=t.EncodedByteAlign||!1,this.columns=t.Columns||1728,this.rows=t.Rows||0,this.eoblock=t.EndOfBlock??!0,this.black=t.BlackIs1||!1,this.codingLine=new Uint32Array(this.columns+1),this.refLine=new Uint32Array(this.columns+2),this.codingLine[0]=this.columns,this.codingPos=0,this.row=0,this.nextLine2D=this.encoding<0,this.inputBits=0,this.inputBuf=0,this.outputBits=0,this.rowsDone=!1;0===(a=this._lookBits(12));)this._eatBits(1);1===a&&this._eatBits(12),this.encoding>0&&(this.nextLine2D=!this._lookBits(1),this._eatBits(1))}readNextChar(){if(this.eof)return-1;const e=this.refLine,t=this.codingLine,a=this.columns;let i,s,o,c,l;if(0===this.outputBits){if(this.rowsDone&&(this.eof=!0),this.eof)return-1;let o,l,h;if(this.err=!1,this.nextLine2D){for(c=0;t[c]<a;++c)e[c]=t[c];for(e[c++]=a,e[c]=a,t[0]=0,this.codingPos=0,i=0,s=0;t[this.codingPos]<a;)switch(o=this._getTwoDimCode(),o){case 0:this._addPixels(e[i+1],s),e[i+1]<a&&(i+=2);break;case 1:if(o=l=0,s){do{o+=h=this._getBlackCode()}while(h>=64);do{l+=h=this._getWhiteCode()}while(h>=64)}else{do{o+=h=this._getWhiteCode()}while(h>=64);do{l+=h=this._getBlackCode()}while(h>=64)}for(this._addPixels(t[this.codingPos]+o,s),t[this.codingPos]<a&&this._addPixels(t[this.codingPos]+l,1^s);e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 7:if(this._addPixels(e[i]+3,s),s^=1,t[this.codingPos]<a)for(++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 5:if(this._addPixels(e[i]+2,s),s^=1,t[this.codingPos]<a)for(++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 3:if(this._addPixels(e[i]+1,s),s^=1,t[this.codingPos]<a)for(++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 2:if(this._addPixels(e[i],s),s^=1,t[this.codingPos]<a)for(++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 8:if(this._addPixelsNeg(e[i]-3,s),s^=1,t[this.codingPos]<a)for(i>0?--i:++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 6:if(this._addPixelsNeg(e[i]-2,s),s^=1,t[this.codingPos]<a)for(i>0?--i:++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case 4:if(this._addPixelsNeg(e[i]-1,s),s^=1,t[this.codingPos]<a)for(i>0?--i:++i;e[i]<=t[this.codingPos]&&e[i]<a;)i+=2;break;case r:this._addPixels(a,0),this.eof=!0;break;default:(0,n.info)("bad 2d code"),this._addPixels(a,0),this.err=!0}}else for(t[0]=0,this.codingPos=0,s=0;t[this.codingPos]<a;){if(o=0,s)do{o+=h=this._getBlackCode()}while(h>=64);else do{o+=h=this._getWhiteCode()}while(h>=64);this._addPixels(t[this.codingPos]+o,s),s^=1}let u=!1;if(this.byteAlign&&(this.inputBits&=-8),this.eoblock||this.row!==this.rows-1){if(o=this._lookBits(12),this.eoline)for(;o!==r&&1!==o;)this._eatBits(1),o=this._lookBits(12);else for(;0===o;)this._eatBits(1),o=this._lookBits(12);1===o?(this._eatBits(12),u=!0):o===r&&(this.eof=!0)}else this.rowsDone=!0;if(!this.eof&&this.encoding>0&&!this.rowsDone&&(this.nextLine2D=!this._lookBits(1),this._eatBits(1)),this.eoblock&&u&&this.byteAlign){if(o=this._lookBits(12),1===o){if(this._eatBits(12),this.encoding>0&&(this._lookBits(1),this._eatBits(1)),this.encoding>=0)for(c=0;c<4;++c)o=this._lookBits(12),1!==o&&(0,n.info)("bad rtc code: "+o),this._eatBits(12),this.encoding>0&&(this._lookBits(1),this._eatBits(1));this.eof=!0}}else if(this.err&&this.eoline){for(;;){if(o=this._lookBits(13),o===r)return this.eof=!0,-1;if(o>>1==1)break;this._eatBits(1)}this._eatBits(12),this.encoding>0&&(this._eatBits(1),this.nextLine2D=!(1&o))}this.outputBits=t[0]>0?t[this.codingPos=0]:t[this.codingPos=1],this.row++}if(this.outputBits>=8)l=1&this.codingPos?0:255,this.outputBits-=8,0===this.outputBits&&t[this.codingPos]<a&&(this.codingPos++,this.outputBits=t[this.codingPos]-t[this.codingPos-1]);else{o=8,l=0;do{if("number"!=typeof this.outputBits)throw new n.FormatError('Invalid /CCITTFaxDecode data, "outputBits" must be a number.');this.outputBits>o?(l<<=o,1&this.codingPos||(l|=255>>8-o),this.outputBits-=o,o=0):(l<<=this.outputBits,1&this.codingPos||(l|=255>>8-this.outputBits),o-=this.outputBits,this.outputBits=0,t[this.codingPos]<a?(this.codingPos++,this.outputBits=t[this.codingPos]-t[this.codingPos-1]):o>0&&(l<<=o,o=0))}while(o)}return this.black&&(l^=255),l}_addPixels(e,t){const a=this.codingLine;let r=this.codingPos;e>a[r]&&(e>this.columns&&((0,n.info)("row is wrong length"),this.err=!0,e=this.columns),1&r^t&&++r,a[r]=e),this.codingPos=r}_addPixelsNeg(e,t){const a=this.codingLine;let r=this.codingPos;if(e>a[r])e>this.columns&&((0,n.info)("row is wrong length"),this.err=!0,e=this.columns),1&r^t&&++r,a[r]=e;else if(e<a[r]){for(e<0&&((0,n.info)("invalid code"),this.err=!0,e=0);r>0&&e<a[r-1];)--r;a[r]=e}this.codingPos=r}_findTableCode(e,t,a,n){const i=n||0;for(let n=e;n<=t;++n){let e=this._lookBits(n);if(e===r)return[!0,1,!1];if(n<t&&(e<<=t-n),!i||e>=i){const t=a[e-i];if(t[0]===n)return this._eatBits(n),[!0,t[1],!0]}}return[!1,0,!1]}_getTwoDimCode(){let e,t=0;if(this.eoblock){if(t=this._lookBits(7),e=i[t],e?.[0]>0)return this._eatBits(e[0]),e[1]}else{const e=this._findTableCode(1,7,i);if(e[0]&&e[2])return e[1]}return(0,n.info)("Bad two dim code"),r}_getWhiteCode(){let e,t=0;if(this.eoblock){if(t=this._lookBits(12),t===r)return 1;if(e=t>>5==0?s[t]:o[t>>3],e[0]>0)return this._eatBits(e[0]),e[1]}else{let e=this._findTableCode(1,9,o);if(e[0])return e[1];if(e=this._findTableCode(11,12,s),e[0])return e[1]}return(0,n.info)("bad white code"),this._eatBits(1),1}_getBlackCode(){let e,t;if(this.eoblock){if(e=this._lookBits(13),e===r)return 1;if(t=e>>7==0?c[e]:e>>9==0&&e>>7!=0?l[(e>>1)-64]:h[e>>7],t[0]>0)return this._eatBits(t[0]),t[1]}else{let e=this._findTableCode(2,6,h);if(e[0])return e[1];if(e=this._findTableCode(7,12,l,64),e[0])return e[1];if(e=this._findTableCode(10,13,c),e[0])return e[1]}return(0,n.info)("bad black code"),this._eatBits(1),1}_lookBits(e){let t;for(;this.inputBits<e;){if(-1===(t=this.source.next()))return 0===this.inputBits?r:this.inputBuf<<e-this.inputBits&65535>>16-e;this.inputBuf=this.inputBuf<<8|t,this.inputBits+=8}return this.inputBuf>>this.inputBits-e&65535>>16-e}_eatBits(e){(this.inputBits-=e)<0&&(this.inputBits=0)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.FlateStream=void 0;var n=a(18),r=a(2);const i=new Int32Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]),s=new Int32Array([3,4,5,6,7,8,9,10,65547,65549,65551,65553,131091,131095,131099,131103,196643,196651,196659,196667,262211,262227,262243,262259,327811,327843,327875,327907,258,258,258]),o=new Int32Array([1,2,3,4,65541,65543,131081,131085,196625,196633,262177,262193,327745,327777,393345,393409,459009,459137,524801,525057,590849,591361,657409,658433,724993,727041,794625,798721,868353,876545]),c=[new Int32Array([459008,524368,524304,524568,459024,524400,524336,590016,459016,524384,524320,589984,524288,524416,524352,590048,459012,524376,524312,589968,459028,524408,524344,590032,459020,524392,524328,59e4,524296,524424,524360,590064,459010,524372,524308,524572,459026,524404,524340,590024,459018,524388,524324,589992,524292,524420,524356,590056,459014,524380,524316,589976,459030,524412,524348,590040,459022,524396,524332,590008,524300,524428,524364,590072,459009,524370,524306,524570,459025,524402,524338,590020,459017,524386,524322,589988,524290,524418,524354,590052,459013,524378,524314,589972,459029,524410,524346,590036,459021,524394,524330,590004,524298,524426,524362,590068,459011,524374,524310,524574,459027,524406,524342,590028,459019,524390,524326,589996,524294,524422,524358,590060,459015,524382,524318,589980,459031,524414,524350,590044,459023,524398,524334,590012,524302,524430,524366,590076,459008,524369,524305,524569,459024,524401,524337,590018,459016,524385,524321,589986,524289,524417,524353,590050,459012,524377,524313,589970,459028,524409,524345,590034,459020,524393,524329,590002,524297,524425,524361,590066,459010,524373,524309,524573,459026,524405,524341,590026,459018,524389,524325,589994,524293,524421,524357,590058,459014,524381,524317,589978,459030,524413,524349,590042,459022,524397,524333,590010,524301,524429,524365,590074,459009,524371,524307,524571,459025,524403,524339,590022,459017,524387,524323,589990,524291,524419,524355,590054,459013,524379,524315,589974,459029,524411,524347,590038,459021,524395,524331,590006,524299,524427,524363,590070,459011,524375,524311,524575,459027,524407,524343,590030,459019,524391,524327,589998,524295,524423,524359,590062,459015,524383,524319,589982,459031,524415,524351,590046,459023,524399,524335,590014,524303,524431,524367,590078,459008,524368,524304,524568,459024,524400,524336,590017,459016,524384,524320,589985,524288,524416,524352,590049,459012,524376,524312,589969,459028,524408,524344,590033,459020,524392,524328,590001,524296,524424,524360,590065,459010,524372,524308,524572,459026,524404,524340,590025,459018,524388,524324,589993,524292,524420,524356,590057,459014,524380,524316,589977,459030,524412,524348,590041,459022,524396,524332,590009,524300,524428,524364,590073,459009,524370,524306,524570,459025,524402,524338,590021,459017,524386,524322,589989,524290,524418,524354,590053,459013,524378,524314,589973,459029,524410,524346,590037,459021,524394,524330,590005,524298,524426,524362,590069,459011,524374,524310,524574,459027,524406,524342,590029,459019,524390,524326,589997,524294,524422,524358,590061,459015,524382,524318,589981,459031,524414,524350,590045,459023,524398,524334,590013,524302,524430,524366,590077,459008,524369,524305,524569,459024,524401,524337,590019,459016,524385,524321,589987,524289,524417,524353,590051,459012,524377,524313,589971,459028,524409,524345,590035,459020,524393,524329,590003,524297,524425,524361,590067,459010,524373,524309,524573,459026,524405,524341,590027,459018,524389,524325,589995,524293,524421,524357,590059,459014,524381,524317,589979,459030,524413,524349,590043,459022,524397,524333,590011,524301,524429,524365,590075,459009,524371,524307,524571,459025,524403,524339,590023,459017,524387,524323,589991,524291,524419,524355,590055,459013,524379,524315,589975,459029,524411,524347,590039,459021,524395,524331,590007,524299,524427,524363,590071,459011,524375,524311,524575,459027,524407,524343,590031,459019,524391,524327,589999,524295,524423,524359,590063,459015,524383,524319,589983,459031,524415,524351,590047,459023,524399,524335,590015,524303,524431,524367,590079]),9],l=[new Int32Array([327680,327696,327688,327704,327684,327700,327692,327708,327682,327698,327690,327706,327686,327702,327694,0,327681,327697,327689,327705,327685,327701,327693,327709,327683,327699,327691,327707,327687,327703,327695,0]),5];class h extends n.DecodeStream{constructor(e,t){super(t),this.str=e,this.dict=e.dict;const a=e.getByte(),n=e.getByte();if(-1===a||-1===n)throw new r.FormatError(`Invalid header in flate stream: ${a}, ${n}`);if(8!=(15&a))throw new r.FormatError(`Unknown compression method in flate stream: ${a}, ${n}`);if(((a<<8)+n)%31!=0)throw new r.FormatError(`Bad FCHECK in flate stream: ${a}, ${n}`);if(32&n)throw new r.FormatError(`FDICT bit set in flate stream: ${a}, ${n}`);this.codeSize=0,this.codeBuf=0}getBits(e){const t=this.str;let a,n=this.codeSize,i=this.codeBuf;for(;n<e;){if(-1===(a=t.getByte()))throw new r.FormatError("Bad encoding in flate stream");i|=a<<n,n+=8}return a=i&(1<<e)-1,this.codeBuf=i>>e,this.codeSize=n-=e,a}getCode(e){const t=this.str,a=e[0],n=e[1];let i,s=this.codeSize,o=this.codeBuf;for(;s<n&&-1!==(i=t.getByte());)o|=i<<s,s+=8;const c=a[o&(1<<n)-1],l=c>>16,h=65535&c;if(l<1||s<l)throw new r.FormatError("Bad encoding in flate stream");return this.codeBuf=o>>l,this.codeSize=s-l,h}generateHuffmanTable(e){const t=e.length;let a,n=0;for(a=0;a<t;++a)e[a]>n&&(n=e[a]);const r=1<<n,i=new Int32Array(r);for(let s=1,o=0,c=2;s<=n;++s,o<<=1,c<<=1)for(let n=0;n<t;++n)if(e[n]===s){let e=0,t=o;for(a=0;a<s;++a)e=e<<1|1&t,t>>=1;for(a=e;a<r;a+=c)i[a]=s<<16|n;++o}return[i,n]}readBlock(){let e,t;const a=this.str;let n,h,u=this.getBits(3);if(1&u&&(this.eof=!0),u>>=1,0===u){let t;if(-1===(t=a.getByte()))throw new r.FormatError("Bad block header in flate stream");let n=t;if(-1===(t=a.getByte()))throw new r.FormatError("Bad block header in flate stream");if(n|=t<<8,-1===(t=a.getByte()))throw new r.FormatError("Bad block header in flate stream");let i=t;if(-1===(t=a.getByte()))throw new r.FormatError("Bad block header in flate stream");if(i|=t<<8,i!==(65535&~n)&&(0!==n||0!==i))throw new r.FormatError("Bad uncompressed block length in flate stream");this.codeBuf=0,this.codeSize=0;const s=this.bufferLength,o=s+n;if(e=this.ensureBuffer(o),this.bufferLength=o,0===n)-1===a.peekByte()&&(this.eof=!0);else{const t=a.getBytes(n);e.set(t,s),t.length<n&&(this.eof=!0)}return}if(1===u)n=c,h=l;else{if(2!==u)throw new r.FormatError("Unknown block type in flate stream");{const e=this.getBits(5)+257,a=this.getBits(5)+1,r=this.getBits(4)+4,s=new Uint8Array(i.length);let o;for(o=0;o<r;++o)s[i[o]]=this.getBits(3);const c=this.generateHuffmanTable(s);t=0,o=0;const l=e+a,u=new Uint8Array(l);let d,f,g;for(;o<l;){const e=this.getCode(c);if(16===e)d=2,f=3,g=t;else if(17===e)d=3,f=3,g=t=0;else{if(18!==e){u[o++]=t=e;continue}d=7,f=11,g=t=0}let a=this.getBits(d)+f;for(;a-- >0;)u[o++]=g}n=this.generateHuffmanTable(u.subarray(0,e)),h=this.generateHuffmanTable(u.subarray(e,l))}}e=this.buffer;let d=e?e.length:0,f=this.bufferLength;for(;;){let a=this.getCode(n);if(a<256){f+1>=d&&(e=this.ensureBuffer(f+1),d=e.length),e[f++]=a;continue}if(256===a)return void(this.bufferLength=f);a-=257,a=s[a];let r=a>>16;r>0&&(r=this.getBits(r)),t=(65535&a)+r,a=this.getCode(h),a=o[a],r=a>>16,r>0&&(r=this.getBits(r));const i=(65535&a)+r;f+t>=d&&(e=this.ensureBuffer(f+t),d=e.length);for(let a=0;a<t;++a,++f)e[f]=e[f-i]}}}t.FlateStream=h},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Jbig2Stream=void 0;var n=a(5),r=a(18),i=a(4),s=a(24),o=a(2);class c extends r.DecodeStream{constructor(e,t,a){super(t),this.stream=e,this.dict=e.dict,this.maybeLength=t,this.params=a}get bytes(){return(0,o.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e=new s.Jbig2Image,t=[];if(this.params instanceof i.Dict){const e=this.params.get("JBIG2Globals");if(e instanceof n.BaseStream){const a=e.getBytes();t.push({data:a,start:0,end:a.length})}}t.push({data:this.bytes,start:0,end:this.bytes.length});const a=e.parseChunks(t),r=a.length;for(let e=0;e<r;e++)a[e]^=255;this.buffer=a,this.bufferLength=r,this.eof=!0}}t.Jbig2Stream=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Jbig2Image=void 0;var n=a(2),r=a(3),i=a(25),s=a(21);class o extends n.BaseException{constructor(e){super(`JBIG2 error: ${e}`,"Jbig2Error")}}class c{getContexts(e){return e in this?this[e]:this[e]=new Int8Array(65536)}}class l{constructor(e,t,a){this.data=e,this.start=t,this.end=a}get decoder(){const e=new i.ArithmeticDecoder(this.data,this.start,this.end);return(0,n.shadow)(this,"decoder",e)}get contextCache(){const e=new c;return(0,n.shadow)(this,"contextCache",e)}}const h=2**31-1,u=-(2**31);function d(e,t,a){const n=e.getContexts(t);let r=1;function i(e){let t=0;for(let i=0;i<e;i++){const e=a.readBit(n,r);r=r<256?r<<1|e:511&(r<<1|e)|256,t=t<<1|e}return t>>>0}const s=i(1),o=i(1)?i(1)?i(1)?i(1)?i(1)?i(32)+4436:i(12)+340:i(8)+84:i(6)+20:i(4)+4:i(2);let c;return 0===s?c=o:o>0&&(c=-o),c>=u&&c<=h?c:null}function f(e,t,a){const n=e.getContexts("IAID");let r=1;for(let e=0;e<a;e++){r=r<<1|t.readBit(n,r)}return a<31?r&(1<<a)-1:2147483647&r}const g=["SymbolDictionary",null,null,null,"IntermediateTextRegion",null,"ImmediateTextRegion","ImmediateLosslessTextRegion",null,null,null,null,null,null,null,null,"PatternDictionary",null,null,null,"IntermediateHalftoneRegion",null,"ImmediateHalftoneRegion","ImmediateLosslessHalftoneRegion",null,null,null,null,null,null,null,null,null,null,null,null,"IntermediateGenericRegion",null,"ImmediateGenericRegion","ImmediateLosslessGenericRegion","IntermediateGenericRefinementRegion",null,"ImmediateGenericRefinementRegion","ImmediateLosslessGenericRefinementRegion",null,null,null,null,"PageInformation","EndOfPage","EndOfStripe","EndOfFile","Profiles","Tables",null,null,null,null,null,null,null,null,"Extension"],p=[[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:2,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:2,y:-1},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}],[{x:-1,y:-2},{x:0,y:-2},{x:1,y:-2},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-2,y:0},{x:-1,y:0}],[{x:-3,y:-1},{x:-2,y:-1},{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-4,y:0},{x:-3,y:0},{x:-2,y:0},{x:-1,y:0}]],m=[{coding:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:1,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:-1,y:1},{x:0,y:1},{x:1,y:1}]},{coding:[{x:-1,y:-1},{x:0,y:-1},{x:1,y:-1},{x:-1,y:0}],reference:[{x:0,y:-1},{x:-1,y:0},{x:0,y:0},{x:1,y:0},{x:0,y:1},{x:1,y:1}]}],b=[39717,1941,229,405],y=[32,8];function w(e,t,a,n,r,i,s,o){if(e){return $(new R(o.data,o.start,o.end),t,a,!1)}if(0===n&&!i&&!r&&4===s.length&&3===s[0].x&&-1===s[0].y&&-3===s[1].x&&-1===s[1].y&&2===s[2].x&&-2===s[2].y&&-2===s[3].x&&-2===s[3].y)return function(e,t,a){const n=a.decoder,r=a.contextCache.getContexts("GB"),i=[];let s,o,c,l,h,u,d;for(o=0;o<t;o++)for(h=i[o]=new Uint8Array(e),u=o<1?h:i[o-1],d=o<2?h:i[o-2],s=d[0]<<13|d[1]<<12|d[2]<<11|u[0]<<7|u[1]<<6|u[2]<<5|u[3]<<4,c=0;c<e;c++)h[c]=l=n.readBit(r,s),s=(31735&s)<<1|(c+3<e?d[c+3]<<11:0)|(c+4<e?u[c+4]<<4:0)|l;return i}(t,a,o);const c=!!i,l=p[n].concat(s);l.sort((function(e,t){return e.y-t.y||e.x-t.x}));const h=l.length,u=new Int8Array(h),d=new Int8Array(h),f=[];let g,m,y=0,w=0,x=0,S=0;for(m=0;m<h;m++)u[m]=l[m].x,d[m]=l[m].y,w=Math.min(w,l[m].x),x=Math.max(x,l[m].x),S=Math.min(S,l[m].y),m<h-1&&l[m].y===l[m+1].y&&l[m].x===l[m+1].x-1?y|=1<<h-1-m:f.push(m);const A=f.length,k=new Int8Array(A),C=new Int8Array(A),v=new Uint16Array(A);for(g=0;g<A;g++)m=f[g],k[g]=l[m].x,C[g]=l[m].y,v[g]=1<<h-1-m;const F=-w,O=-S,I=t-x,T=b[n];let M=new Uint8Array(t);const P=[],N=o.decoder,D=o.contextCache.getContexts("GB");let E,B,L,_,j,U=0,X=0;for(let e=0;e<a;e++){if(r){if(U^=N.readBit(D,T),U){P.push(M);continue}}for(M=new Uint8Array(M),P.push(M),E=0;E<t;E++){if(c&&i[e][E]){M[E]=0;continue}if(E>=F&&E<I&&e>=O)for(X=X<<1&y,m=0;m<A;m++)B=e+C[m],L=E+k[m],_=P[B][L],_&&(_=v[m],X|=_);else for(X=0,j=h-1,m=0;m<h;m++,j--)L=E+u[m],L>=0&&L<t&&(B=e+d[m],B>=0&&(_=P[B][L],_&&(X|=_<<j)));const a=N.readBit(D,X);M[E]=a}}return P}function x(e,t,a,n,r,i,s,c,l){let h=m[a].coding;0===a&&(h=h.concat([c[0]]));const u=h.length,d=new Int32Array(u),f=new Int32Array(u);let g;for(g=0;g<u;g++)d[g]=h[g].x,f[g]=h[g].y;let p=m[a].reference;0===a&&(p=p.concat([c[1]]));const b=p.length,w=new Int32Array(b),x=new Int32Array(b);for(g=0;g<b;g++)w[g]=p[g].x,x[g]=p[g].y;const S=n[0].length,A=n.length,k=y[a],C=[],v=l.decoder,F=l.contextCache.getContexts("GR");let O=0;for(let a=0;a<t;a++){if(s){if(O^=v.readBit(F,k),O)throw new o("prediction is not supported")}const t=new Uint8Array(e);C.push(t);for(let s=0;s<e;s++){let o,c,l=0;for(g=0;g<u;g++)o=a+f[g],c=s+d[g],o<0||c<0||c>=e?l<<=1:l=l<<1|C[o][c];for(g=0;g<b;g++)o=a+x[g]-i,c=s+w[g]-r,o<0||o>=A||c<0||c>=S?l<<=1:l=l<<1|n[o][c];const h=v.readBit(F,l);t[s]=h}}return C}function S(e,t,a,n,r,i,s,c,l,h,u,g,p,m,b,y,w,S,A){if(e&&t)throw new o("refinement with Huffman is not supported");const k=[];let C,v;for(C=0;C<n;C++){if(v=new Uint8Array(a),r)for(let e=0;e<a;e++)v[e]=r;k.push(v)}const F=w.decoder,O=w.contextCache;let I=e?-m.tableDeltaT.decode(A):-d(O,"IADT",F),T=0;for(C=0;C<i;){I+=e?m.tableDeltaT.decode(A):d(O,"IADT",F);T+=e?m.tableFirstS.decode(A):d(O,"IAFS",F);let n=T;for(;;){let r=0;s>1&&(r=e?A.readBits(S):d(O,"IAIT",F));const i=s*I+r,T=e?m.symbolIDTable.decode(A):f(O,F,l),M=t&&(e?A.readBit():d(O,"IARI",F));let P=c[T],N=P[0].length,D=P.length;if(M){const e=d(O,"IARDW",F),t=d(O,"IARDH",F);N+=e,D+=t,P=x(N,D,b,P,(e>>1)+d(O,"IARDX",F),(t>>1)+d(O,"IARDY",F),!1,y,w)}const R=i-(1&g?0:D-1),E=n-(2&g?N-1:0);let B,$,L;if(h){for(B=0;B<D;B++){if(v=k[E+B],!v)continue;L=P[B];const e=Math.min(a-R,N);switch(p){case 0:for($=0;$<e;$++)v[R+$]|=L[$];break;case 2:for($=0;$<e;$++)v[R+$]^=L[$];break;default:throw new o(`operator ${p} is not supported`)}}n+=D-1}else{for($=0;$<D;$++)if(v=k[R+$],v)switch(L=P[$],p){case 0:for(B=0;B<N;B++)v[E+B]|=L[B];break;case 2:for(B=0;B<N;B++)v[E+B]^=L[B];break;default:throw new o(`operator ${p} is not supported`)}n+=N-1}C++;const _=e?m.tableDeltaS.decode(A):d(O,"IADS",F);if(null===_)break;n+=_+u}}return k}function A(e,t){const a={};a.number=(0,r.readUint32)(e,t);const n=e[t+4],i=63&n;if(!g[i])throw new o("invalid segment type: "+i);a.type=i,a.typeName=g[i],a.deferredNonRetain=!!(128&n);const s=!!(64&n),c=e[t+5];let l=c>>5&7;const h=[31&c];let u=t+6;if(7===c){l=536870911&(0,r.readUint32)(e,u-1),u+=3;let t=l+7>>3;for(h[0]=e[u++];--t>0;)h.push(e[u++])}else if(5===c||6===c)throw new o("invalid referred-to flags");a.retainBits=h;let d=4;a.number<=256?d=1:a.number<=65536&&(d=2);const f=[];let p,m;for(p=0;p<l;p++){let t;t=1===d?e[u]:2===d?(0,r.readUint16)(e,u):(0,r.readUint32)(e,u),f.push(t),u+=d}if(a.referredTo=f,s?(a.pageAssociation=(0,r.readUint32)(e,u),u+=4):a.pageAssociation=e[u++],a.length=(0,r.readUint32)(e,u),u+=4,4294967295===a.length){if(38!==i)throw new o("invalid unknown segment length");{const t=C(e,u),n=!!(1&e[u+v]),r=6,i=new Uint8Array(r);for(n||(i[0]=255,i[1]=172),i[2]=t.height>>>24&255,i[3]=t.height>>16&255,i[4]=t.height>>8&255,i[5]=255&t.height,p=u,m=e.length;p<m;p++){let t=0;for(;t<r&&i[t]===e[p+t];)t++;if(t===r){a.length=p+r;break}}if(4294967295===a.length)throw new o("segment end was not found")}}return a.headerEnd=u,a}function k(e,t,a,n){const r=[];let i=a;for(;i<n;){const a=A(t,i);i=a.headerEnd;const n={header:a,data:t};if(e.randomAccess||(n.start=i,i+=a.length,n.end=i),r.push(n),51===a.type)break}if(e.randomAccess)for(let e=0,t=r.length;e<t;e++)r[e].start=i,i+=r[e].header.length,r[e].end=i;return r}function C(e,t){return{width:(0,r.readUint32)(e,t),height:(0,r.readUint32)(e,t+4),x:(0,r.readUint32)(e,t+8),y:(0,r.readUint32)(e,t+12),combinationOperator:7&e[t+16]}}const v=17;function F(e,t){const a=e.header,n=e.data,i=e.end;let s,c,l,h,u=e.start;switch(a.type){case 0:const e={},t=(0,r.readUint16)(n,u);if(e.huffman=!!(1&t),e.refinement=!!(2&t),e.huffmanDHSelector=t>>2&3,e.huffmanDWSelector=t>>4&3,e.bitmapSizeSelector=t>>6&1,e.aggregationInstancesSelector=t>>7&1,e.bitmapCodingContextUsed=!!(256&t),e.bitmapCodingContextRetained=!!(512&t),e.template=t>>10&3,e.refinementTemplate=t>>12&1,u+=2,!e.huffman){for(h=0===e.template?4:1,c=[],l=0;l<h;l++)c.push({x:(0,r.readInt8)(n,u),y:(0,r.readInt8)(n,u+1)}),u+=2;e.at=c}if(e.refinement&&!e.refinementTemplate){for(c=[],l=0;l<2;l++)c.push({x:(0,r.readInt8)(n,u),y:(0,r.readInt8)(n,u+1)}),u+=2;e.refinementAt=c}e.numberOfExportedSymbols=(0,r.readUint32)(n,u),u+=4,e.numberOfNewSymbols=(0,r.readUint32)(n,u),u+=4,s=[e,a.number,a.referredTo,n,u,i];break;case 6:case 7:const d={};d.info=C(n,u),u+=v;const f=(0,r.readUint16)(n,u);if(u+=2,d.huffman=!!(1&f),d.refinement=!!(2&f),d.logStripSize=f>>2&3,d.stripSize=1<<d.logStripSize,d.referenceCorner=f>>4&3,d.transposed=!!(64&f),d.combinationOperator=f>>7&3,d.defaultPixelValue=f>>9&1,d.dsOffset=f<<17>>27,d.refinementTemplate=f>>15&1,d.huffman){const e=(0,r.readUint16)(n,u);u+=2,d.huffmanFS=3&e,d.huffmanDS=e>>2&3,d.huffmanDT=e>>4&3,d.huffmanRefinementDW=e>>6&3,d.huffmanRefinementDH=e>>8&3,d.huffmanRefinementDX=e>>10&3,d.huffmanRefinementDY=e>>12&3,d.huffmanRefinementSizeSelector=!!(16384&e)}if(d.refinement&&!d.refinementTemplate){for(c=[],l=0;l<2;l++)c.push({x:(0,r.readInt8)(n,u),y:(0,r.readInt8)(n,u+1)}),u+=2;d.refinementAt=c}d.numberOfSymbolInstances=(0,r.readUint32)(n,u),u+=4,s=[d,a.referredTo,n,u,i];break;case 16:const g={},p=n[u++];g.mmr=!!(1&p),g.template=p>>1&3,g.patternWidth=n[u++],g.patternHeight=n[u++],g.maxPatternIndex=(0,r.readUint32)(n,u),u+=4,s=[g,a.number,n,u,i];break;case 22:case 23:const m={};m.info=C(n,u),u+=v;const b=n[u++];m.mmr=!!(1&b),m.template=b>>1&3,m.enableSkip=!!(8&b),m.combinationOperator=b>>4&7,m.defaultPixelValue=b>>7&1,m.gridWidth=(0,r.readUint32)(n,u),u+=4,m.gridHeight=(0,r.readUint32)(n,u),u+=4,m.gridOffsetX=4294967295&(0,r.readUint32)(n,u),u+=4,m.gridOffsetY=4294967295&(0,r.readUint32)(n,u),u+=4,m.gridVectorX=(0,r.readUint16)(n,u),u+=2,m.gridVectorY=(0,r.readUint16)(n,u),u+=2,s=[m,a.referredTo,n,u,i];break;case 38:case 39:const y={};y.info=C(n,u),u+=v;const w=n[u++];if(y.mmr=!!(1&w),y.template=w>>1&3,y.prediction=!!(8&w),!y.mmr){for(h=0===y.template?4:1,c=[],l=0;l<h;l++)c.push({x:(0,r.readInt8)(n,u),y:(0,r.readInt8)(n,u+1)}),u+=2;y.at=c}s=[y,n,u,i];break;case 48:const x={width:(0,r.readUint32)(n,u),height:(0,r.readUint32)(n,u+4),resolutionX:(0,r.readUint32)(n,u+8),resolutionY:(0,r.readUint32)(n,u+12)};4294967295===x.height&&delete x.height;const S=n[u+16];(0,r.readUint16)(n,u+17),x.lossless=!!(1&S),x.refinement=!!(2&S),x.defaultPixelValue=S>>2&1,x.combinationOperator=S>>3&3,x.requiresBuffer=!!(32&S),x.combinationOperatorOverride=!!(64&S),s=[x];break;case 49:case 50:case 51:case 62:break;case 53:s=[a.number,n,u,i];break;default:throw new o(`segment type ${a.typeName}(${a.type}) is not implemented`)}const d="on"+a.typeName;d in t&&t[d].apply(t,s)}function O(e,t){for(let a=0,n=e.length;a<n;a++)F(e[a],t)}class I{onPageInformation(e){this.currentPageInfo=e;const t=e.width+7>>3,a=new Uint8ClampedArray(t*e.height);e.defaultPixelValue&&a.fill(255),this.buffer=a}drawBitmap(e,t){const a=this.currentPageInfo,n=e.width,r=e.height,i=a.width+7>>3,s=a.combinationOperatorOverride?e.combinationOperator:a.combinationOperator,c=this.buffer,l=128>>(7&e.x);let h,u,d,f,g=e.y*i+(e.x>>3);switch(s){case 0:for(h=0;h<r;h++){for(d=l,f=g,u=0;u<n;u++)t[h][u]&&(c[f]|=d),d>>=1,d||(d=128,f++);g+=i}break;case 2:for(h=0;h<r;h++){for(d=l,f=g,u=0;u<n;u++)t[h][u]&&(c[f]^=d),d>>=1,d||(d=128,f++);g+=i}break;default:throw new o(`operator ${s} is not supported`)}}onImmediateGenericRegion(e,t,a,n){const r=e.info,i=new l(t,a,n),s=w(e.mmr,r.width,r.height,e.template,e.prediction,null,e.at,i);this.drawBitmap(r,s)}onImmediateLosslessGenericRegion(){this.onImmediateGenericRegion(...arguments)}onSymbolDictionary(e,t,a,n,i,s){let c,h;e.huffman&&(c=function(e,t,a){let n,r,i,s,c=0;switch(e.huffmanDHSelector){case 0:case 1:n=D(e.huffmanDHSelector+4);break;case 3:n=E(c,t,a),c++;break;default:throw new o("invalid Huffman DH selector")}switch(e.huffmanDWSelector){case 0:case 1:r=D(e.huffmanDWSelector+2);break;case 3:r=E(c,t,a),c++;break;default:throw new o("invalid Huffman DW selector")}e.bitmapSizeSelector?(i=E(c,t,a),c++):i=D(1);s=e.aggregationInstancesSelector?E(c,t,a):D(1);return{tableDeltaHeight:n,tableDeltaWidth:r,tableBitmapSize:i,tableAggregateInstances:s}}(e,a,this.customTables),h=new R(n,i,s));let u=this.symbols;u||(this.symbols=u={});const g=[];for(const e of a){const t=u[e];t&&g.push(...t)}const p=new l(n,i,s);u[t]=function(e,t,a,n,i,s,c,l,h,u,g,p){if(e&&t)throw new o("symbol refinement with Huffman is not supported");const m=[];let b=0,y=(0,r.log2)(a.length+n);const A=g.decoder,k=g.contextCache;let C,v;for(e&&(C=D(1),v=[],y=Math.max(y,1));m.length<n;){b+=e?s.tableDeltaHeight.decode(p):d(k,"IADH",A);let n=0,r=0;const i=e?v.length:0;for(;;){const i=e?s.tableDeltaWidth.decode(p):d(k,"IADW",A);if(null===i)break;let o;if(n+=i,r+=n,t){const r=d(k,"IAAI",A);if(r>1)o=S(e,t,n,b,0,r,1,a.concat(m),y,0,0,1,0,s,h,u,g,0,p);else{const e=f(k,A,y),t=d(k,"IARDX",A),r=d(k,"IARDY",A);o=x(n,b,h,e<a.length?a[e]:m[e-a.length],t,r,!1,u,g)}m.push(o)}else e?v.push(n):(o=w(!1,n,b,c,!1,null,l,g),m.push(o))}if(e&&!t){const e=s.tableBitmapSize.decode(p);let t;if(p.byteAlign(),0===e)t=B(p,r,b);else{const a=p.end,n=p.position+e;p.end=n,t=$(p,r,b,!1),p.end=a,p.position=n}const a=v.length;if(i===a-1)m.push(t);else{let e,n,r,s,o,c=0;for(e=i;e<a;e++){for(s=v[e],r=c+s,o=[],n=0;n<b;n++)o.push(t[n].subarray(c,r));m.push(o),c=r}}}}const F=[],O=[];let I,T,M=!1;const P=a.length+n;for(;O.length<P;){let t=e?C.decode(p):d(k,"IAEX",A);for(;t--;)O.push(M);M=!M}for(I=0,T=a.length;I<T;I++)O[I]&&F.push(a[I]);for(let e=0;e<n;I++,e++)O[I]&&F.push(m[e]);return F}(e.huffman,e.refinement,g,e.numberOfNewSymbols,e.numberOfExportedSymbols,c,e.template,e.at,e.refinementTemplate,e.refinementAt,p,h)}onImmediateTextRegion(e,t,a,n,i){const s=e.info;let c,h;const u=this.symbols,d=[];for(const e of t){const t=u[e];t&&d.push(...t)}const f=(0,r.log2)(d.length);e.huffman&&(h=new R(a,n,i),c=function(e,t,a,n,r){const i=[];for(let e=0;e<=34;e++){const t=r.readBits(4);i.push(new T([e,t,0,0]))}const s=new P(i,!1);i.length=0;for(let e=0;e<n;){const t=s.decode(r);if(t>=32){let a,n,s;switch(t){case 32:if(0===e)throw new o("no previous value in symbol ID table");n=r.readBits(2)+3,a=i[e-1].prefixLength;break;case 33:n=r.readBits(3)+3,a=0;break;case 34:n=r.readBits(7)+11,a=0;break;default:throw new o("invalid code length in symbol ID table")}for(s=0;s<n;s++)i.push(new T([e,a,0,0])),e++}else i.push(new T([e,t,0,0])),e++}r.byteAlign();const c=new P(i,!1);let l,h,u,d=0;switch(e.huffmanFS){case 0:case 1:l=D(e.huffmanFS+6);break;case 3:l=E(d,t,a),d++;break;default:throw new o("invalid Huffman FS selector")}switch(e.huffmanDS){case 0:case 1:case 2:h=D(e.huffmanDS+8);break;case 3:h=E(d,t,a),d++;break;default:throw new o("invalid Huffman DS selector")}switch(e.huffmanDT){case 0:case 1:case 2:u=D(e.huffmanDT+11);break;case 3:u=E(d,t,a),d++;break;default:throw new o("invalid Huffman DT selector")}if(e.refinement)throw new o("refinement with Huffman is not supported");return{symbolIDTable:c,tableFirstS:l,tableDeltaS:h,tableDeltaT:u}}(e,t,this.customTables,d.length,h));const g=new l(a,n,i),p=S(e.huffman,e.refinement,s.width,s.height,e.defaultPixelValue,e.numberOfSymbolInstances,e.stripSize,d,f,e.transposed,e.dsOffset,e.referenceCorner,e.combinationOperator,c,e.refinementTemplate,e.refinementAt,g,e.logStripSize,h);this.drawBitmap(s,p)}onImmediateLosslessTextRegion(){this.onImmediateTextRegion(...arguments)}onPatternDictionary(e,t,a,n,r){let i=this.patterns;i||(this.patterns=i={});const s=new l(a,n,r);i[t]=function(e,t,a,n,r,i){const s=[];e||(s.push({x:-t,y:0}),0===r&&s.push({x:-3,y:-1},{x:2,y:-2},{x:-2,y:-2}));const o=w(e,(n+1)*t,a,r,!1,null,s,i),c=[];for(let e=0;e<=n;e++){const n=[],r=t*e,i=r+t;for(let e=0;e<a;e++)n.push(o[e].subarray(r,i));c.push(n)}return c}(e.mmr,e.patternWidth,e.patternHeight,e.maxPatternIndex,e.template,s)}onImmediateHalftoneRegion(e,t,a,n,i){const s=this.patterns[t[0]],c=e.info,h=new l(a,n,i),u=function(e,t,a,n,i,s,c,l,h,u,d,f,g,p,m){if(c)throw new o("skip is not supported");if(0!==l)throw new o(`operator "${l}" is not supported in halftone region`);const b=[];let y,x,S;for(y=0;y<i;y++){if(S=new Uint8Array(n),s)for(x=0;x<n;x++)S[x]=s;b.push(S)}const A=t.length,k=t[0],C=k[0].length,v=k.length,F=(0,r.log2)(A),O=[];e||(O.push({x:a<=1?3:2,y:-1}),0===a&&O.push({x:-3,y:-1},{x:2,y:-2},{x:-2,y:-2}));const I=[];let T,M,P,N,D,E,B,L,_,j,U;for(e&&(T=new R(m.data,m.start,m.end)),y=F-1;y>=0;y--)M=e?$(T,h,u,!0):w(!1,h,u,a,!1,null,O,m),I[y]=M;for(P=0;P<u;P++)for(N=0;N<h;N++){for(D=0,E=0,x=F-1;x>=0;x--)D^=I[x][P][N],E|=D<<x;if(B=t[E],L=d+P*p+N*g>>8,_=f+P*g-N*p>>8,L>=0&&L+C<=n&&_>=0&&_+v<=i)for(y=0;y<v;y++)for(U=b[_+y],j=B[y],x=0;x<C;x++)U[L+x]|=j[x];else{let e,t;for(y=0;y<v;y++)if(t=_+y,!(t<0||t>=i))for(U=b[t],j=B[y],x=0;x<C;x++)e=L+x,e>=0&&e<n&&(U[e]|=j[x])}}return b}(e.mmr,s,e.template,c.width,c.height,e.defaultPixelValue,e.enableSkip,e.combinationOperator,e.gridWidth,e.gridHeight,e.gridOffsetX,e.gridOffsetY,e.gridVectorX,e.gridVectorY,h);this.drawBitmap(c,u)}onImmediateLosslessHalftoneRegion(){this.onImmediateHalftoneRegion(...arguments)}onTables(e,t,a,n){let i=this.customTables;i||(this.customTables=i={}),i[e]=function(e,t,a){const n=e[t],i=4294967295&(0,r.readUint32)(e,t+1),s=4294967295&(0,r.readUint32)(e,t+5),o=new R(e,t+9,a),c=1+(n>>1&7),l=1+(n>>4&7),h=[];let u,d,f=i;do{u=o.readBits(c),d=o.readBits(l),h.push(new T([f,u,d,0])),f+=1<<d}while(f<s);u=o.readBits(c),h.push(new T([i-1,u,32,0,"lower"])),u=o.readBits(c),h.push(new T([s,u,32,0])),1&n&&(u=o.readBits(c),h.push(new T([u,0])));return new P(h,!1)}(t,a,n)}}class T{constructor(e){2===e.length?(this.isOOB=!0,this.rangeLow=0,this.prefixLength=e[0],this.rangeLength=0,this.prefixCode=e[1],this.isLowerRange=!1):(this.isOOB=!1,this.rangeLow=e[0],this.prefixLength=e[1],this.rangeLength=e[2],this.prefixCode=e[3],this.isLowerRange="lower"===e[4])}}class M{constructor(e){this.children=[],e?(this.isLeaf=!0,this.rangeLength=e.rangeLength,this.rangeLow=e.rangeLow,this.isLowerRange=e.isLowerRange,this.isOOB=e.isOOB):this.isLeaf=!1}buildTree(e,t){const a=e.prefixCode>>t&1;if(t<=0)this.children[a]=new M(e);else{let n=this.children[a];n||(this.children[a]=n=new M(null)),n.buildTree(e,t-1)}}decodeNode(e){if(this.isLeaf){if(this.isOOB)return null;const t=e.readBits(this.rangeLength);return this.rangeLow+(this.isLowerRange?-t:t)}const t=this.children[e.readBit()];if(!t)throw new o("invalid Huffman data");return t.decodeNode(e)}}class P{constructor(e,t){t||this.assignPrefixCodes(e),this.rootNode=new M(null);for(let t=0,a=e.length;t<a;t++){const a=e[t];a.prefixLength>0&&this.rootNode.buildTree(a,a.prefixLength-1)}}decode(e){return this.rootNode.decodeNode(e)}assignPrefixCodes(e){const t=e.length;let a=0;for(let n=0;n<t;n++)a=Math.max(a,e[n].prefixLength);const n=new Uint32Array(a+1);for(let a=0;a<t;a++)n[e[a].prefixLength]++;let r,i,s,o=1,c=0;for(n[0]=0;o<=a;){for(c=c+n[o-1]<<1,r=c,i=0;i<t;)s=e[i],s.prefixLength===o&&(s.prefixCode=r,r++),i++;o++}}}const N={};function D(e){let t,a=N[e];if(a)return a;switch(e){case 1:t=[[0,1,4,0],[16,2,8,2],[272,3,16,6],[65808,3,32,7]];break;case 2:t=[[0,1,0,0],[1,2,0,2],[2,3,0,6],[3,4,3,14],[11,5,6,30],[75,6,32,62],[6,63]];break;case 3:t=[[-256,8,8,254],[0,1,0,0],[1,2,0,2],[2,3,0,6],[3,4,3,14],[11,5,6,30],[-257,8,32,255,"lower"],[75,7,32,126],[6,62]];break;case 4:t=[[1,1,0,0],[2,2,0,2],[3,3,0,6],[4,4,3,14],[12,5,6,30],[76,5,32,31]];break;case 5:t=[[-255,7,8,126],[1,1,0,0],[2,2,0,2],[3,3,0,6],[4,4,3,14],[12,5,6,30],[-256,7,32,127,"lower"],[76,6,32,62]];break;case 6:t=[[-2048,5,10,28],[-1024,4,9,8],[-512,4,8,9],[-256,4,7,10],[-128,5,6,29],[-64,5,5,30],[-32,4,5,11],[0,2,7,0],[128,3,7,2],[256,3,8,3],[512,4,9,12],[1024,4,10,13],[-2049,6,32,62,"lower"],[2048,6,32,63]];break;case 7:t=[[-1024,4,9,8],[-512,3,8,0],[-256,4,7,9],[-128,5,6,26],[-64,5,5,27],[-32,4,5,10],[0,4,5,11],[32,5,5,28],[64,5,6,29],[128,4,7,12],[256,3,8,1],[512,3,9,2],[1024,3,10,3],[-1025,5,32,30,"lower"],[2048,5,32,31]];break;case 8:t=[[-15,8,3,252],[-7,9,1,508],[-5,8,1,253],[-3,9,0,509],[-2,7,0,124],[-1,4,0,10],[0,2,1,0],[2,5,0,26],[3,6,0,58],[4,3,4,4],[20,6,1,59],[22,4,4,11],[38,4,5,12],[70,5,6,27],[134,5,7,28],[262,6,7,60],[390,7,8,125],[646,6,10,61],[-16,9,32,510,"lower"],[1670,9,32,511],[2,1]];break;case 9:t=[[-31,8,4,252],[-15,9,2,508],[-11,8,2,253],[-7,9,1,509],[-5,7,1,124],[-3,4,1,10],[-1,3,1,2],[1,3,1,3],[3,5,1,26],[5,6,1,58],[7,3,5,4],[39,6,2,59],[43,4,5,11],[75,4,6,12],[139,5,7,27],[267,5,8,28],[523,6,8,60],[779,7,9,125],[1291,6,11,61],[-32,9,32,510,"lower"],[3339,9,32,511],[2,0]];break;case 10:t=[[-21,7,4,122],[-5,8,0,252],[-4,7,0,123],[-3,5,0,24],[-2,2,2,0],[2,5,0,25],[3,6,0,54],[4,7,0,124],[5,8,0,253],[6,2,6,1],[70,5,5,26],[102,6,5,55],[134,6,6,56],[198,6,7,57],[326,6,8,58],[582,6,9,59],[1094,6,10,60],[2118,7,11,125],[-22,8,32,254,"lower"],[4166,8,32,255],[2,2]];break;case 11:t=[[1,1,0,0],[2,2,1,2],[4,4,0,12],[5,4,1,13],[7,5,1,28],[9,5,2,29],[13,6,2,60],[17,7,2,122],[21,7,3,123],[29,7,4,124],[45,7,5,125],[77,7,6,126],[141,7,32,127]];break;case 12:t=[[1,1,0,0],[2,2,0,2],[3,3,1,6],[5,5,0,28],[6,5,1,29],[8,6,1,60],[10,7,0,122],[11,7,1,123],[13,7,2,124],[17,7,3,125],[25,7,4,126],[41,8,5,254],[73,8,32,255]];break;case 13:t=[[1,1,0,0],[2,3,0,4],[3,4,0,12],[4,5,0,28],[5,4,1,13],[7,3,3,5],[15,6,1,58],[17,6,2,59],[21,6,3,60],[29,6,4,61],[45,6,5,62],[77,7,6,126],[141,7,32,127]];break;case 14:t=[[-2,3,0,4],[-1,3,0,5],[0,1,0,0],[1,3,0,6],[2,3,0,7]];break;case 15:t=[[-24,7,4,124],[-8,6,2,60],[-4,5,1,28],[-2,4,0,12],[-1,3,0,4],[0,1,0,0],[1,3,0,5],[2,4,0,13],[3,5,1,29],[5,6,2,61],[9,7,4,125],[-25,7,32,126,"lower"],[25,7,32,127]];break;default:throw new o(`standard table B.${e} does not exist`)}for(let e=0,a=t.length;e<a;e++)t[e]=new T(t[e]);return a=new P(t,!0),N[e]=a,a}class R{constructor(e,t,a){this.data=e,this.start=t,this.end=a,this.position=t,this.shift=-1,this.currentByte=0}readBit(){if(this.shift<0){if(this.position>=this.end)throw new o("end of data while reading bit");this.currentByte=this.data[this.position++],this.shift=7}const e=this.currentByte>>this.shift&1;return this.shift--,e}readBits(e){let t,a=0;for(t=e-1;t>=0;t--)a|=this.readBit()<<t;return a}byteAlign(){this.shift=-1}next(){return this.position>=this.end?-1:this.data[this.position++]}}function E(e,t,a){let n=0;for(let r=0,i=t.length;r<i;r++){const i=a[t[r]];if(i){if(e===n)return i;n++}}throw new o("can't find custom Huffman table")}function B(e,t,a){const n=[];for(let r=0;r<a;r++){const a=new Uint8Array(t);n.push(a);for(let n=0;n<t;n++)a[n]=e.readBit();e.byteAlign()}return n}function $(e,t,a,n){const r={K:-1,Columns:t,Rows:a,BlackIs1:!0,EndOfBlock:n},i=new s.CCITTFaxDecoder(e,r),o=[];let c,l=!1;for(let e=0;e<a;e++){const e=new Uint8Array(t);o.push(e);let a=-1;for(let n=0;n<t;n++)a<0&&(c=i.readNextChar(),-1===c&&(c=0,l=!0),a=7),e[n]=c>>a&1,a--}if(n&&!l){const e=5;for(let t=0;t<e&&-1!==i.readNextChar();t++);}return o}t.Jbig2Image=class{parseChunks(e){return function(e){const t=new I;for(let a=0,n=e.length;a<n;a++){const n=e[a];O(k({},n.data,n.start,n.end),t)}return t.buffer}(e)}parse(e){throw new Error("Not implemented: Jbig2Image.parse")}}},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ArithmeticDecoder=void 0;const a=[{qe:22017,nmps:1,nlps:1,switchFlag:1},{qe:13313,nmps:2,nlps:6,switchFlag:0},{qe:6145,nmps:3,nlps:9,switchFlag:0},{qe:2753,nmps:4,nlps:12,switchFlag:0},{qe:1313,nmps:5,nlps:29,switchFlag:0},{qe:545,nmps:38,nlps:33,switchFlag:0},{qe:22017,nmps:7,nlps:6,switchFlag:1},{qe:21505,nmps:8,nlps:14,switchFlag:0},{qe:18433,nmps:9,nlps:14,switchFlag:0},{qe:14337,nmps:10,nlps:14,switchFlag:0},{qe:12289,nmps:11,nlps:17,switchFlag:0},{qe:9217,nmps:12,nlps:18,switchFlag:0},{qe:7169,nmps:13,nlps:20,switchFlag:0},{qe:5633,nmps:29,nlps:21,switchFlag:0},{qe:22017,nmps:15,nlps:14,switchFlag:1},{qe:21505,nmps:16,nlps:14,switchFlag:0},{qe:20737,nmps:17,nlps:15,switchFlag:0},{qe:18433,nmps:18,nlps:16,switchFlag:0},{qe:14337,nmps:19,nlps:17,switchFlag:0},{qe:13313,nmps:20,nlps:18,switchFlag:0},{qe:12289,nmps:21,nlps:19,switchFlag:0},{qe:10241,nmps:22,nlps:19,switchFlag:0},{qe:9217,nmps:23,nlps:20,switchFlag:0},{qe:8705,nmps:24,nlps:21,switchFlag:0},{qe:7169,nmps:25,nlps:22,switchFlag:0},{qe:6145,nmps:26,nlps:23,switchFlag:0},{qe:5633,nmps:27,nlps:24,switchFlag:0},{qe:5121,nmps:28,nlps:25,switchFlag:0},{qe:4609,nmps:29,nlps:26,switchFlag:0},{qe:4353,nmps:30,nlps:27,switchFlag:0},{qe:2753,nmps:31,nlps:28,switchFlag:0},{qe:2497,nmps:32,nlps:29,switchFlag:0},{qe:2209,nmps:33,nlps:30,switchFlag:0},{qe:1313,nmps:34,nlps:31,switchFlag:0},{qe:1089,nmps:35,nlps:32,switchFlag:0},{qe:673,nmps:36,nlps:33,switchFlag:0},{qe:545,nmps:37,nlps:34,switchFlag:0},{qe:321,nmps:38,nlps:35,switchFlag:0},{qe:273,nmps:39,nlps:36,switchFlag:0},{qe:133,nmps:40,nlps:37,switchFlag:0},{qe:73,nmps:41,nlps:38,switchFlag:0},{qe:37,nmps:42,nlps:39,switchFlag:0},{qe:21,nmps:43,nlps:40,switchFlag:0},{qe:9,nmps:44,nlps:41,switchFlag:0},{qe:5,nmps:45,nlps:42,switchFlag:0},{qe:1,nmps:45,nlps:43,switchFlag:0},{qe:22017,nmps:46,nlps:46,switchFlag:0}];t.ArithmeticDecoder=class{constructor(e,t,a){this.data=e,this.bp=t,this.dataEnd=a,this.chigh=e[t],this.clow=0,this.byteIn(),this.chigh=this.chigh<<7&65535|this.clow>>9&127,this.clow=this.clow<<7&65535,this.ct-=7,this.a=32768}byteIn(){const e=this.data;let t=this.bp;255===e[t]?e[t+1]>143?(this.clow+=65280,this.ct=8):(t++,this.clow+=e[t]<<9,this.ct=7,this.bp=t):(t++,this.clow+=t<this.dataEnd?e[t]<<8:65280,this.ct=8,this.bp=t),this.clow>65535&&(this.chigh+=this.clow>>16,this.clow&=65535)}readBit(e,t){let n=e[t]>>1,r=1&e[t];const i=a[n],s=i.qe;let o,c=this.a-s;if(this.chigh<s)c<s?(c=s,o=r,n=i.nmps):(c=s,o=1^r,1===i.switchFlag&&(r=o),n=i.nlps);else{if(this.chigh-=s,0!=(32768&c))return this.a=c,r;c<s?(o=1^r,1===i.switchFlag&&(r=o),n=i.nlps):(o=r,n=i.nmps)}do{0===this.ct&&this.byteIn(),c<<=1,this.chigh=this.chigh<<1&65535|this.clow>>15&1,this.clow=this.clow<<1&65535,this.ct--}while(0==(32768&c));return this.a=c,e[t]=n<<1|r,o}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.JpegStream=void 0;var n=a(18),r=a(4),i=a(27),s=a(2);class o extends n.DecodeStream{constructor(e,t,a){let n;for(;-1!==(n=e.getByte());)if(255===n){e.skip(-1);break}super(t),this.stream=e,this.dict=e.dict,this.maybeLength=t,this.params=a}get bytes(){return(0,s.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e={decodeTransform:void 0,colorTransform:void 0},t=this.dict.getArray("D","Decode");if((this.forceRGBA||this.forceRGB)&&Array.isArray(t)){const a=this.dict.get("BPC","BitsPerComponent")||8,n=t.length,r=new Int32Array(n);let i=!1;const s=(1<<a)-1;for(let e=0;e<n;e+=2)r[e]=256*(t[e+1]-t[e])|0,r[e+1]=t[e]*s|0,256===r[e]&&0===r[e+1]||(i=!0);i&&(e.decodeTransform=r)}if(this.params instanceof r.Dict){const t=this.params.get("ColorTransform");Number.isInteger(t)&&(e.colorTransform=t)}const a=new i.JpegImage(e);a.parse(this.bytes);const n=a.getData({width:this.drawWidth,height:this.drawHeight,forceRGBA:this.forceRGBA,forceRGB:this.forceRGB,isSourcePDF:!0});this.buffer=n,this.bufferLength=n.length,this.eof=!0}}t.JpegStream=o},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.JpegImage=void 0;var n=a(2),r=a(28),i=a(3);class s extends n.BaseException{constructor(e){super(`JPEG error: ${e}`,"JpegError")}}class o extends n.BaseException{constructor(e,t){super(e,"DNLMarkerError"),this.scanLines=t}}class c extends n.BaseException{constructor(e){super(e,"EOIMarkerError")}}const l=new Uint8Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),h=4017,u=799,d=3406,f=2276,g=1567,p=3784,m=5793,b=2896;function y(e,t){let a,n,r=0,i=16;for(;i>0&&!e[i-1];)i--;const s=[{children:[],index:0}];let o,c=s[0];for(a=0;a<i;a++){for(n=0;n<e[a];n++){for(c=s.pop(),c.children[c.index]=t[r];c.index>0;)c=s.pop();for(c.index++,s.push(c);s.length<=a;)s.push(o={children:[],index:0}),c.children[c.index]=o.children,c=o;r++}a+1<i&&(s.push(o={children:[],index:0}),c.children[c.index]=o.children,c=o)}return s[0].children}function w(e,t,a){return 64*((e.blocksPerLine+1)*t+a)}function x(e,t,a,r,h,u,d,f,g,p=!1){const m=a.mcusPerLine,b=a.progressive,y=t;let x=0,S=0;function A(){if(S>0)return S--,x>>S&1;if(x=e[t++],255===x){const n=e[t++];if(n){if(220===n&&p){t+=2;const n=(0,i.readUint16)(e,t);if(t+=2,n>0&&n!==a.scanLines)throw new o("Found DNL marker (0xFFDC) while parsing scan data",n)}else if(217===n){if(p){const e=M*(8===a.precision?8:0);if(e>0&&Math.round(a.scanLines/e)>=5)throw new o("Found EOI marker (0xFFD9) while parsing scan data, possibly caused by incorrect `scanLines` parameter",e)}throw new c("Found EOI marker (0xFFD9) while parsing scan data")}throw new s(`unexpected marker ${(x<<8|n).toString(16)}`)}}return S=7,x>>>7}function C(e){let t=e;for(;;){switch(t=t[A()],typeof t){case"number":return t;case"object":continue}throw new s("invalid huffman sequence")}}function v(e){let t=0;for(;e>0;)t=t<<1|A(),e--;return t}function F(e){if(1===e)return 1===A()?1:-1;const t=v(e);return t>=1<<e-1?t:t+(-1<<e)+1}let O=0;let I,T=0;let M=0;function P(e,t,a,n,r){const i=a%m;M=(a/m|0)*e.v+n;const s=i*e.h+r;t(e,w(e,M,s))}function N(e,t,a){M=a/e.blocksPerLine|0;const n=a%e.blocksPerLine;t(e,w(e,M,n))}const D=r.length;let R,E,B,$,L,_;_=b?0===u?0===f?function(e,t){const a=C(e.huffmanTableDC),n=0===a?0:F(a)<<g;e.blockData[t]=e.pred+=n}:function(e,t){e.blockData[t]|=A()<<g}:0===f?function(e,t){if(O>0)return void O--;let a=u;const n=d;for(;a<=n;){const n=C(e.huffmanTableAC),r=15&n,i=n>>4;if(0===r){if(i<15){O=v(i)+(1<<i)-1;break}a+=16;continue}a+=i;const s=l[a];e.blockData[t+s]=F(r)*(1<<g),a++}}:function(e,t){let a=u;const n=d;let r,i,o=0;for(;a<=n;){const n=t+l[a],c=e.blockData[n]<0?-1:1;switch(T){case 0:if(i=C(e.huffmanTableAC),r=15&i,o=i>>4,0===r)o<15?(O=v(o)+(1<<o),T=4):(o=16,T=1);else{if(1!==r)throw new s("invalid ACn encoding");I=F(r),T=o?2:3}continue;case 1:case 2:e.blockData[n]?e.blockData[n]+=c*(A()<<g):(o--,0===o&&(T=2===T?3:0));break;case 3:e.blockData[n]?e.blockData[n]+=c*(A()<<g):(e.blockData[n]=I<<g,T=0);break;case 4:e.blockData[n]&&(e.blockData[n]+=c*(A()<<g))}a++}4===T&&(O--,0===O&&(T=0))}:function(e,t){const a=C(e.huffmanTableDC),n=0===a?0:F(a);e.blockData[t]=e.pred+=n;let r=1;for(;r<64;){const a=C(e.huffmanTableAC),n=15&a,i=a>>4;if(0===n){if(i<15)break;r+=16;continue}r+=i;const s=l[r];e.blockData[t+s]=F(n),r++}};let j,U=0;const X=1===D?r[0].blocksPerLine*r[0].blocksPerColumn:m*a.mcusPerColumn;let H,q;for(;U<=X;){const a=h?Math.min(X-U,h):X;if(a>0){for(E=0;E<D;E++)r[E].pred=0;if(O=0,1===D)for(R=r[0],L=0;L<a;L++)N(R,_,U),U++;else for(L=0;L<a;L++){for(E=0;E<D;E++)for(R=r[E],H=R.h,q=R.v,B=0;B<q;B++)for($=0;$<H;$++)P(R,_,U,B,$);U++}}if(S=0,j=k(e,t),!j)break;if(j.invalid){const e=a>0?"unexpected":"excessive";(0,n.warn)(`decodeScan - ${e} MCU data, current marker is: ${j.invalid}`),t=j.offset}if(!(j.marker>=65488&&j.marker<=65495))break;t+=2}return t-y}function S(e,t,a){const n=e.quantizationTable,r=e.blockData;let i,o,c,l,y,w,x,S,A,k,C,v,F,O,I,T,M;if(!n)throw new s("missing required Quantization Table.");for(let e=0;e<64;e+=8)A=r[t+e],k=r[t+e+1],C=r[t+e+2],v=r[t+e+3],F=r[t+e+4],O=r[t+e+5],I=r[t+e+6],T=r[t+e+7],A*=n[e],0!=(k|C|v|F|O|I|T)?(k*=n[e+1],C*=n[e+2],v*=n[e+3],F*=n[e+4],O*=n[e+5],I*=n[e+6],T*=n[e+7],i=m*A+128>>8,o=m*F+128>>8,c=C,l=I,y=b*(k-T)+128>>8,S=b*(k+T)+128>>8,w=v<<4,x=O<<4,i=i+o+1>>1,o=i-o,M=c*p+l*g+128>>8,c=c*g-l*p+128>>8,l=M,y=y+x+1>>1,x=y-x,S=S+w+1>>1,w=S-w,i=i+l+1>>1,l=i-l,o=o+c+1>>1,c=o-c,M=y*f+S*d+2048>>12,y=y*d-S*f+2048>>12,S=M,M=w*u+x*h+2048>>12,w=w*h-x*u+2048>>12,x=M,a[e]=i+S,a[e+7]=i-S,a[e+1]=o+x,a[e+6]=o-x,a[e+2]=c+w,a[e+5]=c-w,a[e+3]=l+y,a[e+4]=l-y):(M=m*A+512>>10,a[e]=M,a[e+1]=M,a[e+2]=M,a[e+3]=M,a[e+4]=M,a[e+5]=M,a[e+6]=M,a[e+7]=M);for(let e=0;e<8;++e)A=a[e],k=a[e+8],C=a[e+16],v=a[e+24],F=a[e+32],O=a[e+40],I=a[e+48],T=a[e+56],0!=(k|C|v|F|O|I|T)?(i=m*A+2048>>12,o=m*F+2048>>12,c=C,l=I,y=b*(k-T)+2048>>12,S=b*(k+T)+2048>>12,w=v,x=O,i=4112+(i+o+1>>1),o=i-o,M=c*p+l*g+2048>>12,c=c*g-l*p+2048>>12,l=M,y=y+x+1>>1,x=y-x,S=S+w+1>>1,w=S-w,i=i+l+1>>1,l=i-l,o=o+c+1>>1,c=o-c,M=y*f+S*d+2048>>12,y=y*d-S*f+2048>>12,S=M,M=w*u+x*h+2048>>12,w=w*h-x*u+2048>>12,x=M,A=i+S,T=i-S,k=o+x,I=o-x,C=c+w,O=c-w,v=l+y,F=l-y,A<16?A=0:A>=4080?A=255:A>>=4,k<16?k=0:k>=4080?k=255:k>>=4,C<16?C=0:C>=4080?C=255:C>>=4,v<16?v=0:v>=4080?v=255:v>>=4,F<16?F=0:F>=4080?F=255:F>>=4,O<16?O=0:O>=4080?O=255:O>>=4,I<16?I=0:I>=4080?I=255:I>>=4,T<16?T=0:T>=4080?T=255:T>>=4,r[t+e]=A,r[t+e+8]=k,r[t+e+16]=C,r[t+e+24]=v,r[t+e+32]=F,r[t+e+40]=O,r[t+e+48]=I,r[t+e+56]=T):(M=m*A+8192>>14,M=M<-2040?0:M>=2024?255:M+2056>>4,r[t+e]=M,r[t+e+8]=M,r[t+e+16]=M,r[t+e+24]=M,r[t+e+32]=M,r[t+e+40]=M,r[t+e+48]=M,r[t+e+56]=M)}function A(e,t){const a=t.blocksPerLine,n=t.blocksPerColumn,r=new Int16Array(64);for(let e=0;e<n;e++)for(let n=0;n<a;n++){S(t,w(t,e,n),r)}return t.blockData}function k(e,t,a=t){const n=e.length-1;let r=a<t?a:t;if(t>=n)return null;const s=(0,i.readUint16)(e,t);if(s>=65472&&s<=65534)return{invalid:null,marker:s,offset:t};let o=(0,i.readUint16)(e,r);for(;!(o>=65472&&o<=65534);){if(++r>=n)return null;o=(0,i.readUint16)(e,r)}return{invalid:s.toString(16),marker:o,offset:r}}t.JpegImage=class{constructor({decodeTransform:e=null,colorTransform:t=-1}={}){this._decodeTransform=e,this._colorTransform=t}parse(e,{dnlScanLines:t=null}={}){function a(){const t=(0,i.readUint16)(e,d);d+=2;let a=d+t-2;const r=k(e,a,d);r?.invalid&&((0,n.warn)("readDataBlock - incorrect length, current marker is: "+r.invalid),a=r.offset);const s=e.subarray(d,a);return d+=s.length,s}function r(e){const t=Math.ceil(e.samplesPerLine/8/e.maxH),a=Math.ceil(e.scanLines/8/e.maxV);for(const n of e.components){const r=Math.ceil(Math.ceil(e.samplesPerLine/8)*n.h/e.maxH),i=Math.ceil(Math.ceil(e.scanLines/8)*n.v/e.maxV),s=t*n.h,o=64*(a*n.v)*(s+1);n.blockData=new Int16Array(o),n.blocksPerLine=r,n.blocksPerColumn=i}e.mcusPerLine=t,e.mcusPerColumn=a}let h,u,d=0,f=null,g=null,p=0;const m=[],b=[],w=[];let S=(0,i.readUint16)(e,d);if(d+=2,65496!==S)throw new s("SOI not found");S=(0,i.readUint16)(e,d),d+=2;e:for(;65497!==S;){let A,C,v;switch(S){case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:const F=a();65504===S&&74===F[0]&&70===F[1]&&73===F[2]&&70===F[3]&&0===F[4]&&(f={version:{major:F[5],minor:F[6]},densityUnits:F[7],xDensity:F[8]<<8|F[9],yDensity:F[10]<<8|F[11],thumbWidth:F[12],thumbHeight:F[13],thumbData:F.subarray(14,14+3*F[12]*F[13])}),65518===S&&65===F[0]&&100===F[1]&&111===F[2]&&98===F[3]&&101===F[4]&&(g={version:F[5]<<8|F[6],flags0:F[7]<<8|F[8],flags1:F[9]<<8|F[10],transformCode:F[11]});break;case 65499:const O=(0,i.readUint16)(e,d);d+=2;const I=O+d-2;let T;for(;d<I;){const t=e[d++],a=new Uint16Array(64);if(t>>4==0)for(C=0;C<64;C++)T=l[C],a[T]=e[d++];else{if(t>>4!=1)throw new s("DQT - invalid table spec");for(C=0;C<64;C++)T=l[C],a[T]=(0,i.readUint16)(e,d),d+=2}m[15&t]=a}break;case 65472:case 65473:case 65474:if(h)throw new s("Only single frame JPEGs supported");d+=2,h={},h.extended=65473===S,h.progressive=65474===S,h.precision=e[d++];const M=(0,i.readUint16)(e,d);d+=2,h.scanLines=t||M,h.samplesPerLine=(0,i.readUint16)(e,d),d+=2,h.components=[],h.componentIds={};const P=e[d++];let N=0,D=0;for(A=0;A<P;A++){const t=e[d],a=e[d+1]>>4,n=15&e[d+1];N<a&&(N=a),D<n&&(D=n);const r=e[d+2];v=h.components.push({h:a,v:n,quantizationId:r,quantizationTable:null}),h.componentIds[t]=v-1,d+=3}h.maxH=N,h.maxV=D,r(h);break;case 65476:const R=(0,i.readUint16)(e,d);for(d+=2,A=2;A<R;){const t=e[d++],a=new Uint8Array(16);let n=0;for(C=0;C<16;C++,d++)n+=a[C]=e[d];const r=new Uint8Array(n);for(C=0;C<n;C++,d++)r[C]=e[d];A+=17+n,(t>>4==0?w:b)[15&t]=y(a,r)}break;case 65501:d+=2,u=(0,i.readUint16)(e,d),d+=2;break;case 65498:const E=1==++p&&!t;d+=2;const B=e[d++],$=[];for(A=0;A<B;A++){const t=e[d++],a=h.componentIds[t],n=h.components[a];n.index=t;const r=e[d++];n.huffmanTableDC=w[r>>4],n.huffmanTableAC=b[15&r],$.push(n)}const L=e[d++],_=e[d++],j=e[d++];try{const t=x(e,d,h,$,u,L,_,j>>4,15&j,E);d+=t}catch(t){if(t instanceof o)return(0,n.warn)(`${t.message} -- attempting to re-parse the JPEG image.`),this.parse(e,{dnlScanLines:t.scanLines});if(t instanceof c){(0,n.warn)(`${t.message} -- ignoring the rest of the image data.`);break e}throw t}break;case 65500:d+=4;break;case 65535:255!==e[d]&&d--;break;default:const U=k(e,d-2,d-3);if(U?.invalid){(0,n.warn)("JpegImage.parse - unexpected data, current marker is: "+U.invalid),d=U.offset;break}if(!U||d>=e.length-1){(0,n.warn)("JpegImage.parse - reached the end of the image data without finding an EOI marker (0xFFD9).");break e}throw new s("JpegImage.parse - unknown marker: "+S.toString(16))}S=(0,i.readUint16)(e,d),d+=2}this.width=h.samplesPerLine,this.height=h.scanLines,this.jfif=f,this.adobe=g,this.components=[];for(const e of h.components){const t=m[e.quantizationId];t&&(e.quantizationTable=t),this.components.push({index:e.index,output:A(0,e),scaleX:e.h/h.maxH,scaleY:e.v/h.maxV,blocksPerLine:e.blocksPerLine,blocksPerColumn:e.blocksPerColumn})}this.numComponents=this.components.length}_getLinearizedBlockData(e,t,a=!1){const n=this.width/e,r=this.height/t;let i,s,o,c,l,h,u,d,f,g,p,m=0;const b=this.components.length,y=e*t*b,w=new Uint8ClampedArray(y),x=new Uint32Array(e),S=4294967288;let A;for(u=0;u<b;u++){if(i=this.components[u],s=i.scaleX*n,o=i.scaleY*r,m=u,p=i.output,c=i.blocksPerLine+1<<3,s!==A){for(l=0;l<e;l++)d=0|l*s,x[l]=(d&S)<<3|7&d;A=s}for(h=0;h<t;h++)for(d=0|h*o,g=c*(d&S)|(7&d)<<3,l=0;l<e;l++)w[m]=p[g+x[l]],m+=b}let k=this._decodeTransform;if(a||4!==b||k||(k=new Int32Array([-256,255,-256,255,-256,255,-256,255])),k)for(u=0;u<y;)for(d=0,f=0;d<b;d++,u++,f+=2)w[u]=(w[u]*k[f]>>8)+k[f+1];return w}get _isColorConversionNeeded(){return this.adobe?!!this.adobe.transformCode:3===this.numComponents?0!==this._colorTransform&&(82!==this.components[0].index||71!==this.components[1].index||66!==this.components[2].index):1===this._colorTransform}_convertYccToRgb(e){let t,a,n;for(let r=0,i=e.length;r<i;r+=3)t=e[r],a=e[r+1],n=e[r+2],e[r]=t-179.456+1.402*n,e[r+1]=t+135.459-.344*a-.714*n,e[r+2]=t-226.816+1.772*a;return e}_convertYccToRgba(e,t){for(let a=0,n=0,r=e.length;a<r;a+=3,n+=4){const r=e[a],i=e[a+1],s=e[a+2];t[n]=r-179.456+1.402*s,t[n+1]=r+135.459-.344*i-.714*s,t[n+2]=r-226.816+1.772*i,t[n+3]=255}return t}_convertYcckToRgb(e){let t,a,n,r,i=0;for(let s=0,o=e.length;s<o;s+=4)t=e[s],a=e[s+1],n=e[s+2],r=e[s+3],e[i++]=a*(-660635669420364e-19*a+.000437130475926232*n-54080610064599e-18*t+.00048449797120281*r-.154362151871126)-122.67195406894+n*(-.000957964378445773*n+.000817076911346625*t-.00477271405408747*r+1.53380253221734)+t*(.000961250184130688*t-.00266257332283933*r+.48357088451265)+r*(-.000336197177618394*r+.484791561490776),e[i++]=107.268039397724+a*(219927104525741e-19*a-.000640992018297945*n+.000659397001245577*t+.000426105652938837*r-.176491792462875)+n*(-.000778269941513683*n+.00130872261408275*t+.000770482631801132*r-.151051492775562)+t*(.00126935368114843*t-.00265090189010898*r+.25802910206845)+r*(-.000318913117588328*r-.213742400323665),e[i++]=a*(-.000570115196973677*a-263409051004589e-19*n+.0020741088115012*t-.00288260236853442*r+.814272968359295)-20.810012546947+n*(-153496057440975e-19*n-.000132689043961446*t+.000560833691242812*r-.195152027534049)+t*(.00174418132927582*t-.00255243321439347*r+.116935020465145)+r*(-.000343531996510555*r+.24165260232407);return e.subarray(0,i)}_convertYcckToRgba(e){for(let t=0,a=e.length;t<a;t+=4){const a=e[t],n=e[t+1],r=e[t+2],i=e[t+3];e[t]=n*(-660635669420364e-19*n+.000437130475926232*r-54080610064599e-18*a+.00048449797120281*i-.154362151871126)-122.67195406894+r*(-.000957964378445773*r+.000817076911346625*a-.00477271405408747*i+1.53380253221734)+a*(.000961250184130688*a-.00266257332283933*i+.48357088451265)+i*(-.000336197177618394*i+.484791561490776),e[t+1]=107.268039397724+n*(219927104525741e-19*n-.000640992018297945*r+.000659397001245577*a+.000426105652938837*i-.176491792462875)+r*(-.000778269941513683*r+.00130872261408275*a+.000770482631801132*i-.151051492775562)+a*(.00126935368114843*a-.00265090189010898*i+.25802910206845)+i*(-.000318913117588328*i-.213742400323665),e[t+2]=n*(-.000570115196973677*n-263409051004589e-19*r+.0020741088115012*a-.00288260236853442*i+.814272968359295)-20.810012546947+r*(-153496057440975e-19*r-.000132689043961446*a+.000560833691242812*i-.195152027534049)+a*(.00174418132927582*a-.00255243321439347*i+.116935020465145)+i*(-.000343531996510555*i+.24165260232407),e[t+3]=255}return e}_convertYcckToCmyk(e){let t,a,n;for(let r=0,i=e.length;r<i;r+=4)t=e[r],a=e[r+1],n=e[r+2],e[r]=434.456-t-1.402*n,e[r+1]=119.541-t+.344*a+.714*n,e[r+2]=481.816-t-1.772*a;return e}_convertCmykToRgb(e){let t,a,n,r,i=0;for(let s=0,o=e.length;s<o;s+=4)t=e[s],a=e[s+1],n=e[s+2],r=e[s+3],e[i++]=255+t*(-6747147073602441e-20*t+.0008379262121013727*a+.0002894718188643294*n+.003264231057537806*r-1.1185611867203937)+a*(26374107616089405e-21*a-8626949158638572e-20*n-.0002748769067499491*r-.02155688794978967)+n*(-3878099212869363e-20*n-.0003267808279485286*r+.0686742238595345)-r*(.0003361971776183937*r+.7430659151342254),e[i++]=255+t*(.00013596372813588848*t+.000924537132573585*a+.00010567359618683593*n+.0004791864687436512*r-.3109689587515875)+a*(-.00023545346108370344*a+.0002702845253534714*n+.0020200308977307156*r-.7488052167015494)+n*(6834815998235662e-20*n+.00015168452363460973*r-.09751927774728933)-r*(.0003189131175883281*r+.7364883807733168),e[i++]=255+t*(13598650411385307e-21*t+.00012423956175490851*a+.0004751985097583589*n-36729317476630422e-22*r-.05562186980264034)+a*(.00016141380598724676*a+.0009692239130725186*n+.0007782692450036253*r-.44015232367526463)+n*(5.068882914068769e-7*n+.0017778369011375071*r-.7591454649749609)-r*(.0003435319965105553*r+.7063770186160144);return e.subarray(0,i)}_convertCmykToRgba(e){for(let t=0,a=e.length;t<a;t+=4){const a=e[t],n=e[t+1],r=e[t+2],i=e[t+3];e[t]=255+a*(-6747147073602441e-20*a+.0008379262121013727*n+.0002894718188643294*r+.003264231057537806*i-1.1185611867203937)+n*(26374107616089405e-21*n-8626949158638572e-20*r-.0002748769067499491*i-.02155688794978967)+r*(-3878099212869363e-20*r-.0003267808279485286*i+.0686742238595345)-i*(.0003361971776183937*i+.7430659151342254),e[t+1]=255+a*(.00013596372813588848*a+.000924537132573585*n+.00010567359618683593*r+.0004791864687436512*i-.3109689587515875)+n*(-.00023545346108370344*n+.0002702845253534714*r+.0020200308977307156*i-.7488052167015494)+r*(6834815998235662e-20*r+.00015168452363460973*i-.09751927774728933)-i*(.0003189131175883281*i+.7364883807733168),e[t+2]=255+a*(13598650411385307e-21*a+.00012423956175490851*n+.0004751985097583589*r-36729317476630422e-22*i-.05562186980264034)+n*(.00016141380598724676*n+.0009692239130725186*r+.0007782692450036253*i-.44015232367526463)+r*(5.068882914068769e-7*r+.0017778369011375071*i-.7591454649749609)-i*(.0003435319965105553*i+.7063770186160144),e[t+3]=255}return e}getData({width:e,height:t,forceRGBA:a=!1,forceRGB:n=!1,isSourcePDF:i=!1}){if(this.numComponents>4)throw new s("Unsupported color mode");const o=this._getLinearizedBlockData(e,t,i);if(1===this.numComponents&&(a||n)){const e=o.length*(a?4:3),t=new Uint8ClampedArray(e);let n=0;if(a)(0,r.grayToRGBA)(o,new Uint32Array(t.buffer));else for(const e of o)t[n++]=e,t[n++]=e,t[n++]=e;return t}if(3===this.numComponents&&this._isColorConversionNeeded){if(a){const e=new Uint8ClampedArray(o.length/3*4);return this._convertYccToRgba(o,e)}return this._convertYccToRgb(o)}if(4===this.numComponents){if(this._isColorConversionNeeded)return a?this._convertYcckToRgba(o):n?this._convertYcckToRgb(o):this._convertYcckToCmyk(o);if(a)return this._convertCmykToRgba(o);if(n)return this._convertCmykToRgb(o)}return o}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.convertBlackAndWhiteToRGBA=r,t.convertToRGBA=function(e){switch(e.kind){case n.ImageKind.GRAYSCALE_1BPP:return r(e);case n.ImageKind.RGB_24BPP:return function({src:e,srcPos:t=0,dest:a,destPos:r=0,width:i,height:s}){let o=0;const c=e.length>>2,l=new Uint32Array(e.buffer,t,c);if(n.FeatureTest.isLittleEndian){for(;o<c-2;o+=3,r+=4){const e=l[o],t=l[o+1],n=l[o+2];a[r]=4278190080|e,a[r+1]=e>>>24|t<<8|4278190080,a[r+2]=t>>>16|n<<16|4278190080,a[r+3]=n>>>8|4278190080}for(let t=4*o,n=e.length;t<n;t+=3)a[r++]=e[t]|e[t+1]<<8|e[t+2]<<16|4278190080}else{for(;o<c-2;o+=3,r+=4){const e=l[o],t=l[o+1],n=l[o+2];a[r]=255|e,a[r+1]=e<<24|t>>>8|255,a[r+2]=t<<16|n>>>16|255,a[r+3]=n<<8|255}for(let t=4*o,n=e.length;t<n;t+=3)a[r++]=e[t]<<24|e[t+1]<<16|e[t+2]<<8|255}return{srcPos:t,destPos:r}}(e)}return null},t.grayToRGBA=function(e,t){if(n.FeatureTest.isLittleEndian)for(let a=0,n=e.length;a<n;a++)t[a]=65793*e[a]|4278190080;else for(let a=0,n=e.length;a<n;a++)t[a]=16843008*e[a]|255};var n=a(2);function r({src:e,srcPos:t=0,dest:a,width:r,height:i,nonBlackColor:s=4294967295,inverseDecode:o=!1}){const c=n.FeatureTest.isLittleEndian?4278190080:255,[l,h]=o?[s,c]:[c,s],u=r>>3,d=7&r,f=e.length;a=new Uint32Array(a.buffer);let g=0;for(let n=0;n<i;n++){for(const n=t+u;t<n;t++){const n=t<f?e[t]:255;a[g++]=128&n?h:l,a[g++]=64&n?h:l,a[g++]=32&n?h:l,a[g++]=16&n?h:l,a[g++]=8&n?h:l,a[g++]=4&n?h:l,a[g++]=2&n?h:l,a[g++]=1&n?h:l}if(0===d)continue;const n=t<f?e[t++]:255;for(let e=0;e<d;e++)a[g++]=n&1<<7-e?h:l}return{srcPos:t,destPos:g}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.JpxStream=void 0;var n=a(18),r=a(30),i=a(2);class s extends n.DecodeStream{constructor(e,t,a){super(t),this.stream=e,this.dict=e.dict,this.maybeLength=t,this.params=a}get bytes(){return(0,i.shadow)(this,"bytes",this.stream.getBytes(this.maybeLength))}ensureBuffer(e){}readBlock(){if(this.eof)return;const e=new r.JpxImage;e.parse(this.bytes);const t=e.width,a=e.height,n=e.componentsCount,i=e.tiles.length;if(1===i)this.buffer=e.tiles[0].items;else{const r=new Uint8ClampedArray(t*a*n);for(let a=0;a<i;a++){const i=e.tiles[a],s=i.width,o=i.height,c=i.left,l=i.top,h=i.items;let u=0,d=(t*l+c)*n;const f=t*n,g=s*n;for(let e=0;e<o;e++){const e=h.subarray(u,u+g);r.set(e,d),u+=g,d+=f}}this.buffer=r}this.bufferLength=this.buffer.length,this.eof=!0}}t.JpxStream=s},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.JpxImage=void 0;var n=a(2),r=a(3),i=a(25);class s extends n.BaseException{constructor(e){super(`JPX error: ${e}`,"JpxError")}}const o={LL:0,LH:1,HL:1,HH:2};function c(e,t){e.x0=Math.ceil(t.XOsiz/e.XRsiz),e.x1=Math.ceil(t.Xsiz/e.XRsiz),e.y0=Math.ceil(t.YOsiz/e.YRsiz),e.y1=Math.ceil(t.Ysiz/e.YRsiz),e.width=e.x1-e.x0,e.height=e.y1-e.y0}function l(e,t){const a=e.SIZ,n=[];let r;const i=Math.ceil((a.Xsiz-a.XTOsiz)/a.XTsiz),s=Math.ceil((a.Ysiz-a.YTOsiz)/a.YTsiz);for(let e=0;e<s;e++)for(let t=0;t<i;t++)r={},r.tx0=Math.max(a.XTOsiz+t*a.XTsiz,a.XOsiz),r.ty0=Math.max(a.YTOsiz+e*a.YTsiz,a.YOsiz),r.tx1=Math.min(a.XTOsiz+(t+1)*a.XTsiz,a.Xsiz),r.ty1=Math.min(a.YTOsiz+(e+1)*a.YTsiz,a.Ysiz),r.width=r.tx1-r.tx0,r.height=r.ty1-r.ty0,r.components=[],n.push(r);e.tiles=n;for(let e=0,i=a.Csiz;e<i;e++){const a=t[e];for(let t=0,i=n.length;t<i;t++){const i={};r=n[t],i.tcx0=Math.ceil(r.tx0/a.XRsiz),i.tcy0=Math.ceil(r.ty0/a.YRsiz),i.tcx1=Math.ceil(r.tx1/a.XRsiz),i.tcy1=Math.ceil(r.ty1/a.YRsiz),i.width=i.tcx1-i.tcx0,i.height=i.tcy1-i.tcy0,r.components[e]=i}}}function h(e,t,a){const n=t.codingStyleParameters,r={};return n.entropyCoderWithCustomPrecincts?(r.PPx=n.precinctsSizes[a].PPx,r.PPy=n.precinctsSizes[a].PPy):(r.PPx=15,r.PPy=15),r.xcb_=a>0?Math.min(n.xcb,r.PPx-1):Math.min(n.xcb,r.PPx),r.ycb_=a>0?Math.min(n.ycb,r.PPy-1):Math.min(n.ycb,r.PPy),r}function u(e,t,a){const n=1<<a.PPx,r=1<<a.PPy,i=0===t.resLevel,s=1<<a.PPx+(i?0:-1),o=1<<a.PPy+(i?0:-1),c=t.trx1>t.trx0?Math.ceil(t.trx1/n)-Math.floor(t.trx0/n):0,l=t.try1>t.try0?Math.ceil(t.try1/r)-Math.floor(t.try0/r):0,h=c*l;t.precinctParameters={precinctWidth:n,precinctHeight:r,numprecinctswide:c,numprecinctshigh:l,numprecincts:h,precinctWidthInSubband:s,precinctHeightInSubband:o}}function d(e,t,a){const n=a.xcb_,r=a.ycb_,i=1<<n,s=1<<r,o=t.tbx0>>n,c=t.tby0>>r,l=t.tbx1+i-1>>n,h=t.tby1+s-1>>r,u=t.resolution.precinctParameters,d=[],f=[];let g,p,m,b;for(p=c;p<h;p++)for(g=o;g<l;g++){m={cbx:g,cby:p,tbx0:i*g,tby0:s*p,tbx1:i*(g+1),tby1:s*(p+1)},m.tbx0_=Math.max(t.tbx0,m.tbx0),m.tby0_=Math.max(t.tby0,m.tby0),m.tbx1_=Math.min(t.tbx1,m.tbx1),m.tby1_=Math.min(t.tby1,m.tby1);if(b=Math.floor((m.tbx0_-t.tbx0)/u.precinctWidthInSubband)+Math.floor((m.tby0_-t.tby0)/u.precinctHeightInSubband)*u.numprecinctswide,m.precinctNumber=b,m.subbandType=t.type,m.Lblock=3,m.tbx1_<=m.tbx0_||m.tby1_<=m.tby0_)continue;d.push(m);let e=f[b];void 0!==e?(g<e.cbxMin?e.cbxMin=g:g>e.cbxMax&&(e.cbxMax=g),p<e.cbyMin?e.cbxMin=p:p>e.cbyMax&&(e.cbyMax=p)):f[b]=e={cbxMin:g,cbyMin:p,cbxMax:g,cbyMax:p},m.precinct=e}t.codeblockParameters={codeblockWidth:n,codeblockHeight:r,numcodeblockwide:l-o+1,numcodeblockhigh:h-c+1},t.codeblocks=d,t.precincts=f}function f(e,t,a){const n=[],r=e.subbands;for(let e=0,a=r.length;e<a;e++){const a=r[e].codeblocks;for(let e=0,r=a.length;e<r;e++){const r=a[e];r.precinctNumber===t&&n.push(r)}}return{layerNumber:a,codeblocks:n}}function g(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let o=0;for(let e=0;e<i;e++)o=Math.max(o,n.components[e].codingStyleParameters.decompositionLevelsCount);let c=0,l=0,h=0,u=0;this.nextPacket=function(){for(;c<r;c++){for(;l<=o;l++){for(;h<i;h++){const e=n.components[h];if(l>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[l],a=t.precinctParameters.numprecincts;for(;u<a;){const e=f(t,u,c);return u++,e}u=0}h=0}l=0}throw new s("Out of packets")}}function p(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let o=0;for(let e=0;e<i;e++)o=Math.max(o,n.components[e].codingStyleParameters.decompositionLevelsCount);let c=0,l=0,h=0,u=0;this.nextPacket=function(){for(;c<=o;c++){for(;l<r;l++){for(;h<i;h++){const e=n.components[h];if(c>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[c],a=t.precinctParameters.numprecincts;for(;u<a;){const e=f(t,u,l);return u++,e}u=0}h=0}l=0}throw new s("Out of packets")}}function m(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=n.codingStyleDefaultParameters.layersCount,i=t.Csiz;let o,c,l,h,u=0;for(l=0;l<i;l++){const e=n.components[l];u=Math.max(u,e.codingStyleParameters.decompositionLevelsCount)}const d=new Int32Array(u+1);for(c=0;c<=u;++c){let e=0;for(l=0;l<i;++l){const t=n.components[l].resolutions;c<t.length&&(e=Math.max(e,t[c].precinctParameters.numprecincts))}d[c]=e}o=0,c=0,l=0,h=0,this.nextPacket=function(){for(;c<=u;c++){for(;h<d[c];h++){for(;l<i;l++){const e=n.components[l];if(c>e.codingStyleParameters.decompositionLevelsCount)continue;const t=e.resolutions[c],a=t.precinctParameters.numprecincts;if(!(h>=a)){for(;o<r;){const e=f(t,h,o);return o++,e}o=0}}l=0}h=0}throw new s("Out of packets")}}function b(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=n.codingStyleDefaultParameters.layersCount,i=t.Csiz,o=x(n),c=o;let l=0,h=0,u=0,d=0,g=0;this.nextPacket=function(){for(;g<c.maxNumHigh;g++){for(;d<c.maxNumWide;d++){for(;u<i;u++){const e=n.components[u],t=e.codingStyleParameters.decompositionLevelsCount;for(;h<=t;h++){const t=e.resolutions[h],a=o.components[u].resolutions[h],n=w(d,g,a,c,t);if(null!==n){for(;l<r;){const e=f(t,n,l);return l++,e}l=0}}h=0}u=0}d=0}throw new s("Out of packets")}}function y(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=n.codingStyleDefaultParameters.layersCount,i=t.Csiz,o=x(n);let c=0,l=0,h=0,u=0,d=0;this.nextPacket=function(){for(;h<i;++h){const e=n.components[h],t=o.components[h],a=e.codingStyleParameters.decompositionLevelsCount;for(;d<t.maxNumHigh;d++){for(;u<t.maxNumWide;u++){for(;l<=a;l++){const a=e.resolutions[l],n=t.resolutions[l],i=w(u,d,n,t,a);if(null!==i){for(;c<r;){const e=f(a,i,c);return c++,e}c=0}}l=0}u=0}d=0}throw new s("Out of packets")}}function w(e,t,a,n,r){const i=e*n.minWidth,s=t*n.minHeight;if(i%a.width!=0||s%a.height!=0)return null;const o=s/a.width*r.precinctParameters.numprecinctswide;return i/a.height+o}function x(e){const t=e.components.length;let a=Number.MAX_VALUE,n=Number.MAX_VALUE,r=0,i=0;const s=new Array(t);for(let o=0;o<t;o++){const t=e.components[o],c=t.codingStyleParameters.decompositionLevelsCount,l=new Array(c+1);let h=Number.MAX_VALUE,u=Number.MAX_VALUE,d=0,f=0,g=1;for(let e=c;e>=0;--e){const a=t.resolutions[e],n=g*a.precinctParameters.precinctWidth,r=g*a.precinctParameters.precinctHeight;h=Math.min(h,n),u=Math.min(u,r),d=Math.max(d,a.precinctParameters.numprecinctswide),f=Math.max(f,a.precinctParameters.numprecinctshigh),l[e]={width:n,height:r},g<<=1}a=Math.min(a,h),n=Math.min(n,u),r=Math.max(r,d),i=Math.max(i,f),s[o]={resolutions:l,minWidth:h,minHeight:u,maxNumWide:d,maxNumHigh:f}}return{components:s,minWidth:a,minHeight:n,maxNumWide:r,maxNumHigh:i}}function S(e){const t=e.SIZ,a=e.currentTile.index,n=e.tiles[a],r=t.Csiz;for(let e=0;e<r;e++){const t=n.components[e],a=t.codingStyleParameters.decompositionLevelsCount,r=[],i=[];for(let e=0;e<=a;e++){const n=h(0,t,e),s={},o=1<<a-e;let c;if(s.trx0=Math.ceil(t.tcx0/o),s.try0=Math.ceil(t.tcy0/o),s.trx1=Math.ceil(t.tcx1/o),s.try1=Math.ceil(t.tcy1/o),s.resLevel=e,u(0,s,n),r.push(s),0===e)c={},c.type="LL",c.tbx0=Math.ceil(t.tcx0/o),c.tby0=Math.ceil(t.tcy0/o),c.tbx1=Math.ceil(t.tcx1/o),c.tby1=Math.ceil(t.tcy1/o),c.resolution=s,d(0,c,n),i.push(c),s.subbands=[c];else{const r=1<<a-e+1,o=[];c={},c.type="HL",c.tbx0=Math.ceil(t.tcx0/r-.5),c.tby0=Math.ceil(t.tcy0/r),c.tbx1=Math.ceil(t.tcx1/r-.5),c.tby1=Math.ceil(t.tcy1/r),c.resolution=s,d(0,c,n),i.push(c),o.push(c),c={},c.type="LH",c.tbx0=Math.ceil(t.tcx0/r),c.tby0=Math.ceil(t.tcy0/r-.5),c.tbx1=Math.ceil(t.tcx1/r),c.tby1=Math.ceil(t.tcy1/r-.5),c.resolution=s,d(0,c,n),i.push(c),o.push(c),c={},c.type="HH",c.tbx0=Math.ceil(t.tcx0/r-.5),c.tby0=Math.ceil(t.tcy0/r-.5),c.tbx1=Math.ceil(t.tcx1/r-.5),c.tby1=Math.ceil(t.tcy1/r-.5),c.resolution=s,d(0,c,n),i.push(c),o.push(c),s.subbands=o}}t.resolutions=r,t.subbands=i}const i=n.codingStyleDefaultParameters.progressionOrder;switch(i){case 0:n.packetsIterator=new g(e);break;case 1:n.packetsIterator=new p(e);break;case 2:n.packetsIterator=new m(e);break;case 3:n.packetsIterator=new b(e);break;case 4:n.packetsIterator=new y(e);break;default:throw new s(`Unsupported progression order ${i}`)}}function A(e,t,a,n){let i,o=0,c=0,l=!1;function h(e){for(;c<e;){const e=t[a+o];o++,l?(i=i<<7|e,c+=7,l=!1):(i=i<<8|e,c+=8),255===e&&(l=!0)}return c-=e,i>>>c&(1<<e)-1}function u(e){return 255===t[a+o-1]&&t[a+o]===e?(d(1),!0):255===t[a+o]&&t[a+o+1]===e&&(d(2),!0)}function d(e){o+=e}function f(){c=0,l&&(o++,l=!1)}function g(){if(0===h(1))return 1;if(0===h(1))return 2;let e=h(2);return e<3?e+3:(e=h(5),e<31?e+6:(e=h(7),e+37))}const p=e.currentTile.index,m=e.tiles[p],b=e.COD.sopMarkerUsed,y=e.COD.ephMarkerUsed,w=m.packetsIterator;for(;o<n;){f(),b&&u(145)&&d(4);const e=w.nextPacket();if(!h(1))continue;const n=e.layerNumber,i=[];let c;for(let t=0,a=e.codeblocks.length;t<a;t++){c=e.codeblocks[t];let a=c.precinct;const o=c.cbx-a.cbxMin,l=c.cby-a.cbyMin;let u,d,f=!1,p=!1;if(void 0!==c.included)f=!!h(1);else{let e;if(a=c.precinct,void 0!==a.inclusionTree)e=a.inclusionTree;else{const t=a.cbxMax-a.cbxMin+1,r=a.cbyMax-a.cbyMin+1;e=new O(t,r,n),d=new F(t,r),a.inclusionTree=e,a.zeroBitPlanesTree=d;for(let e=0;e<n;e++)if(0!==h(1))throw new s("Invalid tag tree")}if(e.reset(o,l,n))for(;;){if(!h(1)){e.incrementValue(n);break}if(u=!e.nextLevel(),u){c.included=!0,f=p=!0;break}}}if(!f)continue;if(p){for(d=a.zeroBitPlanesTree,d.reset(o,l);;)if(h(1)){if(u=!d.nextLevel(),u)break}else d.incrementValue();c.zeroBitPlanes=d.value}const m=g();for(;h(1);)c.Lblock++;const b=(0,r.log2)(m),y=h((m<1<<b?b-1:b)+c.Lblock);i.push({codeblock:c,codingpasses:m,dataLength:y})}for(f(),y&&u(146);i.length>0;){const e=i.shift();c=e.codeblock,void 0===c.data&&(c.data=[]),c.data.push({data:t,start:a+o,end:a+o+e.dataLength,codingpasses:e.codingpasses}),o+=e.dataLength}}return o}function k(e,t,a,n,r,s,o,c,l){const h=n.tbx0,u=n.tby0,d=n.tbx1-n.tbx0,f=n.codeblocks,g="H"===n.type.charAt(0)?1:0,p="H"===n.type.charAt(1)?t:0;for(let a=0,m=f.length;a<m;++a){const m=f[a],b=m.tbx1_-m.tbx0_,y=m.tby1_-m.tby0_;if(0===b||0===y)continue;if(void 0===m.data)continue;const w=new I(b,y,m.subbandType,m.zeroBitPlanes,s);let x=2;const S=m.data;let A,k,C,v=0,F=0;for(A=0,k=S.length;A<k;A++)C=S[A],v+=C.end-C.start,F+=C.codingpasses;const O=new Uint8Array(v);let T=0;for(A=0,k=S.length;A<k;A++){C=S[A];const e=C.data.subarray(C.start,C.end);O.set(e,T),T+=e.length}const M=new i.ArithmeticDecoder(O,0,v);for(w.setDecoder(M),A=0;A<F;A++){switch(x){case 0:w.runSignificancePropagationPass();break;case 1:w.runMagnitudeRefinementPass();break;case 2:w.runCleanupPass(),c&&w.checkSegmentationSymbol()}l&&w.reset(),x=(x+1)%3}let P=m.tbx0_-h+(m.tby0_-u)*d;const N=w.coefficentsSign,D=w.coefficentsMagnitude,R=w.bitsDecoded,E=o?0:.5;let B,$,L;T=0;const _="LL"!==n.type;for(A=0;A<y;A++){const a=2*(P/d|0)*(t-d)+g+p;for(B=0;B<b;B++){if($=D[T],0!==$){$=($+E)*r,0!==N[T]&&($=-$),L=R[T];e[_?a+(P<<1):P]=o&&L>=s?$:$*(1<<s-L)}P++,T++}P+=d-b}}}function C(e,t,a){const n=t.components[a],r=n.codingStyleParameters,i=n.quantizationParameters,s=r.decompositionLevelsCount,c=i.SPqcds,l=i.scalarExpounded,h=i.guardBits,u=r.segmentationSymbolUsed,d=r.resetContextProbabilities,f=e.components[a].precision,g=r.reversibleTransformation,p=g?new P:new M,m=[];let b=0;for(let e=0;e<=s;e++){const t=n.resolutions[e],a=t.trx1-t.trx0,r=t.try1-t.try0,i=new Float32Array(a*r);for(let n=0,r=t.subbands.length;n<r;n++){let r,s;l?(r=c[b].mu,s=c[b].epsilon,b++):(r=c[0].mu,s=c[0].epsilon+(e>0?1-e:0));const p=t.subbands[n],m=o[p.type];k(i,a,0,p,g?1:2**(f+m-s)*(1+r/2048),h+s-1,g,u,d)}m.push({width:a,height:r,items:i})}const y=p.calculate(m,n.tcx0,n.tcy0);return{left:n.tcx0,top:n.tcy0,width:y.width,height:y.height,items:y.items}}function v(e,t){const a=e.SIZ.Csiz,n=e.tiles[t];for(let t=0;t<a;t++){const a=n.components[t],r=void 0!==e.currentTile.QCC[t]?e.currentTile.QCC[t]:e.currentTile.QCD;a.quantizationParameters=r;const i=void 0!==e.currentTile.COC[t]?e.currentTile.COC[t]:e.currentTile.COD;a.codingStyleParameters=i}n.codingStyleDefaultParameters=e.currentTile.COD}t.JpxImage=class{constructor(){this.failOnCorruptedImage=!1}parse(e){if(65359===(0,r.readUint16)(e,0))return void this.parseCodestream(e,0,e.length);const t=e.length;let a=0;for(;a<t;){let i=8,o=(0,r.readUint32)(e,a);const c=(0,r.readUint32)(e,a+4);if(a+=i,1===o&&(o=4294967296*(0,r.readUint32)(e,a)+(0,r.readUint32)(e,a+4),a+=8,i+=8),0===o&&(o=t-a+i),o<i)throw new s("Invalid box field size");const l=o-i;let h=!0;switch(c){case 1785737832:h=!1;break;case 1668246642:const t=e[a];if(1===t){const t=(0,r.readUint32)(e,a+3);switch(t){case 16:case 17:case 18:break;default:(0,n.warn)("Unknown colorspace "+t)}}else 2===t&&(0,n.info)("ICC profile not supported");break;case 1785737827:this.parseCodestream(e,a,a+l);break;case 1783636e3:218793738!==(0,r.readUint32)(e,a)&&(0,n.warn)("Invalid JP2 signature");break;case 1783634458:case 1718909296:case 1920099697:case 1919251232:case 1768449138:break;default:const i=String.fromCharCode(c>>24&255,c>>16&255,c>>8&255,255&c);(0,n.warn)(`Unsupported header type ${c} (${i}).`)}h&&(a+=l)}}parseImageProperties(e){let t=e.getByte();for(;t>=0;){const a=t;t=e.getByte();if(65361===(a<<8|t)){e.skip(4);const t=e.getInt32()>>>0,a=e.getInt32()>>>0,n=e.getInt32()>>>0,r=e.getInt32()>>>0;e.skip(16);const i=e.getUint16();return this.width=t-n,this.height=a-r,this.componentsCount=i,void(this.bitsPerComponent=8)}}throw new s("No size marker found in JPX stream")}parseCodestream(e,t,a){const i={};let o=!1;try{let s=t;for(;s+1<a;){const t=(0,r.readUint16)(e,s);s+=2;let a,h,u,d,f,g,p=0;switch(t){case 65359:i.mainHeader=!0;break;case 65497:break;case 65361:p=(0,r.readUint16)(e,s);const m={};m.Xsiz=(0,r.readUint32)(e,s+4),m.Ysiz=(0,r.readUint32)(e,s+8),m.XOsiz=(0,r.readUint32)(e,s+12),m.YOsiz=(0,r.readUint32)(e,s+16),m.XTsiz=(0,r.readUint32)(e,s+20),m.YTsiz=(0,r.readUint32)(e,s+24),m.XTOsiz=(0,r.readUint32)(e,s+28),m.YTOsiz=(0,r.readUint32)(e,s+32);const b=(0,r.readUint16)(e,s+36);m.Csiz=b;const y=[];a=s+38;for(let t=0;t<b;t++){const t={precision:1+(127&e[a]),isSigned:!!(128&e[a]),XRsiz:e[a+1],YRsiz:e[a+2]};a+=3,c(t,m),y.push(t)}i.SIZ=m,i.components=y,l(i,y),i.QCC=[],i.COC=[];break;case 65372:p=(0,r.readUint16)(e,s);const w={};switch(a=s+2,h=e[a++],31&h){case 0:d=8,f=!0;break;case 1:d=16,f=!1;break;case 2:d=16,f=!0;break;default:throw new Error("Invalid SQcd value "+h)}for(w.noQuantization=8===d,w.scalarExpounded=f,w.guardBits=h>>5,u=[];a<p+s;){const t={};8===d?(t.epsilon=e[a++]>>3,t.mu=0):(t.epsilon=e[a]>>3,t.mu=(7&e[a])<<8|e[a+1],a+=2),u.push(t)}w.SPqcds=u,i.mainHeader?i.QCD=w:(i.currentTile.QCD=w,i.currentTile.QCC=[]);break;case 65373:p=(0,r.readUint16)(e,s);const x={};let k;switch(a=s+2,i.SIZ.Csiz<257?k=e[a++]:(k=(0,r.readUint16)(e,a),a+=2),h=e[a++],31&h){case 0:d=8,f=!0;break;case 1:d=16,f=!1;break;case 2:d=16,f=!0;break;default:throw new Error("Invalid SQcd value "+h)}for(x.noQuantization=8===d,x.scalarExpounded=f,x.guardBits=h>>5,u=[];a<p+s;){const t={};8===d?(t.epsilon=e[a++]>>3,t.mu=0):(t.epsilon=e[a]>>3,t.mu=(7&e[a])<<8|e[a+1],a+=2),u.push(t)}x.SPqcds=u,i.mainHeader?i.QCC[k]=x:i.currentTile.QCC[k]=x;break;case 65362:p=(0,r.readUint16)(e,s);const C={};a=s+2;const F=e[a++];C.entropyCoderWithCustomPrecincts=!!(1&F),C.sopMarkerUsed=!!(2&F),C.ephMarkerUsed=!!(4&F),C.progressionOrder=e[a++],C.layersCount=(0,r.readUint16)(e,a),a+=2,C.multipleComponentTransform=e[a++],C.decompositionLevelsCount=e[a++],C.xcb=2+(15&e[a++]),C.ycb=2+(15&e[a++]);const O=e[a++];if(C.selectiveArithmeticCodingBypass=!!(1&O),C.resetContextProbabilities=!!(2&O),C.terminationOnEachCodingPass=!!(4&O),C.verticallyStripe=!!(8&O),C.predictableTermination=!!(16&O),C.segmentationSymbolUsed=!!(32&O),C.reversibleTransformation=e[a++],C.entropyCoderWithCustomPrecincts){const t=[];for(;a<p+s;){const n=e[a++];t.push({PPx:15&n,PPy:n>>4})}C.precinctsSizes=t}const I=[];C.selectiveArithmeticCodingBypass&&I.push("selectiveArithmeticCodingBypass"),C.terminationOnEachCodingPass&&I.push("terminationOnEachCodingPass"),C.verticallyStripe&&I.push("verticallyStripe"),C.predictableTermination&&I.push("predictableTermination"),I.length>0&&(o=!0,(0,n.warn)(`JPX: Unsupported COD options (${I.join(", ")}).`)),i.mainHeader?i.COD=C:(i.currentTile.COD=C,i.currentTile.COC=[]);break;case 65424:p=(0,r.readUint16)(e,s),g={},g.index=(0,r.readUint16)(e,s+2),g.length=(0,r.readUint32)(e,s+4),g.dataEnd=g.length+s-2,g.partIndex=e[s+8],g.partsCount=e[s+9],i.mainHeader=!1,0===g.partIndex&&(g.COD=i.COD,g.COC=i.COC.slice(0),g.QCD=i.QCD,g.QCC=i.QCC.slice(0)),i.currentTile=g;break;case 65427:g=i.currentTile,0===g.partIndex&&(v(i,g.index),S(i)),p=g.dataEnd-s,A(i,e,s,p);break;case 65363:(0,n.warn)("JPX: Codestream code 0xFF53 (COC) is not implemented.");case 65365:case 65367:case 65368:case 65380:p=(0,r.readUint16)(e,s);break;default:throw new Error("Unknown codestream code: "+t.toString(16))}s+=p}}catch(e){if(o||this.failOnCorruptedImage)throw new s(e.message);(0,n.warn)(`JPX: Trying to recover from: "${e.message}".`)}this.tiles=function(e){const t=e.SIZ,a=e.components,n=t.Csiz,r=[];for(let t=0,i=e.tiles.length;t<i;t++){const i=e.tiles[t],s=[];for(let t=0;t<n;t++)s[t]=C(e,i,t);const o=s[0],c=new Uint8ClampedArray(o.items.length*n),l={left:o.left,top:o.top,width:o.width,height:o.height,items:c};let h,u,d,f,g,p,m,b=0;if(i.codingStyleDefaultParameters.multipleComponentTransform){const e=4===n,t=s[0].items,r=s[1].items,o=s[2].items,l=e?s[3].items:null;h=a[0].precision-8,u=.5+(128<<h);const y=i.components[0],w=n-3;if(f=t.length,y.codingStyleParameters.reversibleTransformation)for(d=0;d<f;d++,b+=w){g=t[d]+u,p=r[d],m=o[d];const e=g-(m+p>>2);c[b++]=e+m>>h,c[b++]=e>>h,c[b++]=e+p>>h}else for(d=0;d<f;d++,b+=w)g=t[d]+u,p=r[d],m=o[d],c[b++]=g+1.402*m>>h,c[b++]=g-.34413*p-.71414*m>>h,c[b++]=g+1.772*p>>h;if(e)for(d=0,b=3;d<f;d++,b+=4)c[b]=l[d]+u>>h}else for(let e=0;e<n;e++){const t=s[e].items;for(h=a[e].precision-8,u=.5+(128<<h),b=e,d=0,f=t.length;d<f;d++)c[b]=t[d]+u>>h,b+=n}r.push(l)}return r}(i),this.width=i.SIZ.Xsiz-i.SIZ.XOsiz,this.height=i.SIZ.Ysiz-i.SIZ.YOsiz,this.componentsCount=i.SIZ.Csiz}};class F{constructor(e,t){const a=(0,r.log2)(Math.max(e,t))+1;this.levels=[];for(let n=0;n<a;n++){const a={width:e,height:t,items:[]};this.levels.push(a),e=Math.ceil(e/2),t=Math.ceil(t/2)}}reset(e,t){let a,n=0,r=0;for(;n<this.levels.length;){a=this.levels[n];const i=e+t*a.width;if(void 0!==a.items[i]){r=a.items[i];break}a.index=i,e>>=1,t>>=1,n++}n--,a=this.levels[n],a.items[a.index]=r,this.currentLevel=n,delete this.value}incrementValue(){const e=this.levels[this.currentLevel];e.items[e.index]++}nextLevel(){let e=this.currentLevel,t=this.levels[e];const a=t.items[t.index];return e--,e<0?(this.value=a,!1):(this.currentLevel=e,t=this.levels[e],t.items[t.index]=a,!0)}}class O{constructor(e,t,a){const n=(0,r.log2)(Math.max(e,t))+1;this.levels=[];for(let r=0;r<n;r++){const n=new Uint8Array(e*t);for(let e=0,t=n.length;e<t;e++)n[e]=a;const r={width:e,height:t,items:n};this.levels.push(r),e=Math.ceil(e/2),t=Math.ceil(t/2)}}reset(e,t,a){let n=0;for(;n<this.levels.length;){const r=this.levels[n],i=e+t*r.width;r.index=i;const s=r.items[i];if(255===s)break;if(s>a)return this.currentLevel=n,this.propagateValues(),!1;e>>=1,t>>=1,n++}return this.currentLevel=n-1,!0}incrementValue(e){const t=this.levels[this.currentLevel];t.items[t.index]=e+1,this.propagateValues()}propagateValues(){let e=this.currentLevel,t=this.levels[e];const a=t.items[t.index];for(;--e>=0;)t=this.levels[e],t.items[t.index]=a}nextLevel(){let e=this.currentLevel,t=this.levels[e];const a=t.items[t.index];return t.items[t.index]=255,e--,!(e<0)&&(this.currentLevel=e,t=this.levels[e],t.items[t.index]=a,!0)}}class I{static UNIFORM_CONTEXT=17;static RUNLENGTH_CONTEXT=18;static LLAndLHContextsLabel=new Uint8Array([0,5,8,0,3,7,8,0,4,7,8,0,0,0,0,0,1,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8,0,0,0,0,0,2,6,8,0,3,7,8,0,4,7,8]);static HLContextLabel=new Uint8Array([0,3,4,0,5,7,7,0,8,8,8,0,0,0,0,0,1,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8,0,0,0,0,0,2,3,4,0,6,7,7,0,8,8,8]);static HHContextLabel=new Uint8Array([0,1,2,0,1,2,2,0,2,2,2,0,0,0,0,0,3,4,5,0,4,5,5,0,5,5,5,0,0,0,0,0,6,7,7,0,7,7,7,0,7,7,7,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8,0,0,0,0,0,8,8,8,0,8,8,8,0,8,8,8]);constructor(e,t,a,n,r){let i;this.width=e,this.height=t,i="HH"===a?I.HHContextLabel:"HL"===a?I.HLContextLabel:I.LLAndLHContextsLabel,this.contextLabelTable=i;const s=e*t;let o;this.neighborsSignificance=new Uint8Array(s),this.coefficentsSign=new Uint8Array(s),o=r>14?new Uint32Array(s):r>6?new Uint16Array(s):new Uint8Array(s),this.coefficentsMagnitude=o,this.processingFlags=new Uint8Array(s);const c=new Uint8Array(s);if(0!==n)for(let e=0;e<s;e++)c[e]=n;this.bitsDecoded=c,this.reset()}setDecoder(e){this.decoder=e}reset(){this.contexts=new Int8Array(19),this.contexts[0]=8,this.contexts[I.UNIFORM_CONTEXT]=92,this.contexts[I.RUNLENGTH_CONTEXT]=6}setNeighborsSignificance(e,t,a){const n=this.neighborsSignificance,r=this.width,i=this.height,s=t>0,o=t+1<r;let c;e>0&&(c=a-r,s&&(n[c-1]+=16),o&&(n[c+1]+=16),n[c]+=4),e+1<i&&(c=a+r,s&&(n[c-1]+=16),o&&(n[c+1]+=16),n[c]+=4),s&&(n[a-1]+=1),o&&(n[a+1]+=1),n[a]|=128}runSignificancePropagationPass(){const e=this.decoder,t=this.width,a=this.height,n=this.coefficentsMagnitude,r=this.coefficentsSign,i=this.neighborsSignificance,s=this.processingFlags,o=this.contexts,c=this.contextLabelTable,l=this.bitsDecoded;for(let h=0;h<a;h+=4)for(let u=0;u<t;u++){let d=h*t+u;for(let f=0;f<4;f++,d+=t){const t=h+f;if(t>=a)break;if(s[d]&=-2,n[d]||!i[d])continue;const g=c[i[d]];if(e.readBit(o,g)){const e=this.decodeSignBit(t,u,d);r[d]=e,n[d]=1,this.setNeighborsSignificance(t,u,d),s[d]|=2}l[d]++,s[d]|=1}}}decodeSignBit(e,t,a){const n=this.width,r=this.height,i=this.coefficentsMagnitude,s=this.coefficentsSign;let o,c,l,h,u,d;h=t>0&&0!==i[a-1],t+1<n&&0!==i[a+1]?(l=s[a+1],h?(c=s[a-1],o=1-l-c):o=1-l-l):h?(c=s[a-1],o=1-c-c):o=0;const f=3*o;return h=e>0&&0!==i[a-n],e+1<r&&0!==i[a+n]?(l=s[a+n],h?(c=s[a-n],o=1-l-c+f):o=1-l-l+f):h?(c=s[a-n],o=1-c-c+f):o=f,o>=0?(u=9+o,d=this.decoder.readBit(this.contexts,u)):(u=9-o,d=1^this.decoder.readBit(this.contexts,u)),d}runMagnitudeRefinementPass(){const e=this.decoder,t=this.width,a=this.height,n=this.coefficentsMagnitude,r=this.neighborsSignificance,i=this.contexts,s=this.bitsDecoded,o=this.processingFlags,c=t*a,l=4*t;for(let a,h=0;h<c;h=a){a=Math.min(c,h+l);for(let c=0;c<t;c++)for(let l=h+c;l<a;l+=t){if(!n[l]||0!=(1&o[l]))continue;let t=16;if(0!=(2&o[l])){o[l]^=2;t=0===(127&r[l])?15:14}const a=e.readBit(i,t);n[l]=n[l]<<1|a,s[l]++,o[l]|=1}}}runCleanupPass(){const e=this.decoder,t=this.width,a=this.height,n=this.neighborsSignificance,r=this.coefficentsMagnitude,i=this.coefficentsSign,s=this.contexts,o=this.contextLabelTable,c=this.bitsDecoded,l=this.processingFlags,h=t,u=2*t,d=3*t;let f;for(let g=0;g<a;g=f){f=Math.min(g+4,a);const p=g*t,m=g+3<a;for(let a=0;a<t;a++){const b=p+a;let y,w=0,x=b,S=g;if(m&&0===l[b]&&0===l[b+h]&&0===l[b+u]&&0===l[b+d]&&0===n[b]&&0===n[b+h]&&0===n[b+u]&&0===n[b+d]){if(!e.readBit(s,I.RUNLENGTH_CONTEXT)){c[b]++,c[b+h]++,c[b+u]++,c[b+d]++;continue}w=e.readBit(s,I.UNIFORM_CONTEXT)<<1|e.readBit(s,I.UNIFORM_CONTEXT),0!==w&&(S=g+w,x+=w*t),y=this.decodeSignBit(S,a,x),i[x]=y,r[x]=1,this.setNeighborsSignificance(S,a,x),l[x]|=2,x=b;for(let e=g;e<=S;e++,x+=t)c[x]++;w++}for(S=g+w;S<f;S++,x+=t){if(r[x]||0!=(1&l[x]))continue;const t=o[n[x]];1===e.readBit(s,t)&&(y=this.decodeSignBit(S,a,x),i[x]=y,r[x]=1,this.setNeighborsSignificance(S,a,x),l[x]|=2),c[x]++}}}}checkSegmentationSymbol(){const e=this.decoder,t=this.contexts;if(10!==(e.readBit(t,I.UNIFORM_CONTEXT)<<3|e.readBit(t,I.UNIFORM_CONTEXT)<<2|e.readBit(t,I.UNIFORM_CONTEXT)<<1|e.readBit(t,I.UNIFORM_CONTEXT)))throw new s("Invalid segmentation symbol")}}class T{constructor(){this.constructor===T&&(0,n.unreachable)("Cannot initialize Transform.")}calculate(e,t,a){let n=e[0];for(let r=1,i=e.length;r<i;r++)n=this.iterate(n,e[r],t,a);return n}extend(e,t,a){let n=t-1,r=t+1,i=t+a-2,s=t+a;e[n--]=e[r++],e[s++]=e[i--],e[n--]=e[r++],e[s++]=e[i--],e[n--]=e[r++],e[s++]=e[i--],e[n]=e[r],e[s]=e[i]}filter(e,t,a){(0,n.unreachable)("Abstract method `filter` called")}iterate(e,t,a,n){const r=e.width,i=e.height;let s=e.items;const o=t.width,c=t.height,l=t.items;let h,u,d,f,g,p;for(d=0,h=0;h<i;h++)for(f=2*h*o,u=0;u<r;u++,d++,f+=2)l[f]=s[d];s=e.items=null;const m=new Float32Array(o+8);if(1===o){if(0!=(1&a))for(p=0,d=0;p<c;p++,d+=o)l[d]*=.5}else for(p=0,d=0;p<c;p++,d+=o)m.set(l.subarray(d,d+o),4),this.extend(m,4,o),this.filter(m,4,o),l.set(m.subarray(4,4+o),d);let b=16;const y=[];for(h=0;h<b;h++)y.push(new Float32Array(c+8));let w,x=0;if(e=4+c,1===c){if(0!=(1&n))for(g=0;g<o;g++)l[g]*=.5}else for(g=0;g<o;g++){if(0===x){for(b=Math.min(o-g,b),d=g,f=4;f<e;d+=o,f++)for(w=0;w<b;w++)y[w][f]=l[d+w];x=b}x--;const t=y[x];if(this.extend(t,4,c),this.filter(t,4,c),0===x)for(d=g-b+1,f=4;f<e;d+=o,f++)for(w=0;w<b;w++)l[d+w]=y[w][f]}return{width:o,height:c,items:l}}}class M extends T{filter(e,t,a){const n=a>>1;let r,i,s,o;const c=-1.586134342059924,l=-.052980118572961,h=.882911075530934,u=.443506852043971,d=1.230174104914001;for(r=(t|=0)-3,i=n+4;i--;r+=2)e[r]*=.8128930661159609;for(r=t-2,s=u*e[r-1],i=n+3;i--&&(o=u*e[r+1],e[r]=d*e[r]-s-o,i--);r+=2)r+=2,s=u*e[r+1],e[r]=d*e[r]-s-o;for(r=t-1,s=h*e[r-1],i=n+2;i--&&(o=h*e[r+1],e[r]-=s+o,i--);r+=2)r+=2,s=h*e[r+1],e[r]-=s+o;for(r=t,s=l*e[r-1],i=n+1;i--&&(o=l*e[r+1],e[r]-=s+o,i--);r+=2)r+=2,s=l*e[r+1],e[r]-=s+o;if(0!==n)for(r=t+1,s=c*e[r-1],i=n;i--&&(o=c*e[r+1],e[r]-=s+o,i--);r+=2)r+=2,s=c*e[r+1],e[r]-=s+o}}class P extends T{filter(e,t,a){const n=a>>1;let r,i;for(r=t|=0,i=n+1;i--;r+=2)e[r]-=e[r-1]+e[r+1]+2>>2;for(r=t+1,i=n;i--;r+=2)e[r]+=e[r-1]+e[r+1]>>1}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.LZWStream=void 0;var n=a(18);class r extends n.DecodeStream{constructor(e,t,a){super(t),this.str=e,this.dict=e.dict,this.cachedData=0,this.bitsCached=0;const n=4096,r={earlyChange:a,codeLength:9,nextCode:258,dictionaryValues:new Uint8Array(n),dictionaryLengths:new Uint16Array(n),dictionaryPrevCodes:new Uint16Array(n),currentSequence:new Uint8Array(n),currentSequenceLength:0};for(let e=0;e<256;++e)r.dictionaryValues[e]=e,r.dictionaryLengths[e]=1;this.lzwState=r}readBits(e){let t=this.bitsCached,a=this.cachedData;for(;t<e;){const e=this.str.getByte();if(-1===e)return this.eof=!0,null;a=a<<8|e,t+=8}return this.bitsCached=t-=e,this.cachedData=a,this.lastCode=null,a>>>t&(1<<e)-1}readBlock(){let e,t,a,n=1024;const r=this.lzwState;if(!r)return;const i=r.earlyChange;let s=r.nextCode;const o=r.dictionaryValues,c=r.dictionaryLengths,l=r.dictionaryPrevCodes;let h=r.codeLength,u=r.prevCode;const d=r.currentSequence;let f=r.currentSequenceLength,g=0,p=this.bufferLength,m=this.ensureBuffer(this.bufferLength+n);for(e=0;e<512;e++){const e=this.readBits(h),r=f>0;if(e<256)d[0]=e,f=1;else{if(!(e>=258)){if(256===e){h=9,s=258,f=0;continue}this.eof=!0,delete this.lzwState;break}if(e<s)for(f=c[e],t=f-1,a=e;t>=0;t--)d[t]=o[a],a=l[a];else d[f++]=d[0]}if(r&&(l[s]=u,c[s]=c[u]+1,o[s]=d[0],s++,h=s+i&s+i-1?h:0|Math.min(Math.log(s+i)/.6931471805599453+1,12)),u=e,g+=f,n<g){do{n+=512}while(n<g);m=this.ensureBuffer(this.bufferLength+n)}for(t=0;t<f;t++)m[p++]=d[t]}r.nextCode=s,r.codeLength=h,r.prevCode=u,r.currentSequenceLength=f,this.bufferLength=p}}t.LZWStream=r},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PredictorStream=void 0;var n=a(18),r=a(4),i=a(2);class s extends n.DecodeStream{constructor(e,t,a){if(super(t),!(a instanceof r.Dict))return e;const n=this.predictor=a.get("Predictor")||1;if(n<=1)return e;if(2!==n&&(n<10||n>15))throw new i.FormatError(`Unsupported predictor: ${n}`);this.readBlock=2===n?this.readBlockTiff:this.readBlockPng,this.str=e,this.dict=e.dict;const s=this.colors=a.get("Colors")||1,o=this.bits=a.get("BPC","BitsPerComponent")||8,c=this.columns=a.get("Columns")||1;return this.pixBytes=s*o+7>>3,this.rowBytes=c*s*o+7>>3,this}readBlockTiff(){const e=this.rowBytes,t=this.bufferLength,a=this.ensureBuffer(t+e),n=this.bits,r=this.colors,i=this.str.getBytes(e);if(this.eof=!i.length,this.eof)return;let s,o=0,c=0,l=0,h=0,u=t;if(1===n&&1===r)for(s=0;s<e;++s){let e=i[s]^o;e^=e>>1,e^=e>>2,e^=e>>4,o=(1&e)<<7,a[u++]=e}else if(8===n){for(s=0;s<r;++s)a[u++]=i[s];for(;s<e;++s)a[u]=a[u-r]+i[s],u++}else if(16===n){const t=2*r;for(s=0;s<t;++s)a[u++]=i[s];for(;s<e;s+=2){const e=((255&i[s])<<8)+(255&i[s+1])+((255&a[u-t])<<8)+(255&a[u-t+1]);a[u++]=e>>8&255,a[u++]=255&e}}else{const e=new Uint8Array(r+1),u=(1<<n)-1;let d=0,f=t;const g=this.columns;for(s=0;s<g;++s)for(let t=0;t<r;++t)l<n&&(o=o<<8|255&i[d++],l+=8),e[t]=e[t]+(o>>l-n)&u,l-=n,c=c<<n|e[t],h+=n,h>=8&&(a[f++]=c>>h-8&255,h-=8);h>0&&(a[f++]=(c<<8-h)+(o&(1<<8-h)-1))}this.bufferLength+=e}readBlockPng(){const e=this.rowBytes,t=this.pixBytes,a=this.str.getByte(),n=this.str.getBytes(e);if(this.eof=!n.length,this.eof)return;const r=this.bufferLength,s=this.ensureBuffer(r+e);let o=s.subarray(r-e,r);0===o.length&&(o=new Uint8Array(e));let c,l,h,u=r;switch(a){case 0:for(c=0;c<e;++c)s[u++]=n[c];break;case 1:for(c=0;c<t;++c)s[u++]=n[c];for(;c<e;++c)s[u]=s[u-t]+n[c]&255,u++;break;case 2:for(c=0;c<e;++c)s[u++]=o[c]+n[c]&255;break;case 3:for(c=0;c<t;++c)s[u++]=(o[c]>>1)+n[c];for(;c<e;++c)s[u]=(o[c]+s[u-t]>>1)+n[c]&255,u++;break;case 4:for(c=0;c<t;++c)l=o[c],h=n[c],s[u++]=l+h;for(;c<e;++c){l=o[c];const e=o[c-t],a=s[u-t],r=a+l-e;let i=r-a;i<0&&(i=-i);let d=r-l;d<0&&(d=-d);let f=r-e;f<0&&(f=-f),h=n[c],s[u++]=i<=d&&i<=f?a+h:d<=f?l+h:e+h}break;default:throw new i.FormatError(`Unsupported predictor: ${a}`)}this.bufferLength+=e}}t.PredictorStream=s},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.RunLengthStream=void 0;var n=a(18);class r extends n.DecodeStream{constructor(e,t){super(t),this.str=e,this.dict=e.dict}readBlock(){const e=this.str.getBytes(2);if(!e||e.length<2||128===e[0])return void(this.eof=!0);let t,a=this.bufferLength,n=e[0];if(n<128){if(t=this.ensureBuffer(a+n+1),t[a++]=e[1],n>0){const e=this.str.getBytes(n);t.set(e,a),a+=n}}else{n=257-n;const r=e[1];t=this.ensureBuffer(a+n+1);for(let e=0;e<n;e++)t[a++]=r}this.bufferLength=a}}t.RunLengthStream=r},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Font=t.ErrorFont=void 0;var n=a(2),r=a(35),i=a(38),s=a(40),o=a(39),c=a(37),l=a(41),h=a(42),u=a(43),d=a(44),f=a(45),g=a(46),p=a(14),m=a(47),b=a(3),y=a(8),w=a(48);const x=[[57344,63743],[1048576,1114109]],S=1e3,A=["ascent","bbox","black","bold","charProcOperatorList","composite","cssFontInfo","data","defaultVMetrics","defaultWidth","descent","fallbackName","fontMatrix","isInvalidPDFjsFont","isType3Font","italic","loadedName","mimetype","missingFile","name","remeasure","subtype","systemFontInfo","type","vertical"],k=["cMap","defaultEncoding","differences","isMonospace","isSerifFont","isSymbolicFont","seacMap","toFontChar","toUnicode","vmetrics","widths"];function C(e){if(!e.fontMatrix)return;if(e.fontMatrix[0]===n.FONT_IDENTITY_MATRIX[0])return;const t=.001/e.fontMatrix[0],a=e.widths;for(const e in a)a[e]*=t;e.defaultWidth*=t}function v(e){if(!e.fallbackToUnicode)return;if(e.toUnicode instanceof h.IdentityToUnicodeMap)return;const t=[];for(const a in e.fallbackToUnicode)e.toUnicode.has(a)||(t[a]=e.fallbackToUnicode[a]);t.length>0&&e.toUnicode.amend(t)}class F{constructor(e,t,a,n,r,i,s,o,c){this.originalCharCode=e,this.fontChar=t,this.unicode=a,this.accent=n,this.width=r,this.vmetric=i,this.operatorListId=s,this.isSpace=o,this.isInFont=c}get category(){return(0,n.shadow)(this,"category",(0,s.getCharUnicodeCategory)(this.unicode),!0)}}function O(e,t){return(e<<8)+t}function I(e,t,a){e[t+1]=a,e[t]=a>>>8}function T(e,t){const a=(e<<8)+t;return 32768&a?a-65536:a}function M(e){return String.fromCharCode(e>>8&255,255&e)}function P(e){return e>32767?e=32767:e<-32768&&(e=-32768),String.fromCharCode(e>>8&255,255&e)}function N(e){const t=e.peekBytes(4);return"ttcf"===(0,n.bytesToString)(t)}function D(e,{type:t,subtype:a,composite:r}){let i,s;return function(e){const t=e.peekBytes(4);return 65536===(0,b.readUint32)(t,0)||"true"===(0,n.bytesToString)(t)}(e)||N(e)?i=r?"CIDFontType2":"TrueType":!function(e){const t=e.peekBytes(4);return"OTTO"===(0,n.bytesToString)(t)}(e)?!function(e){const t=e.peekBytes(2);return 37===t[0]&&33===t[1]||128===t[0]&&1===t[1]}(e)?!function(e){const t=e.peekBytes(4);return t[0]>=1&&t[3]>=1&&t[3]<=4}(e)?((0,n.warn)("getFontFileType: Unable to detect correct font file Type/Subtype."),i=t,s=a):r?(i="CIDFontType0",s="CIDFontType0C"):(i="MMType1"===t?"MMType1":"Type1",s="Type1C"):i=r?"CIDFontType0":"MMType1"===t?"MMType1":"Type1":i=r?"CIDFontType2":"OpenType",[i,s]}function R(e,t){for(const a in t)e[+a]=t[a]}function E(e,t,a){const n=[];let r;for(let a=0,i=e.length;a<i;a++)r=(0,s.getUnicodeForGlyph)(e[a],t),-1!==r&&(n[a]=r);for(const e in a)r=(0,s.getUnicodeForGlyph)(a[e],t),-1!==r&&(n[+e]=r);return n}function B(e){return 1===e.platform&&0===e.encoding&&0===e.language}function $(e){return 3===e.platform&&1===e.encoding&&1033===e.language}function L(e,t,a=!1){switch(t.length){case 1:return t.charCodeAt(0);case 2:return t.charCodeAt(0)<<8|t.charCodeAt(1)}const r=`Unsupported CID string (charCode ${e}): "${t}".`;if(a)throw new n.FormatError(r);return(0,n.warn)(r),t}function _(e,t,a,r){const i=Object.create(null),s=new Map,o=[],c=new Set;let l=0;let h=x[l][0],u=x[l][1];for(let f in e){f|=0;let g=e[f];if(!t(g))continue;if(h>u){if(l++,l>=x.length){(0,n.warn)("Ran out of space in font private use area.");break}h=x[l][0],u=x[l][1]}const p=h++;0===g&&(g=a);let m=r.get(f);"string"==typeof m&&(m=m.codePointAt(0)),!m||(d=m,x[0][0]<=d&&d<=x[0][1]||x[1][0]<=d&&d<=x[1][1])||c.has(g)||(s.set(m,g),c.add(g)),i[p]=g,o[f]=p}var d;return{toFontChar:o,charCodeToGlyphId:i,toUnicodeExtraMap:s,nextAvailableFontCharCode:h}}function j(e,t,a){const r=function(e,t,a){const n=[];for(const t in e)e[t]>=a||n.push({fontCharCode:0|t,glyphId:e[t]});if(t)for(const[e,r]of t)r>=a||n.push({fontCharCode:e,glyphId:r});0===n.length&&n.push({fontCharCode:0,glyphId:0}),n.sort((function(e,t){return e.fontCharCode-t.fontCharCode}));const r=[],i=n.length;for(let e=0;e<i;){const t=n[e].fontCharCode,a=[n[e].glyphId];++e;let s=t;for(;e<i&&s+1===n[e].fontCharCode&&(a.push(n[e].glyphId),++s,++e,65535!==s););r.push([t,s,a])}return r}(e,t,a),i=r.at(-1)[1]>65535?2:1;let s,o,c,l,h="\0\0"+M(i)+"\0\0"+(0,n.string32)(4+8*i);for(s=r.length-1;s>=0&&!(r[s][0]<=65535);--s);const u=s+1;r[s][0]<65535&&65535===r[s][1]&&(r[s][1]=65534);const d=r[s][1]<65535?1:0,f=u+d,g=m.OpenTypeFileBuilder.getSearchParams(f,2);let p,b,y,w,x="",S="",A="",k="",C="",v=0;for(s=0,o=u;s<o;s++){p=r[s],b=p[0],y=p[1],x+=M(b),S+=M(y),w=p[2];let e=!0;for(c=1,l=w.length;c<l;++c)if(w[c]!==w[c-1]+1){e=!1;break}if(e){A+=M(w[0]-b&65535),k+=M(0)}else{const e=2*(f-s)+2*v;for(v+=y-b+1,A+=M(0),k+=M(e),c=0,l=w.length;c<l;++c)C+=M(w[c])}}d>0&&(S+="ÿÿ",x+="ÿÿ",A+="\0",k+="\0\0");const F="\0\0"+M(2*f)+M(g.range)+M(g.entry)+M(g.rangeShift)+S+"\0\0"+x+A+k+C;let O="",I="";if(i>1){for(h+="\0\0\n"+(0,n.string32)(4+8*i+4+F.length),O="",s=0,o=r.length;s<o;s++){p=r[s],b=p[0],w=p[2];let e=w[0];for(c=1,l=w.length;c<l;++c)w[c]!==w[c-1]+1&&(y=p[0]+c-1,O+=(0,n.string32)(b)+(0,n.string32)(y)+(0,n.string32)(e),b=y+1,e=w[c]);O+=(0,n.string32)(b)+(0,n.string32)(p[1])+(0,n.string32)(e)}I="\0\f\0\0"+(0,n.string32)(O.length+16)+"\0\0\0\0"+(0,n.string32)(O.length/12)}return h+"\0"+M(F.length+4)+F+I+O}function U(e,t,a){a||={unitsPerEm:0,yMax:0,yMin:0,ascent:0,descent:0};let r=0,i=0,o=0,c=0,l=null,h=0,u=-1;if(t){for(let e in t)if(e|=0,(l>e||!l)&&(l=e),h<e&&(h=e),u=(0,s.getUnicodeRangeFor)(e,u),u<32)r|=1<<u;else if(u<64)i|=1<<u-32;else if(u<96)o|=1<<u-64;else{if(!(u<123))throw new n.FormatError("Unicode ranges Bits > 123 are reserved for internal usage");c|=1<<u-96}h>65535&&(h=65535)}else l=0,h=255;const d=e.bbox||[0,0,0,0],f=a.unitsPerEm||1/(e.fontMatrix||n.FONT_IDENTITY_MATRIX)[0],g=e.ascentScaled?1:f/S,p=a.ascent||Math.round(g*(e.ascent||d[3]));let m=a.descent||Math.round(g*(e.descent||d[1]));m>0&&e.descent>0&&d[1]<0&&(m=-m);const b=a.yMax||p,y=-a.yMin||-m;return"\0$ô\0\0\0»\0\0\0»\0\0ß\x001\0\0\0\0"+String.fromCharCode(e.fixedPitch?9:0)+"\0\0\0\0\0\0"+(0,n.string32)(r)+(0,n.string32)(i)+(0,n.string32)(o)+(0,n.string32)(c)+"*21*"+M(e.italicAngle?1:0)+M(l||e.firstChar)+M(h||e.lastChar)+M(p)+M(m)+"\0d"+M(b)+M(y)+"\0\0\0\0\0\0\0\0"+M(e.xHeight)+M(e.capHeight)+M(0)+M(l||e.firstChar)+"\0"}function X(e){const t=Math.floor(65536*e.italicAngle);return"\0\0\0"+(0,n.string32)(t)+"\0\0\0\0"+(0,n.string32)(e.fixedPitch?1:0)+"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"}function H(e){return e.replaceAll(/[^\x21-\x7E]|[[\](){}<>/%]/g,"").slice(0,63)}function q(e,t){t||(t=[[],[]]);const a=[t[0][0]||"Original licence",t[0][1]||e,t[0][2]||"Unknown",t[0][3]||"uniqueID",t[0][4]||e,t[0][5]||"Version 0.11",t[0][6]||H(e),t[0][7]||"Unknown",t[0][8]||"Unknown",t[0][9]||"Unknown"],n=[];let r,i,s,o,c;for(r=0,i=a.length;r<i;r++){c=t[1][r]||a[r];const e=[];for(s=0,o=c.length;s<o;s++)e.push(M(c.charCodeAt(s)));n.push(e.join(""))}const l=[a,n],h=["\0","\0"],u=["\0\0","\0"],d=["\0\0","\t"],f=a.length*h.length;let g="\0\0"+M(f)+M(12*f+6),p=0;for(r=0,i=h.length;r<i;r++){const e=l[r];for(s=0,o=e.length;s<o;s++){c=e[s];g+=h[r]+u[r]+d[r]+M(s)+M(c.length)+M(p),p+=c.length}}return g+=a.join("")+n.join(""),g}t.Font=class{constructor(e,t,a){this.name=e,this.psName=null,this.mimetype=null,this.disableFontFace=!1,this.loadedName=a.loadedName,this.isType3Font=a.isType3Font,this.missingFile=!1,this.cssFontInfo=a.cssFontInfo,this._charsCache=Object.create(null),this._glyphCache=Object.create(null);let r=!!(a.flags&i.FontFlags.Serif);if(!r&&!a.isSimulatedFlags){const t=e.replaceAll(/[,_]/g,"-").split("-")[0],a=(0,l.getSerifFonts)();for(const e of t.split("+"))if(a[e]){r=!0;break}}this.isSerifFont=r,this.isSymbolicFont=!!(a.flags&i.FontFlags.Symbolic),this.isMonospace=!!(a.flags&i.FontFlags.FixedPitch);let{type:s,subtype:o}=a;this.type=s,this.subtype=o,this.systemFontInfo=a.systemFontInfo;const c=e.match(/^InvalidPDFjsFont_(.*)_\d+$/);if(this.isInvalidPDFjsFont=!!c,this.isInvalidPDFjsFont?this.fallbackName=c[1]:this.isMonospace?this.fallbackName="monospace":this.isSerifFont?this.fallbackName="serif":this.fallbackName="sans-serif",this.systemFontInfo?.guessFallback&&(this.systemFontInfo.guessFallback=!1,this.systemFontInfo.css+=`,${this.fallbackName}`),this.differences=a.differences,this.widths=a.widths,this.defaultWidth=a.defaultWidth,this.composite=a.composite,this.cMap=a.cMap,this.capHeight=a.capHeight/S,this.ascent=a.ascent/S,this.descent=a.descent/S,this.lineHeight=this.ascent-this.descent,this.fontMatrix=a.fontMatrix,this.bbox=a.bbox,this.defaultEncoding=a.defaultEncoding,this.toUnicode=a.toUnicode,this.toFontChar=[],"Type3"===a.type){for(let e=0;e<256;e++)this.toFontChar[e]=this.differences[e]||a.defaultEncoding[e];return}if(this.cidEncoding=a.cidEncoding||"",this.vertical=!!a.vertical,this.vertical&&(this.vmetrics=a.vmetrics,this.defaultVMetrics=a.defaultVMetrics),!t||t.isEmpty)return t&&(0,n.warn)('Font file is empty in "'+e+'" ('+this.loadedName+")"),void this.fallbackToSystemFont(a);let h;[s,o]=D(t,a),s===this.type&&o===this.subtype||(0,n.info)(`Inconsistent font file Type/SubType, expected: ${this.type}/${this.subtype} but found: ${s}/${o}.`);try{switch(s){case"MMType1":(0,n.info)("MMType1 font ("+e+"), falling back to Type1.");case"Type1":case"CIDFontType0":this.mimetype="font/opentype";const r="Type1C"===o||"CIDFontType0C"===o?new u.CFFFont(t,a):new w.Type1Font(e,t,a);C(a),h=this.convert(e,r,a);break;case"OpenType":case"TrueType":case"CIDFontType2":this.mimetype="font/opentype",h=this.checkAndRepair(e,t,a),this.isOpenType&&(C(a),s="OpenType");break;default:throw new n.FormatError(`Font ${s} is not supported`)}}catch(e){return(0,n.warn)(e),void this.fallbackToSystemFont(a)}v(a),this.data=h,this.type=s,this.subtype=o,this.fontMatrix=a.fontMatrix,this.widths=a.widths,this.defaultWidth=a.defaultWidth,this.toUnicode=a.toUnicode,this.seacMap=a.seacMap}get renderer(){const e=d.FontRendererFactory.create(this,i.SEAC_ANALYSIS_ENABLED);return(0,n.shadow)(this,"renderer",e)}exportData(e=!1){const t=e?[...A,...k]:A,a=Object.create(null);let n,r;for(n of t)r=this[n],void 0!==r&&(a[n]=r);return a}fallbackToSystemFont(e){this.missingFile=!0;const{name:t,type:a}=this;let n=(0,i.normalizeFontName)(t);const r=(0,l.getStdFontMap)(),u=(0,l.getNonStdFontMap)(),d=!!r[n],g=!(!u[n]||!r[u[n]]);n=r[n]||u[n]||n;const p=(0,f.getFontBasicMetrics)()[n];p&&(isNaN(this.ascent)&&(this.ascent=p.ascent/S),isNaN(this.descent)&&(this.descent=p.descent/S),isNaN(this.capHeight)&&(this.capHeight=p.capHeight/S)),this.bold=/bold/gi.test(n),this.italic=/oblique|italic/gi.test(n),this.black=/Black/g.test(t);const m=/Narrow/g.test(t);if(this.remeasure=(!d||m)&&Object.keys(this.widths).length>0,(d||g)&&"CIDFontType2"===a&&this.cidEncoding.startsWith("Identity-")){const a=e.cidToGidMap,n=[];if(R(n,(0,l.getGlyphMapForStandardFonts)()),/Arial-?Black/i.test(t)?R(n,(0,l.getSupplementalGlyphMapForArialBlack)()):/Calibri/i.test(t)&&R(n,(0,l.getSupplementalGlyphMapForCalibri)()),a){for(const e in n){const t=n[e];void 0!==a[t]&&(n[+e]=a[t])}a.length!==this.toUnicode.length&&e.hasIncludedToUnicodeMap&&this.toUnicode instanceof h.IdentityToUnicodeMap&&this.toUnicode.forEach((function(e,t){const r=n[e];void 0===a[r]&&(n[+e]=t)}))}this.toUnicode instanceof h.IdentityToUnicodeMap||this.toUnicode.forEach((function(e,t){n[+e]=t})),this.toFontChar=n,this.toUnicode=new h.ToUnicodeMap(n)}else if(/Symbol/i.test(n))this.toFontChar=E(c.SymbolSetEncoding,(0,o.getGlyphsUnicode)(),this.differences);else if(/Dingbats/i.test(n))this.toFontChar=E(c.ZapfDingbatsEncoding,(0,o.getDingbatsGlyphsUnicode)(),this.differences);else if(d){const e=E(this.defaultEncoding,(0,o.getGlyphsUnicode)(),this.differences);"CIDFontType2"!==a||this.cidEncoding.startsWith("Identity-")||this.toUnicode instanceof h.IdentityToUnicodeMap||this.toUnicode.forEach((function(t,a){e[+t]=a})),this.toFontChar=e}else{const e=(0,o.getGlyphsUnicode)(),a=[];this.toUnicode.forEach(((t,n)=>{if(!this.composite){const a=this.differences[t]||this.defaultEncoding[t],r=(0,s.getUnicodeForGlyph)(a,e);-1!==r&&(n=r)}a[+t]=n})),this.composite&&this.toUnicode instanceof h.IdentityToUnicodeMap&&/Tahoma|Verdana/i.test(t)&&R(a,(0,l.getGlyphMapForStandardFonts)()),this.toFontChar=a}v(e),this.loadedName=n.split("-")[0]}checkAndRepair(e,t,a){const s=["OS/2","cmap","head","hhea","hmtx","maxp","name","post","loca","glyf","fpgm","prep","cvt ","CFF "];function l(e,t){const a=Object.create(null);a["OS/2"]=null,a.cmap=null,a.head=null,a.hhea=null,a.hmtx=null,a.maxp=null,a.name=null,a.post=null;for(let n=0;n<t;n++){const t=d(e);s.includes(t.tag)&&(0!==t.length&&(a[t.tag]=t))}return a}function d(e){const t=e.getString(4),a=e.getInt32()>>>0,n=e.getInt32()>>>0,r=e.getInt32()>>>0,i=e.pos;e.pos=e.start||0,e.skip(n);const s=e.getBytes(r);return e.pos=i,"head"===t&&(s[8]=s[9]=s[10]=s[11]=0,s[17]|=32),{tag:t,checksum:a,length:r,offset:n,data:s}}function f(e){return{version:e.getString(4),numTables:e.getUint16(),searchRange:e.getUint16(),entrySelector:e.getUint16(),rangeShift:e.getUint16()}}function b(e,t,a,n,r,i){const s={length:0,sizeOfInstructions:0};if(t<0||t>=e.length||a>e.length||a-t<=12)return s;const o=e.subarray(t,a),c=T(o[2],o[3]),l=T(o[4],o[5]),h=T(o[6],o[7]),u=T(o[8],o[9]);c>h&&(I(o,2,h),I(o,6,c)),l>u&&(I(o,4,u),I(o,8,l));const d=T(o[0],o[1]);if(d<0)return d<-1||(n.set(o,r),s.length=o.length),s;let f,g=10,p=0;for(f=0;f<d;f++){p=(o[g]<<8|o[g+1])+1,g+=2}const m=g,b=o[g]<<8|o[g+1];s.sizeOfInstructions=b,g+=2+b;const y=g;let w=0;for(f=0;f<p;f++){const e=o[g++];192&e&&(o[g-1]=63&e);let t=2;2&e?t=1:16&e&&(t=0);let a=2;4&e?a=1:32&e&&(a=0);const n=t+a;if(w+=n,8&e){const e=o[g++];0===e&&(o[g-1]^=8),f+=e,w+=e*n}}if(0===w)return s;let x=g+w;return x>o.length?s:!i&&b>0?(n.set(o.subarray(0,m),r),n.set([0,0],r+m),n.set(o.subarray(y,x),r+m+2),x-=b,o.length-x>3&&(x=x+3&-4),s.length=x,s):o.length-x>3?(x=x+3&-4,n.set(o.subarray(0,x),r),s.length=x,s):(n.set(o,r),s.length=o.length,s)}function w(e){const a=(t.start||0)+e.offset;t.pos=a;const n=[[],[]],r=[],i=e.length,s=a+i;if(0!==t.getUint16()||i<6)return[n,r];const o=t.getUint16(),c=t.getUint16();let l,h;for(l=0;l<o&&t.pos+12<=s;l++){const e={platform:t.getUint16(),encoding:t.getUint16(),language:t.getUint16(),name:t.getUint16(),length:t.getUint16(),offset:t.getUint16()};(B(e)||$(e))&&r.push(e)}for(l=0,h=r.length;l<h;l++){const e=r[l];if(e.length<=0)continue;const i=a+c+e.offset;if(i+e.length>s)continue;t.pos=i;const o=e.name;if(e.encoding){let a="";for(let n=0,r=e.length;n<r;n+=2)a+=String.fromCharCode(t.getUint16());n[1][o]=a}else n[0][o]=t.getString(e.length)}return[n,r]}const x=[0,0,0,0,0,0,0,0,-2,-2,-2,-2,0,0,-2,-5,-1,-1,-1,-1,-1,-1,-1,-1,0,0,-1,0,-1,-1,-1,-1,1,-1,-999,0,1,0,-1,-2,0,-1,-2,-1,-1,0,-1,-1,0,0,-999,-999,-1,-1,-1,-1,-2,-999,-2,-2,-999,0,-2,-2,0,0,-2,0,-2,0,0,0,-2,-1,-1,1,1,0,0,-1,-1,-1,-1,-1,-1,-1,0,0,-1,0,-1,-1,0,-999,-1,-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0,0,0,-2,-999,-999,-999,-999,-999,-1,-1,-2,-2,0,0,0,0,-1,-1,-999,-2,-2,0,0,-1,-2,-2,0,0,0,-1,-1,-1,-2];function S(e,t){let a,r,i,s,o,c=e.data,l=0,h=0,u=0;const d=[],f=[],g=[];let p=t.tooComplexToFollowFunctions,m=!1,b=0,y=0;for(let e=c.length;l<e;){const e=c[l++];if(64===e)if(r=c[l++],m||y)l+=r;else for(a=0;a<r;a++)d.push(c[l++]);else if(65===e)if(r=c[l++],m||y)l+=2*r;else for(a=0;a<r;a++)i=c[l++],d.push(i<<8|c[l++]);else if(176==(248&e))if(r=e-176+1,m||y)l+=r;else for(a=0;a<r;a++)d.push(c[l++]);else if(184==(248&e))if(r=e-184+1,m||y)l+=2*r;else for(a=0;a<r;a++)i=c[l++],d.push(i<<8|c[l++]);else if(43!==e||p)if(44!==e||p){if(45===e)if(m)m=!1,h=l;else{if(o=f.pop(),!o)return(0,n.warn)("TT: ENDF bad stack"),void(t.hintsValid=!1);s=g.pop(),c=o.data,l=o.i,t.functionsStackDeltas[s]=d.length-o.stackTop}else if(137===e)(m||y)&&((0,n.warn)("TT: nested IDEFs not allowed"),p=!0),m=!0,u=l;else if(88===e)++b;else if(27===e)y=b;else if(89===e)y===b&&(y=0),--b;else if(28===e&&!m&&!y){const e=d.at(-1);e>0&&(l+=e-1)}}else(m||y)&&((0,n.warn)("TT: nested FDEFs not allowed"),p=!0),m=!0,u=l,s=d.pop(),t.functionsDefined[s]={data:c,i:l};else if(!m&&!y)if(s=d.at(-1),isNaN(s))(0,n.info)("TT: CALL empty stack (or invalid entry).");else if(t.functionsUsed[s]=!0,s in t.functionsStackDeltas){const e=d.length+t.functionsStackDeltas[s];if(e<0)return(0,n.warn)("TT: CALL invalid functions stack delta."),void(t.hintsValid=!1);d.length=e}else if(s in t.functionsDefined&&!g.includes(s)){if(f.push({data:c,i:l,stackTop:d.length-1}),g.push(s),o=t.functionsDefined[s],!o)return(0,n.warn)("TT: CALL non-existent function"),void(t.hintsValid=!1);c=o.data,l=o.i}if(!m&&!y){let t=0;for(e<=142?t=x[e]:e>=192&&e<=223?t=-1:e>=224&&(t=-2),e>=113&&e<=117&&(r=d.pop(),isNaN(r)||(t=2*-r));t<0&&d.length>0;)d.pop(),t++;for(;t>0;)d.push(NaN),t--}}t.tooComplexToFollowFunctions=p;const w=[c];l>c.length&&w.push(new Uint8Array(l-c.length)),u>h&&((0,n.warn)("TT: complementing a missing function tail"),w.push(new Uint8Array([34,45]))),function(e,t){if(t.length>1){let a,n,r=0;for(a=0,n=t.length;a<n;a++)r+=t[a].length;r=r+3&-4;const i=new Uint8Array(r);let s=0;for(a=0,n=t.length;a<n;a++)i.set(t[a],s),s+=t[a].length;e.data=i,e.length=r}}(e,w)}let A,k,v,F;if(N(t=new y.Stream(new Uint8Array(t.getBytes())))){const e=function(e,t){const{numFonts:a,offsetTable:r}=function(e){const t=e.getString(4);(0,n.assert)("ttcf"===t,"Must be a TrueType Collection font.");const a=e.getUint16(),r=e.getUint16(),i=e.getInt32()>>>0,s=[];for(let t=0;t<i;t++)s.push(e.getInt32()>>>0);const o={ttcTag:t,majorVersion:a,minorVersion:r,numFonts:i,offsetTable:s};switch(a){case 1:return o;case 2:return o.dsigTag=e.getInt32()>>>0,o.dsigLength=e.getInt32()>>>0,o.dsigOffset=e.getInt32()>>>0,o}throw new n.FormatError(`Invalid TrueType Collection majorVersion: ${a}.`)}(e),i=t.split("+");let s;for(let o=0;o<a;o++){e.pos=(e.start||0)+r[o];const a=f(e),c=l(e,a.numTables);if(!c.name)throw new n.FormatError('TrueType Collection font must contain a "name" table.');const[h]=w(c.name);for(let e=0,n=h.length;e<n;e++)for(let n=0,r=h[e].length;n<r;n++){const r=h[e][n]?.replaceAll(/\s/g,"");if(r){if(r===t)return{header:a,tables:c};if(!(i.length<2))for(const e of i)r===e&&(s={name:e,header:a,tables:c})}}}if(s)return(0,n.warn)(`TrueType Collection does not contain "${t}" font, falling back to "${s.name}" font instead.`),{header:s.header,tables:s.tables};throw new n.FormatError(`TrueType Collection does not contain "${t}" font.`)}(t,this.name);A=e.header,k=e.tables}else A=f(t),k=l(t,A.numTables);const M=!k["CFF "];if(M){if(!k.loca)throw new n.FormatError('Required "loca" table is not found');k.glyf||((0,n.warn)('Required "glyf" table is not found -- trying to recover.'),k.glyf={tag:"glyf",data:new Uint8Array(0)}),this.isOpenType=!1}else{const t=a.composite&&(a.cidToGidMap?.length>0||!(a.cMap instanceof p.IdentityCMap));if("OTTO"===A.version&&!t||!k.head||!k.hhea||!k.maxp||!k.post)return F=new y.Stream(k["CFF "].data),v=new u.CFFFont(F,a),C(a),this.convert(e,v,a);delete k.glyf,delete k.loca,delete k.fpgm,delete k.prep,delete k["cvt "],this.isOpenType=!0}if(!k.maxp)throw new n.FormatError('Required "maxp" table is not found');t.pos=(t.start||0)+k.maxp.offset;const P=t.getInt32(),D=t.getUint16();if(a.scaleFactors?.length===D&&M){const{scaleFactors:e}=a,t=O(k.head.data[50],k.head.data[51]),n=new g.GlyfTable({glyfTable:k.glyf.data,isGlyphLocationsLong:t,locaTable:k.loca.data,numGlyphs:D});n.scale(e);const{glyf:r,loca:i,isLocationLong:s}=n.write();k.glyf.data=r,k.loca.data=i,s!==!!t&&(k.head.data[50]=0,k.head.data[51]=s?1:0);const o=k.hmtx.data;for(let t=0;t<D;t++){const a=4*t,n=Math.round(e[t]*O(o[a],o[a+1]));o[a]=n>>8&255,o[a+1]=255&n;I(o,a+2,Math.round(e[t]*T(o[a+2],o[a+3])))}}let R=D+1,E=!0;R>65535&&(E=!1,R=D,(0,n.warn)("Not enough space in glyfs to duplicate first glyph."));let H=0,z=0;if(P>=65536&&k.maxp.length>=22){t.pos+=8;t.getUint16()>2&&(k.maxp.data[14]=0,k.maxp.data[15]=2),t.pos+=4,H=t.getUint16(),t.pos+=4,z=t.getUint16()}k.maxp.data[4]=R>>8,k.maxp.data[5]=255&R;const G=function(e,t,a,r){const i={functionsDefined:[],functionsUsed:[],functionsStackDeltas:[],tooComplexToFollowFunctions:!1,hintsValid:!0};if(e&&S(e,i),t&&S(t,i),e&&function(e,t){if(!e.tooComplexToFollowFunctions){if(e.functionsDefined.length>t)return(0,n.warn)("TT: more functions defined than expected"),void(e.hintsValid=!1);for(let a=0,r=e.functionsUsed.length;a<r;a++){if(a>t)return(0,n.warn)("TT: invalid function id: "+a),void(e.hintsValid=!1);if(e.functionsUsed[a]&&!e.functionsDefined[a])return(0,n.warn)("TT: undefined function: "+a),void(e.hintsValid=!1)}}}(i,r),a&&1&a.length){const e=new Uint8Array(a.length+1);e.set(a.data),a.data=e}return i.hintsValid}(k.fpgm,k.prep,k["cvt "],H);if(G||(delete k.fpgm,delete k.prep,delete k["cvt "]),function(e,t,a,r,i,s){if(!t)return void(a&&(a.data=null));e.pos=(e.start||0)+t.offset,e.pos+=4,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2,e.pos+=2;const o=e.getUint16();e.pos+=8,e.pos+=2;let c=e.getUint16();if(0!==o){2&O(r.data[44],r.data[45])||(t.data[22]=0,t.data[23]=0)}c>i&&((0,n.info)(`The numOfMetrics (${c}) should not be greater than the numGlyphs (${i}).`),c=i,t.data[34]=(65280&c)>>8,t.data[35]=255&c);const l=i-c-(a.length-4*c>>1);if(l>0){const e=new Uint8Array(a.length+2*l);e.set(a.data),s&&(e[a.length]=a.data[2],e[a.length+1]=a.data[3]),a.data=e}}(t,k.hhea,k.hmtx,k.head,R,E),!k.head)throw new n.FormatError('Required "head" table is not found');!function(e,t,a){const r=e.data,i=(s=r[0],o=r[1],c=r[2],l=r[3],(s<<24)+(o<<16)+(c<<8)+l);var s,o,c,l;i>>16!=1&&((0,n.info)("Attempting to fix invalid version in head table: "+i),r[0]=0,r[1]=1,r[2]=0,r[3]=0);const h=O(r[50],r[51]);if(h<0||h>1){(0,n.info)("Attempting to fix invalid indexToLocFormat in head table: "+h);const e=t+1;if(a===e<<1)r[50]=0,r[51]=0;else{if(a!==e<<2)throw new n.FormatError("Could not fix indexToLocFormat: "+h);r[50]=0,r[51]=1}}}(k.head,D,M?k.loca.length:0);let W=Object.create(null);if(M){const e=O(k.head.data[50],k.head.data[51]),t=function(e,t,a,n,r,i,s){let o,c,l;n?(o=4,c=function(e,t){return e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3]},l=function(e,t,a){e[t]=a>>>24&255,e[t+1]=a>>16&255,e[t+2]=a>>8&255,e[t+3]=255&a}):(o=2,c=function(e,t){return e[t]<<9|e[t+1]<<1},l=function(e,t,a){e[t]=a>>9&255,e[t+1]=a>>1&255});const h=i?a+1:a,u=o*(1+h),d=new Uint8Array(u);d.set(e.data.subarray(0,u)),e.data=d;const f=t.data,g=f.length,p=new Uint8Array(g);let m,y;const w=[];for(m=0,y=0;m<a+1;m++,y+=o){let e=c(d,y);e>g&&(e=g),w.push({index:m,offset:e,endOffset:0})}for(w.sort(((e,t)=>e.offset-t.offset)),m=0;m<a;m++)w[m].endOffset=w[m+1].offset;for(w.sort(((e,t)=>e.index-t.index)),m=0;m<a;m++){const{offset:e,endOffset:t}=w[m];if(0!==e||0!==t)break;const a=w[m+1].offset;if(0!==a){w[m].endOffset=a;break}}const x=Object.create(null);let S=0;for(l(d,0,S),m=0,y=o;m<a;m++,y+=o){const e=b(f,w[m].offset,w[m].endOffset,p,S,r),t=e.length;0===t&&(x[m]=!0),e.sizeOfInstructions>s&&(s=e.sizeOfInstructions),S+=t,l(d,y,S)}if(0===S){const e=new Uint8Array([0,1,0,0,0,0,0,0,0,0,0,0,0,0,49,0]);for(m=0,y=o;m<h;m++,y+=o)l(d,y,e.length);t.data=e}else if(i){const a=c(d,o);p.length>a+S?t.data=p.subarray(0,a+S):(t.data=new Uint8Array(a+S),t.data.set(p.subarray(0,S))),t.data.set(p.subarray(0,a),S),l(e.data,d.length-o,S+a)}else t.data=p.subarray(0,S);return{missingGlyphs:x,maxSizeOfInstructions:s}}(k.loca,k.glyf,D,e,G,E,z);W=t.missingGlyphs,P>=65536&&k.maxp.length>=22&&(k.maxp.data[26]=t.maxSizeOfInstructions>>8,k.maxp.data[27]=255&t.maxSizeOfInstructions)}if(!k.hhea)throw new n.FormatError('Required "hhea" table is not found');0===k.hhea.data[10]&&0===k.hhea.data[11]&&(k.hhea.data[10]=255,k.hhea.data[11]=255);const V={unitsPerEm:O(k.head.data[18],k.head.data[19]),yMax:T(k.head.data[42],k.head.data[43]),yMin:T(k.head.data[38],k.head.data[39]),ascent:T(k.hhea.data[4],k.hhea.data[5]),descent:T(k.hhea.data[6],k.hhea.data[7]),lineGap:T(k.hhea.data[8],k.hhea.data[9])};this.ascent=V.ascent/V.unitsPerEm,this.descent=V.descent/V.unitsPerEm,this.lineGap=V.lineGap/V.unitsPerEm,this.cssFontInfo?.lineHeight?(this.lineHeight=this.cssFontInfo.metrics.lineHeight,this.lineGap=this.cssFontInfo.metrics.lineGap):this.lineHeight=this.ascent-this.descent+this.lineGap,k.post&&function(e,a,r){const s=(t.start||0)+e.offset;t.pos=s;const o=s+e.length,c=t.getInt32();let l;t.skip(28);let h,u=!0;switch(c){case 65536:l=i.MacStandardGlyphOrdering;break;case 131072:const e=t.getUint16();if(e!==r){u=!1;break}const s=[];for(h=0;h<e;++h){const e=t.getUint16();if(e>=32768){u=!1;break}s.push(e)}if(!u)break;const d=[],f=[];for(;t.pos<o;){const e=t.getByte();for(f.length=e,h=0;h<e;++h)f[h]=String.fromCharCode(t.getByte());d.push(f.join(""))}for(l=[],h=0;h<e;++h){const e=s[h];e<258?l.push(i.MacStandardGlyphOrdering[e]):l.push(d[e-258])}break;case 196608:break;default:(0,n.warn)("Unknown/unsupported post table version "+c),u=!1,a.defaultEncoding&&(l=a.defaultEncoding)}a.glyphNames=l}(k.post,a,D),k.post={tag:"post",data:X(a)};const K=[];function Y(e){return!W[e]}if(a.composite){const e=a.cidToGidMap||[],t=0===e.length;a.cMap.forEach((function(a,r){if("string"==typeof r&&(r=L(a,r,!0)),r>65535)throw new n.FormatError("Max size of CID is 65,535");let i=-1;t?i=r:void 0!==e[r]&&(i=e[r]),i>=0&&i<D&&Y(i)&&(K[a]=i)}))}else{const e=function(e,t,a,r){if(!e)return(0,n.warn)("No cmap table available."),{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1};let i,s=(t.start||0)+e.offset;t.pos=s,t.skip(2);const o=t.getUint16();let c,l=!1;for(let e=0;e<o;e++){const n=t.getUint16(),i=t.getUint16(),s=t.getInt32()>>>0;let h=!1;if(c?.platformId!==n||c?.encodingId!==i){if(0!==n||0!==i&&1!==i&&3!==i)if(1===n&&0===i)h=!0;else if(3!==n||1!==i||!r&&c){if(a&&3===n&&0===i){h=!0;let a=!0;if(e<o-1){const e=t.peekBytes(2);O(e[0],e[1])<n&&(a=!1)}a&&(l=!0)}}else h=!0,a||(l=!0);else h=!0;if(h&&(c={platformId:n,encodingId:i,offset:s}),l)break}}if(c&&(t.pos=s+c.offset),!c||-1===t.peekByte())return(0,n.warn)("Could not find a preferred cmap table."),{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1};const h=t.getUint16();let u=!1;const d=[];let f,g;if(0===h){for(t.skip(4),f=0;f<256;f++){const e=t.getByte();e&&d.push({charCode:f,glyphId:e})}u=!0}else if(2===h){t.skip(4);const e=[];let a=0;for(let n=0;n<256;n++){const n=t.getUint16()>>3;e.push(n),a=Math.max(n,a)}const n=[];for(let e=0;e<=a;e++)n.push({firstCode:t.getUint16(),entryCount:t.getUint16(),idDelta:T(t.getByte(),t.getByte()),idRangePos:t.pos+t.getUint16()});for(let a=0;a<256;a++)if(0===e[a])t.pos=n[0].idRangePos+2*a,g=t.getUint16(),d.push({charCode:a,glyphId:g});else{const r=n[e[a]];for(f=0;f<r.entryCount;f++){const e=(a<<8)+f+r.firstCode;t.pos=r.idRangePos+2*f,g=t.getUint16(),0!==g&&(g=(g+r.idDelta)%65536),d.push({charCode:e,glyphId:g})}}}else if(4===h){t.skip(4);const e=t.getUint16()>>1;t.skip(6);const a=[];let n;for(n=0;n<e;n++)a.push({end:t.getUint16()});for(t.skip(2),n=0;n<e;n++)a[n].start=t.getUint16();for(n=0;n<e;n++)a[n].delta=t.getUint16();let r,o=0;for(n=0;n<e;n++){i=a[n];const s=t.getUint16();s?(r=(s>>1)-(e-n),i.offsetIndex=r,o=Math.max(o,r+i.end-i.start+1)):i.offsetIndex=-1}const c=[];for(f=0;f<o;f++)c.push(t.getUint16());for(n=0;n<e;n++){i=a[n],s=i.start;const e=i.end,t=i.delta;for(r=i.offsetIndex,f=s;f<=e;f++)65535!==f&&(g=r<0?f:c[r+f-s],g=g+t&65535,d.push({charCode:f,glyphId:g}))}}else if(6===h){t.skip(4);const e=t.getUint16(),a=t.getUint16();for(f=0;f<a;f++){g=t.getUint16();const a=e+f;d.push({charCode:a,glyphId:g})}}else{if(12!==h)return(0,n.warn)("cmap table has unsupported format: "+h),{platformId:-1,encodingId:-1,mappings:[],hasShortCmap:!1};{t.skip(10);const e=t.getInt32()>>>0;for(f=0;f<e;f++){const e=t.getInt32()>>>0,a=t.getInt32()>>>0;let n=t.getInt32()>>>0;for(let t=e;t<=a;t++)d.push({charCode:t,glyphId:n++})}}}d.sort((function(e,t){return e.charCode-t.charCode}));for(let e=1;e<d.length;e++)d[e-1].charCode===d[e].charCode&&(d.splice(e,1),e--);return{platformId:c.platformId,encodingId:c.encodingId,mappings:d,hasShortCmap:u}}(k.cmap,t,this.isSymbolicFont,a.hasEncoding),r=e.platformId,s=e.encodingId,l=e.mappings;let u=[],d=!1;if(!a.hasEncoding||"MacRomanEncoding"!==a.baseEncodingName&&"WinAnsiEncoding"!==a.baseEncodingName||(u=(0,c.getEncoding)(a.baseEncodingName)),a.hasEncoding&&!this.isSymbolicFont&&(3===r&&1===s||1===r&&0===s)){const e=(0,o.getGlyphsUnicode)();for(let t=0;t<256;t++){let n;if(n=void 0!==this.differences[t]?this.differences[t]:u.length&&""!==u[t]?u[t]:c.StandardEncoding[t],!n)continue;const o=(0,i.recoverGlyphName)(n,e);let d;if(3===r&&1===s?d=e[o]:1===r&&0===s&&(d=c.MacRomanEncoding.indexOf(o)),void 0===d){if(!a.glyphNames&&a.hasIncludedToUnicodeMap&&!(this.toUnicode instanceof h.IdentityToUnicodeMap)){const e=this.toUnicode.get(t);e&&(d=e.codePointAt(0))}if(void 0===d)continue}for(const e of l)if(e.charCode===d){K[t]=e.glyphId;break}}}else if(0===r){for(const e of l)K[e.charCode]=e.glyphId;d=!0}else for(const e of l){let t=e.charCode;3===r&&t>=61440&&t<=61695&&(t&=255),K[t]=e.glyphId}if(a.glyphNames&&(u.length||this.differences.length))for(let e=0;e<256;++e){if(!d&&void 0!==K[e])continue;const t=this.differences[e]||u[e];if(!t)continue;const n=a.glyphNames.indexOf(t);n>0&&Y(n)&&(K[e]=n)}}0===K.length&&(K[0]=0);let J=R-1;if(E||(J=0),!a.cssFontInfo){const e=_(K,Y,J,this.toUnicode);this.toFontChar=e.toFontChar,k.cmap={tag:"cmap",data:j(e.charCodeToGlyphId,e.toUnicodeExtraMap,R)},k["OS/2"]&&function(e,t){t.pos=(t.start||0)+e.offset;const a=t.getUint16();t.skip(60);const n=t.getUint16();return!(a<4&&768&n)&&(!(t.getUint16()>t.getUint16())&&(t.skip(6),0!==t.getUint16()&&(e.data[8]=e.data[9]=0,!0)))}(k["OS/2"],t)||(k["OS/2"]={tag:"OS/2",data:U(a,e.charCodeToGlyphId,V)})}if(!M)try{F=new y.Stream(k["CFF "].data);v=new r.CFFParser(F,a,i.SEAC_ANALYSIS_ENABLED).parse(),v.duplicateFirstGlyph();const e=new r.CFFCompiler(v);k["CFF "].data=e.compile()}catch{(0,n.warn)("Failed to compile font "+a.loadedName)}if(k.name){const[t,n]=w(k.name);k.name.data=q(e,t),this.psName=t[0][6]||null,a.composite||function(e,t,a){if(e.isInternalFont)return;if(e.hasIncludedToUnicodeMap)return;if(e.hasEncoding)return;if(e.toUnicode instanceof h.IdentityToUnicodeMap)return;if(!t)return;if(0===a.length)return;if(e.defaultEncoding===c.WinAnsiEncoding)return;for(const e of a)if(!$(e))return;const n=c.WinAnsiEncoding,r=[],i=(0,o.getGlyphsUnicode)();for(const e in n){const t=n[e];if(""===t)continue;const a=i[t];void 0!==a&&(r[e]=String.fromCharCode(a))}r.length>0&&e.toUnicode.amend(r)}(a,this.isSymbolicFont,n)}else k.name={tag:"name",data:q(this.name)};const Z=new m.OpenTypeFileBuilder(A.version);for(const e in k)Z.addTable(e,k[e].data);return Z.toArray()}convert(e,t,a){a.fixedPitch=!1,a.builtInEncoding&&function(e,t){if(e.isInternalFont)return;if(e.hasIncludedToUnicodeMap)return;if(t===e.defaultEncoding)return;if(e.toUnicode instanceof h.IdentityToUnicodeMap)return;const a=[],n=(0,o.getGlyphsUnicode)();for(const r in t){if(e.hasEncoding&&(e.baseEncodingName||void 0!==e.differences[r]))continue;const i=t[r],o=(0,s.getUnicodeForGlyph)(i,n);-1!==o&&(a[r]=String.fromCharCode(o))}a.length>0&&e.toUnicode.amend(a)}(a,a.builtInEncoding);let r=1;t instanceof u.CFFFont&&(r=t.numGlyphs-1);const l=t.getGlyphMapping(a);let d=null,f=l,g=null;a.cssFontInfo||(d=_(l,t.hasGlyphId.bind(t),r,this.toUnicode),this.toFontChar=d.toFontChar,f=d.charCodeToGlyphId,g=d.toUnicodeExtraMap);const p=t.numGlyphs;function b(e,t){let a=null;for(const n in e)t===e[n]&&(a||=[]).push(0|n);return a}function y(e,t){for(const a in e)if(t===e[a])return 0|a;return d.charCodeToGlyphId[d.nextAvailableFontCharCode]=t,d.nextAvailableFontCharCode++}const w=t.seacs;if(d&&i.SEAC_ANALYSIS_ENABLED&&w?.length){const e=a.fontMatrix||n.FONT_IDENTITY_MATRIX,r=t.getCharset(),i=Object.create(null);for(let t in w){t|=0;const a=w[t],n=c.StandardEncoding[a[2]],s=c.StandardEncoding[a[3]],o=r.indexOf(n),h=r.indexOf(s);if(o<0||h<0)continue;const u={x:a[0]*e[0]+a[1]*e[2]+e[4],y:a[0]*e[1]+a[1]*e[3]+e[5]},f=b(l,t);if(f)for(const e of f){const t=d.charCodeToGlyphId,a=y(t,o),n=y(t,h);i[e]={baseFontCharCode:a,accentFontCharCode:n,accentOffset:u}}}a.seacMap=i}const x=1/(a.fontMatrix||n.FONT_IDENTITY_MATRIX)[0],S=new m.OpenTypeFileBuilder("OTTO");return S.addTable("CFF ",t.data),S.addTable("OS/2",U(a,f)),S.addTable("cmap",j(f,g,p)),S.addTable("head","\0\0\0\0\0\0\0\0\0\0_<õ\0\0"+P(x)+"\0\0\0\0\v~'\0\0\0\0\v~'\0\0"+P(a.descent)+"ÿ"+P(a.ascent)+M(a.italicAngle?2:0)+"\0\0\0\0\0\0\0"),S.addTable("hhea","\0\0\0"+P(a.ascent)+P(a.descent)+"\0\0ÿÿ\0\0\0\0\0\0"+P(a.capHeight)+P(Math.tan(a.italicAngle)*a.xHeight)+"\0\0\0\0\0\0\0\0\0\0\0\0"+M(p)),S.addTable("hmtx",function(){const e=t.charstrings,a=t.cff?t.cff.widths:null;let n="\0\0\0\0";for(let t=1,r=p;t<r;t++){let r=0;if(e){const a=e[t-1];r="width"in a?a.width:0}else a&&(r=Math.ceil(a[t]||0));n+=M(r)+M(0)}return n}()),S.addTable("maxp","\0\0P\0"+M(p)),S.addTable("name",q(e)),S.addTable("post",X(a)),S.toArray()}get spaceWidth(){const e=["space","minus","one","i","I"];let t;for(const a of e){if(a in this.widths){t=this.widths[a];break}const e=(0,o.getGlyphsUnicode)()[a];let n=0;if(this.composite&&this.cMap.contains(e)&&(n=this.cMap.lookup(e),"string"==typeof n&&(n=L(e,n))),!n&&this.toUnicode&&(n=this.toUnicode.charCodeOf(e)),n<=0&&(n=e),t=this.widths[n],t)break}return(0,n.shadow)(this,"spaceWidth",t||this.defaultWidth)}_charToGlyph(e,t=!1){let a,r,i,o=this._glyphCache[e];if(o?.isSpace===t)return o;let c=e;this.cMap?.contains(e)&&(c=this.cMap.lookup(e),"string"==typeof c&&(c=L(e,c))),r=this.widths[c],"number"!=typeof r&&(r=this.defaultWidth);const l=this.vmetrics?.[c];let h=this.toUnicode.get(e)||e;"number"==typeof h&&(h=String.fromCharCode(h));let u=void 0!==this.toFontChar[e];if(a=this.toFontChar[e]||e,this.missingFile){const t=this.differences[e]||this.defaultEncoding[e];".notdef"!==t&&""!==t||"Type1"!==this.type||(a=32),a=(0,s.mapSpecialUnicodeValues)(a)}this.isType3Font&&(i=a);let d=null;if(this.seacMap?.[e]){u=!0;const t=this.seacMap[e];a=t.baseFontCharCode,d={fontChar:String.fromCodePoint(t.accentFontCharCode),offset:t.accentOffset}}let f="";return"number"==typeof a&&(a<=1114111?f=String.fromCodePoint(a):(0,n.warn)(`charToGlyph - invalid fontCharCode: ${a}`)),o=new F(e,f,h,d,r,l,i,t,u),this._glyphCache[e]=o}charsToGlyphs(e){let t=this._charsCache[e];if(t)return t;if(t=[],this.cMap){const a=Object.create(null),n=e.length;let r=0;for(;r<n;){this.cMap.readCharCode(e,r,a);const{charcode:n,length:i}=a;r+=i;const s=this._charToGlyph(n,1===i&&32===e.charCodeAt(r-1));t.push(s)}}else for(let a=0,n=e.length;a<n;++a){const n=e.charCodeAt(a),r=this._charToGlyph(n,32===n);t.push(r)}return this._charsCache[e]=t}getCharPositions(e){const t=[];if(this.cMap){const a=Object.create(null);let n=0;for(;n<e.length;){this.cMap.readCharCode(e,n,a);const r=a.length;t.push([n,n+r]),n+=r}}else for(let a=0,n=e.length;a<n;++a)t.push([a,a+1]);return t}get glyphCacheValues(){return Object.values(this._glyphCache)}encodeString(e){const t=[],a=[],n=()=>t.length%2==1,r=this.toUnicode instanceof h.IdentityToUnicodeMap?e=>this.toUnicode.charCodeOf(e):e=>this.toUnicode.charCodeOf(String.fromCodePoint(e));for(let i=0,s=e.length;i<s;i++){const s=e.codePointAt(i);if(s>55295&&(s<57344||s>65533)&&i++,this.toUnicode){const e=r(s);if(-1!==e){n()&&(t.push(a.join("")),a.length=0);for(let t=(this.cMap?this.cMap.getCharCodeLength(e):1)-1;t>=0;t--)a.push(String.fromCharCode(e>>8*t&255));continue}}n()||(t.push(a.join("")),a.length=0),a.push(String.fromCodePoint(s))}return t.push(a.join("")),t}};t.ErrorFont=class{constructor(e){this.error=e,this.loadedName="g_font_error",this.missingFile=!0}charsToGlyphs(){return[]}encodeString(e){return[e]}exportData(e=!1){return{error:this.error}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CFFTopDict=t.CFFStrings=t.CFFStandardStrings=t.CFFPrivateDict=t.CFFParser=t.CFFIndex=t.CFFHeader=t.CFFFDSelect=t.CFFCompiler=t.CFFCharset=t.CFF=void 0;var n=a(2),r=a(36),i=a(37);const s=[".notdef","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","endash","dagger","daggerdbl","periodcentered","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","questiondown","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","ring","cedilla","hungarumlaut","ogonek","caron","emdash","AE","ordfeminine","Lslash","Oslash","OE","ordmasculine","ae","dotlessi","lslash","oslash","oe","germandbls","onesuperior","logicalnot","mu","trademark","Eth","onehalf","plusminus","Thorn","onequarter","divide","brokenbar","degree","thorn","threequarters","twosuperior","registered","minus","eth","multiply","threesuperior","copyright","Aacute","Acircumflex","Adieresis","Agrave","Aring","Atilde","Ccedilla","Eacute","Ecircumflex","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Ntilde","Oacute","Ocircumflex","Odieresis","Ograve","Otilde","Scaron","Uacute","Ucircumflex","Udieresis","Ugrave","Yacute","Ydieresis","Zcaron","aacute","acircumflex","adieresis","agrave","aring","atilde","ccedilla","eacute","ecircumflex","edieresis","egrave","iacute","icircumflex","idieresis","igrave","ntilde","oacute","ocircumflex","odieresis","ograve","otilde","scaron","uacute","ucircumflex","udieresis","ugrave","yacute","ydieresis","zcaron","exclamsmall","Hungarumlautsmall","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","commasuperior","threequartersemdash","periodsuperior","questionsmall","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","ffi","ffl","parenleftinferior","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","exclamdownsmall","centoldstyle","Lslashsmall","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","Dotaccentsmall","Macronsmall","figuredash","hypheninferior","Ogoneksmall","Ringsmall","Cedillasmall","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall","001.000","001.001","001.002","001.003","Black","Bold","Book","Light","Medium","Regular","Roman","Semibold"];t.CFFStandardStrings=s;const o=391,c=[null,{id:"hstem",min:2,stackClearing:!0,stem:!0},null,{id:"vstem",min:2,stackClearing:!0,stem:!0},{id:"vmoveto",min:1,stackClearing:!0},{id:"rlineto",min:2,resetStack:!0},{id:"hlineto",min:1,resetStack:!0},{id:"vlineto",min:1,resetStack:!0},{id:"rrcurveto",min:6,resetStack:!0},null,{id:"callsubr",min:1,undefStack:!0},{id:"return",min:0,undefStack:!0},null,null,{id:"endchar",min:0,stackClearing:!0},null,null,null,{id:"hstemhm",min:2,stackClearing:!0,stem:!0},{id:"hintmask",min:0,stackClearing:!0},{id:"cntrmask",min:0,stackClearing:!0},{id:"rmoveto",min:2,stackClearing:!0},{id:"hmoveto",min:1,stackClearing:!0},{id:"vstemhm",min:2,stackClearing:!0,stem:!0},{id:"rcurveline",min:8,resetStack:!0},{id:"rlinecurve",min:8,resetStack:!0},{id:"vvcurveto",min:4,resetStack:!0},{id:"hhcurveto",min:4,resetStack:!0},null,{id:"callgsubr",min:1,undefStack:!0},{id:"vhcurveto",min:4,resetStack:!0},{id:"hvcurveto",min:4,resetStack:!0}],l=[null,null,null,{id:"and",min:2,stackDelta:-1},{id:"or",min:2,stackDelta:-1},{id:"not",min:1,stackDelta:0},null,null,null,{id:"abs",min:1,stackDelta:0},{id:"add",min:2,stackDelta:-1,stackFn(e,t){e[t-2]=e[t-2]+e[t-1]}},{id:"sub",min:2,stackDelta:-1,stackFn(e,t){e[t-2]=e[t-2]-e[t-1]}},{id:"div",min:2,stackDelta:-1,stackFn(e,t){e[t-2]=e[t-2]/e[t-1]}},null,{id:"neg",min:1,stackDelta:0,stackFn(e,t){e[t-1]=-e[t-1]}},{id:"eq",min:2,stackDelta:-1},null,null,{id:"drop",min:1,stackDelta:-1},null,{id:"put",min:2,stackDelta:-2},{id:"get",min:1,stackDelta:0},{id:"ifelse",min:4,stackDelta:-3},{id:"random",min:0,stackDelta:1},{id:"mul",min:2,stackDelta:-1,stackFn(e,t){e[t-2]=e[t-2]*e[t-1]}},null,{id:"sqrt",min:1,stackDelta:0},{id:"dup",min:1,stackDelta:1},{id:"exch",min:2,stackDelta:0},{id:"index",min:2,stackDelta:0},{id:"roll",min:3,stackDelta:-2},null,null,null,{id:"hflex",min:7,resetStack:!0},{id:"flex",min:13,resetStack:!0},{id:"hflex1",min:9,resetStack:!0},{id:"flex1",min:11,resetStack:!0}];t.CFFParser=class{constructor(e,t,a){this.bytes=e.getBytes(),this.properties=t,this.seacAnalysisEnabled=!!a}parse(){const e=this.properties,t=new h;this.cff=t;const a=this.parseHeader(),n=this.parseIndex(a.endPos),r=this.parseIndex(n.endPos),i=this.parseIndex(r.endPos),s=this.parseIndex(i.endPos),o=this.parseDict(r.obj.get(0)),c=this.createDict(m,o,t.strings);t.header=a.obj,t.names=this.parseNameIndex(n.obj),t.strings=this.parseStringIndex(i.obj),t.topDict=c,t.globalSubrIndex=s.obj,this.parsePrivateDict(t.topDict),t.isCIDFont=c.hasName("ROS");const l=c.getByName("CharStrings"),u=this.parseIndex(l).obj,d=c.getByName("FontMatrix");d&&(e.fontMatrix=d);const f=c.getByName("FontBBox");let g,p;if(f&&(e.ascent=Math.max(f[3],f[1]),e.descent=Math.min(f[1],f[3]),e.ascentScaled=!0),t.isCIDFont){const e=this.parseIndex(c.getByName("FDArray")).obj;for(let a=0,n=e.count;a<n;++a){const n=e.get(a),r=this.createDict(m,this.parseDict(n),t.strings);this.parsePrivateDict(r),t.fdArray.push(r)}p=null,g=this.parseCharsets(c.getByName("charset"),u.count,t.strings,!0),t.fdSelect=this.parseFDSelect(c.getByName("FDSelect"),u.count)}else g=this.parseCharsets(c.getByName("charset"),u.count,t.strings,!1),p=this.parseEncoding(c.getByName("Encoding"),e,t.strings,g.charset);t.charset=g,t.encoding=p;const b=this.parseCharStrings({charStrings:u,localSubrIndex:c.privateDict.subrsIndex,globalSubrIndex:s.obj,fdSelect:t.fdSelect,fdArray:t.fdArray,privateDict:c.privateDict});return t.charStrings=b.charStrings,t.seacs=b.seacs,t.widths=b.widths,t}parseHeader(){let e=this.bytes;const t=e.length;let a=0;for(;a<t&&1!==e[a];)++a;if(a>=t)throw new n.FormatError("Invalid CFF header");0!==a&&((0,n.info)("cff data is shifted"),e=e.subarray(a),this.bytes=e);const r=e[0],i=e[1],s=e[2],o=e[3];return{obj:new u(r,i,s,o),endPos:s}}parseDict(e){let t=0;function a(){let a=e[t++];return 30===a?function(){let a="";const n=15,r=["0","1","2","3","4","5","6","7","8","9",".","E","E-",null,"-"],i=e.length;for(;t<i;){const i=e[t++],s=i>>4,o=15&i;if(s===n)break;if(a+=r[s],o===n)break;a+=r[o]}return parseFloat(a)}():28===a?(a=e[t++],a=(a<<24|e[t++]<<16)>>16,a):29===a?(a=e[t++],a=a<<8|e[t++],a=a<<8|e[t++],a=a<<8|e[t++],a):a>=32&&a<=246?a-139:a>=247&&a<=250?256*(a-247)+e[t++]+108:a>=251&&a<=254?-256*(a-251)-e[t++]-108:((0,n.warn)('CFFParser_parseDict: "'+a+'" is a reserved command.'),NaN)}let r=[];const i=[];t=0;const s=e.length;for(;t<s;){let n=e[t];n<=21?(12===n&&(n=n<<8|e[++t]),i.push([n,r]),r=[],++t):r.push(a())}return i}parseIndex(e){const t=new f,a=this.bytes,n=a[e++]<<8|a[e++],r=[];let i,s,o=e;if(0!==n){const t=a[e++],c=e+(n+1)*t-1;for(i=0,s=n+1;i<s;++i){let n=0;for(let r=0;r<t;++r)n<<=8,n+=a[e++];r.push(c+n)}o=r[n]}for(i=0,s=r.length-1;i<s;++i){const e=r[i],n=r[i+1];t.add(a.subarray(e,n))}return{obj:t,endPos:o}}parseNameIndex(e){const t=[];for(let a=0,r=e.count;a<r;++a){const r=e.get(a);t.push((0,n.bytesToString)(r))}return t}parseStringIndex(e){const t=new d;for(let a=0,r=e.count;a<r;++a){const r=e.get(a);t.add((0,n.bytesToString)(r))}return t}createDict(e,t,a){const n=new e(a);for(const[e,a]of t)n.setByKey(e,a);return n}parseCharString(e,t,a,r){if(!t||e.callDepth>10)return!1;let i=e.stackSize;const s=e.stack;let o=t.length;for(let h=0;h<o;){const u=t[h++];let d=null;if(12===u){const e=t[h++];0===e?(t[h-2]=139,t[h-1]=22,i=0):d=l[e]}else if(28===u)s[i]=(t[h]<<24|t[h+1]<<16)>>16,h+=2,i++;else if(14===u){if(i>=4&&(i-=4,this.seacAnalysisEnabled))return e.seac=s.slice(i,i+4),!1;d=c[u]}else if(u>=32&&u<=246)s[i]=u-139,i++;else if(u>=247&&u<=254)s[i]=u<251?(u-247<<8)+t[h]+108:-(u-251<<8)-t[h]-108,h++,i++;else if(255===u)s[i]=(t[h]<<24|t[h+1]<<16|t[h+2]<<8|t[h+3])/65536,h+=4,i++;else if(19===u||20===u){if(e.hints+=i>>1,0===e.hints){t.copyWithin(h-1,h,-1),h-=1,o-=1;continue}h+=e.hints+7>>3,i%=2,d=c[u]}else{if(10===u||29===u){const t=10===u?a:r;if(!t)return d=c[u],(0,n.warn)("Missing subrsIndex for "+d.id),!1;let o=32768;t.count<1240?o=107:t.count<33900&&(o=1131);const l=s[--i]+o;if(l<0||l>=t.count||isNaN(l))return d=c[u],(0,n.warn)("Out of bounds subrIndex for "+d.id),!1;e.stackSize=i,e.callDepth++;if(!this.parseCharString(e,t.get(l),a,r))return!1;e.callDepth--,i=e.stackSize;continue}if(11===u)return e.stackSize=i,!0;if(0===u&&h===t.length)t[h-1]=14,d=c[14];else{if(9===u){t.copyWithin(h-1,h,-1),h-=1,o-=1;continue}d=c[u]}}if(d){if(d.stem&&(e.hints+=i>>1,3===u||23===u?e.hasVStems=!0:!e.hasVStems||1!==u&&18!==u||((0,n.warn)("CFF stem hints are in wrong order"),t[h-1]=1===u?3:23)),"min"in d&&!e.undefStack&&i<d.min)return(0,n.warn)("Not enough parameters for "+d.id+"; actual: "+i+", expected: "+d.min),0===i&&(t[h-1]=14,!0);e.firstStackClearing&&d.stackClearing&&(e.firstStackClearing=!1,i-=d.min,i>=2&&d.stem?i%=2:i>1&&(0,n.warn)("Found too many parameters for stack-clearing command"),i>0&&(e.width=s[i-1])),"stackDelta"in d?("stackFn"in d&&d.stackFn(s,i),i+=d.stackDelta):d.stackClearing?i=0:d.resetStack?(i=0,e.undefStack=!1):d.undefStack&&(i=0,e.undefStack=!0,e.firstStackClearing=!1)}}return o<t.length&&t.fill(14,o),e.stackSize=i,!0}parseCharStrings({charStrings:e,localSubrIndex:t,globalSubrIndex:a,fdSelect:r,fdArray:i,privateDict:s}){const o=[],c=[],l=e.count;for(let h=0;h<l;h++){const l=e.get(h),u={callDepth:0,stackSize:0,stack:[],undefStack:!0,hints:0,firstStackClearing:!0,seac:null,width:null,hasVStems:!1};let d=!0,f=null,g=s;if(r&&i.length){const e=r.getFDIndex(h);-1===e&&((0,n.warn)("Glyph index is not in fd select."),d=!1),e>=i.length&&((0,n.warn)("Invalid fd index for glyph index."),d=!1),d&&(g=i[e].privateDict,f=g.subrsIndex)}else t&&(f=t);if(d&&(d=this.parseCharString(u,l,f,a)),null!==u.width){const e=g.getByName("nominalWidthX");c[h]=e+u.width}else{const e=g.getByName("defaultWidthX");c[h]=e}null!==u.seac&&(o[h]=u.seac),d||e.set(h,new Uint8Array([14]))}return{charStrings:e,seacs:o,widths:c}}emptyPrivateDictionary(e){const t=this.createDict(y,[],e.strings);e.setByKey(18,[0,0]),e.privateDict=t}parsePrivateDict(e){if(!e.hasName("Private"))return void this.emptyPrivateDictionary(e);const t=e.getByName("Private");if(!Array.isArray(t)||2!==t.length)return void e.removeByName("Private");const a=t[0],n=t[1];if(0===a||n>=this.bytes.length)return void this.emptyPrivateDictionary(e);const r=n+a,i=this.bytes.subarray(n,r),s=this.parseDict(i),o=this.createDict(y,s,e.strings);if(e.privateDict=o,0===o.getByName("ExpansionFactor")&&o.setByName("ExpansionFactor",.06),!o.getByName("Subrs"))return;const c=o.getByName("Subrs"),l=n+c;if(0===c||l>=this.bytes.length)return void this.emptyPrivateDictionary(e);const h=this.parseIndex(l);o.subrsIndex=h.obj}parseCharsets(e,t,a,i){if(0===e)return new x(!0,w.ISO_ADOBE,r.ISOAdobeCharset);if(1===e)return new x(!0,w.EXPERT,r.ExpertCharset);if(2===e)return new x(!0,w.EXPERT_SUBSET,r.ExpertSubsetCharset);const s=this.bytes,o=e,c=s[e++],l=[i?0:".notdef"];let h,u,d;switch(t-=1,c){case 0:for(d=0;d<t;d++)h=s[e++]<<8|s[e++],l.push(i?h:a.get(h));break;case 1:for(;l.length<=t;)for(h=s[e++]<<8|s[e++],u=s[e++],d=0;d<=u;d++)l.push(i?h++:a.get(h++));break;case 2:for(;l.length<=t;)for(h=s[e++]<<8|s[e++],u=s[e++]<<8|s[e++],d=0;d<=u;d++)l.push(i?h++:a.get(h++));break;default:throw new n.FormatError("Unknown charset format")}const f=e,g=s.subarray(o,f);return new x(!1,c,l,g)}parseEncoding(e,t,a,r){const s=Object.create(null),o=this.bytes;let c,l,h,u=!1,d=null;if(0===e||1===e){u=!0,c=e;const t=e?i.ExpertEncoding:i.StandardEncoding;for(l=0,h=r.length;l<h;l++){const e=t.indexOf(r[l]);-1!==e&&(s[e]=l)}}else{const t=e;switch(c=o[e++],127&c){case 0:const t=o[e++];for(l=1;l<=t;l++)s[o[e++]]=l;break;case 1:const a=o[e++];let r=1;for(l=0;l<a;l++){const t=o[e++],a=o[e++];for(let e=t;e<=t+a;e++)s[e]=r++}break;default:throw new n.FormatError(`Unknown encoding format: ${c} in CFF`)}const i=e;128&c&&(o[t]&=127,function(){const t=o[e++];for(l=0;l<t;l++){const t=o[e++],n=(o[e++]<<8)+(255&o[e++]);s[t]=r.indexOf(a.get(n))}}()),d=o.subarray(t,i)}return c&=127,new S(u,c,s,d)}parseFDSelect(e,t){const a=this.bytes,r=a[e++],i=[];let s;switch(r){case 0:for(s=0;s<t;++s){const t=a[e++];i.push(t)}break;case 3:const o=a[e++]<<8|a[e++];for(s=0;s<o;++s){let t=a[e++]<<8|a[e++];0===s&&0!==t&&((0,n.warn)("parseFDSelect: The first range must have a first GID of 0 -- trying to recover."),t=0);const r=a[e++],o=a[e]<<8|a[e+1];for(let e=t;e<o;++e)i.push(r)}e+=2;break;default:throw new n.FormatError(`parseFDSelect: Unknown format "${r}".`)}if(i.length!==t)throw new n.FormatError("parseFDSelect: Invalid font data.");return new A(r,i)}};class h{constructor(){this.header=null,this.names=[],this.topDict=null,this.strings=new d,this.globalSubrIndex=null,this.encoding=null,this.charset=null,this.charStrings=null,this.fdArray=[],this.fdSelect=null,this.isCIDFont=!1}duplicateFirstGlyph(){if(this.charStrings.count>=65535)return void(0,n.warn)("Not enough space in charstrings to duplicate first glyph.");const e=this.charStrings.get(0);this.charStrings.add(e),this.isCIDFont&&this.fdSelect.fdSelect.push(this.fdSelect.fdSelect[0])}hasGlyphId(e){if(e<0||e>=this.charStrings.count)return!1;return this.charStrings.get(e).length>0}}t.CFF=h;class u{constructor(e,t,a,n){this.major=e,this.minor=t,this.hdrSize=a,this.offSize=n}}t.CFFHeader=u;class d{constructor(){this.strings=[]}get(e){return e>=0&&e<=390?s[e]:e-o<=this.strings.length?this.strings[e-o]:s[0]}getSID(e){let t=s.indexOf(e);return-1!==t?t:(t=this.strings.indexOf(e),-1!==t?t+o:-1)}add(e){this.strings.push(e)}get count(){return this.strings.length}}t.CFFStrings=d;class f{constructor(){this.objects=[],this.length=0}add(e){this.length+=e.length,this.objects.push(e)}set(e,t){this.length+=t.length-this.objects[e].length,this.objects[e]=t}get(e){return this.objects[e]}get count(){return this.objects.length}}t.CFFIndex=f;class g{constructor(e,t){this.keyToNameMap=e.keyToNameMap,this.nameToKeyMap=e.nameToKeyMap,this.defaults=e.defaults,this.types=e.types,this.opcodes=e.opcodes,this.order=e.order,this.strings=t,this.values=Object.create(null)}setByKey(e,t){if(!(e in this.keyToNameMap))return!1;if(0===t.length)return!0;for(const a of t)if(isNaN(a))return(0,n.warn)(`Invalid CFFDict value: "${t}" for key "${e}".`),!0;const a=this.types[e];return"num"!==a&&"sid"!==a&&"offset"!==a||(t=t[0]),this.values[e]=t,!0}setByName(e,t){if(!(e in this.nameToKeyMap))throw new n.FormatError(`Invalid dictionary name "${e}"`);this.values[this.nameToKeyMap[e]]=t}hasName(e){return this.nameToKeyMap[e]in this.values}getByName(e){if(!(e in this.nameToKeyMap))throw new n.FormatError(`Invalid dictionary name ${e}"`);const t=this.nameToKeyMap[e];return t in this.values?this.values[t]:this.defaults[t]}removeByName(e){delete this.values[this.nameToKeyMap[e]]}static createTables(e){const t={keyToNameMap:{},nameToKeyMap:{},defaults:{},types:{},opcodes:{},order:[]};for(const a of e){const e=Array.isArray(a[0])?(a[0][0]<<8)+a[0][1]:a[0];t.keyToNameMap[e]=a[1],t.nameToKeyMap[a[1]]=e,t.types[e]=a[2],t.defaults[e]=a[3],t.opcodes[e]=Array.isArray(a[0])?a[0]:[a[0]],t.order.push(e)}return t}}const p=[[[12,30],"ROS",["sid","sid","num"],null],[[12,20],"SyntheticBase","num",null],[0,"version","sid",null],[1,"Notice","sid",null],[[12,0],"Copyright","sid",null],[2,"FullName","sid",null],[3,"FamilyName","sid",null],[4,"Weight","sid",null],[[12,1],"isFixedPitch","num",0],[[12,2],"ItalicAngle","num",0],[[12,3],"UnderlinePosition","num",-100],[[12,4],"UnderlineThickness","num",50],[[12,5],"PaintType","num",0],[[12,6],"CharstringType","num",2],[[12,7],"FontMatrix",["num","num","num","num","num","num"],[.001,0,0,.001,0,0]],[13,"UniqueID","num",null],[5,"FontBBox",["num","num","num","num"],[0,0,0,0]],[[12,8],"StrokeWidth","num",0],[14,"XUID","array",null],[15,"charset","offset",0],[16,"Encoding","offset",0],[17,"CharStrings","offset",0],[18,"Private",["offset","offset"],null],[[12,21],"PostScript","sid",null],[[12,22],"BaseFontName","sid",null],[[12,23],"BaseFontBlend","delta",null],[[12,31],"CIDFontVersion","num",0],[[12,32],"CIDFontRevision","num",0],[[12,33],"CIDFontType","num",0],[[12,34],"CIDCount","num",8720],[[12,35],"UIDBase","num",null],[[12,37],"FDSelect","offset",null],[[12,36],"FDArray","offset",null],[[12,38],"FontName","sid",null]];class m extends g{static get tables(){return(0,n.shadow)(this,"tables",this.createTables(p))}constructor(e){super(m.tables,e),this.privateDict=null}}t.CFFTopDict=m;const b=[[6,"BlueValues","delta",null],[7,"OtherBlues","delta",null],[8,"FamilyBlues","delta",null],[9,"FamilyOtherBlues","delta",null],[[12,9],"BlueScale","num",.039625],[[12,10],"BlueShift","num",7],[[12,11],"BlueFuzz","num",1],[10,"StdHW","num",null],[11,"StdVW","num",null],[[12,12],"StemSnapH","delta",null],[[12,13],"StemSnapV","delta",null],[[12,14],"ForceBold","num",0],[[12,17],"LanguageGroup","num",0],[[12,18],"ExpansionFactor","num",.06],[[12,19],"initialRandomSeed","num",0],[20,"defaultWidthX","num",0],[21,"nominalWidthX","num",0],[19,"Subrs","offset",null]];class y extends g{static get tables(){return(0,n.shadow)(this,"tables",this.createTables(b))}constructor(e){super(y.tables,e),this.subrsIndex=null}}t.CFFPrivateDict=y;const w={ISO_ADOBE:0,EXPERT:1,EXPERT_SUBSET:2};class x{constructor(e,t,a,n){this.predefined=e,this.format=t,this.charset=a,this.raw=n}}t.CFFCharset=x;class S{constructor(e,t,a,n){this.predefined=e,this.format=t,this.encoding=a,this.raw=n}}class A{constructor(e,t){this.format=e,this.fdSelect=t}getFDIndex(e){return e<0||e>=this.fdSelect.length?-1:this.fdSelect[e]}}t.CFFFDSelect=A;class k{constructor(){this.offsets=Object.create(null)}isTracking(e){return e in this.offsets}track(e,t){if(e in this.offsets)throw new n.FormatError(`Already tracking location of ${e}`);this.offsets[e]=t}offset(e){for(const t in this.offsets)this.offsets[t]+=e}setEntryLocation(e,t,a){if(!(e in this.offsets))throw new n.FormatError(`Not tracking location of ${e}`);const r=a.data,i=this.offsets[e];for(let e=0,a=t.length;e<a;++e){const a=5*e+i,s=a+1,o=a+2,c=a+3,l=a+4;if(29!==r[a]||0!==r[s]||0!==r[o]||0!==r[c]||0!==r[l])throw new n.FormatError("writing to an offset that is not empty");const h=t[e];r[a]=29,r[s]=h>>24&255,r[o]=h>>16&255,r[c]=h>>8&255,r[l]=255&h}}}class C{constructor(e){this.cff=e}compile(){const e=this.cff,t={data:[],length:0,add(e){try{this.data.push(...e)}catch{this.data=this.data.concat(e)}this.length=this.data.length}},a=this.compileHeader(e.header);t.add(a);const r=this.compileNameIndex(e.names);if(t.add(r),e.isCIDFont&&e.topDict.hasName("FontMatrix")){const t=e.topDict.getByName("FontMatrix");e.topDict.removeByName("FontMatrix");for(const a of e.fdArray){let e=t.slice(0);a.hasName("FontMatrix")&&(e=n.Util.transform(e,a.getByName("FontMatrix"))),a.setByName("FontMatrix",e)}}const i=e.topDict.getByName("XUID");i?.length>16&&e.topDict.removeByName("XUID"),e.topDict.setByName("charset",0);let s=this.compileTopDicts([e.topDict],t.length,e.isCIDFont);t.add(s.output);const o=s.trackers[0],c=this.compileStringIndex(e.strings.strings);t.add(c);const l=this.compileIndex(e.globalSubrIndex);if(t.add(l),e.encoding&&e.topDict.hasName("Encoding"))if(e.encoding.predefined)o.setEntryLocation("Encoding",[e.encoding.format],t);else{const a=this.compileEncoding(e.encoding);o.setEntryLocation("Encoding",[t.length],t),t.add(a)}const h=this.compileCharset(e.charset,e.charStrings.count,e.strings,e.isCIDFont);o.setEntryLocation("charset",[t.length],t),t.add(h);const u=this.compileCharStrings(e.charStrings);if(o.setEntryLocation("CharStrings",[t.length],t),t.add(u),e.isCIDFont){o.setEntryLocation("FDSelect",[t.length],t);const a=this.compileFDSelect(e.fdSelect);t.add(a),s=this.compileTopDicts(e.fdArray,t.length,!0),o.setEntryLocation("FDArray",[t.length],t),t.add(s.output);const n=s.trackers;this.compilePrivateDicts(e.fdArray,n,t)}return this.compilePrivateDicts([e.topDict],[o],t),t.add([0]),t.data}encodeNumber(e){return Number.isInteger(e)?this.encodeInteger(e):this.encodeFloat(e)}static get EncodeFloatRegExp(){return(0,n.shadow)(this,"EncodeFloatRegExp",/\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/)}encodeFloat(e){let t=e.toString();const a=C.EncodeFloatRegExp.exec(t);if(a){const n=parseFloat("1e"+((a[2]?+a[2]:0)+a[1].length));t=(Math.round(e*n)/n).toString()}let n,r,i="";for(n=0,r=t.length;n<r;++n){const e=t[n];i+="e"===e?"-"===t[++n]?"c":"b":"."===e?"a":"-"===e?"e":e}i+=1&i.length?"f":"ff";const s=[30];for(n=0,r=i.length;n<r;n+=2)s.push(parseInt(i.substring(n,n+2),16));return s}encodeInteger(e){let t;return t=e>=-107&&e<=107?[e+139]:e>=108&&e<=1131?[247+((e-=108)>>8),255&e]:e>=-1131&&e<=-108?[251+((e=-e-108)>>8),255&e]:e>=-32768&&e<=32767?[28,e>>8&255,255&e]:[29,e>>24&255,e>>16&255,e>>8&255,255&e],t}compileHeader(e){return[e.major,e.minor,4,e.offSize]}compileNameIndex(e){const t=new f;for(const a of e){const e=Math.min(a.length,127);let r=new Array(e);for(let t=0;t<e;t++){let e=a[t];(e<"!"||e>"~"||"["===e||"]"===e||"("===e||")"===e||"{"===e||"}"===e||"<"===e||">"===e||"/"===e||"%"===e)&&(e="_"),r[t]=e}r=r.join(""),""===r&&(r="Bad_Font_Name"),t.add((0,n.stringToBytes)(r))}return this.compileIndex(t)}compileTopDicts(e,t,a){const n=[];let r=new f;for(const i of e){a&&(i.removeByName("CIDFontVersion"),i.removeByName("CIDFontRevision"),i.removeByName("CIDFontType"),i.removeByName("CIDCount"),i.removeByName("UIDBase"));const e=new k,s=this.compileDict(i,e);n.push(e),r.add(s),e.offset(t)}return r=this.compileIndex(r,n),{trackers:n,output:r}}compilePrivateDicts(e,t,a){for(let r=0,i=e.length;r<i;++r){const i=e[r],s=i.privateDict;if(!s||!i.hasName("Private"))throw new n.FormatError("There must be a private dictionary.");const o=new k,c=this.compileDict(s,o);let l=a.length;if(o.offset(l),c.length||(l=0),t[r].setEntryLocation("Private",[c.length,l],a),a.add(c),s.subrsIndex&&s.hasName("Subrs")){const e=this.compileIndex(s.subrsIndex);o.setEntryLocation("Subrs",[c.length],a),a.add(e)}}}compileDict(e,t){const a=[];for(const r of e.order){if(!(r in e.values))continue;let i=e.values[r],s=e.types[r];if(Array.isArray(s)||(s=[s]),Array.isArray(i)||(i=[i]),0!==i.length){for(let o=0,c=s.length;o<c;++o){const c=s[o],l=i[o];switch(c){case"num":case"sid":a.push(...this.encodeNumber(l));break;case"offset":const s=e.keyToNameMap[r];t.isTracking(s)||t.track(s,a.length),a.push(29,0,0,0,0);break;case"array":case"delta":a.push(...this.encodeNumber(l));for(let e=1,t=i.length;e<t;++e)a.push(...this.encodeNumber(i[e]));break;default:throw new n.FormatError(`Unknown data type of ${c}`)}}a.push(...e.opcodes[r])}}return a}compileStringIndex(e){const t=new f;for(const a of e)t.add((0,n.stringToBytes)(a));return this.compileIndex(t)}compileCharStrings(e){const t=new f;for(let a=0;a<e.count;a++){const n=e.get(a);0!==n.length?t.add(n):t.add(new Uint8Array([139,14]))}return this.compileIndex(t)}compileCharset(e,t,a,r){let i;const s=t-1;if(r)i=new Uint8Array([2,0,0,s>>8&255,255&s]);else{i=new Uint8Array(1+2*s),i[0]=0;let t=0;const r=e.charset.length;let o=!1;for(let s=1;s<i.length;s+=2){let c=0;if(t<r){const r=e.charset[t++];c=a.getSID(r),-1===c&&(c=0,o||(o=!0,(0,n.warn)(`Couldn't find ${r} in CFF strings`)))}i[s]=c>>8&255,i[s+1]=255&c}}return this.compileTypedArray(i)}compileEncoding(e){return this.compileTypedArray(e.raw)}compileFDSelect(e){const t=e.format;let a,n;switch(t){case 0:for(a=new Uint8Array(1+e.fdSelect.length),a[0]=t,n=0;n<e.fdSelect.length;n++)a[n+1]=e.fdSelect[n];break;case 3:const r=0;let i=e.fdSelect[0];const s=[t,0,0,r>>8&255,255&r,i];for(n=1;n<e.fdSelect.length;n++){const t=e.fdSelect[n];t!==i&&(s.push(n>>8&255,255&n,t),i=t)}const o=(s.length-3)/3;s[1]=o>>8&255,s[2]=255&o,s.push(n>>8&255,255&n),a=new Uint8Array(s)}return this.compileTypedArray(a)}compileTypedArray(e){return Array.from(e)}compileIndex(e,t=[]){const a=e.objects,n=a.length;if(0===n)return[0,0];const r=[n>>8&255,255&n];let i,s,o=1;for(i=0;i<n;++i)o+=a[i].length;s=o<256?1:o<65536?2:o<16777216?3:4,r.push(s);let c=1;for(i=0;i<n+1;i++)1===s?r.push(255&c):2===s?r.push(c>>8&255,255&c):3===s?r.push(c>>16&255,c>>8&255,255&c):r.push(c>>>24&255,c>>16&255,c>>8&255,255&c),a[i]&&(c+=a[i].length);for(i=0;i<n;i++)t[i]&&t[i].offset(r.length),r.push(...a[i]);return r}}t.CFFCompiler=C},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ISOAdobeCharset=t.ExpertSubsetCharset=t.ExpertCharset=void 0;t.ISOAdobeCharset=[".notdef","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","endash","dagger","daggerdbl","periodcentered","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","questiondown","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","ring","cedilla","hungarumlaut","ogonek","caron","emdash","AE","ordfeminine","Lslash","Oslash","OE","ordmasculine","ae","dotlessi","lslash","oslash","oe","germandbls","onesuperior","logicalnot","mu","trademark","Eth","onehalf","plusminus","Thorn","onequarter","divide","brokenbar","degree","thorn","threequarters","twosuperior","registered","minus","eth","multiply","threesuperior","copyright","Aacute","Acircumflex","Adieresis","Agrave","Aring","Atilde","Ccedilla","Eacute","Ecircumflex","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Ntilde","Oacute","Ocircumflex","Odieresis","Ograve","Otilde","Scaron","Uacute","Ucircumflex","Udieresis","Ugrave","Yacute","Ydieresis","Zcaron","aacute","acircumflex","adieresis","agrave","aring","atilde","ccedilla","eacute","ecircumflex","edieresis","egrave","iacute","icircumflex","idieresis","igrave","ntilde","oacute","ocircumflex","odieresis","ograve","otilde","scaron","uacute","ucircumflex","udieresis","ugrave","yacute","ydieresis","zcaron"];t.ExpertCharset=[".notdef","space","exclamsmall","Hungarumlautsmall","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","questionsmall","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","fi","fl","ffi","ffl","parenleftinferior","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","exclamdownsmall","centoldstyle","Lslashsmall","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","Dotaccentsmall","Macronsmall","figuredash","hypheninferior","Ogoneksmall","Ringsmall","Cedillasmall","onequarter","onehalf","threequarters","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall"];t.ExpertSubsetCharset=[".notdef","space","dollaroldstyle","dollarsuperior","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","asuperior","bsuperior","centsuperior","dsuperior","esuperior","isuperior","lsuperior","msuperior","nsuperior","osuperior","rsuperior","ssuperior","tsuperior","ff","fi","fl","ffi","ffl","parenleftinferior","parenrightinferior","hyphensuperior","colonmonetary","onefitted","rupiah","centoldstyle","figuredash","hypheninferior","onequarter","onehalf","threequarters","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior"]},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ZapfDingbatsEncoding=t.WinAnsiEncoding=t.SymbolSetEncoding=t.StandardEncoding=t.MacRomanEncoding=t.ExpertEncoding=void 0,t.getEncoding=function(e){switch(e){case"WinAnsiEncoding":return s;case"StandardEncoding":return i;case"MacRomanEncoding":return r;case"SymbolSetEncoding":return o;case"ZapfDingbatsEncoding":return c;case"ExpertEncoding":return a;case"MacExpertEncoding":return n;default:return null}};const a=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclamsmall","Hungarumlautsmall","","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","commasuperior","threequartersemdash","periodsuperior","questionsmall","","asuperior","bsuperior","centsuperior","dsuperior","esuperior","","","","isuperior","","","lsuperior","msuperior","nsuperior","osuperior","","","rsuperior","ssuperior","tsuperior","","ff","fi","fl","ffi","ffl","parenleftinferior","","parenrightinferior","Circumflexsmall","hyphensuperior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","exclamdownsmall","centoldstyle","Lslashsmall","","","Scaronsmall","Zcaronsmall","Dieresissmall","Brevesmall","Caronsmall","","Dotaccentsmall","","","Macronsmall","","","figuredash","hypheninferior","","","Ogoneksmall","Ringsmall","Cedillasmall","","","","onequarter","onehalf","threequarters","questiondownsmall","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","","","zerosuperior","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","eightsuperior","ninesuperior","zeroinferior","oneinferior","twoinferior","threeinferior","fourinferior","fiveinferior","sixinferior","seveninferior","eightinferior","nineinferior","centinferior","dollarinferior","periodinferior","commainferior","Agravesmall","Aacutesmall","Acircumflexsmall","Atildesmall","Adieresissmall","Aringsmall","AEsmall","Ccedillasmall","Egravesmall","Eacutesmall","Ecircumflexsmall","Edieresissmall","Igravesmall","Iacutesmall","Icircumflexsmall","Idieresissmall","Ethsmall","Ntildesmall","Ogravesmall","Oacutesmall","Ocircumflexsmall","Otildesmall","Odieresissmall","OEsmall","Oslashsmall","Ugravesmall","Uacutesmall","Ucircumflexsmall","Udieresissmall","Yacutesmall","Thornsmall","Ydieresissmall"];t.ExpertEncoding=a;const n=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclamsmall","Hungarumlautsmall","centoldstyle","dollaroldstyle","dollarsuperior","ampersandsmall","Acutesmall","parenleftsuperior","parenrightsuperior","twodotenleader","onedotenleader","comma","hyphen","period","fraction","zerooldstyle","oneoldstyle","twooldstyle","threeoldstyle","fouroldstyle","fiveoldstyle","sixoldstyle","sevenoldstyle","eightoldstyle","nineoldstyle","colon","semicolon","","threequartersemdash","","questionsmall","","","","","Ethsmall","","","onequarter","onehalf","threequarters","oneeighth","threeeighths","fiveeighths","seveneighths","onethird","twothirds","","","","","","","ff","fi","fl","ffi","ffl","parenleftinferior","","parenrightinferior","Circumflexsmall","hypheninferior","Gravesmall","Asmall","Bsmall","Csmall","Dsmall","Esmall","Fsmall","Gsmall","Hsmall","Ismall","Jsmall","Ksmall","Lsmall","Msmall","Nsmall","Osmall","Psmall","Qsmall","Rsmall","Ssmall","Tsmall","Usmall","Vsmall","Wsmall","Xsmall","Ysmall","Zsmall","colonmonetary","onefitted","rupiah","Tildesmall","","","asuperior","centsuperior","","","","","Aacutesmall","Agravesmall","Acircumflexsmall","Adieresissmall","Atildesmall","Aringsmall","Ccedillasmall","Eacutesmall","Egravesmall","Ecircumflexsmall","Edieresissmall","Iacutesmall","Igravesmall","Icircumflexsmall","Idieresissmall","Ntildesmall","Oacutesmall","Ogravesmall","Ocircumflexsmall","Odieresissmall","Otildesmall","Uacutesmall","Ugravesmall","Ucircumflexsmall","Udieresissmall","","eightsuperior","fourinferior","threeinferior","sixinferior","eightinferior","seveninferior","Scaronsmall","","centinferior","twoinferior","","Dieresissmall","","Caronsmall","osuperior","fiveinferior","","commainferior","periodinferior","Yacutesmall","","dollarinferior","","","Thornsmall","","nineinferior","zeroinferior","Zcaronsmall","AEsmall","Oslashsmall","questiondownsmall","oneinferior","Lslashsmall","","","","","","","Cedillasmall","","","","","","OEsmall","figuredash","hyphensuperior","","","","","exclamdownsmall","","Ydieresissmall","","onesuperior","twosuperior","threesuperior","foursuperior","fivesuperior","sixsuperior","sevensuperior","ninesuperior","zerosuperior","","esuperior","rsuperior","tsuperior","","","isuperior","ssuperior","dsuperior","","","","","","lsuperior","Ogoneksmall","Brevesmall","Macronsmall","bsuperior","nsuperior","msuperior","commasuperior","periodsuperior","Dotaccentsmall","Ringsmall","","","",""],r=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","","Adieresis","Aring","Ccedilla","Eacute","Ntilde","Odieresis","Udieresis","aacute","agrave","acircumflex","adieresis","atilde","aring","ccedilla","eacute","egrave","ecircumflex","edieresis","iacute","igrave","icircumflex","idieresis","ntilde","oacute","ograve","ocircumflex","odieresis","otilde","uacute","ugrave","ucircumflex","udieresis","dagger","degree","cent","sterling","section","bullet","paragraph","germandbls","registered","copyright","trademark","acute","dieresis","notequal","AE","Oslash","infinity","plusminus","lessequal","greaterequal","yen","mu","partialdiff","summation","product","pi","integral","ordfeminine","ordmasculine","Omega","ae","oslash","questiondown","exclamdown","logicalnot","radical","florin","approxequal","Delta","guillemotleft","guillemotright","ellipsis","space","Agrave","Atilde","Otilde","OE","oe","endash","emdash","quotedblleft","quotedblright","quoteleft","quoteright","divide","lozenge","ydieresis","Ydieresis","fraction","currency","guilsinglleft","guilsinglright","fi","fl","daggerdbl","periodcentered","quotesinglbase","quotedblbase","perthousand","Acircumflex","Ecircumflex","Aacute","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Oacute","Ocircumflex","apple","Ograve","Uacute","Ucircumflex","Ugrave","dotlessi","circumflex","tilde","macron","breve","dotaccent","ring","cedilla","hungarumlaut","ogonek","caron"];t.MacRomanEncoding=r;const i=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quoteright","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","quoteleft","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","exclamdown","cent","sterling","fraction","yen","florin","section","currency","quotesingle","quotedblleft","guillemotleft","guilsinglleft","guilsinglright","fi","fl","","endash","dagger","daggerdbl","periodcentered","","paragraph","bullet","quotesinglbase","quotedblbase","quotedblright","guillemotright","ellipsis","perthousand","","questiondown","","grave","acute","circumflex","tilde","macron","breve","dotaccent","dieresis","","ring","cedilla","","hungarumlaut","ogonek","caron","emdash","","","","","","","","","","","","","","","","","AE","","ordfeminine","","","","","Lslash","Oslash","OE","ordmasculine","","","","","","ae","","","","dotlessi","","","lslash","oslash","oe","germandbls","","","",""];t.StandardEncoding=i;const s=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","bullet","Euro","bullet","quotesinglbase","florin","quotedblbase","ellipsis","dagger","daggerdbl","circumflex","perthousand","Scaron","guilsinglleft","OE","bullet","Zcaron","bullet","bullet","quoteleft","quoteright","quotedblleft","quotedblright","bullet","endash","emdash","tilde","trademark","scaron","guilsinglright","oe","bullet","zcaron","Ydieresis","space","exclamdown","cent","sterling","currency","yen","brokenbar","section","dieresis","copyright","ordfeminine","guillemotleft","logicalnot","hyphen","registered","macron","degree","plusminus","twosuperior","threesuperior","acute","mu","paragraph","periodcentered","cedilla","onesuperior","ordmasculine","guillemotright","onequarter","onehalf","threequarters","questiondown","Agrave","Aacute","Acircumflex","Atilde","Adieresis","Aring","AE","Ccedilla","Egrave","Eacute","Ecircumflex","Edieresis","Igrave","Iacute","Icircumflex","Idieresis","Eth","Ntilde","Ograve","Oacute","Ocircumflex","Otilde","Odieresis","multiply","Oslash","Ugrave","Uacute","Ucircumflex","Udieresis","Yacute","Thorn","germandbls","agrave","aacute","acircumflex","atilde","adieresis","aring","ae","ccedilla","egrave","eacute","ecircumflex","edieresis","igrave","iacute","icircumflex","idieresis","eth","ntilde","ograve","oacute","ocircumflex","otilde","odieresis","divide","oslash","ugrave","uacute","ucircumflex","udieresis","yacute","thorn","ydieresis"];t.WinAnsiEncoding=s;const o=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","exclam","universal","numbersign","existential","percent","ampersand","suchthat","parenleft","parenright","asteriskmath","plus","comma","minus","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","congruent","Alpha","Beta","Chi","Delta","Epsilon","Phi","Gamma","Eta","Iota","theta1","Kappa","Lambda","Mu","Nu","Omicron","Pi","Theta","Rho","Sigma","Tau","Upsilon","sigma1","Omega","Xi","Psi","Zeta","bracketleft","therefore","bracketright","perpendicular","underscore","radicalex","alpha","beta","chi","delta","epsilon","phi","gamma","eta","iota","phi1","kappa","lambda","mu","nu","omicron","pi","theta","rho","sigma","tau","upsilon","omega1","omega","xi","psi","zeta","braceleft","bar","braceright","similar","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","Euro","Upsilon1","minute","lessequal","fraction","infinity","florin","club","diamond","heart","spade","arrowboth","arrowleft","arrowup","arrowright","arrowdown","degree","plusminus","second","greaterequal","multiply","proportional","partialdiff","bullet","divide","notequal","equivalence","approxequal","ellipsis","arrowvertex","arrowhorizex","carriagereturn","aleph","Ifraktur","Rfraktur","weierstrass","circlemultiply","circleplus","emptyset","intersection","union","propersuperset","reflexsuperset","notsubset","propersubset","reflexsubset","element","notelement","angle","gradient","registerserif","copyrightserif","trademarkserif","product","radical","dotmath","logicalnot","logicaland","logicalor","arrowdblboth","arrowdblleft","arrowdblup","arrowdblright","arrowdbldown","lozenge","angleleft","registersans","copyrightsans","trademarksans","summation","parenlefttp","parenleftex","parenleftbt","bracketlefttp","bracketleftex","bracketleftbt","bracelefttp","braceleftmid","braceleftbt","braceex","","angleright","integral","integraltp","integralex","integralbt","parenrighttp","parenrightex","parenrightbt","bracketrighttp","bracketrightex","bracketrightbt","bracerighttp","bracerightmid","bracerightbt",""];t.SymbolSetEncoding=o;const c=["","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","space","a1","a2","a202","a3","a4","a5","a119","a118","a117","a11","a12","a13","a14","a15","a16","a105","a17","a18","a19","a20","a21","a22","a23","a24","a25","a26","a27","a28","a6","a7","a8","a9","a10","a29","a30","a31","a32","a33","a34","a35","a36","a37","a38","a39","a40","a41","a42","a43","a44","a45","a46","a47","a48","a49","a50","a51","a52","a53","a54","a55","a56","a57","a58","a59","a60","a61","a62","a63","a64","a65","a66","a67","a68","a69","a70","a71","a72","a73","a74","a203","a75","a204","a76","a77","a78","a79","a81","a82","a83","a84","a97","a98","a99","a100","","a89","a90","a93","a94","a91","a92","a205","a85","a206","a86","a87","a88","a95","a96","","","","","","","","","","","","","","","","","","","","a101","a102","a103","a104","a106","a107","a108","a112","a111","a110","a109","a120","a121","a122","a123","a124","a125","a126","a127","a128","a129","a130","a131","a132","a133","a134","a135","a136","a137","a138","a139","a140","a141","a142","a143","a144","a145","a146","a147","a148","a149","a150","a151","a152","a153","a154","a155","a156","a157","a158","a159","a160","a161","a163","a164","a196","a165","a192","a166","a167","a168","a169","a170","a171","a172","a173","a162","a174","a175","a176","a177","a178","a179","a193","a180","a199","a181","a200","a182","","a201","a183","a184","a197","a185","a194","a198","a186","a195","a187","a188","a189","a190","a191",""];t.ZapfDingbatsEncoding=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.SEAC_ANALYSIS_ENABLED=t.MacStandardGlyphOrdering=t.FontFlags=void 0,t.normalizeFontName=function(e){return e.replaceAll(/[,_]/g,"-").replaceAll(/\s/g,"")},t.recoverGlyphName=c,t.type1FontGlyphMapping=function(e,t,a){const i=Object.create(null);let s,l,h;const u=!!(e.flags&o.Symbolic);if(e.isInternalFont)for(h=t,l=0;l<h.length;l++)s=a.indexOf(h[l]),i[l]=s>=0?s:0;else if(e.baseEncodingName)for(h=(0,n.getEncoding)(e.baseEncodingName),l=0;l<h.length;l++)s=a.indexOf(h[l]),i[l]=s>=0?s:0;else if(u)for(l in t)i[l]=t[l];else for(h=n.StandardEncoding,l=0;l<h.length;l++)s=a.indexOf(h[l]),i[l]=s>=0?s:0;const d=e.differences;let f;if(d)for(l in d){const e=d[l];if(s=a.indexOf(e),-1===s){f||(f=(0,r.getGlyphsUnicode)());const t=c(e,f);t!==e&&(s=a.indexOf(t))}i[l]=s>=0?s:0}return i};var n=a(37),r=a(39),i=a(40),s=a(2);t.SEAC_ANALYSIS_ENABLED=!0;const o={FixedPitch:1,Serif:2,Symbolic:4,Script:8,Nonsymbolic:32,Italic:64,AllCap:65536,SmallCap:131072,ForceBold:262144};t.FontFlags=o;function c(e,t){if(void 0!==t[e])return e;const a=(0,i.getUnicodeForGlyph)(e,t);if(-1!==a)for(const e in t)if(t[e]===a)return e;return(0,s.info)("Unable to recover a standard glyph name for: "+e),e}t.MacStandardGlyphOrdering=[".notdef",".null","nonmarkingreturn","space","exclam","quotedbl","numbersign","dollar","percent","ampersand","quotesingle","parenleft","parenright","asterisk","plus","comma","hyphen","period","slash","zero","one","two","three","four","five","six","seven","eight","nine","colon","semicolon","less","equal","greater","question","at","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z","bracketleft","backslash","bracketright","asciicircum","underscore","grave","a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z","braceleft","bar","braceright","asciitilde","Adieresis","Aring","Ccedilla","Eacute","Ntilde","Odieresis","Udieresis","aacute","agrave","acircumflex","adieresis","atilde","aring","ccedilla","eacute","egrave","ecircumflex","edieresis","iacute","igrave","icircumflex","idieresis","ntilde","oacute","ograve","ocircumflex","odieresis","otilde","uacute","ugrave","ucircumflex","udieresis","dagger","degree","cent","sterling","section","bullet","paragraph","germandbls","registered","copyright","trademark","acute","dieresis","notequal","AE","Oslash","infinity","plusminus","lessequal","greaterequal","yen","mu","partialdiff","summation","product","pi","integral","ordfeminine","ordmasculine","Omega","ae","oslash","questiondown","exclamdown","logicalnot","radical","florin","approxequal","Delta","guillemotleft","guillemotright","ellipsis","nonbreakingspace","Agrave","Atilde","Otilde","OE","oe","endash","emdash","quotedblleft","quotedblright","quoteleft","quoteright","divide","lozenge","ydieresis","Ydieresis","fraction","currency","guilsinglleft","guilsinglright","fi","fl","daggerdbl","periodcentered","quotesinglbase","quotedblbase","perthousand","Acircumflex","Ecircumflex","Aacute","Edieresis","Egrave","Iacute","Icircumflex","Idieresis","Igrave","Oacute","Ocircumflex","apple","Ograve","Uacute","Ucircumflex","Ugrave","dotlessi","circumflex","tilde","macron","breve","dotaccent","ring","cedilla","hungarumlaut","ogonek","caron","Lslash","lslash","Scaron","scaron","Zcaron","zcaron","brokenbar","Eth","eth","Yacute","yacute","Thorn","thorn","minus","multiply","onesuperior","twosuperior","threesuperior","onehalf","onequarter","threequarters","franc","Gbreve","gbreve","Idotaccent","Scedilla","scedilla","Cacute","cacute","Ccaron","ccaron","dcroat"]},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getGlyphsUnicode=t.getDingbatsGlyphsUnicode=void 0;var n=a(3);const r=(0,n.getLookupTableFactory)((function(e){e.A=65,e.AE=198,e.AEacute=508,e.AEmacron=482,e.AEsmall=63462,e.Aacute=193,e.Aacutesmall=63457,e.Abreve=258,e.Abreveacute=7854,e.Abrevecyrillic=1232,e.Abrevedotbelow=7862,e.Abrevegrave=7856,e.Abrevehookabove=7858,e.Abrevetilde=7860,e.Acaron=461,e.Acircle=9398,e.Acircumflex=194,e.Acircumflexacute=7844,e.Acircumflexdotbelow=7852,e.Acircumflexgrave=7846,e.Acircumflexhookabove=7848,e.Acircumflexsmall=63458,e.Acircumflextilde=7850,e.Acute=63177,e.Acutesmall=63412,e.Acyrillic=1040,e.Adblgrave=512,e.Adieresis=196,e.Adieresiscyrillic=1234,e.Adieresismacron=478,e.Adieresissmall=63460,e.Adotbelow=7840,e.Adotmacron=480,e.Agrave=192,e.Agravesmall=63456,e.Ahookabove=7842,e.Aiecyrillic=1236,e.Ainvertedbreve=514,e.Alpha=913,e.Alphatonos=902,e.Amacron=256,e.Amonospace=65313,e.Aogonek=260,e.Aring=197,e.Aringacute=506,e.Aringbelow=7680,e.Aringsmall=63461,e.Asmall=63329,e.Atilde=195,e.Atildesmall=63459,e.Aybarmenian=1329,e.B=66,e.Bcircle=9399,e.Bdotaccent=7682,e.Bdotbelow=7684,e.Becyrillic=1041,e.Benarmenian=1330,e.Beta=914,e.Bhook=385,e.Blinebelow=7686,e.Bmonospace=65314,e.Brevesmall=63220,e.Bsmall=63330,e.Btopbar=386,e.C=67,e.Caarmenian=1342,e.Cacute=262,e.Caron=63178,e.Caronsmall=63221,e.Ccaron=268,e.Ccedilla=199,e.Ccedillaacute=7688,e.Ccedillasmall=63463,e.Ccircle=9400,e.Ccircumflex=264,e.Cdot=266,e.Cdotaccent=266,e.Cedillasmall=63416,e.Chaarmenian=1353,e.Cheabkhasiancyrillic=1212,e.Checyrillic=1063,e.Chedescenderabkhasiancyrillic=1214,e.Chedescendercyrillic=1206,e.Chedieresiscyrillic=1268,e.Cheharmenian=1347,e.Chekhakassiancyrillic=1227,e.Cheverticalstrokecyrillic=1208,e.Chi=935,e.Chook=391,e.Circumflexsmall=63222,e.Cmonospace=65315,e.Coarmenian=1361,e.Csmall=63331,e.D=68,e.DZ=497,e.DZcaron=452,e.Daarmenian=1332,e.Dafrican=393,e.Dcaron=270,e.Dcedilla=7696,e.Dcircle=9401,e.Dcircumflexbelow=7698,e.Dcroat=272,e.Ddotaccent=7690,e.Ddotbelow=7692,e.Decyrillic=1044,e.Deicoptic=1006,e.Delta=8710,e.Deltagreek=916,e.Dhook=394,e.Dieresis=63179,e.DieresisAcute=63180,e.DieresisGrave=63181,e.Dieresissmall=63400,e.Digammagreek=988,e.Djecyrillic=1026,e.Dlinebelow=7694,e.Dmonospace=65316,e.Dotaccentsmall=63223,e.Dslash=272,e.Dsmall=63332,e.Dtopbar=395,e.Dz=498,e.Dzcaron=453,e.Dzeabkhasiancyrillic=1248,e.Dzecyrillic=1029,e.Dzhecyrillic=1039,e.E=69,e.Eacute=201,e.Eacutesmall=63465,e.Ebreve=276,e.Ecaron=282,e.Ecedillabreve=7708,e.Echarmenian=1333,e.Ecircle=9402,e.Ecircumflex=202,e.Ecircumflexacute=7870,e.Ecircumflexbelow=7704,e.Ecircumflexdotbelow=7878,e.Ecircumflexgrave=7872,e.Ecircumflexhookabove=7874,e.Ecircumflexsmall=63466,e.Ecircumflextilde=7876,e.Ecyrillic=1028,e.Edblgrave=516,e.Edieresis=203,e.Edieresissmall=63467,e.Edot=278,e.Edotaccent=278,e.Edotbelow=7864,e.Efcyrillic=1060,e.Egrave=200,e.Egravesmall=63464,e.Eharmenian=1335,e.Ehookabove=7866,e.Eightroman=8551,e.Einvertedbreve=518,e.Eiotifiedcyrillic=1124,e.Elcyrillic=1051,e.Elevenroman=8554,e.Emacron=274,e.Emacronacute=7702,e.Emacrongrave=7700,e.Emcyrillic=1052,e.Emonospace=65317,e.Encyrillic=1053,e.Endescendercyrillic=1186,e.Eng=330,e.Enghecyrillic=1188,e.Enhookcyrillic=1223,e.Eogonek=280,e.Eopen=400,e.Epsilon=917,e.Epsilontonos=904,e.Ercyrillic=1056,e.Ereversed=398,e.Ereversedcyrillic=1069,e.Escyrillic=1057,e.Esdescendercyrillic=1194,e.Esh=425,e.Esmall=63333,e.Eta=919,e.Etarmenian=1336,e.Etatonos=905,e.Eth=208,e.Ethsmall=63472,e.Etilde=7868,e.Etildebelow=7706,e.Euro=8364,e.Ezh=439,e.Ezhcaron=494,e.Ezhreversed=440,e.F=70,e.Fcircle=9403,e.Fdotaccent=7710,e.Feharmenian=1366,e.Feicoptic=996,e.Fhook=401,e.Fitacyrillic=1138,e.Fiveroman=8548,e.Fmonospace=65318,e.Fourroman=8547,e.Fsmall=63334,e.G=71,e.GBsquare=13191,e.Gacute=500,e.Gamma=915,e.Gammaafrican=404,e.Gangiacoptic=1002,e.Gbreve=286,e.Gcaron=486,e.Gcedilla=290,e.Gcircle=9404,e.Gcircumflex=284,e.Gcommaaccent=290,e.Gdot=288,e.Gdotaccent=288,e.Gecyrillic=1043,e.Ghadarmenian=1346,e.Ghemiddlehookcyrillic=1172,e.Ghestrokecyrillic=1170,e.Gheupturncyrillic=1168,e.Ghook=403,e.Gimarmenian=1331,e.Gjecyrillic=1027,e.Gmacron=7712,e.Gmonospace=65319,e.Grave=63182,e.Gravesmall=63328,e.Gsmall=63335,e.Gsmallhook=667,e.Gstroke=484,e.H=72,e.H18533=9679,e.H18543=9642,e.H18551=9643,e.H22073=9633,e.HPsquare=13259,e.Haabkhasiancyrillic=1192,e.Hadescendercyrillic=1202,e.Hardsigncyrillic=1066,e.Hbar=294,e.Hbrevebelow=7722,e.Hcedilla=7720,e.Hcircle=9405,e.Hcircumflex=292,e.Hdieresis=7718,e.Hdotaccent=7714,e.Hdotbelow=7716,e.Hmonospace=65320,e.Hoarmenian=1344,e.Horicoptic=1e3,e.Hsmall=63336,e.Hungarumlaut=63183,e.Hungarumlautsmall=63224,e.Hzsquare=13200,e.I=73,e.IAcyrillic=1071,e.IJ=306,e.IUcyrillic=1070,e.Iacute=205,e.Iacutesmall=63469,e.Ibreve=300,e.Icaron=463,e.Icircle=9406,e.Icircumflex=206,e.Icircumflexsmall=63470,e.Icyrillic=1030,e.Idblgrave=520,e.Idieresis=207,e.Idieresisacute=7726,e.Idieresiscyrillic=1252,e.Idieresissmall=63471,e.Idot=304,e.Idotaccent=304,e.Idotbelow=7882,e.Iebrevecyrillic=1238,e.Iecyrillic=1045,e.Ifraktur=8465,e.Igrave=204,e.Igravesmall=63468,e.Ihookabove=7880,e.Iicyrillic=1048,e.Iinvertedbreve=522,e.Iishortcyrillic=1049,e.Imacron=298,e.Imacroncyrillic=1250,e.Imonospace=65321,e.Iniarmenian=1339,e.Iocyrillic=1025,e.Iogonek=302,e.Iota=921,e.Iotaafrican=406,e.Iotadieresis=938,e.Iotatonos=906,e.Ismall=63337,e.Istroke=407,e.Itilde=296,e.Itildebelow=7724,e.Izhitsacyrillic=1140,e.Izhitsadblgravecyrillic=1142,e.J=74,e.Jaarmenian=1345,e.Jcircle=9407,e.Jcircumflex=308,e.Jecyrillic=1032,e.Jheharmenian=1355,e.Jmonospace=65322,e.Jsmall=63338,e.K=75,e.KBsquare=13189,e.KKsquare=13261,e.Kabashkircyrillic=1184,e.Kacute=7728,e.Kacyrillic=1050,e.Kadescendercyrillic=1178,e.Kahookcyrillic=1219,e.Kappa=922,e.Kastrokecyrillic=1182,e.Kaverticalstrokecyrillic=1180,e.Kcaron=488,e.Kcedilla=310,e.Kcircle=9408,e.Kcommaaccent=310,e.Kdotbelow=7730,e.Keharmenian=1364,e.Kenarmenian=1343,e.Khacyrillic=1061,e.Kheicoptic=998,e.Khook=408,e.Kjecyrillic=1036,e.Klinebelow=7732,e.Kmonospace=65323,e.Koppacyrillic=1152,e.Koppagreek=990,e.Ksicyrillic=1134,e.Ksmall=63339,e.L=76,e.LJ=455,e.LL=63167,e.Lacute=313,e.Lambda=923,e.Lcaron=317,e.Lcedilla=315,e.Lcircle=9409,e.Lcircumflexbelow=7740,e.Lcommaaccent=315,e.Ldot=319,e.Ldotaccent=319,e.Ldotbelow=7734,e.Ldotbelowmacron=7736,e.Liwnarmenian=1340,e.Lj=456,e.Ljecyrillic=1033,e.Llinebelow=7738,e.Lmonospace=65324,e.Lslash=321,e.Lslashsmall=63225,e.Lsmall=63340,e.M=77,e.MBsquare=13190,e.Macron=63184,e.Macronsmall=63407,e.Macute=7742,e.Mcircle=9410,e.Mdotaccent=7744,e.Mdotbelow=7746,e.Menarmenian=1348,e.Mmonospace=65325,e.Msmall=63341,e.Mturned=412,e.Mu=924,e.N=78,e.NJ=458,e.Nacute=323,e.Ncaron=327,e.Ncedilla=325,e.Ncircle=9411,e.Ncircumflexbelow=7754,e.Ncommaaccent=325,e.Ndotaccent=7748,e.Ndotbelow=7750,e.Nhookleft=413,e.Nineroman=8552,e.Nj=459,e.Njecyrillic=1034,e.Nlinebelow=7752,e.Nmonospace=65326,e.Nowarmenian=1350,e.Nsmall=63342,e.Ntilde=209,e.Ntildesmall=63473,e.Nu=925,e.O=79,e.OE=338,e.OEsmall=63226,e.Oacute=211,e.Oacutesmall=63475,e.Obarredcyrillic=1256,e.Obarreddieresiscyrillic=1258,e.Obreve=334,e.Ocaron=465,e.Ocenteredtilde=415,e.Ocircle=9412,e.Ocircumflex=212,e.Ocircumflexacute=7888,e.Ocircumflexdotbelow=7896,e.Ocircumflexgrave=7890,e.Ocircumflexhookabove=7892,e.Ocircumflexsmall=63476,e.Ocircumflextilde=7894,e.Ocyrillic=1054,e.Odblacute=336,e.Odblgrave=524,e.Odieresis=214,e.Odieresiscyrillic=1254,e.Odieresissmall=63478,e.Odotbelow=7884,e.Ogoneksmall=63227,e.Ograve=210,e.Ogravesmall=63474,e.Oharmenian=1365,e.Ohm=8486,e.Ohookabove=7886,e.Ohorn=416,e.Ohornacute=7898,e.Ohorndotbelow=7906,e.Ohorngrave=7900,e.Ohornhookabove=7902,e.Ohorntilde=7904,e.Ohungarumlaut=336,e.Oi=418,e.Oinvertedbreve=526,e.Omacron=332,e.Omacronacute=7762,e.Omacrongrave=7760,e.Omega=8486,e.Omegacyrillic=1120,e.Omegagreek=937,e.Omegaroundcyrillic=1146,e.Omegatitlocyrillic=1148,e.Omegatonos=911,e.Omicron=927,e.Omicrontonos=908,e.Omonospace=65327,e.Oneroman=8544,e.Oogonek=490,e.Oogonekmacron=492,e.Oopen=390,e.Oslash=216,e.Oslashacute=510,e.Oslashsmall=63480,e.Osmall=63343,e.Ostrokeacute=510,e.Otcyrillic=1150,e.Otilde=213,e.Otildeacute=7756,e.Otildedieresis=7758,e.Otildesmall=63477,e.P=80,e.Pacute=7764,e.Pcircle=9413,e.Pdotaccent=7766,e.Pecyrillic=1055,e.Peharmenian=1354,e.Pemiddlehookcyrillic=1190,e.Phi=934,e.Phook=420,e.Pi=928,e.Piwrarmenian=1363,e.Pmonospace=65328,e.Psi=936,e.Psicyrillic=1136,e.Psmall=63344,e.Q=81,e.Qcircle=9414,e.Qmonospace=65329,e.Qsmall=63345,e.R=82,e.Raarmenian=1356,e.Racute=340,e.Rcaron=344,e.Rcedilla=342,e.Rcircle=9415,e.Rcommaaccent=342,e.Rdblgrave=528,e.Rdotaccent=7768,e.Rdotbelow=7770,e.Rdotbelowmacron=7772,e.Reharmenian=1360,e.Rfraktur=8476,e.Rho=929,e.Ringsmall=63228,e.Rinvertedbreve=530,e.Rlinebelow=7774,e.Rmonospace=65330,e.Rsmall=63346,e.Rsmallinverted=641,e.Rsmallinvertedsuperior=694,e.S=83,e.SF010000=9484,e.SF020000=9492,e.SF030000=9488,e.SF040000=9496,e.SF050000=9532,e.SF060000=9516,e.SF070000=9524,e.SF080000=9500,e.SF090000=9508,e.SF100000=9472,e.SF110000=9474,e.SF190000=9569,e.SF200000=9570,e.SF210000=9558,e.SF220000=9557,e.SF230000=9571,e.SF240000=9553,e.SF250000=9559,e.SF260000=9565,e.SF270000=9564,e.SF280000=9563,e.SF360000=9566,e.SF370000=9567,e.SF380000=9562,e.SF390000=9556,e.SF400000=9577,e.SF410000=9574,e.SF420000=9568,e.SF430000=9552,e.SF440000=9580,e.SF450000=9575,e.SF460000=9576,e.SF470000=9572,e.SF480000=9573,e.SF490000=9561,e.SF500000=9560,e.SF510000=9554,e.SF520000=9555,e.SF530000=9579,e.SF540000=9578,e.Sacute=346,e.Sacutedotaccent=7780,e.Sampigreek=992,e.Scaron=352,e.Scarondotaccent=7782,e.Scaronsmall=63229,e.Scedilla=350,e.Schwa=399,e.Schwacyrillic=1240,e.Schwadieresiscyrillic=1242,e.Scircle=9416,e.Scircumflex=348,e.Scommaaccent=536,e.Sdotaccent=7776,e.Sdotbelow=7778,e.Sdotbelowdotaccent=7784,e.Seharmenian=1357,e.Sevenroman=8550,e.Shaarmenian=1351,e.Shacyrillic=1064,e.Shchacyrillic=1065,e.Sheicoptic=994,e.Shhacyrillic=1210,e.Shimacoptic=1004,e.Sigma=931,e.Sixroman=8549,e.Smonospace=65331,e.Softsigncyrillic=1068,e.Ssmall=63347,e.Stigmagreek=986,e.T=84,e.Tau=932,e.Tbar=358,e.Tcaron=356,e.Tcedilla=354,e.Tcircle=9417,e.Tcircumflexbelow=7792,e.Tcommaaccent=354,e.Tdotaccent=7786,e.Tdotbelow=7788,e.Tecyrillic=1058,e.Tedescendercyrillic=1196,e.Tenroman=8553,e.Tetsecyrillic=1204,e.Theta=920,e.Thook=428,e.Thorn=222,e.Thornsmall=63486,e.Threeroman=8546,e.Tildesmall=63230,e.Tiwnarmenian=1359,e.Tlinebelow=7790,e.Tmonospace=65332,e.Toarmenian=1337,e.Tonefive=444,e.Tonesix=388,e.Tonetwo=423,e.Tretroflexhook=430,e.Tsecyrillic=1062,e.Tshecyrillic=1035,e.Tsmall=63348,e.Twelveroman=8555,e.Tworoman=8545,e.U=85,e.Uacute=218,e.Uacutesmall=63482,e.Ubreve=364,e.Ucaron=467,e.Ucircle=9418,e.Ucircumflex=219,e.Ucircumflexbelow=7798,e.Ucircumflexsmall=63483,e.Ucyrillic=1059,e.Udblacute=368,e.Udblgrave=532,e.Udieresis=220,e.Udieresisacute=471,e.Udieresisbelow=7794,e.Udieresiscaron=473,e.Udieresiscyrillic=1264,e.Udieresisgrave=475,e.Udieresismacron=469,e.Udieresissmall=63484,e.Udotbelow=7908,e.Ugrave=217,e.Ugravesmall=63481,e.Uhookabove=7910,e.Uhorn=431,e.Uhornacute=7912,e.Uhorndotbelow=7920,e.Uhorngrave=7914,e.Uhornhookabove=7916,e.Uhorntilde=7918,e.Uhungarumlaut=368,e.Uhungarumlautcyrillic=1266,e.Uinvertedbreve=534,e.Ukcyrillic=1144,e.Umacron=362,e.Umacroncyrillic=1262,e.Umacrondieresis=7802,e.Umonospace=65333,e.Uogonek=370,e.Upsilon=933,e.Upsilon1=978,e.Upsilonacutehooksymbolgreek=979,e.Upsilonafrican=433,e.Upsilondieresis=939,e.Upsilondieresishooksymbolgreek=980,e.Upsilonhooksymbol=978,e.Upsilontonos=910,e.Uring=366,e.Ushortcyrillic=1038,e.Usmall=63349,e.Ustraightcyrillic=1198,e.Ustraightstrokecyrillic=1200,e.Utilde=360,e.Utildeacute=7800,e.Utildebelow=7796,e.V=86,e.Vcircle=9419,e.Vdotbelow=7806,e.Vecyrillic=1042,e.Vewarmenian=1358,e.Vhook=434,e.Vmonospace=65334,e.Voarmenian=1352,e.Vsmall=63350,e.Vtilde=7804,e.W=87,e.Wacute=7810,e.Wcircle=9420,e.Wcircumflex=372,e.Wdieresis=7812,e.Wdotaccent=7814,e.Wdotbelow=7816,e.Wgrave=7808,e.Wmonospace=65335,e.Wsmall=63351,e.X=88,e.Xcircle=9421,e.Xdieresis=7820,e.Xdotaccent=7818,e.Xeharmenian=1341,e.Xi=926,e.Xmonospace=65336,e.Xsmall=63352,e.Y=89,e.Yacute=221,e.Yacutesmall=63485,e.Yatcyrillic=1122,e.Ycircle=9422,e.Ycircumflex=374,e.Ydieresis=376,e.Ydieresissmall=63487,e.Ydotaccent=7822,e.Ydotbelow=7924,e.Yericyrillic=1067,e.Yerudieresiscyrillic=1272,e.Ygrave=7922,e.Yhook=435,e.Yhookabove=7926,e.Yiarmenian=1349,e.Yicyrillic=1031,e.Yiwnarmenian=1362,e.Ymonospace=65337,e.Ysmall=63353,e.Ytilde=7928,e.Yusbigcyrillic=1130,e.Yusbigiotifiedcyrillic=1132,e.Yuslittlecyrillic=1126,e.Yuslittleiotifiedcyrillic=1128,e.Z=90,e.Zaarmenian=1334,e.Zacute=377,e.Zcaron=381,e.Zcaronsmall=63231,e.Zcircle=9423,e.Zcircumflex=7824,e.Zdot=379,e.Zdotaccent=379,e.Zdotbelow=7826,e.Zecyrillic=1047,e.Zedescendercyrillic=1176,e.Zedieresiscyrillic=1246,e.Zeta=918,e.Zhearmenian=1338,e.Zhebrevecyrillic=1217,e.Zhecyrillic=1046,e.Zhedescendercyrillic=1174,e.Zhedieresiscyrillic=1244,e.Zlinebelow=7828,e.Zmonospace=65338,e.Zsmall=63354,e.Zstroke=437,e.a=97,e.aabengali=2438,e.aacute=225,e.aadeva=2310,e.aagujarati=2694,e.aagurmukhi=2566,e.aamatragurmukhi=2622,e.aarusquare=13059,e.aavowelsignbengali=2494,e.aavowelsigndeva=2366,e.aavowelsigngujarati=2750,e.abbreviationmarkarmenian=1375,e.abbreviationsigndeva=2416,e.abengali=2437,e.abopomofo=12570,e.abreve=259,e.abreveacute=7855,e.abrevecyrillic=1233,e.abrevedotbelow=7863,e.abrevegrave=7857,e.abrevehookabove=7859,e.abrevetilde=7861,e.acaron=462,e.acircle=9424,e.acircumflex=226,e.acircumflexacute=7845,e.acircumflexdotbelow=7853,e.acircumflexgrave=7847,e.acircumflexhookabove=7849,e.acircumflextilde=7851,e.acute=180,e.acutebelowcmb=791,e.acutecmb=769,e.acutecomb=769,e.acutedeva=2388,e.acutelowmod=719,e.acutetonecmb=833,e.acyrillic=1072,e.adblgrave=513,e.addakgurmukhi=2673,e.adeva=2309,e.adieresis=228,e.adieresiscyrillic=1235,e.adieresismacron=479,e.adotbelow=7841,e.adotmacron=481,e.ae=230,e.aeacute=509,e.aekorean=12624,e.aemacron=483,e.afii00208=8213,e.afii08941=8356,e.afii10017=1040,e.afii10018=1041,e.afii10019=1042,e.afii10020=1043,e.afii10021=1044,e.afii10022=1045,e.afii10023=1025,e.afii10024=1046,e.afii10025=1047,e.afii10026=1048,e.afii10027=1049,e.afii10028=1050,e.afii10029=1051,e.afii10030=1052;e.afii10031=1053,e.afii10032=1054,e.afii10033=1055,e.afii10034=1056,e.afii10035=1057,e.afii10036=1058,e.afii10037=1059,e.afii10038=1060,e.afii10039=1061,e.afii10040=1062,e.afii10041=1063,e.afii10042=1064,e.afii10043=1065,e.afii10044=1066,e.afii10045=1067,e.afii10046=1068,e.afii10047=1069,e.afii10048=1070,e.afii10049=1071,e.afii10050=1168,e.afii10051=1026,e.afii10052=1027,e.afii10053=1028,e.afii10054=1029,e.afii10055=1030,e.afii10056=1031,e.afii10057=1032,e.afii10058=1033,e.afii10059=1034,e.afii10060=1035,e.afii10061=1036,e.afii10062=1038,e.afii10063=63172,e.afii10064=63173,e.afii10065=1072,e.afii10066=1073,e.afii10067=1074,e.afii10068=1075,e.afii10069=1076,e.afii10070=1077,e.afii10071=1105,e.afii10072=1078,e.afii10073=1079,e.afii10074=1080,e.afii10075=1081,e.afii10076=1082,e.afii10077=1083,e.afii10078=1084,e.afii10079=1085,e.afii10080=1086,e.afii10081=1087,e.afii10082=1088,e.afii10083=1089,e.afii10084=1090,e.afii10085=1091,e.afii10086=1092,e.afii10087=1093,e.afii10088=1094,e.afii10089=1095,e.afii10090=1096,e.afii10091=1097,e.afii10092=1098,e.afii10093=1099,e.afii10094=1100,e.afii10095=1101,e.afii10096=1102,e.afii10097=1103,e.afii10098=1169,e.afii10099=1106,e.afii10100=1107,e.afii10101=1108,e.afii10102=1109,e.afii10103=1110,e.afii10104=1111,e.afii10105=1112,e.afii10106=1113,e.afii10107=1114,e.afii10108=1115,e.afii10109=1116,e.afii10110=1118,e.afii10145=1039,e.afii10146=1122,e.afii10147=1138,e.afii10148=1140,e.afii10192=63174,e.afii10193=1119,e.afii10194=1123,e.afii10195=1139,e.afii10196=1141,e.afii10831=63175,e.afii10832=63176,e.afii10846=1241,e.afii299=8206,e.afii300=8207,e.afii301=8205,e.afii57381=1642,e.afii57388=1548,e.afii57392=1632,e.afii57393=1633,e.afii57394=1634,e.afii57395=1635,e.afii57396=1636,e.afii57397=1637,e.afii57398=1638,e.afii57399=1639,e.afii57400=1640,e.afii57401=1641,e.afii57403=1563,e.afii57407=1567,e.afii57409=1569,e.afii57410=1570,e.afii57411=1571,e.afii57412=1572,e.afii57413=1573,e.afii57414=1574,e.afii57415=1575,e.afii57416=1576,e.afii57417=1577,e.afii57418=1578,e.afii57419=1579,e.afii57420=1580,e.afii57421=1581,e.afii57422=1582,e.afii57423=1583,e.afii57424=1584,e.afii57425=1585,e.afii57426=1586,e.afii57427=1587,e.afii57428=1588,e.afii57429=1589,e.afii57430=1590,e.afii57431=1591,e.afii57432=1592,e.afii57433=1593,e.afii57434=1594,e.afii57440=1600,e.afii57441=1601,e.afii57442=1602,e.afii57443=1603,e.afii57444=1604,e.afii57445=1605,e.afii57446=1606,e.afii57448=1608,e.afii57449=1609,e.afii57450=1610,e.afii57451=1611,e.afii57452=1612,e.afii57453=1613,e.afii57454=1614,e.afii57455=1615,e.afii57456=1616,e.afii57457=1617,e.afii57458=1618,e.afii57470=1607,e.afii57505=1700,e.afii57506=1662,e.afii57507=1670,e.afii57508=1688,e.afii57509=1711,e.afii57511=1657,e.afii57512=1672,e.afii57513=1681,e.afii57514=1722,e.afii57519=1746,e.afii57534=1749,e.afii57636=8362,e.afii57645=1470,e.afii57658=1475,e.afii57664=1488,e.afii57665=1489,e.afii57666=1490,e.afii57667=1491,e.afii57668=1492,e.afii57669=1493,e.afii57670=1494,e.afii57671=1495,e.afii57672=1496,e.afii57673=1497,e.afii57674=1498,e.afii57675=1499,e.afii57676=1500,e.afii57677=1501,e.afii57678=1502,e.afii57679=1503,e.afii57680=1504,e.afii57681=1505,e.afii57682=1506,e.afii57683=1507,e.afii57684=1508,e.afii57685=1509,e.afii57686=1510,e.afii57687=1511,e.afii57688=1512,e.afii57689=1513,e.afii57690=1514,e.afii57694=64298,e.afii57695=64299,e.afii57700=64331,e.afii57705=64287,e.afii57716=1520,e.afii57717=1521,e.afii57718=1522,e.afii57723=64309,e.afii57793=1460,e.afii57794=1461,e.afii57795=1462,e.afii57796=1467,e.afii57797=1464,e.afii57798=1463,e.afii57799=1456,e.afii57800=1458,e.afii57801=1457,e.afii57802=1459,e.afii57803=1474,e.afii57804=1473,e.afii57806=1465,e.afii57807=1468,e.afii57839=1469,e.afii57841=1471,e.afii57842=1472,e.afii57929=700,e.afii61248=8453,e.afii61289=8467,e.afii61352=8470,e.afii61573=8236,e.afii61574=8237,e.afii61575=8238,e.afii61664=8204,e.afii63167=1645,e.afii64937=701,e.agrave=224,e.agujarati=2693,e.agurmukhi=2565,e.ahiragana=12354,e.ahookabove=7843,e.aibengali=2448,e.aibopomofo=12574,e.aideva=2320,e.aiecyrillic=1237,e.aigujarati=2704,e.aigurmukhi=2576,e.aimatragurmukhi=2632,e.ainarabic=1593,e.ainfinalarabic=65226,e.aininitialarabic=65227,e.ainmedialarabic=65228,e.ainvertedbreve=515,e.aivowelsignbengali=2504,e.aivowelsigndeva=2376,e.aivowelsigngujarati=2760,e.akatakana=12450,e.akatakanahalfwidth=65393,e.akorean=12623,e.alef=1488,e.alefarabic=1575,e.alefdageshhebrew=64304,e.aleffinalarabic=65166,e.alefhamzaabovearabic=1571,e.alefhamzaabovefinalarabic=65156,e.alefhamzabelowarabic=1573,e.alefhamzabelowfinalarabic=65160,e.alefhebrew=1488,e.aleflamedhebrew=64335,e.alefmaddaabovearabic=1570,e.alefmaddaabovefinalarabic=65154,e.alefmaksuraarabic=1609,e.alefmaksurafinalarabic=65264,e.alefmaksurainitialarabic=65267,e.alefmaksuramedialarabic=65268,e.alefpatahhebrew=64302,e.alefqamatshebrew=64303,e.aleph=8501,e.allequal=8780,e.alpha=945,e.alphatonos=940,e.amacron=257,e.amonospace=65345,e.ampersand=38,e.ampersandmonospace=65286,e.ampersandsmall=63270,e.amsquare=13250,e.anbopomofo=12578,e.angbopomofo=12580,e.angbracketleft=12296,e.angbracketright=12297,e.angkhankhuthai=3674,e.angle=8736,e.anglebracketleft=12296,e.anglebracketleftvertical=65087,e.anglebracketright=12297,e.anglebracketrightvertical=65088,e.angleleft=9001,e.angleright=9002,e.angstrom=8491,e.anoteleia=903,e.anudattadeva=2386,e.anusvarabengali=2434,e.anusvaradeva=2306,e.anusvaragujarati=2690,e.aogonek=261,e.apaatosquare=13056,e.aparen=9372,e.apostrophearmenian=1370,e.apostrophemod=700,e.apple=63743,e.approaches=8784,e.approxequal=8776,e.approxequalorimage=8786,e.approximatelyequal=8773,e.araeaekorean=12686,e.araeakorean=12685,e.arc=8978,e.arighthalfring=7834,e.aring=229,e.aringacute=507,e.aringbelow=7681,e.arrowboth=8596,e.arrowdashdown=8675,e.arrowdashleft=8672,e.arrowdashright=8674,e.arrowdashup=8673,e.arrowdblboth=8660,e.arrowdbldown=8659,e.arrowdblleft=8656,e.arrowdblright=8658,e.arrowdblup=8657,e.arrowdown=8595,e.arrowdownleft=8601,e.arrowdownright=8600,e.arrowdownwhite=8681,e.arrowheaddownmod=709,e.arrowheadleftmod=706,e.arrowheadrightmod=707,e.arrowheadupmod=708,e.arrowhorizex=63719,e.arrowleft=8592,e.arrowleftdbl=8656,e.arrowleftdblstroke=8653,e.arrowleftoverright=8646,e.arrowleftwhite=8678,e.arrowright=8594,e.arrowrightdblstroke=8655,e.arrowrightheavy=10142,e.arrowrightoverleft=8644,e.arrowrightwhite=8680,e.arrowtableft=8676,e.arrowtabright=8677,e.arrowup=8593,e.arrowupdn=8597,e.arrowupdnbse=8616,e.arrowupdownbase=8616,e.arrowupleft=8598,e.arrowupleftofdown=8645,e.arrowupright=8599,e.arrowupwhite=8679,e.arrowvertex=63718,e.asciicircum=94,e.asciicircummonospace=65342,e.asciitilde=126,e.asciitildemonospace=65374,e.ascript=593,e.ascriptturned=594,e.asmallhiragana=12353,e.asmallkatakana=12449,e.asmallkatakanahalfwidth=65383,e.asterisk=42,e.asteriskaltonearabic=1645,e.asteriskarabic=1645,e.asteriskmath=8727,e.asteriskmonospace=65290,e.asterisksmall=65121,e.asterism=8258,e.asuperior=63209,e.asymptoticallyequal=8771,e.at=64,e.atilde=227,e.atmonospace=65312,e.atsmall=65131,e.aturned=592,e.aubengali=2452,e.aubopomofo=12576,e.audeva=2324,e.augujarati=2708,e.augurmukhi=2580,e.aulengthmarkbengali=2519,e.aumatragurmukhi=2636,e.auvowelsignbengali=2508,e.auvowelsigndeva=2380,e.auvowelsigngujarati=2764,e.avagrahadeva=2365,e.aybarmenian=1377,e.ayin=1506,e.ayinaltonehebrew=64288,e.ayinhebrew=1506,e.b=98,e.babengali=2476,e.backslash=92,e.backslashmonospace=65340,e.badeva=2348,e.bagujarati=2732,e.bagurmukhi=2604,e.bahiragana=12400,e.bahtthai=3647,e.bakatakana=12496,e.bar=124,e.barmonospace=65372,e.bbopomofo=12549,e.bcircle=9425,e.bdotaccent=7683,e.bdotbelow=7685,e.beamedsixteenthnotes=9836,e.because=8757,e.becyrillic=1073,e.beharabic=1576,e.behfinalarabic=65168,e.behinitialarabic=65169,e.behiragana=12409,e.behmedialarabic=65170,e.behmeeminitialarabic=64671,e.behmeemisolatedarabic=64520,e.behnoonfinalarabic=64621,e.bekatakana=12505,e.benarmenian=1378,e.bet=1489,e.beta=946,e.betasymbolgreek=976,e.betdagesh=64305,e.betdageshhebrew=64305,e.bethebrew=1489,e.betrafehebrew=64332,e.bhabengali=2477,e.bhadeva=2349,e.bhagujarati=2733,e.bhagurmukhi=2605,e.bhook=595,e.bihiragana=12403,e.bikatakana=12499,e.bilabialclick=664,e.bindigurmukhi=2562,e.birusquare=13105,e.blackcircle=9679,e.blackdiamond=9670,e.blackdownpointingtriangle=9660,e.blackleftpointingpointer=9668,e.blackleftpointingtriangle=9664,e.blacklenticularbracketleft=12304,e.blacklenticularbracketleftvertical=65083,e.blacklenticularbracketright=12305,e.blacklenticularbracketrightvertical=65084,e.blacklowerlefttriangle=9699,e.blacklowerrighttriangle=9698,e.blackrectangle=9644,e.blackrightpointingpointer=9658,e.blackrightpointingtriangle=9654,e.blacksmallsquare=9642,e.blacksmilingface=9787,e.blacksquare=9632,e.blackstar=9733,e.blackupperlefttriangle=9700,e.blackupperrighttriangle=9701,e.blackuppointingsmalltriangle=9652,e.blackuppointingtriangle=9650,e.blank=9251,e.blinebelow=7687,e.block=9608,e.bmonospace=65346,e.bobaimaithai=3610,e.bohiragana=12412,e.bokatakana=12508,e.bparen=9373,e.bqsquare=13251,e.braceex=63732,e.braceleft=123,e.braceleftbt=63731,e.braceleftmid=63730,e.braceleftmonospace=65371,e.braceleftsmall=65115,e.bracelefttp=63729,e.braceleftvertical=65079,e.braceright=125,e.bracerightbt=63742,e.bracerightmid=63741,e.bracerightmonospace=65373,e.bracerightsmall=65116,e.bracerighttp=63740,e.bracerightvertical=65080,e.bracketleft=91,e.bracketleftbt=63728,e.bracketleftex=63727,e.bracketleftmonospace=65339,e.bracketlefttp=63726,e.bracketright=93,e.bracketrightbt=63739,e.bracketrightex=63738,e.bracketrightmonospace=65341,e.bracketrighttp=63737,e.breve=728,e.brevebelowcmb=814,e.brevecmb=774,e.breveinvertedbelowcmb=815,e.breveinvertedcmb=785,e.breveinverteddoublecmb=865,e.bridgebelowcmb=810,e.bridgeinvertedbelowcmb=826,e.brokenbar=166,e.bstroke=384,e.bsuperior=63210,e.btopbar=387,e.buhiragana=12406,e.bukatakana=12502,e.bullet=8226,e.bulletinverse=9688,e.bulletoperator=8729,e.bullseye=9678,e.c=99,e.caarmenian=1390,e.cabengali=2458,e.cacute=263,e.cadeva=2330,e.cagujarati=2714,e.cagurmukhi=2586,e.calsquare=13192,e.candrabindubengali=2433,e.candrabinducmb=784,e.candrabindudeva=2305,e.candrabindugujarati=2689,e.capslock=8682,e.careof=8453,e.caron=711,e.caronbelowcmb=812,e.caroncmb=780,e.carriagereturn=8629,e.cbopomofo=12568,e.ccaron=269,e.ccedilla=231,e.ccedillaacute=7689,e.ccircle=9426,e.ccircumflex=265,e.ccurl=597,e.cdot=267,e.cdotaccent=267,e.cdsquare=13253,e.cedilla=184,e.cedillacmb=807,e.cent=162,e.centigrade=8451,e.centinferior=63199,e.centmonospace=65504,e.centoldstyle=63394,e.centsuperior=63200,e.chaarmenian=1401,e.chabengali=2459,e.chadeva=2331,e.chagujarati=2715,e.chagurmukhi=2587,e.chbopomofo=12564,e.cheabkhasiancyrillic=1213,e.checkmark=10003,e.checyrillic=1095,e.chedescenderabkhasiancyrillic=1215,e.chedescendercyrillic=1207,e.chedieresiscyrillic=1269,e.cheharmenian=1395,e.chekhakassiancyrillic=1228,e.cheverticalstrokecyrillic=1209,e.chi=967,e.chieuchacirclekorean=12919,e.chieuchaparenkorean=12823,e.chieuchcirclekorean=12905,e.chieuchkorean=12618,e.chieuchparenkorean=12809,e.chochangthai=3594,e.chochanthai=3592,e.chochingthai=3593,e.chochoethai=3596,e.chook=392,e.cieucacirclekorean=12918,e.cieucaparenkorean=12822,e.cieuccirclekorean=12904,e.cieuckorean=12616,e.cieucparenkorean=12808,e.cieucuparenkorean=12828,e.circle=9675,e.circlecopyrt=169,e.circlemultiply=8855,e.circleot=8857,e.circleplus=8853,e.circlepostalmark=12342,e.circlewithlefthalfblack=9680,e.circlewithrighthalfblack=9681,e.circumflex=710,e.circumflexbelowcmb=813,e.circumflexcmb=770,e.clear=8999,e.clickalveolar=450,e.clickdental=448,e.clicklateral=449,e.clickretroflex=451,e.club=9827,e.clubsuitblack=9827,e.clubsuitwhite=9831,e.cmcubedsquare=13220,e.cmonospace=65347,e.cmsquaredsquare=13216,e.coarmenian=1409,e.colon=58,e.colonmonetary=8353,e.colonmonospace=65306,e.colonsign=8353,e.colonsmall=65109,e.colontriangularhalfmod=721,e.colontriangularmod=720,e.comma=44,e.commaabovecmb=787,e.commaaboverightcmb=789,e.commaaccent=63171,e.commaarabic=1548,e.commaarmenian=1373,e.commainferior=63201,e.commamonospace=65292,e.commareversedabovecmb=788,e.commareversedmod=701,e.commasmall=65104,e.commasuperior=63202,e.commaturnedabovecmb=786,e.commaturnedmod=699,e.compass=9788,e.congruent=8773,e.contourintegral=8750,e.control=8963,e.controlACK=6,e.controlBEL=7,e.controlBS=8,e.controlCAN=24,e.controlCR=13,e.controlDC1=17,e.controlDC2=18,e.controlDC3=19,e.controlDC4=20,e.controlDEL=127,e.controlDLE=16,e.controlEM=25,e.controlENQ=5,e.controlEOT=4,e.controlESC=27,e.controlETB=23,e.controlETX=3,e.controlFF=12,e.controlFS=28,e.controlGS=29,e.controlHT=9,e.controlLF=10,e.controlNAK=21,e.controlNULL=0,e.controlRS=30,e.controlSI=15,e.controlSO=14,e.controlSOT=2,e.controlSTX=1,e.controlSUB=26,e.controlSYN=22,e.controlUS=31,e.controlVT=11,e.copyright=169,e.copyrightsans=63721,e.copyrightserif=63193,e.cornerbracketleft=12300,e.cornerbracketlefthalfwidth=65378,e.cornerbracketleftvertical=65089,e.cornerbracketright=12301,e.cornerbracketrighthalfwidth=65379,e.cornerbracketrightvertical=65090,e.corporationsquare=13183,e.cosquare=13255,e.coverkgsquare=13254,e.cparen=9374,e.cruzeiro=8354,e.cstretched=663,e.curlyand=8911,e.curlyor=8910,e.currency=164,e.cyrBreve=63185,e.cyrFlex=63186,e.cyrbreve=63188,e.cyrflex=63189,e.d=100,e.daarmenian=1380,e.dabengali=2470,e.dadarabic=1590,e.dadeva=2342,e.dadfinalarabic=65214,e.dadinitialarabic=65215,e.dadmedialarabic=65216,e.dagesh=1468,e.dageshhebrew=1468,e.dagger=8224,e.daggerdbl=8225,e.dagujarati=2726,e.dagurmukhi=2598,e.dahiragana=12384,e.dakatakana=12480,e.dalarabic=1583,e.dalet=1491,e.daletdagesh=64307,e.daletdageshhebrew=64307,e.dalethebrew=1491,e.dalfinalarabic=65194,e.dammaarabic=1615,e.dammalowarabic=1615,e.dammatanaltonearabic=1612,e.dammatanarabic=1612,e.danda=2404,e.dargahebrew=1447,e.dargalefthebrew=1447,e.dasiapneumatacyrilliccmb=1157,e.dblGrave=63187,e.dblanglebracketleft=12298,e.dblanglebracketleftvertical=65085,e.dblanglebracketright=12299,e.dblanglebracketrightvertical=65086,e.dblarchinvertedbelowcmb=811,e.dblarrowleft=8660,e.dblarrowright=8658,e.dbldanda=2405,e.dblgrave=63190,e.dblgravecmb=783,e.dblintegral=8748,e.dbllowline=8215,e.dbllowlinecmb=819,e.dbloverlinecmb=831,e.dblprimemod=698,e.dblverticalbar=8214,e.dblverticallineabovecmb=782,e.dbopomofo=12553,e.dbsquare=13256,e.dcaron=271,e.dcedilla=7697,e.dcircle=9427,e.dcircumflexbelow=7699,e.dcroat=273,e.ddabengali=2465,e.ddadeva=2337,e.ddagujarati=2721,e.ddagurmukhi=2593,e.ddalarabic=1672,e.ddalfinalarabic=64393,e.dddhadeva=2396,e.ddhabengali=2466,e.ddhadeva=2338,e.ddhagujarati=2722,e.ddhagurmukhi=2594,e.ddotaccent=7691,e.ddotbelow=7693,e.decimalseparatorarabic=1643,e.decimalseparatorpersian=1643,e.decyrillic=1076,e.degree=176,e.dehihebrew=1453,e.dehiragana=12391,e.deicoptic=1007,e.dekatakana=12487,e.deleteleft=9003,e.deleteright=8998,e.delta=948,e.deltaturned=397,e.denominatorminusonenumeratorbengali=2552,e.dezh=676,e.dhabengali=2471,e.dhadeva=2343,e.dhagujarati=2727,e.dhagurmukhi=2599,e.dhook=599,e.dialytikatonos=901,e.dialytikatonoscmb=836,e.diamond=9830,e.diamondsuitwhite=9826,e.dieresis=168,e.dieresisacute=63191,e.dieresisbelowcmb=804,e.dieresiscmb=776,e.dieresisgrave=63192,e.dieresistonos=901,e.dihiragana=12386,e.dikatakana=12482,e.dittomark=12291,e.divide=247,e.divides=8739,e.divisionslash=8725,e.djecyrillic=1106,e.dkshade=9619,e.dlinebelow=7695,e.dlsquare=13207,e.dmacron=273,e.dmonospace=65348,e.dnblock=9604,e.dochadathai=3598,e.dodekthai=3604,e.dohiragana=12393,e.dokatakana=12489,e.dollar=36;e.dollarinferior=63203,e.dollarmonospace=65284,e.dollaroldstyle=63268,e.dollarsmall=65129,e.dollarsuperior=63204,e.dong=8363,e.dorusquare=13094,e.dotaccent=729,e.dotaccentcmb=775,e.dotbelowcmb=803,e.dotbelowcomb=803,e.dotkatakana=12539,e.dotlessi=305,e.dotlessj=63166,e.dotlessjstrokehook=644,e.dotmath=8901,e.dottedcircle=9676,e.doubleyodpatah=64287,e.doubleyodpatahhebrew=64287,e.downtackbelowcmb=798,e.downtackmod=725,e.dparen=9375,e.dsuperior=63211,e.dtail=598,e.dtopbar=396,e.duhiragana=12389,e.dukatakana=12485,e.dz=499,e.dzaltone=675,e.dzcaron=454,e.dzcurl=677,e.dzeabkhasiancyrillic=1249,e.dzecyrillic=1109,e.dzhecyrillic=1119,e.e=101,e.eacute=233,e.earth=9793,e.ebengali=2447,e.ebopomofo=12572,e.ebreve=277,e.ecandradeva=2317,e.ecandragujarati=2701,e.ecandravowelsigndeva=2373,e.ecandravowelsigngujarati=2757,e.ecaron=283,e.ecedillabreve=7709,e.echarmenian=1381,e.echyiwnarmenian=1415,e.ecircle=9428,e.ecircumflex=234,e.ecircumflexacute=7871,e.ecircumflexbelow=7705,e.ecircumflexdotbelow=7879,e.ecircumflexgrave=7873,e.ecircumflexhookabove=7875,e.ecircumflextilde=7877,e.ecyrillic=1108,e.edblgrave=517,e.edeva=2319,e.edieresis=235,e.edot=279,e.edotaccent=279,e.edotbelow=7865,e.eegurmukhi=2575,e.eematragurmukhi=2631,e.efcyrillic=1092,e.egrave=232,e.egujarati=2703,e.eharmenian=1383,e.ehbopomofo=12573,e.ehiragana=12360,e.ehookabove=7867,e.eibopomofo=12575,e.eight=56,e.eightarabic=1640,e.eightbengali=2542,e.eightcircle=9319,e.eightcircleinversesansserif=10129,e.eightdeva=2414,e.eighteencircle=9329,e.eighteenparen=9349,e.eighteenperiod=9369,e.eightgujarati=2798,e.eightgurmukhi=2670,e.eighthackarabic=1640,e.eighthangzhou=12328,e.eighthnotebeamed=9835,e.eightideographicparen=12839,e.eightinferior=8328,e.eightmonospace=65304,e.eightoldstyle=63288,e.eightparen=9339,e.eightperiod=9359,e.eightpersian=1784,e.eightroman=8567,e.eightsuperior=8312,e.eightthai=3672,e.einvertedbreve=519,e.eiotifiedcyrillic=1125,e.ekatakana=12456,e.ekatakanahalfwidth=65396,e.ekonkargurmukhi=2676,e.ekorean=12628,e.elcyrillic=1083,e.element=8712,e.elevencircle=9322,e.elevenparen=9342,e.elevenperiod=9362,e.elevenroman=8570,e.ellipsis=8230,e.ellipsisvertical=8942,e.emacron=275,e.emacronacute=7703,e.emacrongrave=7701,e.emcyrillic=1084,e.emdash=8212,e.emdashvertical=65073,e.emonospace=65349,e.emphasismarkarmenian=1371,e.emptyset=8709,e.enbopomofo=12579,e.encyrillic=1085,e.endash=8211,e.endashvertical=65074,e.endescendercyrillic=1187,e.eng=331,e.engbopomofo=12581,e.enghecyrillic=1189,e.enhookcyrillic=1224,e.enspace=8194,e.eogonek=281,e.eokorean=12627,e.eopen=603,e.eopenclosed=666,e.eopenreversed=604,e.eopenreversedclosed=606,e.eopenreversedhook=605,e.eparen=9376,e.epsilon=949,e.epsilontonos=941,e.equal=61,e.equalmonospace=65309,e.equalsmall=65126,e.equalsuperior=8316,e.equivalence=8801,e.erbopomofo=12582,e.ercyrillic=1088,e.ereversed=600,e.ereversedcyrillic=1101,e.escyrillic=1089,e.esdescendercyrillic=1195,e.esh=643,e.eshcurl=646,e.eshortdeva=2318,e.eshortvowelsigndeva=2374,e.eshreversedloop=426,e.eshsquatreversed=645,e.esmallhiragana=12359,e.esmallkatakana=12455,e.esmallkatakanahalfwidth=65386,e.estimated=8494,e.esuperior=63212,e.eta=951,e.etarmenian=1384,e.etatonos=942,e.eth=240,e.etilde=7869,e.etildebelow=7707,e.etnahtafoukhhebrew=1425,e.etnahtafoukhlefthebrew=1425,e.etnahtahebrew=1425,e.etnahtalefthebrew=1425,e.eturned=477,e.eukorean=12641,e.euro=8364,e.evowelsignbengali=2503,e.evowelsigndeva=2375,e.evowelsigngujarati=2759,e.exclam=33,e.exclamarmenian=1372,e.exclamdbl=8252,e.exclamdown=161,e.exclamdownsmall=63393,e.exclammonospace=65281,e.exclamsmall=63265,e.existential=8707,e.ezh=658,e.ezhcaron=495,e.ezhcurl=659,e.ezhreversed=441,e.ezhtail=442,e.f=102,e.fadeva=2398,e.fagurmukhi=2654,e.fahrenheit=8457,e.fathaarabic=1614,e.fathalowarabic=1614,e.fathatanarabic=1611,e.fbopomofo=12552,e.fcircle=9429,e.fdotaccent=7711,e.feharabic=1601,e.feharmenian=1414,e.fehfinalarabic=65234,e.fehinitialarabic=65235,e.fehmedialarabic=65236,e.feicoptic=997,e.female=9792,e.ff=64256,e.f_f=64256,e.ffi=64259,e.f_f_i=64259,e.ffl=64260,e.f_f_l=64260,e.fi=64257,e.f_i=64257,e.fifteencircle=9326,e.fifteenparen=9346,e.fifteenperiod=9366,e.figuredash=8210,e.filledbox=9632,e.filledrect=9644,e.finalkaf=1498,e.finalkafdagesh=64314,e.finalkafdageshhebrew=64314,e.finalkafhebrew=1498,e.finalmem=1501,e.finalmemhebrew=1501,e.finalnun=1503,e.finalnunhebrew=1503,e.finalpe=1507,e.finalpehebrew=1507,e.finaltsadi=1509,e.finaltsadihebrew=1509,e.firsttonechinese=713,e.fisheye=9673,e.fitacyrillic=1139,e.five=53,e.fivearabic=1637,e.fivebengali=2539,e.fivecircle=9316,e.fivecircleinversesansserif=10126,e.fivedeva=2411,e.fiveeighths=8541,e.fivegujarati=2795,e.fivegurmukhi=2667,e.fivehackarabic=1637,e.fivehangzhou=12325,e.fiveideographicparen=12836,e.fiveinferior=8325,e.fivemonospace=65301,e.fiveoldstyle=63285,e.fiveparen=9336,e.fiveperiod=9356,e.fivepersian=1781,e.fiveroman=8564,e.fivesuperior=8309,e.fivethai=3669,e.fl=64258,e.f_l=64258,e.florin=402,e.fmonospace=65350,e.fmsquare=13209,e.fofanthai=3615,e.fofathai=3613,e.fongmanthai=3663,e.forall=8704,e.four=52,e.fourarabic=1636,e.fourbengali=2538,e.fourcircle=9315,e.fourcircleinversesansserif=10125,e.fourdeva=2410,e.fourgujarati=2794,e.fourgurmukhi=2666,e.fourhackarabic=1636,e.fourhangzhou=12324,e.fourideographicparen=12835,e.fourinferior=8324,e.fourmonospace=65300,e.fournumeratorbengali=2551,e.fouroldstyle=63284,e.fourparen=9335,e.fourperiod=9355,e.fourpersian=1780,e.fourroman=8563,e.foursuperior=8308,e.fourteencircle=9325,e.fourteenparen=9345,e.fourteenperiod=9365,e.fourthai=3668,e.fourthtonechinese=715,e.fparen=9377,e.fraction=8260,e.franc=8355,e.g=103,e.gabengali=2455,e.gacute=501,e.gadeva=2327,e.gafarabic=1711,e.gaffinalarabic=64403,e.gafinitialarabic=64404,e.gafmedialarabic=64405,e.gagujarati=2711,e.gagurmukhi=2583,e.gahiragana=12364,e.gakatakana=12460,e.gamma=947,e.gammalatinsmall=611,e.gammasuperior=736,e.gangiacoptic=1003,e.gbopomofo=12557,e.gbreve=287,e.gcaron=487,e.gcedilla=291,e.gcircle=9430,e.gcircumflex=285,e.gcommaaccent=291,e.gdot=289,e.gdotaccent=289,e.gecyrillic=1075,e.gehiragana=12370,e.gekatakana=12466,e.geometricallyequal=8785,e.gereshaccenthebrew=1436,e.gereshhebrew=1523,e.gereshmuqdamhebrew=1437,e.germandbls=223,e.gershayimaccenthebrew=1438,e.gershayimhebrew=1524,e.getamark=12307,e.ghabengali=2456,e.ghadarmenian=1394,e.ghadeva=2328,e.ghagujarati=2712,e.ghagurmukhi=2584,e.ghainarabic=1594,e.ghainfinalarabic=65230,e.ghaininitialarabic=65231,e.ghainmedialarabic=65232,e.ghemiddlehookcyrillic=1173,e.ghestrokecyrillic=1171,e.gheupturncyrillic=1169,e.ghhadeva=2394,e.ghhagurmukhi=2650,e.ghook=608,e.ghzsquare=13203,e.gihiragana=12366,e.gikatakana=12462,e.gimarmenian=1379,e.gimel=1490,e.gimeldagesh=64306,e.gimeldageshhebrew=64306,e.gimelhebrew=1490,e.gjecyrillic=1107,e.glottalinvertedstroke=446,e.glottalstop=660,e.glottalstopinverted=662,e.glottalstopmod=704,e.glottalstopreversed=661,e.glottalstopreversedmod=705,e.glottalstopreversedsuperior=740,e.glottalstopstroke=673,e.glottalstopstrokereversed=674,e.gmacron=7713,e.gmonospace=65351,e.gohiragana=12372,e.gokatakana=12468,e.gparen=9378,e.gpasquare=13228,e.gradient=8711,e.grave=96,e.gravebelowcmb=790,e.gravecmb=768,e.gravecomb=768,e.gravedeva=2387,e.gravelowmod=718,e.gravemonospace=65344,e.gravetonecmb=832,e.greater=62,e.greaterequal=8805,e.greaterequalorless=8923,e.greatermonospace=65310,e.greaterorequivalent=8819,e.greaterorless=8823,e.greateroverequal=8807,e.greatersmall=65125,e.gscript=609,e.gstroke=485,e.guhiragana=12368,e.guillemotleft=171,e.guillemotright=187,e.guilsinglleft=8249,e.guilsinglright=8250,e.gukatakana=12464,e.guramusquare=13080,e.gysquare=13257,e.h=104,e.haabkhasiancyrillic=1193,e.haaltonearabic=1729,e.habengali=2489,e.hadescendercyrillic=1203,e.hadeva=2361,e.hagujarati=2745,e.hagurmukhi=2617,e.haharabic=1581,e.hahfinalarabic=65186,e.hahinitialarabic=65187,e.hahiragana=12399,e.hahmedialarabic=65188,e.haitusquare=13098,e.hakatakana=12495,e.hakatakanahalfwidth=65418,e.halantgurmukhi=2637,e.hamzaarabic=1569,e.hamzalowarabic=1569,e.hangulfiller=12644,e.hardsigncyrillic=1098,e.harpoonleftbarbup=8636,e.harpoonrightbarbup=8640,e.hasquare=13258,e.hatafpatah=1458,e.hatafpatah16=1458,e.hatafpatah23=1458,e.hatafpatah2f=1458,e.hatafpatahhebrew=1458,e.hatafpatahnarrowhebrew=1458,e.hatafpatahquarterhebrew=1458,e.hatafpatahwidehebrew=1458,e.hatafqamats=1459,e.hatafqamats1b=1459,e.hatafqamats28=1459,e.hatafqamats34=1459,e.hatafqamatshebrew=1459,e.hatafqamatsnarrowhebrew=1459,e.hatafqamatsquarterhebrew=1459,e.hatafqamatswidehebrew=1459,e.hatafsegol=1457,e.hatafsegol17=1457,e.hatafsegol24=1457,e.hatafsegol30=1457,e.hatafsegolhebrew=1457,e.hatafsegolnarrowhebrew=1457,e.hatafsegolquarterhebrew=1457,e.hatafsegolwidehebrew=1457,e.hbar=295,e.hbopomofo=12559,e.hbrevebelow=7723,e.hcedilla=7721,e.hcircle=9431,e.hcircumflex=293,e.hdieresis=7719,e.hdotaccent=7715,e.hdotbelow=7717,e.he=1492,e.heart=9829,e.heartsuitblack=9829,e.heartsuitwhite=9825,e.hedagesh=64308,e.hedageshhebrew=64308,e.hehaltonearabic=1729,e.heharabic=1607,e.hehebrew=1492,e.hehfinalaltonearabic=64423,e.hehfinalalttwoarabic=65258,e.hehfinalarabic=65258,e.hehhamzaabovefinalarabic=64421,e.hehhamzaaboveisolatedarabic=64420,e.hehinitialaltonearabic=64424,e.hehinitialarabic=65259,e.hehiragana=12408,e.hehmedialaltonearabic=64425,e.hehmedialarabic=65260,e.heiseierasquare=13179,e.hekatakana=12504,e.hekatakanahalfwidth=65421,e.hekutaarusquare=13110,e.henghook=615,e.herutusquare=13113,e.het=1495,e.hethebrew=1495,e.hhook=614,e.hhooksuperior=689,e.hieuhacirclekorean=12923,e.hieuhaparenkorean=12827,e.hieuhcirclekorean=12909,e.hieuhkorean=12622,e.hieuhparenkorean=12813,e.hihiragana=12402,e.hikatakana=12498,e.hikatakanahalfwidth=65419,e.hiriq=1460,e.hiriq14=1460,e.hiriq21=1460,e.hiriq2d=1460,e.hiriqhebrew=1460,e.hiriqnarrowhebrew=1460,e.hiriqquarterhebrew=1460,e.hiriqwidehebrew=1460,e.hlinebelow=7830,e.hmonospace=65352,e.hoarmenian=1392,e.hohipthai=3627,e.hohiragana=12411,e.hokatakana=12507,e.hokatakanahalfwidth=65422,e.holam=1465,e.holam19=1465,e.holam26=1465,e.holam32=1465,e.holamhebrew=1465,e.holamnarrowhebrew=1465,e.holamquarterhebrew=1465,e.holamwidehebrew=1465,e.honokhukthai=3630,e.hookabovecomb=777,e.hookcmb=777,e.hookpalatalizedbelowcmb=801,e.hookretroflexbelowcmb=802,e.hoonsquare=13122,e.horicoptic=1001,e.horizontalbar=8213,e.horncmb=795,e.hotsprings=9832,e.house=8962,e.hparen=9379,e.hsuperior=688,e.hturned=613,e.huhiragana=12405,e.huiitosquare=13107,e.hukatakana=12501,e.hukatakanahalfwidth=65420,e.hungarumlaut=733,e.hungarumlautcmb=779,e.hv=405,e.hyphen=45,e.hypheninferior=63205,e.hyphenmonospace=65293,e.hyphensmall=65123,e.hyphensuperior=63206,e.hyphentwo=8208,e.i=105,e.iacute=237,e.iacyrillic=1103,e.ibengali=2439,e.ibopomofo=12583,e.ibreve=301,e.icaron=464,e.icircle=9432,e.icircumflex=238,e.icyrillic=1110,e.idblgrave=521,e.ideographearthcircle=12943,e.ideographfirecircle=12939,e.ideographicallianceparen=12863,e.ideographiccallparen=12858,e.ideographiccentrecircle=12965,e.ideographicclose=12294,e.ideographiccomma=12289,e.ideographiccommaleft=65380,e.ideographiccongratulationparen=12855,e.ideographiccorrectcircle=12963,e.ideographicearthparen=12847,e.ideographicenterpriseparen=12861,e.ideographicexcellentcircle=12957,e.ideographicfestivalparen=12864,e.ideographicfinancialcircle=12950,e.ideographicfinancialparen=12854,e.ideographicfireparen=12843,e.ideographichaveparen=12850,e.ideographichighcircle=12964,e.ideographiciterationmark=12293,e.ideographiclaborcircle=12952,e.ideographiclaborparen=12856,e.ideographicleftcircle=12967,e.ideographiclowcircle=12966,e.ideographicmedicinecircle=12969,e.ideographicmetalparen=12846,e.ideographicmoonparen=12842,e.ideographicnameparen=12852,e.ideographicperiod=12290,e.ideographicprintcircle=12958,e.ideographicreachparen=12867,e.ideographicrepresentparen=12857,e.ideographicresourceparen=12862,e.ideographicrightcircle=12968,e.ideographicsecretcircle=12953,e.ideographicselfparen=12866,e.ideographicsocietyparen=12851,e.ideographicspace=12288,e.ideographicspecialparen=12853,e.ideographicstockparen=12849,e.ideographicstudyparen=12859,e.ideographicsunparen=12848,e.ideographicsuperviseparen=12860,e.ideographicwaterparen=12844,e.ideographicwoodparen=12845,e.ideographiczero=12295,e.ideographmetalcircle=12942,e.ideographmooncircle=12938,e.ideographnamecircle=12948,e.ideographsuncircle=12944,e.ideographwatercircle=12940,e.ideographwoodcircle=12941,e.ideva=2311,e.idieresis=239,e.idieresisacute=7727,e.idieresiscyrillic=1253,e.idotbelow=7883,e.iebrevecyrillic=1239,e.iecyrillic=1077,e.ieungacirclekorean=12917,e.ieungaparenkorean=12821,e.ieungcirclekorean=12903,e.ieungkorean=12615,e.ieungparenkorean=12807,e.igrave=236,e.igujarati=2695,e.igurmukhi=2567,e.ihiragana=12356,e.ihookabove=7881,e.iibengali=2440,e.iicyrillic=1080,e.iideva=2312,e.iigujarati=2696,e.iigurmukhi=2568,e.iimatragurmukhi=2624,e.iinvertedbreve=523,e.iishortcyrillic=1081,e.iivowelsignbengali=2496,e.iivowelsigndeva=2368,e.iivowelsigngujarati=2752,e.ij=307,e.ikatakana=12452,e.ikatakanahalfwidth=65394,e.ikorean=12643,e.ilde=732,e.iluyhebrew=1452,e.imacron=299,e.imacroncyrillic=1251,e.imageorapproximatelyequal=8787,e.imatragurmukhi=2623,e.imonospace=65353,e.increment=8710,e.infinity=8734,e.iniarmenian=1387,e.integral=8747,e.integralbottom=8993,e.integralbt=8993,e.integralex=63733,e.integraltop=8992,e.integraltp=8992,e.intersection=8745,e.intisquare=13061,e.invbullet=9688,e.invcircle=9689,e.invsmileface=9787,e.iocyrillic=1105,e.iogonek=303,e.iota=953,e.iotadieresis=970,e.iotadieresistonos=912,e.iotalatin=617,e.iotatonos=943,e.iparen=9380,e.irigurmukhi=2674,e.ismallhiragana=12355,e.ismallkatakana=12451,e.ismallkatakanahalfwidth=65384,e.issharbengali=2554,e.istroke=616,e.isuperior=63213,e.iterationhiragana=12445,e.iterationkatakana=12541,e.itilde=297,e.itildebelow=7725,e.iubopomofo=12585,e.iucyrillic=1102,e.ivowelsignbengali=2495,e.ivowelsigndeva=2367,e.ivowelsigngujarati=2751,e.izhitsacyrillic=1141,e.izhitsadblgravecyrillic=1143,e.j=106,e.jaarmenian=1393,e.jabengali=2460,e.jadeva=2332,e.jagujarati=2716,e.jagurmukhi=2588,e.jbopomofo=12560,e.jcaron=496,e.jcircle=9433,e.jcircumflex=309,e.jcrossedtail=669,e.jdotlessstroke=607,e.jecyrillic=1112,e.jeemarabic=1580,e.jeemfinalarabic=65182,e.jeeminitialarabic=65183,e.jeemmedialarabic=65184,e.jeharabic=1688,e.jehfinalarabic=64395,e.jhabengali=2461,e.jhadeva=2333,e.jhagujarati=2717,e.jhagurmukhi=2589,e.jheharmenian=1403,e.jis=12292,e.jmonospace=65354,e.jparen=9381,e.jsuperior=690,e.k=107,e.kabashkircyrillic=1185,e.kabengali=2453,e.kacute=7729,e.kacyrillic=1082,e.kadescendercyrillic=1179,e.kadeva=2325,e.kaf=1499,e.kafarabic=1603,e.kafdagesh=64315,e.kafdageshhebrew=64315,e.kaffinalarabic=65242,e.kafhebrew=1499,e.kafinitialarabic=65243,e.kafmedialarabic=65244,e.kafrafehebrew=64333,e.kagujarati=2709,e.kagurmukhi=2581,e.kahiragana=12363,e.kahookcyrillic=1220,e.kakatakana=12459,e.kakatakanahalfwidth=65398,e.kappa=954,e.kappasymbolgreek=1008,e.kapyeounmieumkorean=12657,e.kapyeounphieuphkorean=12676,e.kapyeounpieupkorean=12664,e.kapyeounssangpieupkorean=12665,e.karoriisquare=13069,e.kashidaautoarabic=1600,e.kashidaautonosidebearingarabic=1600,e.kasmallkatakana=12533,e.kasquare=13188,e.kasraarabic=1616,e.kasratanarabic=1613,e.kastrokecyrillic=1183,e.katahiraprolongmarkhalfwidth=65392,e.kaverticalstrokecyrillic=1181,e.kbopomofo=12558,e.kcalsquare=13193,e.kcaron=489,e.kcedilla=311,e.kcircle=9434,e.kcommaaccent=311,e.kdotbelow=7731,e.keharmenian=1412,e.kehiragana=12369,e.kekatakana=12465,e.kekatakanahalfwidth=65401,e.kenarmenian=1391,e.kesmallkatakana=12534,e.kgreenlandic=312,e.khabengali=2454,e.khacyrillic=1093,e.khadeva=2326,e.khagujarati=2710,e.khagurmukhi=2582,e.khaharabic=1582,e.khahfinalarabic=65190,e.khahinitialarabic=65191,e.khahmedialarabic=65192,e.kheicoptic=999,e.khhadeva=2393,e.khhagurmukhi=2649,e.khieukhacirclekorean=12920,e.khieukhaparenkorean=12824,e.khieukhcirclekorean=12906,e.khieukhkorean=12619,e.khieukhparenkorean=12810,e.khokhaithai=3586,e.khokhonthai=3589,e.khokhuatthai=3587,e.khokhwaithai=3588,e.khomutthai=3675,e.khook=409,e.khorakhangthai=3590,e.khzsquare=13201,e.kihiragana=12365,e.kikatakana=12461,e.kikatakanahalfwidth=65399,e.kiroguramusquare=13077,e.kiromeetorusquare=13078,e.kirosquare=13076,e.kiyeokacirclekorean=12910,e.kiyeokaparenkorean=12814,e.kiyeokcirclekorean=12896,e.kiyeokkorean=12593,e.kiyeokparenkorean=12800,e.kiyeoksioskorean=12595;e.kjecyrillic=1116,e.klinebelow=7733,e.klsquare=13208,e.kmcubedsquare=13222,e.kmonospace=65355,e.kmsquaredsquare=13218,e.kohiragana=12371,e.kohmsquare=13248,e.kokaithai=3585,e.kokatakana=12467,e.kokatakanahalfwidth=65402,e.kooposquare=13086,e.koppacyrillic=1153,e.koreanstandardsymbol=12927,e.koroniscmb=835,e.kparen=9382,e.kpasquare=13226,e.ksicyrillic=1135,e.ktsquare=13263,e.kturned=670,e.kuhiragana=12367,e.kukatakana=12463,e.kukatakanahalfwidth=65400,e.kvsquare=13240,e.kwsquare=13246,e.l=108,e.labengali=2482,e.lacute=314,e.ladeva=2354,e.lagujarati=2738,e.lagurmukhi=2610,e.lakkhangyaothai=3653,e.lamaleffinalarabic=65276,e.lamalefhamzaabovefinalarabic=65272,e.lamalefhamzaaboveisolatedarabic=65271,e.lamalefhamzabelowfinalarabic=65274,e.lamalefhamzabelowisolatedarabic=65273,e.lamalefisolatedarabic=65275,e.lamalefmaddaabovefinalarabic=65270,e.lamalefmaddaaboveisolatedarabic=65269,e.lamarabic=1604,e.lambda=955,e.lambdastroke=411,e.lamed=1500,e.lameddagesh=64316,e.lameddageshhebrew=64316,e.lamedhebrew=1500,e.lamfinalarabic=65246,e.lamhahinitialarabic=64714,e.laminitialarabic=65247,e.lamjeeminitialarabic=64713,e.lamkhahinitialarabic=64715,e.lamlamhehisolatedarabic=65010,e.lammedialarabic=65248,e.lammeemhahinitialarabic=64904,e.lammeeminitialarabic=64716,e.largecircle=9711,e.lbar=410,e.lbelt=620,e.lbopomofo=12556,e.lcaron=318,e.lcedilla=316,e.lcircle=9435,e.lcircumflexbelow=7741,e.lcommaaccent=316,e.ldot=320,e.ldotaccent=320,e.ldotbelow=7735,e.ldotbelowmacron=7737,e.leftangleabovecmb=794,e.lefttackbelowcmb=792,e.less=60,e.lessequal=8804,e.lessequalorgreater=8922,e.lessmonospace=65308,e.lessorequivalent=8818,e.lessorgreater=8822,e.lessoverequal=8806,e.lesssmall=65124,e.lezh=622,e.lfblock=9612,e.lhookretroflex=621,e.lira=8356,e.liwnarmenian=1388,e.lj=457,e.ljecyrillic=1113,e.ll=63168,e.lladeva=2355,e.llagujarati=2739,e.llinebelow=7739,e.llladeva=2356,e.llvocalicbengali=2529,e.llvocalicdeva=2401,e.llvocalicvowelsignbengali=2531,e.llvocalicvowelsigndeva=2403,e.lmiddletilde=619,e.lmonospace=65356,e.lmsquare=13264,e.lochulathai=3628,e.logicaland=8743,e.logicalnot=172,e.logicalnotreversed=8976,e.logicalor=8744,e.lolingthai=3621,e.longs=383,e.lowlinecenterline=65102,e.lowlinecmb=818,e.lowlinedashed=65101,e.lozenge=9674,e.lparen=9383,e.lslash=322,e.lsquare=8467,e.lsuperior=63214,e.ltshade=9617,e.luthai=3622,e.lvocalicbengali=2444,e.lvocalicdeva=2316,e.lvocalicvowelsignbengali=2530,e.lvocalicvowelsigndeva=2402,e.lxsquare=13267,e.m=109,e.mabengali=2478,e.macron=175,e.macronbelowcmb=817,e.macroncmb=772,e.macronlowmod=717,e.macronmonospace=65507,e.macute=7743,e.madeva=2350,e.magujarati=2734,e.magurmukhi=2606,e.mahapakhhebrew=1444,e.mahapakhlefthebrew=1444,e.mahiragana=12414,e.maichattawalowleftthai=63637,e.maichattawalowrightthai=63636,e.maichattawathai=3659,e.maichattawaupperleftthai=63635,e.maieklowleftthai=63628,e.maieklowrightthai=63627,e.maiekthai=3656,e.maiekupperleftthai=63626,e.maihanakatleftthai=63620,e.maihanakatthai=3633,e.maitaikhuleftthai=63625,e.maitaikhuthai=3655,e.maitholowleftthai=63631,e.maitholowrightthai=63630,e.maithothai=3657,e.maithoupperleftthai=63629,e.maitrilowleftthai=63634,e.maitrilowrightthai=63633,e.maitrithai=3658,e.maitriupperleftthai=63632,e.maiyamokthai=3654,e.makatakana=12510,e.makatakanahalfwidth=65423,e.male=9794,e.mansyonsquare=13127,e.maqafhebrew=1470,e.mars=9794,e.masoracirclehebrew=1455,e.masquare=13187,e.mbopomofo=12551,e.mbsquare=13268,e.mcircle=9436,e.mcubedsquare=13221,e.mdotaccent=7745,e.mdotbelow=7747,e.meemarabic=1605,e.meemfinalarabic=65250,e.meeminitialarabic=65251,e.meemmedialarabic=65252,e.meemmeeminitialarabic=64721,e.meemmeemisolatedarabic=64584,e.meetorusquare=13133,e.mehiragana=12417,e.meizierasquare=13182,e.mekatakana=12513,e.mekatakanahalfwidth=65426,e.mem=1502,e.memdagesh=64318,e.memdageshhebrew=64318,e.memhebrew=1502,e.menarmenian=1396,e.merkhahebrew=1445,e.merkhakefulahebrew=1446,e.merkhakefulalefthebrew=1446,e.merkhalefthebrew=1445,e.mhook=625,e.mhzsquare=13202,e.middledotkatakanahalfwidth=65381,e.middot=183,e.mieumacirclekorean=12914,e.mieumaparenkorean=12818,e.mieumcirclekorean=12900,e.mieumkorean=12609,e.mieumpansioskorean=12656,e.mieumparenkorean=12804,e.mieumpieupkorean=12654,e.mieumsioskorean=12655,e.mihiragana=12415,e.mikatakana=12511,e.mikatakanahalfwidth=65424,e.minus=8722,e.minusbelowcmb=800,e.minuscircle=8854,e.minusmod=727,e.minusplus=8723,e.minute=8242,e.miribaarusquare=13130,e.mirisquare=13129,e.mlonglegturned=624,e.mlsquare=13206,e.mmcubedsquare=13219,e.mmonospace=65357,e.mmsquaredsquare=13215,e.mohiragana=12418,e.mohmsquare=13249,e.mokatakana=12514,e.mokatakanahalfwidth=65427,e.molsquare=13270,e.momathai=3617,e.moverssquare=13223,e.moverssquaredsquare=13224,e.mparen=9384,e.mpasquare=13227,e.mssquare=13235,e.msuperior=63215,e.mturned=623,e.mu=181,e.mu1=181,e.muasquare=13186,e.muchgreater=8811,e.muchless=8810,e.mufsquare=13196,e.mugreek=956,e.mugsquare=13197,e.muhiragana=12416,e.mukatakana=12512,e.mukatakanahalfwidth=65425,e.mulsquare=13205,e.multiply=215,e.mumsquare=13211,e.munahhebrew=1443,e.munahlefthebrew=1443,e.musicalnote=9834,e.musicalnotedbl=9835,e.musicflatsign=9837,e.musicsharpsign=9839,e.mussquare=13234,e.muvsquare=13238,e.muwsquare=13244,e.mvmegasquare=13241,e.mvsquare=13239,e.mwmegasquare=13247,e.mwsquare=13245,e.n=110,e.nabengali=2472,e.nabla=8711,e.nacute=324,e.nadeva=2344,e.nagujarati=2728,e.nagurmukhi=2600,e.nahiragana=12394,e.nakatakana=12490,e.nakatakanahalfwidth=65413,e.napostrophe=329,e.nasquare=13185,e.nbopomofo=12555,e.nbspace=160,e.ncaron=328,e.ncedilla=326,e.ncircle=9437,e.ncircumflexbelow=7755,e.ncommaaccent=326,e.ndotaccent=7749,e.ndotbelow=7751,e.nehiragana=12397,e.nekatakana=12493,e.nekatakanahalfwidth=65416,e.newsheqelsign=8362,e.nfsquare=13195,e.ngabengali=2457,e.ngadeva=2329,e.ngagujarati=2713,e.ngagurmukhi=2585,e.ngonguthai=3591,e.nhiragana=12435,e.nhookleft=626,e.nhookretroflex=627,e.nieunacirclekorean=12911,e.nieunaparenkorean=12815,e.nieuncieuckorean=12597,e.nieuncirclekorean=12897,e.nieunhieuhkorean=12598,e.nieunkorean=12596,e.nieunpansioskorean=12648,e.nieunparenkorean=12801,e.nieunsioskorean=12647,e.nieuntikeutkorean=12646,e.nihiragana=12395,e.nikatakana=12491,e.nikatakanahalfwidth=65414,e.nikhahitleftthai=63641,e.nikhahitthai=3661,e.nine=57,e.ninearabic=1641,e.ninebengali=2543,e.ninecircle=9320,e.ninecircleinversesansserif=10130,e.ninedeva=2415,e.ninegujarati=2799,e.ninegurmukhi=2671,e.ninehackarabic=1641,e.ninehangzhou=12329,e.nineideographicparen=12840,e.nineinferior=8329,e.ninemonospace=65305,e.nineoldstyle=63289,e.nineparen=9340,e.nineperiod=9360,e.ninepersian=1785,e.nineroman=8568,e.ninesuperior=8313,e.nineteencircle=9330,e.nineteenparen=9350,e.nineteenperiod=9370,e.ninethai=3673,e.nj=460,e.njecyrillic=1114,e.nkatakana=12531,e.nkatakanahalfwidth=65437,e.nlegrightlong=414,e.nlinebelow=7753,e.nmonospace=65358,e.nmsquare=13210,e.nnabengali=2467,e.nnadeva=2339,e.nnagujarati=2723,e.nnagurmukhi=2595,e.nnnadeva=2345,e.nohiragana=12398,e.nokatakana=12494,e.nokatakanahalfwidth=65417,e.nonbreakingspace=160,e.nonenthai=3603,e.nonuthai=3609,e.noonarabic=1606,e.noonfinalarabic=65254,e.noonghunnaarabic=1722,e.noonghunnafinalarabic=64415,e.nooninitialarabic=65255,e.noonjeeminitialarabic=64722,e.noonjeemisolatedarabic=64587,e.noonmedialarabic=65256,e.noonmeeminitialarabic=64725,e.noonmeemisolatedarabic=64590,e.noonnoonfinalarabic=64653,e.notcontains=8716,e.notelement=8713,e.notelementof=8713,e.notequal=8800,e.notgreater=8815,e.notgreaternorequal=8817,e.notgreaternorless=8825,e.notidentical=8802,e.notless=8814,e.notlessnorequal=8816,e.notparallel=8742,e.notprecedes=8832,e.notsubset=8836,e.notsucceeds=8833,e.notsuperset=8837,e.nowarmenian=1398,e.nparen=9385,e.nssquare=13233,e.nsuperior=8319,e.ntilde=241,e.nu=957,e.nuhiragana=12396,e.nukatakana=12492,e.nukatakanahalfwidth=65415,e.nuktabengali=2492,e.nuktadeva=2364,e.nuktagujarati=2748,e.nuktagurmukhi=2620,e.numbersign=35,e.numbersignmonospace=65283,e.numbersignsmall=65119,e.numeralsigngreek=884,e.numeralsignlowergreek=885,e.numero=8470,e.nun=1504,e.nundagesh=64320,e.nundageshhebrew=64320,e.nunhebrew=1504,e.nvsquare=13237,e.nwsquare=13243,e.nyabengali=2462,e.nyadeva=2334,e.nyagujarati=2718,e.nyagurmukhi=2590,e.o=111,e.oacute=243,e.oangthai=3629,e.obarred=629,e.obarredcyrillic=1257,e.obarreddieresiscyrillic=1259,e.obengali=2451,e.obopomofo=12571,e.obreve=335,e.ocandradeva=2321,e.ocandragujarati=2705,e.ocandravowelsigndeva=2377,e.ocandravowelsigngujarati=2761,e.ocaron=466,e.ocircle=9438,e.ocircumflex=244,e.ocircumflexacute=7889,e.ocircumflexdotbelow=7897,e.ocircumflexgrave=7891,e.ocircumflexhookabove=7893,e.ocircumflextilde=7895,e.ocyrillic=1086,e.odblacute=337,e.odblgrave=525,e.odeva=2323,e.odieresis=246,e.odieresiscyrillic=1255,e.odotbelow=7885,e.oe=339,e.oekorean=12634,e.ogonek=731,e.ogonekcmb=808,e.ograve=242,e.ogujarati=2707,e.oharmenian=1413,e.ohiragana=12362,e.ohookabove=7887,e.ohorn=417,e.ohornacute=7899,e.ohorndotbelow=7907,e.ohorngrave=7901,e.ohornhookabove=7903,e.ohorntilde=7905,e.ohungarumlaut=337,e.oi=419,e.oinvertedbreve=527,e.okatakana=12458,e.okatakanahalfwidth=65397,e.okorean=12631,e.olehebrew=1451,e.omacron=333,e.omacronacute=7763,e.omacrongrave=7761,e.omdeva=2384,e.omega=969,e.omega1=982,e.omegacyrillic=1121,e.omegalatinclosed=631,e.omegaroundcyrillic=1147,e.omegatitlocyrillic=1149,e.omegatonos=974,e.omgujarati=2768,e.omicron=959,e.omicrontonos=972,e.omonospace=65359,e.one=49,e.onearabic=1633,e.onebengali=2535,e.onecircle=9312,e.onecircleinversesansserif=10122,e.onedeva=2407,e.onedotenleader=8228,e.oneeighth=8539,e.onefitted=63196,e.onegujarati=2791,e.onegurmukhi=2663,e.onehackarabic=1633,e.onehalf=189,e.onehangzhou=12321,e.oneideographicparen=12832,e.oneinferior=8321,e.onemonospace=65297,e.onenumeratorbengali=2548,e.oneoldstyle=63281,e.oneparen=9332,e.oneperiod=9352,e.onepersian=1777,e.onequarter=188,e.oneroman=8560,e.onesuperior=185,e.onethai=3665,e.onethird=8531,e.oogonek=491,e.oogonekmacron=493,e.oogurmukhi=2579,e.oomatragurmukhi=2635,e.oopen=596,e.oparen=9386,e.openbullet=9702,e.option=8997,e.ordfeminine=170,e.ordmasculine=186,e.orthogonal=8735,e.oshortdeva=2322,e.oshortvowelsigndeva=2378,e.oslash=248,e.oslashacute=511,e.osmallhiragana=12361,e.osmallkatakana=12457,e.osmallkatakanahalfwidth=65387,e.ostrokeacute=511,e.osuperior=63216,e.otcyrillic=1151,e.otilde=245,e.otildeacute=7757,e.otildedieresis=7759,e.oubopomofo=12577,e.overline=8254,e.overlinecenterline=65098,e.overlinecmb=773,e.overlinedashed=65097,e.overlinedblwavy=65100,e.overlinewavy=65099,e.overscore=175,e.ovowelsignbengali=2507,e.ovowelsigndeva=2379,e.ovowelsigngujarati=2763,e.p=112,e.paampssquare=13184,e.paasentosquare=13099,e.pabengali=2474,e.pacute=7765,e.padeva=2346,e.pagedown=8671,e.pageup=8670,e.pagujarati=2730,e.pagurmukhi=2602,e.pahiragana=12401,e.paiyannoithai=3631,e.pakatakana=12497,e.palatalizationcyrilliccmb=1156,e.palochkacyrillic=1216,e.pansioskorean=12671,e.paragraph=182,e.parallel=8741,e.parenleft=40,e.parenleftaltonearabic=64830,e.parenleftbt=63725,e.parenleftex=63724,e.parenleftinferior=8333,e.parenleftmonospace=65288,e.parenleftsmall=65113,e.parenleftsuperior=8317,e.parenlefttp=63723,e.parenleftvertical=65077,e.parenright=41,e.parenrightaltonearabic=64831,e.parenrightbt=63736,e.parenrightex=63735,e.parenrightinferior=8334,e.parenrightmonospace=65289,e.parenrightsmall=65114,e.parenrightsuperior=8318,e.parenrighttp=63734,e.parenrightvertical=65078,e.partialdiff=8706,e.paseqhebrew=1472,e.pashtahebrew=1433,e.pasquare=13225,e.patah=1463,e.patah11=1463,e.patah1d=1463,e.patah2a=1463,e.patahhebrew=1463,e.patahnarrowhebrew=1463,e.patahquarterhebrew=1463,e.patahwidehebrew=1463,e.pazerhebrew=1441,e.pbopomofo=12550,e.pcircle=9439,e.pdotaccent=7767,e.pe=1508,e.pecyrillic=1087,e.pedagesh=64324,e.pedageshhebrew=64324,e.peezisquare=13115,e.pefinaldageshhebrew=64323,e.peharabic=1662,e.peharmenian=1402,e.pehebrew=1508,e.pehfinalarabic=64343,e.pehinitialarabic=64344,e.pehiragana=12410,e.pehmedialarabic=64345,e.pekatakana=12506,e.pemiddlehookcyrillic=1191,e.perafehebrew=64334,e.percent=37,e.percentarabic=1642,e.percentmonospace=65285,e.percentsmall=65130,e.period=46,e.periodarmenian=1417,e.periodcentered=183,e.periodhalfwidth=65377,e.periodinferior=63207,e.periodmonospace=65294,e.periodsmall=65106,e.periodsuperior=63208,e.perispomenigreekcmb=834,e.perpendicular=8869,e.perthousand=8240,e.peseta=8359,e.pfsquare=13194,e.phabengali=2475,e.phadeva=2347,e.phagujarati=2731,e.phagurmukhi=2603,e.phi=966,e.phi1=981,e.phieuphacirclekorean=12922,e.phieuphaparenkorean=12826,e.phieuphcirclekorean=12908,e.phieuphkorean=12621,e.phieuphparenkorean=12812,e.philatin=632,e.phinthuthai=3642,e.phisymbolgreek=981,e.phook=421,e.phophanthai=3614,e.phophungthai=3612,e.phosamphaothai=3616,e.pi=960,e.pieupacirclekorean=12915,e.pieupaparenkorean=12819,e.pieupcieuckorean=12662,e.pieupcirclekorean=12901,e.pieupkiyeokkorean=12658,e.pieupkorean=12610,e.pieupparenkorean=12805,e.pieupsioskiyeokkorean=12660,e.pieupsioskorean=12612,e.pieupsiostikeutkorean=12661,e.pieupthieuthkorean=12663,e.pieuptikeutkorean=12659,e.pihiragana=12404,e.pikatakana=12500,e.pisymbolgreek=982,e.piwrarmenian=1411,e.planckover2pi=8463,e.planckover2pi1=8463,e.plus=43,e.plusbelowcmb=799,e.pluscircle=8853,e.plusminus=177,e.plusmod=726,e.plusmonospace=65291,e.plussmall=65122,e.plussuperior=8314,e.pmonospace=65360,e.pmsquare=13272,e.pohiragana=12413,e.pointingindexdownwhite=9759,e.pointingindexleftwhite=9756,e.pointingindexrightwhite=9758,e.pointingindexupwhite=9757,e.pokatakana=12509,e.poplathai=3611,e.postalmark=12306,e.postalmarkface=12320,e.pparen=9387,e.precedes=8826,e.prescription=8478,e.primemod=697,e.primereversed=8245,e.product=8719,e.projective=8965,e.prolongedkana=12540,e.propellor=8984,e.propersubset=8834,e.propersuperset=8835,e.proportion=8759,e.proportional=8733,e.psi=968,e.psicyrillic=1137,e.psilipneumatacyrilliccmb=1158,e.pssquare=13232,e.puhiragana=12407,e.pukatakana=12503,e.pvsquare=13236,e.pwsquare=13242,e.q=113,e.qadeva=2392,e.qadmahebrew=1448,e.qafarabic=1602,e.qaffinalarabic=65238,e.qafinitialarabic=65239,e.qafmedialarabic=65240,e.qamats=1464,e.qamats10=1464,e.qamats1a=1464,e.qamats1c=1464,e.qamats27=1464,e.qamats29=1464,e.qamats33=1464,e.qamatsde=1464,e.qamatshebrew=1464,e.qamatsnarrowhebrew=1464,e.qamatsqatanhebrew=1464,e.qamatsqatannarrowhebrew=1464,e.qamatsqatanquarterhebrew=1464,e.qamatsqatanwidehebrew=1464,e.qamatsquarterhebrew=1464,e.qamatswidehebrew=1464,e.qarneyparahebrew=1439,e.qbopomofo=12561,e.qcircle=9440,e.qhook=672,e.qmonospace=65361,e.qof=1511,e.qofdagesh=64327,e.qofdageshhebrew=64327,e.qofhebrew=1511,e.qparen=9388,e.quarternote=9833,e.qubuts=1467,e.qubuts18=1467,e.qubuts25=1467,e.qubuts31=1467,e.qubutshebrew=1467,e.qubutsnarrowhebrew=1467,e.qubutsquarterhebrew=1467,e.qubutswidehebrew=1467,e.question=63,e.questionarabic=1567,e.questionarmenian=1374,e.questiondown=191,e.questiondownsmall=63423,e.questiongreek=894,e.questionmonospace=65311,e.questionsmall=63295,e.quotedbl=34,e.quotedblbase=8222,e.quotedblleft=8220,e.quotedblmonospace=65282,e.quotedblprime=12318,e.quotedblprimereversed=12317,e.quotedblright=8221,e.quoteleft=8216,e.quoteleftreversed=8219,e.quotereversed=8219,e.quoteright=8217,e.quoterightn=329,e.quotesinglbase=8218,e.quotesingle=39,e.quotesinglemonospace=65287,e.r=114,e.raarmenian=1404,e.rabengali=2480,e.racute=341,e.radeva=2352,e.radical=8730,e.radicalex=63717,e.radoverssquare=13230,e.radoverssquaredsquare=13231,e.radsquare=13229,e.rafe=1471,e.rafehebrew=1471,e.ragujarati=2736,e.ragurmukhi=2608,e.rahiragana=12425,e.rakatakana=12521,e.rakatakanahalfwidth=65431,e.ralowerdiagonalbengali=2545,e.ramiddlediagonalbengali=2544,e.ramshorn=612,e.ratio=8758,e.rbopomofo=12566,e.rcaron=345,e.rcedilla=343,e.rcircle=9441,e.rcommaaccent=343,e.rdblgrave=529,e.rdotaccent=7769,e.rdotbelow=7771,e.rdotbelowmacron=7773,e.referencemark=8251,e.reflexsubset=8838,e.reflexsuperset=8839,e.registered=174,e.registersans=63720,e.registerserif=63194,e.reharabic=1585,e.reharmenian=1408,e.rehfinalarabic=65198,e.rehiragana=12428,e.rekatakana=12524;e.rekatakanahalfwidth=65434,e.resh=1512,e.reshdageshhebrew=64328,e.reshhebrew=1512,e.reversedtilde=8765,e.reviahebrew=1431,e.reviamugrashhebrew=1431,e.revlogicalnot=8976,e.rfishhook=638,e.rfishhookreversed=639,e.rhabengali=2525,e.rhadeva=2397,e.rho=961,e.rhook=637,e.rhookturned=635,e.rhookturnedsuperior=693,e.rhosymbolgreek=1009,e.rhotichookmod=734,e.rieulacirclekorean=12913,e.rieulaparenkorean=12817,e.rieulcirclekorean=12899,e.rieulhieuhkorean=12608,e.rieulkiyeokkorean=12602,e.rieulkiyeoksioskorean=12649,e.rieulkorean=12601,e.rieulmieumkorean=12603,e.rieulpansioskorean=12652,e.rieulparenkorean=12803,e.rieulphieuphkorean=12607,e.rieulpieupkorean=12604,e.rieulpieupsioskorean=12651,e.rieulsioskorean=12605,e.rieulthieuthkorean=12606,e.rieultikeutkorean=12650,e.rieulyeorinhieuhkorean=12653,e.rightangle=8735,e.righttackbelowcmb=793,e.righttriangle=8895,e.rihiragana=12426,e.rikatakana=12522,e.rikatakanahalfwidth=65432,e.ring=730,e.ringbelowcmb=805,e.ringcmb=778,e.ringhalfleft=703,e.ringhalfleftarmenian=1369,e.ringhalfleftbelowcmb=796,e.ringhalfleftcentered=723,e.ringhalfright=702,e.ringhalfrightbelowcmb=825,e.ringhalfrightcentered=722,e.rinvertedbreve=531,e.rittorusquare=13137,e.rlinebelow=7775,e.rlongleg=636,e.rlonglegturned=634,e.rmonospace=65362,e.rohiragana=12429,e.rokatakana=12525,e.rokatakanahalfwidth=65435,e.roruathai=3619,e.rparen=9389,e.rrabengali=2524,e.rradeva=2353,e.rragurmukhi=2652,e.rreharabic=1681,e.rrehfinalarabic=64397,e.rrvocalicbengali=2528,e.rrvocalicdeva=2400,e.rrvocalicgujarati=2784,e.rrvocalicvowelsignbengali=2500,e.rrvocalicvowelsigndeva=2372,e.rrvocalicvowelsigngujarati=2756,e.rsuperior=63217,e.rtblock=9616,e.rturned=633,e.rturnedsuperior=692,e.ruhiragana=12427,e.rukatakana=12523,e.rukatakanahalfwidth=65433,e.rupeemarkbengali=2546,e.rupeesignbengali=2547,e.rupiah=63197,e.ruthai=3620,e.rvocalicbengali=2443,e.rvocalicdeva=2315,e.rvocalicgujarati=2699,e.rvocalicvowelsignbengali=2499,e.rvocalicvowelsigndeva=2371,e.rvocalicvowelsigngujarati=2755,e.s=115,e.sabengali=2488,e.sacute=347,e.sacutedotaccent=7781,e.sadarabic=1589,e.sadeva=2360,e.sadfinalarabic=65210,e.sadinitialarabic=65211,e.sadmedialarabic=65212,e.sagujarati=2744,e.sagurmukhi=2616,e.sahiragana=12373,e.sakatakana=12469,e.sakatakanahalfwidth=65403,e.sallallahoualayhewasallamarabic=65018,e.samekh=1505,e.samekhdagesh=64321,e.samekhdageshhebrew=64321,e.samekhhebrew=1505,e.saraaathai=3634,e.saraaethai=3649,e.saraaimaimalaithai=3652,e.saraaimaimuanthai=3651,e.saraamthai=3635,e.saraathai=3632,e.saraethai=3648,e.saraiileftthai=63622,e.saraiithai=3637,e.saraileftthai=63621,e.saraithai=3636,e.saraothai=3650,e.saraueeleftthai=63624,e.saraueethai=3639,e.saraueleftthai=63623,e.sarauethai=3638,e.sarauthai=3640,e.sarauuthai=3641,e.sbopomofo=12569,e.scaron=353,e.scarondotaccent=7783,e.scedilla=351,e.schwa=601,e.schwacyrillic=1241,e.schwadieresiscyrillic=1243,e.schwahook=602,e.scircle=9442,e.scircumflex=349,e.scommaaccent=537,e.sdotaccent=7777,e.sdotbelow=7779,e.sdotbelowdotaccent=7785,e.seagullbelowcmb=828,e.second=8243,e.secondtonechinese=714,e.section=167,e.seenarabic=1587,e.seenfinalarabic=65202,e.seeninitialarabic=65203,e.seenmedialarabic=65204,e.segol=1462,e.segol13=1462,e.segol1f=1462,e.segol2c=1462,e.segolhebrew=1462,e.segolnarrowhebrew=1462,e.segolquarterhebrew=1462,e.segoltahebrew=1426,e.segolwidehebrew=1462,e.seharmenian=1405,e.sehiragana=12379,e.sekatakana=12475,e.sekatakanahalfwidth=65406,e.semicolon=59,e.semicolonarabic=1563,e.semicolonmonospace=65307,e.semicolonsmall=65108,e.semivoicedmarkkana=12444,e.semivoicedmarkkanahalfwidth=65439,e.sentisquare=13090,e.sentosquare=13091,e.seven=55,e.sevenarabic=1639,e.sevenbengali=2541,e.sevencircle=9318,e.sevencircleinversesansserif=10128,e.sevendeva=2413,e.seveneighths=8542,e.sevengujarati=2797,e.sevengurmukhi=2669,e.sevenhackarabic=1639,e.sevenhangzhou=12327,e.sevenideographicparen=12838,e.seveninferior=8327,e.sevenmonospace=65303,e.sevenoldstyle=63287,e.sevenparen=9338,e.sevenperiod=9358,e.sevenpersian=1783,e.sevenroman=8566,e.sevensuperior=8311,e.seventeencircle=9328,e.seventeenparen=9348,e.seventeenperiod=9368,e.seventhai=3671,e.sfthyphen=173,e.shaarmenian=1399,e.shabengali=2486,e.shacyrillic=1096,e.shaddaarabic=1617,e.shaddadammaarabic=64609,e.shaddadammatanarabic=64606,e.shaddafathaarabic=64608,e.shaddakasraarabic=64610,e.shaddakasratanarabic=64607,e.shade=9618,e.shadedark=9619,e.shadelight=9617,e.shademedium=9618,e.shadeva=2358,e.shagujarati=2742,e.shagurmukhi=2614,e.shalshelethebrew=1427,e.shbopomofo=12565,e.shchacyrillic=1097,e.sheenarabic=1588,e.sheenfinalarabic=65206,e.sheeninitialarabic=65207,e.sheenmedialarabic=65208,e.sheicoptic=995,e.sheqel=8362,e.sheqelhebrew=8362,e.sheva=1456,e.sheva115=1456,e.sheva15=1456,e.sheva22=1456,e.sheva2e=1456,e.shevahebrew=1456,e.shevanarrowhebrew=1456,e.shevaquarterhebrew=1456,e.shevawidehebrew=1456,e.shhacyrillic=1211,e.shimacoptic=1005,e.shin=1513,e.shindagesh=64329,e.shindageshhebrew=64329,e.shindageshshindot=64300,e.shindageshshindothebrew=64300,e.shindageshsindot=64301,e.shindageshsindothebrew=64301,e.shindothebrew=1473,e.shinhebrew=1513,e.shinshindot=64298,e.shinshindothebrew=64298,e.shinsindot=64299,e.shinsindothebrew=64299,e.shook=642,e.sigma=963,e.sigma1=962,e.sigmafinal=962,e.sigmalunatesymbolgreek=1010,e.sihiragana=12375,e.sikatakana=12471,e.sikatakanahalfwidth=65404,e.siluqhebrew=1469,e.siluqlefthebrew=1469,e.similar=8764,e.sindothebrew=1474,e.siosacirclekorean=12916,e.siosaparenkorean=12820,e.sioscieuckorean=12670,e.sioscirclekorean=12902,e.sioskiyeokkorean=12666,e.sioskorean=12613,e.siosnieunkorean=12667,e.siosparenkorean=12806,e.siospieupkorean=12669,e.siostikeutkorean=12668,e.six=54,e.sixarabic=1638,e.sixbengali=2540,e.sixcircle=9317,e.sixcircleinversesansserif=10127,e.sixdeva=2412,e.sixgujarati=2796,e.sixgurmukhi=2668,e.sixhackarabic=1638,e.sixhangzhou=12326,e.sixideographicparen=12837,e.sixinferior=8326,e.sixmonospace=65302,e.sixoldstyle=63286,e.sixparen=9337,e.sixperiod=9357,e.sixpersian=1782,e.sixroman=8565,e.sixsuperior=8310,e.sixteencircle=9327,e.sixteencurrencydenominatorbengali=2553,e.sixteenparen=9347,e.sixteenperiod=9367,e.sixthai=3670,e.slash=47,e.slashmonospace=65295,e.slong=383,e.slongdotaccent=7835,e.smileface=9786,e.smonospace=65363,e.sofpasuqhebrew=1475,e.softhyphen=173,e.softsigncyrillic=1100,e.sohiragana=12381,e.sokatakana=12477,e.sokatakanahalfwidth=65407,e.soliduslongoverlaycmb=824,e.solidusshortoverlaycmb=823,e.sorusithai=3625,e.sosalathai=3624,e.sosothai=3595,e.sosuathai=3626,e.space=32,e.spacehackarabic=32,e.spade=9824,e.spadesuitblack=9824,e.spadesuitwhite=9828,e.sparen=9390,e.squarebelowcmb=827,e.squarecc=13252,e.squarecm=13213,e.squarediagonalcrosshatchfill=9641,e.squarehorizontalfill=9636,e.squarekg=13199,e.squarekm=13214,e.squarekmcapital=13262,e.squareln=13265,e.squarelog=13266,e.squaremg=13198,e.squaremil=13269,e.squaremm=13212,e.squaremsquared=13217,e.squareorthogonalcrosshatchfill=9638,e.squareupperlefttolowerrightfill=9639,e.squareupperrighttolowerleftfill=9640,e.squareverticalfill=9637,e.squarewhitewithsmallblack=9635,e.srsquare=13275,e.ssabengali=2487,e.ssadeva=2359,e.ssagujarati=2743,e.ssangcieuckorean=12617,e.ssanghieuhkorean=12677,e.ssangieungkorean=12672,e.ssangkiyeokkorean=12594,e.ssangnieunkorean=12645,e.ssangpieupkorean=12611,e.ssangsioskorean=12614,e.ssangtikeutkorean=12600,e.ssuperior=63218,e.sterling=163,e.sterlingmonospace=65505,e.strokelongoverlaycmb=822,e.strokeshortoverlaycmb=821,e.subset=8834,e.subsetnotequal=8842,e.subsetorequal=8838,e.succeeds=8827,e.suchthat=8715,e.suhiragana=12377,e.sukatakana=12473,e.sukatakanahalfwidth=65405,e.sukunarabic=1618,e.summation=8721,e.sun=9788,e.superset=8835,e.supersetnotequal=8843,e.supersetorequal=8839,e.svsquare=13276,e.syouwaerasquare=13180,e.t=116,e.tabengali=2468,e.tackdown=8868,e.tackleft=8867,e.tadeva=2340,e.tagujarati=2724,e.tagurmukhi=2596,e.taharabic=1591,e.tahfinalarabic=65218,e.tahinitialarabic=65219,e.tahiragana=12383,e.tahmedialarabic=65220,e.taisyouerasquare=13181,e.takatakana=12479,e.takatakanahalfwidth=65408,e.tatweelarabic=1600,e.tau=964,e.tav=1514,e.tavdages=64330,e.tavdagesh=64330,e.tavdageshhebrew=64330,e.tavhebrew=1514,e.tbar=359,e.tbopomofo=12554,e.tcaron=357,e.tccurl=680,e.tcedilla=355,e.tcheharabic=1670,e.tchehfinalarabic=64379,e.tchehinitialarabic=64380,e.tchehmedialarabic=64381,e.tcircle=9443,e.tcircumflexbelow=7793,e.tcommaaccent=355,e.tdieresis=7831,e.tdotaccent=7787,e.tdotbelow=7789,e.tecyrillic=1090,e.tedescendercyrillic=1197,e.teharabic=1578,e.tehfinalarabic=65174,e.tehhahinitialarabic=64674,e.tehhahisolatedarabic=64524,e.tehinitialarabic=65175,e.tehiragana=12390,e.tehjeeminitialarabic=64673,e.tehjeemisolatedarabic=64523,e.tehmarbutaarabic=1577,e.tehmarbutafinalarabic=65172,e.tehmedialarabic=65176,e.tehmeeminitialarabic=64676,e.tehmeemisolatedarabic=64526,e.tehnoonfinalarabic=64627,e.tekatakana=12486,e.tekatakanahalfwidth=65411,e.telephone=8481,e.telephoneblack=9742,e.telishagedolahebrew=1440,e.telishaqetanahebrew=1449,e.tencircle=9321,e.tenideographicparen=12841,e.tenparen=9341,e.tenperiod=9361,e.tenroman=8569,e.tesh=679,e.tet=1496,e.tetdagesh=64312,e.tetdageshhebrew=64312,e.tethebrew=1496,e.tetsecyrillic=1205,e.tevirhebrew=1435,e.tevirlefthebrew=1435,e.thabengali=2469,e.thadeva=2341,e.thagujarati=2725,e.thagurmukhi=2597,e.thalarabic=1584,e.thalfinalarabic=65196,e.thanthakhatlowleftthai=63640,e.thanthakhatlowrightthai=63639,e.thanthakhatthai=3660,e.thanthakhatupperleftthai=63638,e.theharabic=1579,e.thehfinalarabic=65178,e.thehinitialarabic=65179,e.thehmedialarabic=65180,e.thereexists=8707,e.therefore=8756,e.theta=952,e.theta1=977,e.thetasymbolgreek=977,e.thieuthacirclekorean=12921,e.thieuthaparenkorean=12825,e.thieuthcirclekorean=12907,e.thieuthkorean=12620,e.thieuthparenkorean=12811,e.thirteencircle=9324,e.thirteenparen=9344,e.thirteenperiod=9364,e.thonangmonthothai=3601,e.thook=429,e.thophuthaothai=3602,e.thorn=254,e.thothahanthai=3607,e.thothanthai=3600,e.thothongthai=3608,e.thothungthai=3606,e.thousandcyrillic=1154,e.thousandsseparatorarabic=1644,e.thousandsseparatorpersian=1644,e.three=51,e.threearabic=1635,e.threebengali=2537,e.threecircle=9314,e.threecircleinversesansserif=10124,e.threedeva=2409,e.threeeighths=8540,e.threegujarati=2793,e.threegurmukhi=2665,e.threehackarabic=1635,e.threehangzhou=12323,e.threeideographicparen=12834,e.threeinferior=8323,e.threemonospace=65299,e.threenumeratorbengali=2550,e.threeoldstyle=63283,e.threeparen=9334,e.threeperiod=9354,e.threepersian=1779,e.threequarters=190,e.threequartersemdash=63198,e.threeroman=8562,e.threesuperior=179,e.threethai=3667,e.thzsquare=13204,e.tihiragana=12385,e.tikatakana=12481,e.tikatakanahalfwidth=65409,e.tikeutacirclekorean=12912,e.tikeutaparenkorean=12816,e.tikeutcirclekorean=12898,e.tikeutkorean=12599,e.tikeutparenkorean=12802,e.tilde=732,e.tildebelowcmb=816,e.tildecmb=771,e.tildecomb=771,e.tildedoublecmb=864,e.tildeoperator=8764,e.tildeoverlaycmb=820,e.tildeverticalcmb=830,e.timescircle=8855,e.tipehahebrew=1430,e.tipehalefthebrew=1430,e.tippigurmukhi=2672,e.titlocyrilliccmb=1155,e.tiwnarmenian=1407,e.tlinebelow=7791,e.tmonospace=65364,e.toarmenian=1385,e.tohiragana=12392,e.tokatakana=12488,e.tokatakanahalfwidth=65412,e.tonebarextrahighmod=741,e.tonebarextralowmod=745,e.tonebarhighmod=742,e.tonebarlowmod=744,e.tonebarmidmod=743,e.tonefive=445,e.tonesix=389,e.tonetwo=424,e.tonos=900,e.tonsquare=13095,e.topatakthai=3599,e.tortoiseshellbracketleft=12308,e.tortoiseshellbracketleftsmall=65117,e.tortoiseshellbracketleftvertical=65081,e.tortoiseshellbracketright=12309,e.tortoiseshellbracketrightsmall=65118,e.tortoiseshellbracketrightvertical=65082,e.totaothai=3605,e.tpalatalhook=427,e.tparen=9391,e.trademark=8482,e.trademarksans=63722,e.trademarkserif=63195,e.tretroflexhook=648,e.triagdn=9660,e.triaglf=9668,e.triagrt=9658,e.triagup=9650,e.ts=678,e.tsadi=1510,e.tsadidagesh=64326,e.tsadidageshhebrew=64326,e.tsadihebrew=1510,e.tsecyrillic=1094,e.tsere=1461,e.tsere12=1461,e.tsere1e=1461,e.tsere2b=1461,e.tserehebrew=1461,e.tserenarrowhebrew=1461,e.tserequarterhebrew=1461,e.tserewidehebrew=1461,e.tshecyrillic=1115,e.tsuperior=63219,e.ttabengali=2463,e.ttadeva=2335,e.ttagujarati=2719,e.ttagurmukhi=2591,e.tteharabic=1657,e.ttehfinalarabic=64359,e.ttehinitialarabic=64360,e.ttehmedialarabic=64361,e.tthabengali=2464,e.tthadeva=2336,e.tthagujarati=2720,e.tthagurmukhi=2592,e.tturned=647,e.tuhiragana=12388,e.tukatakana=12484,e.tukatakanahalfwidth=65410,e.tusmallhiragana=12387,e.tusmallkatakana=12483,e.tusmallkatakanahalfwidth=65391,e.twelvecircle=9323,e.twelveparen=9343,e.twelveperiod=9363,e.twelveroman=8571,e.twentycircle=9331,e.twentyhangzhou=21316,e.twentyparen=9351,e.twentyperiod=9371,e.two=50,e.twoarabic=1634,e.twobengali=2536,e.twocircle=9313,e.twocircleinversesansserif=10123,e.twodeva=2408,e.twodotenleader=8229,e.twodotleader=8229,e.twodotleadervertical=65072,e.twogujarati=2792,e.twogurmukhi=2664,e.twohackarabic=1634,e.twohangzhou=12322,e.twoideographicparen=12833,e.twoinferior=8322,e.twomonospace=65298,e.twonumeratorbengali=2549,e.twooldstyle=63282,e.twoparen=9333,e.twoperiod=9353,e.twopersian=1778,e.tworoman=8561,e.twostroke=443,e.twosuperior=178,e.twothai=3666,e.twothirds=8532,e.u=117,e.uacute=250,e.ubar=649,e.ubengali=2441,e.ubopomofo=12584,e.ubreve=365,e.ucaron=468,e.ucircle=9444,e.ucircumflex=251,e.ucircumflexbelow=7799,e.ucyrillic=1091,e.udattadeva=2385,e.udblacute=369,e.udblgrave=533,e.udeva=2313,e.udieresis=252,e.udieresisacute=472,e.udieresisbelow=7795,e.udieresiscaron=474,e.udieresiscyrillic=1265,e.udieresisgrave=476,e.udieresismacron=470,e.udotbelow=7909,e.ugrave=249,e.ugujarati=2697,e.ugurmukhi=2569,e.uhiragana=12358,e.uhookabove=7911,e.uhorn=432,e.uhornacute=7913,e.uhorndotbelow=7921,e.uhorngrave=7915,e.uhornhookabove=7917,e.uhorntilde=7919,e.uhungarumlaut=369,e.uhungarumlautcyrillic=1267,e.uinvertedbreve=535,e.ukatakana=12454,e.ukatakanahalfwidth=65395,e.ukcyrillic=1145,e.ukorean=12636,e.umacron=363,e.umacroncyrillic=1263,e.umacrondieresis=7803,e.umatragurmukhi=2625,e.umonospace=65365,e.underscore=95,e.underscoredbl=8215,e.underscoremonospace=65343,e.underscorevertical=65075,e.underscorewavy=65103,e.union=8746,e.universal=8704,e.uogonek=371,e.uparen=9392,e.upblock=9600,e.upperdothebrew=1476,e.upsilon=965,e.upsilondieresis=971,e.upsilondieresistonos=944,e.upsilonlatin=650,e.upsilontonos=973,e.uptackbelowcmb=797,e.uptackmod=724,e.uragurmukhi=2675,e.uring=367,e.ushortcyrillic=1118,e.usmallhiragana=12357,e.usmallkatakana=12453,e.usmallkatakanahalfwidth=65385,e.ustraightcyrillic=1199,e.ustraightstrokecyrillic=1201,e.utilde=361,e.utildeacute=7801,e.utildebelow=7797,e.uubengali=2442,e.uudeva=2314,e.uugujarati=2698,e.uugurmukhi=2570,e.uumatragurmukhi=2626,e.uuvowelsignbengali=2498,e.uuvowelsigndeva=2370,e.uuvowelsigngujarati=2754,e.uvowelsignbengali=2497,e.uvowelsigndeva=2369,e.uvowelsigngujarati=2753,e.v=118,e.vadeva=2357,e.vagujarati=2741,e.vagurmukhi=2613,e.vakatakana=12535,e.vav=1493,e.vavdagesh=64309,e.vavdagesh65=64309,e.vavdageshhebrew=64309,e.vavhebrew=1493,e.vavholam=64331,e.vavholamhebrew=64331,e.vavvavhebrew=1520,e.vavyodhebrew=1521,e.vcircle=9445,e.vdotbelow=7807,e.vecyrillic=1074,e.veharabic=1700,e.vehfinalarabic=64363,e.vehinitialarabic=64364,e.vehmedialarabic=64365,e.vekatakana=12537,e.venus=9792,e.verticalbar=124,e.verticallineabovecmb=781,e.verticallinebelowcmb=809,e.verticallinelowmod=716,e.verticallinemod=712,e.vewarmenian=1406,e.vhook=651,e.vikatakana=12536,e.viramabengali=2509,e.viramadeva=2381,e.viramagujarati=2765,e.visargabengali=2435,e.visargadeva=2307,e.visargagujarati=2691,e.vmonospace=65366,e.voarmenian=1400,e.voicediterationhiragana=12446,e.voicediterationkatakana=12542,e.voicedmarkkana=12443,e.voicedmarkkanahalfwidth=65438,e.vokatakana=12538,e.vparen=9393,e.vtilde=7805,e.vturned=652,e.vuhiragana=12436,e.vukatakana=12532,e.w=119,e.wacute=7811,e.waekorean=12633,e.wahiragana=12431,e.wakatakana=12527,e.wakatakanahalfwidth=65436,e.wakorean=12632,e.wasmallhiragana=12430,e.wasmallkatakana=12526,e.wattosquare=13143,e.wavedash=12316,e.wavyunderscorevertical=65076,e.wawarabic=1608,e.wawfinalarabic=65262,e.wawhamzaabovearabic=1572,e.wawhamzaabovefinalarabic=65158,e.wbsquare=13277,e.wcircle=9446,e.wcircumflex=373,e.wdieresis=7813,e.wdotaccent=7815,e.wdotbelow=7817,e.wehiragana=12433,e.weierstrass=8472,e.wekatakana=12529,e.wekorean=12638,e.weokorean=12637,e.wgrave=7809,e.whitebullet=9702,e.whitecircle=9675,e.whitecircleinverse=9689,e.whitecornerbracketleft=12302,e.whitecornerbracketleftvertical=65091,e.whitecornerbracketright=12303,e.whitecornerbracketrightvertical=65092,e.whitediamond=9671,e.whitediamondcontainingblacksmalldiamond=9672,e.whitedownpointingsmalltriangle=9663;e.whitedownpointingtriangle=9661,e.whiteleftpointingsmalltriangle=9667,e.whiteleftpointingtriangle=9665,e.whitelenticularbracketleft=12310,e.whitelenticularbracketright=12311,e.whiterightpointingsmalltriangle=9657,e.whiterightpointingtriangle=9655,e.whitesmallsquare=9643,e.whitesmilingface=9786,e.whitesquare=9633,e.whitestar=9734,e.whitetelephone=9743,e.whitetortoiseshellbracketleft=12312,e.whitetortoiseshellbracketright=12313,e.whiteuppointingsmalltriangle=9653,e.whiteuppointingtriangle=9651,e.wihiragana=12432,e.wikatakana=12528,e.wikorean=12639,e.wmonospace=65367,e.wohiragana=12434,e.wokatakana=12530,e.wokatakanahalfwidth=65382,e.won=8361,e.wonmonospace=65510,e.wowaenthai=3623,e.wparen=9394,e.wring=7832,e.wsuperior=695,e.wturned=653,e.wynn=447,e.x=120,e.xabovecmb=829,e.xbopomofo=12562,e.xcircle=9447,e.xdieresis=7821,e.xdotaccent=7819,e.xeharmenian=1389,e.xi=958,e.xmonospace=65368,e.xparen=9395,e.xsuperior=739,e.y=121,e.yaadosquare=13134,e.yabengali=2479,e.yacute=253,e.yadeva=2351,e.yaekorean=12626,e.yagujarati=2735,e.yagurmukhi=2607,e.yahiragana=12420,e.yakatakana=12516,e.yakatakanahalfwidth=65428,e.yakorean=12625,e.yamakkanthai=3662,e.yasmallhiragana=12419,e.yasmallkatakana=12515,e.yasmallkatakanahalfwidth=65388,e.yatcyrillic=1123,e.ycircle=9448,e.ycircumflex=375,e.ydieresis=255,e.ydotaccent=7823,e.ydotbelow=7925,e.yeharabic=1610,e.yehbarreearabic=1746,e.yehbarreefinalarabic=64431,e.yehfinalarabic=65266,e.yehhamzaabovearabic=1574,e.yehhamzaabovefinalarabic=65162,e.yehhamzaaboveinitialarabic=65163,e.yehhamzaabovemedialarabic=65164,e.yehinitialarabic=65267,e.yehmedialarabic=65268,e.yehmeeminitialarabic=64733,e.yehmeemisolatedarabic=64600,e.yehnoonfinalarabic=64660,e.yehthreedotsbelowarabic=1745,e.yekorean=12630,e.yen=165,e.yenmonospace=65509,e.yeokorean=12629,e.yeorinhieuhkorean=12678,e.yerahbenyomohebrew=1450,e.yerahbenyomolefthebrew=1450,e.yericyrillic=1099,e.yerudieresiscyrillic=1273,e.yesieungkorean=12673,e.yesieungpansioskorean=12675,e.yesieungsioskorean=12674,e.yetivhebrew=1434,e.ygrave=7923,e.yhook=436,e.yhookabove=7927,e.yiarmenian=1397,e.yicyrillic=1111,e.yikorean=12642,e.yinyang=9775,e.yiwnarmenian=1410,e.ymonospace=65369,e.yod=1497,e.yoddagesh=64313,e.yoddageshhebrew=64313,e.yodhebrew=1497,e.yodyodhebrew=1522,e.yodyodpatahhebrew=64287,e.yohiragana=12424,e.yoikorean=12681,e.yokatakana=12520,e.yokatakanahalfwidth=65430,e.yokorean=12635,e.yosmallhiragana=12423,e.yosmallkatakana=12519,e.yosmallkatakanahalfwidth=65390,e.yotgreek=1011,e.yoyaekorean=12680,e.yoyakorean=12679,e.yoyakthai=3618,e.yoyingthai=3597,e.yparen=9396,e.ypogegrammeni=890,e.ypogegrammenigreekcmb=837,e.yr=422,e.yring=7833,e.ysuperior=696,e.ytilde=7929,e.yturned=654,e.yuhiragana=12422,e.yuikorean=12684,e.yukatakana=12518,e.yukatakanahalfwidth=65429,e.yukorean=12640,e.yusbigcyrillic=1131,e.yusbigiotifiedcyrillic=1133,e.yuslittlecyrillic=1127,e.yuslittleiotifiedcyrillic=1129,e.yusmallhiragana=12421,e.yusmallkatakana=12517,e.yusmallkatakanahalfwidth=65389,e.yuyekorean=12683,e.yuyeokorean=12682,e.yyabengali=2527,e.yyadeva=2399,e.z=122,e.zaarmenian=1382,e.zacute=378,e.zadeva=2395,e.zagurmukhi=2651,e.zaharabic=1592,e.zahfinalarabic=65222,e.zahinitialarabic=65223,e.zahiragana=12374,e.zahmedialarabic=65224,e.zainarabic=1586,e.zainfinalarabic=65200,e.zakatakana=12470,e.zaqefgadolhebrew=1429,e.zaqefqatanhebrew=1428,e.zarqahebrew=1432,e.zayin=1494,e.zayindagesh=64310,e.zayindageshhebrew=64310,e.zayinhebrew=1494,e.zbopomofo=12567,e.zcaron=382,e.zcircle=9449,e.zcircumflex=7825,e.zcurl=657,e.zdot=380,e.zdotaccent=380,e.zdotbelow=7827,e.zecyrillic=1079,e.zedescendercyrillic=1177,e.zedieresiscyrillic=1247,e.zehiragana=12380,e.zekatakana=12476,e.zero=48,e.zeroarabic=1632,e.zerobengali=2534,e.zerodeva=2406,e.zerogujarati=2790,e.zerogurmukhi=2662,e.zerohackarabic=1632,e.zeroinferior=8320,e.zeromonospace=65296,e.zerooldstyle=63280,e.zeropersian=1776,e.zerosuperior=8304,e.zerothai=3664,e.zerowidthjoiner=65279,e.zerowidthnonjoiner=8204,e.zerowidthspace=8203,e.zeta=950,e.zhbopomofo=12563,e.zhearmenian=1386,e.zhebrevecyrillic=1218,e.zhecyrillic=1078,e.zhedescendercyrillic=1175,e.zhedieresiscyrillic=1245,e.zihiragana=12376,e.zikatakana=12472,e.zinorhebrew=1454,e.zlinebelow=7829,e.zmonospace=65370,e.zohiragana=12382,e.zokatakana=12478,e.zparen=9397,e.zretroflexhook=656,e.zstroke=438,e.zuhiragana=12378,e.zukatakana=12474,e[".notdef"]=0,e.angbracketleftbig=9001,e.angbracketleftBig=9001,e.angbracketleftbigg=9001,e.angbracketleftBigg=9001,e.angbracketrightBig=9002,e.angbracketrightbig=9002,e.angbracketrightBigg=9002,e.angbracketrightbigg=9002,e.arrowhookleft=8618,e.arrowhookright=8617,e.arrowlefttophalf=8636,e.arrowleftbothalf=8637,e.arrownortheast=8599,e.arrownorthwest=8598,e.arrowrighttophalf=8640,e.arrowrightbothalf=8641,e.arrowsoutheast=8600,e.arrowsouthwest=8601,e.backslashbig=8726,e.backslashBig=8726,e.backslashBigg=8726,e.backslashbigg=8726,e.bardbl=8214,e.bracehtipdownleft=65079,e.bracehtipdownright=65079,e.bracehtipupleft=65080,e.bracehtipupright=65080,e.braceleftBig=123,e.braceleftbig=123,e.braceleftbigg=123,e.braceleftBigg=123,e.bracerightBig=125,e.bracerightbig=125,e.bracerightbigg=125,e.bracerightBigg=125,e.bracketleftbig=91,e.bracketleftBig=91,e.bracketleftbigg=91,e.bracketleftBigg=91,e.bracketrightBig=93,e.bracketrightbig=93,e.bracketrightbigg=93,e.bracketrightBigg=93,e.ceilingleftbig=8968,e.ceilingleftBig=8968,e.ceilingleftBigg=8968,e.ceilingleftbigg=8968,e.ceilingrightbig=8969,e.ceilingrightBig=8969,e.ceilingrightbigg=8969,e.ceilingrightBigg=8969,e.circledotdisplay=8857,e.circledottext=8857,e.circlemultiplydisplay=8855,e.circlemultiplytext=8855,e.circleplusdisplay=8853,e.circleplustext=8853,e.contintegraldisplay=8750,e.contintegraltext=8750,e.coproductdisplay=8720,e.coproducttext=8720,e.floorleftBig=8970,e.floorleftbig=8970,e.floorleftbigg=8970,e.floorleftBigg=8970,e.floorrightbig=8971,e.floorrightBig=8971,e.floorrightBigg=8971,e.floorrightbigg=8971,e.hatwide=770,e.hatwider=770,e.hatwidest=770,e.intercal=7488,e.integraldisplay=8747,e.integraltext=8747,e.intersectiondisplay=8898,e.intersectiontext=8898,e.logicalanddisplay=8743,e.logicalandtext=8743,e.logicalordisplay=8744,e.logicalortext=8744,e.parenleftBig=40,e.parenleftbig=40,e.parenleftBigg=40,e.parenleftbigg=40,e.parenrightBig=41,e.parenrightbig=41,e.parenrightBigg=41,e.parenrightbigg=41,e.prime=8242,e.productdisplay=8719,e.producttext=8719,e.radicalbig=8730,e.radicalBig=8730,e.radicalBigg=8730,e.radicalbigg=8730,e.radicalbt=8730,e.radicaltp=8730,e.radicalvertex=8730,e.slashbig=47,e.slashBig=47,e.slashBigg=47,e.slashbigg=47,e.summationdisplay=8721,e.summationtext=8721,e.tildewide=732,e.tildewider=732,e.tildewidest=732,e.uniondisplay=8899,e.unionmultidisplay=8846,e.unionmultitext=8846,e.unionsqdisplay=8852,e.unionsqtext=8852,e.uniontext=8899,e.vextenddouble=8741,e.vextendsingle=8739}));t.getGlyphsUnicode=r;const i=(0,n.getLookupTableFactory)((function(e){e.space=32,e.a1=9985,e.a2=9986,e.a202=9987,e.a3=9988,e.a4=9742,e.a5=9990,e.a119=9991,e.a118=9992,e.a117=9993,e.a11=9755,e.a12=9758,e.a13=9996,e.a14=9997,e.a15=9998,e.a16=9999,e.a105=1e4,e.a17=10001,e.a18=10002,e.a19=10003,e.a20=10004,e.a21=10005,e.a22=10006,e.a23=10007,e.a24=10008,e.a25=10009,e.a26=10010,e.a27=10011,e.a28=10012,e.a6=10013,e.a7=10014,e.a8=10015,e.a9=10016,e.a10=10017,e.a29=10018,e.a30=10019,e.a31=10020,e.a32=10021,e.a33=10022,e.a34=10023,e.a35=9733,e.a36=10025,e.a37=10026,e.a38=10027,e.a39=10028,e.a40=10029,e.a41=10030,e.a42=10031,e.a43=10032,e.a44=10033,e.a45=10034,e.a46=10035,e.a47=10036,e.a48=10037,e.a49=10038,e.a50=10039,e.a51=10040,e.a52=10041,e.a53=10042,e.a54=10043,e.a55=10044,e.a56=10045,e.a57=10046,e.a58=10047,e.a59=10048,e.a60=10049,e.a61=10050,e.a62=10051,e.a63=10052,e.a64=10053,e.a65=10054,e.a66=10055,e.a67=10056,e.a68=10057,e.a69=10058,e.a70=10059,e.a71=9679,e.a72=10061,e.a73=9632,e.a74=10063,e.a203=10064,e.a75=10065,e.a204=10066,e.a76=9650,e.a77=9660,e.a78=9670,e.a79=10070,e.a81=9687,e.a82=10072,e.a83=10073,e.a84=10074,e.a97=10075,e.a98=10076,e.a99=10077,e.a100=10078,e.a101=10081,e.a102=10082,e.a103=10083,e.a104=10084,e.a106=10085,e.a107=10086,e.a108=10087,e.a112=9827,e.a111=9830,e.a110=9829,e.a109=9824,e.a120=9312,e.a121=9313,e.a122=9314,e.a123=9315,e.a124=9316,e.a125=9317,e.a126=9318,e.a127=9319,e.a128=9320,e.a129=9321,e.a130=10102,e.a131=10103,e.a132=10104,e.a133=10105,e.a134=10106,e.a135=10107,e.a136=10108,e.a137=10109,e.a138=10110,e.a139=10111,e.a140=10112,e.a141=10113,e.a142=10114,e.a143=10115,e.a144=10116,e.a145=10117,e.a146=10118,e.a147=10119,e.a148=10120,e.a149=10121,e.a150=10122,e.a151=10123,e.a152=10124,e.a153=10125,e.a154=10126,e.a155=10127,e.a156=10128,e.a157=10129,e.a158=10130,e.a159=10131,e.a160=10132,e.a161=8594,e.a163=8596,e.a164=8597,e.a196=10136,e.a165=10137,e.a192=10138,e.a166=10139,e.a167=10140,e.a168=10141,e.a169=10142,e.a170=10143,e.a171=10144,e.a172=10145,e.a173=10146,e.a162=10147,e.a174=10148,e.a175=10149,e.a176=10150,e.a177=10151,e.a178=10152,e.a179=10153,e.a193=10154,e.a180=10155,e.a199=10156,e.a181=10157,e.a200=10158,e.a182=10159,e.a201=10161,e.a183=10162,e.a184=10163,e.a197=10164,e.a185=10165,e.a194=10166,e.a198=10167,e.a186=10168,e.a195=10169,e.a187=10170,e.a188=10171,e.a189=10172,e.a190=10173,e.a191=10174,e.a89=10088,e.a90=10089,e.a93=10090,e.a94=10091,e.a91=10092,e.a92=10093,e.a205=10094,e.a85=10095,e.a206=10096,e.a86=10097,e.a87=10098,e.a88=10099,e.a95=10100,e.a96=10101,e[".notdef"]=0}));t.getDingbatsGlyphsUnicode=i},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.clearUnicodeCaches=function(){s.clear()},t.getCharUnicodeCategory=function(e){const t=s.get(e);if(t)return t;const a=e.match(i),n={isWhitespace:!!a?.[1],isZeroWidthDiacritic:!!a?.[2],isInvisibleFormatMark:!!a?.[3]};return s.set(e,n),n},t.getUnicodeForGlyph=function(e,t){let a=t[e];if(void 0!==a)return a;if(!e)return-1;if("u"===e[0]){const t=e.length;let n;if(7===t&&"n"===e[1]&&"i"===e[2])n=e.substring(3);else{if(!(t>=5&&t<=7))return-1;n=e.substring(1)}if(n===n.toUpperCase()&&(a=parseInt(n,16),a>=0))return a}return-1},t.getUnicodeRangeFor=function(e,t=-1){if(-1!==t){const a=r[t];for(let n=0,r=a.length;n<r;n+=2)if(e>=a[n]&&e<=a[n+1])return t}for(let t=0,a=r.length;t<a;t++){const a=r[t];for(let n=0,r=a.length;n<r;n+=2)if(e>=a[n]&&e<=a[n+1])return t}return-1},t.mapSpecialUnicodeValues=function(e){if(e>=65520&&e<=65535)return 0;if(e>=62976&&e<=63743)return n()[e]||e;if(173===e)return 45;return e};const n=(0,a(3).getLookupTableFactory)((function(e){e[63721]=169,e[63193]=169,e[63720]=174,e[63194]=174,e[63722]=8482,e[63195]=8482,e[63729]=9127,e[63730]=9128,e[63731]=9129,e[63740]=9131,e[63741]=9132,e[63742]=9133,e[63726]=9121,e[63727]=9122,e[63728]=9123,e[63737]=9124,e[63738]=9125,e[63739]=9126,e[63723]=9115,e[63724]=9116,e[63725]=9117,e[63734]=9118,e[63735]=9119,e[63736]=9120}));const r=[[0,127],[128,255],[256,383],[384,591],[592,687,7424,7551,7552,7615],[688,767,42752,42783],[768,879,7616,7679],[880,1023],[11392,11519],[1024,1279,1280,1327,11744,11775,42560,42655],[1328,1423],[1424,1535],[42240,42559],[1536,1791,1872,1919],[1984,2047],[2304,2431],[2432,2559],[2560,2687],[2688,2815],[2816,2943],[2944,3071],[3072,3199],[3200,3327],[3328,3455],[3584,3711],[3712,3839],[4256,4351,11520,11567],[6912,7039],[4352,4607],[7680,7935,11360,11391,42784,43007],[7936,8191],[8192,8303,11776,11903],[8304,8351],[8352,8399],[8400,8447],[8448,8527],[8528,8591],[8592,8703,10224,10239,10496,10623,11008,11263],[8704,8959,10752,11007,10176,10223,10624,10751],[8960,9215],[9216,9279],[9280,9311],[9312,9471],[9472,9599],[9600,9631],[9632,9727],[9728,9983],[9984,10175],[12288,12351],[12352,12447],[12448,12543,12784,12799],[12544,12591,12704,12735],[12592,12687],[43072,43135],[12800,13055],[13056,13311],[44032,55215],[55296,57343],[67840,67871],[19968,40959,11904,12031,12032,12255,12272,12287,13312,19903,131072,173791,12688,12703],[57344,63743],[12736,12783,63744,64255,194560,195103],[64256,64335],[64336,65023],[65056,65071],[65040,65055],[65104,65135],[65136,65279],[65280,65519],[65520,65535],[3840,4095],[1792,1871],[1920,1983],[3456,3583],[4096,4255],[4608,4991,4992,5023,11648,11743],[5024,5119],[5120,5759],[5760,5791],[5792,5887],[6016,6143],[6144,6319],[10240,10495],[40960,42127],[5888,5919,5920,5951,5952,5983,5984,6015],[66304,66351],[66352,66383],[66560,66639],[118784,119039,119040,119295,119296,119375],[119808,120831],[1044480,1048573],[65024,65039,917760,917999],[917504,917631],[6400,6479],[6480,6527],[6528,6623],[6656,6687],[11264,11359],[11568,11647],[19904,19967],[43008,43055],[65536,65663,65664,65791,65792,65855],[65856,65935],[66432,66463],[66464,66527],[66640,66687],[66688,66735],[67584,67647],[68096,68191],[119552,119647],[73728,74751,74752,74879],[119648,119679],[7040,7103],[7168,7247],[7248,7295],[43136,43231],[43264,43311],[43312,43359],[43520,43615],[65936,65999],[66e3,66047],[66208,66271,66176,66207,67872,67903],[127024,127135,126976,127023]];const i=new RegExp("^(\\s)|(\\p{Mn})|(\\p{Cf})$","u"),s=new Map},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getSerifFonts=t.getNonStdFontMap=t.getGlyphMapForStandardFonts=t.getFontNameToFileMap=void 0,t.getStandardFontName=function(e){const t=(0,r.normalizeFontName)(e);return i()[t]},t.getSymbolsFonts=t.getSupplementalGlyphMapForCalibri=t.getSupplementalGlyphMapForArialBlack=t.getStdFontMap=void 0,t.isKnownFontName=function(e){const t=(0,r.normalizeFontName)(e);return!!(i()[t]||o()[t]||c()[t]||l()[t])};var n=a(3),r=a(38);const i=(0,n.getLookupTableFactory)((function(e){e["Times-Roman"]="Times-Roman",e.Helvetica="Helvetica",e.Courier="Courier",e.Symbol="Symbol",e["Times-Bold"]="Times-Bold",e["Helvetica-Bold"]="Helvetica-Bold",e["Courier-Bold"]="Courier-Bold",e.ZapfDingbats="ZapfDingbats",e["Times-Italic"]="Times-Italic",e["Helvetica-Oblique"]="Helvetica-Oblique",e["Courier-Oblique"]="Courier-Oblique",e["Times-BoldItalic"]="Times-BoldItalic",e["Helvetica-BoldOblique"]="Helvetica-BoldOblique",e["Courier-BoldOblique"]="Courier-BoldOblique",e.ArialNarrow="Helvetica",e["ArialNarrow-Bold"]="Helvetica-Bold",e["ArialNarrow-BoldItalic"]="Helvetica-BoldOblique",e["ArialNarrow-Italic"]="Helvetica-Oblique",e.ArialBlack="Helvetica",e["ArialBlack-Bold"]="Helvetica-Bold",e["ArialBlack-BoldItalic"]="Helvetica-BoldOblique",e["ArialBlack-Italic"]="Helvetica-Oblique",e["Arial-Black"]="Helvetica",e["Arial-Black-Bold"]="Helvetica-Bold",e["Arial-Black-BoldItalic"]="Helvetica-BoldOblique",e["Arial-Black-Italic"]="Helvetica-Oblique",e.Arial="Helvetica",e["Arial-Bold"]="Helvetica-Bold",e["Arial-BoldItalic"]="Helvetica-BoldOblique",e["Arial-Italic"]="Helvetica-Oblique",e.ArialMT="Helvetica",e["Arial-BoldItalicMT"]="Helvetica-BoldOblique",e["Arial-BoldMT"]="Helvetica-Bold",e["Arial-ItalicMT"]="Helvetica-Oblique",e["Arial-BoldItalicMT-BoldItalic"]="Helvetica-BoldOblique",e["Arial-BoldMT-Bold"]="Helvetica-Bold",e["Arial-ItalicMT-Italic"]="Helvetica-Oblique",e.ArialUnicodeMS="Helvetica",e["ArialUnicodeMS-Bold"]="Helvetica-Bold",e["ArialUnicodeMS-BoldItalic"]="Helvetica-BoldOblique",e["ArialUnicodeMS-Italic"]="Helvetica-Oblique",e["Courier-BoldItalic"]="Courier-BoldOblique",e["Courier-Italic"]="Courier-Oblique",e.CourierNew="Courier",e["CourierNew-Bold"]="Courier-Bold",e["CourierNew-BoldItalic"]="Courier-BoldOblique",e["CourierNew-Italic"]="Courier-Oblique",e["CourierNewPS-BoldItalicMT"]="Courier-BoldOblique",e["CourierNewPS-BoldMT"]="Courier-Bold",e["CourierNewPS-ItalicMT"]="Courier-Oblique",e.CourierNewPSMT="Courier",e["Helvetica-BoldItalic"]="Helvetica-BoldOblique",e["Helvetica-Italic"]="Helvetica-Oblique",e["Symbol-Bold"]="Symbol",e["Symbol-BoldItalic"]="Symbol",e["Symbol-Italic"]="Symbol",e.TimesNewRoman="Times-Roman",e["TimesNewRoman-Bold"]="Times-Bold",e["TimesNewRoman-BoldItalic"]="Times-BoldItalic",e["TimesNewRoman-Italic"]="Times-Italic",e.TimesNewRomanPS="Times-Roman",e["TimesNewRomanPS-Bold"]="Times-Bold",e["TimesNewRomanPS-BoldItalic"]="Times-BoldItalic",e["TimesNewRomanPS-BoldItalicMT"]="Times-BoldItalic",e["TimesNewRomanPS-BoldMT"]="Times-Bold",e["TimesNewRomanPS-Italic"]="Times-Italic",e["TimesNewRomanPS-ItalicMT"]="Times-Italic",e.TimesNewRomanPSMT="Times-Roman",e["TimesNewRomanPSMT-Bold"]="Times-Bold",e["TimesNewRomanPSMT-BoldItalic"]="Times-BoldItalic",e["TimesNewRomanPSMT-Italic"]="Times-Italic"}));t.getStdFontMap=i;const s=(0,n.getLookupTableFactory)((function(e){e.Courier="FoxitFixed.pfb",e["Courier-Bold"]="FoxitFixedBold.pfb",e["Courier-BoldOblique"]="FoxitFixedBoldItalic.pfb",e["Courier-Oblique"]="FoxitFixedItalic.pfb",e.Helvetica="LiberationSans-Regular.ttf",e["Helvetica-Bold"]="LiberationSans-Bold.ttf",e["Helvetica-BoldOblique"]="LiberationSans-BoldItalic.ttf",e["Helvetica-Oblique"]="LiberationSans-Italic.ttf",e["Times-Roman"]="FoxitSerif.pfb",e["Times-Bold"]="FoxitSerifBold.pfb",e["Times-BoldItalic"]="FoxitSerifBoldItalic.pfb",e["Times-Italic"]="FoxitSerifItalic.pfb",e.Symbol="FoxitSymbol.pfb",e.ZapfDingbats="FoxitDingbats.pfb",e["LiberationSans-Regular"]="LiberationSans-Regular.ttf",e["LiberationSans-Bold"]="LiberationSans-Bold.ttf",e["LiberationSans-Italic"]="LiberationSans-Italic.ttf",e["LiberationSans-BoldItalic"]="LiberationSans-BoldItalic.ttf"}));t.getFontNameToFileMap=s;const o=(0,n.getLookupTableFactory)((function(e){e.Calibri="Helvetica",e["Calibri-Bold"]="Helvetica-Bold",e["Calibri-BoldItalic"]="Helvetica-BoldOblique",e["Calibri-Italic"]="Helvetica-Oblique",e.CenturyGothic="Helvetica",e["CenturyGothic-Bold"]="Helvetica-Bold",e["CenturyGothic-BoldItalic"]="Helvetica-BoldOblique",e["CenturyGothic-Italic"]="Helvetica-Oblique",e.ComicSansMS="Comic Sans MS",e["ComicSansMS-Bold"]="Comic Sans MS-Bold",e["ComicSansMS-BoldItalic"]="Comic Sans MS-BoldItalic",e["ComicSansMS-Italic"]="Comic Sans MS-Italic",e.Impact="Helvetica",e["ItcSymbol-Bold"]="Helvetica-Bold",e["ItcSymbol-BoldItalic"]="Helvetica-BoldOblique",e["ItcSymbol-Book"]="Helvetica",e["ItcSymbol-BookItalic"]="Helvetica-Oblique",e["ItcSymbol-Medium"]="Helvetica",e["ItcSymbol-MediumItalic"]="Helvetica-Oblique",e.LucidaConsole="Courier",e["LucidaConsole-Bold"]="Courier-Bold",e["LucidaConsole-BoldItalic"]="Courier-BoldOblique",e["LucidaConsole-Italic"]="Courier-Oblique",e["LucidaSans-Demi"]="Helvetica-Bold",e["MS-Gothic"]="MS Gothic",e["MS-Gothic-Bold"]="MS Gothic-Bold",e["MS-Gothic-BoldItalic"]="MS Gothic-BoldItalic",e["MS-Gothic-Italic"]="MS Gothic-Italic",e["MS-Mincho"]="MS Mincho",e["MS-Mincho-Bold"]="MS Mincho-Bold",e["MS-Mincho-BoldItalic"]="MS Mincho-BoldItalic",e["MS-Mincho-Italic"]="MS Mincho-Italic",e["MS-PGothic"]="MS PGothic",e["MS-PGothic-Bold"]="MS PGothic-Bold",e["MS-PGothic-BoldItalic"]="MS PGothic-BoldItalic",e["MS-PGothic-Italic"]="MS PGothic-Italic",e["MS-PMincho"]="MS PMincho",e["MS-PMincho-Bold"]="MS PMincho-Bold",e["MS-PMincho-BoldItalic"]="MS PMincho-BoldItalic",e["MS-PMincho-Italic"]="MS PMincho-Italic",e.NuptialScript="Times-Italic",e.SegoeUISymbol="Helvetica"}));t.getNonStdFontMap=o;const c=(0,n.getLookupTableFactory)((function(e){e["Adobe Jenson"]=!0,e["Adobe Text"]=!0,e.Albertus=!0,e.Aldus=!0,e.Alexandria=!0,e.Algerian=!0,e["American Typewriter"]=!0,e.Antiqua=!0,e.Apex=!0,e.Arno=!0,e.Aster=!0,e.Aurora=!0,e.Baskerville=!0,e.Bell=!0,e.Bembo=!0,e["Bembo Schoolbook"]=!0,e.Benguiat=!0,e["Berkeley Old Style"]=!0,e["Bernhard Modern"]=!0,e["Berthold City"]=!0,e.Bodoni=!0,e["Bauer Bodoni"]=!0,e["Book Antiqua"]=!0,e.Bookman=!0,e["Bordeaux Roman"]=!0,e["Californian FB"]=!0,e.Calisto=!0,e.Calvert=!0,e.Capitals=!0,e.Cambria=!0,e.Cartier=!0,e.Caslon=!0,e.Catull=!0,e.Centaur=!0,e["Century Old Style"]=!0,e["Century Schoolbook"]=!0,e.Chaparral=!0,e["Charis SIL"]=!0,e.Cheltenham=!0,e["Cholla Slab"]=!0,e.Clarendon=!0,e.Clearface=!0,e.Cochin=!0,e.Colonna=!0,e["Computer Modern"]=!0,e["Concrete Roman"]=!0,e.Constantia=!0,e["Cooper Black"]=!0,e.Corona=!0,e.Ecotype=!0,e.Egyptienne=!0,e.Elephant=!0,e.Excelsior=!0,e.Fairfield=!0,e["FF Scala"]=!0,e.Folkard=!0,e.Footlight=!0,e.FreeSerif=!0,e["Friz Quadrata"]=!0,e.Garamond=!0,e.Gentium=!0,e.Georgia=!0,e.Gloucester=!0,e["Goudy Old Style"]=!0,e["Goudy Schoolbook"]=!0,e["Goudy Pro Font"]=!0,e.Granjon=!0,e["Guardian Egyptian"]=!0,e.Heather=!0,e.Hercules=!0,e["High Tower Text"]=!0,e.Hiroshige=!0,e["Hoefler Text"]=!0,e["Humana Serif"]=!0,e.Imprint=!0,e["Ionic No. 5"]=!0,e.Janson=!0,e.Joanna=!0,e.Korinna=!0,e.Lexicon=!0,e.LiberationSerif=!0,e["Liberation Serif"]=!0,e["Linux Libertine"]=!0,e.Literaturnaya=!0,e.Lucida=!0,e["Lucida Bright"]=!0,e.Melior=!0,e.Memphis=!0,e.Miller=!0,e.Minion=!0,e.Modern=!0,e["Mona Lisa"]=!0,e["Mrs Eaves"]=!0,e["MS Serif"]=!0,e["Museo Slab"]=!0,e["New York"]=!0,e["Nimbus Roman"]=!0,e["NPS Rawlinson Roadway"]=!0,e.NuptialScript=!0,e.Palatino=!0,e.Perpetua=!0,e.Plantin=!0,e["Plantin Schoolbook"]=!0,e.Playbill=!0,e["Poor Richard"]=!0,e["Rawlinson Roadway"]=!0,e.Renault=!0,e.Requiem=!0,e.Rockwell=!0,e.Roman=!0,e["Rotis Serif"]=!0,e.Sabon=!0,e.Scala=!0,e.Seagull=!0,e.Sistina=!0,e.Souvenir=!0,e.STIX=!0,e["Stone Informal"]=!0,e["Stone Serif"]=!0,e.Sylfaen=!0,e.Times=!0,e.Trajan=!0,e["Trinité"]=!0,e["Trump Mediaeval"]=!0,e.Utopia=!0,e["Vale Type"]=!0,e["Bitstream Vera"]=!0,e["Vera Serif"]=!0,e.Versailles=!0,e.Wanted=!0,e.Weiss=!0,e["Wide Latin"]=!0,e.Windsor=!0,e.XITS=!0}));t.getSerifFonts=c;const l=(0,n.getLookupTableFactory)((function(e){e.Dingbats=!0,e.Symbol=!0,e.ZapfDingbats=!0,e.Wingdings=!0,e["Wingdings-Bold"]=!0,e["Wingdings-Regular"]=!0}));t.getSymbolsFonts=l;const h=(0,n.getLookupTableFactory)((function(e){e[2]=10,e[3]=32,e[4]=33,e[5]=34,e[6]=35,e[7]=36,e[8]=37,e[9]=38,e[10]=39,e[11]=40,e[12]=41,e[13]=42,e[14]=43,e[15]=44,e[16]=45,e[17]=46,e[18]=47,e[19]=48,e[20]=49,e[21]=50,e[22]=51,e[23]=52,e[24]=53,e[25]=54,e[26]=55,e[27]=56,e[28]=57,e[29]=58,e[30]=894,e[31]=60,e[32]=61,e[33]=62,e[34]=63,e[35]=64,e[36]=65,e[37]=66,e[38]=67,e[39]=68,e[40]=69,e[41]=70,e[42]=71,e[43]=72,e[44]=73,e[45]=74,e[46]=75,e[47]=76,e[48]=77,e[49]=78,e[50]=79,e[51]=80,e[52]=81,e[53]=82,e[54]=83,e[55]=84,e[56]=85,e[57]=86,e[58]=87,e[59]=88,e[60]=89,e[61]=90,e[62]=91,e[63]=92,e[64]=93,e[65]=94,e[66]=95,e[67]=96,e[68]=97,e[69]=98,e[70]=99,e[71]=100,e[72]=101,e[73]=102,e[74]=103,e[75]=104,e[76]=105,e[77]=106,e[78]=107,e[79]=108,e[80]=109,e[81]=110,e[82]=111,e[83]=112,e[84]=113,e[85]=114,e[86]=115,e[87]=116,e[88]=117,e[89]=118,e[90]=119,e[91]=120,e[92]=121,e[93]=122,e[94]=123,e[95]=124,e[96]=125,e[97]=126,e[98]=196,e[99]=197,e[100]=199,e[101]=201,e[102]=209,e[103]=214,e[104]=220,e[105]=225,e[106]=224,e[107]=226,e[108]=228,e[109]=227,e[110]=229,e[111]=231,e[112]=233,e[113]=232,e[114]=234,e[115]=235,e[116]=237,e[117]=236,e[118]=238,e[119]=239,e[120]=241,e[121]=243,e[122]=242,e[123]=244,e[124]=246,e[125]=245,e[126]=250,e[127]=249,e[128]=251,e[129]=252,e[130]=8224,e[131]=176,e[132]=162,e[133]=163,e[134]=167,e[135]=8226,e[136]=182,e[137]=223,e[138]=174,e[139]=169,e[140]=8482,e[141]=180,e[142]=168,e[143]=8800,e[144]=198,e[145]=216,e[146]=8734,e[147]=177,e[148]=8804,e[149]=8805,e[150]=165,e[151]=181,e[152]=8706,e[153]=8721,e[154]=8719,e[156]=8747,e[157]=170,e[158]=186,e[159]=8486,e[160]=230,e[161]=248,e[162]=191,e[163]=161,e[164]=172,e[165]=8730,e[166]=402,e[167]=8776,e[168]=8710,e[169]=171,e[170]=187,e[171]=8230,e[179]=8220,e[180]=8221,e[181]=8216,e[182]=8217,e[200]=193,e[203]=205,e[207]=211,e[210]=218,e[223]=711,e[224]=321,e[225]=322,e[226]=352,e[227]=353,e[228]=381,e[229]=382,e[233]=221,e[234]=253,e[252]=263,e[253]=268,e[254]=269,e[258]=258,e[260]=260,e[261]=261,e[265]=280,e[266]=281,e[267]=282,e[268]=283,e[269]=313,e[275]=323,e[276]=324,e[278]=328,e[283]=344,e[284]=345,e[285]=346,e[286]=347,e[292]=367,e[295]=377,e[296]=378,e[298]=380,e[305]=963,e[306]=964,e[307]=966,e[308]=8215,e[309]=8252,e[310]=8319,e[311]=8359,e[312]=8592,e[313]=8593,e[337]=9552,e[493]=1039,e[494]=1040,e[672]=1488,e[673]=1489,e[674]=1490,e[675]=1491,e[676]=1492,e[677]=1493,e[678]=1494,e[679]=1495,e[680]=1496,e[681]=1497,e[682]=1498,e[683]=1499,e[684]=1500,e[685]=1501,e[686]=1502,e[687]=1503,e[688]=1504,e[689]=1505,e[690]=1506,e[691]=1507,e[692]=1508,e[693]=1509,e[694]=1510,e[695]=1511,e[696]=1512,e[697]=1513,e[698]=1514,e[705]=1524,e[706]=8362,e[710]=64288,e[711]=64298,e[759]=1617,e[761]=1776,e[763]=1778,e[775]=1652,e[777]=1764,e[778]=1780,e[779]=1781,e[780]=1782,e[782]=771,e[783]=64726,e[786]=8363,e[788]=8532,e[790]=768,e[791]=769,e[792]=768,e[795]=803,e[797]=64336,e[798]=64337,e[799]=64342,e[800]=64343,e[801]=64344,e[802]=64345,e[803]=64362,e[804]=64363,e[805]=64364,e[2424]=7821,e[2425]=7822,e[2426]=7823,e[2427]=7824,e[2428]=7825,e[2429]=7826,e[2430]=7827,e[2433]=7682,e[2678]=8045,e[2679]=8046,e[2830]=1552,e[2838]=686,e[2840]=751,e[2842]=753,e[2843]=754,e[2844]=755,e[2846]=757,e[2856]=767,e[2857]=848,e[2858]=849,e[2862]=853,e[2863]=854,e[2864]=855,e[2865]=861,e[2866]=862,e[2906]=7460,e[2908]=7462,e[2909]=7463,e[2910]=7464,e[2912]=7466,e[2913]=7467,e[2914]=7468,e[2916]=7470,e[2917]=7471,e[2918]=7472,e[2920]=7474,e[2921]=7475,e[2922]=7476,e[2924]=7478,e[2925]=7479,e[2926]=7480,e[2928]=7482,e[2929]=7483,e[2930]=7484,e[2932]=7486,e[2933]=7487,e[2934]=7488,e[2936]=7490,e[2937]=7491,e[2938]=7492,e[2940]=7494,e[2941]=7495,e[2942]=7496,e[2944]=7498,e[2946]=7500,e[2948]=7502,e[2950]=7504,e[2951]=7505,e[2952]=7506,e[2954]=7508,e[2955]=7509,e[2956]=7510,e[2958]=7512,e[2959]=7513,e[2960]=7514,e[2962]=7516,e[2963]=7517,e[2964]=7518,e[2966]=7520,e[2967]=7521,e[2968]=7522,e[2970]=7524,e[2971]=7525,e[2972]=7526,e[2974]=7528,e[2975]=7529,e[2976]=7530,e[2978]=1537,e[2979]=1538,e[2980]=1539,e[2982]=1549,e[2983]=1551,e[2984]=1552,e[2986]=1554,e[2987]=1555,e[2988]=1556,e[2990]=1623,e[2991]=1624,e[2995]=1775,e[2999]=1791,e[3002]=64290,e[3003]=64291,e[3004]=64292,e[3006]=64294,e[3007]=64295,e[3008]=64296,e[3011]=1900,e[3014]=8223,e[3015]=8244,e[3017]=7532,e[3018]=7533,e[3019]=7534,e[3075]=7590,e[3076]=7591,e[3079]=7594,e[3080]=7595,e[3083]=7598,e[3084]=7599,e[3087]=7602,e[3088]=7603,e[3091]=7606,e[3092]=7607,e[3095]=7610,e[3096]=7611,e[3099]=7614,e[3100]=7615,e[3103]=7618,e[3104]=7619,e[3107]=8337,e[3108]=8338,e[3116]=1884,e[3119]=1885,e[3120]=1885,e[3123]=1886,e[3124]=1886,e[3127]=1887,e[3128]=1887,e[3131]=1888,e[3132]=1888,e[3135]=1889,e[3136]=1889,e[3139]=1890,e[3140]=1890,e[3143]=1891,e[3144]=1891,e[3147]=1892,e[3148]=1892,e[3153]=580,e[3154]=581,e[3157]=584,e[3158]=585,e[3161]=588,e[3162]=589,e[3165]=891,e[3166]=892,e[3169]=1274,e[3170]=1275,e[3173]=1278,e[3174]=1279,e[3181]=7622,e[3182]=7623,e[3282]=11799,e[3316]=578,e[3379]=42785,e[3393]=1159,e[3416]=8377}));t.getGlyphMapForStandardFonts=h;const u=(0,n.getLookupTableFactory)((function(e){e[227]=322,e[264]=261,e[291]=346}));t.getSupplementalGlyphMapForArialBlack=u;const d=(0,n.getLookupTableFactory)((function(e){e[1]=32,e[4]=65,e[5]=192,e[6]=193,e[9]=196,e[17]=66,e[18]=67,e[21]=268,e[24]=68,e[28]=69,e[29]=200,e[30]=201,e[32]=282,e[38]=70,e[39]=71,e[44]=72,e[47]=73,e[48]=204,e[49]=205,e[58]=74,e[60]=75,e[62]=76,e[68]=77,e[69]=78,e[75]=79,e[76]=210,e[80]=214,e[87]=80,e[89]=81,e[90]=82,e[92]=344,e[94]=83,e[97]=352,e[100]=84,e[104]=85,e[109]=220,e[115]=86,e[116]=87,e[121]=88,e[122]=89,e[124]=221,e[127]=90,e[129]=381,e[258]=97,e[259]=224,e[260]=225,e[263]=228,e[268]=261,e[271]=98,e[272]=99,e[273]=263,e[275]=269,e[282]=100,e[286]=101,e[287]=232,e[288]=233,e[290]=283,e[295]=281,e[296]=102,e[336]=103,e[346]=104,e[349]=105,e[350]=236,e[351]=237,e[361]=106,e[364]=107,e[367]=108,e[371]=322,e[373]=109,e[374]=110,e[381]=111,e[382]=242,e[383]=243,e[386]=246,e[393]=112,e[395]=113,e[396]=114,e[398]=345,e[400]=115,e[401]=347,e[403]=353,e[410]=116,e[437]=117,e[442]=252,e[448]=118,e[449]=119,e[454]=120,e[455]=121,e[457]=253,e[460]=122,e[462]=382,e[463]=380,e[853]=44,e[855]=58,e[856]=46,e[876]=47,e[878]=45,e[882]=45,e[894]=40,e[895]=41,e[896]=91,e[897]=93,e[923]=64,e[1004]=48,e[1005]=49,e[1006]=50,e[1007]=51,e[1008]=52,e[1009]=53,e[1010]=54,e[1011]=55,e[1012]=56,e[1013]=57,e[1081]=37,e[1085]=43,e[1086]=45}));t.getSupplementalGlyphMapForCalibri=d},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ToUnicodeMap=t.IdentityToUnicodeMap=void 0;var n=a(2);t.ToUnicodeMap=class{constructor(e=[]){this._map=e}get length(){return this._map.length}forEach(e){for(const t in this._map)e(t,this._map[t].charCodeAt(0))}has(e){return void 0!==this._map[e]}get(e){return this._map[e]}charCodeOf(e){const t=this._map;if(t.length<=65536)return t.indexOf(e);for(const a in t)if(t[a]===e)return 0|a;return-1}amend(e){for(const t in e)this._map[t]=e[t]}};t.IdentityToUnicodeMap=class{constructor(e,t){this.firstChar=e,this.lastChar=t}get length(){return this.lastChar+1-this.firstChar}forEach(e){for(let t=this.firstChar,a=this.lastChar;t<=a;t++)e(t,t)}has(e){return this.firstChar<=e&&e<=this.lastChar}get(e){if(this.firstChar<=e&&e<=this.lastChar)return String.fromCharCode(e)}charCodeOf(e){return Number.isInteger(e)&&e>=this.firstChar&&e<=this.lastChar?e:-1}amend(e){(0,n.unreachable)("Should not call amend()")}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CFFFont=void 0;var n=a(35),r=a(38),i=a(2);t.CFFFont=class{constructor(e,t){this.properties=t;const a=new n.CFFParser(e,t,r.SEAC_ANALYSIS_ENABLED);this.cff=a.parse(),this.cff.duplicateFirstGlyph();const s=new n.CFFCompiler(this.cff);this.seacs=this.cff.seacs;try{this.data=s.compile()}catch{(0,i.warn)("Failed to compile font "+t.loadedName),this.data=e}this._createBuiltInEncoding()}get numGlyphs(){return this.cff.charStrings.count}getCharset(){return this.cff.charset.charset}getGlyphMapping(){const e=this.cff,t=this.properties,{cidToGidMap:a,cMap:n}=t,i=e.charset.charset;let s,o;if(t.composite){let t,r;if(a?.length>0){t=Object.create(null);for(let e=0,n=a.length;e<n;e++){const n=a[e];void 0!==n&&(t[n]=e)}}if(s=Object.create(null),e.isCIDFont)for(o=0;o<i.length;o++){const e=i[o];r=n.charCodeOf(e),void 0!==t?.[r]&&(r=t[r]),s[r]=o}else for(o=0;o<e.charStrings.count;o++)r=n.charCodeOf(o),s[r]=o;return s}let c=e.encoding?e.encoding.encoding:null;return t.isInternalFont&&(c=t.defaultEncoding),s=(0,r.type1FontGlyphMapping)(t,c,i),s}hasGlyphId(e){return this.cff.hasGlyphId(e)}_createBuiltInEncoding(){const{charset:e,encoding:t}=this.cff;if(!e||!t)return;const a=e.charset,n=t.encoding,r=[];for(const e in n){const t=n[e];if(t>=0){const n=a[t];n&&(r[e]=n)}}r.length>0&&(this.properties.builtInEncoding=r)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.FontRendererFactory=void 0;var n=a(2),r=a(35),i=a(39),s=a(37),o=a(8);function c(e,t){return(e[t]<<24|e[t+1]<<16|e[t+2]<<8|e[t+3])>>>0}function l(e,t){return e[t]<<8|e[t+1]}function h(e,t){return(e[t]<<24|e[t+1]<<16)>>16}function u(e,t){return e[t]<<24>>24}function d(e,t){return h(e,t)/16384}function f(e){const t=e.length;let a=32768;return t<1240?a=107:t<33900&&(a=1131),a}function g(e,t,a){const r=1===l(e,t+2)?c(e,t+8):c(e,t+16),i=l(e,t+r);let s,o,h;if(4===i){l(e,t+r+2);const a=l(e,t+r+6)>>1;for(o=t+r+14,s=[],h=0;h<a;h++,o+=2)s[h]={end:l(e,o)};for(o+=2,h=0;h<a;h++,o+=2)s[h].start=l(e,o);for(h=0;h<a;h++,o+=2)s[h].idDelta=l(e,o);for(h=0;h<a;h++,o+=2){let t=l(e,o);if(0!==t){s[h].ids=[];for(let a=0,n=s[h].end-s[h].start+1;a<n;a++)s[h].ids[a]=l(e,o+t),t+=2}}return s}if(12===i){const a=c(e,t+r+12);for(o=t+r+16,s=[],h=0;h<a;h++)t=c(e,o),s.push({start:t,end:c(e,o+4),idDelta:c(e,o+8)-t}),o+=12;return s}throw new n.FormatError(`unsupported cmap: ${i}`)}function p(e,t,a,n){const i=new r.CFFParser(new o.Stream(e,t,a-t),{},n).parse();return{glyphs:i.charStrings.objects,subrs:i.topDict.privateDict?.subrsIndex?.objects,gsubrs:i.globalSubrIndex?.objects,isCFFCIDFont:i.isCIDFont,fdSelect:i.fdSelect,fdArray:i.fdArray}}function m(e,t){const a=t.codePointAt(0);let n=0,r=0,i=e.length-1;for(;r<i;){const t=r+i+1>>1;a<e[t].start?i=t-1:r=t}return e[r].start<=a&&a<=e[r].end&&(n=e[r].idDelta+(e[r].ids?e[r].ids[a-e[r].start]:a)&65535),{charCode:a,glyphId:n}}function b(e,t,a){function n(e,a){t.push({cmd:"moveTo",args:[e,a]})}function r(e,a){t.push({cmd:"lineTo",args:[e,a]})}function i(e,a,n,r){t.push({cmd:"quadraticCurveTo",args:[e,a,n,r]})}let s=0;const o=h(e,s);let c,f=0,g=0;if(s+=10,o<0)do{c=l(e,s);const n=l(e,s+2);let r,i;s+=4,1&c?(2&c?(r=h(e,s),i=h(e,s+2)):(r=l(e,s),i=l(e,s+2)),s+=4):2&c?(r=u(e,s++),i=u(e,s++)):(r=e[s++],i=e[s++]),2&c?(f=r,g=i):(f=0,g=0);let o=1,p=1,m=0,y=0;8&c?(o=p=d(e,s),s+=2):64&c?(o=d(e,s),p=d(e,s+2),s+=4):128&c&&(o=d(e,s),m=d(e,s+2),y=d(e,s+4),p=d(e,s+6),s+=8);const w=a.glyphs[n];w&&(t.push({cmd:"save"},{cmd:"transform",args:[o,m,y,p,f,g]}),b(w,t,a),t.push({cmd:"restore"}))}while(32&c);else{const t=[];let a,u;for(a=0;a<o;a++)t.push(l(e,s)),s+=2;s+=2+l(e,s);const d=t.at(-1)+1,p=[];for(;p.length<d;){c=e[s++];let t=1;for(8&c&&(t+=e[s++]);t-- >0;)p.push({flags:c})}for(a=0;a<d;a++){switch(18&p[a].flags){case 0:f+=h(e,s),s+=2;break;case 2:f-=e[s++];break;case 18:f+=e[s++]}p[a].x=f}for(a=0;a<d;a++){switch(36&p[a].flags){case 0:g+=h(e,s),s+=2;break;case 4:g-=e[s++];break;case 36:g+=e[s++]}p[a].y=g}let m=0;for(s=0;s<o;s++){const e=t[s],o=p.slice(m,e+1);if(1&o[0].flags)o.push(o[0]);else if(1&o.at(-1).flags)o.unshift(o.at(-1));else{const e={flags:1,x:(o[0].x+o.at(-1).x)/2,y:(o[0].y+o.at(-1).y)/2};o.unshift(e),o.push(e)}for(n(o[0].x,o[0].y),a=1,u=o.length;a<u;a++)1&o[a].flags?r(o[a].x,o[a].y):1&o[a+1].flags?(i(o[a].x,o[a].y,o[a+1].x,o[a+1].y),a++):i(o[a].x,o[a].y,(o[a].x+o[a+1].x)/2,(o[a].y+o[a+1].y)/2);m=e+1}}}function y(e,t,a,r){function i(e,a){t.push({cmd:"moveTo",args:[e,a]})}function o(e,a){t.push({cmd:"lineTo",args:[e,a]})}function c(e,a,n,r,i,s){t.push({cmd:"bezierCurveTo",args:[e,a,n,r,i,s]})}const l=[];let h=0,u=0,d=0;!function e(g){let p=0;for(;p<g.length;){let b,w,x,S,A,k,C,v,F,O=!1,I=g[p++];switch(I){case 1:case 3:case 18:case 23:d+=l.length>>1,O=!0;break;case 4:u+=l.pop(),i(h,u),O=!0;break;case 5:for(;l.length>0;)h+=l.shift(),u+=l.shift(),o(h,u);break;case 6:for(;l.length>0&&(h+=l.shift(),o(h,u),0!==l.length);)u+=l.shift(),o(h,u);break;case 7:for(;l.length>0&&(u+=l.shift(),o(h,u),0!==l.length);)h+=l.shift(),o(h,u);break;case 8:for(;l.length>0;)b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u);break;case 10:if(v=l.pop(),F=null,a.isCFFCIDFont){const e=a.fdSelect.getFDIndex(r);if(e>=0&&e<a.fdArray.length){const t=a.fdArray[e];let n;t.privateDict?.subrsIndex&&(n=t.privateDict.subrsIndex.objects),n&&(v+=f(n),F=n[v])}else(0,n.warn)("Invalid fd index for glyph index.")}else F=a.subrs[v+a.subrsBias];F&&e(F);break;case 11:return;case 12:switch(I=g[p++],I){case 34:b=h+l.shift(),w=b+l.shift(),A=u+l.shift(),h=w+l.shift(),c(b,u,w,A,h,A),b=h+l.shift(),w=b+l.shift(),h=w+l.shift(),c(b,A,w,u,h,u);break;case 35:b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u),b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u),l.pop();break;case 36:b=h+l.shift(),A=u+l.shift(),w=b+l.shift(),k=A+l.shift(),h=w+l.shift(),c(b,A,w,k,h,k),b=h+l.shift(),w=b+l.shift(),C=k+l.shift(),h=w+l.shift(),c(b,k,w,C,h,u);break;case 37:const e=h,t=u;b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u),b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w,u=S,Math.abs(h-e)>Math.abs(u-t)?h+=l.shift():u+=l.shift(),c(b,x,w,S,h,u);break;default:throw new n.FormatError(`unknown operator: 12 ${I}`)}break;case 14:if(l.length>=4){const e=l.pop(),n=l.pop();u=l.pop(),h=l.pop(),t.push({cmd:"save"},{cmd:"translate",args:[h,u]});let r=m(a.cmap,String.fromCharCode(a.glyphNameMap[s.StandardEncoding[e]]));y(a.glyphs[r.glyphId],t,a,r.glyphId),t.push({cmd:"restore"}),r=m(a.cmap,String.fromCharCode(a.glyphNameMap[s.StandardEncoding[n]])),y(a.glyphs[r.glyphId],t,a,r.glyphId)}return;case 19:case 20:d+=l.length>>1,p+=d+7>>3,O=!0;break;case 21:u+=l.pop(),h+=l.pop(),i(h,u),O=!0;break;case 22:h+=l.pop(),i(h,u),O=!0;break;case 24:for(;l.length>2;)b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u);h+=l.shift(),u+=l.shift(),o(h,u);break;case 25:for(;l.length>6;)h+=l.shift(),u+=l.shift(),o(h,u);b=h+l.shift(),x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+l.shift(),c(b,x,w,S,h,u);break;case 26:for(l.length%2&&(h+=l.shift());l.length>0;)b=h,x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w,u=S+l.shift(),c(b,x,w,S,h,u);break;case 27:for(l.length%2&&(u+=l.shift());l.length>0;)b=h+l.shift(),x=u,w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S,c(b,x,w,S,h,u);break;case 28:l.push((g[p]<<24|g[p+1]<<16)>>16),p+=2;break;case 29:v=l.pop()+a.gsubrsBias,F=a.gsubrs[v],F&&e(F);break;case 30:for(;l.length>0&&(b=h,x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+(1===l.length?l.shift():0),c(b,x,w,S,h,u),0!==l.length);)b=h+l.shift(),x=u,w=b+l.shift(),S=x+l.shift(),u=S+l.shift(),h=w+(1===l.length?l.shift():0),c(b,x,w,S,h,u);break;case 31:for(;l.length>0&&(b=h+l.shift(),x=u,w=b+l.shift(),S=x+l.shift(),u=S+l.shift(),h=w+(1===l.length?l.shift():0),c(b,x,w,S,h,u),0!==l.length);)b=h,x=u+l.shift(),w=b+l.shift(),S=x+l.shift(),h=w+l.shift(),u=S+(1===l.length?l.shift():0),c(b,x,w,S,h,u);break;default:if(I<32)throw new n.FormatError(`unknown operator: ${I}`);I<247?l.push(I-139):I<251?l.push(256*(I-247)+g[p++]+108):I<255?l.push(256*-(I-251)-g[p++]-108):(l.push((g[p]<<24|g[p+1]<<16|g[p+2]<<8|g[p+3])/65536),p+=4)}O&&(l.length=0)}}(e)}const w=[];class x{constructor(e){this.constructor===x&&(0,n.unreachable)("Cannot initialize CompiledFont."),this.fontMatrix=e,this.compiledGlyphs=Object.create(null),this.compiledCharCodeToGlyphId=Object.create(null)}getPathJs(e){const{charCode:t,glyphId:a}=m(this.cmap,e);let n=this.compiledGlyphs[a];if(!n)try{n=this.compileGlyph(this.glyphs[a],a),this.compiledGlyphs[a]=n}catch(e){throw this.compiledGlyphs[a]=w,void 0===this.compiledCharCodeToGlyphId[t]&&(this.compiledCharCodeToGlyphId[t]=a),e}return void 0===this.compiledCharCodeToGlyphId[t]&&(this.compiledCharCodeToGlyphId[t]=a),n}compileGlyph(e,t){if(!e||0===e.length||14===e[0])return w;let a=this.fontMatrix;if(this.isCFFCIDFont){const e=this.fdSelect.getFDIndex(t);if(e>=0&&e<this.fdArray.length){a=this.fdArray[e].getByName("FontMatrix")||n.FONT_IDENTITY_MATRIX}else(0,n.warn)("Invalid fd index for glyph index.")}const r=[{cmd:"save"},{cmd:"transform",args:a.slice()},{cmd:"scale",args:["size","-size"]}];return this.compileGlyphImpl(e,r,t),r.push({cmd:"restore"}),r}compileGlyphImpl(){(0,n.unreachable)("Children classes should implement this.")}hasBuiltPath(e){const{charCode:t,glyphId:a}=m(this.cmap,e);return void 0!==this.compiledGlyphs[a]&&void 0!==this.compiledCharCodeToGlyphId[t]}}class S extends x{constructor(e,t,a){super(a||[488e-6,0,0,488e-6,0,0]),this.glyphs=e,this.cmap=t}compileGlyphImpl(e,t){b(e,t,this)}}class A extends x{constructor(e,t,a,n){super(a||[.001,0,0,.001,0,0]),this.glyphs=e.glyphs,this.gsubrs=e.gsubrs||[],this.subrs=e.subrs||[],this.cmap=t,this.glyphNameMap=n||(0,i.getGlyphsUnicode)(),this.gsubrsBias=f(this.gsubrs),this.subrsBias=f(this.subrs),this.isCFFCIDFont=e.isCFFCIDFont,this.fdSelect=e.fdSelect,this.fdArray=e.fdArray}compileGlyphImpl(e,t,a){y(e,t,this,a)}}t.FontRendererFactory=class{static create(e,t){const a=new Uint8Array(e.data);let r,i,s,o,h,u;const d=l(a,4);for(let e=0,f=12;e<d;e++,f+=16){const e=(0,n.bytesToString)(a.subarray(f,f+4)),d=c(a,f+8),m=c(a,f+12);switch(e){case"cmap":r=g(a,d);break;case"glyf":i=a.subarray(d,d+m);break;case"loca":s=a.subarray(d,d+m);break;case"head":u=l(a,d+18),h=l(a,d+50);break;case"CFF ":o=p(a,d,d+m,t)}}if(i){const t=u?[1/u,0,0,1/u,0,0]:e.fontMatrix;return new S(function(e,t,a){let n,r;a?(n=4,r=c):(n=2,r=(e,t)=>2*l(e,t));const i=[];let s=r(t,0);for(let a=n;a<t.length;a+=n){const n=r(t,a);i.push(e.subarray(s,n)),s=n}return i}(i,s,h),r,t)}return new A(o,r,e.fontMatrix,e.glyphNameMap)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getMetrics=t.getFontBasicMetrics=void 0;var n=a(3);const r=(0,n.getLookupTableFactory)((function(e){e.Courier=600,e["Courier-Bold"]=600,e["Courier-BoldOblique"]=600,e["Courier-Oblique"]=600,e.Helvetica=(0,n.getLookupTableFactory)((function(e){e.space=278,e.exclam=278,e.quotedbl=355,e.numbersign=556,e.dollar=556,e.percent=889,e.ampersand=667,e.quoteright=222,e.parenleft=333,e.parenright=333,e.asterisk=389,e.plus=584,e.comma=278,e.hyphen=333,e.period=278,e.slash=278,e.zero=556,e.one=556,e.two=556,e.three=556,e.four=556,e.five=556,e.six=556,e.seven=556,e.eight=556,e.nine=556,e.colon=278,e.semicolon=278,e.less=584,e.equal=584,e.greater=584,e.question=556,e.at=1015,e.A=667,e.B=667,e.C=722,e.D=722,e.E=667,e.F=611,e.G=778,e.H=722,e.I=278,e.J=500,e.K=667,e.L=556,e.M=833,e.N=722,e.O=778,e.P=667,e.Q=778,e.R=722,e.S=667,e.T=611,e.U=722,e.V=667,e.W=944,e.X=667,e.Y=667,e.Z=611,e.bracketleft=278,e.backslash=278,e.bracketright=278,e.asciicircum=469,e.underscore=556,e.quoteleft=222,e.a=556,e.b=556,e.c=500,e.d=556,e.e=556,e.f=278,e.g=556,e.h=556,e.i=222,e.j=222,e.k=500,e.l=222,e.m=833,e.n=556,e.o=556,e.p=556,e.q=556,e.r=333,e.s=500,e.t=278,e.u=556,e.v=500,e.w=722,e.x=500,e.y=500,e.z=500,e.braceleft=334,e.bar=260,e.braceright=334,e.asciitilde=584,e.exclamdown=333,e.cent=556,e.sterling=556,e.fraction=167,e.yen=556,e.florin=556,e.section=556,e.currency=556,e.quotesingle=191,e.quotedblleft=333,e.guillemotleft=556,e.guilsinglleft=333,e.guilsinglright=333,e.fi=500,e.fl=500,e.endash=556,e.dagger=556,e.daggerdbl=556,e.periodcentered=278,e.paragraph=537,e.bullet=350,e.quotesinglbase=222,e.quotedblbase=333,e.quotedblright=333,e.guillemotright=556,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=611,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=1e3,e.ordfeminine=370,e.Lslash=556,e.Oslash=778,e.OE=1e3,e.ordmasculine=365,e.ae=889,e.dotlessi=278,e.lslash=222,e.oslash=611,e.oe=944,e.germandbls=611,e.Idieresis=278,e.eacute=556,e.abreve=556,e.uhungarumlaut=556,e.ecaron=556,e.Ydieresis=667,e.divide=584,e.Yacute=667,e.Acircumflex=667,e.aacute=556,e.Ucircumflex=722,e.yacute=500,e.scommaaccent=500,e.ecircumflex=556,e.Uring=722,e.Udieresis=722,e.aogonek=556,e.Uacute=722,e.uogonek=556,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=737,e.Emacron=667,e.ccaron=500,e.aring=556,e.Ncommaaccent=722,e.lacute=222,e.agrave=556,e.Tcommaaccent=611,e.Cacute=722,e.atilde=556,e.Edotaccent=667,e.scaron=500,e.scedilla=500,e.iacute=278,e.lozenge=471,e.Rcaron=722,e.Gcommaaccent=778,e.ucircumflex=556,e.acircumflex=556,e.Amacron=667,e.rcaron=333,e.ccedilla=500,e.Zdotaccent=611,e.Thorn=667,e.Omacron=778,e.Racute=722,e.Sacute=667,e.dcaron=643,e.Umacron=722,e.uring=556,e.threesuperior=333,e.Ograve=778,e.Agrave=667,e.Abreve=667,e.multiply=584,e.uacute=556,e.Tcaron=611,e.partialdiff=476,e.ydieresis=500,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=556,e.edieresis=556,e.cacute=500,e.nacute=556,e.umacron=556,e.Ncaron=722,e.Iacute=278,e.plusminus=584,e.brokenbar=260,e.registered=737,e.Gbreve=778,e.Idotaccent=278,e.summation=600,e.Egrave=667,e.racute=333,e.omacron=556,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=722,e.lcommaaccent=222,e.tcaron=317,e.eogonek=556,e.Uogonek=722,e.Aacute=667,e.Adieresis=667,e.egrave=556,e.zacute=500,e.iogonek=222,e.Oacute=778,e.oacute=556,e.amacron=556,e.sacute=500,e.idieresis=278,e.Ocircumflex=778,e.Ugrave=722,e.Delta=612,e.thorn=556,e.twosuperior=333,e.Odieresis=778,e.mu=556,e.igrave=278,e.ohungarumlaut=556,e.Eogonek=667,e.dcroat=556,e.threequarters=834,e.Scedilla=667,e.lcaron=299,e.Kcommaaccent=667,e.Lacute=556,e.trademark=1e3,e.edotaccent=556,e.Igrave=278,e.Imacron=278,e.Lcaron=556,e.onehalf=834,e.lessequal=549,e.ocircumflex=556,e.ntilde=556,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=556,e.gbreve=556,e.onequarter=834,e.Scaron=667,e.Scommaaccent=667,e.Ohungarumlaut=778,e.degree=400,e.ograve=556,e.Ccaron=722,e.ugrave=556,e.radical=453,e.Dcaron=722,e.rcommaaccent=333,e.Ntilde=722,e.otilde=556,e.Rcommaaccent=722,e.Lcommaaccent=556,e.Atilde=667,e.Aogonek=667,e.Aring=667,e.Otilde=778,e.zdotaccent=500,e.Ecaron=667,e.Iogonek=278,e.kcommaaccent=500,e.minus=584,e.Icircumflex=278,e.ncaron=556,e.tcommaaccent=278,e.logicalnot=584,e.odieresis=556,e.udieresis=556,e.notequal=549,e.gcommaaccent=556,e.eth=556,e.zcaron=500,e.ncommaaccent=556,e.onesuperior=333,e.imacron=278,e.Euro=556})),e["Helvetica-Bold"]=(0,n.getLookupTableFactory)((function(e){e.space=278,e.exclam=333,e.quotedbl=474,e.numbersign=556,e.dollar=556,e.percent=889,e.ampersand=722,e.quoteright=278,e.parenleft=333,e.parenright=333,e.asterisk=389,e.plus=584,e.comma=278,e.hyphen=333,e.period=278,e.slash=278,e.zero=556,e.one=556,e.two=556,e.three=556,e.four=556,e.five=556,e.six=556,e.seven=556,e.eight=556,e.nine=556,e.colon=333,e.semicolon=333,e.less=584,e.equal=584,e.greater=584,e.question=611,e.at=975,e.A=722,e.B=722,e.C=722,e.D=722,e.E=667,e.F=611,e.G=778,e.H=722,e.I=278,e.J=556,e.K=722,e.L=611,e.M=833,e.N=722,e.O=778,e.P=667,e.Q=778,e.R=722,e.S=667,e.T=611,e.U=722,e.V=667,e.W=944,e.X=667,e.Y=667,e.Z=611,e.bracketleft=333,e.backslash=278,e.bracketright=333,e.asciicircum=584,e.underscore=556,e.quoteleft=278,e.a=556,e.b=611,e.c=556,e.d=611,e.e=556,e.f=333,e.g=611,e.h=611,e.i=278,e.j=278,e.k=556,e.l=278,e.m=889,e.n=611,e.o=611,e.p=611,e.q=611,e.r=389,e.s=556,e.t=333,e.u=611,e.v=556,e.w=778,e.x=556,e.y=556,e.z=500,e.braceleft=389,e.bar=280,e.braceright=389,e.asciitilde=584,e.exclamdown=333,e.cent=556,e.sterling=556,e.fraction=167,e.yen=556,e.florin=556,e.section=556,e.currency=556,e.quotesingle=238,e.quotedblleft=500,e.guillemotleft=556,e.guilsinglleft=333,e.guilsinglright=333,e.fi=611,e.fl=611,e.endash=556,e.dagger=556,e.daggerdbl=556,e.periodcentered=278,e.paragraph=556,e.bullet=350,e.quotesinglbase=278,e.quotedblbase=500,e.quotedblright=500,e.guillemotright=556,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=611,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=1e3,e.ordfeminine=370,e.Lslash=611,e.Oslash=778,e.OE=1e3,e.ordmasculine=365,e.ae=889,e.dotlessi=278,e.lslash=278,e.oslash=611,e.oe=944,e.germandbls=611,e.Idieresis=278,e.eacute=556,e.abreve=556,e.uhungarumlaut=611,e.ecaron=556,e.Ydieresis=667,e.divide=584,e.Yacute=667,e.Acircumflex=722,e.aacute=556,e.Ucircumflex=722,e.yacute=556,e.scommaaccent=556,e.ecircumflex=556,e.Uring=722,e.Udieresis=722,e.aogonek=556,e.Uacute=722,e.uogonek=611,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=737,e.Emacron=667,e.ccaron=556,e.aring=556,e.Ncommaaccent=722,e.lacute=278,e.agrave=556,e.Tcommaaccent=611,e.Cacute=722,e.atilde=556,e.Edotaccent=667,e.scaron=556,e.scedilla=556,e.iacute=278,e.lozenge=494,e.Rcaron=722,e.Gcommaaccent=778,e.ucircumflex=611,e.acircumflex=556,e.Amacron=722,e.rcaron=389,e.ccedilla=556,e.Zdotaccent=611,e.Thorn=667,e.Omacron=778,e.Racute=722,e.Sacute=667,e.dcaron=743,e.Umacron=722,e.uring=611,e.threesuperior=333,e.Ograve=778,e.Agrave=722,e.Abreve=722,e.multiply=584,e.uacute=611,e.Tcaron=611,e.partialdiff=494,e.ydieresis=556,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=556,e.edieresis=556,e.cacute=556,e.nacute=611,e.umacron=611,e.Ncaron=722,e.Iacute=278,e.plusminus=584,e.brokenbar=280,e.registered=737,e.Gbreve=778,e.Idotaccent=278,e.summation=600,e.Egrave=667,e.racute=389,e.omacron=611,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=722,e.lcommaaccent=278,e.tcaron=389,e.eogonek=556,e.Uogonek=722,e.Aacute=722,e.Adieresis=722,e.egrave=556,e.zacute=500,e.iogonek=278,e.Oacute=778,e.oacute=611,e.amacron=556,e.sacute=556,e.idieresis=278,e.Ocircumflex=778,e.Ugrave=722,e.Delta=612,e.thorn=611,e.twosuperior=333,e.Odieresis=778,e.mu=611,e.igrave=278,e.ohungarumlaut=611,e.Eogonek=667,e.dcroat=611,e.threequarters=834,e.Scedilla=667,e.lcaron=400,e.Kcommaaccent=722,e.Lacute=611,e.trademark=1e3,e.edotaccent=556,e.Igrave=278,e.Imacron=278,e.Lcaron=611,e.onehalf=834,e.lessequal=549,e.ocircumflex=611,e.ntilde=611,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=556,e.gbreve=611,e.onequarter=834,e.Scaron=667,e.Scommaaccent=667,e.Ohungarumlaut=778,e.degree=400,e.ograve=611,e.Ccaron=722,e.ugrave=611,e.radical=549,e.Dcaron=722,e.rcommaaccent=389,e.Ntilde=722,e.otilde=611,e.Rcommaaccent=722,e.Lcommaaccent=611,e.Atilde=722,e.Aogonek=722,e.Aring=722,e.Otilde=778,e.zdotaccent=500,e.Ecaron=667,e.Iogonek=278,e.kcommaaccent=556,e.minus=584,e.Icircumflex=278,e.ncaron=611,e.tcommaaccent=333,e.logicalnot=584,e.odieresis=611,e.udieresis=611,e.notequal=549,e.gcommaaccent=611,e.eth=611,e.zcaron=500,e.ncommaaccent=611,e.onesuperior=333,e.imacron=278,e.Euro=556})),e["Helvetica-BoldOblique"]=(0,n.getLookupTableFactory)((function(e){e.space=278,e.exclam=333,e.quotedbl=474,e.numbersign=556,e.dollar=556,e.percent=889,e.ampersand=722,e.quoteright=278,e.parenleft=333,e.parenright=333,e.asterisk=389,e.plus=584,e.comma=278,e.hyphen=333,e.period=278,e.slash=278,e.zero=556,e.one=556,e.two=556,e.three=556,e.four=556,e.five=556,e.six=556,e.seven=556,e.eight=556,e.nine=556,e.colon=333,e.semicolon=333,e.less=584,e.equal=584,e.greater=584,e.question=611,e.at=975,e.A=722,e.B=722,e.C=722,e.D=722,e.E=667,e.F=611,e.G=778,e.H=722,e.I=278,e.J=556,e.K=722,e.L=611,e.M=833,e.N=722,e.O=778,e.P=667,e.Q=778,e.R=722,e.S=667,e.T=611,e.U=722,e.V=667,e.W=944,e.X=667,e.Y=667,e.Z=611,e.bracketleft=333,e.backslash=278,e.bracketright=333,e.asciicircum=584,e.underscore=556,e.quoteleft=278,e.a=556,e.b=611,e.c=556,e.d=611,e.e=556,e.f=333,e.g=611,e.h=611,e.i=278,e.j=278,e.k=556,e.l=278,e.m=889,e.n=611,e.o=611,e.p=611,e.q=611,e.r=389,e.s=556,e.t=333,e.u=611,e.v=556,e.w=778,e.x=556,e.y=556,e.z=500,e.braceleft=389,e.bar=280,e.braceright=389,e.asciitilde=584,e.exclamdown=333,e.cent=556,e.sterling=556,e.fraction=167,e.yen=556,e.florin=556,e.section=556,e.currency=556,e.quotesingle=238,e.quotedblleft=500,e.guillemotleft=556,e.guilsinglleft=333,e.guilsinglright=333,e.fi=611,e.fl=611,e.endash=556,e.dagger=556,e.daggerdbl=556,e.periodcentered=278,e.paragraph=556,e.bullet=350,e.quotesinglbase=278,e.quotedblbase=500,e.quotedblright=500,e.guillemotright=556,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=611,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=1e3,e.ordfeminine=370,e.Lslash=611,e.Oslash=778,e.OE=1e3,e.ordmasculine=365,e.ae=889,e.dotlessi=278,e.lslash=278,e.oslash=611,e.oe=944,e.germandbls=611,e.Idieresis=278,e.eacute=556,e.abreve=556,e.uhungarumlaut=611,e.ecaron=556,e.Ydieresis=667,e.divide=584,e.Yacute=667,e.Acircumflex=722,e.aacute=556,e.Ucircumflex=722,e.yacute=556,e.scommaaccent=556,e.ecircumflex=556,e.Uring=722,e.Udieresis=722,e.aogonek=556,e.Uacute=722,e.uogonek=611,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=737,e.Emacron=667,e.ccaron=556,e.aring=556,e.Ncommaaccent=722,e.lacute=278,e.agrave=556,e.Tcommaaccent=611,e.Cacute=722,e.atilde=556,e.Edotaccent=667,e.scaron=556,e.scedilla=556,e.iacute=278,e.lozenge=494,e.Rcaron=722,e.Gcommaaccent=778,e.ucircumflex=611,e.acircumflex=556,e.Amacron=722,e.rcaron=389,e.ccedilla=556,e.Zdotaccent=611,e.Thorn=667,e.Omacron=778,e.Racute=722,e.Sacute=667,e.dcaron=743,e.Umacron=722,e.uring=611,e.threesuperior=333,e.Ograve=778,e.Agrave=722,e.Abreve=722,e.multiply=584,e.uacute=611,e.Tcaron=611,e.partialdiff=494,e.ydieresis=556,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=556,e.edieresis=556,e.cacute=556,e.nacute=611,e.umacron=611,e.Ncaron=722,e.Iacute=278,e.plusminus=584,e.brokenbar=280,e.registered=737,e.Gbreve=778,e.Idotaccent=278,e.summation=600,e.Egrave=667,e.racute=389,e.omacron=611,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=722,e.lcommaaccent=278,e.tcaron=389,e.eogonek=556,e.Uogonek=722,e.Aacute=722,e.Adieresis=722,e.egrave=556,e.zacute=500,e.iogonek=278,e.Oacute=778,e.oacute=611,e.amacron=556,e.sacute=556,e.idieresis=278,e.Ocircumflex=778,e.Ugrave=722,e.Delta=612,e.thorn=611,e.twosuperior=333,e.Odieresis=778,e.mu=611,e.igrave=278,e.ohungarumlaut=611,e.Eogonek=667,e.dcroat=611,e.threequarters=834,e.Scedilla=667,e.lcaron=400,e.Kcommaaccent=722,e.Lacute=611,e.trademark=1e3,e.edotaccent=556,e.Igrave=278,e.Imacron=278,e.Lcaron=611,e.onehalf=834,e.lessequal=549,e.ocircumflex=611,e.ntilde=611,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=556,e.gbreve=611,e.onequarter=834,e.Scaron=667,e.Scommaaccent=667,e.Ohungarumlaut=778,e.degree=400,e.ograve=611,e.Ccaron=722,e.ugrave=611,e.radical=549,e.Dcaron=722,e.rcommaaccent=389,e.Ntilde=722,e.otilde=611,e.Rcommaaccent=722,e.Lcommaaccent=611,e.Atilde=722,e.Aogonek=722,e.Aring=722,e.Otilde=778,e.zdotaccent=500,e.Ecaron=667,e.Iogonek=278,e.kcommaaccent=556,e.minus=584,e.Icircumflex=278,e.ncaron=611,e.tcommaaccent=333,e.logicalnot=584,e.odieresis=611,e.udieresis=611,e.notequal=549,e.gcommaaccent=611,e.eth=611,e.zcaron=500,e.ncommaaccent=611,e.onesuperior=333,e.imacron=278,e.Euro=556})),e["Helvetica-Oblique"]=(0,n.getLookupTableFactory)((function(e){e.space=278,e.exclam=278,e.quotedbl=355,e.numbersign=556,e.dollar=556,e.percent=889,e.ampersand=667,e.quoteright=222,e.parenleft=333,e.parenright=333,e.asterisk=389,e.plus=584,e.comma=278,e.hyphen=333,e.period=278,e.slash=278,e.zero=556,e.one=556,e.two=556,e.three=556,e.four=556,e.five=556,e.six=556,e.seven=556,e.eight=556,e.nine=556,e.colon=278,e.semicolon=278,e.less=584,e.equal=584,e.greater=584,e.question=556,e.at=1015,e.A=667,e.B=667,e.C=722,e.D=722,e.E=667,e.F=611,e.G=778,e.H=722,e.I=278,e.J=500,e.K=667,e.L=556,e.M=833,e.N=722,e.O=778,e.P=667,e.Q=778,e.R=722,e.S=667,e.T=611,e.U=722,e.V=667,e.W=944,e.X=667,e.Y=667,e.Z=611,e.bracketleft=278,e.backslash=278,e.bracketright=278,e.asciicircum=469,e.underscore=556,e.quoteleft=222,e.a=556,e.b=556,e.c=500,e.d=556,e.e=556,e.f=278,e.g=556,e.h=556,e.i=222,e.j=222,e.k=500,e.l=222,e.m=833,e.n=556,e.o=556,e.p=556,e.q=556,e.r=333,e.s=500,e.t=278,e.u=556,e.v=500,e.w=722,e.x=500,e.y=500,e.z=500,e.braceleft=334,e.bar=260,e.braceright=334,e.asciitilde=584,e.exclamdown=333,e.cent=556,e.sterling=556,e.fraction=167,e.yen=556,e.florin=556,e.section=556,e.currency=556,e.quotesingle=191,e.quotedblleft=333,e.guillemotleft=556,e.guilsinglleft=333,e.guilsinglright=333,e.fi=500,e.fl=500,e.endash=556,e.dagger=556,e.daggerdbl=556,e.periodcentered=278,e.paragraph=537,e.bullet=350,e.quotesinglbase=222,e.quotedblbase=333,e.quotedblright=333,e.guillemotright=556,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=611,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=1e3,e.ordfeminine=370,e.Lslash=556,e.Oslash=778,e.OE=1e3,e.ordmasculine=365,e.ae=889,e.dotlessi=278,e.lslash=222,e.oslash=611,e.oe=944,e.germandbls=611,e.Idieresis=278,e.eacute=556,e.abreve=556,e.uhungarumlaut=556,e.ecaron=556,e.Ydieresis=667,e.divide=584,e.Yacute=667,e.Acircumflex=667,e.aacute=556,e.Ucircumflex=722,e.yacute=500,e.scommaaccent=500,e.ecircumflex=556,e.Uring=722,e.Udieresis=722,e.aogonek=556,e.Uacute=722,e.uogonek=556,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=737,e.Emacron=667,e.ccaron=500,e.aring=556,e.Ncommaaccent=722,e.lacute=222,e.agrave=556,e.Tcommaaccent=611,e.Cacute=722,e.atilde=556,e.Edotaccent=667,e.scaron=500,e.scedilla=500,e.iacute=278,e.lozenge=471,e.Rcaron=722,e.Gcommaaccent=778,e.ucircumflex=556,e.acircumflex=556,e.Amacron=667,e.rcaron=333,e.ccedilla=500,e.Zdotaccent=611,e.Thorn=667,e.Omacron=778,e.Racute=722,e.Sacute=667,e.dcaron=643,e.Umacron=722,e.uring=556,e.threesuperior=333,e.Ograve=778,e.Agrave=667,e.Abreve=667,e.multiply=584,e.uacute=556,e.Tcaron=611,e.partialdiff=476,e.ydieresis=500,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=556,e.edieresis=556,e.cacute=500,e.nacute=556,e.umacron=556,e.Ncaron=722,e.Iacute=278,e.plusminus=584,e.brokenbar=260,e.registered=737,e.Gbreve=778,e.Idotaccent=278,e.summation=600,e.Egrave=667,e.racute=333,e.omacron=556,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=722,e.lcommaaccent=222,e.tcaron=317,e.eogonek=556,e.Uogonek=722,e.Aacute=667,e.Adieresis=667,e.egrave=556,e.zacute=500,e.iogonek=222,e.Oacute=778,e.oacute=556,e.amacron=556,e.sacute=500,e.idieresis=278,e.Ocircumflex=778,e.Ugrave=722,e.Delta=612,e.thorn=556,e.twosuperior=333,e.Odieresis=778,e.mu=556,e.igrave=278,e.ohungarumlaut=556,e.Eogonek=667,e.dcroat=556,e.threequarters=834,e.Scedilla=667,e.lcaron=299,e.Kcommaaccent=667,e.Lacute=556,e.trademark=1e3,e.edotaccent=556,e.Igrave=278,e.Imacron=278,e.Lcaron=556,e.onehalf=834,e.lessequal=549,e.ocircumflex=556,e.ntilde=556,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=556,e.gbreve=556,e.onequarter=834,e.Scaron=667,e.Scommaaccent=667,e.Ohungarumlaut=778,e.degree=400,e.ograve=556,e.Ccaron=722,e.ugrave=556,e.radical=453,e.Dcaron=722,e.rcommaaccent=333,e.Ntilde=722,e.otilde=556,e.Rcommaaccent=722,e.Lcommaaccent=556,e.Atilde=667,e.Aogonek=667,e.Aring=667,e.Otilde=778,e.zdotaccent=500,e.Ecaron=667,e.Iogonek=278,e.kcommaaccent=500,e.minus=584,e.Icircumflex=278,e.ncaron=556,e.tcommaaccent=278,e.logicalnot=584,e.odieresis=556,e.udieresis=556,e.notequal=549,e.gcommaaccent=556,e.eth=556,e.zcaron=500,e.ncommaaccent=556,e.onesuperior=333,e.imacron=278,e.Euro=556})),e.Symbol=(0,n.getLookupTableFactory)((function(e){e.space=250,e.exclam=333,e.universal=713,e.numbersign=500,e.existential=549,e.percent=833,e.ampersand=778,e.suchthat=439,e.parenleft=333,e.parenright=333,e.asteriskmath=500,e.plus=549,e.comma=250,e.minus=549,e.period=250,e.slash=278,e.zero=500,e.one=500,e.two=500,e.three=500,e.four=500,e.five=500,e.six=500,e.seven=500,e.eight=500,e.nine=500,e.colon=278,e.semicolon=278,e.less=549,e.equal=549,e.greater=549,e.question=444,e.congruent=549,e.Alpha=722,e.Beta=667,e.Chi=722,e.Delta=612,e.Epsilon=611,e.Phi=763,e.Gamma=603,e.Eta=722,e.Iota=333,e.theta1=631,e.Kappa=722,e.Lambda=686,e.Mu=889,e.Nu=722,e.Omicron=722,e.Pi=768,e.Theta=741,e.Rho=556,e.Sigma=592,e.Tau=611,e.Upsilon=690,e.sigma1=439,e.Omega=768,e.Xi=645,e.Psi=795,e.Zeta=611,e.bracketleft=333,e.therefore=863,e.bracketright=333,e.perpendicular=658,e.underscore=500,e.radicalex=500,e.alpha=631,e.beta=549,e.chi=549,e.delta=494,e.epsilon=439,e.phi=521,e.gamma=411,e.eta=603,e.iota=329,e.phi1=603,e.kappa=549,e.lambda=549,e.mu=576,e.nu=521,e.omicron=549,e.pi=549,e.theta=521,e.rho=549,e.sigma=603,e.tau=439,e.upsilon=576,e.omega1=713,e.omega=686,e.xi=493,e.psi=686,e.zeta=494,e.braceleft=480,e.bar=200,e.braceright=480,e.similar=549,e.Euro=750,e.Upsilon1=620,e.minute=247,e.lessequal=549,e.fraction=167,e.infinity=713,e.florin=500,e.club=753,e.diamond=753,e.heart=753,e.spade=753,e.arrowboth=1042,e.arrowleft=987,e.arrowup=603,e.arrowright=987,e.arrowdown=603,e.degree=400,e.plusminus=549,e.second=411,e.greaterequal=549,e.multiply=549,e.proportional=713,e.partialdiff=494,e.bullet=460,e.divide=549,e.notequal=549,e.equivalence=549,e.approxequal=549,e.ellipsis=1e3,e.arrowvertex=603,e.arrowhorizex=1e3,e.carriagereturn=658,e.aleph=823,e.Ifraktur=686,e.Rfraktur=795,e.weierstrass=987,e.circlemultiply=768,e.circleplus=768,e.emptyset=823,e.intersection=768,e.union=768,e.propersuperset=713,e.reflexsuperset=713,e.notsubset=713,e.propersubset=713,e.reflexsubset=713,e.element=713,e.notelement=713,e.angle=768,e.gradient=713,e.registerserif=790,e.copyrightserif=790,e.trademarkserif=890,e.product=823,e.radical=549,e.dotmath=250,e.logicalnot=713,e.logicaland=603,e.logicalor=603,e.arrowdblboth=1042,e.arrowdblleft=987,e.arrowdblup=603,e.arrowdblright=987,e.arrowdbldown=603,e.lozenge=494,e.angleleft=329,e.registersans=790,e.copyrightsans=790,e.trademarksans=786,e.summation=713,e.parenlefttp=384,e.parenleftex=384,e.parenleftbt=384,e.bracketlefttp=384,e.bracketleftex=384,e.bracketleftbt=384,e.bracelefttp=494,e.braceleftmid=494,e.braceleftbt=494,e.braceex=494,e.angleright=329,e.integral=274,e.integraltp=686,e.integralex=686,e.integralbt=686,e.parenrighttp=384,e.parenrightex=384,e.parenrightbt=384,e.bracketrighttp=384,e.bracketrightex=384,e.bracketrightbt=384,e.bracerighttp=494,e.bracerightmid=494,e.bracerightbt=494,e.apple=790})),e["Times-Roman"]=(0,n.getLookupTableFactory)((function(e){e.space=250,e.exclam=333,e.quotedbl=408,e.numbersign=500,e.dollar=500,e.percent=833,e.ampersand=778,e.quoteright=333,e.parenleft=333,e.parenright=333,e.asterisk=500,e.plus=564,e.comma=250,e.hyphen=333,e.period=250,e.slash=278,e.zero=500,e.one=500,e.two=500,e.three=500,e.four=500,e.five=500,e.six=500,e.seven=500,e.eight=500,e.nine=500,e.colon=278,e.semicolon=278,e.less=564,e.equal=564,e.greater=564,e.question=444,e.at=921,e.A=722,e.B=667,e.C=667,e.D=722,e.E=611,e.F=556,e.G=722,e.H=722,e.I=333,e.J=389,e.K=722,e.L=611,e.M=889,e.N=722,e.O=722,e.P=556,e.Q=722,e.R=667,e.S=556,e.T=611,e.U=722,e.V=722,e.W=944,e.X=722,e.Y=722,e.Z=611,e.bracketleft=333,e.backslash=278,e.bracketright=333,e.asciicircum=469,e.underscore=500,e.quoteleft=333,e.a=444,e.b=500,e.c=444,e.d=500,e.e=444,e.f=333,e.g=500,e.h=500,e.i=278,e.j=278,e.k=500,e.l=278,e.m=778,e.n=500,e.o=500,e.p=500,e.q=500,e.r=333,e.s=389,e.t=278,e.u=500,e.v=500,e.w=722,e.x=500,e.y=500,e.z=444,e.braceleft=480,e.bar=200,e.braceright=480,e.asciitilde=541,e.exclamdown=333,e.cent=500,e.sterling=500,e.fraction=167,e.yen=500,e.florin=500,e.section=500,e.currency=500,e.quotesingle=180,e.quotedblleft=444,e.guillemotleft=500,e.guilsinglleft=333,e.guilsinglright=333,e.fi=556,e.fl=556,e.endash=500,e.dagger=500,e.daggerdbl=500,e.periodcentered=250,e.paragraph=453,e.bullet=350,e.quotesinglbase=333,e.quotedblbase=444,e.quotedblright=444,e.guillemotright=500,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=444,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=889,e.ordfeminine=276,e.Lslash=611,e.Oslash=722,e.OE=889,e.ordmasculine=310,e.ae=667,e.dotlessi=278,e.lslash=278,e.oslash=500,e.oe=722,e.germandbls=500,e.Idieresis=333,e.eacute=444,e.abreve=444,e.uhungarumlaut=500,e.ecaron=444,e.Ydieresis=722,e.divide=564,e.Yacute=722,e.Acircumflex=722,e.aacute=444,e.Ucircumflex=722,e.yacute=500,e.scommaaccent=389,e.ecircumflex=444,e.Uring=722,e.Udieresis=722,e.aogonek=444,e.Uacute=722,e.uogonek=500,e.Edieresis=611,e.Dcroat=722,e.commaaccent=250,e.copyright=760,e.Emacron=611,e.ccaron=444,e.aring=444,e.Ncommaaccent=722,e.lacute=278,e.agrave=444,e.Tcommaaccent=611,e.Cacute=667,e.atilde=444,e.Edotaccent=611,e.scaron=389,e.scedilla=389,e.iacute=278,e.lozenge=471,e.Rcaron=667,e.Gcommaaccent=722,e.ucircumflex=500,e.acircumflex=444,e.Amacron=722,e.rcaron=333,e.ccedilla=444,e.Zdotaccent=611,e.Thorn=556,e.Omacron=722,e.Racute=667,e.Sacute=556,e.dcaron=588,e.Umacron=722,e.uring=500,e.threesuperior=300,e.Ograve=722,e.Agrave=722,e.Abreve=722,e.multiply=564,e.uacute=500,e.Tcaron=611,e.partialdiff=476,e.ydieresis=500,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=611,e.adieresis=444,e.edieresis=444,e.cacute=444,e.nacute=500,e.umacron=500,e.Ncaron=722,e.Iacute=333,e.plusminus=564,e.brokenbar=200,e.registered=760,e.Gbreve=722,e.Idotaccent=333,e.summation=600,e.Egrave=611,e.racute=333,e.omacron=500,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=667,e.lcommaaccent=278,e.tcaron=326,e.eogonek=444,e.Uogonek=722,e.Aacute=722,e.Adieresis=722,e.egrave=444,e.zacute=444,e.iogonek=278,e.Oacute=722,e.oacute=500,e.amacron=444,e.sacute=389,e.idieresis=278,e.Ocircumflex=722,e.Ugrave=722,e.Delta=612,e.thorn=500,e.twosuperior=300,e.Odieresis=722,e.mu=500,e.igrave=278,e.ohungarumlaut=500,e.Eogonek=611,e.dcroat=500,e.threequarters=750,e.Scedilla=556,e.lcaron=344,e.Kcommaaccent=722,e.Lacute=611,e.trademark=980,e.edotaccent=444,e.Igrave=333,e.Imacron=333,e.Lcaron=611,e.onehalf=750,e.lessequal=549,e.ocircumflex=500,e.ntilde=500,e.Uhungarumlaut=722,e.Eacute=611,e.emacron=444,e.gbreve=500,e.onequarter=750,e.Scaron=556,e.Scommaaccent=556,e.Ohungarumlaut=722,e.degree=400,e.ograve=500,e.Ccaron=667,e.ugrave=500,e.radical=453,e.Dcaron=722,e.rcommaaccent=333,e.Ntilde=722,e.otilde=500,e.Rcommaaccent=667,e.Lcommaaccent=611,e.Atilde=722,e.Aogonek=722,e.Aring=722,e.Otilde=722,e.zdotaccent=444,e.Ecaron=611,e.Iogonek=333,e.kcommaaccent=500,e.minus=564,e.Icircumflex=333,e.ncaron=500,e.tcommaaccent=278,e.logicalnot=564,e.odieresis=500,e.udieresis=500,e.notequal=549,e.gcommaaccent=500,e.eth=500,e.zcaron=444,e.ncommaaccent=500,e.onesuperior=300,e.imacron=278,e.Euro=500})),e["Times-Bold"]=(0,n.getLookupTableFactory)((function(e){e.space=250,e.exclam=333,e.quotedbl=555,e.numbersign=500,e.dollar=500,e.percent=1e3,e.ampersand=833,e.quoteright=333,e.parenleft=333,e.parenright=333,e.asterisk=500,e.plus=570,e.comma=250,e.hyphen=333,e.period=250,e.slash=278,e.zero=500,e.one=500,e.two=500,e.three=500,e.four=500,e.five=500,e.six=500,e.seven=500,e.eight=500,e.nine=500,e.colon=333,e.semicolon=333,e.less=570,e.equal=570,e.greater=570,e.question=500,e.at=930,e.A=722,e.B=667,e.C=722,e.D=722,e.E=667,e.F=611,e.G=778,e.H=778,e.I=389,e.J=500,e.K=778,e.L=667,e.M=944,e.N=722,e.O=778,e.P=611,e.Q=778,e.R=722,e.S=556,e.T=667,e.U=722,e.V=722,e.W=1e3,e.X=722,e.Y=722,e.Z=667,e.bracketleft=333,e.backslash=278,e.bracketright=333,e.asciicircum=581,e.underscore=500,e.quoteleft=333,e.a=500,e.b=556,e.c=444,e.d=556,e.e=444,e.f=333,e.g=500,e.h=556,e.i=278,e.j=333,e.k=556,e.l=278,e.m=833,e.n=556,e.o=500,e.p=556,e.q=556,e.r=444,e.s=389,e.t=333,e.u=556,e.v=500,e.w=722,e.x=500,e.y=500,e.z=444,e.braceleft=394,e.bar=220,e.braceright=394,e.asciitilde=520,e.exclamdown=333,e.cent=500,e.sterling=500,e.fraction=167,e.yen=500,e.florin=500,e.section=500,e.currency=500,e.quotesingle=278,e.quotedblleft=500,e.guillemotleft=500,e.guilsinglleft=333,e.guilsinglright=333,e.fi=556,e.fl=556,e.endash=500,e.dagger=500,e.daggerdbl=500,e.periodcentered=250,e.paragraph=540,e.bullet=350,e.quotesinglbase=333,e.quotedblbase=500,e.quotedblright=500,e.guillemotright=500,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=500,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=1e3,e.ordfeminine=300,e.Lslash=667,e.Oslash=778,e.OE=1e3,e.ordmasculine=330,e.ae=722,e.dotlessi=278,e.lslash=278,e.oslash=500,e.oe=722,e.germandbls=556,e.Idieresis=389,e.eacute=444,e.abreve=500,e.uhungarumlaut=556,e.ecaron=444,e.Ydieresis=722,e.divide=570,e.Yacute=722,e.Acircumflex=722,e.aacute=500,e.Ucircumflex=722,e.yacute=500,e.scommaaccent=389,e.ecircumflex=444,e.Uring=722,e.Udieresis=722,e.aogonek=500,e.Uacute=722,e.uogonek=556,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=747,e.Emacron=667,e.ccaron=444,e.aring=500,e.Ncommaaccent=722,e.lacute=278,e.agrave=500,e.Tcommaaccent=667,e.Cacute=722,e.atilde=500,e.Edotaccent=667,e.scaron=389,e.scedilla=389,e.iacute=278,e.lozenge=494,e.Rcaron=722,e.Gcommaaccent=778,e.ucircumflex=556,e.acircumflex=500,e.Amacron=722,e.rcaron=444,e.ccedilla=444,e.Zdotaccent=667,e.Thorn=611,e.Omacron=778,e.Racute=722,e.Sacute=556,e.dcaron=672,e.Umacron=722,e.uring=556,e.threesuperior=300,e.Ograve=778,e.Agrave=722,e.Abreve=722,e.multiply=570,e.uacute=556,e.Tcaron=667,e.partialdiff=494,e.ydieresis=500,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=500,e.edieresis=444,e.cacute=444,e.nacute=556,e.umacron=556,e.Ncaron=722,e.Iacute=389,e.plusminus=570,e.brokenbar=220,e.registered=747,e.Gbreve=778,e.Idotaccent=389,e.summation=600,e.Egrave=667,e.racute=444,e.omacron=500,e.Zacute=667,e.Zcaron=667,e.greaterequal=549,e.Eth=722,e.Ccedilla=722,e.lcommaaccent=278,e.tcaron=416,e.eogonek=444,e.Uogonek=722,e.Aacute=722,e.Adieresis=722,e.egrave=444,e.zacute=444,e.iogonek=278,e.Oacute=778,e.oacute=500,e.amacron=500,e.sacute=389,e.idieresis=278,e.Ocircumflex=778,e.Ugrave=722,e.Delta=612,e.thorn=556,e.twosuperior=300,e.Odieresis=778,e.mu=556,e.igrave=278,e.ohungarumlaut=500,e.Eogonek=667,e.dcroat=556,e.threequarters=750,e.Scedilla=556,e.lcaron=394,e.Kcommaaccent=778,e.Lacute=667,e.trademark=1e3,e.edotaccent=444,e.Igrave=389,e.Imacron=389,e.Lcaron=667,e.onehalf=750,e.lessequal=549,e.ocircumflex=500,e.ntilde=556,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=444,e.gbreve=500,e.onequarter=750,e.Scaron=556,e.Scommaaccent=556,e.Ohungarumlaut=778,e.degree=400,e.ograve=500,e.Ccaron=722,e.ugrave=556,e.radical=549,e.Dcaron=722,e.rcommaaccent=444,e.Ntilde=722,e.otilde=500,e.Rcommaaccent=722,e.Lcommaaccent=667,e.Atilde=722,e.Aogonek=722,e.Aring=722,e.Otilde=778,e.zdotaccent=444,e.Ecaron=667,e.Iogonek=389,e.kcommaaccent=556,e.minus=570,e.Icircumflex=389,e.ncaron=556,e.tcommaaccent=333,e.logicalnot=570,e.odieresis=500,e.udieresis=556,e.notequal=549,e.gcommaaccent=500,e.eth=500,e.zcaron=444,e.ncommaaccent=556,e.onesuperior=300,e.imacron=278,e.Euro=500})),e["Times-BoldItalic"]=(0,n.getLookupTableFactory)((function(e){e.space=250,e.exclam=389,e.quotedbl=555,e.numbersign=500,e.dollar=500,e.percent=833,e.ampersand=778,e.quoteright=333,e.parenleft=333,e.parenright=333,e.asterisk=500,e.plus=570,e.comma=250,e.hyphen=333,e.period=250,e.slash=278,e.zero=500,e.one=500,e.two=500,e.three=500,e.four=500,e.five=500,e.six=500,e.seven=500,e.eight=500,e.nine=500,e.colon=333,e.semicolon=333,e.less=570,e.equal=570,e.greater=570,e.question=500,e.at=832,e.A=667,e.B=667,e.C=667,e.D=722,e.E=667,e.F=667,e.G=722,e.H=778,e.I=389,e.J=500,e.K=667,e.L=611,e.M=889,e.N=722,e.O=722,e.P=611,e.Q=722,e.R=667,e.S=556,e.T=611,e.U=722,e.V=667,e.W=889,e.X=667,e.Y=611,e.Z=611,e.bracketleft=333,e.backslash=278,e.bracketright=333,e.asciicircum=570,e.underscore=500,e.quoteleft=333,e.a=500,e.b=500,e.c=444,e.d=500,e.e=444,e.f=333,e.g=500,e.h=556,e.i=278,e.j=278,e.k=500,e.l=278,e.m=778,e.n=556,e.o=500,e.p=500,e.q=500,e.r=389,e.s=389,e.t=278,e.u=556,e.v=444,e.w=667,e.x=500,e.y=444,e.z=389,e.braceleft=348,e.bar=220,e.braceright=348,e.asciitilde=570,e.exclamdown=389,e.cent=500,e.sterling=500,e.fraction=167,e.yen=500,e.florin=500,e.section=500,e.currency=500,e.quotesingle=278,e.quotedblleft=500,e.guillemotleft=500,e.guilsinglleft=333,e.guilsinglright=333,e.fi=556,e.fl=556,e.endash=500,e.dagger=500,e.daggerdbl=500,e.periodcentered=250,e.paragraph=500,e.bullet=350,e.quotesinglbase=333,e.quotedblbase=500,e.quotedblright=500,e.guillemotright=500,e.ellipsis=1e3,e.perthousand=1e3,e.questiondown=500,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=1e3,e.AE=944,e.ordfeminine=266,e.Lslash=611,e.Oslash=722,e.OE=944,e.ordmasculine=300,e.ae=722,e.dotlessi=278,e.lslash=278,e.oslash=500,e.oe=722,e.germandbls=500,e.Idieresis=389,e.eacute=444,e.abreve=500,e.uhungarumlaut=556,e.ecaron=444,e.Ydieresis=611,e.divide=570,e.Yacute=611,e.Acircumflex=667,e.aacute=500,e.Ucircumflex=722,e.yacute=444,e.scommaaccent=389,e.ecircumflex=444,e.Uring=722,e.Udieresis=722,e.aogonek=500,e.Uacute=722,e.uogonek=556,e.Edieresis=667,e.Dcroat=722,e.commaaccent=250,e.copyright=747,e.Emacron=667,e.ccaron=444,e.aring=500,e.Ncommaaccent=722,e.lacute=278,e.agrave=500,e.Tcommaaccent=611,e.Cacute=667,e.atilde=500,e.Edotaccent=667,e.scaron=389,e.scedilla=389,e.iacute=278,e.lozenge=494,e.Rcaron=667,e.Gcommaaccent=722,e.ucircumflex=556,e.acircumflex=500,e.Amacron=667,e.rcaron=389,e.ccedilla=444,e.Zdotaccent=611,e.Thorn=611,e.Omacron=722,e.Racute=667,e.Sacute=556,e.dcaron=608,e.Umacron=722,e.uring=556,e.threesuperior=300,e.Ograve=722,e.Agrave=667,e.Abreve=667,e.multiply=570,e.uacute=556,e.Tcaron=611,e.partialdiff=494,e.ydieresis=444,e.Nacute=722,e.icircumflex=278,e.Ecircumflex=667,e.adieresis=500,e.edieresis=444,e.cacute=444,e.nacute=556,e.umacron=556,e.Ncaron=722,e.Iacute=389,e.plusminus=570,e.brokenbar=220,e.registered=747,e.Gbreve=722,e.Idotaccent=389,e.summation=600,e.Egrave=667,e.racute=389,e.omacron=500,e.Zacute=611,e.Zcaron=611,e.greaterequal=549,e.Eth=722,e.Ccedilla=667,e.lcommaaccent=278,e.tcaron=366,e.eogonek=444,e.Uogonek=722,e.Aacute=667,e.Adieresis=667,e.egrave=444,e.zacute=389,e.iogonek=278,e.Oacute=722,e.oacute=500,e.amacron=500,e.sacute=389,e.idieresis=278,e.Ocircumflex=722,e.Ugrave=722,e.Delta=612,e.thorn=500,e.twosuperior=300,e.Odieresis=722,e.mu=576,e.igrave=278,e.ohungarumlaut=500,e.Eogonek=667,e.dcroat=500,e.threequarters=750,e.Scedilla=556,e.lcaron=382,e.Kcommaaccent=667,e.Lacute=611,e.trademark=1e3,e.edotaccent=444,e.Igrave=389,e.Imacron=389,e.Lcaron=611,e.onehalf=750,e.lessequal=549,e.ocircumflex=500,e.ntilde=556,e.Uhungarumlaut=722,e.Eacute=667,e.emacron=444,e.gbreve=500,e.onequarter=750,e.Scaron=556,e.Scommaaccent=556,e.Ohungarumlaut=722,e.degree=400,e.ograve=500,e.Ccaron=667,e.ugrave=556,e.radical=549,e.Dcaron=722,e.rcommaaccent=389,e.Ntilde=722,e.otilde=500,e.Rcommaaccent=667,e.Lcommaaccent=611,e.Atilde=667,e.Aogonek=667,e.Aring=667,e.Otilde=722,e.zdotaccent=389,e.Ecaron=667,e.Iogonek=389,e.kcommaaccent=500,e.minus=606,e.Icircumflex=389,e.ncaron=556,e.tcommaaccent=278,e.logicalnot=606,e.odieresis=500,e.udieresis=556,e.notequal=549,e.gcommaaccent=500,e.eth=500,e.zcaron=389,e.ncommaaccent=556,e.onesuperior=300,e.imacron=278,e.Euro=500})),e["Times-Italic"]=(0,n.getLookupTableFactory)((function(e){e.space=250,e.exclam=333,e.quotedbl=420,e.numbersign=500,e.dollar=500,e.percent=833,e.ampersand=778,e.quoteright=333,e.parenleft=333,e.parenright=333,e.asterisk=500,e.plus=675,e.comma=250,e.hyphen=333,e.period=250,e.slash=278,e.zero=500,e.one=500,e.two=500,e.three=500,e.four=500,e.five=500,e.six=500,e.seven=500,e.eight=500,e.nine=500,e.colon=333,e.semicolon=333,e.less=675,e.equal=675,e.greater=675,e.question=500,e.at=920,e.A=611,e.B=611,e.C=667,e.D=722,e.E=611,e.F=611,e.G=722,e.H=722,e.I=333,e.J=444,e.K=667,e.L=556,e.M=833,e.N=667,e.O=722,e.P=611,e.Q=722,e.R=611,e.S=500,e.T=556,e.U=722,e.V=611,e.W=833,e.X=611,e.Y=556,e.Z=556,e.bracketleft=389,e.backslash=278,e.bracketright=389,e.asciicircum=422,e.underscore=500,e.quoteleft=333,e.a=500,e.b=500,e.c=444,e.d=500,e.e=444,e.f=278,e.g=500,e.h=500,e.i=278,e.j=278,e.k=444,e.l=278,e.m=722,e.n=500,e.o=500,e.p=500,e.q=500,e.r=389,e.s=389,e.t=278,e.u=500,e.v=444,e.w=667,e.x=444,e.y=444,e.z=389,e.braceleft=400,e.bar=275,e.braceright=400,e.asciitilde=541,e.exclamdown=389,e.cent=500,e.sterling=500,e.fraction=167,e.yen=500,e.florin=500,e.section=500,e.currency=500,e.quotesingle=214,e.quotedblleft=556,e.guillemotleft=500,e.guilsinglleft=333,e.guilsinglright=333,e.fi=500,e.fl=500,e.endash=500,e.dagger=500,e.daggerdbl=500,e.periodcentered=250,e.paragraph=523,e.bullet=350,e.quotesinglbase=333,e.quotedblbase=556,e.quotedblright=556,e.guillemotright=500,e.ellipsis=889,e.perthousand=1e3,e.questiondown=500,e.grave=333,e.acute=333,e.circumflex=333,e.tilde=333,e.macron=333,e.breve=333,e.dotaccent=333,e.dieresis=333,e.ring=333,e.cedilla=333,e.hungarumlaut=333,e.ogonek=333,e.caron=333,e.emdash=889,e.AE=889,e.ordfeminine=276,e.Lslash=556,e.Oslash=722,e.OE=944,e.ordmasculine=310,e.ae=667,e.dotlessi=278,e.lslash=278,e.oslash=500,e.oe=667,e.germandbls=500,e.Idieresis=333,e.eacute=444,e.abreve=500,e.uhungarumlaut=500,e.ecaron=444,e.Ydieresis=556,e.divide=675,e.Yacute=556,e.Acircumflex=611,e.aacute=500,e.Ucircumflex=722,e.yacute=444,e.scommaaccent=389,e.ecircumflex=444,e.Uring=722,e.Udieresis=722,e.aogonek=500,e.Uacute=722,e.uogonek=500,e.Edieresis=611,e.Dcroat=722,e.commaaccent=250,e.copyright=760,e.Emacron=611,e.ccaron=444,e.aring=500,e.Ncommaaccent=667,e.lacute=278,e.agrave=500,e.Tcommaaccent=556,e.Cacute=667,e.atilde=500,e.Edotaccent=611,e.scaron=389,e.scedilla=389,e.iacute=278,e.lozenge=471,e.Rcaron=611,e.Gcommaaccent=722,e.ucircumflex=500,e.acircumflex=500,e.Amacron=611,e.rcaron=389,e.ccedilla=444,e.Zdotaccent=556,e.Thorn=611,e.Omacron=722,e.Racute=611,e.Sacute=500,e.dcaron=544,e.Umacron=722,e.uring=500,e.threesuperior=300,e.Ograve=722,e.Agrave=611,e.Abreve=611,e.multiply=675,e.uacute=500,e.Tcaron=556,e.partialdiff=476,e.ydieresis=444,e.Nacute=667,e.icircumflex=278,e.Ecircumflex=611,e.adieresis=500,e.edieresis=444,e.cacute=444,e.nacute=500,e.umacron=500,e.Ncaron=667,e.Iacute=333,e.plusminus=675,e.brokenbar=275,e.registered=760,e.Gbreve=722,e.Idotaccent=333,e.summation=600,e.Egrave=611,e.racute=389,e.omacron=500,e.Zacute=556,e.Zcaron=556,e.greaterequal=549,e.Eth=722,e.Ccedilla=667,e.lcommaaccent=278,e.tcaron=300,e.eogonek=444,e.Uogonek=722,e.Aacute=611,e.Adieresis=611,e.egrave=444,e.zacute=389,e.iogonek=278,e.Oacute=722,e.oacute=500,e.amacron=500,e.sacute=389,e.idieresis=278,e.Ocircumflex=722,e.Ugrave=722,e.Delta=612,e.thorn=500,e.twosuperior=300,e.Odieresis=722,e.mu=500,e.igrave=278,e.ohungarumlaut=500,e.Eogonek=611,e.dcroat=500,e.threequarters=750,e.Scedilla=500,e.lcaron=300,e.Kcommaaccent=667,e.Lacute=556,e.trademark=980,e.edotaccent=444,e.Igrave=333,e.Imacron=333,e.Lcaron=611,e.onehalf=750,e.lessequal=549,e.ocircumflex=500,e.ntilde=500,e.Uhungarumlaut=722,e.Eacute=611,e.emacron=444,e.gbreve=500,e.onequarter=750,e.Scaron=500,e.Scommaaccent=500,e.Ohungarumlaut=722,e.degree=400,e.ograve=500,e.Ccaron=667,e.ugrave=500,e.radical=453,e.Dcaron=722,e.rcommaaccent=389,e.Ntilde=667,e.otilde=500,e.Rcommaaccent=611,e.Lcommaaccent=556,e.Atilde=611,e.Aogonek=611,e.Aring=611,e.Otilde=722,e.zdotaccent=389,e.Ecaron=611,e.Iogonek=333,e.kcommaaccent=444,e.minus=675,e.Icircumflex=333,e.ncaron=500,e.tcommaaccent=278,e.logicalnot=675,e.odieresis=500,e.udieresis=500,e.notequal=549,e.gcommaaccent=500,e.eth=500,e.zcaron=389,e.ncommaaccent=500,e.onesuperior=300,e.imacron=278,e.Euro=500})),e.ZapfDingbats=(0,n.getLookupTableFactory)((function(e){e.space=278,e.a1=974,e.a2=961,e.a202=974,e.a3=980,e.a4=719,e.a5=789,e.a119=790,e.a118=791,e.a117=690,e.a11=960,e.a12=939,e.a13=549,e.a14=855,e.a15=911,e.a16=933,e.a105=911,e.a17=945,e.a18=974,e.a19=755,e.a20=846,e.a21=762,e.a22=761,e.a23=571,e.a24=677,e.a25=763,e.a26=760,e.a27=759,e.a28=754,e.a6=494,e.a7=552,e.a8=537,e.a9=577,e.a10=692,e.a29=786,e.a30=788,e.a31=788,e.a32=790,e.a33=793,e.a34=794,e.a35=816,e.a36=823,e.a37=789,e.a38=841,e.a39=823,e.a40=833,e.a41=816,e.a42=831,e.a43=923,e.a44=744,e.a45=723,e.a46=749,e.a47=790,e.a48=792,e.a49=695,e.a50=776,e.a51=768,e.a52=792,e.a53=759,e.a54=707,e.a55=708,e.a56=682,e.a57=701,e.a58=826,e.a59=815,e.a60=789,e.a61=789,e.a62=707,e.a63=687,e.a64=696,e.a65=689,e.a66=786,e.a67=787,e.a68=713,e.a69=791,e.a70=785,e.a71=791,e.a72=873,e.a73=761,e.a74=762,e.a203=762,e.a75=759,e.a204=759,e.a76=892,e.a77=892,e.a78=788,e.a79=784,e.a81=438,e.a82=138,e.a83=277,e.a84=415,e.a97=392,e.a98=392,e.a99=668,e.a100=668,e.a89=390,e.a90=390,e.a93=317,e.a94=317,e.a91=276,e.a92=276,e.a205=509,e.a85=509,e.a206=410,e.a86=410,e.a87=234,e.a88=234,e.a95=334,e.a96=334,e.a101=732,e.a102=544,e.a103=544,e.a104=910,e.a106=667,e.a107=760,e.a108=760,e.a112=776,e.a111=595,e.a110=694,e.a109=626,e.a120=788,e.a121=788,e.a122=788,e.a123=788,e.a124=788,e.a125=788,e.a126=788,e.a127=788,e.a128=788,e.a129=788,e.a130=788,e.a131=788,e.a132=788,e.a133=788,e.a134=788,e.a135=788,e.a136=788,e.a137=788,e.a138=788,e.a139=788,e.a140=788,e.a141=788,e.a142=788,e.a143=788,e.a144=788,e.a145=788,e.a146=788,e.a147=788,e.a148=788,e.a149=788,e.a150=788,e.a151=788,e.a152=788,e.a153=788,e.a154=788,e.a155=788,e.a156=788,e.a157=788,e.a158=788,e.a159=788,e.a160=894,e.a161=838,e.a163=1016,e.a164=458,e.a196=748,e.a165=924,e.a192=748,e.a166=918,e.a167=927,e.a168=928,e.a169=928,e.a170=834,e.a171=873,e.a172=828,e.a173=924,e.a162=924,e.a174=917,e.a175=930,e.a176=931,e.a177=463,e.a178=883,e.a179=836,e.a193=836,e.a180=867,e.a199=867,e.a181=696,e.a200=696,e.a182=874,e.a201=874,e.a183=760,e.a184=946,e.a197=771,e.a185=865,e.a194=771,e.a198=888,e.a186=967,e.a195=888,e.a187=831,e.a188=873,e.a189=927,e.a190=970,e.a191=918}))}));t.getMetrics=r;const i=(0,n.getLookupTableFactory)((function(e){e.Courier={ascent:629,descent:-157,capHeight:562,xHeight:-426},e["Courier-Bold"]={ascent:629,descent:-157,capHeight:562,xHeight:439},e["Courier-Oblique"]={ascent:629,descent:-157,capHeight:562,xHeight:426},e["Courier-BoldOblique"]={ascent:629,descent:-157,capHeight:562,xHeight:426},e.Helvetica={ascent:718,descent:-207,capHeight:718,xHeight:523},e["Helvetica-Bold"]={ascent:718,descent:-207,capHeight:718,xHeight:532},e["Helvetica-Oblique"]={ascent:718,descent:-207,capHeight:718,xHeight:523},e["Helvetica-BoldOblique"]={ascent:718,descent:-207,capHeight:718,xHeight:532},e["Times-Roman"]={ascent:683,descent:-217,capHeight:662,xHeight:450},e["Times-Bold"]={ascent:683,descent:-217,capHeight:676,xHeight:461},e["Times-Italic"]={ascent:683,descent:-217,capHeight:653,xHeight:441},e["Times-BoldItalic"]={ascent:683,descent:-217,capHeight:669,xHeight:462},e.Symbol={ascent:Math.NaN,descent:Math.NaN,capHeight:Math.NaN,xHeight:Math.NaN},e.ZapfDingbats={ascent:Math.NaN,descent:Math.NaN,capHeight:Math.NaN,xHeight:Math.NaN}}));t.getFontBasicMetrics=i},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.GlyfTable=void 0;t.GlyfTable=class{constructor({glyfTable:e,isGlyphLocationsLong:t,locaTable:n,numGlyphs:r}){this.glyphs=[];const i=new DataView(n.buffer,n.byteOffset,n.byteLength),s=new DataView(e.buffer,e.byteOffset,e.byteLength),o=t?4:2;let c=t?i.getUint32(0):2*i.getUint16(0),l=0;for(let e=0;e<r;e++){l+=o;const e=t?i.getUint32(l):2*i.getUint16(l);if(e===c){this.glyphs.push(new a({}));continue}const n=a.parse(c,s);this.glyphs.push(n),c=e}}getSize(){return this.glyphs.reduce(((e,t)=>e+(t.getSize()+3&-4)),0)}write(){const e=this.getSize(),t=new DataView(new ArrayBuffer(e)),a=e>131070,n=a?4:2,r=new DataView(new ArrayBuffer((this.glyphs.length+1)*n));a?r.setUint32(0,0):r.setUint16(0,0);let i=0,s=0;for(const e of this.glyphs)i+=e.write(i,t),i=i+3&-4,s+=n,a?r.setUint32(s,i):r.setUint16(s,i>>1);return{isLocationLong:a,loca:new Uint8Array(r.buffer),glyf:new Uint8Array(t.buffer)}}scale(e){for(let t=0,a=this.glyphs.length;t<a;t++)this.glyphs[t].scale(e[t])}};class a{constructor({header:e=null,simple:t=null,composites:a=null}){this.header=e,this.simple=t,this.composites=a}static parse(e,t){const[r,o]=n.parse(e,t);if(e+=r,o.numberOfContours<0){const n=[];for(;;){const[a,r]=s.parse(e,t);if(e+=a,n.push(r),!(32&r.flags))break}return new a({header:o,composites:n})}const c=i.parse(e,t,o.numberOfContours);return new a({header:o,simple:c})}getSize(){if(!this.header)return 0;const e=this.simple?this.simple.getSize():this.composites.reduce(((e,t)=>e+t.getSize()),0);return this.header.getSize()+e}write(e,t){if(!this.header)return 0;const a=e;if(e+=this.header.write(e,t),this.simple)e+=this.simple.write(e,t);else for(const a of this.composites)e+=a.write(e,t);return e-a}scale(e){if(!this.header)return;const t=(this.header.xMin+this.header.xMax)/2;if(this.header.scale(t,e),this.simple)this.simple.scale(t,e);else for(const a of this.composites)a.scale(t,e)}}class n{constructor({numberOfContours:e,xMin:t,yMin:a,xMax:n,yMax:r}){this.numberOfContours=e,this.xMin=t,this.yMin=a,this.xMax=n,this.yMax=r}static parse(e,t){return[10,new n({numberOfContours:t.getInt16(e),xMin:t.getInt16(e+2),yMin:t.getInt16(e+4),xMax:t.getInt16(e+6),yMax:t.getInt16(e+8)})]}getSize(){return 10}write(e,t){return t.setInt16(e,this.numberOfContours),t.setInt16(e+2,this.xMin),t.setInt16(e+4,this.yMin),t.setInt16(e+6,this.xMax),t.setInt16(e+8,this.yMax),10}scale(e,t){this.xMin=Math.round(e+(this.xMin-e)*t),this.xMax=Math.round(e+(this.xMax-e)*t)}}class r{constructor({flags:e,xCoordinates:t,yCoordinates:a}){this.xCoordinates=t,this.yCoordinates=a,this.flags=e}}class i{constructor({contours:e,instructions:t}){this.contours=e,this.instructions=t}static parse(e,t,a){const n=[];for(let r=0;r<a;r++){const a=t.getUint16(e);e+=2,n.push(a)}const s=n[a-1]+1,o=t.getUint16(e);e+=2;const c=new Uint8Array(t).slice(e,e+o);e+=o;const l=[];for(let a=0;a<s;e++,a++){let n=t.getUint8(e);if(l.push(n),8&n){const r=t.getUint8(++e);n^=8;for(let e=0;e<r;e++)l.push(n);a+=r}}const h=[];let u=[],d=[],f=[];const g=[];let p=0,m=0;for(let a=0;a<s;a++){const r=l[a];if(2&r){const a=t.getUint8(e++);m+=16&r?a:-a,u.push(m)}else 16&r||(m+=t.getInt16(e),e+=2),u.push(m);n[p]===a&&(p++,h.push(u),u=[])}m=0,p=0;for(let a=0;a<s;a++){const i=l[a];if(4&i){const a=t.getUint8(e++);m+=32&i?a:-a,d.push(m)}else 32&i||(m+=t.getInt16(e),e+=2),d.push(m);f.push(1&i|64&i),n[p]===a&&(u=h[p],p++,g.push(new r({flags:f,xCoordinates:u,yCoordinates:d})),d=[],f=[])}return new i({contours:g,instructions:c})}getSize(){let e=2*this.contours.length+2+this.instructions.length,t=0,a=0;for(const n of this.contours){e+=n.flags.length;for(let r=0,i=n.xCoordinates.length;r<i;r++){const i=n.xCoordinates[r],s=n.yCoordinates[r];let o=Math.abs(i-t);o>255?e+=2:o>0&&(e+=1),t=i,o=Math.abs(s-a),o>255?e+=2:o>0&&(e+=1),a=s}}return e}write(e,t){const a=e,n=[],r=[],i=[];let s=0,o=0;for(const a of this.contours){for(let e=0,t=a.xCoordinates.length;e<t;e++){let t=a.flags[e];const c=a.xCoordinates[e];let l=c-s;if(0===l)t|=16,n.push(0);else{const e=Math.abs(l);e<=255?(t|=l>=0?18:2,n.push(e)):n.push(l)}s=c;const h=a.yCoordinates[e];if(l=h-o,0===l)t|=32,r.push(0);else{const e=Math.abs(l);e<=255?(t|=l>=0?36:4,r.push(e)):r.push(l)}o=h,i.push(t)}t.setUint16(e,n.length-1),e+=2}t.setUint16(e,this.instructions.length),e+=2,this.instructions.length&&(new Uint8Array(t.buffer,0,t.buffer.byteLength).set(this.instructions,e),e+=this.instructions.length);for(const a of i)t.setUint8(e++,a);for(let a=0,r=n.length;a<r;a++){const r=n[a],s=i[a];2&s?t.setUint8(e++,r):16&s||(t.setInt16(e,r),e+=2)}for(let a=0,n=r.length;a<n;a++){const n=r[a],s=i[a];4&s?t.setUint8(e++,n):32&s||(t.setInt16(e,n),e+=2)}return e-a}scale(e,t){for(const a of this.contours)if(0!==a.xCoordinates.length)for(let n=0,r=a.xCoordinates.length;n<r;n++)a.xCoordinates[n]=Math.round(e+(a.xCoordinates[n]-e)*t)}}class s{constructor({flags:e,glyphIndex:t,argument1:a,argument2:n,transf:r,instructions:i}){this.flags=e,this.glyphIndex=t,this.argument1=a,this.argument2=n,this.transf=r,this.instructions=i}static parse(e,t){const a=e,n=[];let r=t.getUint16(e);const i=t.getUint16(e+2);let o,c;e+=4,1&r?(2&r?(o=t.getInt16(e),c=t.getInt16(e+2)):(o=t.getUint16(e),c=t.getUint16(e+2)),e+=4,r^=1):(2&r?(o=t.getInt8(e),c=t.getInt8(e+1)):(o=t.getUint8(e),c=t.getUint8(e+1)),e+=2),8&r?(n.push(t.getUint16(e)),e+=2):64&r?(n.push(t.getUint16(e),t.getUint16(e+2)),e+=4):128&r&&(n.push(t.getUint16(e),t.getUint16(e+2),t.getUint16(e+4),t.getUint16(e+6)),e+=8);let l=null;if(256&r){const a=t.getUint16(e);e+=2,l=new Uint8Array(t).slice(e,e+a),e+=a}return[e-a,new s({flags:r,glyphIndex:i,argument1:o,argument2:c,transf:n,instructions:l})]}getSize(){let e=4+2*this.transf.length;return 256&this.flags&&(e+=2+this.instructions.length),e+=2,2&this.flags?this.argument1>=-128&&this.argument1<=127&&this.argument2>=-128&&this.argument2<=127||(e+=2):this.argument1>=0&&this.argument1<=255&&this.argument2>=0&&this.argument2<=255||(e+=2),e}write(e,t){const a=e;return 2&this.flags?this.argument1>=-128&&this.argument1<=127&&this.argument2>=-128&&this.argument2<=127||(this.flags|=1):this.argument1>=0&&this.argument1<=255&&this.argument2>=0&&this.argument2<=255||(this.flags|=1),t.setUint16(e,this.flags),t.setUint16(e+2,this.glyphIndex),e+=4,1&this.flags?(2&this.flags?(t.setInt16(e,this.argument1),t.setInt16(e+2,this.argument2)):(t.setUint16(e,this.argument1),t.setUint16(e+2,this.argument2)),e+=4):(t.setUint8(e,this.argument1),t.setUint8(e+1,this.argument2),e+=2),256&this.flags&&(t.setUint16(e,this.instructions.length),e+=2,this.instructions.length&&(new Uint8Array(t.buffer,0,t.buffer.byteLength).set(this.instructions,e),e+=this.instructions.length)),e-a}scale(e,t){}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.OpenTypeFileBuilder=void 0;var n=a(3),r=a(2);function i(e,t,a){e[t]=a>>8&255,e[t+1]=255&a}function s(e,t,a){e[t]=a>>24&255,e[t+1]=a>>16&255,e[t+2]=a>>8&255,e[t+3]=255&a}function o(e,t,a){if(a instanceof Uint8Array)e.set(a,t);else if("string"==typeof a)for(let n=0,r=a.length;n<r;n++)e[t++]=255&a.charCodeAt(n);else for(const n of a)e[t++]=255&n}class c{constructor(e){this.sfnt=e,this.tables=Object.create(null)}static getSearchParams(e,t){let a=1,n=0;for(;(a^e)>a;)a<<=1,n++;const r=a*t;return{range:r,entry:n,rangeShift:t*e-r}}toArray(){let e=this.sfnt;const t=this.tables,a=Object.keys(t);a.sort();const l=a.length;let h,u,d,f,g,p=12+16*l;const m=[p];for(h=0;h<l;h++){f=t[a[h]];p+=(f.length+3&-4)>>>0,m.push(p)}const b=new Uint8Array(p);for(h=0;h<l;h++)f=t[a[h]],o(b,m[h],f);"true"===e&&(e=(0,r.string32)(65536)),b[0]=255&e.charCodeAt(0),b[1]=255&e.charCodeAt(1),b[2]=255&e.charCodeAt(2),b[3]=255&e.charCodeAt(3),i(b,4,l);const y=c.getSearchParams(l,16);for(i(b,6,y.range),i(b,8,y.entry),i(b,10,y.rangeShift),p=12,h=0;h<l;h++){g=a[h],b[p]=255&g.charCodeAt(0),b[p+1]=255&g.charCodeAt(1),b[p+2]=255&g.charCodeAt(2),b[p+3]=255&g.charCodeAt(3);let e=0;for(u=m[h],d=m[h+1];u<d;u+=4){e=e+(0,n.readUint32)(b,u)>>>0}s(b,p+4,e),s(b,p+8,m[h]),s(b,p+12,t[g].length),p+=16}return b}addTable(e,t){if(e in this.tables)throw new Error("Table "+e+" already exists");this.tables[e]=t}}t.OpenTypeFileBuilder=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Type1Font=void 0;var n=a(35),r=a(2),i=a(38),s=a(3),o=a(8),c=a(49);function l(e,t,a){const n=e.length,r=t.length,i=n-r;let o=a,c=!1;for(;o<i;){let a=0;for(;a<r&&e[o+a]===t[a];)a++;if(a>=r){for(o+=a;o<n&&(0,s.isWhiteSpace)(e[o]);)o++;c=!0;break}o++}return{found:c,length:o}}t.Type1Font=class{constructor(e,t,a){let n=a.length1,s=a.length2,h=t.peekBytes(6);const u=128===h[0]&&1===h[1];u&&(t.skip(6),n=h[5]<<24|h[4]<<16|h[3]<<8|h[2]);const d=function(e,t){const a=[101,101,120,101,99],n=e.pos;let i,s,c,h;try{i=e.getBytes(t),s=i.length}catch{}if(s===t&&(c=l(i,a,t-2*a.length),c.found&&c.length===t))return{stream:new o.Stream(i),length:t};for((0,r.warn)('Invalid "Length1" property in Type1 font -- trying to recover.'),e.pos=n;c=l(e.peekBytes(2048),a,0),0!==c.length;)if(e.pos+=c.length,c.found){h=e.pos-n;break}return e.pos=n,h?{stream:new o.Stream(e.getBytes(h)),length:h}:((0,r.warn)('Unable to recover "Length1" property in Type1 font -- using as is.'),{stream:new o.Stream(e.getBytes(t)),length:t})}(t,n);new c.Type1Parser(d.stream,!1,i.SEAC_ANALYSIS_ENABLED).extractFontHeader(a),u&&(h=t.getBytes(6),s=h[5]<<24|h[4]<<16|h[3]<<8|h[2]);const f=function(e,t){const a=e.getBytes();if(0===a.length)throw new r.FormatError("getEexecBlock - no font program found.");return{stream:new o.Stream(a),length:a.length}}(t),g=new c.Type1Parser(f.stream,!0,i.SEAC_ANALYSIS_ENABLED).extractFontProgram(a);for(const e in g.properties)a[e]=g.properties[e];const p=g.charstrings,m=this.getType2Charstrings(p),b=this.getType2Subrs(g.subrs);this.charstrings=p,this.data=this.wrap(e,m,this.charstrings,b,a),this.seacs=this.getSeacs(g.charstrings)}get numGlyphs(){return this.charstrings.length+1}getCharset(){const e=[".notdef"];for(const{glyphName:t}of this.charstrings)e.push(t);return e}getGlyphMapping(e){const t=this.charstrings;if(e.composite){const a=Object.create(null);for(let n=0,r=t.length;n<r;n++){a[e.cMap.charCodeOf(n)]=n+1}return a}const a=[".notdef"];let n,r;for(r=0;r<t.length;r++)a.push(t[r].glyphName);const s=e.builtInEncoding;if(s){n=Object.create(null);for(const e in s)r=a.indexOf(s[e]),r>=0&&(n[e]=r)}return(0,i.type1FontGlyphMapping)(e,n,a)}hasGlyphId(e){if(e<0||e>=this.numGlyphs)return!1;if(0===e)return!0;return this.charstrings[e-1].charstring.length>0}getSeacs(e){const t=[];for(let a=0,n=e.length;a<n;a++){const n=e[a];n.seac&&(t[a+1]=n.seac)}return t}getType2Charstrings(e){const t=[];for(const a of e)t.push(a.charstring);return t}getType2Subrs(e){let t=0;const a=e.length;t=a<1133?107:a<33769?1131:32768;const n=[];let r;for(r=0;r<t;r++)n.push([11]);for(r=0;r<a;r++)n.push(e[r]);return n}wrap(e,t,a,r,i){const s=new n.CFF;s.header=new n.CFFHeader(1,0,4,4),s.names=[e];const o=new n.CFFTopDict;o.setByName("version",391),o.setByName("Notice",392),o.setByName("FullName",393),o.setByName("FamilyName",394),o.setByName("Weight",395),o.setByName("Encoding",null),o.setByName("FontMatrix",i.fontMatrix),o.setByName("FontBBox",i.bbox),o.setByName("charset",null),o.setByName("CharStrings",null),o.setByName("Private",null),s.topDict=o;const c=new n.CFFStrings;c.add("Version 0.11"),c.add("See original notice"),c.add(e),c.add(e),c.add("Medium"),s.strings=c,s.globalSubrIndex=new n.CFFIndex;const l=t.length,h=[".notdef"];let u,d;for(u=0;u<l;u++){const e=a[u].glyphName;-1===n.CFFStandardStrings.indexOf(e)&&c.add(e),h.push(e)}s.charset=new n.CFFCharset(!1,0,h);const f=new n.CFFIndex;for(f.add([139,14]),u=0;u<l;u++)f.add(t[u]);s.charStrings=f;const g=new n.CFFPrivateDict;g.setByName("Subrs",null);const p=["BlueValues","OtherBlues","FamilyBlues","FamilyOtherBlues","StemSnapH","StemSnapV","BlueShift","BlueFuzz","BlueScale","LanguageGroup","ExpansionFactor","ForceBold","StdHW","StdVW"];for(u=0,d=p.length;u<d;u++){const e=p[u];if(!(e in i.privateData))continue;const t=i.privateData[e];if(Array.isArray(t))for(let e=t.length-1;e>0;e--)t[e]-=t[e-1];g.setByName(e,t)}s.topDict.privateDict=g;const m=new n.CFFIndex;for(u=0,d=r.length;u<d;u++)m.add(r[u]);g.subrsIndex=m;return new n.CFFCompiler(s).compile()}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Type1Parser=void 0;var n=a(37),r=a(3),i=a(8),s=a(2);const o=[4],c=[5],l=[6],h=[7],u=[8],d=[12,35],f=[14],g=[21],p=[22],m=[30],b=[31];class y{constructor(){this.width=0,this.lsb=0,this.flexing=!1,this.output=[],this.stack=[]}convert(e,t,a){const n=e.length;let r,i,y,w=!1;for(let x=0;x<n;x++){let n=e[x];if(n<32){switch(12===n&&(n=(n<<8)+e[++x]),n){case 1:case 3:case 9:case 3072:case 3073:case 3074:case 3105:this.stack=[];break;case 4:if(this.flexing){if(this.stack.length<1){w=!0;break}const e=this.stack.pop();this.stack.push(0,e);break}w=this.executeCommand(1,o);break;case 5:w=this.executeCommand(2,c);break;case 6:w=this.executeCommand(1,l);break;case 7:w=this.executeCommand(1,h);break;case 8:w=this.executeCommand(6,u);break;case 10:if(this.stack.length<1){w=!0;break}if(y=this.stack.pop(),!t[y]){w=!0;break}w=this.convert(t[y],t,a);break;case 11:return w;case 13:if(this.stack.length<2){w=!0;break}r=this.stack.pop(),i=this.stack.pop(),this.lsb=i,this.width=r,this.stack.push(r,i),w=this.executeCommand(2,p);break;case 14:this.output.push(f[0]);break;case 21:if(this.flexing)break;w=this.executeCommand(2,g);break;case 22:if(this.flexing){this.stack.push(0);break}w=this.executeCommand(1,p);break;case 30:w=this.executeCommand(4,m);break;case 31:w=this.executeCommand(4,b);break;case 3078:if(a){const e=this.stack.at(-5);this.seac=this.stack.splice(-4,4),this.seac[0]+=this.lsb-e,w=this.executeCommand(0,f)}else w=this.executeCommand(4,f);break;case 3079:if(this.stack.length<4){w=!0;break}this.stack.pop(),r=this.stack.pop();const e=this.stack.pop();i=this.stack.pop(),this.lsb=i,this.width=r,this.stack.push(r,i,e),w=this.executeCommand(3,g);break;case 3084:if(this.stack.length<2){w=!0;break}const x=this.stack.pop(),S=this.stack.pop();this.stack.push(S/x);break;case 3088:if(this.stack.length<2){w=!0;break}y=this.stack.pop();const A=this.stack.pop();if(0===y&&3===A){const e=this.stack.splice(-17,17);this.stack.push(e[2]+e[0],e[3]+e[1],e[4],e[5],e[6],e[7],e[8],e[9],e[10],e[11],e[12],e[13],e[14]),w=this.executeCommand(13,d,!0),this.flexing=!1,this.stack.push(e[15],e[16])}else 1===y&&0===A&&(this.flexing=!0);break;case 3089:break;default:(0,s.warn)('Unknown type 1 charstring command of "'+n+'"')}if(w)break}else n<=246?n-=139:n=n<=250?256*(n-247)+e[++x]+108:n<=254?-256*(n-251)-e[++x]-108:(255&e[++x])<<24|(255&e[++x])<<16|(255&e[++x])<<8|(255&e[++x])<<0,this.stack.push(n)}return w}executeCommand(e,t,a){const n=this.stack.length;if(e>n)return!0;const r=n-e;for(let e=r;e<n;e++){let t=this.stack[e];Number.isInteger(t)?this.output.push(28,t>>8&255,255&t):(t=65536*t|0,this.output.push(255,t>>24&255,t>>16&255,t>>8&255,255&t))}return this.output.push(...t),a?this.stack.splice(r,e):this.stack.length=0,!1}}function w(e){return e>=48&&e<=57||e>=65&&e<=70||e>=97&&e<=102}function x(e,t,a){if(a>=e.length)return new Uint8Array(0);let n,r,i=0|t;for(n=0;n<a;n++)i=52845*(e[n]+i)+22719&65535;const s=e.length-a,o=new Uint8Array(s);for(n=a,r=0;r<s;n++,r++){const t=e[n];o[r]=t^i>>8,i=52845*(t+i)+22719&65535}return o}function S(e){return 47===e||91===e||93===e||123===e||125===e||40===e||41===e}t.Type1Parser=class{constructor(e,t,a){if(t){const t=e.getBytes(),a=!((w(t[0])||(0,r.isWhiteSpace)(t[0]))&&w(t[1])&&w(t[2])&&w(t[3])&&w(t[4])&&w(t[5])&&w(t[6])&&w(t[7]));e=new i.Stream(a?x(t,55665,4):function(e,t,a){let n=0|t;const r=e.length,i=new Uint8Array(r>>>1);let s,o;for(s=0,o=0;s<r;s++){const t=e[s];if(!w(t))continue;let a;for(s++;s<r&&!w(a=e[s]);)s++;if(s<r){const e=parseInt(String.fromCharCode(t,a),16);i[o++]=e^n>>8,n=52845*(e+n)+22719&65535}}return i.slice(a,o)}(t,55665,4))}this.seacAnalysisEnabled=!!a,this.stream=e,this.nextChar()}readNumberArray(){this.getToken();const e=[];for(;;){const t=this.getToken();if(null===t||"]"===t||"}"===t)break;e.push(parseFloat(t||0))}return e}readNumber(){const e=this.getToken();return parseFloat(e||0)}readInt(){const e=this.getToken();return 0|parseInt(e||0,10)}readBoolean(){return"true"===this.getToken()?1:0}nextChar(){return this.currentChar=this.stream.getByte()}prevChar(){return this.stream.skip(-2),this.currentChar=this.stream.getByte()}getToken(){let e=!1,t=this.currentChar;for(;;){if(-1===t)return null;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(!(0,r.isWhiteSpace)(t))break;t=this.nextChar()}if(S(t))return this.nextChar(),String.fromCharCode(t);let a="";do{a+=String.fromCharCode(t),t=this.nextChar()}while(t>=0&&!(0,r.isWhiteSpace)(t)&&!S(t));return a}readCharStrings(e,t){return-1===t?e:x(e,4330,t)}extractFontProgram(e){const t=this.stream,a=[],n=[],r=Object.create(null);r.lenIV=4;const i={subrs:[],charstrings:[],properties:{privateData:r}};let s,o,c,l;for(;null!==(s=this.getToken());)if("/"===s)switch(s=this.getToken(),s){case"CharStrings":for(this.getToken(),this.getToken(),this.getToken(),this.getToken();s=this.getToken(),null!==s&&"end"!==s;){if("/"!==s)continue;const e=this.getToken();o=this.readInt(),this.getToken(),c=o>0?t.getBytes(o):new Uint8Array(0),l=i.properties.privateData.lenIV;const a=this.readCharStrings(c,l);this.nextChar(),s=this.getToken(),"noaccess"===s?this.getToken():"/"===s&&this.prevChar(),n.push({glyph:e,encoded:a})}break;case"Subrs":for(this.readInt(),this.getToken();"dup"===this.getToken();){const e=this.readInt();o=this.readInt(),this.getToken(),c=o>0?t.getBytes(o):new Uint8Array(0),l=i.properties.privateData.lenIV;const n=this.readCharStrings(c,l);this.nextChar(),s=this.getToken(),"noaccess"===s&&this.getToken(),a[e]=n}break;case"BlueValues":case"OtherBlues":case"FamilyBlues":case"FamilyOtherBlues":const e=this.readNumberArray();e.length>0&&e.length,0;break;case"StemSnapH":case"StemSnapV":i.properties.privateData[s]=this.readNumberArray();break;case"StdHW":case"StdVW":i.properties.privateData[s]=this.readNumberArray()[0];break;case"BlueShift":case"lenIV":case"BlueFuzz":case"BlueScale":case"LanguageGroup":i.properties.privateData[s]=this.readNumber();break;case"ExpansionFactor":i.properties.privateData[s]=this.readNumber()||.06;break;case"ForceBold":i.properties.privateData[s]=this.readBoolean()}for(const{encoded:t,glyph:r}of n){const n=new y,s=n.convert(t,a,this.seacAnalysisEnabled);let o=n.output;s&&(o=[14]);const c={glyphName:r,charstring:o,width:n.width,lsb:n.lsb,seac:n.seac};if(".notdef"===r?i.charstrings.unshift(c):i.charstrings.push(c),e.builtInEncoding){const t=e.builtInEncoding.indexOf(r);t>-1&&void 0===e.widths[t]&&t>=e.firstChar&&t<=e.lastChar&&(e.widths[t]=n.width)}}return i}extractFontHeader(e){let t;for(;null!==(t=this.getToken());)if("/"===t)switch(t=this.getToken(),t){case"FontMatrix":const a=this.readNumberArray();e.fontMatrix=a;break;case"Encoding":const r=this.getToken();let i;if(/^\d+$/.test(r)){i=[];const e=0|parseInt(r,10);this.getToken();for(let a=0;a<e;a++){for(t=this.getToken();"dup"!==t&&"def"!==t;)if(t=this.getToken(),null===t)return;if("def"===t)break;const e=this.readInt();this.getToken();const a=this.getToken();i[e]=a,this.getToken()}}else i=(0,n.getEncoding)(r);e.builtInEncoding=i;break;case"FontBBox":const s=this.readNumberArray();e.ascent=Math.max(s[3],s[1]),e.descent=Math.min(s[1],s[3]),e.ascentScaled=!0}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Pattern=void 0,t.clearPatternCaches=function(){m=Object.create(null)},t.getTilingPatternIR=function(e,t,a){const r=t.getArray("Matrix"),i=n.Util.normalizeRect(t.getArray("BBox")),s=t.get("XStep"),o=t.get("YStep"),c=t.get("PaintType"),l=t.get("TilingType");if(i[2]-i[0]==0||i[3]-i[1]==0)throw new n.FormatError(`Invalid getTilingPatternIR /BBox array: [${i}].`);return["TilingPattern",a,e,r,i,s,o,c,l]};var n=a(2),r=a(5),i=a(12),s=a(3);const o=2,c=3,l=4,h=5,u=6,d=7;t.Pattern=class{constructor(){(0,n.unreachable)("Cannot initialize Pattern.")}static parseShading(e,t,a,i,f){const p=e instanceof r.BaseStream?e.dict:e,m=p.get("ShadingType");try{switch(m){case o:case c:return new g(p,t,a,i,f);case l:case h:case u:case d:return new y(e,t,a,i,f);default:throw new n.FormatError("Unsupported ShadingType: "+m)}}catch(e){if(e instanceof s.MissingDataException)throw e;return(0,n.warn)(e),new w}}};class f{static SMALL_NUMBER=1e-6;constructor(){this.constructor===f&&(0,n.unreachable)("Cannot initialize BaseShading.")}getIR(){(0,n.unreachable)("Abstract method `getIR` called.")}}class g extends f{constructor(e,t,a,r,s){super(),this.coordsArr=e.getArray("Coords"),this.shadingType=e.get("ShadingType");const o=i.ColorSpace.parse({cs:e.getRaw("CS")||e.getRaw("ColorSpace"),xref:t,resources:a,pdfFunctionFactory:r,localColorSpaceCache:s}),l=e.getArray("BBox");this.bbox=Array.isArray(l)&&4===l.length?n.Util.normalizeRect(l):null;let h=0,u=1;if(e.has("Domain")){const t=e.getArray("Domain");h=t[0],u=t[1]}let d=!1,g=!1;if(e.has("Extend")){const t=e.getArray("Extend");d=t[0],g=t[1]}if(!(this.shadingType!==c||d&&g)){const[e,t,a,r,i,s]=this.coordsArr,o=Math.hypot(e-r,t-i);a<=s+o&&s<=a+o&&(0,n.warn)("Unsupported radial gradient.")}this.extendStart=d,this.extendEnd=g;const p=e.getRaw("Function"),m=r.createFromArray(p),b=(u-h)/840,y=this.colorStops=[];if(h>=u||b<=0)return void(0,n.info)("Bad shading domain.");const w=new Float32Array(o.numComps),x=new Float32Array(1);let S,A=0;x[0]=h,m(x,0,w,0);let k=o.getRgb(w,0);const C=n.Util.makeHexColor(k[0],k[1],k[2]);y.push([0,C]);let v=1;x[0]=h+b,m(x,0,w,0);let F=o.getRgb(w,0),O=F[0]-k[0]+1,I=F[1]-k[1]+1,T=F[2]-k[2]+1,M=F[0]-k[0]-1,P=F[1]-k[1]-1,N=F[2]-k[2]-1;for(let e=2;e<840;e++){x[0]=h+e*b,m(x,0,w,0),S=o.getRgb(w,0);const t=e-A;O=Math.min(O,(S[0]-k[0]+1)/t),I=Math.min(I,(S[1]-k[1]+1)/t),T=Math.min(T,(S[2]-k[2]+1)/t),M=Math.max(M,(S[0]-k[0]-1)/t),P=Math.max(P,(S[1]-k[1]-1)/t),N=Math.max(N,(S[2]-k[2]-1)/t);if(!(M<=O&&P<=I&&N<=T)){const e=n.Util.makeHexColor(F[0],F[1],F[2]);y.push([v/840,e]),O=S[0]-F[0]+1,I=S[1]-F[1]+1,T=S[2]-F[2]+1,M=S[0]-F[0]-1,P=S[1]-F[1]-1,N=S[2]-F[2]-1,A=v,k=F}v=e,F=S}const D=n.Util.makeHexColor(F[0],F[1],F[2]);y.push([1,D]);let R="transparent";e.has("Background")&&(S=o.getRgb(e.get("Background"),0),R=n.Util.makeHexColor(S[0],S[1],S[2])),d||(y.unshift([0,R]),y[1][0]+=f.SMALL_NUMBER),g||(y.at(-1)[0]-=f.SMALL_NUMBER,y.push([1,R])),this.colorStops=y}getIR(){const e=this.coordsArr,t=this.shadingType;let a,r,i,s,l;return t===o?(r=[e[0],e[1]],i=[e[2],e[3]],s=null,l=null,a="axial"):t===c?(r=[e[0],e[1]],i=[e[3],e[4]],s=e[2],l=e[5],a="radial"):(0,n.unreachable)(`getPattern type unknown: ${t}`),["RadialAxial",a,this.bbox,this.colorStops,r,i,s,l]}}class p{constructor(e,t){this.stream=e,this.context=t,this.buffer=0,this.bufferLength=0;const a=t.numComps;this.tmpCompsBuf=new Float32Array(a);const n=t.colorSpace.numComps;this.tmpCsCompsBuf=t.colorFn?new Float32Array(n):this.tmpCompsBuf}get hasData(){if(this.stream.end)return this.stream.pos<this.stream.end;if(this.bufferLength>0)return!0;const e=this.stream.getByte();return!(e<0)&&(this.buffer=e,this.bufferLength=8,!0)}readBits(e){let t=this.buffer,a=this.bufferLength;if(32===e){if(0===a)return(this.stream.getByte()<<24|this.stream.getByte()<<16|this.stream.getByte()<<8|this.stream.getByte())>>>0;t=t<<24|this.stream.getByte()<<16|this.stream.getByte()<<8|this.stream.getByte();const e=this.stream.getByte();return this.buffer=e&(1<<a)-1,(t<<8-a|(255&e)>>a)>>>0}if(8===e&&0===a)return this.stream.getByte();for(;a<e;)t=t<<8|this.stream.getByte(),a+=8;return a-=e,this.bufferLength=a,this.buffer=t&(1<<a)-1,t>>a}align(){this.buffer=0,this.bufferLength=0}readFlag(){return this.readBits(this.context.bitsPerFlag)}readCoordinate(){const e=this.context.bitsPerCoordinate,t=this.readBits(e),a=this.readBits(e),n=this.context.decode,r=e<32?1/((1<<e)-1):2.3283064365386963e-10;return[t*r*(n[1]-n[0])+n[0],a*r*(n[3]-n[2])+n[2]]}readComponents(){const e=this.context.numComps,t=this.context.bitsPerComponent,a=t<32?1/((1<<t)-1):2.3283064365386963e-10,n=this.context.decode,r=this.tmpCompsBuf;for(let i=0,s=4;i<e;i++,s+=2){const e=this.readBits(t);r[i]=e*a*(n[s+1]-n[s])+n[s]}const i=this.tmpCsCompsBuf;return this.context.colorFn&&this.context.colorFn(r,0,i,0),this.context.colorSpace.getRgb(i,0)}}let m=Object.create(null);function b(e){return m[e]||=function(e){const t=[];for(let a=0;a<=e;a++){const n=a/e,r=1-n;t.push(new Float32Array([r**3,3*n*r**2,3*n**2*r,n**3]))}return t}(e)}class y extends f{static MIN_SPLIT_PATCH_CHUNKS_AMOUNT=3;static MAX_SPLIT_PATCH_CHUNKS_AMOUNT=20;static TRIANGLE_DENSITY=20;constructor(e,t,a,s,o){if(super(),!(e instanceof r.BaseStream))throw new n.FormatError("Mesh data is not a stream");const c=e.dict;this.shadingType=c.get("ShadingType");const f=c.getArray("BBox");this.bbox=Array.isArray(f)&&4===f.length?n.Util.normalizeRect(f):null;const g=i.ColorSpace.parse({cs:c.getRaw("CS")||c.getRaw("ColorSpace"),xref:t,resources:a,pdfFunctionFactory:s,localColorSpaceCache:o});this.background=c.has("Background")?g.getRgb(c.get("Background"),0):null;const m=c.getRaw("Function"),b=m?s.createFromArray(m):null;this.coords=[],this.colors=[],this.figures=[];const y={bitsPerCoordinate:c.get("BitsPerCoordinate"),bitsPerComponent:c.get("BitsPerComponent"),bitsPerFlag:c.get("BitsPerFlag"),decode:c.getArray("Decode"),colorFn:b,colorSpace:g,numComps:b?1:g.numComps},w=new p(e,y);let x=!1;switch(this.shadingType){case l:this._decodeType4Shading(w);break;case h:const e=0|c.get("VerticesPerRow");if(e<2)throw new n.FormatError("Invalid VerticesPerRow");this._decodeType5Shading(w,e);break;case u:this._decodeType6Shading(w),x=!0;break;case d:this._decodeType7Shading(w),x=!0;break;default:(0,n.unreachable)("Unsupported mesh type.")}if(x){this._updateBounds();for(let e=0,t=this.figures.length;e<t;e++)this._buildFigureFromPatch(e)}this._updateBounds(),this._packData()}_decodeType4Shading(e){const t=this.coords,a=this.colors,r=[],i=[];let s=0;for(;e.hasData;){const o=e.readFlag(),c=e.readCoordinate(),l=e.readComponents();if(0===s){if(!(0<=o&&o<=2))throw new n.FormatError("Unknown type4 flag");switch(o){case 0:s=3;break;case 1:i.push(i.at(-2),i.at(-1)),s=1;break;case 2:i.push(i.at(-3),i.at(-1)),s=1}r.push(o)}i.push(t.length),t.push(c),a.push(l),s--,e.align()}this.figures.push({type:"triangles",coords:new Int32Array(i),colors:new Int32Array(i)})}_decodeType5Shading(e,t){const a=this.coords,n=this.colors,r=[];for(;e.hasData;){const t=e.readCoordinate(),i=e.readComponents();r.push(a.length),a.push(t),n.push(i)}this.figures.push({type:"lattice",coords:new Int32Array(r),colors:new Int32Array(r),verticesPerRow:t})}_decodeType6Shading(e){const t=this.coords,a=this.colors,r=new Int32Array(16),i=new Int32Array(4);for(;e.hasData;){const s=e.readFlag();if(!(0<=s&&s<=3))throw new n.FormatError("Unknown type6 flag");const o=t.length;for(let a=0,n=0!==s?8:12;a<n;a++)t.push(e.readCoordinate());const c=a.length;for(let t=0,n=0!==s?2:4;t<n;t++)a.push(e.readComponents());let l,h,u,d;switch(s){case 0:r[12]=o+3,r[13]=o+4,r[14]=o+5,r[15]=o+6,r[8]=o+2,r[11]=o+7,r[4]=o+1,r[7]=o+8,r[0]=o,r[1]=o+11,r[2]=o+10,r[3]=o+9,i[2]=c+1,i[3]=c+2,i[0]=c,i[1]=c+3;break;case 1:l=r[12],h=r[13],u=r[14],d=r[15],r[12]=d,r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=u,r[11]=o+3,r[4]=h,r[7]=o+4,r[0]=l,r[1]=o+7,r[2]=o+6,r[3]=o+5,l=i[2],h=i[3],i[2]=h,i[3]=c,i[0]=l,i[1]=c+1;break;case 2:l=r[15],h=r[11],r[12]=r[3],r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=r[7],r[11]=o+3,r[4]=h,r[7]=o+4,r[0]=l,r[1]=o+7,r[2]=o+6,r[3]=o+5,l=i[3],i[2]=i[1],i[3]=c,i[0]=l,i[1]=c+1;break;case 3:r[12]=r[0],r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=r[1],r[11]=o+3,r[4]=r[2],r[7]=o+4,r[0]=r[3],r[1]=o+7,r[2]=o+6,r[3]=o+5,i[2]=i[0],i[3]=c,i[0]=i[1],i[1]=c+1}r[5]=t.length,t.push([(-4*t[r[0]][0]-t[r[15]][0]+6*(t[r[4]][0]+t[r[1]][0])-2*(t[r[12]][0]+t[r[3]][0])+3*(t[r[13]][0]+t[r[7]][0]))/9,(-4*t[r[0]][1]-t[r[15]][1]+6*(t[r[4]][1]+t[r[1]][1])-2*(t[r[12]][1]+t[r[3]][1])+3*(t[r[13]][1]+t[r[7]][1]))/9]),r[6]=t.length,t.push([(-4*t[r[3]][0]-t[r[12]][0]+6*(t[r[2]][0]+t[r[7]][0])-2*(t[r[0]][0]+t[r[15]][0])+3*(t[r[4]][0]+t[r[14]][0]))/9,(-4*t[r[3]][1]-t[r[12]][1]+6*(t[r[2]][1]+t[r[7]][1])-2*(t[r[0]][1]+t[r[15]][1])+3*(t[r[4]][1]+t[r[14]][1]))/9]),r[9]=t.length,t.push([(-4*t[r[12]][0]-t[r[3]][0]+6*(t[r[8]][0]+t[r[13]][0])-2*(t[r[0]][0]+t[r[15]][0])+3*(t[r[11]][0]+t[r[1]][0]))/9,(-4*t[r[12]][1]-t[r[3]][1]+6*(t[r[8]][1]+t[r[13]][1])-2*(t[r[0]][1]+t[r[15]][1])+3*(t[r[11]][1]+t[r[1]][1]))/9]),r[10]=t.length,t.push([(-4*t[r[15]][0]-t[r[0]][0]+6*(t[r[11]][0]+t[r[14]][0])-2*(t[r[12]][0]+t[r[3]][0])+3*(t[r[2]][0]+t[r[8]][0]))/9,(-4*t[r[15]][1]-t[r[0]][1]+6*(t[r[11]][1]+t[r[14]][1])-2*(t[r[12]][1]+t[r[3]][1])+3*(t[r[2]][1]+t[r[8]][1]))/9]),this.figures.push({type:"patch",coords:new Int32Array(r),colors:new Int32Array(i)})}}_decodeType7Shading(e){const t=this.coords,a=this.colors,r=new Int32Array(16),i=new Int32Array(4);for(;e.hasData;){const s=e.readFlag();if(!(0<=s&&s<=3))throw new n.FormatError("Unknown type7 flag");const o=t.length;for(let a=0,n=0!==s?12:16;a<n;a++)t.push(e.readCoordinate());const c=a.length;for(let t=0,n=0!==s?2:4;t<n;t++)a.push(e.readComponents());let l,h,u,d;switch(s){case 0:r[12]=o+3,r[13]=o+4,r[14]=o+5,r[15]=o+6,r[8]=o+2,r[9]=o+13,r[10]=o+14,r[11]=o+7,r[4]=o+1,r[5]=o+12,r[6]=o+15,r[7]=o+8,r[0]=o,r[1]=o+11,r[2]=o+10,r[3]=o+9,i[2]=c+1,i[3]=c+2,i[0]=c,i[1]=c+3;break;case 1:l=r[12],h=r[13],u=r[14],d=r[15],r[12]=d,r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=u,r[9]=o+9,r[10]=o+10,r[11]=o+3,r[4]=h,r[5]=o+8,r[6]=o+11,r[7]=o+4,r[0]=l,r[1]=o+7,r[2]=o+6,r[3]=o+5,l=i[2],h=i[3],i[2]=h,i[3]=c,i[0]=l,i[1]=c+1;break;case 2:l=r[15],h=r[11],r[12]=r[3],r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=r[7],r[9]=o+9,r[10]=o+10,r[11]=o+3,r[4]=h,r[5]=o+8,r[6]=o+11,r[7]=o+4,r[0]=l,r[1]=o+7,r[2]=o+6,r[3]=o+5,l=i[3],i[2]=i[1],i[3]=c,i[0]=l,i[1]=c+1;break;case 3:r[12]=r[0],r[13]=o+0,r[14]=o+1,r[15]=o+2,r[8]=r[1],r[9]=o+9,r[10]=o+10,r[11]=o+3,r[4]=r[2],r[5]=o+8,r[6]=o+11,r[7]=o+4,r[0]=r[3],r[1]=o+7,r[2]=o+6,r[3]=o+5,i[2]=i[0],i[3]=c,i[0]=i[1],i[1]=c+1}this.figures.push({type:"patch",coords:new Int32Array(r),colors:new Int32Array(i)})}}_buildFigureFromPatch(e){const t=this.figures[e];(0,n.assert)("patch"===t.type,"Unexpected patch mesh figure");const a=this.coords,r=this.colors,i=t.coords,s=t.colors,o=Math.min(a[i[0]][0],a[i[3]][0],a[i[12]][0],a[i[15]][0]),c=Math.min(a[i[0]][1],a[i[3]][1],a[i[12]][1],a[i[15]][1]),l=Math.max(a[i[0]][0],a[i[3]][0],a[i[12]][0],a[i[15]][0]),h=Math.max(a[i[0]][1],a[i[3]][1],a[i[12]][1],a[i[15]][1]);let u=Math.ceil((l-o)*y.TRIANGLE_DENSITY/(this.bounds[2]-this.bounds[0]));u=Math.max(y.MIN_SPLIT_PATCH_CHUNKS_AMOUNT,Math.min(y.MAX_SPLIT_PATCH_CHUNKS_AMOUNT,u));let d=Math.ceil((h-c)*y.TRIANGLE_DENSITY/(this.bounds[3]-this.bounds[1]));d=Math.max(y.MIN_SPLIT_PATCH_CHUNKS_AMOUNT,Math.min(y.MAX_SPLIT_PATCH_CHUNKS_AMOUNT,d));const f=u+1,g=new Int32Array((d+1)*f),p=new Int32Array((d+1)*f);let m=0;const w=new Uint8Array(3),x=new Uint8Array(3),S=r[s[0]],A=r[s[1]],k=r[s[2]],C=r[s[3]],v=b(d),F=b(u);for(let e=0;e<=d;e++){w[0]=(S[0]*(d-e)+k[0]*e)/d|0,w[1]=(S[1]*(d-e)+k[1]*e)/d|0,w[2]=(S[2]*(d-e)+k[2]*e)/d|0,x[0]=(A[0]*(d-e)+C[0]*e)/d|0,x[1]=(A[1]*(d-e)+C[1]*e)/d|0,x[2]=(A[2]*(d-e)+C[2]*e)/d|0;for(let t=0;t<=u;t++,m++){if(!(0!==e&&e!==d||0!==t&&t!==u))continue;let n=0,s=0,o=0;for(let r=0;r<=3;r++)for(let c=0;c<=3;c++,o++){const l=v[e][r]*F[t][c];n+=a[i[o]][0]*l,s+=a[i[o]][1]*l}g[m]=a.length,a.push([n,s]),p[m]=r.length;const c=new Uint8Array(3);c[0]=(w[0]*(u-t)+x[0]*t)/u|0,c[1]=(w[1]*(u-t)+x[1]*t)/u|0,c[2]=(w[2]*(u-t)+x[2]*t)/u|0,r.push(c)}}g[0]=i[0],p[0]=s[0],g[u]=i[3],p[u]=s[1],g[f*d]=i[12],p[f*d]=s[2],g[f*d+u]=i[15],p[f*d+u]=s[3],this.figures[e]={type:"lattice",coords:g,colors:p,verticesPerRow:f}}_updateBounds(){let e=this.coords[0][0],t=this.coords[0][1],a=e,n=t;for(let r=1,i=this.coords.length;r<i;r++){const i=this.coords[r][0],s=this.coords[r][1];e=e>i?i:e,t=t>s?s:t,a=a<i?i:a,n=n<s?s:n}this.bounds=[e,t,a,n]}_packData(){let e,t,a,n;const r=this.coords,i=new Float32Array(2*r.length);for(e=0,a=0,t=r.length;e<t;e++){const t=r[e];i[a++]=t[0],i[a++]=t[1]}this.coords=i;const s=this.colors,o=new Uint8Array(3*s.length);for(e=0,a=0,t=s.length;e<t;e++){const t=s[e];o[a++]=t[0],o[a++]=t[1],o[a++]=t[2]}this.colors=o;const c=this.figures;for(e=0,t=c.length;e<t;e++){const t=c[e],r=t.coords,i=t.colors;for(a=0,n=r.length;a<n;a++)r[a]*=2,i[a]*=3}}getIR(){return["Mesh",this.shadingType,this.coords,this.colors,this.figures,this.bounds,this.bbox,this.background]}}class w extends f{getIR(){return["Dummy"]}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getXfaFontDict=function(e){const t=function(e){const t=d(e);if(!t)return null;const{baseWidths:a,baseMapping:n,factors:r}=t,i=r?a.map(((e,t)=>e*r[t])):a;let s,o=-2;const c=[];for(const[e,t]of n.map(((e,t)=>[e,t])).sort((([e],[t])=>e-t)))-1!==e&&(e===o+1?(s.push(i[t]),o+=1):(o=e,s=[i[t]],c.push(e,s)));return c}(e),a=new r.Dict(null);a.set("BaseFont",r.Name.get(e)),a.set("Type",r.Name.get("Font")),a.set("Subtype",r.Name.get("CIDFontType2")),a.set("Encoding",r.Name.get("Identity-H")),a.set("CIDToGIDMap",r.Name.get("Identity")),a.set("W",t),a.set("FirstChar",t[0]),a.set("LastChar",t.at(-2)+t.at(-1).length-1);const n=new r.Dict(null);a.set("FontDescriptor",n);const i=new r.Dict(null);return i.set("Ordering","Identity"),i.set("Registry","Adobe"),i.set("Supplement",0),a.set("CIDSystemInfo",i),a},t.getXfaFontName=d;var n=a(52),r=a(4),i=a(53),s=a(54),o=a(55),c=a(56),l=a(3),h=a(38);const u=(0,l.getLookupTableFactory)((function(e){e["MyriadPro-Regular"]=e["PdfJS-Fallback-Regular"]={name:"LiberationSans-Regular",factors:o.MyriadProRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:o.MyriadProRegularMetrics},e["MyriadPro-Bold"]=e["PdfJS-Fallback-Bold"]={name:"LiberationSans-Bold",factors:o.MyriadProBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:o.MyriadProBoldMetrics},e["MyriadPro-It"]=e["MyriadPro-Italic"]=e["PdfJS-Fallback-Italic"]={name:"LiberationSans-Italic",factors:o.MyriadProItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:o.MyriadProItalicMetrics},e["MyriadPro-BoldIt"]=e["MyriadPro-BoldItalic"]=e["PdfJS-Fallback-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:o.MyriadProBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:o.MyriadProBoldItalicMetrics},e.ArialMT=e.Arial=e["Arial-Regular"]={name:"LiberationSans-Regular",baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping},e["Arial-BoldMT"]=e["Arial-Bold"]={name:"LiberationSans-Bold",baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping},e["Arial-ItalicMT"]=e["Arial-Italic"]={name:"LiberationSans-Italic",baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping},e["Arial-BoldItalicMT"]=e["Arial-BoldItalic"]={name:"LiberationSans-BoldItalic",baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping},e["Calibri-Regular"]={name:"LiberationSans-Regular",factors:n.CalibriRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:n.CalibriRegularMetrics},e["Calibri-Bold"]={name:"LiberationSans-Bold",factors:n.CalibriBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:n.CalibriBoldMetrics},e["Calibri-Italic"]={name:"LiberationSans-Italic",factors:n.CalibriItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:n.CalibriItalicMetrics},e["Calibri-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:n.CalibriBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:n.CalibriBoldItalicMetrics},e["Segoeui-Regular"]={name:"LiberationSans-Regular",factors:c.SegoeuiRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:c.SegoeuiRegularMetrics},e["Segoeui-Bold"]={name:"LiberationSans-Bold",factors:c.SegoeuiBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:c.SegoeuiBoldMetrics},e["Segoeui-Italic"]={name:"LiberationSans-Italic",factors:c.SegoeuiItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:c.SegoeuiItalicMetrics},e["Segoeui-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:c.SegoeuiBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:c.SegoeuiBoldItalicMetrics},e["Helvetica-Regular"]=e.Helvetica={name:"LiberationSans-Regular",factors:i.HelveticaRegularFactors,baseWidths:s.LiberationSansRegularWidths,baseMapping:s.LiberationSansRegularMapping,metrics:i.HelveticaRegularMetrics},e["Helvetica-Bold"]={name:"LiberationSans-Bold",factors:i.HelveticaBoldFactors,baseWidths:s.LiberationSansBoldWidths,baseMapping:s.LiberationSansBoldMapping,metrics:i.HelveticaBoldMetrics},e["Helvetica-Italic"]={name:"LiberationSans-Italic",factors:i.HelveticaItalicFactors,baseWidths:s.LiberationSansItalicWidths,baseMapping:s.LiberationSansItalicMapping,metrics:i.HelveticaItalicMetrics},e["Helvetica-BoldItalic"]={name:"LiberationSans-BoldItalic",factors:i.HelveticaBoldItalicFactors,baseWidths:s.LiberationSansBoldItalicWidths,baseMapping:s.LiberationSansBoldItalicMapping,metrics:i.HelveticaBoldItalicMetrics}}));function d(e){const t=(0,h.normalizeFontName)(e);return u()[t]}},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.CalibriRegularMetrics=t.CalibriRegularFactors=t.CalibriItalicMetrics=t.CalibriItalicFactors=t.CalibriBoldMetrics=t.CalibriBoldItalicMetrics=t.CalibriBoldItalicFactors=t.CalibriBoldFactors=void 0;t.CalibriBoldFactors=[1.3877,1,1,1,.97801,.92482,.89552,.91133,.81988,.97566,.98152,.93548,.93548,1.2798,.85284,.92794,1,.96134,1.54657,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.82845,.82845,.85284,.85284,.85284,.75859,.92138,.83908,.7762,.73293,.87289,.73133,.7514,.81921,.87356,.95958,.59526,.75727,.69225,1.04924,.9121,.86943,.79795,.88198,.77958,.70864,.81055,.90399,.88653,.96017,.82577,.77892,.78257,.97507,1.54657,.97507,.85284,.89552,.90176,.88762,.8785,.75241,.8785,.90518,.95015,.77618,.8785,.88401,.91916,.86304,.88401,.91488,.8785,.8801,.8785,.8785,.91343,.7173,1.04106,.8785,.85075,.95794,.82616,.85162,.79492,.88331,1.69808,.88331,.85284,.97801,.89552,.91133,.89552,.91133,1.7801,.89552,1.24487,1.13254,1.12401,.96839,.85284,.68787,.70645,.85592,.90747,1.01466,1.0088,.90323,1,1.07463,1,.91056,.75806,1.19118,.96839,.78864,.82845,.84133,.75859,.83908,.83908,.83908,.83908,.83908,.83908,.77539,.73293,.73133,.73133,.73133,.73133,.95958,.95958,.95958,.95958,.88506,.9121,.86943,.86943,.86943,.86943,.86943,.85284,.87508,.90399,.90399,.90399,.90399,.77892,.79795,.90807,.88762,.88762,.88762,.88762,.88762,.88762,.8715,.75241,.90518,.90518,.90518,.90518,.88401,.88401,.88401,.88401,.8785,.8785,.8801,.8801,.8801,.8801,.8801,.90747,.89049,.8785,.8785,.8785,.8785,.85162,.8785,.85162,.83908,.88762,.83908,.88762,.83908,.88762,.73293,.75241,.73293,.75241,.73293,.75241,.73293,.75241,.87289,.83016,.88506,.93125,.73133,.90518,.73133,.90518,.73133,.90518,.73133,.90518,.73133,.90518,.81921,.77618,.81921,.77618,.81921,.77618,1,1,.87356,.8785,.91075,.89608,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.76229,.90167,.59526,.91916,1,1,.86304,.69225,.88401,1,1,.70424,.79468,.91926,.88175,.70823,.94903,.9121,.8785,1,1,.9121,.8785,.87802,.88656,.8785,.86943,.8801,.86943,.8801,.86943,.8801,.87402,.89291,.77958,.91343,1,1,.77958,.91343,.70864,.7173,.70864,.7173,.70864,.7173,.70864,.7173,1,1,.81055,.75841,.81055,1.06452,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.90399,.8785,.96017,.95794,.77892,.85162,.77892,.78257,.79492,.78257,.79492,.78257,.79492,.9297,.56892,.83908,.88762,.77539,.8715,.87508,.89049,1,1,.81055,1.04106,1.20528,1.20528,1,1.15543,.70674,.98387,.94721,1.33431,1.45894,.95161,1.06303,.83908,.80352,.57184,.6965,.56289,.82001,.56029,.81235,1.02988,.83908,.7762,.68156,.80367,.73133,.78257,.87356,.86943,.95958,.75727,.89019,1.04924,.9121,.7648,.86943,.87356,.79795,.78275,.81055,.77892,.9762,.82577,.99819,.84896,.95958,.77892,.96108,1.01407,.89049,1.02988,.94211,.96108,.8936,.84021,.87842,.96399,.79109,.89049,1.00813,1.02988,.86077,.87445,.92099,.84723,.86513,.8801,.75638,.85714,.78216,.79586,.87965,.94211,.97747,.78287,.97926,.84971,1.02988,.94211,.8801,.94211,.84971,.73133,1,1,1,1,1,1,1,1,1,1,1,1,.90264,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.90518,1,1,1,1,1,1,1,1,1,1,1,1,.90548,1,1,1,1,1,1,.96017,.95794,.96017,.95794,.96017,.95794,.77892,.85162,1,1,.89552,.90527,1,.90363,.92794,.92794,.92794,.92794,.87012,.87012,.87012,.89552,.89552,1.42259,.71143,1.06152,1,1,1.03372,1.03372,.97171,1.4956,2.2807,.93835,.83406,.91133,.84107,.91133,1,1,1,.72021,1,1.23108,.83489,.88525,.88525,.81499,.90527,1.81055,.90527,1.81055,1.31006,1.53711,.94434,1.08696,1,.95018,.77192,.85284,.90747,1.17534,.69825,.9716,1.37077,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.08004,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,.90727,.90727,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriBoldMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriBoldItalicFactors=[1.3877,1,1,1,.97801,.92482,.89552,.91133,.81988,.97566,.98152,.93548,.93548,1.2798,.85284,.92794,1,.96134,1.56239,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.82845,.82845,.85284,.85284,.85284,.75859,.92138,.83908,.7762,.71805,.87289,.73133,.7514,.81921,.87356,.95958,.59526,.75727,.69225,1.04924,.90872,.85938,.79795,.87068,.77958,.69766,.81055,.90399,.88653,.96068,.82577,.77892,.78257,.97507,1.529,.97507,.85284,.89552,.90176,.94908,.86411,.74012,.86411,.88323,.95015,.86411,.86331,.88401,.91916,.86304,.88401,.9039,.86331,.86331,.86411,.86411,.90464,.70852,1.04106,.86331,.84372,.95794,.82616,.84548,.79492,.88331,1.69808,.88331,.85284,.97801,.89552,.91133,.89552,.91133,1.7801,.89552,1.24487,1.13254,1.19129,.96839,.85284,.68787,.70645,.85592,.90747,1.01466,1.0088,.90323,1,1.07463,1,.91056,.75806,1.19118,.96839,.78864,.82845,.84133,.75859,.83908,.83908,.83908,.83908,.83908,.83908,.77539,.71805,.73133,.73133,.73133,.73133,.95958,.95958,.95958,.95958,.88506,.90872,.85938,.85938,.85938,.85938,.85938,.85284,.87068,.90399,.90399,.90399,.90399,.77892,.79795,.90807,.94908,.94908,.94908,.94908,.94908,.94908,.85887,.74012,.88323,.88323,.88323,.88323,.88401,.88401,.88401,.88401,.8785,.86331,.86331,.86331,.86331,.86331,.86331,.90747,.89049,.86331,.86331,.86331,.86331,.84548,.86411,.84548,.83908,.94908,.83908,.94908,.83908,.94908,.71805,.74012,.71805,.74012,.71805,.74012,.71805,.74012,.87289,.79538,.88506,.92726,.73133,.88323,.73133,.88323,.73133,.88323,.73133,.88323,.73133,.88323,.81921,.86411,.81921,.86411,.81921,.86411,1,1,.87356,.86331,.91075,.8777,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.95958,.88401,.76467,.90167,.59526,.91916,1,1,.86304,.69225,.88401,1,1,.70424,.77312,.91926,.88175,.70823,.94903,.90872,.86331,1,1,.90872,.86331,.86906,.88116,.86331,.85938,.86331,.85938,.86331,.85938,.86331,.87402,.86549,.77958,.90464,1,1,.77958,.90464,.69766,.70852,.69766,.70852,.69766,.70852,.69766,.70852,1,1,.81055,.75841,.81055,1.06452,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.90399,.86331,.96068,.95794,.77892,.84548,.77892,.78257,.79492,.78257,.79492,.78257,.79492,.9297,.56892,.83908,.94908,.77539,.85887,.87068,.89049,1,1,.81055,1.04106,1.20528,1.20528,1,1.15543,.70088,.98387,.94721,1.33431,1.45894,.95161,1.48387,.83908,.80352,.57118,.6965,.56347,.79179,.55853,.80346,1.02988,.83908,.7762,.67174,.86036,.73133,.78257,.87356,.86441,.95958,.75727,.89019,1.04924,.90872,.74889,.85938,.87891,.79795,.7957,.81055,.77892,.97447,.82577,.97466,.87179,.95958,.77892,.94252,.95612,.8753,1.02988,.92733,.94252,.87411,.84021,.8728,.95612,.74081,.8753,1.02189,1.02988,.84814,.87445,.91822,.84723,.85668,.86331,.81344,.87581,.76422,.82046,.96057,.92733,.99375,.78022,.95452,.86015,1.02988,.92733,.86331,.92733,.86015,.73133,1,1,1,1,1,1,1,1,1,1,1,1,.90631,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.88323,1,1,1,1,1,1,1,1,1,1,1,1,.85174,1,1,1,1,1,1,.96068,.95794,.96068,.95794,.96068,.95794,.77892,.84548,1,1,.89552,.90527,1,.90363,.92794,.92794,.92794,.89807,.87012,.87012,.87012,.89552,.89552,1.42259,.71094,1.06152,1,1,1.03372,1.03372,.97171,1.4956,2.2807,.92972,.83406,.91133,.83326,.91133,1,1,1,.72021,1,1.23108,.83489,.88525,.88525,.81499,.90616,1.81055,.90527,1.81055,1.3107,1.53711,.94434,1.08696,1,.95018,.77192,.85284,.90747,1.17534,.69825,.9716,1.37077,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.08004,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,.90727,.90727,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriBoldItalicMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriItalicFactors=[1.3877,1,1,1,1.17223,1.1293,.89552,.91133,.80395,1.02269,1.15601,.91056,.91056,1.2798,.85284,.89807,1,.90861,1.39543,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.96309,.96309,.85284,.85284,.85284,.83319,.88071,.8675,.81552,.72346,.85193,.73206,.7522,.81105,.86275,.90685,.6377,.77892,.75593,1.02638,.89249,.84118,.77452,.85374,.75186,.67789,.79776,.88844,.85066,.94309,.77818,.7306,.76659,1.10369,1.38313,1.10369,1.06139,.89552,.8739,.9245,.9245,.83203,.9245,.85865,1.09842,.9245,.9245,1.03297,1.07692,.90918,1.03297,.94959,.9245,.92274,.9245,.9245,1.02933,.77832,1.20562,.9245,.8916,.98986,.86621,.89453,.79004,.94152,1.77256,.94152,.85284,.97801,.89552,.91133,.89552,.91133,1.91729,.89552,1.17889,1.13254,1.16359,.92098,.85284,.68787,.71353,.84737,.90747,1.0088,1.0044,.87683,1,1.09091,1,.92229,.739,1.15642,.92098,.76288,.80504,.80972,.75859,.8675,.8675,.8675,.8675,.8675,.8675,.76318,.72346,.73206,.73206,.73206,.73206,.90685,.90685,.90685,.90685,.86477,.89249,.84118,.84118,.84118,.84118,.84118,.85284,.84557,.88844,.88844,.88844,.88844,.7306,.77452,.86331,.9245,.9245,.9245,.9245,.9245,.9245,.84843,.83203,.85865,.85865,.85865,.85865,.82601,.82601,.82601,.82601,.94469,.9245,.92274,.92274,.92274,.92274,.92274,.90747,.86651,.9245,.9245,.9245,.9245,.89453,.9245,.89453,.8675,.9245,.8675,.9245,.8675,.9245,.72346,.83203,.72346,.83203,.72346,.83203,.72346,.83203,.85193,.8875,.86477,.99034,.73206,.85865,.73206,.85865,.73206,.85865,.73206,.85865,.73206,.85865,.81105,.9245,.81105,.9245,.81105,.9245,1,1,.86275,.9245,.90872,.93591,.90685,.82601,.90685,.82601,.90685,.82601,.90685,1.03297,.90685,.82601,.77896,1.05611,.6377,1.07692,1,1,.90918,.75593,1.03297,1,1,.76032,.9375,.98156,.93407,.77261,1.11429,.89249,.9245,1,1,.89249,.9245,.92534,.86698,.9245,.84118,.92274,.84118,.92274,.84118,.92274,.8667,.86291,.75186,1.02933,1,1,.75186,1.02933,.67789,.77832,.67789,.77832,.67789,.77832,.67789,.77832,1,1,.79776,.97655,.79776,1.23023,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.88844,.9245,.94309,.98986,.7306,.89453,.7306,.76659,.79004,.76659,.79004,.76659,.79004,1.09231,.54873,.8675,.9245,.76318,.84843,.84557,.86651,1,1,.79776,1.20562,1.18622,1.18622,1,1.1437,.67009,.96334,.93695,1.35191,1.40909,.95161,1.48387,.8675,.90861,.6192,.7363,.64824,.82411,.56321,.85696,1.23516,.8675,.81552,.7286,.84134,.73206,.76659,.86275,.84369,.90685,.77892,.85871,1.02638,.89249,.75828,.84118,.85984,.77452,.76466,.79776,.7306,.90782,.77818,.903,.87291,.90685,.7306,.99058,1.03667,.94635,1.23516,.9849,.99058,.92393,.8916,.942,1.03667,.75026,.94635,1.0297,1.23516,.90918,.94048,.98217,.89746,.84153,.92274,.82507,.88832,.84438,.88178,1.03525,.9849,1.00225,.78086,.97248,.89404,1.23516,.9849,.92274,.9849,.89404,.73206,1,1,1,1,1,1,1,1,1,1,1,1,.89693,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.85865,1,1,1,1,1,1,1,1,1,1,1,1,.90933,1,1,1,1,1,1,.94309,.98986,.94309,.98986,.94309,.98986,.7306,.89453,1,1,.89552,.90527,1,.90186,1.12308,1.12308,1.12308,1.12308,1.2566,1.2566,1.2566,.89552,.89552,1.42259,.68994,1.03809,1,1,1.0176,1.0176,1.11523,1.4956,2.01462,.97858,.82616,.91133,.83437,.91133,1,1,1,.70508,1,1.23108,.79801,.84426,.84426,.774,.90572,1.81055,.90749,1.81055,1.28809,1.55469,.94434,1.07806,1,.97094,.7589,.85284,.90747,1.19658,.69825,.97622,1.33512,.90747,.90747,.85284,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.0336,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,1.05859,1.05859,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.CalibriItalicMetrics={lineHeight:1.2207,lineGap:.2207};t.CalibriRegularFactors=[1.3877,1,1,1,1.17223,1.1293,.89552,.91133,.80395,1.02269,1.15601,.91056,.91056,1.2798,.85284,.89807,1,.90861,1.39016,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.91133,.96309,.96309,.85284,.85284,.85284,.83319,.88071,.8675,.81552,.73834,.85193,.73206,.7522,.81105,.86275,.90685,.6377,.77892,.75593,1.02638,.89385,.85122,.77452,.86503,.75186,.68887,.79776,.88844,.85066,.94258,.77818,.7306,.76659,1.10369,1.39016,1.10369,1.06139,.89552,.8739,.86128,.94469,.8457,.94469,.89464,1.09842,.84636,.94469,1.03297,1.07692,.90918,1.03297,.95897,.94469,.9482,.94469,.94469,1.04692,.78223,1.20562,.94469,.90332,.98986,.86621,.90527,.79004,.94152,1.77256,.94152,.85284,.97801,.89552,.91133,.89552,.91133,1.91729,.89552,1.17889,1.13254,1.08707,.92098,.85284,.68787,.71353,.84737,.90747,1.0088,1.0044,.87683,1,1.09091,1,.92229,.739,1.15642,.92098,.76288,.80504,.80972,.75859,.8675,.8675,.8675,.8675,.8675,.8675,.76318,.73834,.73206,.73206,.73206,.73206,.90685,.90685,.90685,.90685,.86477,.89385,.85122,.85122,.85122,.85122,.85122,.85284,.85311,.88844,.88844,.88844,.88844,.7306,.77452,.86331,.86128,.86128,.86128,.86128,.86128,.86128,.8693,.8457,.89464,.89464,.89464,.89464,.82601,.82601,.82601,.82601,.94469,.94469,.9482,.9482,.9482,.9482,.9482,.90747,.86651,.94469,.94469,.94469,.94469,.90527,.94469,.90527,.8675,.86128,.8675,.86128,.8675,.86128,.73834,.8457,.73834,.8457,.73834,.8457,.73834,.8457,.85193,.92454,.86477,.9921,.73206,.89464,.73206,.89464,.73206,.89464,.73206,.89464,.73206,.89464,.81105,.84636,.81105,.84636,.81105,.84636,1,1,.86275,.94469,.90872,.95786,.90685,.82601,.90685,.82601,.90685,.82601,.90685,1.03297,.90685,.82601,.77741,1.05611,.6377,1.07692,1,1,.90918,.75593,1.03297,1,1,.76032,.90452,.98156,1.11842,.77261,1.11429,.89385,.94469,1,1,.89385,.94469,.95877,.86901,.94469,.85122,.9482,.85122,.9482,.85122,.9482,.8667,.90016,.75186,1.04692,1,1,.75186,1.04692,.68887,.78223,.68887,.78223,.68887,.78223,.68887,.78223,1,1,.79776,.92188,.79776,1.23023,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.88844,.94469,.94258,.98986,.7306,.90527,.7306,.76659,.79004,.76659,.79004,.76659,.79004,1.09231,.54873,.8675,.86128,.76318,.8693,.85311,.86651,1,1,.79776,1.20562,1.18622,1.18622,1,1.1437,.67742,.96334,.93695,1.35191,1.40909,.95161,1.48387,.86686,.90861,.62267,.74359,.65649,.85498,.56963,.88254,1.23516,.8675,.81552,.75443,.84503,.73206,.76659,.86275,.85122,.90685,.77892,.85746,1.02638,.89385,.75657,.85122,.86275,.77452,.74171,.79776,.7306,.95165,.77818,.89772,.88831,.90685,.7306,.98142,1.02191,.96576,1.23516,.99018,.98142,.9236,.89258,.94035,1.02191,.78848,.96576,.9561,1.23516,.90918,.92578,.95424,.89746,.83969,.9482,.80113,.89442,.85208,.86155,.98022,.99018,1.00452,.81209,.99247,.89181,1.23516,.99018,.9482,.99018,.89181,.73206,1,1,1,1,1,1,1,1,1,1,1,1,.88844,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.89464,1,1,1,1,1,1,1,1,1,1,1,1,.96766,1,1,1,1,1,1,.94258,.98986,.94258,.98986,.94258,.98986,.7306,.90527,1,1,.89552,.90527,1,.90186,1.12308,1.12308,1.12308,1.12308,1.2566,1.2566,1.2566,.89552,.89552,1.42259,.69043,1.03809,1,1,1.0176,1.0176,1.11523,1.4956,2.01462,.99331,.82616,.91133,.84286,.91133,1,1,1,.70508,1,1.23108,.79801,.84426,.84426,.774,.90527,1.81055,.90527,1.81055,1.28809,1.55469,.94434,1.07806,1,.97094,.7589,.85284,.90747,1.19658,.69825,.97622,1.33512,.90747,.90747,.85356,.90747,.90747,1.44947,.85284,.8941,.8941,.70572,.8,.70572,.70572,.70572,.70572,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.99862,.99862,1,1,1,1,1,1.0336,.91027,1,1,1,.99862,1,1,1,1,1,1,1,1,1,1,1,1,1.05859,1.05859,1,1,1,1.07185,.99413,.96334,1.08065,1,1,1,1,1,1,1,1,1,1,1];t.CalibriRegularMetrics={lineHeight:1.2207,lineGap:.2207}},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.HelveticaRegularMetrics=t.HelveticaRegularFactors=t.HelveticaItalicMetrics=t.HelveticaItalicFactors=t.HelveticaBoldMetrics=t.HelveticaBoldItalicMetrics=t.HelveticaBoldItalicFactors=t.HelveticaBoldFactors=void 0;t.HelveticaBoldFactors=[.76116,1,1,1.0006,.99998,.99974,.99973,.99973,.99982,.99977,1.00087,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99998,1,1.00003,1.00003,1.00003,1.00026,.9999,.99977,.99977,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,.99973,.99977,1.00026,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,.99998,1.0006,.99998,1.00003,.99973,.99998,.99973,1.00026,.99973,1.00026,.99973,.99998,1.00026,1.00026,1.0006,1.0006,.99973,1.0006,.99982,1.00026,1.00026,1.00026,1.00026,.99959,.99973,.99998,1.00026,.99973,1.00022,.99973,.99973,1,.99959,1.00077,.99959,1.00003,.99998,.99973,.99973,.99973,.99973,1.00077,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.99973,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,.99977,.99977,.99977,.99977,.99977,.99977,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,.99973,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.06409,1.00026,1.00026,1.00026,1.00026,1.00026,.99973,1.00026,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,1.03374,.99977,1.00026,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,.99977,1.00026,.99977,1.00026,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.00042,.99973,.99973,1.0006,.99977,.99973,.99973,1.00026,1.0006,1.00026,1.0006,1.00026,1.03828,1.00026,.99999,1.00026,1.0006,.99977,1.00026,.99977,1.00026,.99977,1.00026,.9993,.9998,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1,1.00016,.99977,.99959,.99977,.99959,.99977,.99959,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00026,.99998,1.00026,.8121,1.00026,.99998,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,1.00016,1.00022,1.00001,.99973,1.00001,1.00026,1,1.00026,1,1.00026,1,1.0006,.99973,.99977,.99973,1,.99982,1.00022,1.00026,1.00001,.99973,1.00026,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,1.00034,.99977,1,.99997,1.00026,1.00078,1.00036,.99973,1.00013,1.0006,.99977,.99977,.99988,.85148,1.00001,1.00026,.99977,1.00022,1.0006,.99977,1.00001,.99999,.99977,1.00069,1.00022,.99977,1.00001,.99984,1.00026,1.00001,1.00024,1.00001,.9999,1,1.0006,1.00001,1.00041,.99962,1.00026,1.0006,.99995,1.00041,.99942,.99973,.99927,1.00082,.99902,1.00026,1.00087,1.0006,1.00069,.99973,.99867,.99973,.9993,1.00026,1.00049,1.00056,1,.99988,.99935,.99995,.99954,1.00055,.99945,1.00032,1.0006,.99995,1.00026,.99995,1.00032,1.00001,1.00008,.99971,1.00019,.9994,1.00001,1.0006,1.00044,.99973,1.00023,1.00047,1,.99942,.99561,.99989,1.00035,.99977,1.00035,.99977,1.00019,.99944,1.00001,1.00021,.99926,1.00035,1.00035,.99942,1.00048,.99999,.99977,1.00022,1.00035,1.00001,.99977,1.00026,.99989,1.00057,1.00001,.99936,1.00052,1.00012,.99996,1.00043,1,1.00035,.9994,.99976,1.00035,.99973,1.00052,1.00041,1.00119,1.00037,.99973,1.00002,.99986,1.00041,1.00041,.99902,.9996,1.00034,.99999,1.00026,.99999,1.00026,.99973,1.00052,.99973,1,.99973,1.00041,1.00075,.9994,1.0003,.99999,1,1.00041,.99955,1,.99915,.99973,.99973,1.00026,1.00119,.99955,.99973,1.0006,.99911,1.0006,1.00026,.99972,1.00026,.99902,1.00041,.99973,.99999,1,1,1.00038,1.0005,1.00016,1.00022,1.00016,1.00022,1.00016,1.00022,1.00001,.99973,1,1,.99973,1,1,.99955,1.0006,1.0006,1.0006,1.0006,1,1,1,.99973,.99973,.99972,1,1,1.00106,.99999,.99998,.99998,.99999,.99998,1.66475,1,.99973,.99973,1.00023,.99973,.99971,1.00047,1.00023,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1,1,1,1,1,1,1,.99972,1,1.20985,1.39713,1.00003,1.00031,1.00015,1,.99561,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.99972,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaBoldMetrics={lineHeight:1.2,lineGap:.2};t.HelveticaBoldItalicFactors=[.76116,1,1,1.0006,.99998,.99974,.99973,.99973,.99982,.99977,1.00087,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99998,1,1.00003,1.00003,1.00003,1.00026,.9999,.99977,.99977,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,.99973,.99977,1.00026,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,.99998,1.0006,.99998,1.00003,.99973,.99998,.99973,1.00026,.99973,1.00026,.99973,.99998,1.00026,1.00026,1.0006,1.0006,.99973,1.0006,.99982,1.00026,1.00026,1.00026,1.00026,.99959,.99973,.99998,1.00026,.99973,1.00022,.99973,.99973,1,.99959,1.00077,.99959,1.00003,.99998,.99973,.99973,.99973,.99973,1.00077,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.99973,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,.99977,.99977,.99977,.99977,.99977,.99977,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,.99973,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.00026,1.06409,1.00026,1.00026,1.00026,1.00026,1.00026,.99973,1.00026,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,1.0044,.99977,1.00026,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,.99977,1.00026,.99977,1.00026,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99971,.99973,.99973,1.0006,.99977,.99973,.99973,1.00026,1.0006,1.00026,1.0006,1.00026,1.01011,1.00026,.99999,1.00026,1.0006,.99977,1.00026,.99977,1.00026,.99977,1.00026,.9993,.9998,1.00026,1.00022,1.00026,1.00022,1.00026,1.00022,1.00026,1,1.00016,.99977,.99959,.99977,.99959,.99977,.99959,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00026,.99998,1.00026,.8121,1.00026,.99998,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,.99977,1.00026,1.00016,1.00022,1.00001,.99973,1.00001,1.00026,1,1.00026,1,1.00026,1,1.0006,.99973,.99977,.99973,1,.99982,1.00022,1.00026,1.00001,.99973,1.00026,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99977,1,1,1.00026,.99969,.99972,.99981,.9998,1.0006,.99977,.99977,1.00022,.91155,1.00001,1.00026,.99977,1.00022,1.0006,.99977,1.00001,.99999,.99977,.99966,1.00022,1.00032,1.00001,.99944,1.00026,1.00001,.99968,1.00001,1.00047,1,1.0006,1.00001,.99981,1.00101,1.00026,1.0006,.99948,.99981,1.00064,.99973,.99942,1.00101,1.00061,1.00026,1.00069,1.0006,1.00014,.99973,1.01322,.99973,1.00065,1.00026,1.00012,.99923,1,1.00064,1.00076,.99948,1.00055,1.00063,1.00007,.99943,1.0006,.99948,1.00026,.99948,.99943,1.00001,1.00001,1.00029,1.00038,1.00035,1.00001,1.0006,1.0006,.99973,.99978,1.00001,1.00057,.99989,.99967,.99964,.99967,.99977,.99999,.99977,1.00038,.99977,1.00001,.99973,1.00066,.99967,.99967,1.00041,.99998,.99999,.99977,1.00022,.99967,1.00001,.99977,1.00026,.99964,1.00031,1.00001,.99999,.99999,1,1.00023,1,1,.99999,1.00035,1.00001,.99999,.99973,.99977,.99999,1.00058,.99973,.99973,.99955,.9995,1.00026,1.00026,1.00032,.99989,1.00034,.99999,1.00026,1.00026,1.00026,.99973,.45998,.99973,1.00026,.99973,1.00001,.99999,.99982,.99994,.99996,1,1.00042,1.00044,1.00029,1.00023,.99973,.99973,1.00026,.99949,1.00002,.99973,1.0006,1.0006,1.0006,.99975,1.00026,1.00026,1.00032,.98685,.99973,1.00026,1,1,.99966,1.00044,1.00016,1.00022,1.00016,1.00022,1.00016,1.00022,1.00001,.99973,1,1,.99973,1,1,.99955,1.0006,1.0006,1.0006,1.0006,1,1,1,.99973,.99973,.99972,1,1,1.00106,.99999,.99998,.99998,.99999,.99998,1.66475,1,.99973,.99973,1,.99973,.99971,.99978,1,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1.00098,1,1,1,1.00049,1,1,.99972,1,1.20985,1.39713,1.00003,1.00031,1.00015,1,.99561,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.99972,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaBoldItalicMetrics={lineHeight:1.35,lineGap:.2};t.HelveticaItalicFactors=[.76116,1,1,1.0006,1.0006,1.00006,.99973,.99973,.99982,1.00001,1.00043,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.0006,1,1.00003,1.00003,1.00003,.99973,.99987,1.00001,1.00001,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,1,1.00001,.99973,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,1.0006,1.0006,1.0006,.99949,.99973,.99998,.99973,.99973,1,.99973,.99973,1.0006,.99973,.99973,.99924,.99924,1,.99924,.99999,.99973,.99973,.99973,.99973,.99998,1,1.0006,.99973,1,.99977,1,1,1,1.00005,1.0009,1.00005,1.00003,.99998,.99973,.99973,.99973,.99973,1.0009,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.9998,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,1.00001,1.00001,1.00001,1.00001,1.00001,1.00001,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,1,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.06409,1.00026,.99973,.99973,.99973,.99973,1,.99973,1,1.00001,.99973,1.00001,.99973,1.00001,.99973,.99977,1,.99977,1,.99977,1,.99977,1,.99977,1.0288,.99977,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,.99977,.99973,.99977,.99973,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99924,1.0006,1.0006,.99946,1.00034,1,.99924,1.00001,1,1,.99973,.99924,.99973,.99924,.99973,1.06311,.99973,1.00024,.99973,.99924,.99977,.99973,.99977,.99973,.99977,.99973,1.00041,.9998,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1,1.00016,.99977,.99998,.99977,.99998,.99977,.99998,1.00001,1,1.00001,1,1.00001,1,1.00001,1,1.00026,1.0006,1.00026,.89547,1.00026,1.0006,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,1.00016,.99977,1.00001,1,1.00001,1.00026,1,1.00026,1,1.00026,1,.99924,.99973,1.00001,.99973,1,.99982,1.00022,1.00026,1.00001,1,1.00026,1.0006,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,1.00001,1,1.00054,.99977,1.00084,1.00007,.99973,1.00013,.99924,1.00001,1.00001,.99945,.91221,1.00001,1.00026,.99977,1.00022,1.0006,1.00001,1.00001,.99999,.99977,.99933,1.00022,1.00054,1.00001,1.00065,1.00026,1.00001,1.0001,1.00001,1.00052,1,1.0006,1.00001,.99945,.99897,.99968,.99924,1.00036,.99945,.99949,1,1.0006,.99897,.99918,.99968,.99911,.99924,1,.99962,1.01487,1,1.0005,.99973,1.00012,1.00043,1,.99995,.99994,1.00036,.99947,1.00019,1.00063,1.00025,.99924,1.00036,.99973,1.00036,1.00025,1.00001,1.00001,1.00027,1.0001,1.00068,1.00001,1.0006,1.0006,1,1.00008,.99957,.99972,.9994,.99954,.99975,1.00051,1.00001,1.00019,1.00001,1.0001,.99986,1.00001,1.00001,1.00038,.99954,.99954,.9994,1.00066,.99999,.99977,1.00022,1.00054,1.00001,.99977,1.00026,.99975,1.0001,1.00001,.99993,.9995,.99955,1.00016,.99978,.99974,1.00019,1.00022,.99955,1.00053,.99973,1.00089,1.00005,.99967,1.00048,.99973,1.00002,1.00034,.99973,.99973,.99964,1.00006,1.00066,.99947,.99973,.98894,.99973,1,.44898,1,.99946,1,1.00039,1.00082,.99991,.99991,.99985,1.00022,1.00023,1.00061,1.00006,.99966,.99973,.99973,.99973,1.00019,1.0008,1,.99924,.99924,.99924,.99983,1.00044,.99973,.99964,.98332,1,.99973,1,1,.99962,.99895,1.00016,.99977,1.00016,.99977,1.00016,.99977,1.00001,1,1,1,.99973,1,1,.99955,.99924,.99924,.99924,.99924,.99998,.99998,.99998,.99973,.99973,.99972,1,1,1.00267,.99999,.99998,.99998,1,.99998,1.66475,1,.99973,.99973,1.00023,.99973,1.00423,.99925,.99999,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1.00049,1,1.00245,1,1,1,1,.96329,1,1.20985,1.39713,1.00003,.8254,1.00015,1,1.00035,1.00027,1.00031,1.00031,1.00003,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.95317,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,.99998,.99998,.99998,.99998,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaItalicMetrics={lineHeight:1.35,lineGap:.2};t.HelveticaRegularFactors=[.76116,1,1,1.0006,1.0006,1.00006,.99973,.99973,.99982,1.00001,1.00043,.99998,.99998,.99959,1.00003,1.0006,.99998,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.0006,1,1.00003,1.00003,1.00003,.99973,.99987,1.00001,1.00001,.99977,.99977,1.00001,1.00026,1.00022,.99977,1.0006,1,1.00001,.99973,.99999,.99977,1.00022,1.00001,1.00022,.99977,1.00001,1.00026,.99977,1.00001,1.00016,1.00001,1.00001,1.00026,1.0006,1.0006,1.0006,.99949,.99973,.99998,.99973,.99973,1,.99973,.99973,1.0006,.99973,.99973,.99924,.99924,1,.99924,.99999,.99973,.99973,.99973,.99973,.99998,1,1.0006,.99973,1,.99977,1,1,1,1.00005,1.0009,1.00005,1.00003,.99998,.99973,.99973,.99973,.99973,1.0009,.99973,.99998,1.00025,.99968,.99973,1.00003,1.00025,.60299,1.00024,1.06409,1,1,.99998,1,.9998,1.0006,.99998,1,.99936,.99973,1.00002,1.00002,1.00002,1.00026,1.00001,1.00001,1.00001,1.00001,1.00001,1.00001,1,.99977,1.00001,1.00001,1.00001,1.00001,1.0006,1.0006,1.0006,1.0006,.99977,.99977,1.00022,1.00022,1.00022,1.00022,1.00022,1.00003,1.00022,.99977,.99977,.99977,.99977,1.00001,1.00001,1.00026,.99973,.99973,.99973,.99973,.99973,.99973,.99982,1,.99973,.99973,.99973,.99973,1.0006,1.0006,1.0006,1.0006,.99973,.99973,.99973,.99973,.99973,.99973,.99973,1.06409,1.00026,.99973,.99973,.99973,.99973,1,.99973,1,1.00001,.99973,1.00001,.99973,1.00001,.99973,.99977,1,.99977,1,.99977,1,.99977,1,.99977,1.04596,.99977,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00001,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,.99977,.99973,.99977,.99973,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,1.0006,.99924,1.0006,1.0006,1.00019,1.00034,1,.99924,1.00001,1,1,.99973,.99924,.99973,.99924,.99973,1.02572,.99973,1.00005,.99973,.99924,.99977,.99973,.99977,.99973,.99977,.99973,.99999,.9998,.99973,1.00022,.99973,1.00022,.99973,1.00022,.99973,1,1.00016,.99977,.99998,.99977,.99998,.99977,.99998,1.00001,1,1.00001,1,1.00001,1,1.00001,1,1.00026,1.0006,1.00026,.84533,1.00026,1.0006,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,.99977,.99973,1.00016,.99977,1.00001,1,1.00001,1.00026,1,1.00026,1,1.00026,1,.99924,.99973,1.00001,.99973,1,.99982,1.00022,1.00026,1.00001,1,1.00026,1.0006,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99998,.99928,1,.99977,1.00013,1.00055,.99947,.99945,.99941,.99924,1.00001,1.00001,1.0004,.91621,1.00001,1.00026,.99977,1.00022,1.0006,1.00001,1.00005,.99999,.99977,1.00015,1.00022,.99977,1.00001,.99973,1.00026,1.00001,1.00019,1.00001,.99946,1,1.0006,1.00001,.99978,1.00045,.99973,.99924,1.00023,.99978,.99966,1,1.00065,1.00045,1.00019,.99973,.99973,.99924,1,1,.96499,1,1.00055,.99973,1.00008,1.00027,1,.9997,.99995,1.00023,.99933,1.00019,1.00015,1.00031,.99924,1.00023,.99973,1.00023,1.00031,1.00001,.99928,1.00029,1.00092,1.00035,1.00001,1.0006,1.0006,1,.99988,.99975,1,1.00082,.99561,.9996,1.00035,1.00001,.99962,1.00001,1.00092,.99964,1.00001,.99963,.99999,1.00035,1.00035,1.00082,.99962,.99999,.99977,1.00022,1.00035,1.00001,.99977,1.00026,.9996,.99967,1.00001,1.00034,1.00074,1.00054,1.00053,1.00063,.99971,.99962,1.00035,.99975,.99977,.99973,1.00043,.99953,1.0007,.99915,.99973,1.00008,.99892,1.00073,1.00073,1.00114,.99915,1.00073,.99955,.99973,1.00092,.99973,1,.99998,1,1.0003,1,1.00043,1.00001,.99969,1.0003,1,1.00035,1.00001,.9995,1,1.00092,.99973,.99973,.99973,1.0007,.9995,1,.99924,1.0006,.99924,.99972,1.00062,.99973,1.00114,1.00073,1,.99955,1,1,1.00047,.99968,1.00016,.99977,1.00016,.99977,1.00016,.99977,1.00001,1,1,1,.99973,1,1,.99955,.99924,.99924,.99924,.99924,.99998,.99998,.99998,.99973,.99973,.99972,1,1,1.00267,.99999,.99998,.99998,1,.99998,1.66475,1,.99973,.99973,1.00023,.99973,.99971,.99925,1.00023,1,.99991,.99984,1.00002,1.00002,1.00002,1.00002,1,1,1,1,1,1,1,.96329,1,1.20985,1.39713,1.00003,.8254,1.00015,1,1.00035,1.00027,1.00031,1.00031,.99915,1.00031,1.00031,.99999,1.00003,.99999,.99999,1.41144,1.6,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.41144,1.40579,1.40579,1.36625,.99999,1,.99861,.99861,1,1.00026,1.00026,1.00026,1.00026,.95317,.99999,.99999,.99999,.99999,1.40483,1,.99977,1.00054,1,1,.99953,.99962,1.00042,.9995,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.HelveticaRegularMetrics={lineHeight:1.2,lineGap:.2}},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.LiberationSansRegularWidths=t.LiberationSansRegularMapping=t.LiberationSansItalicWidths=t.LiberationSansItalicMapping=t.LiberationSansBoldWidths=t.LiberationSansBoldMapping=t.LiberationSansBoldItalicWidths=t.LiberationSansBoldItalicMapping=void 0;t.LiberationSansBoldWidths=[365,0,333,278,333,474,556,556,889,722,238,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,333,333,584,584,584,611,975,722,722,722,722,667,611,778,722,278,556,722,611,833,722,778,667,778,722,667,611,722,667,944,667,667,611,333,278,333,584,556,333,556,611,556,611,556,333,611,611,278,278,556,278,889,611,611,611,611,389,556,333,611,556,778,556,556,500,389,280,389,584,333,556,556,556,556,280,556,333,737,370,556,584,737,552,400,549,333,333,333,576,556,278,333,333,365,556,834,834,834,611,722,722,722,722,722,722,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,556,556,556,556,556,278,278,278,278,611,611,611,611,611,611,611,549,611,611,611,611,611,556,611,556,722,556,722,556,722,556,722,556,722,556,722,556,722,556,722,719,722,611,667,556,667,556,667,556,667,556,667,556,778,611,778,611,778,611,778,611,722,611,722,611,278,278,278,278,278,278,278,278,278,278,785,556,556,278,722,556,556,611,278,611,278,611,385,611,479,611,278,722,611,722,611,722,611,708,723,611,778,611,778,611,778,611,1e3,944,722,389,722,389,722,389,667,556,667,556,667,556,667,556,611,333,611,479,611,333,722,611,722,611,722,611,722,611,722,611,722,611,944,778,667,556,667,611,500,611,500,611,500,278,556,722,556,1e3,889,778,611,667,556,611,333,333,333,333,333,333,333,333,333,333,333,465,722,333,853,906,474,825,927,838,278,722,722,601,719,667,611,722,778,278,722,667,833,722,644,778,722,667,600,611,667,821,667,809,802,278,667,615,451,611,278,582,615,610,556,606,475,460,611,541,278,558,556,612,556,445,611,766,619,520,684,446,582,715,576,753,845,278,582,611,582,845,667,669,885,567,711,667,278,276,556,1094,1062,875,610,722,622,719,722,719,722,567,712,667,904,626,719,719,610,702,833,722,778,719,667,722,611,622,854,667,730,703,1005,1019,870,979,719,711,1031,719,556,618,615,417,635,556,709,497,615,615,500,635,740,604,611,604,611,556,490,556,875,556,615,581,833,844,729,854,615,552,854,583,556,556,611,417,552,556,278,281,278,969,906,611,500,615,556,604,778,611,487,447,944,778,944,778,944,778,667,556,333,333,556,1e3,1e3,552,278,278,278,278,500,500,500,556,556,350,1e3,1e3,240,479,333,333,604,333,167,396,556,556,1094,556,885,489,1115,1e3,768,600,834,834,834,834,1e3,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,722,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,611,611,333,333,333,333,333,333,333,333,222,222,333,333,333,333,333,333,333,333];t.LiberationSansBoldMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansBoldItalicWidths=[365,0,333,278,333,474,556,556,889,722,238,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,333,333,584,584,584,611,975,722,722,722,722,667,611,778,722,278,556,722,611,833,722,778,667,778,722,667,611,722,667,944,667,667,611,333,278,333,584,556,333,556,611,556,611,556,333,611,611,278,278,556,278,889,611,611,611,611,389,556,333,611,556,778,556,556,500,389,280,389,584,333,556,556,556,556,280,556,333,737,370,556,584,737,552,400,549,333,333,333,576,556,278,333,333,365,556,834,834,834,611,722,722,722,722,722,722,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,556,556,556,556,556,278,278,278,278,611,611,611,611,611,611,611,549,611,611,611,611,611,556,611,556,722,556,722,556,722,556,722,556,722,556,722,556,722,556,722,740,722,611,667,556,667,556,667,556,667,556,667,556,778,611,778,611,778,611,778,611,722,611,722,611,278,278,278,278,278,278,278,278,278,278,782,556,556,278,722,556,556,611,278,611,278,611,396,611,479,611,278,722,611,722,611,722,611,708,723,611,778,611,778,611,778,611,1e3,944,722,389,722,389,722,389,667,556,667,556,667,556,667,556,611,333,611,479,611,333,722,611,722,611,722,611,722,611,722,611,722,611,944,778,667,556,667,611,500,611,500,611,500,278,556,722,556,1e3,889,778,611,667,556,611,333,333,333,333,333,333,333,333,333,333,333,333,722,333,854,906,473,844,930,847,278,722,722,610,671,667,611,722,778,278,722,667,833,722,657,778,718,667,590,611,667,822,667,829,781,278,667,620,479,611,278,591,620,621,556,610,479,492,611,558,278,566,556,603,556,450,611,712,605,532,664,409,591,704,578,773,834,278,591,611,591,834,667,667,886,614,719,667,278,278,556,1094,1042,854,622,719,677,719,722,708,722,614,722,667,927,643,719,719,615,687,833,722,778,719,667,722,611,677,781,667,729,708,979,989,854,1e3,708,719,1042,729,556,619,604,534,618,556,736,510,611,611,507,622,740,604,611,611,611,556,889,556,885,556,646,583,889,935,707,854,594,552,865,589,556,556,611,469,563,556,278,278,278,969,906,611,507,619,556,611,778,611,575,467,944,778,944,778,944,778,667,556,333,333,556,1e3,1e3,552,278,278,278,278,500,500,500,556,556,350,1e3,1e3,240,479,333,333,604,333,167,396,556,556,1104,556,885,516,1146,1e3,768,600,834,834,834,834,999,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,722,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,611,611,333,333,333,333,333,333,333,333,222,222,333,333,333,333,333,333,333,333];t.LiberationSansBoldItalicMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansItalicWidths=[365,0,333,278,278,355,556,556,889,667,191,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,278,278,584,584,584,556,1015,667,667,722,722,667,611,778,722,278,500,667,556,833,722,778,667,778,722,667,611,722,667,944,667,667,611,278,278,278,469,556,333,556,556,500,556,556,278,556,556,222,222,500,222,833,556,556,556,556,333,500,278,556,500,722,500,500,500,334,260,334,584,333,556,556,556,556,260,556,333,737,370,556,584,737,552,400,549,333,333,333,576,537,278,333,333,365,556,834,834,834,611,667,667,667,667,667,667,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,500,556,556,556,556,278,278,278,278,556,556,556,556,556,556,556,549,611,556,556,556,556,500,556,500,667,556,667,556,667,556,722,500,722,500,722,500,722,500,722,625,722,556,667,556,667,556,667,556,667,556,667,556,778,556,778,556,778,556,778,556,722,556,722,556,278,278,278,278,278,278,278,222,278,278,733,444,500,222,667,500,500,556,222,556,222,556,281,556,400,556,222,722,556,722,556,722,556,615,723,556,778,556,778,556,778,556,1e3,944,722,333,722,333,722,333,667,500,667,500,667,500,667,500,611,278,611,354,611,278,722,556,722,556,722,556,722,556,722,556,722,556,944,722,667,500,667,611,500,611,500,611,500,222,556,667,556,1e3,889,778,611,667,500,611,278,333,333,333,333,333,333,333,333,333,333,333,667,278,789,846,389,794,865,775,222,667,667,570,671,667,611,722,778,278,667,667,833,722,648,778,725,667,600,611,667,837,667,831,761,278,667,570,439,555,222,550,570,571,500,556,439,463,555,542,222,500,492,548,500,447,556,670,573,486,603,374,550,652,546,728,779,222,550,556,550,779,667,667,843,544,708,667,278,278,500,1066,982,844,589,715,639,724,667,651,667,544,704,667,917,614,715,715,589,686,833,722,778,725,667,722,611,639,795,667,727,673,920,923,805,886,651,694,1022,682,556,562,522,493,553,556,688,465,556,556,472,564,686,550,556,556,556,500,833,500,835,500,572,518,830,851,621,736,526,492,752,534,556,556,556,378,496,500,222,222,222,910,828,556,472,565,500,556,778,556,492,339,944,722,944,722,944,722,667,500,333,333,556,1e3,1e3,552,222,222,222,222,333,333,333,556,556,350,1e3,1e3,188,354,333,333,500,333,167,365,556,556,1094,556,885,323,1083,1e3,768,600,834,834,834,834,1e3,500,998,500,1e3,500,500,494,612,823,713,584,549,713,979,719,274,549,549,584,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,500,500,333,333,333,333,333,333,333,333,222,222,294,294,324,324,316,328,398,285];t.LiberationSansItalicMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1];t.LiberationSansRegularWidths=[365,0,333,278,278,355,556,556,889,667,191,333,333,389,584,278,333,278,278,556,556,556,556,556,556,556,556,556,556,278,278,584,584,584,556,1015,667,667,722,722,667,611,778,722,278,500,667,556,833,722,778,667,778,722,667,611,722,667,944,667,667,611,278,278,278,469,556,333,556,556,500,556,556,278,556,556,222,222,500,222,833,556,556,556,556,333,500,278,556,500,722,500,500,500,334,260,334,584,333,556,556,556,556,260,556,333,737,370,556,584,737,552,400,549,333,333,333,576,537,278,333,333,365,556,834,834,834,611,667,667,667,667,667,667,1e3,722,667,667,667,667,278,278,278,278,722,722,778,778,778,778,778,584,778,722,722,722,722,667,667,611,556,556,556,556,556,556,889,500,556,556,556,556,278,278,278,278,556,556,556,556,556,556,556,549,611,556,556,556,556,500,556,500,667,556,667,556,667,556,722,500,722,500,722,500,722,500,722,615,722,556,667,556,667,556,667,556,667,556,667,556,778,556,778,556,778,556,778,556,722,556,722,556,278,278,278,278,278,278,278,222,278,278,735,444,500,222,667,500,500,556,222,556,222,556,292,556,334,556,222,722,556,722,556,722,556,604,723,556,778,556,778,556,778,556,1e3,944,722,333,722,333,722,333,667,500,667,500,667,500,667,500,611,278,611,375,611,278,722,556,722,556,722,556,722,556,722,556,722,556,944,722,667,500,667,611,500,611,500,611,500,222,556,667,556,1e3,889,778,611,667,500,611,278,333,333,333,333,333,333,333,333,333,333,333,667,278,784,838,384,774,855,752,222,667,667,551,668,667,611,722,778,278,667,668,833,722,650,778,722,667,618,611,667,798,667,835,748,278,667,578,446,556,222,547,578,575,500,557,446,441,556,556,222,500,500,576,500,448,556,690,569,482,617,395,547,648,525,713,781,222,547,556,547,781,667,667,865,542,719,667,278,278,500,1057,1010,854,583,722,635,719,667,656,667,542,677,667,923,604,719,719,583,656,833,722,778,719,667,722,611,635,760,667,740,667,917,938,792,885,656,719,1010,722,556,573,531,365,583,556,669,458,559,559,438,583,688,552,556,542,556,500,458,500,823,500,573,521,802,823,625,719,521,510,750,542,556,556,556,365,510,500,222,278,222,906,812,556,438,559,500,552,778,556,489,411,944,722,944,722,944,722,667,500,333,333,556,1e3,1e3,552,222,222,222,222,333,333,333,556,556,350,1e3,1e3,188,354,333,333,500,333,167,365,556,556,1094,556,885,323,1073,1e3,768,600,834,834,834,834,1e3,500,1e3,500,1e3,500,500,494,612,823,713,584,549,713,979,719,274,549,549,583,549,549,604,584,604,604,708,625,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,708,729,604,604,354,354,1e3,990,990,990,990,494,604,604,604,604,354,1021,1052,917,750,750,531,656,594,510,500,750,750,500,500,333,333,333,333,333,333,333,333,222,222,294,294,324,324,316,328,398,285];t.LiberationSansRegularMapping=[-1,-1,-1,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,161,162,163,164,165,166,167,168,169,170,171,172,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,301,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,402,506,507,508,509,510,511,536,537,538,539,710,711,713,728,729,730,731,732,733,900,901,902,903,904,905,906,908,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926,927,928,929,931,932,933,934,935,936,937,938,939,940,941,942,943,944,945,946,947,948,949,950,951,952,953,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,970,971,972,973,974,1024,1025,1026,1027,1028,1029,1030,1031,1032,1033,1034,1035,1036,1037,1038,1039,1040,1041,1042,1043,1044,1045,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091,1092,1093,1094,1095,1096,1097,1098,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1138,1139,1168,1169,7808,7809,7810,7811,7812,7813,7922,7923,8208,8209,8211,8212,8213,8215,8216,8217,8218,8219,8220,8221,8222,8224,8225,8226,8230,8240,8242,8243,8249,8250,8252,8254,8260,8319,8355,8356,8359,8364,8453,8467,8470,8482,8486,8494,8539,8540,8541,8542,8592,8593,8594,8595,8596,8597,8616,8706,8710,8719,8721,8722,8730,8734,8735,8745,8747,8776,8800,8801,8804,8805,8962,8976,8992,8993,9472,9474,9484,9488,9492,9496,9500,9508,9516,9524,9532,9552,9553,9554,9555,9556,9557,9558,9559,9560,9561,9562,9563,9564,9565,9566,9567,9568,9569,9570,9571,9572,9573,9574,9575,9576,9577,9578,9579,9580,9600,9604,9608,9612,9616,9617,9618,9619,9632,9633,9642,9643,9644,9650,9658,9660,9668,9674,9675,9679,9688,9689,9702,9786,9787,9788,9792,9794,9824,9827,9829,9830,9834,9835,9836,61441,61442,61445,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1]},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.MyriadProRegularMetrics=t.MyriadProRegularFactors=t.MyriadProItalicMetrics=t.MyriadProItalicFactors=t.MyriadProBoldMetrics=t.MyriadProBoldItalicMetrics=t.MyriadProBoldItalicFactors=t.MyriadProBoldFactors=void 0;t.MyriadProBoldFactors=[1.36898,1,1,.72706,.80479,.83734,.98894,.99793,.9897,.93884,.86209,.94292,.94292,1.16661,1.02058,.93582,.96694,.93582,1.19137,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.99793,.78076,.78076,1.02058,1.02058,1.02058,.72851,.78966,.90838,.83637,.82391,.96376,.80061,.86275,.8768,.95407,1.0258,.73901,.85022,.83655,1.0156,.95546,.92179,.87107,.92179,.82114,.8096,.89713,.94438,.95353,.94083,.91905,.90406,.9446,.94292,1.18777,.94292,1.02058,.89903,.90088,.94938,.97898,.81093,.97571,.94938,1.024,.9577,.95933,.98621,1.0474,.97455,.98981,.9672,.95933,.9446,.97898,.97407,.97646,.78036,1.10208,.95442,.95298,.97579,.9332,.94039,.938,.80687,1.01149,.80687,1.02058,.80479,.99793,.99793,.99793,.99793,1.01149,1.00872,.90088,.91882,1.0213,.8361,1.02058,.62295,.54324,.89022,1.08595,1,1,.90088,1,.97455,.93582,.90088,1,1.05686,.8361,.99642,.99642,.99642,.72851,.90838,.90838,.90838,.90838,.90838,.90838,.868,.82391,.80061,.80061,.80061,.80061,1.0258,1.0258,1.0258,1.0258,.97484,.95546,.92179,.92179,.92179,.92179,.92179,1.02058,.92179,.94438,.94438,.94438,.94438,.90406,.86958,.98225,.94938,.94938,.94938,.94938,.94938,.94938,.9031,.81093,.94938,.94938,.94938,.94938,.98621,.98621,.98621,.98621,.93969,.95933,.9446,.9446,.9446,.9446,.9446,1.08595,.9446,.95442,.95442,.95442,.95442,.94039,.97898,.94039,.90838,.94938,.90838,.94938,.90838,.94938,.82391,.81093,.82391,.81093,.82391,.81093,.82391,.81093,.96376,.84313,.97484,.97571,.80061,.94938,.80061,.94938,.80061,.94938,.80061,.94938,.80061,.94938,.8768,.9577,.8768,.9577,.8768,.9577,1,1,.95407,.95933,.97069,.95933,1.0258,.98621,1.0258,.98621,1.0258,.98621,1.0258,.98621,1.0258,.98621,.887,1.01591,.73901,1.0474,1,1,.97455,.83655,.98981,1,1,.83655,.73977,.83655,.73903,.84638,1.033,.95546,.95933,1,1,.95546,.95933,.8271,.95417,.95933,.92179,.9446,.92179,.9446,.92179,.9446,.936,.91964,.82114,.97646,1,1,.82114,.97646,.8096,.78036,.8096,.78036,1,1,.8096,.78036,1,1,.89713,.77452,.89713,1.10208,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94438,.95442,.94083,.97579,.90406,.94039,.90406,.9446,.938,.9446,.938,.9446,.938,1,.99793,.90838,.94938,.868,.9031,.92179,.9446,1,1,.89713,1.10208,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90989,.9358,.91945,.83181,.75261,.87992,.82976,.96034,.83689,.97268,1.0078,.90838,.83637,.8019,.90157,.80061,.9446,.95407,.92436,1.0258,.85022,.97153,1.0156,.95546,.89192,.92179,.92361,.87107,.96318,.89713,.93704,.95638,.91905,.91709,.92796,1.0258,.93704,.94836,1.0373,.95933,1.0078,.95871,.94836,.96174,.92601,.9498,.98607,.95776,.95933,1.05453,1.0078,.98275,.9314,.95617,.91701,1.05993,.9446,.78367,.9553,1,.86832,1.0128,.95871,.99394,.87548,.96361,.86774,1.0078,.95871,.9446,.95871,.86774,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.94083,.97579,.94083,.97579,.94083,.97579,.90406,.94039,.96694,1,.89903,1,1,1,.93582,.93582,.93582,1,.908,.908,.918,.94219,.94219,.96544,1,1.285,1,1,.81079,.81079,1,1,.74854,1,1,1,1,.99793,1,1,1,.65,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.17173,1,.80535,.76169,1.02058,1.0732,1.05486,1,1,1.30692,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.16161,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProBoldMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProBoldItalicFactors=[1.36898,1,1,.66227,.80779,.81625,.97276,.97276,.97733,.92222,.83266,.94292,.94292,1.16148,1.02058,.93582,.96694,.93582,1.17337,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.97276,.78076,.78076,1.02058,1.02058,1.02058,.71541,.76813,.85576,.80591,.80729,.94299,.77512,.83655,.86523,.92222,.98621,.71743,.81698,.79726,.98558,.92222,.90637,.83809,.90637,.80729,.76463,.86275,.90699,.91605,.9154,.85308,.85458,.90531,.94292,1.21296,.94292,1.02058,.89903,1.18616,.99613,.91677,.78216,.91677,.90083,.98796,.9135,.92168,.95381,.98981,.95298,.95381,.93459,.92168,.91513,.92004,.91677,.95077,.748,1.04502,.91677,.92061,.94236,.89544,.89364,.9,.80687,.8578,.80687,1.02058,.80779,.97276,.97276,.97276,.97276,.8578,.99973,1.18616,.91339,1.08074,.82891,1.02058,.55509,.71526,.89022,1.08595,1,1,1.18616,1,.96736,.93582,1.18616,1,1.04864,.82711,.99043,.99043,.99043,.71541,.85576,.85576,.85576,.85576,.85576,.85576,.845,.80729,.77512,.77512,.77512,.77512,.98621,.98621,.98621,.98621,.95961,.92222,.90637,.90637,.90637,.90637,.90637,1.02058,.90251,.90699,.90699,.90699,.90699,.85458,.83659,.94951,.99613,.99613,.99613,.99613,.99613,.99613,.85811,.78216,.90083,.90083,.90083,.90083,.95381,.95381,.95381,.95381,.9135,.92168,.91513,.91513,.91513,.91513,.91513,1.08595,.91677,.91677,.91677,.91677,.91677,.89364,.92332,.89364,.85576,.99613,.85576,.99613,.85576,.99613,.80729,.78216,.80729,.78216,.80729,.78216,.80729,.78216,.94299,.76783,.95961,.91677,.77512,.90083,.77512,.90083,.77512,.90083,.77512,.90083,.77512,.90083,.86523,.9135,.86523,.9135,.86523,.9135,1,1,.92222,.92168,.92222,.92168,.98621,.95381,.98621,.95381,.98621,.95381,.98621,.95381,.98621,.95381,.86036,.97096,.71743,.98981,1,1,.95298,.79726,.95381,1,1,.79726,.6894,.79726,.74321,.81691,1.0006,.92222,.92168,1,1,.92222,.92168,.79464,.92098,.92168,.90637,.91513,.90637,.91513,.90637,.91513,.909,.87514,.80729,.95077,1,1,.80729,.95077,.76463,.748,.76463,.748,1,1,.76463,.748,1,1,.86275,.72651,.86275,1.04502,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.90699,.91677,.9154,.94236,.85458,.89364,.85458,.90531,.9,.90531,.9,.90531,.9,1,.97276,.85576,.99613,.845,.85811,.90251,.91677,1,1,.86275,1.04502,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.18616,1.00899,1.30628,.85576,.80178,.66862,.7927,.69323,.88127,.72459,.89711,.95381,.85576,.80591,.7805,.94729,.77512,.90531,.92222,.90637,.98621,.81698,.92655,.98558,.92222,.85359,.90637,.90976,.83809,.94523,.86275,.83509,.93157,.85308,.83392,.92346,.98621,.83509,.92886,.91324,.92168,.95381,.90646,.92886,.90557,.86847,.90276,.91324,.86842,.92168,.99531,.95381,.9224,.85408,.92699,.86847,1.0051,.91513,.80487,.93481,1,.88159,1.05214,.90646,.97355,.81539,.89398,.85923,.95381,.90646,.91513,.90646,.85923,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.9154,.94236,.9154,.94236,.9154,.94236,.85458,.89364,.96694,1,.89903,1,1,1,.91782,.91782,.91782,1,.896,.896,.896,.9332,.9332,.95973,1,1.26,1,1,.80479,.80178,1,1,.85633,1,1,1,1,.97276,1,1,1,.698,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.14542,1,.79199,.78694,1.02058,1.03493,1.05486,1,1,1.23026,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.20006,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProBoldItalicMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProItalicFactors=[1.36898,1,1,.65507,.84943,.85639,.88465,.88465,.86936,.88307,.86948,.85283,.85283,1.06383,1.02058,.75945,.9219,.75945,1.17337,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.88465,.75945,.75945,1.02058,1.02058,1.02058,.69046,.70926,.85158,.77812,.76852,.89591,.70466,.76125,.80094,.86822,.83864,.728,.77212,.79475,.93637,.87514,.8588,.76013,.8588,.72421,.69866,.77598,.85991,.80811,.87832,.78112,.77512,.8562,1.0222,1.18417,1.0222,1.27014,.89903,1.15012,.93859,.94399,.846,.94399,.81453,1.0186,.94219,.96017,1.03075,1.02175,.912,1.03075,.96998,.96017,.93859,.94399,.94399,.95493,.746,1.12658,.94578,.91,.979,.882,.882,.83,.85034,.83537,.85034,1.02058,.70869,.88465,.88465,.88465,.88465,.83537,.90083,1.15012,.9161,.94565,.73541,1.02058,.53609,.69353,.79519,1.08595,1,1,1.15012,1,.91974,.75945,1.15012,1,.9446,.73361,.9005,.9005,.9005,.62864,.85158,.85158,.85158,.85158,.85158,.85158,.773,.76852,.70466,.70466,.70466,.70466,.83864,.83864,.83864,.83864,.90561,.87514,.8588,.8588,.8588,.8588,.8588,1.02058,.85751,.85991,.85991,.85991,.85991,.77512,.76013,.88075,.93859,.93859,.93859,.93859,.93859,.93859,.8075,.846,.81453,.81453,.81453,.81453,.82424,.82424,.82424,.82424,.9278,.96017,.93859,.93859,.93859,.93859,.93859,1.08595,.8562,.94578,.94578,.94578,.94578,.882,.94578,.882,.85158,.93859,.85158,.93859,.85158,.93859,.76852,.846,.76852,.846,.76852,.846,.76852,.846,.89591,.8544,.90561,.94399,.70466,.81453,.70466,.81453,.70466,.81453,.70466,.81453,.70466,.81453,.80094,.94219,.80094,.94219,.80094,.94219,1,1,.86822,.96017,.86822,.96017,.83864,.82424,.83864,.82424,.83864,.82424,.83864,1.03075,.83864,.82424,.81402,1.02738,.728,1.02175,1,1,.912,.79475,1.03075,1,1,.79475,.83911,.79475,.66266,.80553,1.06676,.87514,.96017,1,1,.87514,.96017,.86865,.87396,.96017,.8588,.93859,.8588,.93859,.8588,.93859,.867,.84759,.72421,.95493,1,1,.72421,.95493,.69866,.746,.69866,.746,1,1,.69866,.746,1,1,.77598,.88417,.77598,1.12658,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.85991,.94578,.87832,.979,.77512,.882,.77512,.8562,.83,.8562,.83,.8562,.83,1,.88465,.85158,.93859,.773,.8075,.85751,.8562,1,1,.77598,1.12658,1.15012,1.15012,1.15012,1.15012,1.15012,1.15313,1.15012,1.15012,1.15012,1.08106,1.03901,.85158,.77025,.62264,.7646,.65351,.86026,.69461,.89947,1.03075,.85158,.77812,.76449,.88836,.70466,.8562,.86822,.8588,.83864,.77212,.85308,.93637,.87514,.82352,.8588,.85701,.76013,.89058,.77598,.8156,.82565,.78112,.77899,.89386,.83864,.8156,.9486,.92388,.96186,1.03075,.91123,.9486,.93298,.878,.93942,.92388,.84596,.96186,.95119,1.03075,.922,.88787,.95829,.88,.93559,.93859,.78815,.93758,1,.89217,1.03737,.91123,.93969,.77487,.85769,.86799,1.03075,.91123,.93859,.91123,.86799,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.87832,.979,.87832,.979,.87832,.979,.77512,.882,.9219,1,.89903,1,1,1,.87321,.87321,.87321,1,1.027,1.027,1.027,.86847,.86847,.79121,1,1.124,1,1,.73572,.73572,1,1,.85034,1,1,1,1,.88465,1,1,1,.669,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.04828,1,.74948,.75187,1.02058,.98391,1.02119,1,1,1.06233,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.05233,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProItalicMetrics={lineHeight:1.2,lineGap:.2};t.MyriadProRegularFactors=[1.36898,1,1,.76305,.82784,.94935,.89364,.92241,.89073,.90706,.98472,.85283,.85283,1.0664,1.02058,.74505,.9219,.74505,1.23456,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.92241,.74505,.74505,1.02058,1.02058,1.02058,.73002,.72601,.91755,.8126,.80314,.92222,.73764,.79726,.83051,.90284,.86023,.74,.8126,.84869,.96518,.91115,.8858,.79761,.8858,.74498,.73914,.81363,.89591,.83659,.89633,.85608,.8111,.90531,1.0222,1.22736,1.0222,1.27014,.89903,.90088,.86667,1.0231,.896,1.01411,.90083,1.05099,1.00512,.99793,1.05326,1.09377,.938,1.06226,1.00119,.99793,.98714,1.0231,1.01231,.98196,.792,1.19137,.99074,.962,1.01915,.926,.942,.856,.85034,.92006,.85034,1.02058,.69067,.92241,.92241,.92241,.92241,.92006,.9332,.90088,.91882,.93484,.75339,1.02058,.56866,.54324,.79519,1.08595,1,1,.90088,1,.95325,.74505,.90088,1,.97198,.75339,.91009,.91009,.91009,.66466,.91755,.91755,.91755,.91755,.91755,.91755,.788,.80314,.73764,.73764,.73764,.73764,.86023,.86023,.86023,.86023,.92915,.91115,.8858,.8858,.8858,.8858,.8858,1.02058,.8858,.89591,.89591,.89591,.89591,.8111,.79611,.89713,.86667,.86667,.86667,.86667,.86667,.86667,.86936,.896,.90083,.90083,.90083,.90083,.84224,.84224,.84224,.84224,.97276,.99793,.98714,.98714,.98714,.98714,.98714,1.08595,.89876,.99074,.99074,.99074,.99074,.942,1.0231,.942,.91755,.86667,.91755,.86667,.91755,.86667,.80314,.896,.80314,.896,.80314,.896,.80314,.896,.92222,.93372,.92915,1.01411,.73764,.90083,.73764,.90083,.73764,.90083,.73764,.90083,.73764,.90083,.83051,1.00512,.83051,1.00512,.83051,1.00512,1,1,.90284,.99793,.90976,.99793,.86023,.84224,.86023,.84224,.86023,.84224,.86023,1.05326,.86023,.84224,.82873,1.07469,.74,1.09377,1,1,.938,.84869,1.06226,1,1,.84869,.83704,.84869,.81441,.85588,1.08927,.91115,.99793,1,1,.91115,.99793,.91887,.90991,.99793,.8858,.98714,.8858,.98714,.8858,.98714,.894,.91434,.74498,.98196,1,1,.74498,.98196,.73914,.792,.73914,.792,1,1,.73914,.792,1,1,.81363,.904,.81363,1.19137,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89591,.99074,.89633,1.01915,.8111,.942,.8111,.90531,.856,.90531,.856,.90531,.856,1,.92241,.91755,.86667,.788,.86936,.8858,.89876,1,1,.81363,1.19137,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90088,.90388,1.03901,.92138,.78105,.7154,.86169,.80513,.94007,.82528,.98612,1.06226,.91755,.8126,.81884,.92819,.73764,.90531,.90284,.8858,.86023,.8126,.91172,.96518,.91115,.83089,.8858,.87791,.79761,.89297,.81363,.88157,.89992,.85608,.81992,.94307,.86023,.88157,.95308,.98699,.99793,1.06226,.95817,.95308,.97358,.928,.98088,.98699,.92761,.99793,.96017,1.06226,.986,.944,.95978,.938,.96705,.98714,.80442,.98972,1,.89762,1.04552,.95817,.99007,.87064,.91879,.88888,1.06226,.95817,.98714,.95817,.88888,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.89633,1.01915,.89633,1.01915,.89633,1.01915,.8111,.942,.9219,1,.89903,1,1,1,.93173,.93173,.93173,1,1.06304,1.06304,1.06904,.89903,.89903,.80549,1,1.156,1,1,.76575,.76575,1,1,.72458,1,1,1,1,.92241,1,1,1,.619,1,1.36145,1,1,1,1,1,1,1,1,1,1,1,1.07257,1,.74705,.71119,1.02058,1.024,1.02119,1,1,1.1536,1.08595,1.08595,1,1.08595,1.08595,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.05638,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.MyriadProRegularMetrics={lineHeight:1.2,lineGap:.2}},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.SegoeuiRegularMetrics=t.SegoeuiRegularFactors=t.SegoeuiItalicMetrics=t.SegoeuiItalicFactors=t.SegoeuiBoldMetrics=t.SegoeuiBoldItalicMetrics=t.SegoeuiBoldItalicFactors=t.SegoeuiBoldFactors=void 0;t.SegoeuiBoldFactors=[1.76738,1,1,.99297,.9824,1.04016,1.06497,1.03424,.97529,1.17647,1.23203,1.1085,1.1085,1.16939,1.2107,.9754,1.21408,.9754,1.59578,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,1.03424,.81378,.81378,1.2107,1.2107,1.2107,.71703,.97847,.97363,.88776,.8641,1.02096,.79795,.85132,.914,1.06085,1.1406,.8007,.89858,.83693,1.14889,1.09398,.97489,.92094,.97489,.90399,.84041,.95923,1.00135,1,1.06467,.98243,.90996,.99361,1.1085,1.56942,1.1085,1.2107,.74627,.94282,.96752,1.01519,.86304,1.01359,.97278,1.15103,1.01359,.98561,1.02285,1.02285,1.00527,1.02285,1.0302,.99041,1.0008,1.01519,1.01359,1.02258,.79104,1.16862,.99041,.97454,1.02511,.99298,.96752,.95801,.94856,1.16579,.94856,1.2107,.9824,1.03424,1.03424,1,1.03424,1.16579,.8727,1.3871,1.18622,1.10818,1.04478,1.2107,1.18622,.75155,.94994,1.28826,1.21408,1.21408,.91056,1,.91572,.9754,.64663,1.18328,1.24866,1.04478,1.14169,1.15749,1.17389,.71703,.97363,.97363,.97363,.97363,.97363,.97363,.93506,.8641,.79795,.79795,.79795,.79795,1.1406,1.1406,1.1406,1.1406,1.02096,1.09398,.97426,.97426,.97426,.97426,.97426,1.2107,.97489,1.00135,1.00135,1.00135,1.00135,.90996,.92094,1.02798,.96752,.96752,.96752,.96752,.96752,.96752,.93136,.86304,.97278,.97278,.97278,.97278,1.02285,1.02285,1.02285,1.02285,.97122,.99041,1,1,1,1,1,1.28826,1.0008,.99041,.99041,.99041,.99041,.96752,1.01519,.96752,.97363,.96752,.97363,.96752,.97363,.96752,.8641,.86304,.8641,.86304,.8641,.86304,.8641,.86304,1.02096,1.03057,1.02096,1.03517,.79795,.97278,.79795,.97278,.79795,.97278,.79795,.97278,.79795,.97278,.914,1.01359,.914,1.01359,.914,1.01359,1,1,1.06085,.98561,1.06085,1.00879,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,1.1406,1.02285,.97138,1.08692,.8007,1.02285,1,1,1.00527,.83693,1.02285,1,1,.83693,.9455,.83693,.90418,.83693,1.13005,1.09398,.99041,1,1,1.09398,.99041,.96692,1.09251,.99041,.97489,1.0008,.97489,1.0008,.97489,1.0008,.93994,.97931,.90399,1.02258,1,1,.90399,1.02258,.84041,.79104,.84041,.79104,.84041,.79104,.84041,.79104,1,1,.95923,1.07034,.95923,1.16862,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.00135,.99041,1.06467,1.02511,.90996,.96752,.90996,.99361,.95801,.99361,.95801,.99361,.95801,1.07733,1.03424,.97363,.96752,.93506,.93136,.97489,1.0008,1,1,.95923,1.16862,1.15103,1.15103,1.01173,1.03959,.75953,.81378,.79912,1.15103,1.21994,.95161,.87815,1.01149,.81525,.7676,.98167,1.01134,1.02546,.84097,1.03089,1.18102,.97363,.88776,.85134,.97826,.79795,.99361,1.06085,.97489,1.1406,.89858,1.0388,1.14889,1.09398,.86039,.97489,1.0595,.92094,.94793,.95923,.90996,.99346,.98243,1.02112,.95493,1.1406,.90996,1.03574,1.02597,1.0008,1.18102,1.06628,1.03574,1.0192,1.01932,1.00886,.97531,1.0106,1.0008,1.13189,1.18102,1.02277,.98683,1.0016,.99561,1.07237,1.0008,.90434,.99921,.93803,.8965,1.23085,1.06628,1.04983,.96268,1.0499,.98439,1.18102,1.06628,1.0008,1.06628,.98439,.79795,1,1,1,1,1,1,1,1,1,1,1,1,1.09466,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.97278,1,1,1,1,1,1,1,1,1,1,1,1,1.02065,1,1,1,1,1,1,1.06467,1.02511,1.06467,1.02511,1.06467,1.02511,.90996,.96752,1,1.21408,.89903,1,1,.75155,1.04394,1.04394,1.04394,1.04394,.98633,.98633,.98633,.73047,.73047,1.20642,.91211,1.25635,1.222,1.02956,1.03372,1.03372,.96039,1.24633,1,1.12454,.93503,1.03424,1.19687,1.03424,1,1,1,.771,1,1,1.15749,1.15749,1.15749,1.10948,.86279,.94434,.86279,.94434,.86182,1,1,1.16897,1,.96085,.90137,1.2107,1.18416,1.13973,.69825,.9716,2.10339,1.29004,1.29004,1.21172,1.29004,1.29004,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18874,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.09193,1.09193,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiBoldMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiBoldItalicFactors=[1.76738,1,1,.98946,1.03959,1.04016,1.02809,1.036,.97639,1.10953,1.23203,1.11144,1.11144,1.16939,1.21237,.9754,1.21261,.9754,1.59754,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,1.036,.81378,.81378,1.21237,1.21237,1.21237,.73541,.97847,.97363,.89723,.87897,1.0426,.79429,.85292,.91149,1.05815,1.1406,.79631,.90128,.83853,1.04396,1.10615,.97552,.94436,.97552,.88641,.80527,.96083,1.00135,1,1.06777,.9817,.91142,.99361,1.11144,1.57293,1.11144,1.21237,.74627,1.31818,1.06585,.97042,.83055,.97042,.93503,1.1261,.97042,.97922,1.14236,.94552,1.01054,1.14236,1.02471,.97922,.94165,.97042,.97042,1.0276,.78929,1.1261,.97922,.95874,1.02197,.98507,.96752,.97168,.95107,1.16579,.95107,1.21237,1.03959,1.036,1.036,1,1.036,1.16579,.87357,1.31818,1.18754,1.26781,1.05356,1.21237,1.18622,.79487,.94994,1.29004,1.24047,1.24047,1.31818,1,.91484,.9754,1.31818,1.1349,1.24866,1.05356,1.13934,1.15574,1.17389,.73541,.97363,.97363,.97363,.97363,.97363,.97363,.94385,.87897,.79429,.79429,.79429,.79429,1.1406,1.1406,1.1406,1.1406,1.0426,1.10615,.97552,.97552,.97552,.97552,.97552,1.21237,.97552,1.00135,1.00135,1.00135,1.00135,.91142,.94436,.98721,1.06585,1.06585,1.06585,1.06585,1.06585,1.06585,.96705,.83055,.93503,.93503,.93503,.93503,1.14236,1.14236,1.14236,1.14236,.93125,.97922,.94165,.94165,.94165,.94165,.94165,1.29004,.94165,.97922,.97922,.97922,.97922,.96752,.97042,.96752,.97363,1.06585,.97363,1.06585,.97363,1.06585,.87897,.83055,.87897,.83055,.87897,.83055,.87897,.83055,1.0426,1.0033,1.0426,.97042,.79429,.93503,.79429,.93503,.79429,.93503,.79429,.93503,.79429,.93503,.91149,.97042,.91149,.97042,.91149,.97042,1,1,1.05815,.97922,1.05815,.97922,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,1.1406,1.14236,.97441,1.04302,.79631,1.01582,1,1,1.01054,.83853,1.14236,1,1,.83853,1.09125,.83853,.90418,.83853,1.19508,1.10615,.97922,1,1,1.10615,.97922,1.01034,1.10466,.97922,.97552,.94165,.97552,.94165,.97552,.94165,.91602,.91981,.88641,1.0276,1,1,.88641,1.0276,.80527,.78929,.80527,.78929,.80527,.78929,.80527,.78929,1,1,.96083,1.05403,.95923,1.16862,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.00135,.97922,1.06777,1.02197,.91142,.96752,.91142,.99361,.97168,.99361,.97168,.99361,.97168,1.23199,1.036,.97363,1.06585,.94385,.96705,.97552,.94165,1,1,.96083,1.1261,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,1.31818,.95161,1.27126,1.00811,.83284,.77702,.99137,.95253,1.0347,.86142,1.07205,1.14236,.97363,.89723,.86869,1.09818,.79429,.99361,1.05815,.97552,1.1406,.90128,1.06662,1.04396,1.10615,.84918,.97552,1.04694,.94436,.98015,.96083,.91142,1.00356,.9817,1.01945,.98999,1.1406,.91142,1.04961,.9898,1.00639,1.14236,1.07514,1.04961,.99607,1.02897,1.008,.9898,.95134,1.00639,1.11121,1.14236,1.00518,.97981,1.02186,1,1.08578,.94165,.99314,.98387,.93028,.93377,1.35125,1.07514,1.10687,.93491,1.04232,1.00351,1.14236,1.07514,.94165,1.07514,1.00351,.79429,1,1,1,1,1,1,1,1,1,1,1,1,1.09097,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.93503,1,1,1,1,1,1,1,1,1,1,1,1,.96609,1,1,1,1,1,1,1.06777,1.02197,1.06777,1.02197,1.06777,1.02197,.91142,.96752,1,1.21261,.89903,1,1,.75155,1.04745,1.04745,1.04745,1.04394,.98633,.98633,.98633,.72959,.72959,1.20502,.91406,1.26514,1.222,1.02956,1.03372,1.03372,.96039,1.24633,1,1.09125,.93327,1.03336,1.16541,1.036,1,1,1,.771,1,1,1.15574,1.15574,1.15574,1.15574,.86364,.94434,.86279,.94434,.86224,1,1,1.16798,1,.96085,.90068,1.21237,1.18416,1.13904,.69825,.9716,2.10339,1.29004,1.29004,1.21339,1.29004,1.29004,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18775,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.13269,1.13269,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiBoldItalicMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiItalicFactors=[1.76738,1,1,.98946,1.14763,1.05365,1.06234,.96927,.92586,1.15373,1.18414,.91349,.91349,1.07403,1.17308,.78383,1.20088,.78383,1.42531,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.78383,.78383,1.17308,1.17308,1.17308,.77349,.94565,.94729,.85944,.88506,.9858,.74817,.80016,.88449,.98039,.95782,.69238,.89898,.83231,.98183,1.03989,.96924,.86237,.96924,.80595,.74524,.86091,.95402,.94143,.98448,.8858,.83089,.93285,1.0949,1.39016,1.0949,1.45994,.74627,1.04839,.97454,.97454,.87207,.97454,.87533,1.06151,.97454,1.00176,1.16484,1.08132,.98047,1.16484,1.02989,1.01054,.96225,.97454,.97454,1.06598,.79004,1.16344,1.00351,.94629,.9973,.91016,.96777,.9043,.91082,.92481,.91082,1.17308,.95748,.96927,.96927,1,.96927,.92481,.80597,1.04839,1.23393,1.1781,.9245,1.17308,1.20808,.63218,.94261,1.24822,1.09971,1.09971,1.04839,1,.85273,.78032,1.04839,1.09971,1.22326,.9245,1.09836,1.13525,1.15222,.70424,.94729,.94729,.94729,.94729,.94729,.94729,.85498,.88506,.74817,.74817,.74817,.74817,.95782,.95782,.95782,.95782,.9858,1.03989,.96924,.96924,.96924,.96924,.96924,1.17308,.96924,.95402,.95402,.95402,.95402,.83089,.86237,.88409,.97454,.97454,.97454,.97454,.97454,.97454,.92916,.87207,.87533,.87533,.87533,.87533,.93146,.93146,.93146,.93146,.93854,1.01054,.96225,.96225,.96225,.96225,.96225,1.24822,.8761,1.00351,1.00351,1.00351,1.00351,.96777,.97454,.96777,.94729,.97454,.94729,.97454,.94729,.97454,.88506,.87207,.88506,.87207,.88506,.87207,.88506,.87207,.9858,.95391,.9858,.97454,.74817,.87533,.74817,.87533,.74817,.87533,.74817,.87533,.74817,.87533,.88449,.97454,.88449,.97454,.88449,.97454,1,1,.98039,1.00176,.98039,1.00176,.95782,.93146,.95782,.93146,.95782,.93146,.95782,1.16484,.95782,.93146,.84421,1.12761,.69238,1.08132,1,1,.98047,.83231,1.16484,1,1,.84723,1.04861,.84723,.78755,.83231,1.23736,1.03989,1.01054,1,1,1.03989,1.01054,.9857,1.03849,1.01054,.96924,.96225,.96924,.96225,.96924,.96225,.92383,.90171,.80595,1.06598,1,1,.80595,1.06598,.74524,.79004,.74524,.79004,.74524,.79004,.74524,.79004,1,1,.86091,1.02759,.85771,1.16344,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.95402,1.00351,.98448,.9973,.83089,.96777,.83089,.93285,.9043,.93285,.9043,.93285,.9043,1.31868,.96927,.94729,.97454,.85498,.92916,.96924,.8761,1,1,.86091,1.16344,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,1.04839,.81965,.81965,.94729,.78032,.71022,.90883,.84171,.99877,.77596,1.05734,1.2,.94729,.85944,.82791,.9607,.74817,.93285,.98039,.96924,.95782,.89898,.98316,.98183,1.03989,.78614,.96924,.97642,.86237,.86075,.86091,.83089,.90082,.8858,.97296,1.01284,.95782,.83089,1.0976,1.04,1.03342,1.2,1.0675,1.0976,.98205,1.03809,1.05097,1.04,.95364,1.03342,1.05401,1.2,1.02148,1.0119,1.04724,1.0127,1.02732,.96225,.8965,.97783,.93574,.94818,1.30679,1.0675,1.11826,.99821,1.0557,1.0326,1.2,1.0675,.96225,1.0675,1.0326,.74817,1,1,1,1,1,1,1,1,1,1,1,1,1.03754,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.87533,1,1,1,1,1,1,1,1,1,1,1,1,.98705,1,1,1,1,1,1,.98448,.9973,.98448,.9973,.98448,.9973,.83089,.96777,1,1.20088,.89903,1,1,.75155,.94945,.94945,.94945,.94945,1.12317,1.12317,1.12317,.67603,.67603,1.15621,.73584,1.21191,1.22135,1.06483,.94868,.94868,.95996,1.24633,1,1.07497,.87709,.96927,1.01473,.96927,1,1,1,.77295,1,1,1.09836,1.09836,1.09836,1.01522,.86321,.94434,.8649,.94434,.86182,1,1,1.083,1,.91578,.86438,1.17308,1.18416,1.14589,.69825,.97622,1.96791,1.24822,1.24822,1.17308,1.24822,1.24822,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.17984,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.10742,1.10742,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiItalicMetrics={lineHeight:1.33008,lineGap:0};t.SegoeuiRegularFactors=[1.76738,1,1,.98594,1.02285,1.10454,1.06234,.96927,.92037,1.19985,1.2046,.90616,.90616,1.07152,1.1714,.78032,1.20088,.78032,1.40246,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.96927,.78032,.78032,1.1714,1.1714,1.1714,.80597,.94084,.96706,.85944,.85734,.97093,.75842,.79936,.88198,.9831,.95782,.71387,.86969,.84636,1.07796,1.03584,.96924,.83968,.96924,.82826,.79649,.85771,.95132,.93119,.98965,.88433,.8287,.93365,1.08612,1.3638,1.08612,1.45786,.74627,.80499,.91484,1.05707,.92383,1.05882,.9403,1.12654,1.05882,1.01756,1.09011,1.09011,.99414,1.09011,1.034,1.01756,1.05356,1.05707,1.05882,1.04399,.84863,1.21968,1.01756,.95801,1.00068,.91797,.96777,.9043,.90351,.92105,.90351,1.1714,.85337,.96927,.96927,.99912,.96927,.92105,.80597,1.2434,1.20808,1.05937,.90957,1.1714,1.20808,.75155,.94261,1.24644,1.09971,1.09971,.84751,1,.85273,.78032,.61584,1.05425,1.17914,.90957,1.08665,1.11593,1.14169,.73381,.96706,.96706,.96706,.96706,.96706,.96706,.86035,.85734,.75842,.75842,.75842,.75842,.95782,.95782,.95782,.95782,.97093,1.03584,.96924,.96924,.96924,.96924,.96924,1.1714,.96924,.95132,.95132,.95132,.95132,.8287,.83968,.89049,.91484,.91484,.91484,.91484,.91484,.91484,.93575,.92383,.9403,.9403,.9403,.9403,.8717,.8717,.8717,.8717,1.00527,1.01756,1.05356,1.05356,1.05356,1.05356,1.05356,1.24644,.95923,1.01756,1.01756,1.01756,1.01756,.96777,1.05707,.96777,.96706,.91484,.96706,.91484,.96706,.91484,.85734,.92383,.85734,.92383,.85734,.92383,.85734,.92383,.97093,1.0969,.97093,1.05882,.75842,.9403,.75842,.9403,.75842,.9403,.75842,.9403,.75842,.9403,.88198,1.05882,.88198,1.05882,.88198,1.05882,1,1,.9831,1.01756,.9831,1.01756,.95782,.8717,.95782,.8717,.95782,.8717,.95782,1.09011,.95782,.8717,.84784,1.11551,.71387,1.09011,1,1,.99414,.84636,1.09011,1,1,.84636,1.0536,.84636,.94298,.84636,1.23297,1.03584,1.01756,1,1,1.03584,1.01756,1.00323,1.03444,1.01756,.96924,1.05356,.96924,1.05356,.96924,1.05356,.93066,.98293,.82826,1.04399,1,1,.82826,1.04399,.79649,.84863,.79649,.84863,.79649,.84863,.79649,.84863,1,1,.85771,1.17318,.85771,1.21968,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.95132,1.01756,.98965,1.00068,.8287,.96777,.8287,.93365,.9043,.93365,.9043,.93365,.9043,1.08571,.96927,.96706,.91484,.86035,.93575,.96924,.95923,1,1,.85771,1.21968,1.11437,1.11437,.93109,.91202,.60411,.84164,.55572,1.01173,.97361,.81818,.81818,.96635,.78032,.72727,.92366,.98601,1.03405,.77968,1.09799,1.2,.96706,.85944,.85638,.96491,.75842,.93365,.9831,.96924,.95782,.86969,.94152,1.07796,1.03584,.78437,.96924,.98715,.83968,.83491,.85771,.8287,.94492,.88433,.9287,1.0098,.95782,.8287,1.0625,.98248,1.03424,1.2,1.01071,1.0625,.95246,1.03809,1.04912,.98248,1.00221,1.03424,1.05443,1.2,1.04785,.99609,1.00169,1.05176,.99346,1.05356,.9087,1.03004,.95542,.93117,1.23362,1.01071,1.07831,1.02512,1.05205,1.03502,1.2,1.01071,1.05356,1.01071,1.03502,.75842,1,1,1,1,1,1,1,1,1,1,1,1,1.03719,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,.9403,1,1,1,1,1,1,1,1,1,1,1,1,1.04021,1,1,1,1,1,1,.98965,1.00068,.98965,1.00068,.98965,1.00068,.8287,.96777,1,1.20088,.89903,1,1,.75155,1.03077,1.03077,1.03077,1.03077,1.13196,1.13196,1.13196,.67428,.67428,1.16039,.73291,1.20996,1.22135,1.06483,.94868,.94868,.95996,1.24633,1,1.07497,.87796,.96927,1.01518,.96927,1,1,1,.77295,1,1,1.10539,1.10539,1.11358,1.06967,.86279,.94434,.86279,.94434,.86182,1,1,1.083,1,.91578,.86507,1.1714,1.18416,1.14589,.69825,.97622,1.9697,1.24822,1.24822,1.17238,1.24822,1.24822,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1.42603,1,.99862,.99862,1,.87025,.87025,.87025,.87025,1.18083,1.42603,1,1.42603,1.42603,.99862,1,1,1,1,1,1.2886,1.04315,1.15296,1.34163,1,1,1,1.10938,1.10938,1,1,1,1.05425,1.09971,1.09971,1.09971,1,1,1,1,1,1,1,1,1,1,1];t.SegoeuiRegularMetrics={lineHeight:1.33008,lineGap:0}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PostScriptEvaluator=t.PostScriptCompiler=t.PDFFunctionFactory=void 0,t.isPDFFunction=function(e){let t;if(e instanceof n.Dict)t=e;else{if(!(e instanceof s.BaseStream))return!1;t=e.dict}return t.has("FunctionType")};var n=a(4),r=a(2),i=a(58),s=a(5),o=a(59);function c(e){if(!Array.isArray(e))return null;const t=e.length;for(let a=0;a<t;a++)if("number"!=typeof e[a]){const a=new Array(t);for(let n=0;n<t;n++)a[n]=+e[n];return a}return e}t.PDFFunctionFactory=class{constructor({xref:e,isEvalSupported:t=!0}){this.xref=e,this.isEvalSupported=!1!==t}create(e){const t=this.getCached(e);if(t)return t;const a=l.parse({xref:this.xref,isEvalSupported:this.isEvalSupported,fn:e instanceof n.Ref?this.xref.fetch(e):e});return this._cache(e,a),a}createFromArray(e){const t=this.getCached(e);if(t)return t;const a=l.parseArray({xref:this.xref,isEvalSupported:this.isEvalSupported,fnObj:e instanceof n.Ref?this.xref.fetch(e):e});return this._cache(e,a),a}getCached(e){let t;if(e instanceof n.Ref?t=e:e instanceof n.Dict?t=e.objId:e instanceof s.BaseStream&&(t=e.dict?.objId),t){const e=this._localFunctionCache.getByRef(t);if(e)return e}return null}_cache(e,t){if(!t)throw new Error('PDFFunctionFactory._cache - expected "parsedFunction" argument.');let a;e instanceof n.Ref?a=e:e instanceof n.Dict?a=e.objId:e instanceof s.BaseStream&&(a=e.dict?.objId),a&&this._localFunctionCache.set(null,a,t)}get _localFunctionCache(){return(0,r.shadow)(this,"_localFunctionCache",new o.LocalFunctionCache)}};class l{static getSampleArray(e,t,a,n){let r,i,s=1;for(r=0,i=e.length;r<i;r++)s*=e[r];s*=t;const o=new Array(s);let c=0,l=0;const h=1/(2**a-1),u=n.getBytes((s*a+7)/8);let d=0;for(r=0;r<s;r++){for(;c<a;)l<<=8,l|=u[d++],c+=8;c-=a,o[r]=(l>>c)*h,l&=(1<<c)-1}return o}static parse({xref:e,isEvalSupported:t,fn:a}){const n=a.dict||a;switch(n.get("FunctionType")){case 0:return this.constructSampled({xref:e,isEvalSupported:t,fn:a,dict:n});case 1:break;case 2:return this.constructInterpolated({xref:e,isEvalSupported:t,dict:n});case 3:return this.constructStiched({xref:e,isEvalSupported:t,dict:n});case 4:return this.constructPostScript({xref:e,isEvalSupported:t,fn:a,dict:n})}throw new r.FormatError("Unknown type of function")}static parseArray({xref:e,isEvalSupported:t,fnObj:a}){if(!Array.isArray(a))return this.parse({xref:e,isEvalSupported:t,fn:a});const n=[];for(const r of a)n.push(this.parse({xref:e,isEvalSupported:t,fn:e.fetchIfRef(r)}));return function(e,t,a,r){for(let i=0,s=n.length;i<s;i++)n[i](e,t,a,r+i)}}static constructSampled({xref:e,isEvalSupported:t,fn:a,dict:n}){function i(e){const t=e.length,a=[];let n=0;for(let r=0;r<t;r+=2)a[n++]=[e[r],e[r+1]];return a}function s(e,t,a,n,r){return n+(r-n)/(a-t)*(e-t)}let o=c(n.getArray("Domain")),l=c(n.getArray("Range"));if(!o||!l)throw new r.FormatError("No domain or range");const h=o.length/2,u=l.length/2;o=i(o),l=i(l);const d=c(n.getArray("Size")),f=n.get("BitsPerSample"),g=n.get("Order")||1;1!==g&&(0,r.info)("No support for cubic spline interpolation: "+g);let p=c(n.getArray("Encode"));if(p)p=i(p);else{p=[];for(let e=0;e<h;++e)p.push([0,d[e]-1])}let m=c(n.getArray("Decode"));m=m?i(m):l;const b=this.getSampleArray(d,u,f,a);return function(e,t,a,n){const r=1<<h,i=new Float64Array(r),c=new Uint32Array(r);let f,g;for(g=0;g<r;g++)i[g]=1;let y=u,w=1;for(f=0;f<h;++f){const a=o[f][0],n=o[f][1];let l=s(Math.min(Math.max(e[t+f],a),n),a,n,p[f][0],p[f][1]);const h=d[f];l=Math.min(Math.max(l,0),h-1);const u=l<h-1?Math.floor(l):l-1,m=u+1-l,b=l-u,x=u*y,S=x+y;for(g=0;g<r;g++)g&w?(i[g]*=b,c[g]+=S):(i[g]*=m,c[g]+=x);y*=h,w<<=1}for(g=0;g<u;++g){let e=0;for(f=0;f<r;f++)e+=b[c[f]+g]*i[f];e=s(e,0,1,m[g][0],m[g][1]),a[n+g]=Math.min(Math.max(e,l[g][0]),l[g][1])}}}static constructInterpolated({xref:e,isEvalSupported:t,dict:a}){const n=c(a.getArray("C0"))||[0],r=c(a.getArray("C1"))||[1],i=a.get("N"),s=[];for(let e=0,t=n.length;e<t;++e)s.push(r[e]-n[e]);const o=s.length;return function(e,t,a,r){const c=1===i?e[t]:e[t]**i;for(let e=0;e<o;++e)a[r+e]=n[e]+c*s[e]}}static constructStiched({xref:e,isEvalSupported:t,dict:a}){const n=c(a.getArray("Domain"));if(!n)throw new r.FormatError("No domain");if(1!==n.length/2)throw new r.FormatError("Bad domain for stiched function");const i=[];for(const n of a.get("Functions"))i.push(this.parse({xref:e,isEvalSupported:t,fn:e.fetchIfRef(n)}));const s=c(a.getArray("Bounds")),o=c(a.getArray("Encode")),l=new Float32Array(1);return function(e,t,a,r){const c=function(e,t,a){return e>a?e=a:e<t&&(e=t),e}(e[t],n[0],n[1]),h=s.length;let u;for(u=0;u<h&&!(c<s[u]);++u);let d=n[0];u>0&&(d=s[u-1]);let f=n[1];u<s.length&&(f=s[u]);const g=o[2*u],p=o[2*u+1];l[0]=d===f?g:g+(c-d)*(p-g)/(f-d),i[u](l,0,a,r)}}static constructPostScript({xref:e,isEvalSupported:t,fn:a,dict:n}){const s=c(n.getArray("Domain")),o=c(n.getArray("Range"));if(!s)throw new r.FormatError("No domain.");if(!o)throw new r.FormatError("No range.");const l=new i.PostScriptLexer(a),h=new i.PostScriptParser(l).parse();if(t&&r.FeatureTest.isEvalSupported){const e=(new C).compile(h,s,o);if(e)return new Function("src","srcOffset","dest","destOffset",e)}(0,r.info)("Unable to compile PS function");const d=o.length>>1,f=s.length>>1,g=new u(h),p=Object.create(null);let m=8192;const b=new Float32Array(f);return function(e,t,a,n){let r,i,s="";const c=b;for(r=0;r<f;r++)i=e[t+r],c[r]=i,s+=i+"_";const l=p[s];if(void 0!==l)return void a.set(l,n);const h=new Float32Array(d),u=g.execute(c),y=u.length-d;for(r=0;r<d;r++){i=u[y+r];let e=o[2*r];i<e?i=e:(e=o[2*r+1],i>e&&(i=e)),h[r]=i}m>0&&(m--,p[s]=h),a.set(h,n)}}}class h{static MAX_STACK_SIZE=100;constructor(e){this.stack=e?Array.from(e):[]}push(e){if(this.stack.length>=h.MAX_STACK_SIZE)throw new Error("PostScript function stack overflow.");this.stack.push(e)}pop(){if(this.stack.length<=0)throw new Error("PostScript function stack underflow.");return this.stack.pop()}copy(e){if(this.stack.length+e>=h.MAX_STACK_SIZE)throw new Error("PostScript function stack overflow.");const t=this.stack;for(let a=t.length-e,n=e-1;n>=0;n--,a++)t.push(t[a])}index(e){this.push(this.stack[this.stack.length-e-1])}roll(e,t){const a=this.stack,n=a.length-e,r=a.length-1,i=n+(t-Math.floor(t/e)*e);for(let e=n,t=r;e<t;e++,t--){const n=a[e];a[e]=a[t],a[t]=n}for(let e=n,t=i-1;e<t;e++,t--){const n=a[e];a[e]=a[t],a[t]=n}for(let e=i,t=r;e<t;e++,t--){const n=a[e];a[e]=a[t],a[t]=n}}}class u{constructor(e){this.operators=e}execute(e){const t=new h(e);let a=0;const n=this.operators,i=n.length;let s,o,c;for(;a<i;)if(s=n[a++],"number"!=typeof s)switch(s){case"jz":c=t.pop(),o=t.pop(),o||(a=c);break;case"j":o=t.pop(),a=o;break;case"abs":o=t.pop(),t.push(Math.abs(o));break;case"add":c=t.pop(),o=t.pop(),t.push(o+c);break;case"and":c=t.pop(),o=t.pop(),"boolean"==typeof o&&"boolean"==typeof c?t.push(o&&c):t.push(o&c);break;case"atan":c=t.pop(),o=t.pop(),o=Math.atan2(o,c)/Math.PI*180,o<0&&(o+=360),t.push(o);break;case"bitshift":c=t.pop(),o=t.pop(),o>0?t.push(o<<c):t.push(o>>c);break;case"ceiling":o=t.pop(),t.push(Math.ceil(o));break;case"copy":o=t.pop(),t.copy(o);break;case"cos":o=t.pop(),t.push(Math.cos(o%360/180*Math.PI));break;case"cvi":o=0|t.pop(),t.push(o);break;case"cvr":break;case"div":c=t.pop(),o=t.pop(),t.push(o/c);break;case"dup":t.copy(1);break;case"eq":c=t.pop(),o=t.pop(),t.push(o===c);break;case"exch":t.roll(2,1);break;case"exp":c=t.pop(),o=t.pop(),t.push(o**c);break;case"false":t.push(!1);break;case"floor":o=t.pop(),t.push(Math.floor(o));break;case"ge":c=t.pop(),o=t.pop(),t.push(o>=c);break;case"gt":c=t.pop(),o=t.pop(),t.push(o>c);break;case"idiv":c=t.pop(),o=t.pop(),t.push(o/c|0);break;case"index":o=t.pop(),t.index(o);break;case"le":c=t.pop(),o=t.pop(),t.push(o<=c);break;case"ln":o=t.pop(),t.push(Math.log(o));break;case"log":o=t.pop(),t.push(Math.log10(o));break;case"lt":c=t.pop(),o=t.pop(),t.push(o<c);break;case"mod":c=t.pop(),o=t.pop(),t.push(o%c);break;case"mul":c=t.pop(),o=t.pop(),t.push(o*c);break;case"ne":c=t.pop(),o=t.pop(),t.push(o!==c);break;case"neg":o=t.pop(),t.push(-o);break;case"not":o=t.pop(),"boolean"==typeof o?t.push(!o):t.push(~o);break;case"or":c=t.pop(),o=t.pop(),"boolean"==typeof o&&"boolean"==typeof c?t.push(o||c):t.push(o|c);break;case"pop":t.pop();break;case"roll":c=t.pop(),o=t.pop(),t.roll(o,c);break;case"round":o=t.pop(),t.push(Math.round(o));break;case"sin":o=t.pop(),t.push(Math.sin(o%360/180*Math.PI));break;case"sqrt":o=t.pop(),t.push(Math.sqrt(o));break;case"sub":c=t.pop(),o=t.pop(),t.push(o-c);break;case"true":t.push(!0);break;case"truncate":o=t.pop(),o=o<0?Math.ceil(o):Math.floor(o),t.push(o);break;case"xor":c=t.pop(),o=t.pop(),"boolean"==typeof o&&"boolean"==typeof c?t.push(o!==c):t.push(o^c);break;default:throw new r.FormatError(`Unknown operator ${s}`)}else t.push(s);return t.stack}}t.PostScriptEvaluator=u;class d{constructor(e){this.type=e}visit(e){(0,r.unreachable)("abstract method")}}class f extends d{constructor(e,t,a){super("args"),this.index=e,this.min=t,this.max=a}visit(e){e.visitArgument(this)}}class g extends d{constructor(e){super("literal"),this.number=e,this.min=e,this.max=e}visit(e){e.visitLiteral(this)}}class p extends d{constructor(e,t,a,n,r){super("binary"),this.op=e,this.arg1=t,this.arg2=a,this.min=n,this.max=r}visit(e){e.visitBinaryOperation(this)}}class m extends d{constructor(e,t){super("max"),this.arg=e,this.min=e.min,this.max=t}visit(e){e.visitMin(this)}}class b extends d{constructor(e,t,a){super("var"),this.index=e,this.min=t,this.max=a}visit(e){e.visitVariable(this)}}class y extends d{constructor(e,t){super("definition"),this.variable=e,this.arg=t}visit(e){e.visitVariableDefinition(this)}}class w{constructor(){this.parts=[]}visitArgument(e){this.parts.push("Math.max(",e.min,", Math.min(",e.max,", src[srcOffset + ",e.index,"]))")}visitVariable(e){this.parts.push("v",e.index)}visitLiteral(e){this.parts.push(e.number)}visitBinaryOperation(e){this.parts.push("("),e.arg1.visit(this),this.parts.push(" ",e.op," "),e.arg2.visit(this),this.parts.push(")")}visitVariableDefinition(e){this.parts.push("var "),e.variable.visit(this),this.parts.push(" = "),e.arg.visit(this),this.parts.push(";")}visitMin(e){this.parts.push("Math.min("),e.arg.visit(this),this.parts.push(", ",e.max,")")}toString(){return this.parts.join("")}}function x(e,t){return"literal"===t.type&&0===t.number?e:"literal"===e.type&&0===e.number?t:"literal"===t.type&&"literal"===e.type?new g(e.number+t.number):new p("+",e,t,e.min+t.min,e.max+t.max)}function S(e,t){if("literal"===t.type){if(0===t.number)return new g(0);if(1===t.number)return e;if("literal"===e.type)return new g(e.number*t.number)}if("literal"===e.type){if(0===e.number)return new g(0);if(1===e.number)return t}const a=Math.min(e.min*t.min,e.min*t.max,e.max*t.min,e.max*t.max),n=Math.max(e.min*t.min,e.min*t.max,e.max*t.min,e.max*t.max);return new p("*",e,t,a,n)}function A(e,t){if("literal"===t.type){if(0===t.number)return e;if("literal"===e.type)return new g(e.number-t.number)}return"binary"===t.type&&"-"===t.op&&"literal"===e.type&&1===e.number&&"literal"===t.arg1.type&&1===t.arg1.number?t.arg2:new p("-",e,t,e.min-t.max,e.max-t.min)}function k(e,t){return e.min>=t?new g(t):e.max<=t?e:new m(e,t)}class C{compile(e,t,a){const n=[],r=[],i=t.length>>1,s=a.length>>1;let o,c,l,h,u,d,p,m,C=0;for(let e=0;e<i;e++)n.push(new f(e,t[2*e],t[2*e+1]));for(let t=0,a=e.length;t<a;t++)if(m=e[t],"number"!=typeof m)switch(m){case"add":if(n.length<2)return null;h=n.pop(),l=n.pop(),n.push(x(l,h));break;case"cvr":if(n.length<1)return null;break;case"mul":if(n.length<2)return null;h=n.pop(),l=n.pop(),n.push(S(l,h));break;case"sub":if(n.length<2)return null;h=n.pop(),l=n.pop(),n.push(A(l,h));break;case"exch":if(n.length<2)return null;u=n.pop(),d=n.pop(),n.push(u,d);break;case"pop":if(n.length<1)return null;n.pop();break;case"index":if(n.length<1)return null;if(l=n.pop(),"literal"!==l.type)return null;if(o=l.number,o<0||!Number.isInteger(o)||n.length<o)return null;if(u=n[n.length-o-1],"literal"===u.type||"var"===u.type){n.push(u);break}p=new b(C++,u.min,u.max),n[n.length-o-1]=p,n.push(p),r.push(new y(p,u));break;case"dup":if(n.length<1)return null;if("number"==typeof e[t+1]&&"gt"===e[t+2]&&e[t+3]===t+7&&"jz"===e[t+4]&&"pop"===e[t+5]&&e[t+6]===e[t+1]){l=n.pop(),n.push(k(l,e[t+1])),t+=6;break}if(u=n.at(-1),"literal"===u.type||"var"===u.type){n.push(u);break}p=new b(C++,u.min,u.max),n[n.length-1]=p,n.push(p),r.push(new y(p,u));break;case"roll":if(n.length<2)return null;if(h=n.pop(),l=n.pop(),"literal"!==h.type||"literal"!==l.type)return null;if(c=h.number,o=l.number,o<=0||!Number.isInteger(o)||!Number.isInteger(c)||n.length<o)return null;if(c=(c%o+o)%o,0===c)break;n.push(...n.splice(n.length-o,o-c));break;default:return null}else n.push(new g(m));if(n.length!==s)return null;const v=[];for(const e of r){const t=new w;e.visit(t),v.push(t.toString())}for(let e=0,t=n.length;e<t;e++){const t=n[e],r=new w;t.visit(r);const i=a[2*e],s=a[2*e+1],o=[r.toString()];i>t.min&&(o.unshift("Math.max(",i,", "),o.push(")")),s<t.max&&(o.unshift("Math.min(",s,", "),o.push(")")),o.unshift("dest[destOffset + ",e,"] = "),o.push(";"),v.push(o.join(""))}return v.join("\n")}}t.PostScriptCompiler=C},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PostScriptParser=t.PostScriptLexer=void 0;var n=a(2),r=a(4),i=a(3);t.PostScriptParser=class{constructor(e){this.lexer=e,this.operators=[],this.token=null,this.prev=null}nextToken(){this.prev=this.token,this.token=this.lexer.getToken()}accept(e){return this.token.type===e&&(this.nextToken(),!0)}expect(e){if(this.accept(e))return!0;throw new n.FormatError(`Unexpected symbol: found ${this.token.type} expected ${e}.`)}parse(){return this.nextToken(),this.expect(s.LBRACE),this.parseBlock(),this.expect(s.RBRACE),this.operators}parseBlock(){for(;;)if(this.accept(s.NUMBER))this.operators.push(this.prev.value);else if(this.accept(s.OPERATOR))this.operators.push(this.prev.value);else{if(!this.accept(s.LBRACE))return;this.parseCondition()}}parseCondition(){const e=this.operators.length;if(this.operators.push(null,null),this.parseBlock(),this.expect(s.RBRACE),this.accept(s.IF))this.operators[e]=this.operators.length,this.operators[e+1]="jz";else{if(!this.accept(s.LBRACE))throw new n.FormatError("PS Function: error parsing conditional.");{const t=this.operators.length;this.operators.push(null,null);const a=this.operators.length;this.parseBlock(),this.expect(s.RBRACE),this.expect(s.IFELSE),this.operators[t]=this.operators.length,this.operators[t+1]="j",this.operators[e]=a,this.operators[e+1]="jz"}}}};const s={LBRACE:0,RBRACE:1,NUMBER:2,OPERATOR:3,IF:4,IFELSE:5};class o{static get opCache(){return(0,n.shadow)(this,"opCache",Object.create(null))}constructor(e,t){this.type=e,this.value=t}static getOperator(e){return o.opCache[e]||=new o(s.OPERATOR,e)}static get LBRACE(){return(0,n.shadow)(this,"LBRACE",new o(s.LBRACE,"{"))}static get RBRACE(){return(0,n.shadow)(this,"RBRACE",new o(s.RBRACE,"}"))}static get IF(){return(0,n.shadow)(this,"IF",new o(s.IF,"IF"))}static get IFELSE(){return(0,n.shadow)(this,"IFELSE",new o(s.IFELSE,"IFELSE"))}}t.PostScriptLexer=class{constructor(e){this.stream=e,this.nextChar(),this.strBuf=[]}nextChar(){return this.currentChar=this.stream.getByte()}getToken(){let e=!1,t=this.currentChar;for(;;){if(t<0)return r.EOF;if(e)10!==t&&13!==t||(e=!1);else if(37===t)e=!0;else if(!(0,i.isWhiteSpace)(t))break;t=this.nextChar()}switch(0|t){case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:case 43:case 45:case 46:return new o(s.NUMBER,this.getNumber());case 123:return this.nextChar(),o.LBRACE;case 125:return this.nextChar(),o.RBRACE}const a=this.strBuf;for(a.length=0,a[0]=String.fromCharCode(t);(t=this.nextChar())>=0&&(t>=65&&t<=90||t>=97&&t<=122);)a.push(String.fromCharCode(t));const n=a.join("");switch(n.toLowerCase()){case"if":return o.IF;case"ifelse":return o.IFELSE;default:return o.getOperator(n)}}getNumber(){let e=this.currentChar;const t=this.strBuf;for(t.length=0,t[0]=String.fromCharCode(e);(e=this.nextChar())>=0&&(e>=48&&e<=57||45===e||46===e);)t.push(String.fromCharCode(e));const a=parseFloat(t.join(""));if(isNaN(a))throw new n.FormatError(`Invalid floating point number: ${a}`);return a}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.RegionalImageCache=t.LocalTilingPatternCache=t.LocalImageCache=t.LocalGStateCache=t.LocalFunctionCache=t.LocalColorSpaceCache=t.GlobalImageCache=void 0;var n=a(2),r=a(4);class i{constructor(e){this.constructor===i&&(0,n.unreachable)("Cannot initialize BaseLocalCache."),this._onlyRefs=!0===e?.onlyRefs,this._onlyRefs||(this._nameRefMap=new Map,this._imageMap=new Map),this._imageCache=new r.RefSetCache}getByName(e){this._onlyRefs&&(0,n.unreachable)("Should not call `getByName` method.");const t=this._nameRefMap.get(e);return t?this.getByRef(t):this._imageMap.get(e)||null}getByRef(e){return this._imageCache.get(e)||null}set(e,t,a){(0,n.unreachable)("Abstract method `set` called.")}}t.LocalImageCache=class extends i{set(e,t=null,a){if("string"!=typeof e)throw new Error('LocalImageCache.set - expected "name" argument.');if(t){if(this._imageCache.has(t))return;return this._nameRefMap.set(e,t),void this._imageCache.put(t,a)}this._imageMap.has(e)||this._imageMap.set(e,a)}};t.LocalColorSpaceCache=class extends i{set(e=null,t=null,a){if("string"!=typeof e&&!t)throw new Error('LocalColorSpaceCache.set - expected "name" and/or "ref" argument.');if(t){if(this._imageCache.has(t))return;return null!==e&&this._nameRefMap.set(e,t),void this._imageCache.put(t,a)}this._imageMap.has(e)||this._imageMap.set(e,a)}};t.LocalFunctionCache=class extends i{constructor(e){super({onlyRefs:!0})}set(e=null,t,a){if(!t)throw new Error('LocalFunctionCache.set - expected "ref" argument.');this._imageCache.has(t)||this._imageCache.put(t,a)}};t.LocalGStateCache=class extends i{set(e,t=null,a){if("string"!=typeof e)throw new Error('LocalGStateCache.set - expected "name" argument.');if(t){if(this._imageCache.has(t))return;return this._nameRefMap.set(e,t),void this._imageCache.put(t,a)}this._imageMap.has(e)||this._imageMap.set(e,a)}};t.LocalTilingPatternCache=class extends i{constructor(e){super({onlyRefs:!0})}set(e=null,t,a){if(!t)throw new Error('LocalTilingPatternCache.set - expected "ref" argument.');this._imageCache.has(t)||this._imageCache.put(t,a)}};t.RegionalImageCache=class extends i{constructor(e){super({onlyRefs:!0})}set(e=null,t,a){if(!t)throw new Error('RegionalImageCache.set - expected "ref" argument.');this._imageCache.has(t)||this._imageCache.put(t,a)}};class s{static NUM_PAGES_THRESHOLD=2;static MIN_IMAGES_TO_CACHE=10;static MAX_BYTE_SIZE=5*n.MAX_IMAGE_SIZE_TO_CACHE;constructor(){this._refCache=new r.RefSetCache,this._imageCache=new r.RefSetCache}get _byteSize(){let e=0;for(const t of this._imageCache)e+=t.byteSize;return e}get _cacheLimitReached(){return!(this._imageCache.size<s.MIN_IMAGES_TO_CACHE)&&!(this._byteSize<s.MAX_BYTE_SIZE)}shouldCache(e,t){let a=this._refCache.get(e);return a||(a=new Set,this._refCache.put(e,a)),a.add(t),!(a.size<s.NUM_PAGES_THRESHOLD)&&!(!this._imageCache.has(e)&&this._cacheLimitReached)}addByteSize(e,t){const a=this._imageCache.get(e);a&&(a.byteSize||(a.byteSize=t))}getData(e,t){const a=this._refCache.get(e);if(!a)return null;if(a.size<s.NUM_PAGES_THRESHOLD)return null;const n=this._imageCache.get(e);return n?(a.add(t),n):null}setData(e,t){if(!this._refCache.has(e))throw new Error('GlobalImageCache.setData - expected "shouldCache" to have been called.');this._imageCache.has(e)||(this._cacheLimitReached?(0,n.warn)("GlobalImageCache.setData - cache limit reached."):this._imageCache.put(e,t))}clear(e=!1){e||this._refCache.clear(),this._imageCache.clear()}}t.GlobalImageCache=s},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.bidi=function(e,t=-1,a=!1){let g=!0;const p=e.length;if(0===p||a)return u(e,g,a);d.length=p,f.length=p;let m,b,y=0;for(m=0;m<p;++m){d[m]=e.charAt(m);const t=e.charCodeAt(m);let a="L";t<=255?a=r[t]:1424<=t&&t<=1524?a="R":1536<=t&&t<=1791?(a=i[255&t],a||(0,n.warn)("Bidi: invalid Unicode character "+t.toString(16))):(1792<=t&&t<=2220||64336<=t&&t<=65023||65136<=t&&t<=65279)&&(a="AL"),"R"!==a&&"AL"!==a&&"AN"!==a||y++,f[m]=a}if(0===y)return g=!0,u(e,g);-1===t&&(y/p<.3&&p>4?(g=!0,t=0):(g=!1,t=1));const w=[];for(m=0;m<p;++m)w[m]=t;const x=s(t)?"R":"L",S=x,A=S;let k,C=S;for(m=0;m<p;++m)"NSM"===f[m]?f[m]=C:C=f[m];for(C=S,m=0;m<p;++m)k=f[m],"EN"===k?f[m]="AL"===C?"AN":"EN":"R"!==k&&"L"!==k&&"AL"!==k||(C=k);for(m=0;m<p;++m)k=f[m],"AL"===k&&(f[m]="R");for(m=1;m<p-1;++m)"ES"===f[m]&&"EN"===f[m-1]&&"EN"===f[m+1]&&(f[m]="EN"),"CS"!==f[m]||"EN"!==f[m-1]&&"AN"!==f[m-1]||f[m+1]!==f[m-1]||(f[m]=f[m-1]);for(m=0;m<p;++m)if("EN"===f[m]){for(let e=m-1;e>=0&&"ET"===f[e];--e)f[e]="EN";for(let e=m+1;e<p&&"ET"===f[e];++e)f[e]="EN"}for(m=0;m<p;++m)k=f[m],"WS"!==k&&"ES"!==k&&"ET"!==k&&"CS"!==k||(f[m]="ON");for(C=S,m=0;m<p;++m)k=f[m],"EN"===k?f[m]="L"===C?"L":"EN":"R"!==k&&"L"!==k||(C=k);for(m=0;m<p;++m)if("ON"===f[m]){const e=c(f,m+1,"ON");let t=S;m>0&&(t=f[m-1]);let a=A;e+1<p&&(a=f[e+1]),"L"!==t&&(t="R"),"L"!==a&&(a="R"),t===a&&l(f,m,e,t),m=e-1}for(m=0;m<p;++m)"ON"===f[m]&&(f[m]=x);for(m=0;m<p;++m)k=f[m],o(w[m])?"R"===k?w[m]+=1:"AN"!==k&&"EN"!==k||(w[m]+=2):"L"!==k&&"AN"!==k&&"EN"!==k||(w[m]+=1);let v,F=-1,O=99;for(m=0,b=w.length;m<b;++m)v=w[m],F<v&&(F=v),O>v&&s(v)&&(O=v);for(v=F;v>=O;--v){let e=-1;for(m=0,b=w.length;m<b;++m)w[m]<v?e>=0&&(h(d,e,m),e=-1):e<0&&(e=m);e>=0&&h(d,e,w.length)}for(m=0,b=d.length;m<b;++m){const e=d[m];"<"!==e&&">"!==e||(d[m]="")}return u(d.join(""),g)};var n=a(2);const r=["BN","BN","BN","BN","BN","BN","BN","BN","BN","S","B","S","WS","B","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","B","B","B","S","WS","ON","ON","ET","ET","ET","ON","ON","ON","ON","ON","ES","CS","ES","CS","CS","EN","EN","EN","EN","EN","EN","EN","EN","EN","EN","CS","ON","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","ON","ON","ON","BN","BN","BN","BN","BN","BN","B","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","BN","CS","ON","ET","ET","ET","ET","ON","ON","ON","ON","L","ON","ON","BN","ON","ON","ET","ET","EN","EN","ON","L","ON","ON","ON","EN","L","ON","ON","ON","ON","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","L","ON","L","L","L","L","L","L","L","L"],i=["AN","AN","AN","AN","AN","AN","ON","ON","AL","ET","ET","AL","CS","AL","ON","ON","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AL","AL","","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AN","AN","AN","AN","AN","AN","AN","AN","AN","AN","ET","AN","AN","AL","AL","AL","NSM","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","AL","NSM","NSM","NSM","NSM","NSM","NSM","NSM","AN","ON","NSM","NSM","NSM","NSM","NSM","NSM","AL","AL","NSM","NSM","ON","NSM","NSM","NSM","NSM","AL","AL","EN","EN","EN","EN","EN","EN","EN","EN","EN","EN","AL","AL","AL","AL","AL","AL"];function s(e){return 0!=(1&e)}function o(e){return 0==(1&e)}function c(e,t,a){let n,r;for(n=t,r=e.length;n<r;++n)if(e[n]!==a)return n;return n}function l(e,t,a,n){for(let r=t;r<a;++r)e[r]=n}function h(e,t,a){for(let n=t,r=a-1;n<r;++n,--r){const t=e[n];e[n]=e[r],e[r]=t}}function u(e,t,a=!1){let n="ltr";return a?n="ttb":t||(n="rtl"),{str:e,dir:n}}const d=[],f=[]},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.getFontSubstitution=function(e,t,a,d,f){const g=d=(0,n.normalizeFontName)(d);let p=e.get(g);if(p)return p;let m=l.get(d);if(!m)for(const[e,t]of h)if(d.startsWith(e)){d=`${t}${d.substring(e.length)}`,m=l.get(d);break}let b=!1;m||(m=l.get(f),b=!0);const y=`${t.getDocId()}_s${t.createFontId()}`;if(!m){if(!(0,r.validateFontName)(d))return e.set(g,null),null;const t=/bold/gi.test(d),a=/oblique|italic/gi.test(d);return p={css:y,guessFallback:!0,loadedName:y,baseFontName:d,src:`local(${d})`,style:t&&a&&c||t&&s||a&&o||i},e.set(g,p),p}const w=[];b&&(0,r.validateFontName)(d)&&w.push(`local(${d})`);const{style:x,ultimate:S}=u(m,w,a),A=null===S;return p={css:`${y}${A?"":`,${S}`}`,guessFallback:A,loadedName:y,baseFontName:d,src:w.join(","),style:x},e.set(g,p),p};var n=a(38),r=a(3);const i={style:"normal",weight:"normal"},s={style:"normal",weight:"bold"},o={style:"italic",weight:"normal"},c={style:"italic",weight:"bold"},l=new Map([["Times-Roman",{local:["Times New Roman","Times-Roman","Times","Liberation Serif","Nimbus Roman","Nimbus Roman L","Tinos","Thorndale","TeX Gyre Termes","FreeSerif","DejaVu Serif","Bitstream Vera Serif","Ubuntu"],style:i,ultimate:"serif"}],["Times-Bold",{alias:"Times-Roman",style:s,ultimate:"serif"}],["Times-Italic",{alias:"Times-Roman",style:o,ultimate:"serif"}],["Times-BoldItalic",{alias:"Times-Roman",style:c,ultimate:"serif"}],["Helvetica",{local:["Helvetica","Helvetica Neue","Arial","Arial Nova","Liberation Sans","Arimo","Nimbus Sans","Nimbus Sans L","A030","TeX Gyre Heros","FreeSans","DejaVu Sans","Albany","Bitstream Vera Sans","Arial Unicode MS","Microsoft Sans Serif","Apple Symbols","Cantarell"],path:"LiberationSans-Regular.ttf",style:i,ultimate:"sans-serif"}],["Helvetica-Bold",{alias:"Helvetica",path:"LiberationSans-Bold.ttf",style:s,ultimate:"sans-serif"}],["Helvetica-Oblique",{alias:"Helvetica",path:"LiberationSans-Italic.ttf",style:o,ultimate:"sans-serif"}],["Helvetica-BoldOblique",{alias:"Helvetica",path:"LiberationSans-BoldItalic.ttf",style:c,ultimate:"sans-serif"}],["Courier",{local:["Courier","Courier New","Liberation Mono","Nimbus Mono","Nimbus Mono L","Cousine","Cumberland","TeX Gyre Cursor","FreeMono"],style:i,ultimate:"monospace"}],["Courier-Bold",{alias:"Courier",style:s,ultimate:"monospace"}],["Courier-Oblique",{alias:"Courier",style:o,ultimate:"monospace"}],["Courier-BoldOblique",{alias:"Courier",style:c,ultimate:"monospace"}],["ArialBlack",{local:["Arial Black"],style:{style:"normal",weight:"900"},fallback:"Helvetica-Bold"}],["ArialBlack-Bold",{alias:"ArialBlack"}],["ArialBlack-Italic",{alias:"ArialBlack",style:{style:"italic",weight:"900"},fallback:"Helvetica-BoldOblique"}],["ArialBlack-BoldItalic",{alias:"ArialBlack-Italic"}],["ArialNarrow",{local:["Arial Narrow","Liberation Sans Narrow","Helvetica Condensed","Nimbus Sans Narrow","TeX Gyre Heros Cn"],style:i,fallback:"Helvetica"}],["ArialNarrow-Bold",{alias:"ArialNarrow",style:s,fallback:"Helvetica-Bold"}],["ArialNarrow-Italic",{alias:"ArialNarrow",style:o,fallback:"Helvetica-Oblique"}],["ArialNarrow-BoldItalic",{alias:"ArialNarrow",style:c,fallback:"Helvetica-BoldOblique"}],["Calibri",{local:["Calibri","Carlito"],style:i,fallback:"Helvetica"}],["Calibri-Bold",{alias:"Calibri",style:s,fallback:"Helvetica-Bold"}],["Calibri-Italic",{alias:"Calibri",style:o,fallback:"Helvetica-Oblique"}],["Calibri-BoldItalic",{alias:"Calibri",style:c,fallback:"Helvetica-BoldOblique"}],["Wingdings",{local:["Wingdings","URW Dingbats"],style:i}],["Wingdings-Regular",{alias:"Wingdings"}],["Wingdings-Bold",{alias:"Wingdings"}]]),h=new Map([["Arial-Black","ArialBlack"]]);function u({alias:e,local:t,path:a,fallback:n,style:r,ultimate:i},h,d,f=!0,g=!0,p=""){const m={style:null,ultimate:null};if(t){const e=p?` ${p}`:"";for(const a of t)h.push(`local(${a}${e})`)}if(e){const t=l.get(e),i=p||function(e){switch(e){case s:return"Bold";case o:return"Italic";case c:return"Bold Italic";default:if("bold"===e?.weight)return"Bold";if("italic"===e?.style)return"Italic"}return""}(r);Object.assign(m,u(t,h,d,f&&!n,g&&!a,i))}if(r&&(m.style=r),i&&(m.ultimate=i),f&&n){const e=l.get(n),{ultimate:t}=u(e,h,d,f,g&&!a,p);m.ultimate||=t}return g&&a&&d&&h.push(`url(${d}${a})`),m}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ImageResizer=void 0;var n=a(2);class r{constructor(e,t){this._imgData=e,this._isMask=t}static needsToBeResized(e,t){if(e<=this._goodSquareLength&&t<=this._goodSquareLength)return!1;const{MAX_DIM:a}=this;if(e>a||t>a)return!0;const n=e*t;if(this._hasMaxArea)return n>this.MAX_AREA;if(n<this._goodSquareLength**2)return!1;if(this._areGoodDims(e,t))return this._goodSquareLength=Math.max(this._goodSquareLength,Math.floor(Math.sqrt(e*t))),!1;this._goodSquareLength=this._guessMax(this._goodSquareLength,a,128,0);return n>(this.MAX_AREA=this._goodSquareLength**2)}static get MAX_DIM(){return(0,n.shadow)(this,"MAX_DIM",this._guessMax(2048,65537,0,1))}static get MAX_AREA(){return this._hasMaxArea=!0,(0,n.shadow)(this,"MAX_AREA",this._guessMax(r._goodSquareLength,this.MAX_DIM,128,0)**2)}static set MAX_AREA(e){e>=0&&(this._hasMaxArea=!0,(0,n.shadow)(this,"MAX_AREA",e))}static setMaxArea(e){this._hasMaxArea||(this.MAX_AREA=e>>2)}static _areGoodDims(e,t){try{const a=new OffscreenCanvas(e,t),n=a.getContext("2d");n.fillRect(0,0,1,1);const r=n.getImageData(0,0,1,1).data[3];return a.width=a.height=1,0!==r}catch{return!1}}static _guessMax(e,t,a,n){for(;e+a+1<t;){const a=Math.floor((e+t)/2),r=n||a;this._areGoodDims(a,r)?e=a:t=a}return e}static async createImage(e,t=!1){return new r(e,t)._createImage()}async _createImage(){const e=this._encodeBMP(),t=new Blob([e.buffer],{type:"image/bmp"}),a=createImageBitmap(t),{MAX_AREA:n,MAX_DIM:i}=r,{_imgData:s}=this,{width:o,height:c}=s,l=Math.max(o/i,c/i,Math.sqrt(o*c/n)),h=Math.max(l,2),u=Math.round(10*(l+1.25))/10/h,d=Math.floor(Math.log2(u)),f=new Array(d+2).fill(2);f[0]=h,f.splice(-1,1,u/(1<<d));let g=o,p=c,m=await a;for(const e of f){const t=g,a=p;g=Math.floor(g/e)-1,p=Math.floor(p/e)-1;const n=new OffscreenCanvas(g,p);n.getContext("2d").drawImage(m,0,0,t,a,0,0,g,p),m=n.transferToImageBitmap()}return s.data=null,s.bitmap=m,s.width=g,s.height=p,s}_encodeBMP(){const{width:e,height:t,kind:a}=this._imgData;let r,i=this._imgData.data,s=new Uint8Array(0),o=s,c=0;switch(a){case n.ImageKind.GRAYSCALE_1BPP:{r=1,s=new Uint8Array(this._isMask?[255,255,255,255,0,0,0,0]:[0,0,0,0,255,255,255,255]);const a=e+7>>3,n=a+3&-4;if(a!==n){const e=new Uint8Array(n*t);let r=0;for(let s=0,o=t*a;s<o;s+=a,r+=n)e.set(i.subarray(s,s+a),r);i=e}break}case n.ImageKind.RGB_24BPP:if(r=24,3&e){const a=3*e,n=a+3&-4,r=n-a,s=new Uint8Array(n*t);let o=0;for(let e=0,n=t*a;e<n;e+=a){const t=i.subarray(e,e+a);for(let e=0;e<a;e+=3)s[o++]=t[e+2],s[o++]=t[e+1],s[o++]=t[e];o+=r}i=s}else for(let e=0,t=i.length;e<t;e+=3){const t=i[e];i[e]=i[e+2],i[e+2]=t}break;case n.ImageKind.RGBA_32BPP:r=32,c=3,o=new Uint8Array(68);const a=new DataView(o.buffer);n.FeatureTest.isLittleEndian?(a.setUint32(0,255,!0),a.setUint32(4,65280,!0),a.setUint32(8,16711680,!0),a.setUint32(12,4278190080,!0)):(a.setUint32(0,4278190080,!0),a.setUint32(4,16711680,!0),a.setUint32(8,65280,!0),a.setUint32(12,255,!0));break;default:throw new Error("invalid format")}let l=0;const h=40+o.length,u=14+h+s.length+i.length,d=new Uint8Array(u),f=new DataView(d.buffer);return f.setUint16(l,19778,!0),l+=2,f.setUint32(l,u,!0),l+=4,f.setUint32(l,0,!0),l+=4,f.setUint32(l,14+h+s.length,!0),l+=4,f.setUint32(l,h,!0),l+=4,f.setInt32(l,e,!0),l+=4,f.setInt32(l,-t,!0),l+=4,f.setUint16(l,1,!0),l+=2,f.setUint16(l,r,!0),l+=2,f.setUint32(l,c,!0),l+=4,f.setUint32(l,0,!0),l+=4,f.setInt32(l,0,!0),l+=4,f.setInt32(l,0,!0),l+=4,f.setUint32(l,s.length/4,!0),l+=4,f.setUint32(l,0,!0),l+=4,d.set(o,l),l+=o.length,d.set(s,l),l+=s.length,d.set(i,l),d}}t.ImageResizer=r,r._goodSquareLength=2048},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.MurmurHash3_64=void 0;var n=a(2);const r=3285377520,i=4294901760,s=65535;t.MurmurHash3_64=class{constructor(e){this.h1=e?4294967295&e:r,this.h2=e?4294967295&e:r}update(e){let t,a;if("string"==typeof e){t=new Uint8Array(2*e.length),a=0;for(let n=0,r=e.length;n<r;n++){const r=e.charCodeAt(n);r<=255?t[a++]=r:(t[a++]=r>>>8,t[a++]=255&r)}}else{if(!(0,n.isArrayBuffer)(e))throw new Error("Wrong data format in MurmurHash3_64_update. Input must be a string or array.");t=e.slice(),a=t.byteLength}const r=a>>2,o=a-4*r,c=new Uint32Array(t.buffer,0,r);let l=0,h=0,u=this.h1,d=this.h2;const f=3432918353,g=461845907,p=11601,m=13715;for(let e=0;e<r;e++)1&e?(l=c[e],l=l*f&i|l*p&s,l=l<<15|l>>>17,l=l*g&i|l*m&s,u^=l,u=u<<13|u>>>19,u=5*u+3864292196):(h=c[e],h=h*f&i|h*p&s,h=h<<15|h>>>17,h=h*g&i|h*m&s,d^=h,d=d<<13|d>>>19,d=5*d+3864292196);switch(l=0,o){case 3:l^=t[4*r+2]<<16;case 2:l^=t[4*r+1]<<8;case 1:l^=t[4*r],l=l*f&i|l*p&s,l=l<<15|l>>>17,l=l*g&i|l*m&s,1&r?u^=l:d^=l}this.h1=u,this.h2=d}hexdigest(){let e=this.h1,t=this.h2;return e^=t>>>1,e=3981806797*e&i|36045*e&s,t=4283543511*t&i|(2950163797*(t<<16|e>>>16)&i)>>>16,e^=t>>>1,e=444984403*e&i|60499*e&s,t=3301882366*t&i|(3120437893*(t<<16|e>>>16)&i)>>>16,e^=t>>>1,(e>>>0).toString(16).padStart(8,"0")+(t>>>0).toString(16).padStart(8,"0")}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.OperatorList=void 0;var n=a(2);function r(e,t,a,n,r){let i=e;for(let e=0,a=t.length-1;e<a;e++){const a=t[e];i=i[a]||=[]}i[t.at(-1)]={checkFn:a,iterateFn:n,processFn:r}}const i=[];r(i,[n.OPS.save,n.OPS.transform,n.OPS.paintInlineImageXObject,n.OPS.restore],null,(function(e,t){const a=e.fnArray,r=(t-(e.iCurr-3))%4;switch(r){case 0:return a[t]===n.OPS.save;case 1:return a[t]===n.OPS.transform;case 2:return a[t]===n.OPS.paintInlineImageXObject;case 3:return a[t]===n.OPS.restore}throw new Error(`iterateInlineImageGroup - invalid pos: ${r}`)}),(function(e,t){const a=e.fnArray,r=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=i-1,l=Math.min(Math.floor((t-s)/4),200);if(l<10)return t-(t-s)%4;let h=0;const u=[];let d=0,f=1,g=1;for(let e=0;e<l;e++){const t=r[o+(e<<2)],a=r[c+(e<<2)][0];f+a.width>1e3&&(h=Math.max(h,f),g+=d+2,f=0,d=0),u.push({transform:t,x:f,y:g,w:a.width,h:a.height}),f+=a.width+2,d=Math.max(d,a.height)}const p=Math.max(h,f)+1,m=g+d+1,b=new Uint8Array(p*m*4),y=p<<2;for(let e=0;e<l;e++){const t=r[c+(e<<2)][0].data,a=u[e].w<<2;let n=0,i=u[e].x+u[e].y*p<<2;b.set(t.subarray(0,a),i-y);for(let r=0,s=u[e].h;r<s;r++)b.set(t.subarray(n,n+a),i),n+=a,i+=y;for(b.set(t.subarray(n-a,n),i);i>=0;)t[i-4]=t[i],t[i-3]=t[i+1],t[i-2]=t[i+2],t[i-1]=t[i+3],t[i+a]=t[i+a-4],t[i+a+1]=t[i+a-3],t[i+a+2]=t[i+a-2],t[i+a+3]=t[i+a-1],i-=y}const w={width:p,height:m};if(e.isOffscreenCanvasSupported){const e=new OffscreenCanvas(p,m);e.getContext("2d").putImageData(new ImageData(new Uint8ClampedArray(b.buffer),p,m),0,0),w.bitmap=e.transferToImageBitmap(),w.data=null}else w.kind=n.ImageKind.RGBA_32BPP,w.data=b;return a.splice(s,4*l,n.OPS.paintInlineImageXObjectGroup),r.splice(s,4*l,[w,u]),s+1})),r(i,[n.OPS.save,n.OPS.transform,n.OPS.paintImageMaskXObject,n.OPS.restore],null,(function(e,t){const a=e.fnArray,r=(t-(e.iCurr-3))%4;switch(r){case 0:return a[t]===n.OPS.save;case 1:return a[t]===n.OPS.transform;case 2:return a[t]===n.OPS.paintImageMaskXObject;case 3:return a[t]===n.OPS.restore}throw new Error(`iterateImageMaskGroup - invalid pos: ${r}`)}),(function(e,t){const a=e.fnArray,r=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=i-1;let l=Math.floor((t-s)/4);if(l<10)return t-(t-s)%4;let h,u,d=!1;const f=r[c][0],g=r[o][0],p=r[o][1],m=r[o][2],b=r[o][3];if(p===m){d=!0,h=o+4;let e=c+4;for(let t=1;t<l;t++,h+=4,e+=4)if(u=r[h],r[e][0]!==f||u[0]!==g||u[1]!==p||u[2]!==m||u[3]!==b){t<10?d=!1:l=t;break}}if(d){l=Math.min(l,1e3);const e=new Float32Array(2*l);h=o;for(let t=0;t<l;t++,h+=4)u=r[h],e[t<<1]=u[4],e[1+(t<<1)]=u[5];a.splice(s,4*l,n.OPS.paintImageMaskXObjectRepeat),r.splice(s,4*l,[f,g,p,m,b,e])}else{l=Math.min(l,100);const e=[];for(let t=0;t<l;t++){u=r[o+(t<<2)];const a=r[c+(t<<2)][0];e.push({data:a.data,width:a.width,height:a.height,interpolate:a.interpolate,count:a.count,transform:u})}a.splice(s,4*l,n.OPS.paintImageMaskXObjectGroup),r.splice(s,4*l,[e])}return s+1})),r(i,[n.OPS.save,n.OPS.transform,n.OPS.paintImageXObject,n.OPS.restore],(function(e){const t=e.argsArray,a=e.iCurr-2;return 0===t[a][1]&&0===t[a][2]}),(function(e,t){const a=e.fnArray,r=e.argsArray,i=(t-(e.iCurr-3))%4;switch(i){case 0:return a[t]===n.OPS.save;case 1:if(a[t]!==n.OPS.transform)return!1;const i=e.iCurr-2,s=r[i][0],o=r[i][3];return r[t][0]===s&&0===r[t][1]&&0===r[t][2]&&r[t][3]===o;case 2:if(a[t]!==n.OPS.paintImageXObject)return!1;const c=r[e.iCurr-1][0];return r[t][0]===c;case 3:return a[t]===n.OPS.restore}throw new Error(`iterateImageGroup - invalid pos: ${i}`)}),(function(e,t){const a=e.fnArray,r=e.argsArray,i=e.iCurr,s=i-3,o=i-2,c=r[i-1][0],l=r[o][0],h=r[o][3],u=Math.min(Math.floor((t-s)/4),1e3);if(u<3)return t-(t-s)%4;const d=new Float32Array(2*u);let f=o;for(let e=0;e<u;e++,f+=4){const t=r[f];d[e<<1]=t[4],d[1+(e<<1)]=t[5]}const g=[c,l,h,d];return a.splice(s,4*u,n.OPS.paintImageXObjectRepeat),r.splice(s,4*u,g),s+1})),r(i,[n.OPS.beginText,n.OPS.setFont,n.OPS.setTextMatrix,n.OPS.showText,n.OPS.endText],null,(function(e,t){const a=e.fnArray,r=e.argsArray,i=(t-(e.iCurr-4))%5;switch(i){case 0:return a[t]===n.OPS.beginText;case 1:return a[t]===n.OPS.setFont;case 2:return a[t]===n.OPS.setTextMatrix;case 3:if(a[t]!==n.OPS.showText)return!1;const i=e.iCurr-3,s=r[i][0],o=r[i][1];return r[t][0]===s&&r[t][1]===o;case 4:return a[t]===n.OPS.endText}throw new Error(`iterateShowTextGroup - invalid pos: ${i}`)}),(function(e,t){const a=e.fnArray,n=e.argsArray,r=e.iCurr,i=r-4,s=r-3,o=r-2,c=r-1,l=r,h=n[s][0],u=n[s][1];let d=Math.min(Math.floor((t-i)/5),1e3);if(d<3)return t-(t-i)%5;let f=i;i>=4&&a[i-4]===a[s]&&a[i-3]===a[o]&&a[i-2]===a[c]&&a[i-1]===a[l]&&n[i-4][0]===h&&n[i-4][1]===u&&(d++,f-=5);let g=f+4;for(let e=1;e<d;e++)a.splice(g,3),n.splice(g,3),g+=2;return g+1}));class s{constructor(e){this.queue=e}_optimize(){}push(e,t){this.queue.fnArray.push(e),this.queue.argsArray.push(t),this._optimize()}flush(){}reset(){}}class o extends s{constructor(e){super(e),this.state=null,this.context={iCurr:0,fnArray:e.fnArray,argsArray:e.argsArray,isOffscreenCanvasSupported:!1},this.match=null,this.lastProcessed=0}set isOffscreenCanvasSupported(e){this.context.isOffscreenCanvasSupported=e}_optimize(){const e=this.queue.fnArray;let t=this.lastProcessed,a=e.length,n=this.state,r=this.match;if(!n&&!r&&t+1===a&&!i[e[t]])return void(this.lastProcessed=a);const s=this.context;for(;t<a;){if(r){if((0,r.iterateFn)(s,t)){t++;continue}if(t=(0,r.processFn)(s,t+1),a=e.length,r=null,n=null,t>=a)break}n=(n||i)[e[t]],n&&!Array.isArray(n)?(s.iCurr=t,t++,!n.checkFn||(0,n.checkFn)(s)?(r=n,n=null):n=null):t++}this.state=n,this.match=r,this.lastProcessed=t}flush(){for(;this.match;){const e=this.queue.fnArray.length;this.lastProcessed=(0,this.match.processFn)(this.context,e),this.match=null,this.state=null,this._optimize()}}reset(){this.state=null,this.match=null,this.lastProcessed=0}}class c{static CHUNK_SIZE=1e3;static CHUNK_SIZE_ABOUT=this.CHUNK_SIZE-5;constructor(e=0,t){this._streamSink=t,this.fnArray=[],this.argsArray=[],this.optimizer=!t||e&n.RenderingIntentFlag.OPLIST?new s(this):new o(this),this.dependencies=new Set,this._totalLength=0,this.weight=0,this._resolved=t?null:Promise.resolve()}set isOffscreenCanvasSupported(e){this.optimizer.isOffscreenCanvasSupported=e}get length(){return this.argsArray.length}get ready(){return this._resolved||this._streamSink.ready}get totalLength(){return this._totalLength+this.length}addOp(e,t){this.optimizer.push(e,t),this.weight++,this._streamSink&&(this.weight>=c.CHUNK_SIZE||this.weight>=c.CHUNK_SIZE_ABOUT&&(e===n.OPS.restore||e===n.OPS.endText))&&this.flush()}addImageOps(e,t,a){void 0!==a&&this.addOp(n.OPS.beginMarkedContentProps,["OC",a]),this.addOp(e,t),void 0!==a&&this.addOp(n.OPS.endMarkedContent,[])}addDependency(e){this.dependencies.has(e)||(this.dependencies.add(e),this.addOp(n.OPS.dependency,[e]))}addDependencies(e){for(const t of e)this.addDependency(t)}addOpList(e){if(e instanceof c){for(const t of e.dependencies)this.dependencies.add(t);for(let t=0,a=e.length;t<a;t++)this.addOp(e.fnArray[t],e.argsArray[t])}else(0,n.warn)('addOpList - ignoring invalid "opList" parameter.')}getIR(){return{fnArray:this.fnArray,argsArray:this.argsArray,length:this.length}}get _transfers(){const e=[],{fnArray:t,argsArray:a,length:r}=this;for(let i=0;i<r;i++)switch(t[i]){case n.OPS.paintInlineImageXObject:case n.OPS.paintInlineImageXObjectGroup:case n.OPS.paintImageMaskXObject:const t=a[i][0];!t.cached&&t.data?.buffer instanceof ArrayBuffer&&e.push(t.data.buffer)}return e}flush(e=!1,t=null){this.optimizer.flush();const a=this.length;this._totalLength+=a,this._streamSink.enqueue({fnArray:this.fnArray,argsArray:this.argsArray,lastChunk:e,separateAnnots:t,length:a},1,this._transfers),this.dependencies.clear(),this.fnArray.length=0,this.argsArray.length=0,this.weight=0,this.optimizer.reset()}}t.OperatorList=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PDFImage=void 0;var n=a(2),r=a(28),i=a(5),s=a(12),o=a(18),c=a(62),l=a(26),h=a(30),u=a(4);function d(e,t,a,n){return(e=t+e*a)<0?e=0:e>n&&(e=n),e}function f(e,t,a,n,r,i){const s=r*i;let o;o=t<=8?new Uint8Array(s):t<=16?new Uint16Array(s):new Uint32Array(s);const c=a/r,l=n/i;let h,u,d,f,g=0;const p=new Uint16Array(r),m=a;for(h=0;h<r;h++)p[h]=Math.floor(h*c);for(h=0;h<i;h++)for(d=Math.floor(h*l)*m,u=0;u<r;u++)f=d+p[u],o[g++]=e[f];return o}class g{constructor({xref:e,res:t,image:a,isInline:r=!1,smask:o=null,mask:c=null,isMask:l=!1,pdfFunctionFactory:d,localColorSpaceCache:f}){this.image=a;const p=a.dict,m=p.get("F","Filter");let b;if(m instanceof u.Name)b=m.name;else if(Array.isArray(m)){const t=e.fetchIfRef(m[0]);t instanceof u.Name&&(b=t.name)}switch(b){case"JPXDecode":const e=new h.JpxImage;e.parseImageProperties(a.stream),a.stream.reset(),a.width=e.width,a.height=e.height,a.bitsPerComponent=e.bitsPerComponent,a.numComps=e.componentsCount;break;case"JBIG2Decode":a.bitsPerComponent=1,a.numComps=1}let y=p.get("W","Width"),w=p.get("H","Height");if(Number.isInteger(a.width)&&a.width>0&&Number.isInteger(a.height)&&a.height>0&&(a.width!==y||a.height!==w)&&((0,n.warn)("PDFImage - using the Width/Height of the image data, rather than the image dictionary."),y=a.width,w=a.height),y<1||w<1)throw new n.FormatError(`Invalid image width: ${y} or height: ${w}`);this.width=y,this.height=w,this.interpolate=p.get("I","Interpolate"),this.imageMask=p.get("IM","ImageMask")||!1,this.matte=p.get("Matte")||!1;let x=a.bitsPerComponent;if(!x&&(x=p.get("BPC","BitsPerComponent"),!x)){if(!this.imageMask)throw new n.FormatError(`Bits per component missing in image: ${this.imageMask}`);x=1}if(this.bpc=x,!this.imageMask){let i=p.getRaw("CS")||p.getRaw("ColorSpace");if(!i)switch((0,n.info)("JPX images (which do not require color spaces)"),a.numComps){case 1:i=u.Name.get("DeviceGray");break;case 3:i=u.Name.get("DeviceRGB");break;case 4:i=u.Name.get("DeviceCMYK");break;default:throw new Error(`JPX images with ${a.numComps} color components not supported.`)}this.colorSpace=s.ColorSpace.parse({cs:i,xref:e,resources:r?t:null,pdfFunctionFactory:d,localColorSpaceCache:f}),this.numComps=this.colorSpace.numComps}if(this.decode=p.getArray("D","Decode"),this.needsDecode=!1,this.decode&&(this.colorSpace&&!this.colorSpace.isDefaultDecode(this.decode,x)||l&&!s.ColorSpace.isDefaultDecode(this.decode,1))){this.needsDecode=!0;const e=(1<<x)-1;this.decodeCoefficients=[],this.decodeAddends=[];const t="Indexed"===this.colorSpace?.name;for(let a=0,n=0;a<this.decode.length;a+=2,++n){const r=this.decode[a],i=this.decode[a+1];this.decodeCoefficients[n]=t?(i-r)/e:i-r,this.decodeAddends[n]=t?r:e*r}}if(o)this.smask=new g({xref:e,res:t,image:o,isInline:r,pdfFunctionFactory:d,localColorSpaceCache:f});else if(c)if(c instanceof i.BaseStream){c.dict.get("IM","ImageMask")?this.mask=new g({xref:e,res:t,image:c,isInline:r,isMask:!0,pdfFunctionFactory:d,localColorSpaceCache:f}):(0,n.warn)("Ignoring /Mask in image without /ImageMask.")}else this.mask=c}static async buildImage({xref:e,res:t,image:a,isInline:r=!1,pdfFunctionFactory:s,localColorSpaceCache:o}){const c=a;let l=null,h=null;const u=a.dict.get("SMask"),d=a.dict.get("Mask");return u?u instanceof i.BaseStream?l=u:(0,n.warn)("Unsupported /SMask format."):d&&(d instanceof i.BaseStream||Array.isArray(d)?h=d:(0,n.warn)("Unsupported /Mask format.")),new g({xref:e,res:t,image:c,isInline:r,smask:l,mask:h,pdfFunctionFactory:s,localColorSpaceCache:o})}static createRawMask({imgArray:e,width:t,height:a,imageIsFromDecodeStream:n,inverseDecode:r,interpolate:i}){const s=(t+7>>3)*a,o=e.byteLength;let c,l;if(!n||r&&!(s===o)?r?(c=new Uint8Array(s),c.set(e),c.fill(255,o)):c=new Uint8Array(e):c=e,r)for(l=0;l<o;l++)c[l]^=255;return{data:c,width:t,height:a,interpolate:i}}static async createMask({imgArray:e,width:t,height:a,imageIsFromDecodeStream:i,inverseDecode:s,interpolate:o,isOffscreenCanvasSupported:l=!1}){const h=1===t&&1===a&&s===(0===e.length||!!(128&e[0]));if(h)return{isSingleOpaquePixel:h};if(l){if(c.ImageResizer.needsToBeResized(t,a)){const i=new Uint8ClampedArray(t*a*4);return(0,r.convertBlackAndWhiteToRGBA)({src:e,dest:i,width:t,height:a,nonBlackColor:0,inverseDecode:s}),c.ImageResizer.createImage({kind:n.ImageKind.RGBA_32BPP,data:i,width:t,height:a,interpolate:o})}const i=new OffscreenCanvas(t,a),l=i.getContext("2d"),h=l.createImageData(t,a);(0,r.convertBlackAndWhiteToRGBA)({src:e,dest:h.data,width:t,height:a,nonBlackColor:0,inverseDecode:s}),l.putImageData(h,0,0);return{data:null,width:t,height:a,interpolate:o,bitmap:i.transferToImageBitmap()}}return this.createRawMask({imgArray:e,width:t,height:a,inverseDecode:s,imageIsFromDecodeStream:i,interpolate:o})}get drawWidth(){return Math.max(this.width,this.smask?.width||0,this.mask?.width||0)}get drawHeight(){return Math.max(this.height,this.smask?.height||0,this.mask?.height||0)}decodeBuffer(e){const t=this.bpc,a=this.numComps,n=this.decodeAddends,r=this.decodeCoefficients,i=(1<<t)-1;let s,o;if(1===t){for(s=0,o=e.length;s<o;s++)e[s]=+!e[s];return}let c=0;for(s=0,o=this.width*this.height;s<o;s++)for(let t=0;t<a;t++)e[c]=d(e[c],n[t],r[t],i),c++}getComponents(e){const t=this.bpc;if(8===t)return e;const a=this.width,n=this.height,r=this.numComps,i=a*n*r;let s,o=0;s=t<=8?new Uint8Array(i):t<=16?new Uint16Array(i):new Uint32Array(i);const c=a*r,l=(1<<t)-1;let h,u,d=0;if(1===t){let t,a,r;for(let i=0;i<n;i++){for(a=d+(-8&c),r=d+c;d<a;)u=e[o++],s[d]=u>>7&1,s[d+1]=u>>6&1,s[d+2]=u>>5&1,s[d+3]=u>>4&1,s[d+4]=u>>3&1,s[d+5]=u>>2&1,s[d+6]=u>>1&1,s[d+7]=1&u,d+=8;if(d<r)for(u=e[o++],t=128;d<r;)s[d++]=+!!(u&t),t>>=1}}else{let a=0;for(u=0,d=0,h=i;d<h;++d){for(d%c==0&&(u=0,a=0);a<t;)u=u<<8|e[o++],a+=8;const n=a-t;let r=u>>n;r<0?r=0:r>l&&(r=l),s[d]=r,u&=(1<<n)-1,a=n}}return s}fillOpacity(e,t,a,r,i){const s=this.smask,o=this.mask;let c,l,h,u,d,p;if(s)l=s.width,h=s.height,c=new Uint8ClampedArray(l*h),s.fillGrayBuffer(c),l===t&&h===a||(c=f(c,s.bpc,l,h,t,a));else if(o)if(o instanceof g){for(l=o.width,h=o.height,c=new Uint8ClampedArray(l*h),o.numComps=1,o.fillGrayBuffer(c),u=0,d=l*h;u<d;++u)c[u]=255-c[u];l===t&&h===a||(c=f(c,o.bpc,l,h,t,a))}else{if(!Array.isArray(o))throw new n.FormatError("Unknown mask format.");{c=new Uint8ClampedArray(t*a);const e=this.numComps;for(u=0,d=t*a;u<d;++u){let t=0;const a=u*e;for(p=0;p<e;++p){const e=i[a+p],n=2*p;if(e<o[n]||e>o[n+1]){t=255;break}}c[u]=t}}}if(c)for(u=0,p=3,d=t*r;u<d;++u,p+=4)e[p]=c[u];else for(u=0,p=3,d=t*r;u<d;++u,p+=4)e[p]=255}undoPreblend(e,t,a){const n=this.smask?.matte;if(!n)return;const r=this.colorSpace.getRgb(n,0),i=r[0],s=r[1],o=r[2],c=t*a*4;for(let t=0;t<c;t+=4){const a=e[t+3];if(0===a){e[t]=255,e[t+1]=255,e[t+2]=255;continue}const n=255/a;e[t]=(e[t]-i)*n+i,e[t+1]=(e[t+1]-s)*n+s,e[t+2]=(e[t+2]-o)*n+o}}async createImageData(e=!1,t=!1){const a=this.drawWidth,r=this.drawHeight,i={width:a,height:r,interpolate:this.interpolate,kind:0,data:null},s=this.numComps,o=this.width,h=this.height,u=this.bpc,d=o*s*u+7>>3,f=t&&c.ImageResizer.needsToBeResized(a,r);if(!e){let e;if("DeviceGray"===this.colorSpace.name&&1===u?e=n.ImageKind.GRAYSCALE_1BPP:"DeviceRGB"!==this.colorSpace.name||8!==u||this.needsDecode||(e=n.ImageKind.RGB_24BPP),e&&!this.smask&&!this.mask&&a===o&&r===h){const s=this.getImageBytes(h*d,{});if(t)return f?c.ImageResizer.createImage({data:s,kind:e,width:a,height:r,interpolate:this.interpolate},this.needsDecode):this.createBitmap(e,o,h,s);if(i.kind=e,i.data=s,this.needsDecode){(0,n.assert)(e===n.ImageKind.GRAYSCALE_1BPP,"PDFImage.createImageData: The image must be grayscale.");const t=i.data;for(let e=0,a=t.length;e<a;e++)t[e]^=255}return i}if(this.image instanceof l.JpegStream&&!this.smask&&!this.mask&&!this.needsDecode){let e=h*d;if(t&&!f){let t=!1;switch(this.colorSpace.name){case"DeviceGray":e*=4,t=!0;break;case"DeviceRGB":e=e/3*4,t=!0;break;case"DeviceCMYK":t=!0}if(t){const t=this.getImageBytes(e,{drawWidth:a,drawHeight:r,forceRGBA:!0});return this.createBitmap(n.ImageKind.RGBA_32BPP,a,r,t)}}else switch(this.colorSpace.name){case"DeviceGray":e*=3;case"DeviceRGB":case"DeviceCMYK":return i.kind=n.ImageKind.RGB_24BPP,i.data=this.getImageBytes(e,{drawWidth:a,drawHeight:r,forceRGB:!0}),f?c.ImageResizer.createImage(i):i}}}const g=this.getImageBytes(h*d,{internal:!0}),p=0|g.length/d*r/h,m=this.getComponents(g);let b,y,w,x,S,A;if(t&&!f&&(w=new OffscreenCanvas(a,r),x=w.getContext("2d"),S=x.createImageData(a,r),A=S.data),i.kind=n.ImageKind.RGBA_32BPP,e||this.smask||this.mask)t&&!f||(A=new Uint8ClampedArray(a*r*4)),b=1,y=!0,this.fillOpacity(A,a,r,p,m);else{if(!t||f)i.kind=n.ImageKind.RGB_24BPP,A=new Uint8ClampedArray(a*r*3),b=0;else{new Uint32Array(A.buffer).fill(n.FeatureTest.isLittleEndian?4278190080:255),b=1}y=!1}if(this.needsDecode&&this.decodeBuffer(m),this.colorSpace.fillRgb(A,o,h,a,r,p,u,m,b),y&&this.undoPreblend(A,a,p),t&&!f){x.putImageData(S,0,0);return{data:null,width:a,height:r,bitmap:w.transferToImageBitmap(),interpolate:this.interpolate}}return i.data=A,f?c.ImageResizer.createImage(i):i}fillGrayBuffer(e){const t=this.numComps;if(1!==t)throw new n.FormatError(`Reading gray scale from a color image: ${t}`);const a=this.width,r=this.height,i=this.bpc,s=a*t*i+7>>3,o=this.getImageBytes(r*s,{internal:!0}),c=this.getComponents(o);let l,h;if(1===i){if(h=a*r,this.needsDecode)for(l=0;l<h;++l)e[l]=c[l]-1&255;else for(l=0;l<h;++l)e[l]=255&-c[l];return}this.needsDecode&&this.decodeBuffer(c),h=a*r;const u=255/((1<<i)-1);for(l=0;l<h;++l)e[l]=u*c[l]}createBitmap(e,t,a,i){const s=new OffscreenCanvas(t,a),o=s.getContext("2d");let c;e===n.ImageKind.RGBA_32BPP?c=new ImageData(i,t,a):(c=o.createImageData(t,a),(0,r.convertToRGBA)({kind:e,src:i,dest:new Uint32Array(c.data.buffer),width:t,height:a,inverseDecode:this.needsDecode})),o.putImageData(c,0,0);return{data:null,width:t,height:a,bitmap:s.transferToImageBitmap(),interpolate:this.interpolate}}getImageBytes(e,{drawWidth:t,drawHeight:a,forceRGBA:r=!1,forceRGB:i=!1,internal:s=!1}){this.image.reset(),this.image.drawWidth=t||this.width,this.image.drawHeight=a||this.height,this.image.forceRGBA=!!r,this.image.forceRGB=!!i;const c=this.image.getBytes(e);return s||this.image instanceof o.DecodeStream?c:((0,n.assert)(c instanceof Uint8Array,'PDFImage.getImageBytes: Unsupported "imageBytes" type.'),new Uint8Array(c))}}t.PDFImage=g},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Catalog=void 0;var n=a(3),r=a(2),i=a(4),s=a(67),o=a(5),c=a(68),l=a(12),h=a(69),u=a(59),d=a(70),f=a(72);function g(e){return e instanceof i.Dict&&(e=e.get("D")),Array.isArray(e)?e:null}class p{constructor(e,t){if(this.pdfManager=e,this.xref=t,this._catDict=t.getCatalogObj(),!(this._catDict instanceof i.Dict))throw new r.FormatError("Catalog object is not a dictionary.");this.toplevelPagesDict,this._actualNumPages=null,this.fontCache=new i.RefSetCache,this.builtInCMapCache=new Map,this.standardFontDataCache=new Map,this.globalImageCache=new u.GlobalImageCache,this.pageKidsCountCache=new i.RefSetCache,this.pageIndexCache=new i.RefSetCache,this.nonBlendModesSet=new i.RefSet,this.systemFontCache=new Map}cloneDict(){return this._catDict.clone()}get version(){const e=this._catDict.get("Version");if(e instanceof i.Name){if(n.PDF_VERSION_REGEXP.test(e.name))return(0,r.shadow)(this,"version",e.name);(0,r.warn)(`Invalid PDF catalog version: ${e.name}`)}return(0,r.shadow)(this,"version",null)}get lang(){const e=this._catDict.get("Lang");return(0,r.shadow)(this,"lang","string"==typeof e?(0,r.stringToPDFString)(e):null)}get needsRendering(){const e=this._catDict.get("NeedsRendering");return(0,r.shadow)(this,"needsRendering","boolean"==typeof e&&e)}get collection(){let e=null;try{const t=this._catDict.get("Collection");t instanceof i.Dict&&t.size>0&&(e=t)}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.info)("Cannot fetch Collection entry; assuming no collection is present.")}return(0,r.shadow)(this,"collection",e)}get acroForm(){let e=null;try{const t=this._catDict.get("AcroForm");t instanceof i.Dict&&t.size>0&&(e=t)}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.info)("Cannot fetch AcroForm entry; assuming no forms are present.")}return(0,r.shadow)(this,"acroForm",e)}get acroFormRef(){const e=this._catDict.getRaw("AcroForm");return(0,r.shadow)(this,"acroFormRef",e instanceof i.Ref?e:null)}get metadata(){const e=this._catDict.getRaw("Metadata");if(!(e instanceof i.Ref))return(0,r.shadow)(this,"metadata",null);let t=null;try{const a=this.xref.fetch(e,!this.xref.encrypt?.encryptMetadata);if(a instanceof o.BaseStream&&a.dict instanceof i.Dict){const e=a.dict.get("Type"),n=a.dict.get("Subtype");if((0,i.isName)(e,"Metadata")&&(0,i.isName)(n,"XML")){const e=(0,r.stringToUTF8String)(a.getString());e&&(t=new d.MetadataParser(e).serializable)}}}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.info)(`Skipping invalid Metadata: "${e}".`)}return(0,r.shadow)(this,"metadata",t)}get markInfo(){let e=null;try{e=this._readMarkInfo()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)("Unable to read mark info.")}return(0,r.shadow)(this,"markInfo",e)}_readMarkInfo(){const e=this._catDict.get("MarkInfo");if(!(e instanceof i.Dict))return null;const t={Marked:!1,UserProperties:!1,Suspects:!1};for(const a in t){const n=e.get(a);"boolean"==typeof n&&(t[a]=n)}return t}get structTreeRoot(){let e=null;try{e=this._readStructTreeRoot()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)("Unable read to structTreeRoot info.")}return(0,r.shadow)(this,"structTreeRoot",e)}_readStructTreeRoot(){const e=this._catDict.getRaw("StructTreeRoot"),t=this.xref.fetchIfRef(e);if(!(t instanceof i.Dict))return null;const a=new f.StructTreeRoot(t,e);return a.init(),a}get toplevelPagesDict(){const e=this._catDict.get("Pages");if(!(e instanceof i.Dict))throw new r.FormatError("Invalid top-level pages dictionary.");return(0,r.shadow)(this,"toplevelPagesDict",e)}get documentOutline(){let e=null;try{e=this._readDocumentOutline()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)("Unable to read document outline.")}return(0,r.shadow)(this,"documentOutline",e)}_readDocumentOutline(){let e=this._catDict.get("Outlines");if(!(e instanceof i.Dict))return null;if(e=e.getRaw("First"),!(e instanceof i.Ref))return null;const t={items:[]},a=[{obj:e,parent:t}],n=new i.RefSet;n.put(e);const s=this.xref,o=new Uint8ClampedArray(3);for(;a.length>0;){const t=a.shift(),c=s.fetchIfRef(t.obj);if(null===c)continue;if(!c.has("Title"))throw new r.FormatError("Invalid outline item encountered.");const h={url:null,dest:null,action:null};p.parseDestDictionary({destDict:c,resultObj:h,docBaseUrl:this.baseUrl,docAttachments:this.attachments});const u=c.get("Title"),d=c.get("F")||0,f=c.getArray("C"),g=c.get("Count");let m=o;!Array.isArray(f)||3!==f.length||0===f[0]&&0===f[1]&&0===f[2]||(m=l.ColorSpace.singletons.rgb.getRgb(f,0));const b={action:h.action,attachment:h.attachment,dest:h.dest,url:h.url,unsafeUrl:h.unsafeUrl,newWindow:h.newWindow,setOCGState:h.setOCGState,title:(0,r.stringToPDFString)(u),color:m,count:Number.isInteger(g)?g:void 0,bold:!!(2&d),italic:!!(1&d),items:[]};t.parent.items.push(b),e=c.getRaw("First"),e instanceof i.Ref&&!n.has(e)&&(a.push({obj:e,parent:b}),n.put(e)),e=c.getRaw("Next"),e instanceof i.Ref&&!n.has(e)&&(a.push({obj:e,parent:t.parent}),n.put(e))}return t.items.length>0?t.items:null}get permissions(){let e=null;try{e=this._readPermissions()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)("Unable to read permissions.")}return(0,r.shadow)(this,"permissions",e)}_readPermissions(){const e=this.xref.trailer.get("Encrypt");if(!(e instanceof i.Dict))return null;let t=e.get("P");if("number"!=typeof t)return null;t+=2**32;const a=[];for(const e in r.PermissionFlag){const n=r.PermissionFlag[e];t&n&&a.push(n)}return a}get optionalContentConfig(){let e=null;try{const t=this._catDict.get("OCProperties");if(!t)return(0,r.shadow)(this,"optionalContentConfig",null);const a=t.get("D");if(!a)return(0,r.shadow)(this,"optionalContentConfig",null);const n=t.get("OCGs");if(!Array.isArray(n))return(0,r.shadow)(this,"optionalContentConfig",null);const s=[],o=[];for(const e of n){if(!(e instanceof i.Ref))continue;o.push(e);const t=this.xref.fetchIfRef(e);s.push({id:e.toString(),name:"string"==typeof t.get("Name")?(0,r.stringToPDFString)(t.get("Name")):null,intent:"string"==typeof t.get("Intent")?(0,r.stringToPDFString)(t.get("Intent")):null})}e=this._readOptionalContentConfig(a,o),e.groups=s}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)(`Unable to read optional content config: ${e}`)}return(0,r.shadow)(this,"optionalContentConfig",e)}_readOptionalContentConfig(e,t){function a(e){const a=[];if(Array.isArray(e))for(const n of e)n instanceof i.Ref&&t.includes(n)&&a.push(n.toString());return a}function n(e,a=0){if(!Array.isArray(e))return null;const n=[];for(const r of e){if(r instanceof i.Ref&&t.includes(r)){c.put(r),n.push(r.toString());continue}const e=s(r,a);e&&n.push(e)}if(a>0)return n;const r=[];for(const e of t)c.has(e)||r.push(e.toString());return r.length&&n.push({name:null,order:r}),n}function s(e,t){if(++t>l)return(0,r.warn)("parseNestedOrder - reached MAX_NESTED_LEVELS."),null;const a=o.fetchIfRef(e);if(!Array.isArray(a))return null;const i=o.fetchIfRef(a[0]);if("string"!=typeof i)return null;const s=n(a.slice(1),t);return s&&s.length?{name:(0,r.stringToPDFString)(i),order:s}:null}const o=this.xref,c=new i.RefSet,l=10;return{name:"string"==typeof e.get("Name")?(0,r.stringToPDFString)(e.get("Name")):null,creator:"string"==typeof e.get("Creator")?(0,r.stringToPDFString)(e.get("Creator")):null,baseState:e.get("BaseState")instanceof i.Name?e.get("BaseState").name:null,on:a(e.get("ON")),off:a(e.get("OFF")),order:n(e.get("Order")),groups:null}}setActualNumPages(e=null){this._actualNumPages=e}get hasActualNumPages(){return null!==this._actualNumPages}get _pagesCount(){const e=this.toplevelPagesDict.get("Count");if(!Number.isInteger(e))throw new r.FormatError("Page count in top-level pages dictionary is not an integer.");return(0,r.shadow)(this,"_pagesCount",e)}get numPages(){return this.hasActualNumPages?this._actualNumPages:this._pagesCount}get destinations(){const e=this._readDests(),t=Object.create(null);if(e instanceof s.NameTree)for(const[a,n]of e.getAll()){const e=g(n);e&&(t[(0,r.stringToPDFString)(a)]=e)}else e instanceof i.Dict&&e.forEach((function(e,a){const n=g(a);n&&(t[e]=n)}));return(0,r.shadow)(this,"destinations",t)}getDestination(e){const t=this._readDests();if(t instanceof s.NameTree){const a=g(t.get(e));if(a)return a;const n=this.destinations[e];if(n)return(0,r.warn)(`Found "${e}" at an incorrect position in the NameTree.`),n}else if(t instanceof i.Dict){const a=g(t.get(e));if(a)return a}return null}_readDests(){const e=this._catDict.get("Names");return e?.has("Dests")?new s.NameTree(e.getRaw("Dests"),this.xref):this._catDict.has("Dests")?this._catDict.get("Dests"):void 0}get pageLabels(){let e=null;try{e=this._readPageLabels()}catch(e){if(e instanceof n.MissingDataException)throw e;(0,r.warn)("Unable to read page labels.")}return(0,r.shadow)(this,"pageLabels",e)}_readPageLabels(){const e=this._catDict.getRaw("PageLabels");if(!e)return null;const t=new Array(this.numPages);let a=null,o="";const c=new s.NumberTree(e,this.xref).getAll();let l="",h=1;for(let e=0,s=this.numPages;e<s;e++){const s=c.get(e);if(void 0!==s){if(!(s instanceof i.Dict))throw new r.FormatError("PageLabel is not a dictionary.");if(s.has("Type")&&!(0,i.isName)(s.get("Type"),"PageLabel"))throw new r.FormatError("Invalid type in PageLabel dictionary.");if(s.has("S")){const e=s.get("S");if(!(e instanceof i.Name))throw new r.FormatError("Invalid style in PageLabel dictionary.");a=e.name}else a=null;if(s.has("P")){const e=s.get("P");if("string"!=typeof e)throw new r.FormatError("Invalid prefix in PageLabel dictionary.");o=(0,r.stringToPDFString)(e)}else o="";if(s.has("St")){const e=s.get("St");if(!(Number.isInteger(e)&&e>=1))throw new r.FormatError("Invalid start in PageLabel dictionary.");h=e}else h=1}switch(a){case"D":l=h;break;case"R":case"r":l=(0,n.toRomanNumerals)(h,"r"===a);break;case"A":case"a":const e=26,t="a"===a?97:65,i=h-1;l=String.fromCharCode(t+i%e).repeat(Math.floor(i/e)+1);break;default:if(a)throw new r.FormatError(`Invalid style "${a}" in PageLabel dictionary.`);l=""}t[e]=o+l,h++}return t}get pageLayout(){const e=this._catDict.get("PageLayout");let t="";if(e instanceof i.Name)switch(e.name){case"SinglePage":case"OneColumn":case"TwoColumnLeft":case"TwoColumnRight":case"TwoPageLeft":case"TwoPageRight":t=e.name}return(0,r.shadow)(this,"pageLayout",t)}get pageMode(){const e=this._catDict.get("PageMode");let t="UseNone";if(e instanceof i.Name)switch(e.name){case"UseNone":case"UseOutlines":case"UseThumbs":case"FullScreen":case"UseOC":case"UseAttachments":t=e.name}return(0,r.shadow)(this,"pageMode",t)}get viewerPreferences(){const e=this._catDict.get("ViewerPreferences");if(!(e instanceof i.Dict))return(0,r.shadow)(this,"viewerPreferences",null);let t=null;for(const a of e.getKeys()){const n=e.get(a);let s;switch(a){case"HideToolbar":case"HideMenubar":case"HideWindowUI":case"FitWindow":case"CenterWindow":case"DisplayDocTitle":case"PickTrayByPDFSize":"boolean"==typeof n&&(s=n);break;case"NonFullScreenPageMode":if(n instanceof i.Name)switch(n.name){case"UseNone":case"UseOutlines":case"UseThumbs":case"UseOC":s=n.name;break;default:s="UseNone"}break;case"Direction":if(n instanceof i.Name)switch(n.name){case"L2R":case"R2L":s=n.name;break;default:s="L2R"}break;case"ViewArea":case"ViewClip":case"PrintArea":case"PrintClip":if(n instanceof i.Name)switch(n.name){case"MediaBox":case"CropBox":case"BleedBox":case"TrimBox":case"ArtBox":s=n.name;break;default:s="CropBox"}break;case"PrintScaling":if(n instanceof i.Name)switch(n.name){case"None":case"AppDefault":s=n.name;break;default:s="AppDefault"}break;case"Duplex":if(n instanceof i.Name)switch(n.name){case"Simplex":case"DuplexFlipShortEdge":case"DuplexFlipLongEdge":s=n.name;break;default:s="None"}break;case"PrintPageRange":if(Array.isArray(n)&&n.length%2==0){n.every(((e,t,a)=>Number.isInteger(e)&&e>0&&(0===t||e>=a[t-1])&&e<=this.numPages))&&(s=n)}break;case"NumCopies":Number.isInteger(n)&&n>0&&(s=n);break;default:(0,r.warn)(`Ignoring non-standard key in ViewerPreferences: ${a}.`);continue}void 0!==s?(t||(t=Object.create(null)),t[a]=s):(0,r.warn)(`Bad value, for key "${a}", in ViewerPreferences: ${n}.`)}return(0,r.shadow)(this,"viewerPreferences",t)}get openAction(){const e=this._catDict.get("OpenAction"),t=Object.create(null);if(e instanceof i.Dict){const a=new i.Dict(this.xref);a.set("A",e);const n={url:null,dest:null,action:null};p.parseDestDictionary({destDict:a,resultObj:n}),Array.isArray(n.dest)?t.dest=n.dest:n.action&&(t.action=n.action)}else Array.isArray(e)&&(t.dest=e);return(0,r.shadow)(this,"openAction",(0,r.objectSize)(t)>0?t:null)}get attachments(){const e=this._catDict.get("Names");let t=null;if(e instanceof i.Dict&&e.has("EmbeddedFiles")){const a=new s.NameTree(e.getRaw("EmbeddedFiles"),this.xref);for(const[e,n]of a.getAll()){const a=new h.FileSpec(n,this.xref);t||(t=Object.create(null)),t[(0,r.stringToPDFString)(e)]=a.serializable}}return(0,r.shadow)(this,"attachments",t)}get xfaImages(){const e=this._catDict.get("Names");let t=null;if(e instanceof i.Dict&&e.has("XFAImages")){const a=new s.NameTree(e.getRaw("XFAImages"),this.xref);for(const[e,n]of a.getAll())t||(t=new i.Dict(this.xref)),t.set((0,r.stringToPDFString)(e),n)}return(0,r.shadow)(this,"xfaImages",t)}_collectJavaScript(){const e=this._catDict.get("Names");let t=null;function a(e,a){if(!(a instanceof i.Dict))return;if(!(0,i.isName)(a.get("S"),"JavaScript"))return;let n=a.get("JS");if(n instanceof o.BaseStream)n=n.getString();else if("string"!=typeof n)return;n=(0,r.stringToPDFString)(n).replaceAll("\0",""),n&&(t||=new Map).set(e,n)}if(e instanceof i.Dict&&e.has("JavaScript")){const t=new s.NameTree(e.getRaw("JavaScript"),this.xref);for(const[e,n]of t.getAll())a((0,r.stringToPDFString)(e),n)}const n=this._catDict.get("OpenAction");return n&&a("OpenAction",n),t}get jsActions(){const e=this._collectJavaScript();let t=(0,n.collectActions)(this.xref,this._catDict,r.DocumentActionEventType);if(e){t||=Object.create(null);for(const[a,n]of e)a in t?t[a].push(n):t[a]=[n]}return(0,r.shadow)(this,"jsActions",t)}async fontFallback(e,t){const a=await Promise.all(this.fontCache);for(const n of a)if(n.loadedName===e)return void n.fallback(t)}async cleanup(e=!1){(0,c.clearGlobalCaches)(),this.globalImageCache.clear(e),this.pageKidsCountCache.clear(),this.pageIndexCache.clear(),this.nonBlendModesSet.clear();const t=await Promise.all(this.fontCache);for(const{dict:e}of t)delete e.cacheKey;this.fontCache.clear(),this.builtInCMapCache.clear(),this.standardFontDataCache.clear(),this.systemFontCache.clear()}async getPageDict(e){const t=[this.toplevelPagesDict],a=new i.RefSet,n=this._catDict.getRaw("Pages");n instanceof i.Ref&&a.put(n);const s=this.xref,o=this.pageKidsCountCache,c=this.pageIndexCache;let l=0;for(;t.length;){const n=t.pop();if(n instanceof i.Ref){const h=o.get(n);if(h>=0&&l+h<=e){l+=h;continue}if(a.has(n))throw new r.FormatError("Pages tree contains circular reference.");a.put(n);const u=await s.fetchAsync(n);if(u instanceof i.Dict){let t=u.getRaw("Type");if(t instanceof i.Ref&&(t=await s.fetchAsync(t)),(0,i.isName)(t,"Page")||!u.has("Kids")){if(o.has(n)||o.put(n,1),c.has(n)||c.put(n,l),l===e)return[u,n];l++;continue}}t.push(u);continue}if(!(n instanceof i.Dict))throw new r.FormatError("Page dictionary kid reference points to wrong type of object.");const{objId:h}=n;let u=n.getRaw("Count");if(u instanceof i.Ref&&(u=await s.fetchAsync(u)),Number.isInteger(u)&&u>=0&&(h&&!o.has(h)&&o.put(h,u),l+u<=e)){l+=u;continue}let d=n.getRaw("Kids");if(d instanceof i.Ref&&(d=await s.fetchAsync(d)),!Array.isArray(d)){let t=n.getRaw("Type");if(t instanceof i.Ref&&(t=await s.fetchAsync(t)),(0,i.isName)(t,"Page")||!n.has("Kids")){if(l===e)return[n,null];l++;continue}throw new r.FormatError("Page dictionary kids object is not an array.")}for(let e=d.length-1;e>=0;e--)t.push(d[e])}throw new Error(`Page index ${e} not found.`)}async getAllPageDicts(e=!1){const{ignoreErrors:t}=this.pdfManager.evaluatorOptions,a=[{currentNode:this.toplevelPagesDict,posInKids:0}],s=new i.RefSet,o=this._catDict.getRaw("Pages");o instanceof i.Ref&&s.put(o);const c=new Map,l=this.xref,h=this.pageIndexCache;let u=0;function d(a){if(a instanceof n.XRefEntryException&&!e)throw a;e&&t&&0===u&&((0,r.warn)(`getAllPageDicts - Skipping invalid first page: "${a}".`),a=i.Dict.empty),c.set(u++,[a,null])}for(;a.length>0;){const e=a.at(-1),{currentNode:t,posInKids:n}=e;let o=t.getRaw("Kids");if(o instanceof i.Ref)try{o=await l.fetchAsync(o)}catch(e){d(e);break}if(!Array.isArray(o)){d(new r.FormatError("Page dictionary kids object is not an array."));break}if(n>=o.length){a.pop();continue}const p=o[n];let m;if(p instanceof i.Ref){if(s.has(p)){d(new r.FormatError("Pages tree contains circular reference."));break}s.put(p);try{m=await l.fetchAsync(p)}catch(e){d(e);break}}else m=p;if(!(m instanceof i.Dict)){d(new r.FormatError("Page dictionary kid reference points to wrong type of object."));break}let b=m.getRaw("Type");if(b instanceof i.Ref)try{b=await l.fetchAsync(b)}catch(e){d(e);break}(0,i.isName)(b,"Page")||!m.has("Kids")?(f=m,(g=p instanceof i.Ref?p:null)&&!h.has(g)&&h.put(g,u),c.set(u++,[f,g])):a.push({currentNode:m,posInKids:0}),e.posInKids++}var f,g;return c}getPageIndex(e){const t=this.pageIndexCache.get(e);if(void 0!==t)return Promise.resolve(t);const a=this.xref;let n=0;const s=t=>function(t){let n,s=0;return a.fetchAsync(t).then((function(a){if((0,i.isRefsEqual)(t,e)&&!(0,i.isDict)(a,"Page")&&!(a instanceof i.Dict&&!a.has("Type")&&a.has("Contents")))throw new r.FormatError("The reference does not point to a /Page dictionary.");if(!a)return null;if(!(a instanceof i.Dict))throw new r.FormatError("Node must be a dictionary.");return n=a.getRaw("Parent"),a.getAsync("Parent")})).then((function(e){if(!e)return null;if(!(e instanceof i.Dict))throw new r.FormatError("Parent must be a dictionary.");return e.getAsync("Kids")})).then((function(e){if(!e)return null;const o=[];let c=!1;for(const n of e){if(!(n instanceof i.Ref))throw new r.FormatError("Kid must be a reference.");if((0,i.isRefsEqual)(n,t)){c=!0;break}o.push(a.fetchAsync(n).then((function(e){if(!(e instanceof i.Dict))throw new r.FormatError("Kid node must be a dictionary.");e.has("Count")?s+=e.get("Count"):s++})))}if(!c)throw new r.FormatError("Kid reference not found in parent's kids.");return Promise.all(o).then((function(){return[s,n]}))}))}(t).then((t=>{if(!t)return this.pageIndexCache.put(e,n),n;const[a,r]=t;return n+=a,s(r)}));return s(e)}get baseUrl(){const e=this._catDict.get("URI");if(e instanceof i.Dict){const t=e.get("Base");if("string"==typeof t){const e=(0,r.createValidAbsoluteUrl)(t,null,{tryConvertEncoding:!0});if(e)return(0,r.shadow)(this,"baseUrl",e.href)}}return(0,r.shadow)(this,"baseUrl",this.pdfManager.docBaseUrl)}static parseDestDictionary({destDict:e,resultObj:t,docBaseUrl:a=null,docAttachments:s=null}){if(!(e instanceof i.Dict))return void(0,r.warn)("parseDestDictionary: `destDict` must be a dictionary.");let c,l,h=e.get("A");if(h instanceof i.Dict||(e.has("Dest")?h=e.get("Dest"):(h=e.get("AA"),h instanceof i.Dict&&(h.has("D")?h=h.get("D"):h.has("U")&&(h=h.get("U"))))),h instanceof i.Dict){const e=h.get("S");if(!(e instanceof i.Name))return void(0,r.warn)("parseDestDictionary: Invalid type in Action dictionary.");const a=e.name;switch(a){case"ResetForm":const e=h.get("Flags"),u=0==(1&("number"==typeof e?e:0)),d=[],f=[];for(const e of h.get("Fields")||[])e instanceof i.Ref?f.push(e.toString()):"string"==typeof e&&d.push((0,r.stringToPDFString)(e));t.resetForm={fields:d,refs:f,include:u};break;case"URI":c=h.get("URI"),c instanceof i.Name&&(c="/"+c.name);break;case"GoTo":l=h.get("D");break;case"Launch":case"GoToR":const g=h.get("F");g instanceof i.Dict?c=g.get("F")||null:"string"==typeof g&&(c=g);let p=h.get("D");if(p&&(p instanceof i.Name&&(p=p.name),"string"==typeof c)){const e=c.split("#")[0];"string"==typeof p?c=e+"#"+p:Array.isArray(p)&&(c=e+"#"+JSON.stringify(p))}const m=h.get("NewWindow");"boolean"==typeof m&&(t.newWindow=m);break;case"GoToE":const b=h.get("T");let y;if(s&&b instanceof i.Dict){const e=b.get("R"),t=b.get("N");(0,i.isName)(e,"C")&&"string"==typeof t&&(y=s[(0,r.stringToPDFString)(t)])}y?t.attachment=y:(0,r.warn)('parseDestDictionary - unimplemented "GoToE" action.');break;case"Named":const w=h.get("N");w instanceof i.Name&&(t.action=w.name);break;case"SetOCGState":const x=h.get("State"),S=h.get("PreserveRB");if(!Array.isArray(x)||0===x.length)break;const A=[];for(const e of x)if(e instanceof i.Name)switch(e.name){case"ON":case"OFF":case"Toggle":A.push(e.name)}else e instanceof i.Ref&&A.push(e.toString());if(A.length!==x.length)break;t.setOCGState={state:A,preserveRB:"boolean"!=typeof S||S};break;case"JavaScript":const k=h.get("JS");let C;k instanceof o.BaseStream?C=k.getString():"string"==typeof k&&(C=k);const v=C&&(0,n.recoverJsURL)((0,r.stringToPDFString)(C));if(v){c=v.url,t.newWindow=v.newWindow;break}default:if("JavaScript"===a||"SubmitForm"===a)break;(0,r.warn)(`parseDestDictionary - unsupported action: "${a}".`)}}else e.has("Dest")&&(l=e.get("Dest"));if("string"==typeof c){const e=(0,r.createValidAbsoluteUrl)(c,a,{addDefaultProtocol:!0,tryConvertEncoding:!0});e&&(t.url=e.href),t.unsafeUrl=c}l&&(l instanceof i.Name&&(l=l.name),"string"==typeof l?t.dest=(0,r.stringToPDFString)(l):Array.isArray(l)&&(t.dest=l))}}t.Catalog=p},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.NumberTree=t.NameTree=void 0;var n=a(4),r=a(2);class i{constructor(e,t,a){this.constructor===i&&(0,r.unreachable)("Cannot initialize NameOrNumberTree."),this.root=e,this.xref=t,this._type=a}getAll(){const e=new Map;if(!this.root)return e;const t=this.xref,a=new n.RefSet;a.put(this.root);const i=[this.root];for(;i.length>0;){const s=t.fetchIfRef(i.shift());if(!(s instanceof n.Dict))continue;if(s.has("Kids")){const e=s.get("Kids");if(!Array.isArray(e))continue;for(const t of e){if(a.has(t))throw new r.FormatError(`Duplicate entry in "${this._type}" tree.`);i.push(t),a.put(t)}continue}const o=s.get(this._type);if(Array.isArray(o))for(let a=0,n=o.length;a<n;a+=2)e.set(t.fetchIfRef(o[a]),t.fetchIfRef(o[a+1]))}return e}get(e){if(!this.root)return null;const t=this.xref;let a=t.fetchIfRef(this.root),n=0;for(;a.has("Kids");){if(++n>10)return(0,r.warn)(`Search depth limit reached for "${this._type}" tree.`),null;const i=a.get("Kids");if(!Array.isArray(i))return null;let s=0,o=i.length-1;for(;s<=o;){const n=s+o>>1,r=t.fetchIfRef(i[n]),c=r.get("Limits");if(e<t.fetchIfRef(c[0]))o=n-1;else{if(!(e>t.fetchIfRef(c[1]))){a=r;break}s=n+1}}if(s>o)return null}const i=a.get(this._type);if(Array.isArray(i)){let a=0,n=i.length-2;for(;a<=n;){const r=a+n>>1,s=r+(1&r),o=t.fetchIfRef(i[s]);if(e<o)n=s-2;else{if(!(e>o))return t.fetchIfRef(i[s+1]);a=s+2}}}return null}}t.NameTree=class extends i{constructor(e,t){super(e,t,"Names")}};t.NumberTree=class extends i{constructor(e,t){super(e,t,"Nums")}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.clearGlobalCaches=function(){(0,n.clearPatternCaches)(),(0,r.clearPrimitiveCaches)(),(0,i.clearUnicodeCaches)()};var n=a(50),r=a(4),i=a(40)},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.FileSpec=void 0;var n=a(2),r=a(5),i=a(4);function s(e){return e.has("UF")?e.get("UF"):e.has("F")?e.get("F"):e.has("Unix")?e.get("Unix"):e.has("Mac")?e.get("Mac"):e.has("DOS")?e.get("DOS"):null}t.FileSpec=class{constructor(e,t){e instanceof i.Dict&&(this.xref=t,this.root=e,e.has("FS")&&(this.fs=e.get("FS")),this.description=e.has("Desc")?(0,n.stringToPDFString)(e.get("Desc")):"",e.has("RF")&&(0,n.warn)("Related file specifications are not supported"),this.contentAvailable=!0,e.has("EF")||(this.contentAvailable=!1,(0,n.warn)("Non-embedded file specifications are not supported")))}get filename(){if(!this._filename&&this.root){const e=s(this.root)||"unnamed";this._filename=(0,n.stringToPDFString)(e).replaceAll("\\\\","\\").replaceAll("\\/","/").replaceAll("\\","/")}return this._filename}get content(){if(!this.contentAvailable)return null;!this.contentRef&&this.root&&(this.contentRef=s(this.root.get("EF")));let e=null;if(this.contentRef){const t=this.xref.fetchIfRef(this.contentRef);t instanceof r.BaseStream?e=t.getBytes():(0,n.warn)("Embedded file specification points to non-existing/invalid content")}else(0,n.warn)("Embedded file specification does not have a content");return e}get serializable(){return{filename:this.filename,content:this.content}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.MetadataParser=void 0;var n=a(71);t.MetadataParser=class{constructor(e){e=this._repair(e);const t=new n.SimpleXMLParser({lowerCaseName:!0}).parseFromString(e);this._metadataMap=new Map,this._data=e,t&&this._parse(t)}_repair(e){return e.replace(/^[^<]+/,"").replaceAll(/>\\376\\377([^<]+)/g,(function(e,t){const a=t.replaceAll(/\\([0-3])([0-7])([0-7])/g,(function(e,t,a,n){return String.fromCharCode(64*t+8*a+1*n)})).replaceAll(/&(amp|apos|gt|lt|quot);/g,(function(e,t){switch(t){case"amp":return"&";case"apos":return"'";case"gt":return">";case"lt":return"<";case"quot":return'"'}throw new Error(`_repair: ${t} isn't defined.`)})),n=[">"];for(let e=0,t=a.length;e<t;e+=2){const t=256*a.charCodeAt(e)+a.charCodeAt(e+1);t>=32&&t<127&&60!==t&&62!==t&&38!==t?n.push(String.fromCharCode(t)):n.push("&#x"+(65536+t).toString(16).substring(1)+";")}return n.join("")}))}_getSequence(e){const t=e.nodeName;return"rdf:bag"!==t&&"rdf:seq"!==t&&"rdf:alt"!==t?null:e.childNodes.filter((e=>"rdf:li"===e.nodeName))}_parseArray(e){if(!e.hasChildNodes())return;const[t]=e.childNodes,a=this._getSequence(t)||[];this._metadataMap.set(e.nodeName,a.map((e=>e.textContent.trim())))}_parse(e){let t=e.documentElement;if("rdf:rdf"!==t.nodeName)for(t=t.firstChild;t&&"rdf:rdf"!==t.nodeName;)t=t.nextSibling;if(t&&"rdf:rdf"===t.nodeName&&t.hasChildNodes())for(const e of t.childNodes)if("rdf:description"===e.nodeName)for(const t of e.childNodes){const e=t.nodeName;switch(e){case"#text":continue;case"dc:creator":case"dc:subject":this._parseArray(t);continue}this._metadataMap.set(e,t.textContent.trim())}}get serializable(){return{parsedData:this._metadataMap,rawData:this._data}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XMLParserErrorCode=t.XMLParserBase=t.SimpleXMLParser=t.SimpleDOMNode=void 0;var n=a(3);const r={NoError:0,EndOfDocument:-1,UnterminatedCdat:-2,UnterminatedXmlDeclaration:-3,UnterminatedDoctypeDeclaration:-4,UnterminatedComment:-5,MalformedElement:-6,OutOfMemory:-7,UnterminatedAttributeValue:-8,UnterminatedElement:-9,ElementNeverBegun:-10};function i(e,t){const a=e[t];return" "===a||"\n"===a||"\r"===a||"\t"===a}t.XMLParserErrorCode=r;class s{_resolveEntities(e){return e.replaceAll(/&([^;]+);/g,((e,t)=>{if("#x"===t.substring(0,2))return String.fromCodePoint(parseInt(t.substring(2),16));if("#"===t.substring(0,1))return String.fromCodePoint(parseInt(t.substring(1),10));switch(t){case"lt":return"<";case"gt":return">";case"amp":return"&";case"quot":return'"';case"apos":return"'"}return this.onResolveEntity(t)}))}_parseContent(e,t){const a=[];let n=t;function r(){for(;n<e.length&&i(e,n);)++n}for(;n<e.length&&!i(e,n)&&">"!==e[n]&&"/"!==e[n];)++n;const s=e.substring(t,n);for(r();n<e.length&&">"!==e[n]&&"/"!==e[n]&&"?"!==e[n];){r();let t="",s="";for(;n<e.length&&!i(e,n)&&"="!==e[n];)t+=e[n],++n;if(r(),"="!==e[n])return null;++n,r();const o=e[n];if('"'!==o&&"'"!==o)return null;const c=e.indexOf(o,++n);if(c<0)return null;s=e.substring(n,c),a.push({name:t,value:this._resolveEntities(s)}),n=c+1,r()}return{name:s,attributes:a,parsed:n-t}}_parseProcessingInstruction(e,t){let a=t;for(;a<e.length&&!i(e,a)&&">"!==e[a]&&"?"!==e[a]&&"/"!==e[a];)++a;const n=e.substring(t,a);!function(){for(;a<e.length&&i(e,a);)++a}();const r=a;for(;a<e.length&&("?"!==e[a]||">"!==e[a+1]);)++a;return{name:n,value:e.substring(r,a),parsed:a-t}}parseXml(e){let t=0;for(;t<e.length;){let a=t;if("<"===e[t]){++a;let t;switch(e[a]){case"/":if(++a,t=e.indexOf(">",a),t<0)return void this.onError(r.UnterminatedElement);this.onEndElement(e.substring(a,t)),a=t+1;break;case"?":++a;const n=this._parseProcessingInstruction(e,a);if("?>"!==e.substring(a+n.parsed,a+n.parsed+2))return void this.onError(r.UnterminatedXmlDeclaration);this.onPi(n.name,n.value),a+=n.parsed+2;break;case"!":if("--"===e.substring(a+1,a+3)){if(t=e.indexOf("--\x3e",a+3),t<0)return void this.onError(r.UnterminatedComment);this.onComment(e.substring(a+3,t)),a=t+3}else if("[CDATA["===e.substring(a+1,a+8)){if(t=e.indexOf("]]>",a+8),t<0)return void this.onError(r.UnterminatedCdat);this.onCdata(e.substring(a+8,t)),a=t+3}else{if("DOCTYPE"!==e.substring(a+1,a+8))return void this.onError(r.MalformedElement);{const n=e.indexOf("[",a+8);let i=!1;if(t=e.indexOf(">",a+8),t<0)return void this.onError(r.UnterminatedDoctypeDeclaration);if(n>0&&t>n){if(t=e.indexOf("]>",a+8),t<0)return void this.onError(r.UnterminatedDoctypeDeclaration);i=!0}const s=e.substring(a+8,t+(i?1:0));this.onDoctype(s),a=t+(i?2:1)}}break;default:const i=this._parseContent(e,a);if(null===i)return void this.onError(r.MalformedElement);let s=!1;if("/>"===e.substring(a+i.parsed,a+i.parsed+2))s=!0;else if(">"!==e.substring(a+i.parsed,a+i.parsed+1))return void this.onError(r.UnterminatedElement);this.onBeginElement(i.name,i.attributes,s),a+=i.parsed+(s?2:1)}}else{for(;a<e.length&&"<"!==e[a];)a++;const n=e.substring(t,a);this.onText(this._resolveEntities(n))}t=a}}onResolveEntity(e){return`&${e};`}onPi(e,t){}onComment(e){}onCdata(e){}onDoctype(e){}onText(e){}onBeginElement(e,t,a){}onEndElement(e){}onError(e){}}t.XMLParserBase=s;class o{constructor(e,t){this.nodeName=e,this.nodeValue=t,Object.defineProperty(this,"parentNode",{value:null,writable:!0})}get firstChild(){return this.childNodes?.[0]}get nextSibling(){const e=this.parentNode.childNodes;if(!e)return;const t=e.indexOf(this);return-1!==t?e[t+1]:void 0}get textContent(){return this.childNodes?this.childNodes.map((function(e){return e.textContent})).join(""):this.nodeValue||""}get children(){return this.childNodes||[]}hasChildNodes(){return this.childNodes?.length>0}searchNode(e,t){if(t>=e.length)return this;const a=e[t];if(a.name.startsWith("#")&&t<e.length-1)return this.searchNode(e,t+1);const n=[];let r=this;for(;;){if(a.name===r.nodeName){if(0!==a.pos){if(0===n.length)return null;{const[i]=n.pop();let s=0;for(const n of i.childNodes)if(a.name===n.nodeName){if(s===a.pos)return n.searchNode(e,t+1);s++}return r.searchNode(e,t+1)}}{const a=r.searchNode(e,t+1);if(null!==a)return a}}if(r.childNodes?.length>0)n.push([r,0]),r=r.childNodes[0];else{if(0===n.length)return null;for(;0!==n.length;){const[e,t]=n.pop(),a=t+1;if(a<e.childNodes.length){n.push([e,a]),r=e.childNodes[a];break}}if(0===n.length)return null}}}dump(e){if("#text"!==this.nodeName){if(e.push(`<${this.nodeName}`),this.attributes)for(const t of this.attributes)e.push(` ${t.name}="${(0,n.encodeToXmlString)(t.value)}"`);if(this.hasChildNodes()){e.push(">");for(const t of this.childNodes)t.dump(e);e.push(`</${this.nodeName}>`)}else this.nodeValue?e.push(`>${(0,n.encodeToXmlString)(this.nodeValue)}</${this.nodeName}>`):e.push("/>")}else e.push((0,n.encodeToXmlString)(this.nodeValue))}}t.SimpleDOMNode=o;t.SimpleXMLParser=class extends s{constructor({hasAttributes:e=!1,lowerCaseName:t=!1}){super(),this._currentFragment=null,this._stack=null,this._errorCode=r.NoError,this._hasAttributes=e,this._lowerCaseName=t}parseFromString(e){if(this._currentFragment=[],this._stack=[],this._errorCode=r.NoError,this.parseXml(e),this._errorCode!==r.NoError)return;const[t]=this._currentFragment;return t?{documentElement:t}:void 0}onText(e){if(function(e){for(let t=0,a=e.length;t<a;t++)if(!i(e,t))return!1;return!0}(e))return;const t=new o("#text",e);this._currentFragment.push(t)}onCdata(e){const t=new o("#text",e);this._currentFragment.push(t)}onBeginElement(e,t,a){this._lowerCaseName&&(e=e.toLowerCase());const n=new o(e);n.childNodes=[],this._hasAttributes&&(n.attributes=t),this._currentFragment.push(n),a||(this._stack.push(this._currentFragment),this._currentFragment=n.childNodes)}onEndElement(e){this._currentFragment=this._stack.pop()||[];const t=this._currentFragment.at(-1);if(!t)return null;for(const e of t.childNodes)e.parentNode=t;return t}onError(e){this._errorCode=e}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.StructTreeRoot=t.StructTreePage=void 0;var n=a(2),r=a(4),i=a(67),s=a(73);const o=1,c=2,l=3,h=4,u=5;class d{constructor(e,t){this.dict=e,this.ref=t instanceof r.Ref?t:null,this.roleMap=new Map,this.structParentIds=null}init(){this.readRoleMap()}#k(e,t,a){if(!(e instanceof r.Ref)||t<0)return;this.structParentIds||=new r.RefSetCache;let n=this.structParentIds.get(e);n||(n=[],this.structParentIds.put(e,n)),n.push([t,a])}addAnnotationIdToPage(e,t){this.#k(e,t,h)}readRoleMap(){const e=this.dict.get("RoleMap");e instanceof r.Dict&&e.forEach(((e,t)=>{t instanceof r.Name&&this.roleMap.set(e,t.name)}))}static async canCreateStructureTree({catalogRef:e,pdfManager:t,newAnnotationsByPage:a}){if(!(e instanceof r.Ref))return(0,n.warn)("Cannot save the struct tree: no catalog reference."),!1;let i=0,s=!0;for(const[e,o]of a){const{ref:a}=await t.getPage(e);if(!(a instanceof r.Ref)){(0,n.warn)(`Cannot save the struct tree: page ${e} has no ref.`),s=!0;break}for(const e of o)e.accessibilityData?.type&&(e.parentTreeId=i++,s=!1)}if(s){for(const e of a.values())for(const t of e)delete t.parentTreeId;return!1}return!0}static async createStructureTree({newAnnotationsByPage:e,xref:t,catalogRef:a,pdfManager:n,newRefs:i}){const o=n.catalog.cloneDict(),c=t.getNewTemporaryRef();o.set("StructTreeRoot",c);const l=[];await(0,s.writeObject)(a,o,l,t),i.push({ref:a,data:l.join("")});const h=new r.Dict(t);h.set("Type",r.Name.get("StructTreeRoot"));const u=t.getNewTemporaryRef();h.set("ParentTree",u);const d=[];h.set("K",d);const f=new r.Dict(t),g=[];f.set("Nums",g);const p=await this.#C({newAnnotationsByPage:e,structTreeRootRef:c,kids:d,nums:g,xref:t,pdfManager:n,newRefs:i,buffer:l});h.set("ParentTreeNextKey",p),l.length=0,await(0,s.writeObject)(u,f,l,t),i.push({ref:u,data:l.join("")}),l.length=0,await(0,s.writeObject)(c,h,l,t),i.push({ref:c,data:l.join("")})}async canUpdateStructTree({pdfManager:e,newAnnotationsByPage:t}){if(!this.ref)return(0,n.warn)("Cannot update the struct tree: no root reference."),!1;let a=this.dict.get("ParentTreeNextKey");if(!Number.isInteger(a)||a<0)return(0,n.warn)("Cannot update the struct tree: invalid next key."),!1;const i=this.dict.get("ParentTree");if(!(i instanceof r.Dict))return(0,n.warn)("Cannot update the struct tree: ParentTree isn't a dict."),!1;const s=i.get("Nums");if(!Array.isArray(s))return(0,n.warn)("Cannot update the struct tree: nums isn't an array."),!1;const{numPages:o}=e.catalog;for(const a of t.keys()){const{pageDict:t,ref:i}=await e.getPage(a);if(!(i instanceof r.Ref))return(0,n.warn)(`Cannot save the struct tree: page ${a} has no ref.`),!1;const s=t.get("StructParents");if(!Number.isInteger(s)||s<0||s>=o)return(0,n.warn)(`Cannot save the struct tree: page ${a} has no id.`),!1}let c=!0;for(const[n,r]of t){const{pageDict:t}=await e.getPage(n);d.#v({elements:r,xref:this.dict.xref,pageDict:t,parentTree:i});for(const e of r)e.accessibilityData?.type&&(e.parentTreeId=a++,c=!1)}if(c){for(const e of t.values())for(const t of e)delete t.parentTreeId,delete t.structTreeParent;return!1}return!0}async updateStructureTree({newAnnotationsByPage:e,pdfManager:t,newRefs:a}){const n=this.dict.xref,i=this.dict.clone(),o=this.ref;let c,l=i.getRaw("ParentTree");l instanceof r.Ref?c=n.fetch(l):(c=l,l=n.getNewTemporaryRef(),i.set("ParentTree",l)),c=c.clone();let h=c.getRaw("Nums"),u=null;h instanceof r.Ref&&(u=h,h=n.fetch(u)),h=h.slice(),u||c.set("Nums",h);let f=i.getRaw("K"),g=null;f instanceof r.Ref?(g=f,f=n.fetch(g)):(g=n.getNewTemporaryRef(),i.set("K",g)),f=Array.isArray(f)?f.slice():[f];const p=[],m=await d.#C({newAnnotationsByPage:e,structTreeRootRef:o,kids:f,nums:h,xref:n,pdfManager:t,newRefs:a,buffer:p});i.set("ParentTreeNextKey",m),p.length=0,await(0,s.writeObject)(g,f,p,n),a.push({ref:g,data:p.join("")}),u&&(p.length=0,await(0,s.writeObject)(u,h,p,n),a.push({ref:u,data:p.join("")})),p.length=0,await(0,s.writeObject)(l,c,p,n),a.push({ref:l,data:p.join("")}),p.length=0,await(0,s.writeObject)(o,i,p,n),a.push({ref:o,data:p.join("")})}static async#C({newAnnotationsByPage:e,structTreeRootRef:t,kids:a,nums:n,xref:i,pdfManager:o,newRefs:c,buffer:l}){const h=r.Name.get("OBJR");let u=-1/0;for(const[d,f]of e){const{ref:e}=await o.getPage(d);for(const{accessibilityData:{type:o,title:d,lang:g,alt:p,expanded:m,actualText:b},ref:y,parentTreeId:w,structTreeParent:x}of f){u=Math.max(u,w);const f=i.getNewTemporaryRef(),S=new r.Dict(i);S.set("S",r.Name.get(o)),d&&S.set("T",d),g&&S.set("Lang",g),p&&S.set("Alt",p),m&&S.set("E",m),b&&S.set("ActualText",b),x?await this.#F({structTreeParent:x,tagDict:S,newTagRef:f,fallbackRef:t,xref:i,newRefs:c,buffer:l}):S.set("P",t);const A=new r.Dict(i);S.set("K",A),A.set("Type",h),A.set("Pg",e),A.set("Obj",y),l.length=0,await(0,s.writeObject)(f,S,l,i),c.push({ref:f,data:l.join("")}),n.push(w,f),a.push(f)}}return u+1}static#v({elements:e,xref:t,pageDict:a,parentTree:n}){const s=new Map;for(const t of e)if(t.structTreeParentId){const e=parseInt(t.structTreeParentId.split("_mc")[1],10);s.set(e,t)}const o=a.get("StructParents"),c=new i.NumberTree(n,t).get(o);if(!Array.isArray(c))return;const l=(e,a,n)=>{const i=s.get(e);if(i){const e=a.getRaw("P"),s=t.fetchIfRef(e);return e instanceof r.Ref&&s instanceof r.Dict&&(i.structTreeParent={ref:n,dict:a}),!0}return!1};for(const e of c){if(!(e instanceof r.Ref))continue;const a=t.fetch(e),n=a.get("K");if(Number.isInteger(n))l(n,a,e);else if(Array.isArray(n))for(let r of n)if(r=t.fetchIfRef(r),Number.isInteger(r)&&l(r,a,e))break}}static async#F({structTreeParent:{ref:e,dict:t},tagDict:a,newTagRef:i,fallbackRef:o,xref:c,newRefs:l,buffer:h}){const u=t.getRaw("P");let d=c.fetchIfRef(u);a.set("P",u);let f,g=!1,p=d.getRaw("K");if(p instanceof r.Ref?f=c.fetch(p):(f=p,p=c.getNewTemporaryRef(),d=d.clone(),d.set("K",p),g=!0),Array.isArray(f)){const t=f.indexOf(e);if(!(t>=0))return(0,n.warn)("Cannot update the struct tree: parent kid not found."),void a.set("P",o);f=f.slice(),f.splice(t+1,0,i)}else f instanceof r.Dict&&(f=[p,i],p=c.getNewTemporaryRef(),d.set("K",p),g=!0);h.length=0,await(0,s.writeObject)(p,f,h,c),l.push({ref:p,data:h.join("")}),g&&(h.length=0,await(0,s.writeObject)(u,d,h,c),l.push({ref:u,data:h.join("")}))}}t.StructTreeRoot=d;class f{constructor(e,t){this.tree=e,this.dict=t,this.kids=[],this.parseKids()}get role(){const e=this.dict.get("S"),t=e instanceof r.Name?e.name:"",{root:a}=this.tree;return a.roleMap.has(t)?a.roleMap.get(t):t}parseKids(){let e=null;const t=this.dict.getRaw("Pg");t instanceof r.Ref&&(e=t.toString());const a=this.dict.get("K");if(Array.isArray(a))for(const t of a){const a=this.parseKid(e,t);a&&this.kids.push(a)}else{const t=this.parseKid(e,a);t&&this.kids.push(t)}}parseKid(e,t){if(Number.isInteger(t))return this.tree.pageDict.objId!==e?null:new g({type:o,mcid:t,pageObjId:e});let a=null;if(t instanceof r.Ref?a=this.dict.xref.fetch(t):t instanceof r.Dict&&(a=t),!a)return null;const n=a.getRaw("Pg");n instanceof r.Ref&&(e=n.toString());const i=a.get("Type")instanceof r.Name?a.get("Type").name:null;if("MCR"===i){if(this.tree.pageDict.objId!==e)return null;const t=a.getRaw("Stm");return new g({type:c,refObjId:t instanceof r.Ref?t.toString():null,pageObjId:e,mcid:a.get("MCID")})}if("OBJR"===i){if(this.tree.pageDict.objId!==e)return null;const t=a.getRaw("Obj");return new g({type:l,refObjId:t instanceof r.Ref?t.toString():null,pageObjId:e})}return new g({type:u,dict:a})}}class g{constructor({type:e,dict:t=null,mcid:a=null,pageObjId:n=null,refObjId:r=null}){this.type=e,this.dict=t,this.mcid=a,this.pageObjId=n,this.refObjId=r,this.parentNode=null}}t.StructTreePage=class{constructor(e,t){this.root=e,this.rootDict=e?e.dict:null,this.pageDict=t,this.nodes=[]}parse(e){if(!this.root||!this.rootDict)return;const t=this.rootDict.get("ParentTree");if(!t)return;const a=this.pageDict.get("StructParents"),n=e instanceof r.Ref&&this.root.structParentIds?.get(e);if(!Number.isInteger(a)&&!n)return;const s=new Map,o=new i.NumberTree(t,this.rootDict.xref);if(Number.isInteger(a)){const e=o.get(a);if(Array.isArray(e))for(const t of e)t instanceof r.Ref&&this.addNode(this.rootDict.xref.fetch(t),s)}if(n)for(const[e,t]of n){const a=o.get(e);if(a){const e=this.addNode(this.rootDict.xref.fetchIfRef(a),s);1===e?.kids?.length&&e.kids[0].type===l&&(e.kids[0].type=t)}}}addNode(e,t,a=0){if(a>40)return(0,n.warn)("StructTree MAX_DEPTH reached."),null;if(t.has(e))return t.get(e);const i=new f(this,e);t.set(e,i);const s=e.get("P");if(!s||(0,r.isName)(s.get("Type"),"StructTreeRoot"))return this.addTopLevelNode(e,i)||t.delete(e),i;const o=this.addNode(s,t,a+1);if(!o)return i;let c=!1;for(const t of o.kids)t.type===u&&t.dict===e&&(t.parentNode=i,c=!0);return c||t.delete(e),i}addTopLevelNode(e,t){const a=this.rootDict.get("K");if(!a)return!1;if(a instanceof r.Dict)return a.objId===e.objId&&(this.nodes[0]=t,!0);if(!Array.isArray(a))return!0;let n=!1;for(let r=0;r<a.length;r++){const i=a[r];i?.toString()===e.objId&&(this.nodes[r]=t,n=!0)}return n}get serializable(){function e(t,a,r=0){if(r>40)return void(0,n.warn)("StructTree too deep to be fully serialized.");const i=Object.create(null);i.role=t.role,i.children=[],a.children.push(i);const s=t.dict.get("Alt");"string"==typeof s&&(i.alt=(0,n.stringToPDFString)(s));const d=t.dict.get("Lang");"string"==typeof d&&(i.lang=(0,n.stringToPDFString)(d));for(const a of t.kids){const t=a.type===u?a.parentNode:null;t?e(t,i,r+1):a.type===o||a.type===c?i.children.push({type:"content",id:`p${a.pageObjId}_mc${a.mcid}`}):a.type===l?i.children.push({type:"object",id:a.refObjId}):a.type===h&&i.children.push({type:"annotation",id:`${n.AnnotationPrefix}${a.refObjId}`})}}const t=Object.create(null);t.children=[],t.role="Root";for(const a of this.nodes)a&&e(a,t);return t}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.incrementalUpdate=async function({originalData:e,xrefInfo:t,newRefs:a,xref:o=null,hasXfa:u=!1,xfaDatasetsRef:d=null,hasXfaDatasetsEntry:f=!1,needAppearances:m,acroFormRef:b=null,acroForm:y=null,xfaData:w=null}){await async function({xref:e,acroForm:t,acroFormRef:a,hasXfa:r,hasXfaDatasetsEntry:i,xfaDatasetsRef:s,needAppearances:o,newRefs:c}){!r||i||s||(0,n.warn)("XFA - Cannot save it");if(!o&&(!r||!s||i))return;const h=t.clone();if(r&&!i){const e=t.get("XFA").slice();e.splice(2,0,"datasets"),e.splice(3,0,s),h.set("XFA",e)}o&&h.set("NeedAppearances",!0);const u=[];await l(a,h,u,e),c.push({ref:a,data:u.join("")})}({xref:o,acroForm:y,acroFormRef:b,hasXfa:u,hasXfaDatasetsEntry:f,xfaDatasetsRef:d,needAppearances:m,newRefs:a}),u&&function({xfaData:e,xfaDatasetsRef:t,newRefs:a,xref:r}){if(null===e){e=function(e,t){const a=new s.SimpleXMLParser({hasAttributes:!0}).parseFromString(e);for(const{xfa:e}of t){if(!e)continue;const{path:t,value:r}=e;if(!t)continue;const o=(0,i.parseXFAPath)(t);let c=a.documentElement.searchNode(o,0);!c&&o.length>1&&(c=a.documentElement.searchNode([o.at(-1)],0)),c?c.childNodes=Array.isArray(r)?r.map((e=>new s.SimpleDOMNode("value",e))):[new s.SimpleDOMNode("#text",r)]:(0,n.warn)(`Node not found for path: ${t}`)}const r=[];return a.documentElement.dump(r),r.join("")}(r.fetchIfRef(t).getString(),a)}const o=r.encrypt;if(o){e=o.createCipherTransform(t.num,t.gen).encryptString(e)}const c=`${t.num} ${t.gen} obj\n<< /Type /EmbeddedFile /Length ${e.length}>>\nstream\n`+e+"\nendstream\nendobj\n";a.push({ref:t,data:c})}({xfaData:w,xfaDatasetsRef:d,newRefs:a,xref:o});const x=new r.Dict(null),S=t.newRef;let A,k;const C=e.at(-1);10===C||13===C?(A=[],k=e.length):(A=["\n"],k=e.length+1);x.set("Size",S.num+1),x.set("Prev",t.startXRef),x.set("Type",r.Name.get("XRef")),null!==t.rootRef&&x.set("Root",t.rootRef);null!==t.infoRef&&x.set("Info",t.infoRef);null!==t.encryptRef&&x.set("Encrypt",t.encryptRef);a.push({ref:S,data:""}),a=a.sort(((e,t)=>e.ref.num-t.ref.num));const v=[[0,1,65535]],F=[0,1];let O=0;for(const{ref:e,data:t}of a)O=Math.max(O,k),v.push([1,k,Math.min(e.gen,65535)]),k+=t.length,F.push(e.num,1),A.push(t);if(x.set("Index",F),Array.isArray(t.fileIds)&&t.fileIds.length>0){const e=function(e,t){const a=Math.floor(Date.now()/1e3),r=t.filename||"",i=[a.toString(),r,e.toString()];let s=i.reduce(((e,t)=>e+t.length),0);for(const e of Object.values(t.info))i.push(e),s+=e.length;const o=new Uint8Array(s);let l=0;for(const e of i)p(e,l,o),l+=e.length;return(0,n.bytesToString)((0,c.calculateMD5)(o))}(k,t);x.set("ID",[t.fileIds[0],e])}const I=[1,Math.ceil(Math.log2(O)/8),2],T=(I[0]+I[1]+I[2])*v.length;x.set("W",I),x.set("Length",T),A.push(`${S.num} ${S.gen} obj\n`),await h(x,A,null),A.push(" stream\n");const M=A.reduce(((e,t)=>e+t.length),0),P=`\nendstream\nendobj\nstartxref\n${k}\n%%EOF\n`,N=new Uint8Array(e.length+M+T+P.length);N.set(e);let D=e.length;for(const e of A)p(e,D,N),D+=e.length;for(const[e,t,a]of v)D=g(e,I[0],D,N),D=g(t,I[1],D,N),D=g(a,I[2],D,N);return p(P,D,N),N},t.writeDict=h,t.writeObject=l;var n=a(2),r=a(4),i=a(3),s=a(71),o=a(5),c=a(74);async function l(e,t,a,{encrypt:n=null}){const i=n?.createCipherTransform(e.num,e.gen);a.push(`${e.num} ${e.gen} obj\n`),t instanceof r.Dict?await h(t,a,i):t instanceof o.BaseStream?await u(t,a,i):Array.isArray(t)&&await d(t,a,i),a.push("\nendobj\n")}async function h(e,t,a){t.push("<<");for(const n of e.getKeys())t.push(` /${(0,i.escapePDFName)(n)} `),await f(e.getRaw(n),t,a);t.push(">>")}async function u(e,t,a){let i=e.getString();const{dict:s}=e,[o,c]=await Promise.all([s.getAsync("Filter"),s.getAsync("DecodeParms")]),l=Array.isArray(o)?await s.xref.fetchIfRefAsync(o[0]):o,u=(0,r.isName)(l,"FlateDecode");if("undefined"!=typeof CompressionStream&&(i.length>=256||u))try{const e=(0,n.stringToBytes)(i),t=new CompressionStream("deflate"),a=t.writable.getWriter();a.write(e),a.close();const l=await new Response(t.readable).arrayBuffer();let h,d;i=(0,n.bytesToString)(new Uint8Array(l)),o?u||(h=Array.isArray(o)?[r.Name.get("FlateDecode"),...o]:[r.Name.get("FlateDecode"),o],c&&(d=Array.isArray(c)?[null,...c]:[null,c])):h=r.Name.get("FlateDecode"),h&&s.set("Filter",h),d&&s.set("DecodeParms",d)}catch(e){(0,n.info)(`writeStream - cannot compress data: "${e}".`)}a&&(i=a.encryptString(i)),s.set("Length",i.length),await h(s,t,a),t.push(" stream\n",i,"\nendstream")}async function d(e,t,a){t.push("[");let n=!0;for(const r of e)n?n=!1:t.push(" "),await f(r,t,a);t.push("]")}async function f(e,t,a){e instanceof r.Name?t.push(`/${(0,i.escapePDFName)(e.name)}`):e instanceof r.Ref?t.push(`${e.num} ${e.gen} R`):Array.isArray(e)?await d(e,t,a):"string"==typeof e?(a&&(e=a.encryptString(e)),t.push(`(${(0,i.escapeString)(e)})`)):"number"==typeof e?t.push((0,i.numberToString)(e)):"boolean"==typeof e?t.push(e.toString()):e instanceof r.Dict?await h(e,t,a):e instanceof o.BaseStream?await u(e,t,a):null===e?t.push("null"):(0,n.warn)(`Unhandled value in writer: ${typeof e}, please file a bug.`)}function g(e,t,a,n){for(let r=t+a-1;r>a-1;r--)n[r]=255&e,e>>=8;return a+t}function p(e,t,a){for(let n=0,r=e.length;n<r;n++)a[t+n]=255&e.charCodeAt(n)}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.calculateSHA256=t.calculateMD5=t.PDF20=t.PDF17=t.CipherTransformFactory=t.ARCFourCipher=t.AES256Cipher=t.AES128Cipher=void 0,t.calculateSHA384=u,t.calculateSHA512=void 0;var n=a(2),r=a(4),i=a(75);class s{constructor(e){this.a=0,this.b=0;const t=new Uint8Array(256),a=e.length;for(let e=0;e<256;++e)t[e]=e;for(let n=0,r=0;n<256;++n){const i=t[n];r=r+i+e[n%a]&255,t[n]=t[r],t[r]=i}this.s=t}encryptBlock(e){let t=this.a,a=this.b;const n=this.s,r=e.length,i=new Uint8Array(r);for(let s=0;s<r;++s){t=t+1&255;const r=n[t];a=a+r&255;const o=n[a];n[t]=o,n[a]=r,i[s]=e[s]^n[r+o&255]}return this.a=t,this.b=a,i}decryptBlock(e){return this.encryptBlock(e)}encrypt(e){return this.encryptBlock(e)}}t.ARCFourCipher=s;const o=function(){const e=new Uint8Array([7,12,17,22,7,12,17,22,7,12,17,22,7,12,17,22,5,9,14,20,5,9,14,20,5,9,14,20,5,9,14,20,4,11,16,23,4,11,16,23,4,11,16,23,4,11,16,23,6,10,15,21,6,10,15,21,6,10,15,21,6,10,15,21]),t=new Int32Array([-680876936,-389564586,606105819,-1044525330,-176418897,1200080426,-1473231341,-45705983,1770035416,-1958414417,-42063,-1990404162,1804603682,-40341101,-1502002290,1236535329,-165796510,-1069501632,643717713,-373897302,-701558691,38016083,-660478335,-405537848,568446438,-1019803690,-187363961,1163531501,-1444681467,-51403784,1735328473,-1926607734,-378558,-2022574463,1839030562,-35309556,-1530992060,1272893353,-155497632,-1094730640,681279174,-358537222,-722521979,76029189,-640364487,-421815835,530742520,-995338651,-198630844,1126891415,-1416354905,-57434055,1700485571,-1894986606,-1051523,-2054922799,1873313359,-30611744,-1560198380,1309151649,-145523070,-1120210379,718787259,-343485551]);return function(a,n,r){let i=1732584193,s=-271733879,o=-1732584194,c=271733878;const l=r+72&-64,h=new Uint8Array(l);let u,d;for(u=0;u<r;++u)h[u]=a[n++];h[u++]=128;const f=l-8;for(;u<f;)h[u++]=0;h[u++]=r<<3&255,h[u++]=r>>5&255,h[u++]=r>>13&255,h[u++]=r>>21&255,h[u++]=r>>>29&255,h[u++]=0,h[u++]=0,h[u++]=0;const g=new Int32Array(16);for(u=0;u<l;){for(d=0;d<16;++d,u+=4)g[d]=h[u]|h[u+1]<<8|h[u+2]<<16|h[u+3]<<24;let a,n,r=i,l=s,f=o,p=c;for(d=0;d<64;++d){d<16?(a=l&f|~l&p,n=d):d<32?(a=p&l|~p&f,n=5*d+1&15):d<48?(a=l^f^p,n=3*d+5&15):(a=f^(l|~p),n=7*d&15);const i=p,s=r+a+t[d]+g[n]|0,o=e[d];p=f,f=l,l=l+(s<<o|s>>>32-o)|0,r=i}i=i+r|0,s=s+l|0,o=o+f|0,c=c+p|0}return new Uint8Array([255&i,i>>8&255,i>>16&255,i>>>24&255,255&s,s>>8&255,s>>16&255,s>>>24&255,255&o,o>>8&255,o>>16&255,o>>>24&255,255&c,c>>8&255,c>>16&255,c>>>24&255])}}();t.calculateMD5=o;class c{constructor(e,t){this.high=0|e,this.low=0|t}and(e){this.high&=e.high,this.low&=e.low}xor(e){this.high^=e.high,this.low^=e.low}or(e){this.high|=e.high,this.low|=e.low}shiftRight(e){e>=32?(this.low=this.high>>>e-32|0,this.high=0):(this.low=this.low>>>e|this.high<<32-e,this.high=this.high>>>e|0)}shiftLeft(e){e>=32?(this.high=this.low<<e-32,this.low=0):(this.high=this.high<<e|this.low>>>32-e,this.low<<=e)}rotateRight(e){let t,a;32&e?(a=this.low,t=this.high):(t=this.low,a=this.high),e&=31,this.low=t>>>e|a<<32-e,this.high=a>>>e|t<<32-e}not(){this.high=~this.high,this.low=~this.low}add(e){const t=(this.low>>>0)+(e.low>>>0);let a=(this.high>>>0)+(e.high>>>0);t>4294967295&&(a+=1),this.low=0|t,this.high=0|a}copyTo(e,t){e[t]=this.high>>>24&255,e[t+1]=this.high>>16&255,e[t+2]=this.high>>8&255,e[t+3]=255&this.high,e[t+4]=this.low>>>24&255,e[t+5]=this.low>>16&255,e[t+6]=this.low>>8&255,e[t+7]=255&this.low}assign(e){this.high=e.high,this.low=e.low}}const l=function(){function e(e,t){return e>>>t|e<<32-t}function t(e,t,a){return e&t^~e&a}function a(e,t,a){return e&t^e&a^t&a}function n(t){return e(t,2)^e(t,13)^e(t,22)}function r(t){return e(t,6)^e(t,11)^e(t,25)}function i(t){return e(t,7)^e(t,18)^t>>>3}const s=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];return function(o,c,l){let h=1779033703,u=3144134277,d=1013904242,f=2773480762,g=1359893119,p=2600822924,m=528734635,b=1541459225;const y=64*Math.ceil((l+9)/64),w=new Uint8Array(y);let x,S;for(x=0;x<l;++x)w[x]=o[c++];w[x++]=128;const A=y-8;for(;x<A;)w[x++]=0;w[x++]=0,w[x++]=0,w[x++]=0,w[x++]=l>>>29&255,w[x++]=l>>21&255,w[x++]=l>>13&255,w[x++]=l>>5&255,w[x++]=l<<3&255;const k=new Uint32Array(64);for(x=0;x<y;){for(S=0;S<16;++S)k[S]=w[x]<<24|w[x+1]<<16|w[x+2]<<8|w[x+3],x+=4;for(S=16;S<64;++S)k[S]=0|(e(C=k[S-2],17)^e(C,19)^C>>>10)+k[S-7]+i(k[S-15])+k[S-16];let o,c,l=h,y=u,A=d,v=f,F=g,O=p,I=m,T=b;for(S=0;S<64;++S)o=T+r(F)+t(F,O,I)+s[S]+k[S],c=n(l)+a(l,y,A),T=I,I=O,O=F,F=v+o|0,v=A,A=y,y=l,l=o+c|0;h=h+l|0,u=u+y|0,d=d+A|0,f=f+v|0,g=g+F|0,p=p+O|0,m=m+I|0,b=b+T|0}var C;return new Uint8Array([h>>24&255,h>>16&255,h>>8&255,255&h,u>>24&255,u>>16&255,u>>8&255,255&u,d>>24&255,d>>16&255,d>>8&255,255&d,f>>24&255,f>>16&255,f>>8&255,255&f,g>>24&255,g>>16&255,g>>8&255,255&g,p>>24&255,p>>16&255,p>>8&255,255&p,m>>24&255,m>>16&255,m>>8&255,255&m,b>>24&255,b>>16&255,b>>8&255,255&b])}}();t.calculateSHA256=l;const h=function(){function e(e,t,a,n,r){e.assign(t),e.and(a),r.assign(t),r.not(),r.and(n),e.xor(r)}function t(e,t,a,n,r){e.assign(t),e.and(a),r.assign(t),r.and(n),e.xor(r),r.assign(a),r.and(n),e.xor(r)}function a(e,t,a){e.assign(t),e.rotateRight(28),a.assign(t),a.rotateRight(34),e.xor(a),a.assign(t),a.rotateRight(39),e.xor(a)}function n(e,t,a){e.assign(t),e.rotateRight(14),a.assign(t),a.rotateRight(18),e.xor(a),a.assign(t),a.rotateRight(41),e.xor(a)}function r(e,t,a){e.assign(t),e.rotateRight(1),a.assign(t),a.rotateRight(8),e.xor(a),a.assign(t),a.shiftRight(7),e.xor(a)}function i(e,t,a){e.assign(t),e.rotateRight(19),a.assign(t),a.rotateRight(61),e.xor(a),a.assign(t),a.shiftRight(6),e.xor(a)}const s=[new c(1116352408,3609767458),new c(1899447441,602891725),new c(3049323471,3964484399),new c(3921009573,2173295548),new c(961987163,4081628472),new c(1508970993,3053834265),new c(2453635748,2937671579),new c(2870763221,3664609560),new c(3624381080,2734883394),new c(310598401,1164996542),new c(607225278,1323610764),new c(1426881987,3590304994),new c(1925078388,4068182383),new c(2162078206,991336113),new c(2614888103,633803317),new c(3248222580,3479774868),new c(3835390401,2666613458),new c(4022224774,944711139),new c(264347078,2341262773),new c(604807628,2007800933),new c(770255983,1495990901),new c(1249150122,1856431235),new c(1555081692,3175218132),new c(1996064986,2198950837),new c(2554220882,3999719339),new c(2821834349,766784016),new c(2952996808,2566594879),new c(3210313671,3203337956),new c(3336571891,1034457026),new c(3584528711,2466948901),new c(113926993,3758326383),new c(338241895,168717936),new c(666307205,1188179964),new c(773529912,1546045734),new c(1294757372,1522805485),new c(1396182291,2643833823),new c(1695183700,2343527390),new c(1986661051,1014477480),new c(2177026350,1206759142),new c(2456956037,344077627),new c(2730485921,1290863460),new c(2820302411,3158454273),new c(3259730800,3505952657),new c(3345764771,106217008),new c(3516065817,3606008344),new c(3600352804,1432725776),new c(4094571909,1467031594),new c(275423344,851169720),new c(430227734,3100823752),new c(506948616,1363258195),new c(659060556,3750685593),new c(883997877,3785050280),new c(958139571,3318307427),new c(1322822218,3812723403),new c(1537002063,2003034995),new c(1747873779,3602036899),new c(1955562222,1575990012),new c(2024104815,1125592928),new c(2227730452,2716904306),new c(2361852424,442776044),new c(2428436474,593698344),new c(2756734187,3733110249),new c(3204031479,2999351573),new c(3329325298,3815920427),new c(3391569614,3928383900),new c(3515267271,566280711),new c(3940187606,3454069534),new c(4118630271,4000239992),new c(116418474,1914138554),new c(174292421,2731055270),new c(289380356,3203993006),new c(460393269,320620315),new c(685471733,587496836),new c(852142971,1086792851),new c(1017036298,365543100),new c(1126000580,2618297676),new c(1288033470,3409855158),new c(1501505948,4234509866),new c(1607167915,987167468),new c(1816402316,1246189591)];return function(o,l,h,u=!1){let d,f,g,p,m,b,y,w;u?(d=new c(3418070365,3238371032),f=new c(1654270250,914150663),g=new c(2438529370,812702999),p=new c(355462360,4144912697),m=new c(1731405415,4290775857),b=new c(2394180231,1750603025),y=new c(3675008525,1694076839),w=new c(1203062813,3204075428)):(d=new c(1779033703,4089235720),f=new c(3144134277,2227873595),g=new c(1013904242,4271175723),p=new c(2773480762,1595750129),m=new c(1359893119,2917565137),b=new c(2600822924,725511199),y=new c(528734635,4215389547),w=new c(1541459225,327033209));const x=128*Math.ceil((h+17)/128),S=new Uint8Array(x);let A,k;for(A=0;A<h;++A)S[A]=o[l++];S[A++]=128;const C=x-16;for(;A<C;)S[A++]=0;S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=0,S[A++]=h>>>29&255,S[A++]=h>>21&255,S[A++]=h>>13&255,S[A++]=h>>5&255,S[A++]=h<<3&255;const v=new Array(80);for(A=0;A<80;A++)v[A]=new c(0,0);let F=new c(0,0),O=new c(0,0),I=new c(0,0),T=new c(0,0),M=new c(0,0),P=new c(0,0),N=new c(0,0),D=new c(0,0);const R=new c(0,0),E=new c(0,0),B=new c(0,0),$=new c(0,0);let L,_;for(A=0;A<x;){for(k=0;k<16;++k)v[k].high=S[A]<<24|S[A+1]<<16|S[A+2]<<8|S[A+3],v[k].low=S[A+4]<<24|S[A+5]<<16|S[A+6]<<8|S[A+7],A+=8;for(k=16;k<80;++k)L=v[k],i(L,v[k-2],$),L.add(v[k-7]),r(B,v[k-15],$),L.add(B),L.add(v[k-16]);for(F.assign(d),O.assign(f),I.assign(g),T.assign(p),M.assign(m),P.assign(b),N.assign(y),D.assign(w),k=0;k<80;++k)R.assign(D),n(B,M,$),R.add(B),e(B,M,P,N,$),R.add(B),R.add(s[k]),R.add(v[k]),a(E,F,$),t(B,F,O,I,$),E.add(B),L=D,D=N,N=P,P=M,T.add(R),M=T,T=I,I=O,O=F,L.assign(R),L.add(E),F=L;d.add(F),f.add(O),g.add(I),p.add(T),m.add(M),b.add(P),y.add(N),w.add(D)}return u?(_=new Uint8Array(48),d.copyTo(_,0),f.copyTo(_,8),g.copyTo(_,16),p.copyTo(_,24),m.copyTo(_,32),b.copyTo(_,40)):(_=new Uint8Array(64),d.copyTo(_,0),f.copyTo(_,8),g.copyTo(_,16),p.copyTo(_,24),m.copyTo(_,32),b.copyTo(_,40),y.copyTo(_,48),w.copyTo(_,56)),_}}();function u(e,t,a){return h(e,t,a,!0)}t.calculateSHA512=h;class d{decryptBlock(e){return e}encrypt(e){return e}}class f{constructor(){this.constructor===f&&(0,n.unreachable)("Cannot initialize AESBaseCipher."),this._s=new Uint8Array([99,124,119,123,242,107,111,197,48,1,103,43,254,215,171,118,202,130,201,125,250,89,71,240,173,212,162,175,156,164,114,192,183,253,147,38,54,63,247,204,52,165,229,241,113,216,49,21,4,199,35,195,24,150,5,154,7,18,128,226,235,39,178,117,9,131,44,26,27,110,90,160,82,59,214,179,41,227,47,132,83,209,0,237,32,252,177,91,106,203,190,57,74,76,88,207,208,239,170,251,67,77,51,133,69,249,2,127,80,60,159,168,81,163,64,143,146,157,56,245,188,182,218,33,16,255,243,210,205,12,19,236,95,151,68,23,196,167,126,61,100,93,25,115,96,129,79,220,34,42,144,136,70,238,184,20,222,94,11,219,224,50,58,10,73,6,36,92,194,211,172,98,145,149,228,121,231,200,55,109,141,213,78,169,108,86,244,234,101,122,174,8,186,120,37,46,28,166,180,198,232,221,116,31,75,189,139,138,112,62,181,102,72,3,246,14,97,53,87,185,134,193,29,158,225,248,152,17,105,217,142,148,155,30,135,233,206,85,40,223,140,161,137,13,191,230,66,104,65,153,45,15,176,84,187,22]),this._inv_s=new Uint8Array([82,9,106,213,48,54,165,56,191,64,163,158,129,243,215,251,124,227,57,130,155,47,255,135,52,142,67,68,196,222,233,203,84,123,148,50,166,194,35,61,238,76,149,11,66,250,195,78,8,46,161,102,40,217,36,178,118,91,162,73,109,139,209,37,114,248,246,100,134,104,152,22,212,164,92,204,93,101,182,146,108,112,72,80,253,237,185,218,94,21,70,87,167,141,157,132,144,216,171,0,140,188,211,10,247,228,88,5,184,179,69,6,208,44,30,143,202,63,15,2,193,175,189,3,1,19,138,107,58,145,17,65,79,103,220,234,151,242,207,206,240,180,230,115,150,172,116,34,231,173,53,133,226,249,55,232,28,117,223,110,71,241,26,113,29,41,197,137,111,183,98,14,170,24,190,27,252,86,62,75,198,210,121,32,154,219,192,254,120,205,90,244,31,221,168,51,136,7,199,49,177,18,16,89,39,128,236,95,96,81,127,169,25,181,74,13,45,229,122,159,147,201,156,239,160,224,59,77,174,42,245,176,200,235,187,60,131,83,153,97,23,43,4,126,186,119,214,38,225,105,20,99,85,33,12,125]),this._mix=new Uint32Array([0,235474187,470948374,303765277,941896748,908933415,607530554,708780849,1883793496,2118214995,1817866830,1649639237,1215061108,1181045119,1417561698,1517767529,3767586992,4003061179,4236429990,4069246893,3635733660,3602770327,3299278474,3400528769,2430122216,2664543715,2362090238,2193862645,2835123396,2801107407,3035535058,3135740889,3678124923,3576870512,3341394285,3374361702,3810496343,3977675356,4279080257,4043610186,2876494627,2776292904,3076639029,3110650942,2472011535,2640243204,2403728665,2169303058,1001089995,899835584,666464733,699432150,59727847,226906860,530400753,294930682,1273168787,1172967064,1475418501,1509430414,1942435775,2110667444,1876241833,1641816226,2910219766,2743034109,2976151520,3211623147,2505202138,2606453969,2302690252,2269728455,3711829422,3543599269,3240894392,3475313331,3843699074,3943906441,4178062228,4144047775,1306967366,1139781709,1374988112,1610459739,1975683434,2076935265,1775276924,1742315127,1034867998,866637845,566021896,800440835,92987698,193195065,429456164,395441711,1984812685,2017778566,1784663195,1683407248,1315562145,1080094634,1383856311,1551037884,101039829,135050206,437757123,337553864,1042385657,807962610,573804783,742039012,2531067453,2564033334,2328828971,2227573024,2935566865,2700099354,3001755655,3168937228,3868552805,3902563182,4203181171,4102977912,3736164937,3501741890,3265478751,3433712980,1106041591,1340463100,1576976609,1408749034,2043211483,2009195472,1708848333,1809054150,832877231,1068351396,766945465,599762354,159417987,126454664,361929877,463180190,2709260871,2943682380,3178106961,3009879386,2572697195,2538681184,2236228733,2336434550,3509871135,3745345300,3441850377,3274667266,3910161971,3877198648,4110568485,4211818798,2597806476,2497604743,2261089178,2295101073,2733856160,2902087851,3202437046,2968011453,3936291284,3835036895,4136440770,4169408201,3535486456,3702665459,3467192302,3231722213,2051518780,1951317047,1716890410,1750902305,1113818384,1282050075,1584504582,1350078989,168810852,67556463,371049330,404016761,841739592,1008918595,775550814,540080725,3969562369,3801332234,4035489047,4269907996,3569255213,3669462566,3366754619,3332740144,2631065433,2463879762,2160117071,2395588676,2767645557,2868897406,3102011747,3069049960,202008497,33778362,270040487,504459436,875451293,975658646,675039627,641025152,2084704233,1917518562,1615861247,1851332852,1147550661,1248802510,1484005843,1451044056,933301370,967311729,733156972,632953703,260388950,25965917,328671808,496906059,1206477858,1239443753,1543208500,1441952575,2144161806,1908694277,1675577880,1842759443,3610369226,3644379585,3408119516,3307916247,4011190502,3776767469,4077384432,4245618683,2809771154,2842737049,3144396420,3043140495,2673705150,2438237621,2203032232,2370213795]),this._mixCol=new Uint8Array(256);for(let e=0;e<256;e++)this._mixCol[e]=e<128?e<<1:e<<1^27;this.buffer=new Uint8Array(16),this.bufferPosition=0}_expandKey(e){(0,n.unreachable)("Cannot call `_expandKey` on the base class")}_decrypt(e,t){let a,n,r;const i=new Uint8Array(16);i.set(e);for(let e=0,a=this._keySize;e<16;++e,++a)i[e]^=t[a];for(let e=this._cyclesOfRepetition-1;e>=1;--e){a=i[13],i[13]=i[9],i[9]=i[5],i[5]=i[1],i[1]=a,a=i[14],n=i[10],i[14]=i[6],i[10]=i[2],i[6]=a,i[2]=n,a=i[15],n=i[11],r=i[7],i[15]=i[3],i[11]=a,i[7]=n,i[3]=r;for(let e=0;e<16;++e)i[e]=this._inv_s[i[e]];for(let a=0,n=16*e;a<16;++a,++n)i[a]^=t[n];for(let e=0;e<16;e+=4){const t=this._mix[i[e]],n=this._mix[i[e+1]],r=this._mix[i[e+2]],s=this._mix[i[e+3]];a=t^n>>>8^n<<24^r>>>16^r<<16^s>>>24^s<<8,i[e]=a>>>24&255,i[e+1]=a>>16&255,i[e+2]=a>>8&255,i[e+3]=255&a}}a=i[13],i[13]=i[9],i[9]=i[5],i[5]=i[1],i[1]=a,a=i[14],n=i[10],i[14]=i[6],i[10]=i[2],i[6]=a,i[2]=n,a=i[15],n=i[11],r=i[7],i[15]=i[3],i[11]=a,i[7]=n,i[3]=r;for(let e=0;e<16;++e)i[e]=this._inv_s[i[e]],i[e]^=t[e];return i}_encrypt(e,t){const a=this._s;let n,r,i;const s=new Uint8Array(16);s.set(e);for(let e=0;e<16;++e)s[e]^=t[e];for(let e=1;e<this._cyclesOfRepetition;e++){for(let e=0;e<16;++e)s[e]=a[s[e]];i=s[1],s[1]=s[5],s[5]=s[9],s[9]=s[13],s[13]=i,i=s[2],r=s[6],s[2]=s[10],s[6]=s[14],s[10]=i,s[14]=r,i=s[3],r=s[7],n=s[11],s[3]=s[15],s[7]=i,s[11]=r,s[15]=n;for(let e=0;e<16;e+=4){const t=s[e+0],a=s[e+1],r=s[e+2],i=s[e+3];n=t^a^r^i,s[e+0]^=n^this._mixCol[t^a],s[e+1]^=n^this._mixCol[a^r],s[e+2]^=n^this._mixCol[r^i],s[e+3]^=n^this._mixCol[i^t]}for(let a=0,n=16*e;a<16;++a,++n)s[a]^=t[n]}for(let e=0;e<16;++e)s[e]=a[s[e]];i=s[1],s[1]=s[5],s[5]=s[9],s[9]=s[13],s[13]=i,i=s[2],r=s[6],s[2]=s[10],s[6]=s[14],s[10]=i,s[14]=r,i=s[3],r=s[7],n=s[11],s[3]=s[15],s[7]=i,s[11]=r,s[15]=n;for(let e=0,a=this._keySize;e<16;++e,++a)s[e]^=t[a];return s}_decryptBlock2(e,t){const a=e.length;let n=this.buffer,r=this.bufferPosition;const i=[];let s=this.iv;for(let t=0;t<a;++t){if(n[r]=e[t],++r,r<16)continue;const a=this._decrypt(n,this._key);for(let e=0;e<16;++e)a[e]^=s[e];s=n,i.push(a),n=new Uint8Array(16),r=0}if(this.buffer=n,this.bufferLength=r,this.iv=s,0===i.length)return new Uint8Array(0);let o=16*i.length;if(t){const e=i.at(-1);let t=e[15];if(t<=16){for(let a=15,n=16-t;a>=n;--a)if(e[a]!==t){t=0;break}o-=t,i[i.length-1]=e.subarray(0,16-t)}}const c=new Uint8Array(o);for(let e=0,t=0,a=i.length;e<a;++e,t+=16)c.set(i[e],t);return c}decryptBlock(e,t,a=null){const n=e.length,r=this.buffer;let i=this.bufferPosition;if(a)this.iv=a;else{for(let t=0;i<16&&t<n;++t,++i)r[i]=e[t];if(i<16)return this.bufferLength=i,new Uint8Array(0);this.iv=r,e=e.subarray(16)}return this.buffer=new Uint8Array(16),this.bufferLength=0,this.decryptBlock=this._decryptBlock2,this.decryptBlock(e,t)}encrypt(e,t){const a=e.length;let n=this.buffer,r=this.bufferPosition;const i=[];t||(t=new Uint8Array(16));for(let s=0;s<a;++s){if(n[r]=e[s],++r,r<16)continue;for(let e=0;e<16;++e)n[e]^=t[e];const a=this._encrypt(n,this._key);t=a,i.push(a),n=new Uint8Array(16),r=0}if(this.buffer=n,this.bufferLength=r,this.iv=t,0===i.length)return new Uint8Array(0);const s=16*i.length,o=new Uint8Array(s);for(let e=0,t=0,a=i.length;e<a;++e,t+=16)o.set(i[e],t);return o}}class g extends f{constructor(e){super(),this._cyclesOfRepetition=10,this._keySize=160,this._rcon=new Uint8Array([141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141,1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145,57,114,228,211,189,97,194,159,37,74,148,51,102,204,131,29,58,116,232,203,141]),this._key=this._expandKey(e)}_expandKey(e){const t=this._s,a=this._rcon,n=new Uint8Array(176);n.set(e);for(let e=16,r=1;e<176;++r){let i=n[e-3],s=n[e-2],o=n[e-1],c=n[e-4];i=t[i],s=t[s],o=t[o],c=t[c],i^=a[r];for(let t=0;t<4;++t)n[e]=i^=n[e-16],e++,n[e]=s^=n[e-16],e++,n[e]=o^=n[e-16],e++,n[e]=c^=n[e-16],e++}return n}}t.AES128Cipher=g;class p extends f{constructor(e){super(),this._cyclesOfRepetition=14,this._keySize=224,this._key=this._expandKey(e)}_expandKey(e){const t=this._s,a=new Uint8Array(240);a.set(e);let n,r,i,s,o=1;for(let e=32,c=1;e<240;++c){e%32==16?(n=t[n],r=t[r],i=t[i],s=t[s]):e%32==0&&(n=a[e-3],r=a[e-2],i=a[e-1],s=a[e-4],n=t[n],r=t[r],i=t[i],s=t[s],n^=o,(o<<=1)>=256&&(o=255&(27^o)));for(let t=0;t<4;++t)a[e]=n^=a[e-32],e++,a[e]=r^=a[e-32],e++,a[e]=i^=a[e-32],e++,a[e]=s^=a[e-32],e++}return a}}t.AES256Cipher=p;class m{checkOwnerPassword(e,t,a,r){const i=new Uint8Array(e.length+56);i.set(e,0),i.set(t,e.length),i.set(a,e.length+t.length);const s=l(i,0,i.length);return(0,n.isArrayEqual)(s,r)}checkUserPassword(e,t,a){const r=new Uint8Array(e.length+8);r.set(e,0),r.set(t,e.length);const i=l(r,0,r.length);return(0,n.isArrayEqual)(i,a)}getOwnerKey(e,t,a,n){const r=new Uint8Array(e.length+56);r.set(e,0),r.set(t,e.length),r.set(a,e.length+t.length);const i=l(r,0,r.length);return new p(i).decryptBlock(n,!1,new Uint8Array(16))}getUserKey(e,t,a){const n=new Uint8Array(e.length+8);n.set(e,0),n.set(t,e.length);const r=l(n,0,n.length);return new p(r).decryptBlock(a,!1,new Uint8Array(16))}}t.PDF17=m;class b{_hash(e,t,a){let n=l(t,0,t.length).subarray(0,32),r=[0],i=0;for(;i<64||r.at(-1)>i-32;){const t=e.length+n.length+a.length,s=new Uint8Array(t);let o=0;s.set(e,o),o+=e.length,s.set(n,o),o+=n.length,s.set(a,o);const c=new Uint8Array(64*t);for(let e=0,a=0;e<64;e++,a+=t)c.set(s,a);r=new g(n.subarray(0,16)).encrypt(c,n.subarray(16,32));const d=r.slice(0,16).reduce(((e,t)=>e+t),0)%3;0===d?n=l(r,0,r.length):1===d?n=u(r,0,r.length):2===d&&(n=h(r,0,r.length)),i++}return n.subarray(0,32)}checkOwnerPassword(e,t,a,r){const i=new Uint8Array(e.length+56);i.set(e,0),i.set(t,e.length),i.set(a,e.length+t.length);const s=this._hash(e,i,a);return(0,n.isArrayEqual)(s,r)}checkUserPassword(e,t,a){const r=new Uint8Array(e.length+8);r.set(e,0),r.set(t,e.length);const i=this._hash(e,r,[]);return(0,n.isArrayEqual)(i,a)}getOwnerKey(e,t,a,n){const r=new Uint8Array(e.length+56);r.set(e,0),r.set(t,e.length),r.set(a,e.length+t.length);const i=this._hash(e,r,a);return new p(i).decryptBlock(n,!1,new Uint8Array(16))}getUserKey(e,t,a){const n=new Uint8Array(e.length+8);n.set(e,0),n.set(t,e.length);const r=this._hash(e,n,[]);return new p(r).decryptBlock(a,!1,new Uint8Array(16))}}t.PDF20=b;class y{constructor(e,t){this.StringCipherConstructor=e,this.StreamCipherConstructor=t}createStream(e,t){const a=new this.StreamCipherConstructor;return new i.DecryptStream(e,t,(function(e,t){return a.decryptBlock(e,t)}))}decryptString(e){const t=new this.StringCipherConstructor;let a=(0,n.stringToBytes)(e);return a=t.decryptBlock(a,!0),(0,n.bytesToString)(a)}encryptString(e){const t=new this.StringCipherConstructor;if(t instanceof f){const a=16-e.length%16;e+=String.fromCharCode(a).repeat(a);const r=new Uint8Array(16);if("undefined"!=typeof crypto)crypto.getRandomValues(r);else for(let e=0;e<16;e++)r[e]=Math.floor(256*Math.random());let i=(0,n.stringToBytes)(e);i=t.encrypt(i,r);const s=new Uint8Array(16+i.length);return s.set(r),s.set(i,16),(0,n.bytesToString)(s)}let a=(0,n.stringToBytes)(e);return a=t.encrypt(a),(0,n.bytesToString)(a)}}class w{static#O=new Uint8Array([40,191,78,94,78,117,138,65,100,0,78,86,255,250,1,8,46,46,0,182,208,104,62,128,47,12,169,254,100,83,105,122]);#I(e,t,a,n,r,i,s,o,c,l,h,u){if(t){const e=Math.min(127,t.length);t=t.subarray(0,e)}else t=[];const d=6===e?new b:new m;return d.checkUserPassword(t,o,s)?d.getUserKey(t,c,h):t.length&&d.checkOwnerPassword(t,n,i,a)?d.getOwnerKey(t,r,i,l):null}#T(e,t,a,n,r,i,c,l){const h=40+a.length+e.length,u=new Uint8Array(h);let d,f,g=0;if(t)for(f=Math.min(32,t.length);g<f;++g)u[g]=t[g];for(d=0;g<32;)u[g++]=w.#O[d++];for(d=0,f=a.length;d<f;++d)u[g++]=a[d];for(u[g++]=255&r,u[g++]=r>>8&255,u[g++]=r>>16&255,u[g++]=r>>>24&255,d=0,f=e.length;d<f;++d)u[g++]=e[d];i>=4&&!l&&(u[g++]=255,u[g++]=255,u[g++]=255,u[g++]=255);let p=o(u,0,g);const m=c>>3;if(i>=3)for(d=0;d<50;++d)p=o(p,0,m);const b=p.subarray(0,m);let y,x;if(i>=3){for(g=0;g<32;++g)u[g]=w.#O[g];for(d=0,f=e.length;d<f;++d)u[g++]=e[d];y=new s(b),x=y.encryptBlock(o(u,0,g)),f=b.length;const t=new Uint8Array(f);for(d=1;d<=19;++d){for(let e=0;e<f;++e)t[e]=b[e]^d;y=new s(t),x=y.encryptBlock(x)}for(d=0,f=x.length;d<f;++d)if(n[d]!==x[d])return null}else for(y=new s(b),x=y.encryptBlock(w.#O),d=0,f=x.length;d<f;++d)if(n[d]!==x[d])return null;return b}#M(e,t,a,n){const r=new Uint8Array(32);let i=0;const c=Math.min(32,e.length);for(;i<c;++i)r[i]=e[i];let l=0;for(;i<32;)r[i++]=w.#O[l++];let h=o(r,0,i);const u=n>>3;if(a>=3)for(l=0;l<50;++l)h=o(h,0,h.length);let d,f;if(a>=3){f=t;const e=new Uint8Array(u);for(l=19;l>=0;l--){for(let t=0;t<u;++t)e[t]=h[t]^l;d=new s(e),f=d.encryptBlock(f)}}else d=new s(h.subarray(0,u)),f=d.encryptBlock(t);return f}#P(e,t,a,n=!1){const r=new Uint8Array(a.length+9),i=a.length;let s;for(s=0;s<i;++s)r[s]=a[s];r[s++]=255&e,r[s++]=e>>8&255,r[s++]=e>>16&255,r[s++]=255&t,r[s++]=t>>8&255,n&&(r[s++]=115,r[s++]=65,r[s++]=108,r[s++]=84);return o(r,0,s).subarray(0,Math.min(a.length+5,16))}#N(e,t,a,i,o){if(!(t instanceof r.Name))throw new n.FormatError("Invalid crypt filter name.");const c=this,l=e.get(t.name),h=l?.get("CFM");if(!h||"None"===h.name)return function(){return new d};if("V2"===h.name)return function(){return new s(c.#P(a,i,o,!1))};if("AESV2"===h.name)return function(){return new g(c.#P(a,i,o,!0))};if("AESV3"===h.name)return function(){return new p(o)};throw new n.FormatError("Unknown crypto method")}constructor(e,t,a){const i=e.get("Filter");if(!(0,r.isName)(i,"Standard"))throw new n.FormatError("unknown encryption method");this.filterName=i.name,this.dict=e;const s=e.get("V");if(!Number.isInteger(s)||1!==s&&2!==s&&4!==s&&5!==s)throw new n.FormatError("unsupported encryption algorithm");this.algorithm=s;let o=e.get("Length");if(!o)if(s<=3)o=40;else{const t=e.get("CF"),a=e.get("StmF");if(t instanceof r.Dict&&a instanceof r.Name){t.suppressEncryption=!0;const e=t.get(a.name);o=e?.get("Length")||128,o<40&&(o<<=3)}}if(!Number.isInteger(o)||o<40||o%8!=0)throw new n.FormatError("invalid key length");const c=(0,n.stringToBytes)(e.get("O")),l=(0,n.stringToBytes)(e.get("U")),h=c.subarray(0,32),u=l.subarray(0,32),d=e.get("P"),f=e.get("R"),g=(4===s||5===s)&&!1!==e.get("EncryptMetadata");this.encryptMetadata=g;const p=(0,n.stringToBytes)(t);let m,b;if(a){if(6===f)try{a=(0,n.utf8StringToString)(a)}catch{(0,n.warn)("CipherTransformFactory: Unable to convert UTF8 encoded password.")}m=(0,n.stringToBytes)(a)}if(5!==s)b=this.#T(p,m,h,u,d,f,o,g);else{const t=c.subarray(32,40),a=c.subarray(40,48),r=l.subarray(0,48),i=l.subarray(32,40),s=l.subarray(40,48),o=(0,n.stringToBytes)(e.get("OE")),d=(0,n.stringToBytes)(e.get("UE")),g=(0,n.stringToBytes)(e.get("Perms"));b=this.#I(f,m,h,t,a,r,u,i,s,o,d,g)}if(!b&&!a)throw new n.PasswordException("No password given",n.PasswordResponses.NEED_PASSWORD);if(!b&&a){const e=this.#M(m,h,f,o);b=this.#T(p,e,h,u,d,f,o,g)}if(!b)throw new n.PasswordException("Incorrect Password",n.PasswordResponses.INCORRECT_PASSWORD);if(this.encryptionKey=b,s>=4){const t=e.get("CF");t instanceof r.Dict&&(t.suppressEncryption=!0),this.cf=t,this.stmf=e.get("StmF")||r.Name.get("Identity"),this.strf=e.get("StrF")||r.Name.get("Identity"),this.eff=e.get("EFF")||this.stmf}}createCipherTransform(e,t){if(4===this.algorithm||5===this.algorithm)return new y(this.#N(this.cf,this.strf,e,t,this.encryptionKey),this.#N(this.cf,this.stmf,e,t,this.encryptionKey));const a=this.#P(e,t,this.encryptionKey,!1),n=function(){return new s(a)};return new y(n,n)}}t.CipherTransformFactory=w},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.DecryptStream=void 0;var n=a(18);class r extends n.DecodeStream{constructor(e,t,a){super(t),this.str=e,this.dict=e.dict,this.decrypt=a,this.nextChunk=null,this.initialized=!1}readBlock(){let e;if(this.initialized?e=this.nextChunk:(e=this.str.getBytes(512),this.initialized=!0),!e||0===e.length)return void(this.eof=!0);this.nextChunk=this.str.getBytes(512);const t=this.nextChunk?.length>0;e=(0,this.decrypt)(e,!t);const a=this.bufferLength,n=a+e.length;this.ensureBuffer(n).set(e,a),this.bufferLength=n}}t.DecryptStream=r},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectLoader=void 0;var n=a(4),r=a(5),i=a(3),s=a(2);function o(e,t){if(e instanceof n.Dict)e=e.getRawValues();else if(e instanceof r.BaseStream)e=e.dict.getRawValues();else if(!Array.isArray(e))return;for(const i of e)((a=i)instanceof n.Ref||a instanceof n.Dict||a instanceof r.BaseStream||Array.isArray(a))&&t.push(i);var a}t.ObjectLoader=class{constructor(e,t,a){this.dict=e,this.keys=t,this.xref=a,this.refSet=null}async load(){if(this.xref.stream.isDataLoaded)return;const{keys:e,dict:t}=this;this.refSet=new n.RefSet;const a=[];for(const n of e){const e=t.getRaw(n);void 0!==e&&a.push(e)}return this._walk(a)}async _walk(e){const t=[],a=[];for(;e.length;){let c=e.pop();if(c instanceof n.Ref){if(this.refSet.has(c))continue;try{this.refSet.put(c),c=this.xref.fetch(c)}catch(e){if(!(e instanceof i.MissingDataException)){(0,s.warn)(`ObjectLoader._walk - requesting all data: "${e}".`),this.refSet=null;const{manager:t}=this.xref.stream;return t.requestAllChunks()}t.push(c),a.push({begin:e.begin,end:e.end})}}if(c instanceof r.BaseStream){const e=c.getBaseStreams();if(e){let n=!1;for(const t of e)t.isDataLoaded||(n=!0,a.push({begin:t.start,end:t.end}));n&&t.push(c)}}o(c,e)}if(a.length){await this.xref.stream.manager.requestRanges(a);for(const e of t)e instanceof n.Ref&&this.refSet.remove(e);return this._walk(t)}this.refSet=null}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XFAFactory=void 0;var n=a(78),r=a(79),i=a(89),s=a(85),o=a(84),c=a(2),l=a(90),h=a(100);class u{constructor(e){try{this.root=(new l.XFAParser).parse(u._createDocument(e));const t=new r.Binder(this.root);this.form=t.bind(),this.dataHandler=new i.DataHandler(this.root,t.getData()),this.form[n.$globalData].template=this.form}catch(e){(0,c.warn)(`XFA - an error occurred during parsing and binding: ${e}`)}}isValid(){return this.root&&this.form}_createPagesHelper(){const e=this.form[n.$toPages]();return new Promise(((t,a)=>{const n=()=>{try{const a=e.next();a.done?t(a.value):setTimeout(n,0)}catch(e){a(e)}};setTimeout(n,0)}))}async _createPages(){try{this.pages=await this._createPagesHelper(),this.dims=this.pages.children.map((e=>{const{width:t,height:a}=e.attributes.style;return[0,0,parseInt(t),parseInt(a)]}))}catch(e){(0,c.warn)(`XFA - an error occurred during layout: ${e}`)}}getBoundingBox(e){return this.dims[e]}async getNumPages(){return this.pages||await this._createPages(),this.dims.length}setImages(e){this.form[n.$globalData].images=e}setFonts(e){this.form[n.$globalData].fontFinder=new s.FontFinder(e);const t=[];for(let e of this.form[n.$globalData].usedTypefaces){e=(0,o.stripQuotes)(e);this.form[n.$globalData].fontFinder.find(e)||t.push(e)}return t.length>0?t:null}appendFonts(e,t){this.form[n.$globalData].fontFinder.add(e,t)}async getPages(){this.pages||await this._createPages();const e=this.pages;return this.pages=null,e}serializeData(e){return this.dataHandler.serialize(e)}static _createDocument(e){return e["/xdp:xdp"]?Object.values(e).join(""):e["xdp:xdp"]}static getRichTextAsHtml(e){if(!e||"string"!=typeof e)return null;try{let t=new l.XFAParser(h.XhtmlNamespace,!0).parse(e);if(!["body","xhtml"].includes(t[n.$nodeName])){const e=h.XhtmlNamespace.body({});e[n.$appendChild](t),t=e}const a=t[n.$toHTML]();if(!a.success)return null;const{html:r}=a,{attributes:i}=r;return i&&(i.class&&(i.class=i.class.filter((e=>!e.startsWith("xfa")))),i.dir="auto"),{html:r,str:t[n.$text]()}}catch(e){(0,c.warn)(`XFA - an error occurred during parsing of rich text: ${e}`)}return null}}t.XFAFactory=u},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.$uid=t.$toStyle=t.$toString=t.$toPages=t.$toHTML=t.$text=t.$tabIndex=t.$setValue=t.$setSetAttributes=t.$setId=t.$searchNode=t.$root=t.$resolvePrototypes=t.$removeChild=t.$pushPara=t.$pushGlyphs=t.$popPara=t.$onText=t.$onChildCheck=t.$onChild=t.$nsAttributes=t.$nodeName=t.$namespaceId=t.$lastAttribute=t.$isUsable=t.$isTransparent=t.$isThereMoreWidth=t.$isSplittable=t.$isNsAgnostic=t.$isDescendent=t.$isDataValue=t.$isCDATAXml=t.$isBindable=t.$insertAt=t.$indexOf=t.$ids=t.$hasSettableValue=t.$globalData=t.$getTemplateRoot=t.$getSubformParent=t.$getRealChildrenByNameIt=t.$getParent=t.$getNextPage=t.$getExtra=t.$getDataValue=t.$getContainedChildren=t.$getChildrenByNameIt=t.$getChildrenByName=t.$getChildrenByClass=t.$getChildren=t.$getAvailableSpace=t.$getAttributes=t.$getAttributeIt=t.$flushHTML=t.$finalize=t.$extra=t.$dump=t.$data=t.$content=t.$consumed=t.$clone=t.$cleanup=t.$cleanPage=t.$clean=t.$childrenToHTML=t.$appendChild=t.$addHTML=t.$acceptWhitespace=void 0;const a=Symbol();t.$acceptWhitespace=a;const n=Symbol();t.$addHTML=n;const r=Symbol();t.$appendChild=r;const i=Symbol();t.$childrenToHTML=i;const s=Symbol();t.$clean=s;const o=Symbol();t.$cleanPage=o;const c=Symbol();t.$cleanup=c;const l=Symbol();t.$clone=l;const h=Symbol();t.$consumed=h;const u=Symbol("content");t.$content=u;const d=Symbol("data");t.$data=d;const f=Symbol();t.$dump=f;const g=Symbol("extra");t.$extra=g;const p=Symbol();t.$finalize=p;const m=Symbol();t.$flushHTML=m;const b=Symbol();t.$getAttributeIt=b;const y=Symbol();t.$getAttributes=y;const w=Symbol();t.$getAvailableSpace=w;const x=Symbol();t.$getChildrenByClass=x;const S=Symbol();t.$getChildrenByName=S;const A=Symbol();t.$getChildrenByNameIt=A;const k=Symbol();t.$getDataValue=k;const C=Symbol();t.$getExtra=C;const v=Symbol();t.$getRealChildrenByNameIt=v;const F=Symbol();t.$getChildren=F;const O=Symbol();t.$getContainedChildren=O;const I=Symbol();t.$getNextPage=I;const T=Symbol();t.$getSubformParent=T;const M=Symbol();t.$getParent=M;const P=Symbol();t.$getTemplateRoot=P;const N=Symbol();t.$globalData=N;const D=Symbol();t.$hasSettableValue=D;const R=Symbol();t.$ids=R;const E=Symbol();t.$indexOf=E;const B=Symbol();t.$insertAt=B;const $=Symbol();t.$isCDATAXml=$;const L=Symbol();t.$isBindable=L;const _=Symbol();t.$isDataValue=_;const j=Symbol();t.$isDescendent=j;const U=Symbol();t.$isNsAgnostic=U;const X=Symbol();t.$isSplittable=X;const H=Symbol();t.$isThereMoreWidth=H;const q=Symbol();t.$isTransparent=q;const z=Symbol();t.$isUsable=z;const G=Symbol();t.$lastAttribute=G;const W=Symbol("namespaceId");t.$namespaceId=W;const V=Symbol("nodeName");t.$nodeName=V;const K=Symbol();t.$nsAttributes=K;const Y=Symbol();t.$onChild=Y;const J=Symbol();t.$onChildCheck=J;const Z=Symbol();t.$onText=Z;const Q=Symbol();t.$pushGlyphs=Q;const ee=Symbol();t.$popPara=ee;const te=Symbol();t.$pushPara=te;const ae=Symbol();t.$removeChild=ae;const ne=Symbol("root");t.$root=ne;const re=Symbol();t.$resolvePrototypes=re;const ie=Symbol();t.$searchNode=ie;const se=Symbol();t.$setId=se;const oe=Symbol();t.$setSetAttributes=oe;const ce=Symbol();t.$setValue=ce;const le=Symbol();t.$tabIndex=le;const he=Symbol();t.$text=he;const ue=Symbol();t.$toPages=ue;const de=Symbol();t.$toHTML=de;const fe=Symbol();t.$toString=fe;const ge=Symbol();t.$toStyle=ge;const pe=Symbol("uid");t.$uid=pe},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Binder=void 0;var n=a(78),r=a(80),i=a(88),s=a(87),o=a(81),c=a(2);const l=o.NamespaceIds.datasets.id;function h(e){const t=new r.Text({});return t[n.$content]=e,t}t.Binder=class{constructor(e){this.root=e,this.datasets=e.datasets,this.data=e.datasets?.data||new s.XmlObject(o.NamespaceIds.datasets.id,"data"),this.emptyMerge=0===this.data[n.$getChildren]().length,this.root.form=this.form=e.template[n.$clone]()}_isConsumeData(){return!this.emptyMerge&&this._mergeMode}_isMatchTemplate(){return!this._isConsumeData()}bind(){return this._bindElement(this.form,this.data),this.form}getData(){return this.data}_bindValue(e,t,a){if(e[n.$data]=t,e[n.$hasSettableValue]())if(t[n.$isDataValue]()){const a=t[n.$getDataValue]();e[n.$setValue](h(a))}else if(e instanceof r.Field&&"multiSelect"===e.ui?.choiceList?.open){const a=t[n.$getChildren]().map((e=>e[n.$content].trim())).join("\n");e[n.$setValue](h(a))}else this._isConsumeData()&&(0,c.warn)("XFA - Nodes haven't the same type.");else!t[n.$isDataValue]()||this._isMatchTemplate()?this._bindElement(e,t):(0,c.warn)("XFA - Nodes haven't the same type.")}_findDataByNameToConsume(e,t,a,r){if(!e)return null;let i,s;for(let r=0;r<3;r++){for(i=a[n.$getRealChildrenByNameIt](e,!1,!0);s=i.next().value,s;)if(t===s[n.$isDataValue]())return s;if(a[n.$namespaceId]===o.NamespaceIds.datasets.id&&"data"===a[n.$nodeName])break;a=a[n.$getParent]()}return r?(i=this.data[n.$getRealChildrenByNameIt](e,!0,!1),s=i.next().value,s||(i=this.data[n.$getAttributeIt](e,!0),s=i.next().value,s?.[n.$isDataValue]()?s:null)):null}_setProperties(e,t){if(e.hasOwnProperty("setProperty"))for(const{ref:a,target:o,connection:l}of e.setProperty.children){if(l)continue;if(!a)continue;const h=(0,i.searchNode)(this.root,t,a,!1,!1);if(!h){(0,c.warn)(`XFA - Invalid reference: ${a}.`);continue}const[u]=h;if(!u[n.$isDescendent](this.data)){(0,c.warn)("XFA - Invalid node: must be a data node.");continue}const d=(0,i.searchNode)(this.root,e,o,!1,!1);if(!d){(0,c.warn)(`XFA - Invalid target: ${o}.`);continue}const[f]=d;if(!f[n.$isDescendent](e)){(0,c.warn)("XFA - Invalid target: must be a property or subproperty.");continue}const g=f[n.$getParent]();if(f instanceof r.SetProperty||g instanceof r.SetProperty){(0,c.warn)("XFA - Invalid target: cannot be a setProperty or one of its properties.");continue}if(f instanceof r.BindItems||g instanceof r.BindItems){(0,c.warn)("XFA - Invalid target: cannot be a bindItems or one of its properties.");continue}const p=u[n.$text](),m=f[n.$nodeName];if(f instanceof s.XFAAttribute){const e=Object.create(null);e[m]=p;const t=Reflect.construct(Object.getPrototypeOf(g).constructor,[e]);g[m]=t[m]}else f.hasOwnProperty(n.$content)?(f[n.$data]=u,f[n.$content]=p,f[n.$finalize]()):(0,c.warn)("XFA - Invalid node to use in setProperty")}}_bindItems(e,t){if(!e.hasOwnProperty("items")||!e.hasOwnProperty("bindItems")||e.bindItems.isEmpty())return;for(const t of e.items.children)e[n.$removeChild](t);e.items.clear();const a=new r.Items({}),s=new r.Items({});e[n.$appendChild](a),e.items.push(a),e[n.$appendChild](s),e.items.push(s);for(const{ref:r,labelRef:o,valueRef:l,connection:u}of e.bindItems.children){if(u)continue;if(!r)continue;const e=(0,i.searchNode)(this.root,t,r,!1,!1);if(e)for(const t of e){if(!t[n.$isDescendent](this.datasets)){(0,c.warn)(`XFA - Invalid ref (${r}): must be a datasets child.`);continue}const e=(0,i.searchNode)(this.root,t,o,!0,!1);if(!e){(0,c.warn)(`XFA - Invalid label: ${o}.`);continue}const[u]=e;if(!u[n.$isDescendent](this.datasets)){(0,c.warn)("XFA - Invalid label: must be a datasets child.");continue}const d=(0,i.searchNode)(this.root,t,l,!0,!1);if(!d){(0,c.warn)(`XFA - Invalid value: ${l}.`);continue}const[f]=d;if(!f[n.$isDescendent](this.datasets)){(0,c.warn)("XFA - Invalid value: must be a datasets child.");continue}const g=h(u[n.$text]()),p=h(f[n.$text]());a[n.$appendChild](g),a.text.push(g),s[n.$appendChild](p),s.text.push(p)}else(0,c.warn)(`XFA - Invalid reference: ${r}.`)}}_bindOccurrences(e,t,a){let r;if(t.length>1&&(r=e[n.$clone](),r[n.$removeChild](r.occur),r.occur=null),this._bindValue(e,t[0],a),this._setProperties(e,t[0]),this._bindItems(e,t[0]),1===t.length)return;const i=e[n.$getParent](),s=e[n.$nodeName],o=i[n.$indexOf](e);for(let e=1,c=t.length;e<c;e++){const c=t[e],l=r[n.$clone]();i[s].push(l),i[n.$insertAt](o+e,l),this._bindValue(l,c,a),this._setProperties(l,c),this._bindItems(l,c)}}_createOccurrences(e){if(!this.emptyMerge)return;const{occur:t}=e;if(!t||t.initial<=1)return;const a=e[n.$getParent](),r=e[n.$nodeName];if(!(a[r]instanceof s.XFAObjectArray))return;let i;i=e.name?a[r].children.filter((t=>t.name===e.name)).length:a[r].children.length;const o=a[n.$indexOf](e)+1,c=t.initial-i;if(c){const t=e[n.$clone]();t[n.$removeChild](t.occur),t.occur=null,a[r].push(t),a[n.$insertAt](o,t);for(let e=1;e<c;e++){const i=t[n.$clone]();a[r].push(i),a[n.$insertAt](o+e,i)}}}_getOccurInfo(e){const{name:t,occur:a}=e;if(!a||!t)return[1,1];const n=-1===a.max?1/0:a.max;return[a.min,n]}_setAndBind(e,t){this._setProperties(e,t),this._bindItems(e,t),this._bindElement(e,t)}_bindElement(e,t){const a=[];this._createOccurrences(e);for(const r of e[n.$getChildren]()){if(r[n.$data])continue;if(void 0===this._mergeMode&&"subform"===r[n.$nodeName]){this._mergeMode="consumeData"===r.mergeMode;const e=t[n.$getChildren]();if(e.length>0)this._bindOccurrences(r,[e[0]],null);else if(this.emptyMerge){const e=t[n.$namespaceId]===l?-1:t[n.$namespaceId],a=r[n.$data]=new s.XmlObject(e,r.name||"root");t[n.$appendChild](a),this._bindElement(r,a)}continue}if(!r[n.$isBindable]())continue;let e=!1,o=null,h=null,u=null;if(r.bind){switch(r.bind.match){case"none":this._setAndBind(r,t);continue;case"global":e=!0;break;case"dataRef":if(!r.bind.ref){(0,c.warn)(`XFA - ref is empty in node ${r[n.$nodeName]}.`),this._setAndBind(r,t);continue}h=r.bind.ref}r.bind.picture&&(o=r.bind.picture[n.$content])}const[d,f]=this._getOccurInfo(r);if(h){if(u=(0,i.searchNode)(this.root,t,h,!0,!1),null===u){if(u=(0,i.createDataNode)(this.data,t,h),!u)continue;this._isConsumeData()&&(u[n.$consumed]=!0),this._setAndBind(r,u);continue}this._isConsumeData()&&(u=u.filter((e=>!e[n.$consumed]))),u.length>f?u=u.slice(0,f):0===u.length&&(u=null),u&&this._isConsumeData()&&u.forEach((e=>{e[n.$consumed]=!0}))}else{if(!r.name){this._setAndBind(r,t);continue}if(this._isConsumeData()){const a=[];for(;a.length<f;){const i=this._findDataByNameToConsume(r.name,r[n.$hasSettableValue](),t,e);if(!i)break;i[n.$consumed]=!0,a.push(i)}u=a.length>0?a:null}else{if(u=t[n.$getRealChildrenByNameIt](r.name,!1,this.emptyMerge).next().value,!u){if(0===d){a.push(r);continue}const e=t[n.$namespaceId]===l?-1:t[n.$namespaceId];u=r[n.$data]=new s.XmlObject(e,r.name),this.emptyMerge&&(u[n.$consumed]=!0),t[n.$appendChild](u),this._setAndBind(r,u);continue}this.emptyMerge&&(u[n.$consumed]=!0),u=[u]}}u?this._bindOccurrences(r,u,o):d>0?this._setAndBind(r,t):a.push(r)}a.forEach((e=>e[n.$getParent]()[n.$removeChild](e)))}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Value=t.Text=t.TemplateNamespace=t.Template=t.SetProperty=t.Items=t.Field=t.BindItems=void 0;var n=a(78),r=a(81),i=a(82),s=a(83),o=a(87),c=a(84),l=a(2),h=a(85),u=a(3),d=a(88);const f=r.NamespaceIds.template.id,g="http://www.w3.org/2000/svg",p=/^H(\d+)$/,m=new Set(["image/gif","image/jpeg","image/jpg","image/pjpeg","image/png","image/apng","image/x-png","image/bmp","image/x-ms-bmp","image/tiff","image/tif","application/octet-stream"]),b=[[[66,77],"image/bmp"],[[255,216,255],"image/jpeg"],[[73,73,42,0],"image/tiff"],[[77,77,0,42],"image/tiff"],[[71,73,70,56,57,97],"image/gif"],[[137,80,78,71,13,10,26,10],"image/png"]];function y(e){if(!e||!e.border)return{w:0,h:0};const t=e.border[n.$getExtra]();return t?{w:t.widths[0]+t.widths[2]+t.insets[0]+t.insets[2],h:t.widths[1]+t.widths[3]+t.insets[1]+t.insets[3]}:{w:0,h:0}}function w(e){return e.margin&&(e.margin.topInset||e.margin.rightInset||e.margin.bottomInset||e.margin.leftInset)}function x(e,t){if(!e.value){const t=new Rt({});e[n.$appendChild](t),e.value=t}e.value[n.$setValue](t)}function*S(e){for(const t of e[n.$getChildren]())t instanceof xt?yield*t[n.$getContainedChildren]():yield t}function A(e){return"error"===e.validate?.nullTest}function k(e){for(;e;){if(!e.traversal)return void(e[n.$tabIndex]=e[n.$getParent]()[n.$tabIndex]);if(e[n.$tabIndex])return;let t=null;for(const a of e.traversal[n.$getChildren]())if("next"===a.operation){t=a;break}if(!t||!t.ref)return void(e[n.$tabIndex]=e[n.$getParent]()[n.$tabIndex]);const a=e[n.$getTemplateRoot]();e[n.$tabIndex]=++a[n.$tabIndex];const r=a[n.$searchNode](t.ref,e);if(!r)return;e=r[0]}}function C(e,t){const a=e.assist;if(a){const e=a[n.$toHTML]();e&&(t.title=e);const r=a.role.match(p);if(r){const e="heading",a=r[1];t.role=e,t["aria-level"]=a}}if("table"===e.layout)t.role="table";else if("row"===e.layout)t.role="row";else{const a=e[n.$getParent]();"row"===a.layout&&(t.role="TH"===a.assist?.role?"columnheader":"cell")}}function v(e){if(!e.assist)return null;const t=e.assist;return t.speak&&""!==t.speak[n.$content]?t.speak[n.$content]:t.toolTip?t.toolTip[n.$content]:null}function F(e){return c.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:Object.create(null)},children:[{name:"span",attributes:{style:Object.create(null)},value:e}]})}function O(e){const t=e[n.$getTemplateRoot]();null===t[n.$extra].firstUnsplittable&&(t[n.$extra].firstUnsplittable=e,t[n.$extra].noLayoutFailure=!0)}function I(e){const t=e[n.$getTemplateRoot]();t[n.$extra].firstUnsplittable===e&&(t[n.$extra].noLayoutFailure=!1)}function T(e){if(e[n.$extra])return!1;if(e[n.$extra]=Object.create(null),"auto"===e.targetType)return!1;const t=e[n.$getTemplateRoot]();let a=null;if(e.target){if(a=t[n.$searchNode](e.target,e[n.$getParent]()),!a)return!1;a=a[0]}const{currentPageArea:r,currentContentArea:i}=t[n.$extra];if("pageArea"===e.targetType)return a instanceof Qe||(a=null),e.startNew?(e[n.$extra].target=a||r,!0):!(!a||a===r)&&(e[n.$extra].target=a,!0);a instanceof ee||(a=null);const s=a&&a[n.$getParent]();let o,c=s;if(e.startNew)if(a){const e=s.contentArea.children,t=e.indexOf(i),n=e.indexOf(a);-1!==t&&t<n&&(c=null),o=n-1}else o=r.contentArea.children.indexOf(i);else{if(!a||a===i)return!1;o=s.contentArea.children.indexOf(a)-1,c=s===r?null:s}return e[n.$extra].target=c,e[n.$extra].index=o,!0}function M(e,t,a){const r=e[n.$getTemplateRoot](),i=r[n.$extra].noLayoutFailure,s=t[n.$getSubformParent];t[n.$getSubformParent]=()=>e,r[n.$extra].noLayoutFailure=!0;const o=t[n.$toHTML](a);e[n.$addHTML](o.html,o.bbox),r[n.$extra].noLayoutFailure=i,t[n.$getSubformParent]=s}class P extends o.StringObject{constructor(e){super(f,"appearanceFilter"),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||""}}class N extends o.XFAObject{constructor(e){super(f,"arc",!0),this.circular=(0,c.getInteger)({data:e.circular,defaultValue:0,validate:e=>1===e}),this.hand=(0,c.getStringOption)(e.hand,["even","left","right"]),this.id=e.id||"",this.startAngle=(0,c.getFloat)({data:e.startAngle,defaultValue:0,validate:e=>!0}),this.sweepAngle=(0,c.getFloat)({data:e.sweepAngle,defaultValue:360,validate:e=>!0}),this.use=e.use||"",this.usehref=e.usehref||"",this.edge=null,this.fill=null}[n.$toHTML](){const e=this.edge||new ue({}),t=e[n.$toStyle](),a=Object.create(null);let r;"visible"===this.fill?.presence?Object.assign(a,this.fill[n.$toStyle]()):a.fill="transparent",a.strokeWidth=(0,s.measureToString)("visible"===e.presence?e.thickness:0),a.stroke=t.color;const i={xmlns:g,style:{width:"100%",height:"100%",overflow:"visible"}};if(360===this.sweepAngle)r={name:"ellipse",attributes:{xmlns:g,cx:"50%",cy:"50%",rx:"50%",ry:"50%",style:a}};else{const e=this.startAngle*Math.PI/180,t=this.sweepAngle*Math.PI/180,n=this.sweepAngle>180?1:0,[s,o,c,l]=[50*(1+Math.cos(e)),50*(1-Math.sin(e)),50*(1+Math.cos(e+t)),50*(1-Math.sin(e+t))];r={name:"path",attributes:{xmlns:g,d:`M ${s} ${o} A 50 50 0 ${n} 0 ${c} ${l}`,vectorEffect:"non-scaling-stroke",style:a}},Object.assign(i,{viewBox:"0 0 100 100",preserveAspectRatio:"none"})}const o={name:"svg",children:[r],attributes:i};return w(this[n.$getParent]()[n.$getParent]())?c.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[o]}):(o.attributes.style.position="absolute",c.HTMLResult.success(o))}}class D extends o.XFAObject{constructor(e){super(f,"area",!0),this.colSpan=(0,c.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e}),this.id=e.id||"",this.name=e.name||"",this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.desc=null,this.extras=null,this.area=new o.XFAObjectArray,this.draw=new o.XFAObjectArray,this.exObject=new o.XFAObjectArray,this.exclGroup=new o.XFAObjectArray,this.field=new o.XFAObjectArray,this.subform=new o.XFAObjectArray,this.subformSet=new o.XFAObjectArray}*[n.$getContainedChildren](){yield*S(this)}[n.$isTransparent](){return!0}[n.$isBindable](){return!0}[n.$addHTML](e,t){const[a,r,i,s]=t;this[n.$extra].width=Math.max(this[n.$extra].width,a+i),this[n.$extra].height=Math.max(this[n.$extra].height,r+s),this[n.$extra].children.push(e)}[n.$getAvailableSpace](){return this[n.$extra].availableSpace}[n.$toHTML](e){const t=(0,s.toStyle)(this,"position"),a={style:t,id:this[n.$uid],class:["xfaArea"]};(0,s.isPrintOnly)(this)&&a.class.push("xfaPrintOnly"),this.name&&(a.xfaName=this.name);const r=[];this[n.$extra]={children:r,width:0,height:0,availableSpace:e};const i=this[n.$childrenToHTML]({filter:new Set(["area","draw","field","exclGroup","subform","subformSet"]),include:!0});if(!i.success)return i.isBreak()?i:(delete this[n.$extra],c.HTMLResult.FAILURE);t.width=(0,s.measureToString)(this[n.$extra].width),t.height=(0,s.measureToString)(this[n.$extra].height);const o={name:"div",attributes:a,children:r},l=[this.x,this.y,this[n.$extra].width,this[n.$extra].height];return delete this[n.$extra],c.HTMLResult.success(o,l)}}class R extends o.XFAObject{constructor(e){super(f,"assist",!0),this.id=e.id||"",this.role=e.role||"",this.use=e.use||"",this.usehref=e.usehref||"",this.speak=null,this.toolTip=null}[n.$toHTML](){return this.toolTip?.[n.$content]||null}}class E extends o.XFAObject{constructor(e){super(f,"barcode",!0),this.charEncoding=(0,c.getKeyword)({data:e.charEncoding?e.charEncoding.toLowerCase():"",defaultValue:"",validate:e=>["utf-8","big-five","fontspecific","gbk","gb-18030","gb-2312","ksc-5601","none","shift-jis","ucs-2","utf-16"].includes(e)||e.match(/iso-8859-\d{2}/)}),this.checksum=(0,c.getStringOption)(e.checksum,["none","1mod10","1mod10_1mod11","2mod10","auto"]),this.dataColumnCount=(0,c.getInteger)({data:e.dataColumnCount,defaultValue:-1,validate:e=>e>=0}),this.dataLength=(0,c.getInteger)({data:e.dataLength,defaultValue:-1,validate:e=>e>=0}),this.dataPrep=(0,c.getStringOption)(e.dataPrep,["none","flateCompress"]),this.dataRowCount=(0,c.getInteger)({data:e.dataRowCount,defaultValue:-1,validate:e=>e>=0}),this.endChar=e.endChar||"",this.errorCorrectionLevel=(0,c.getInteger)({data:e.errorCorrectionLevel,defaultValue:-1,validate:e=>e>=0&&e<=8}),this.id=e.id||"",this.moduleHeight=(0,c.getMeasurement)(e.moduleHeight,"5mm"),this.moduleWidth=(0,c.getMeasurement)(e.moduleWidth,"0.25mm"),this.printCheckDigit=(0,c.getInteger)({data:e.printCheckDigit,defaultValue:0,validate:e=>1===e}),this.rowColumnRatio=(0,c.getRatio)(e.rowColumnRatio),this.startChar=e.startChar||"",this.textLocation=(0,c.getStringOption)(e.textLocation,["below","above","aboveEmbedded","belowEmbedded","none"]),this.truncate=(0,c.getInteger)({data:e.truncate,defaultValue:0,validate:e=>1===e}),this.type=(0,c.getStringOption)(e.type?e.type.toLowerCase():"",["aztec","codabar","code2of5industrial","code2of5interleaved","code2of5matrix","code2of5standard","code3of9","code3of9extended","code11","code49","code93","code128","code128a","code128b","code128c","code128sscc","datamatrix","ean8","ean8add2","ean8add5","ean13","ean13add2","ean13add5","ean13pwcd","fim","logmars","maxicode","msi","pdf417","pdf417macro","plessey","postauscust2","postauscust3","postausreplypaid","postausstandard","postukrm4scc","postusdpbc","postusimb","postusstandard","postus5zip","qrcode","rfid","rss14","rss14expanded","rss14limited","rss14stacked","rss14stackedomni","rss14truncated","telepen","ucc128","ucc128random","ucc128sscc","upca","upcaadd2","upcaadd5","upcapwcd","upce","upceadd2","upceadd5","upcean2","upcean5","upsmaxicode"]),this.upsMode=(0,c.getStringOption)(e.upsMode,["usCarrier","internationalCarrier","secureSymbol","standardSymbol"]),this.use=e.use||"",this.usehref=e.usehref||"",this.wideNarrowRatio=(0,c.getRatio)(e.wideNarrowRatio),this.encrypt=null,this.extras=null}}class B extends o.XFAObject{constructor(e){super(f,"bind",!0),this.match=(0,c.getStringOption)(e.match,["once","dataRef","global","none"]),this.ref=e.ref||"",this.picture=null}}class $ extends o.XFAObject{constructor(e){super(f,"bindItems"),this.connection=e.connection||"",this.labelRef=e.labelRef||"",this.ref=e.ref||"",this.valueRef=e.valueRef||""}}t.BindItems=$;class L extends o.XFAObject{constructor(e){super(f,"bookend"),this.id=e.id||"",this.leader=e.leader||"",this.trailer=e.trailer||"",this.use=e.use||"",this.usehref=e.usehref||""}}class _ extends o.Option01{constructor(e){super(f,"boolean"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$toHTML](e){return F(1===this[n.$content]?"1":"0")}}class j extends o.XFAObject{constructor(e){super(f,"border",!0),this.break=(0,c.getStringOption)(e.break,["close","open"]),this.hand=(0,c.getStringOption)(e.hand,["even","left","right"]),this.id=e.id||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.corner=new o.XFAObjectArray(4),this.edge=new o.XFAObjectArray(4),this.extras=null,this.fill=null,this.margin=null}[n.$getExtra](){if(!this[n.$extra]){const e=this.edge.children.slice();if(e.length<4){const t=e.at(-1)||new ue({});for(let a=e.length;a<4;a++)e.push(t)}const t=e.map((e=>e.thickness)),a=[0,0,0,0];this.margin&&(a[0]=this.margin.topInset,a[1]=this.margin.rightInset,a[2]=this.margin.bottomInset,a[3]=this.margin.leftInset),this[n.$extra]={widths:t,insets:a,edges:e}}return this[n.$extra]}[n.$toStyle](){const{edges:e}=this[n.$getExtra](),t=e.map((e=>{const t=e[n.$toStyle]();return t.color||="#000000",t})),a=Object.create(null);if(this.margin&&Object.assign(a,this.margin[n.$toStyle]()),"visible"===this.fill?.presence&&Object.assign(a,this.fill[n.$toStyle]()),this.corner.children.some((e=>0!==e.radius))){const e=this.corner.children.map((e=>e[n.$toStyle]()));if(2===e.length||3===e.length){const t=e.at(-1);for(let a=e.length;a<4;a++)e.push(t)}a.borderRadius=e.map((e=>e.radius)).join(" ")}switch(this.presence){case"invisible":case"hidden":a.borderStyle="";break;case"inactive":a.borderStyle="none";break;default:a.borderStyle=t.map((e=>e.style)).join(" ")}return a.borderWidth=t.map((e=>e.width)).join(" "),a.borderColor=t.map((e=>e.color)).join(" "),a}}class U extends o.XFAObject{constructor(e){super(f,"break",!0),this.after=(0,c.getStringOption)(e.after,["auto","contentArea","pageArea","pageEven","pageOdd"]),this.afterTarget=e.afterTarget||"",this.before=(0,c.getStringOption)(e.before,["auto","contentArea","pageArea","pageEven","pageOdd"]),this.beforeTarget=e.beforeTarget||"",this.bookendLeader=e.bookendLeader||"",this.bookendTrailer=e.bookendTrailer||"",this.id=e.id||"",this.overflowLeader=e.overflowLeader||"",this.overflowTarget=e.overflowTarget||"",this.overflowTrailer=e.overflowTrailer||"",this.startNew=(0,c.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e}),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}}class X extends o.XFAObject{constructor(e){super(f,"breakAfter",!0),this.id=e.id||"",this.leader=e.leader||"",this.startNew=(0,c.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e}),this.target=e.target||"",this.targetType=(0,c.getStringOption)(e.targetType,["auto","contentArea","pageArea"]),this.trailer=e.trailer||"",this.use=e.use||"",this.usehref=e.usehref||"",this.script=null}}class H extends o.XFAObject{constructor(e){super(f,"breakBefore",!0),this.id=e.id||"",this.leader=e.leader||"",this.startNew=(0,c.getInteger)({data:e.startNew,defaultValue:0,validate:e=>1===e}),this.target=e.target||"",this.targetType=(0,c.getStringOption)(e.targetType,["auto","contentArea","pageArea"]),this.trailer=e.trailer||"",this.use=e.use||"",this.usehref=e.usehref||"",this.script=null}[n.$toHTML](e){return this[n.$extra]={},c.HTMLResult.FAILURE}}class q extends o.XFAObject{constructor(e){super(f,"button",!0),this.highlight=(0,c.getStringOption)(e.highlight,["inverted","none","outline","push"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}[n.$toHTML](e){const t=this[n.$getParent]()[n.$getParent](),a={name:"button",attributes:{id:this[n.$uid],class:["xfaButton"],style:{}},children:[]};for(const e of t.event.children){if("click"!==e.activity||!e.script)continue;const t=(0,u.recoverJsURL)(e.script[n.$content]);if(!t)continue;const r=(0,s.fixURL)(t.url);r&&a.children.push({name:"a",attributes:{id:"link"+this[n.$uid],href:r,newWindow:t.newWindow,class:["xfaLink"],style:{}},children:[]})}return c.HTMLResult.success(a)}}class z extends o.XFAObject{constructor(e){super(f,"calculate",!0),this.id=e.id||"",this.override=(0,c.getStringOption)(e.override,["disabled","error","ignore","warning"]),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.message=null,this.script=null}}class G extends o.XFAObject{constructor(e){super(f,"caption",!0),this.id=e.id||"",this.placement=(0,c.getStringOption)(e.placement,["left","bottom","inline","right","top"]),this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.reserve=Math.ceil((0,c.getMeasurement)(e.reserve)),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.font=null,this.margin=null,this.para=null,this.value=null}[n.$setValue](e){x(this,e)}[n.$getExtra](e){if(!this[n.$extra]){let{width:t,height:a}=e;switch(this.placement){case"left":case"right":case"inline":t=this.reserve<=0?t:this.reserve;break;case"top":case"bottom":a=this.reserve<=0?a:this.reserve}this[n.$extra]=(0,s.layoutNode)(this,{width:t,height:a})}return this[n.$extra]}[n.$toHTML](e){if(!this.value)return c.HTMLResult.EMPTY;this[n.$pushPara]();const t=this.value[n.$toHTML](e).html;if(!t)return this[n.$popPara](),c.HTMLResult.EMPTY;const a=this.reserve;if(this.reserve<=0){const{w:t,h:a}=this[n.$getExtra](e);switch(this.placement){case"left":case"right":case"inline":this.reserve=t;break;case"top":case"bottom":this.reserve=a}}const r=[];"string"==typeof t?r.push({name:"#text",value:t}):r.push(t);const i=(0,s.toStyle)(this,"font","margin","visibility");switch(this.placement){case"left":case"right":this.reserve>0&&(i.width=(0,s.measureToString)(this.reserve));break;case"top":case"bottom":this.reserve>0&&(i.height=(0,s.measureToString)(this.reserve))}return(0,s.setPara)(this,null,t),this[n.$popPara](),this.reserve=a,c.HTMLResult.success({name:"div",attributes:{style:i,class:["xfaCaption"]},children:r})}}class W extends o.StringObject{constructor(e){super(f,"certificate"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class V extends o.XFAObject{constructor(e){super(f,"certificates",!0),this.credentialServerPolicy=(0,c.getStringOption)(e.credentialServerPolicy,["optional","required"]),this.id=e.id||"",this.url=e.url||"",this.urlPolicy=e.urlPolicy||"",this.use=e.use||"",this.usehref=e.usehref||"",this.encryption=null,this.issuers=null,this.keyUsage=null,this.oids=null,this.signing=null,this.subjectDNs=null}}class K extends o.XFAObject{constructor(e){super(f,"checkButton",!0),this.id=e.id||"",this.mark=(0,c.getStringOption)(e.mark,["default","check","circle","cross","diamond","square","star"]),this.shape=(0,c.getStringOption)(e.shape,["square","round"]),this.size=(0,c.getMeasurement)(e.size,"10pt"),this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.extras=null,this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)("margin"),a=(0,s.measureToString)(this.size);let r,i,o;t.width=t.height=a;const l=this[n.$getParent]()[n.$getParent](),h=l.items.children.length&&l.items.children[0][n.$toHTML]().html||[],u={on:(void 0!==h[0]?h[0]:"on").toString(),off:(void 0!==h[1]?h[1]:"off").toString()},d=(l.value?.[n.$text]()||"off")===u.on||void 0,f=l[n.$getSubformParent](),g=l[n.$uid];let p;f instanceof Ae?(o=f[n.$uid],r="radio",i="xfaRadio",p=f[n.$data]?.[n.$uid]||f[n.$uid]):(r="checkbox",i="xfaCheckbox",p=l[n.$data]?.[n.$uid]||l[n.$uid]);const m={name:"input",attributes:{class:[i],style:t,fieldId:g,dataId:p,type:r,checked:d,xfaOn:u.on,xfaOff:u.off,"aria-label":v(l),"aria-required":!1}};return o&&(m.attributes.name=o),A(l)&&(m.attributes["aria-required"]=!0,m.attributes.required=!0),c.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[m]})}}class Y extends o.XFAObject{constructor(e){super(f,"choiceList",!0),this.commitOn=(0,c.getStringOption)(e.commitOn,["select","exit"]),this.id=e.id||"",this.open=(0,c.getStringOption)(e.open,["userControl","always","multiSelect","onEntry"]),this.textEntry=(0,c.getInteger)({data:e.textEntry,defaultValue:0,validate:e=>1===e}),this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.extras=null,this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","margin"),a=this[n.$getParent]()[n.$getParent](),r={fontSize:`calc(${a.font?.size||10}px * var(--scale-factor))`},i=[];if(a.items.children.length>0){const e=a.items;let t=0,s=0;2===e.children.length&&(t=e.children[0].save,s=1-t);const o=e.children[t][n.$toHTML]().html,c=e.children[s][n.$toHTML]().html;let l=!1;const h=a.value?.[n.$text]()||"";for(let e=0,t=o.length;e<t;e++){const t={name:"option",attributes:{value:c[e]||o[e],style:r},value:o[e]};c[e]===h&&(t.attributes.selected=l=!0),i.push(t)}l||i.splice(0,0,{name:"option",attributes:{hidden:!0,selected:!0},value:" "})}const o={class:["xfaSelect"],fieldId:a[n.$uid],dataId:a[n.$data]?.[n.$uid]||a[n.$uid],style:t,"aria-label":v(a),"aria-required":!1};return A(a)&&(o["aria-required"]=!0,o.required=!0),"multiSelect"===this.open&&(o.multiple=!0),c.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[{name:"select",children:i,attributes:o}]})}}class J extends o.XFAObject{constructor(e){super(f,"color",!0),this.cSpace=(0,c.getStringOption)(e.cSpace,["SRGB"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.value=e.value?(0,c.getColor)(e.value):"",this.extras=null}[n.$hasSettableValue](){return!1}[n.$toStyle](){return this.value?l.Util.makeHexColor(this.value.r,this.value.g,this.value.b):null}}class Z extends o.XFAObject{constructor(e){super(f,"comb"),this.id=e.id||"",this.numberOfCells=(0,c.getInteger)({data:e.numberOfCells,defaultValue:0,validate:e=>e>=0}),this.use=e.use||"",this.usehref=e.usehref||""}}class Q extends o.XFAObject{constructor(e){super(f,"connect",!0),this.connection=e.connection||"",this.id=e.id||"",this.ref=e.ref||"",this.usage=(0,c.getStringOption)(e.usage,["exportAndImport","exportOnly","importOnly"]),this.use=e.use||"",this.usehref=e.usehref||"",this.picture=null}}class ee extends o.XFAObject{constructor(e){super(f,"contentArea",!0),this.h=(0,c.getMeasurement)(e.h),this.id=e.id||"",this.name=e.name||"",this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.w=(0,c.getMeasurement)(e.w),this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.desc=null,this.extras=null}[n.$toHTML](e){const t={left:(0,s.measureToString)(this.x),top:(0,s.measureToString)(this.y),width:(0,s.measureToString)(this.w),height:(0,s.measureToString)(this.h)},a=["xfaContentarea"];return(0,s.isPrintOnly)(this)&&a.push("xfaPrintOnly"),c.HTMLResult.success({name:"div",children:[],attributes:{style:t,class:a,id:this[n.$uid]}})}}class te extends o.XFAObject{constructor(e){super(f,"corner",!0),this.id=e.id||"",this.inverted=(0,c.getInteger)({data:e.inverted,defaultValue:0,validate:e=>1===e}),this.join=(0,c.getStringOption)(e.join,["square","round"]),this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.radius=(0,c.getMeasurement)(e.radius),this.stroke=(0,c.getStringOption)(e.stroke,["solid","dashDot","dashDotDot","dashed","dotted","embossed","etched","lowered","raised"]),this.thickness=(0,c.getMeasurement)(e.thickness,"0.5pt"),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"visibility");return e.radius=(0,s.measureToString)("square"===this.join?0:this.radius),e}}class ae extends o.ContentObject{constructor(e){super(f,"date"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return F(this[n.$content]?this[n.$content].toString():"")}}class ne extends o.ContentObject{constructor(e){super(f,"dateTime"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return F(this[n.$content]?this[n.$content].toString():"")}}class re extends o.XFAObject{constructor(e){super(f,"dateTimeEdit",!0),this.hScrollPolicy=(0,c.getStringOption)(e.hScrollPolicy,["auto","off","on"]),this.id=e.id||"",this.picker=(0,c.getStringOption)(e.picker,["host","none"]),this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.comb=null,this.extras=null,this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin"),a=this[n.$getParent]()[n.$getParent](),r={name:"input",attributes:{type:"text",fieldId:a[n.$uid],dataId:a[n.$data]?.[n.$uid]||a[n.$uid],class:["xfaTextfield"],style:t,"aria-label":v(a),"aria-required":!1}};return A(a)&&(r.attributes["aria-required"]=!0,r.attributes.required=!0),c.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[r]})}}class ie extends o.ContentObject{constructor(e){super(f,"decimal"),this.fracDigits=(0,c.getInteger)({data:e.fracDigits,defaultValue:2,validate:e=>!0}),this.id=e.id||"",this.leadDigits=(0,c.getInteger)({data:e.leadDigits,defaultValue:-1,validate:e=>!0}),this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=parseFloat(this[n.$content].trim());this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return F(null!==this[n.$content]?this[n.$content].toString():"")}}class se extends o.XFAObject{constructor(e){super(f,"defaultUi",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}}class oe extends o.XFAObject{constructor(e){super(f,"desc",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.boolean=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.time=new o.XFAObjectArray}}class ce extends o.OptionObject{constructor(e){super(f,"digestMethod",["","SHA1","SHA256","SHA512","RIPEMD160"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||""}}class le extends o.XFAObject{constructor(e){super(f,"digestMethods",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.digestMethod=new o.XFAObjectArray}}class he extends o.XFAObject{constructor(e){super(f,"draw",!0),this.anchorType=(0,c.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]),this.colSpan=(0,c.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e}),this.h=e.h?(0,c.getMeasurement)(e.h):"",this.hAlign=(0,c.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]),this.id=e.id||"",this.locale=e.locale||"",this.maxH=(0,c.getMeasurement)(e.maxH,"0pt"),this.maxW=(0,c.getMeasurement)(e.maxW,"0pt"),this.minH=(0,c.getMeasurement)(e.minH,"0pt"),this.minW=(0,c.getMeasurement)(e.minW,"0pt"),this.name=e.name||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.relevant=(0,c.getRelevant)(e.relevant),this.rotate=(0,c.getInteger)({data:e.rotate,defaultValue:0,validate:e=>e%90==0}),this.use=e.use||"",this.usehref=e.usehref||"",this.w=e.w?(0,c.getMeasurement)(e.w):"",this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.assist=null,this.border=null,this.caption=null,this.desc=null,this.extras=null,this.font=null,this.keep=null,this.margin=null,this.para=null,this.traversal=null,this.ui=null,this.value=null,this.setProperty=new o.XFAObjectArray}[n.$setValue](e){x(this,e)}[n.$toHTML](e){if(k(this),"hidden"===this.presence||"inactive"===this.presence)return c.HTMLResult.EMPTY;(0,s.fixDimensions)(this),this[n.$pushPara]();const t=this.w,a=this.h,{w:r,h:o,isBroken:l}=(0,s.layoutNode)(this,e);if(r&&""===this.w){if(l&&this[n.$getSubformParent]()[n.$isThereMoreWidth]())return this[n.$popPara](),c.HTMLResult.FAILURE;this.w=r}if(o&&""===this.h&&(this.h=o),O(this),!(0,i.checkDimensions)(this,e))return this.w=t,this.h=a,this[n.$popPara](),c.HTMLResult.FAILURE;I(this);const h=(0,s.toStyle)(this,"font","hAlign","dimensions","position","presence","rotate","anchorType","border","margin");(0,s.setMinMaxDimensions)(this,h),h.margin&&(h.padding=h.margin,delete h.margin);const u=["xfaDraw"];this.font&&u.push("xfaFont"),(0,s.isPrintOnly)(this)&&u.push("xfaPrintOnly");const d={style:h,id:this[n.$uid],class:u};this.name&&(d.xfaName=this.name);const f={name:"div",attributes:d,children:[]};C(this,d);const g=(0,s.computeBbox)(this,f,e),p=this.value?this.value[n.$toHTML](e).html:null;return null===p?(this.w=t,this.h=a,this[n.$popPara](),c.HTMLResult.success((0,s.createWrapper)(this,f),g)):(f.children.push(p),(0,s.setPara)(this,h,p),this.w=t,this.h=a,this[n.$popPara](),c.HTMLResult.success((0,s.createWrapper)(this,f),g))}}class ue extends o.XFAObject{constructor(e){super(f,"edge",!0),this.cap=(0,c.getStringOption)(e.cap,["square","butt","round"]),this.id=e.id||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.stroke=(0,c.getStringOption)(e.stroke,["solid","dashDot","dashDotDot","dashed","dotted","embossed","etched","lowered","raised"]),this.thickness=(0,c.getMeasurement)(e.thickness,"0.5pt"),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"visibility");if(Object.assign(e,{linecap:this.cap,width:(0,s.measureToString)(this.thickness),color:this.color?this.color[n.$toStyle]():"#000000",style:""}),"visible"!==this.presence)e.style="none";else switch(this.stroke){case"solid":e.style="solid";break;case"dashDot":case"dashDotDot":case"dashed":e.style="dashed";break;case"dotted":e.style="dotted";break;case"embossed":e.style="ridge";break;case"etched":e.style="groove";break;case"lowered":e.style="inset";break;case"raised":e.style="outset"}return e}}class de extends o.OptionObject{constructor(e){super(f,"encoding",["adbe.x509.rsa_sha1","adbe.pkcs7.detached","adbe.pkcs7.sha1"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||""}}class fe extends o.XFAObject{constructor(e){super(f,"encodings",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.encoding=new o.XFAObjectArray}}class ge extends o.XFAObject{constructor(e){super(f,"encrypt",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.certificate=null}}class pe extends o.XFAObject{constructor(e){super(f,"encryptData",!0),this.id=e.id||"",this.operation=(0,c.getStringOption)(e.operation,["encrypt","decrypt"]),this.target=e.target||"",this.use=e.use||"",this.usehref=e.usehref||"",this.filter=null,this.manifest=null}}class me extends o.XFAObject{constructor(e){super(f,"encryption",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.certificate=new o.XFAObjectArray}}class be extends o.OptionObject{constructor(e){super(f,"encryptionMethod",["","AES256-CBC","TRIPLEDES-CBC","AES128-CBC","AES192-CBC"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||""}}class ye extends o.XFAObject{constructor(e){super(f,"encryptionMethods",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.encryptionMethod=new o.XFAObjectArray}}class we extends o.XFAObject{constructor(e){super(f,"event",!0),this.activity=(0,c.getStringOption)(e.activity,["click","change","docClose","docReady","enter","exit","full","indexChange","initialize","mouseDown","mouseEnter","mouseExit","mouseUp","postExecute","postOpen","postPrint","postSave","postSign","postSubmit","preExecute","preOpen","prePrint","preSave","preSign","preSubmit","ready","validationState"]),this.id=e.id||"",this.listen=(0,c.getStringOption)(e.listen,["refOnly","refAndDescendents"]),this.name=e.name||"",this.ref=e.ref||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.encryptData=null,this.execute=null,this.script=null,this.signData=null,this.submit=null}}class xe extends o.ContentObject{constructor(e){super(f,"exData"),this.contentType=e.contentType||"",this.href=e.href||"",this.id=e.id||"",this.maxLength=(0,c.getInteger)({data:e.maxLength,defaultValue:-1,validate:e=>e>=-1}),this.name=e.name||"",this.rid=e.rid||"",this.transferEncoding=(0,c.getStringOption)(e.transferEncoding,["none","base64","package"]),this.use=e.use||"",this.usehref=e.usehref||""}[n.$isCDATAXml](){return"text/html"===this.contentType}[n.$onChild](e){return("text/html"===this.contentType&&e[n.$namespaceId]===r.NamespaceIds.xhtml.id||"text/xml"===this.contentType)&&(this[n.$content]=e,!0)}[n.$toHTML](e){return"text/html"===this.contentType&&this[n.$content]?this[n.$content][n.$toHTML](e):c.HTMLResult.EMPTY}}class Se extends o.XFAObject{constructor(e){super(f,"exObject",!0),this.archive=e.archive||"",this.classId=e.classId||"",this.codeBase=e.codeBase||"",this.codeType=e.codeType||"",this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.boolean=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.exObject=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.time=new o.XFAObjectArray}}class Ae extends o.XFAObject{constructor(e){super(f,"exclGroup",!0),this.access=(0,c.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]),this.accessKey=e.accessKey||"",this.anchorType=(0,c.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]),this.colSpan=(0,c.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e}),this.h=e.h?(0,c.getMeasurement)(e.h):"",this.hAlign=(0,c.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]),this.id=e.id||"",this.layout=(0,c.getStringOption)(e.layout,["position","lr-tb","rl-row","rl-tb","row","table","tb"]),this.maxH=(0,c.getMeasurement)(e.maxH,"0pt"),this.maxW=(0,c.getMeasurement)(e.maxW,"0pt"),this.minH=(0,c.getMeasurement)(e.minH,"0pt"),this.minW=(0,c.getMeasurement)(e.minW,"0pt"),this.name=e.name||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.w=e.w?(0,c.getMeasurement)(e.w):"",this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.assist=null,this.bind=null,this.border=null,this.calculate=null,this.caption=null,this.desc=null,this.extras=null,this.margin=null,this.para=null,this.traversal=null,this.validate=null,this.connect=new o.XFAObjectArray,this.event=new o.XFAObjectArray,this.field=new o.XFAObjectArray,this.setProperty=new o.XFAObjectArray}[n.$isBindable](){return!0}[n.$hasSettableValue](){return!0}[n.$setValue](e){for(const t of this.field.children){if(!t.value){const e=new Rt({});t[n.$appendChild](e),t.value=e}t.value[n.$setValue](e)}}[n.$isThereMoreWidth](){return this.layout.endsWith("-tb")&&0===this[n.$extra].attempt&&this[n.$extra].numberInLine>0||this[n.$getParent]()[n.$isThereMoreWidth]()}[n.$isSplittable](){const e=this[n.$getSubformParent]();return!!e[n.$isSplittable]()&&(void 0!==this[n.$extra]._isSplittable?this[n.$extra]._isSplittable:"position"===this.layout||this.layout.includes("row")?(this[n.$extra]._isSplittable=!1,!1):(!e.layout?.endsWith("-tb")||0===e[n.$extra].numberInLine)&&(this[n.$extra]._isSplittable=!0,!0))}[n.$flushHTML](){return(0,i.flushHTML)(this)}[n.$addHTML](e,t){(0,i.addHTML)(this,e,t)}[n.$getAvailableSpace](){return(0,i.getAvailableSpace)(this)}[n.$toHTML](e){if(k(this),"hidden"===this.presence||"inactive"===this.presence||0===this.h||0===this.w)return c.HTMLResult.EMPTY;(0,s.fixDimensions)(this);const t=[],a={id:this[n.$uid],class:[]};(0,s.setAccess)(this,a.class),this[n.$extra]||(this[n.$extra]=Object.create(null)),Object.assign(this[n.$extra],{children:t,attributes:a,attempt:0,line:null,numberInLine:0,availableSpace:{width:Math.min(this.w||1/0,e.width),height:Math.min(this.h||1/0,e.height)},width:0,height:0,prevHeight:0,currentWidth:0});const r=this[n.$isSplittable]();if(r||O(this),!(0,i.checkDimensions)(this,e))return c.HTMLResult.FAILURE;const o=new Set(["field"]);if(this.layout.includes("row")){const e=this[n.$getSubformParent]().columnWidths;Array.isArray(e)&&e.length>0&&(this[n.$extra].columnWidths=e,this[n.$extra].currentColumn=0)}const l=(0,s.toStyle)(this,"anchorType","dimensions","position","presence","border","margin","hAlign"),h=["xfaExclgroup"],u=(0,s.layoutClass)(this);u&&h.push(u),(0,s.isPrintOnly)(this)&&h.push("xfaPrintOnly"),a.style=l,a.class=h,this.name&&(a.xfaName=this.name),this[n.$pushPara]();const d="lr-tb"===this.layout||"rl-tb"===this.layout,f=d?2:1;for(;this[n.$extra].attempt<f;this[n.$extra].attempt++){d&&1===this[n.$extra].attempt&&(this[n.$extra].numberInLine=0);const e=this[n.$childrenToHTML]({filter:o,include:!0});if(e.success)break;if(e.isBreak())return this[n.$popPara](),e;if(d&&0===this[n.$extra].attempt&&0===this[n.$extra].numberInLine&&!this[n.$getTemplateRoot]()[n.$extra].noLayoutFailure){this[n.$extra].attempt=f;break}}if(this[n.$popPara](),r||I(this),this[n.$extra].attempt===f)return r||delete this[n.$extra],c.HTMLResult.FAILURE;let g=0,p=0;this.margin&&(g=this.margin.leftInset+this.margin.rightInset,p=this.margin.topInset+this.margin.bottomInset);const m=Math.max(this[n.$extra].width+g,this.w||0),b=Math.max(this[n.$extra].height+p,this.h||0),y=[this.x,this.y,m,b];""===this.w&&(l.width=(0,s.measureToString)(m)),""===this.h&&(l.height=(0,s.measureToString)(b));const w={name:"div",attributes:a,children:t};return C(this,a),delete this[n.$extra],c.HTMLResult.success((0,s.createWrapper)(this,w),y)}}class ke extends o.XFAObject{constructor(e){super(f,"execute"),this.connection=e.connection||"",this.executeType=(0,c.getStringOption)(e.executeType,["import","remerge"]),this.id=e.id||"",this.runAt=(0,c.getStringOption)(e.runAt,["client","both","server"]),this.use=e.use||"",this.usehref=e.usehref||""}}class Ce extends o.XFAObject{constructor(e){super(f,"extras",!0),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||"",this.boolean=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.extras=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.time=new o.XFAObjectArray}}class ve extends o.XFAObject{constructor(e){super(f,"field",!0),this.access=(0,c.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]),this.accessKey=e.accessKey||"",this.anchorType=(0,c.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]),this.colSpan=(0,c.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e}),this.h=e.h?(0,c.getMeasurement)(e.h):"",this.hAlign=(0,c.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]),this.id=e.id||"",this.locale=e.locale||"",this.maxH=(0,c.getMeasurement)(e.maxH,"0pt"),this.maxW=(0,c.getMeasurement)(e.maxW,"0pt"),this.minH=(0,c.getMeasurement)(e.minH,"0pt"),this.minW=(0,c.getMeasurement)(e.minW,"0pt"),this.name=e.name||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.relevant=(0,c.getRelevant)(e.relevant),this.rotate=(0,c.getInteger)({data:e.rotate,defaultValue:0,validate:e=>e%90==0}),this.use=e.use||"",this.usehref=e.usehref||"",this.w=e.w?(0,c.getMeasurement)(e.w):"",this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.assist=null,this.bind=null,this.border=null,this.calculate=null,this.caption=null,this.desc=null,this.extras=null,this.font=null,this.format=null,this.items=new o.XFAObjectArray(2),this.keep=null,this.margin=null,this.para=null,this.traversal=null,this.ui=null,this.validate=null,this.value=null,this.bindItems=new o.XFAObjectArray,this.connect=new o.XFAObjectArray,this.event=new o.XFAObjectArray,this.setProperty=new o.XFAObjectArray}[n.$isBindable](){return!0}[n.$setValue](e){x(this,e)}[n.$toHTML](e){if(k(this),!this.ui){let e;switch(this.ui=new Nt({}),this.ui[n.$globalData]=this[n.$globalData],this[n.$appendChild](this.ui),this.items.children.length){case 0:e=new Ft({}),this.ui.textEdit=e;break;case 1:e=new K({}),this.ui.checkButton=e;break;case 2:e=new Y({}),this.ui.choiceList=e}this.ui[n.$appendChild](e)}if(!this.ui||"hidden"===this.presence||"inactive"===this.presence||0===this.h||0===this.w)return c.HTMLResult.EMPTY;this.caption&&delete this.caption[n.$extra],this[n.$pushPara]();const t=this.caption?this.caption[n.$toHTML](e).html:null,a=this.w,r=this.h;let o=0,l=0;this.margin&&(o=this.margin.leftInset+this.margin.rightInset,l=this.margin.topInset+this.margin.bottomInset);let u=null;if(""===this.w||""===this.h){let t=null,a=null,r=0,i=0;if(this.ui.checkButton)r=i=this.ui.checkButton.size;else{const{w:t,h:a}=(0,s.layoutNode)(this,e);null!==t?(r=t,i=a):i=(0,h.getMetrics)(this.font,!0).lineNoGap}if(u=y(this.ui[n.$getExtra]()),r+=u.w,i+=u.h,this.caption){const{w:s,h:o,isBroken:l}=this.caption[n.$getExtra](e);if(l&&this[n.$getSubformParent]()[n.$isThereMoreWidth]())return this[n.$popPara](),c.HTMLResult.FAILURE;switch(t=s,a=o,this.caption.placement){case"left":case"right":case"inline":t+=r;break;case"top":case"bottom":a+=i}}else t=r,a=i;t&&""===this.w&&(t+=o,this.w=Math.min(this.maxW<=0?1/0:this.maxW,this.minW+1<t?t:this.minW)),a&&""===this.h&&(a+=l,this.h=Math.min(this.maxH<=0?1/0:this.maxH,this.minH+1<a?a:this.minH))}if(this[n.$popPara](),(0,s.fixDimensions)(this),O(this),!(0,i.checkDimensions)(this,e))return this.w=a,this.h=r,this[n.$popPara](),c.HTMLResult.FAILURE;I(this);const d=(0,s.toStyle)(this,"font","dimensions","position","rotate","anchorType","presence","margin","hAlign");(0,s.setMinMaxDimensions)(this,d);const f=["xfaField"];this.font&&f.push("xfaFont"),(0,s.isPrintOnly)(this)&&f.push("xfaPrintOnly");const g={style:d,id:this[n.$uid],class:f};d.margin&&(d.padding=d.margin,delete d.margin),(0,s.setAccess)(this,f),this.name&&(g.xfaName=this.name);const p=[],m={name:"div",attributes:g,children:p};C(this,g);const b=this.border?this.border[n.$toStyle]():null,w=(0,s.computeBbox)(this,m,e),x=this.ui[n.$toHTML]().html;if(!x)return Object.assign(d,b),c.HTMLResult.success((0,s.createWrapper)(this,m),w);this[n.$tabIndex]&&(x.children?.[0]?x.children[0].attributes.tabindex=this[n.$tabIndex]:x.attributes.tabindex=this[n.$tabIndex]),x.attributes.style||(x.attributes.style=Object.create(null));let S=null;if(this.ui.button?(1===x.children.length&&([S]=x.children.splice(0,1)),Object.assign(x.attributes.style,b)):Object.assign(d,b),p.push(x),this.value)if(this.ui.imageEdit)x.children.push(this.value[n.$toHTML]().html);else if(!this.ui.button){let e="";if(this.value.exData)e=this.value.exData[n.$text]();else if(this.value.text)e=this.value.text[n.$getExtra]();else{const t=this.value[n.$toHTML]().html;null!==t&&(e=t.children[0].value)}this.ui.textEdit&&this.value.text?.maxChars&&(x.children[0].attributes.maxLength=this.value.text.maxChars),e&&(this.ui.numericEdit&&(e=parseFloat(e),e=isNaN(e)?"":e.toString()),"textarea"===x.children[0].name?x.children[0].attributes.textContent=e:x.children[0].attributes.value=e)}if(!this.ui.imageEdit&&x.children?.[0]&&this.h){u=u||y(this.ui[n.$getExtra]());let t=0;if(this.caption&&["top","bottom"].includes(this.caption.placement)){t=this.caption.reserve,t<=0&&(t=this.caption[n.$getExtra](e).h);const a=this.h-t-l-u.h;x.children[0].attributes.style.height=(0,s.measureToString)(a)}else x.children[0].attributes.style.height="100%"}if(S&&x.children.push(S),!t)return x.attributes.class&&x.attributes.class.push("xfaLeft"),this.w=a,this.h=r,c.HTMLResult.success((0,s.createWrapper)(this,m),w);if(this.ui.button)return d.padding&&delete d.padding,"div"===t.name&&(t.name="span"),x.children.push(t),c.HTMLResult.success(m,w);switch(this.ui.checkButton&&(t.attributes.class[0]="xfaCaptionForCheckButton"),x.attributes.class||(x.attributes.class=[]),x.children.splice(0,0,t),this.caption.placement){case"left":case"inline":x.attributes.class.push("xfaLeft");break;case"right":x.attributes.class.push("xfaRight");break;case"top":x.attributes.class.push("xfaTop");break;case"bottom":x.attributes.class.push("xfaBottom")}return this.w=a,this.h=r,c.HTMLResult.success((0,s.createWrapper)(this,m),w)}}t.Field=ve;class Fe extends o.XFAObject{constructor(e){super(f,"fill",!0),this.id=e.id||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null,this.linear=null,this.pattern=null,this.radial=null,this.solid=null,this.stipple=null}[n.$toStyle](){const e=this[n.$getParent](),t=e[n.$getParent]()[n.$getParent](),a=Object.create(null);let r="color",i=r;e instanceof j&&(r="background-color",i="background",t instanceof Nt&&(a.backgroundColor="white")),(e instanceof lt||e instanceof N)&&(r=i="fill",a.fill="white");for(const e of Object.getOwnPropertyNames(this)){if("extras"===e||"color"===e)continue;const t=this[e];if(!(t instanceof o.XFAObject))continue;const s=t[n.$toStyle](this.color);return s&&(a[s.startsWith("#")?r:i]=s),a}if(this.color?.value){const e=this.color[n.$toStyle]();a[e.startsWith("#")?r:i]=e}return a}}class Oe extends o.XFAObject{constructor(e){super(f,"filter",!0),this.addRevocationInfo=(0,c.getStringOption)(e.addRevocationInfo,["","required","optional","none"]),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||"",this.version=(0,c.getInteger)({data:this.version,defaultValue:5,validate:e=>e>=1&&e<=5}),this.appearanceFilter=null,this.certificates=null,this.digestMethods=null,this.encodings=null,this.encryptionMethods=null,this.handler=null,this.lockDocument=null,this.mdp=null,this.reasons=null,this.timeStamp=null}}class Ie extends o.ContentObject{constructor(e){super(f,"float"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=parseFloat(this[n.$content].trim());this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return F(null!==this[n.$content]?this[n.$content].toString():"")}}class Te extends o.XFAObject{constructor(e){super(f,"font",!0),this.baselineShift=(0,c.getMeasurement)(e.baselineShift),this.fontHorizontalScale=(0,c.getFloat)({data:e.fontHorizontalScale,defaultValue:100,validate:e=>e>=0}),this.fontVerticalScale=(0,c.getFloat)({data:e.fontVerticalScale,defaultValue:100,validate:e=>e>=0}),this.id=e.id||"",this.kerningMode=(0,c.getStringOption)(e.kerningMode,["none","pair"]),this.letterSpacing=(0,c.getMeasurement)(e.letterSpacing,"0"),this.lineThrough=(0,c.getInteger)({data:e.lineThrough,defaultValue:0,validate:e=>1===e||2===e}),this.lineThroughPeriod=(0,c.getStringOption)(e.lineThroughPeriod,["all","word"]),this.overline=(0,c.getInteger)({data:e.overline,defaultValue:0,validate:e=>1===e||2===e}),this.overlinePeriod=(0,c.getStringOption)(e.overlinePeriod,["all","word"]),this.posture=(0,c.getStringOption)(e.posture,["normal","italic"]),this.size=(0,c.getMeasurement)(e.size,"10pt"),this.typeface=e.typeface||"Courier",this.underline=(0,c.getInteger)({data:e.underline,defaultValue:0,validate:e=>1===e||2===e}),this.underlinePeriod=(0,c.getStringOption)(e.underlinePeriod,["all","word"]),this.use=e.use||"",this.usehref=e.usehref||"",this.weight=(0,c.getStringOption)(e.weight,["normal","bold"]),this.extras=null,this.fill=null}[n.$clean](e){super[n.$clean](e),this[n.$globalData].usedTypefaces.add(this.typeface)}[n.$toStyle](){const e=(0,s.toStyle)(this,"fill"),t=e.color;return t&&("#000000"===t?delete e.color:t.startsWith("#")||(e.background=t,e.backgroundClip="text",e.color="transparent")),this.baselineShift&&(e.verticalAlign=(0,s.measureToString)(this.baselineShift)),e.fontKerning="none"===this.kerningMode?"none":"normal",e.letterSpacing=(0,s.measureToString)(this.letterSpacing),0!==this.lineThrough&&(e.textDecoration="line-through",2===this.lineThrough&&(e.textDecorationStyle="double")),0!==this.overline&&(e.textDecoration="overline",2===this.overline&&(e.textDecorationStyle="double")),e.fontStyle=this.posture,e.fontSize=(0,s.measureToString)(.99*this.size),(0,s.setFontFamily)(this,this,this[n.$globalData].fontFinder,e),0!==this.underline&&(e.textDecoration="underline",2===this.underline&&(e.textDecorationStyle="double")),e.fontWeight=this.weight,e}}class Me extends o.XFAObject{constructor(e){super(f,"format",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.picture=null}}class Pe extends o.StringObject{constructor(e){super(f,"handler"),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||""}}class Ne extends o.XFAObject{constructor(e){super(f,"hyphenation"),this.excludeAllCaps=(0,c.getInteger)({data:e.excludeAllCaps,defaultValue:0,validate:e=>1===e}),this.excludeInitialCap=(0,c.getInteger)({data:e.excludeInitialCap,defaultValue:0,validate:e=>1===e}),this.hyphenate=(0,c.getInteger)({data:e.hyphenate,defaultValue:0,validate:e=>1===e}),this.id=e.id||"",this.pushCharacterCount=(0,c.getInteger)({data:e.pushCharacterCount,defaultValue:3,validate:e=>e>=0}),this.remainCharacterCount=(0,c.getInteger)({data:e.remainCharacterCount,defaultValue:3,validate:e=>e>=0}),this.use=e.use||"",this.usehref=e.usehref||"",this.wordCharacterCount=(0,c.getInteger)({data:e.wordCharacterCount,defaultValue:7,validate:e=>e>=0})}}class De extends o.StringObject{constructor(e){super(f,"image"),this.aspect=(0,c.getStringOption)(e.aspect,["fit","actual","height","none","width"]),this.contentType=e.contentType||"",this.href=e.href||"",this.id=e.id||"",this.name=e.name||"",this.transferEncoding=(0,c.getStringOption)(e.transferEncoding,["base64","none","package"]),this.use=e.use||"",this.usehref=e.usehref||""}[n.$toHTML](){if(this.contentType&&!m.has(this.contentType.toLowerCase()))return c.HTMLResult.EMPTY;let e=this[n.$globalData].images&&this[n.$globalData].images.get(this.href);if(!e&&(this.href||!this[n.$content]))return c.HTMLResult.EMPTY;if(e||"base64"!==this.transferEncoding||(e=(0,l.stringToBytes)(atob(this[n.$content]))),!e)return c.HTMLResult.EMPTY;if(!this.contentType){for(const[t,a]of b)if(e.length>t.length&&t.every(((t,a)=>t===e[a]))){this.contentType=a;break}if(!this.contentType)return c.HTMLResult.EMPTY}const t=new Blob([e],{type:this.contentType});let a;switch(this.aspect){case"fit":case"actual":break;case"height":a={height:"100%",objectFit:"fill"};break;case"none":a={width:"100%",height:"100%",objectFit:"fill"};break;case"width":a={width:"100%",objectFit:"fill"}}const r=this[n.$getParent]();return c.HTMLResult.success({name:"img",attributes:{class:["xfaImage"],style:a,src:URL.createObjectURL(t),alt:r?v(r[n.$getParent]()):null}})}}class Re extends o.XFAObject{constructor(e){super(f,"imageEdit",!0),this.data=(0,c.getStringOption)(e.data,["link","embed"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.extras=null,this.margin=null}[n.$toHTML](e){return"embed"===this.data?c.HTMLResult.success({name:"div",children:[],attributes:{}}):c.HTMLResult.EMPTY}}class Ee extends o.ContentObject{constructor(e){super(f,"integer"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=parseInt(this[n.$content].trim(),10);this[n.$content]=isNaN(e)?null:e}[n.$toHTML](e){return F(null!==this[n.$content]?this[n.$content].toString():"")}}class Be extends o.XFAObject{constructor(e){super(f,"issuers",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.certificate=new o.XFAObjectArray}}class $e extends o.XFAObject{constructor(e){super(f,"items",!0),this.id=e.id||"",this.name=e.name||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.ref=e.ref||"",this.save=(0,c.getInteger)({data:e.save,defaultValue:0,validate:e=>1===e}),this.use=e.use||"",this.usehref=e.usehref||"",this.boolean=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.time=new o.XFAObjectArray}[n.$toHTML](){const e=[];for(const t of this[n.$getChildren]())e.push(t[n.$text]());return c.HTMLResult.success(e)}}t.Items=$e;class Le extends o.XFAObject{constructor(e){super(f,"keep",!0),this.id=e.id||"";const t=["none","contentArea","pageArea"];this.intact=(0,c.getStringOption)(e.intact,t),this.next=(0,c.getStringOption)(e.next,t),this.previous=(0,c.getStringOption)(e.previous,t),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}}class _e extends o.XFAObject{constructor(e){super(f,"keyUsage");const t=["","yes","no"];this.crlSign=(0,c.getStringOption)(e.crlSign,t),this.dataEncipherment=(0,c.getStringOption)(e.dataEncipherment,t),this.decipherOnly=(0,c.getStringOption)(e.decipherOnly,t),this.digitalSignature=(0,c.getStringOption)(e.digitalSignature,t),this.encipherOnly=(0,c.getStringOption)(e.encipherOnly,t),this.id=e.id||"",this.keyAgreement=(0,c.getStringOption)(e.keyAgreement,t),this.keyCertSign=(0,c.getStringOption)(e.keyCertSign,t),this.keyEncipherment=(0,c.getStringOption)(e.keyEncipherment,t),this.nonRepudiation=(0,c.getStringOption)(e.nonRepudiation,t),this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||""}}class je extends o.XFAObject{constructor(e){super(f,"line",!0),this.hand=(0,c.getStringOption)(e.hand,["even","left","right"]),this.id=e.id||"",this.slope=(0,c.getStringOption)(e.slope,["\\","/"]),this.use=e.use||"",this.usehref=e.usehref||"",this.edge=null}[n.$toHTML](){const e=this[n.$getParent]()[n.$getParent](),t=this.edge||new ue({}),a=t[n.$toStyle](),r=Object.create(null),i="visible"===t.presence?t.thickness:0;let o,l,h,u;r.strokeWidth=(0,s.measureToString)(i),r.stroke=a.color;let d="100%",f="100%";e.w<=i?([o,l,h,u]=["50%",0,"50%","100%"],d=r.strokeWidth):e.h<=i?([o,l,h,u]=[0,"50%","100%","50%"],f=r.strokeWidth):"\\"===this.slope?[o,l,h,u]=[0,0,"100%","100%"]:[o,l,h,u]=[0,"100%","100%",0];const p={name:"svg",children:[{name:"line",attributes:{xmlns:g,x1:o,y1:l,x2:h,y2:u,style:r}}],attributes:{xmlns:g,width:d,height:f,style:{overflow:"visible"}}};return w(e)?c.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[p]}):(p.attributes.style.position="absolute",c.HTMLResult.success(p))}}class Ue extends o.XFAObject{constructor(e){super(f,"linear",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["toRight","toBottom","toLeft","toTop"]),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";return`linear-gradient(${this.type.replace(/([RBLT])/," $1").toLowerCase()}, ${e}, ${this.color?this.color[n.$toStyle]():"#000000"})`}}class Xe extends o.ContentObject{constructor(e){super(f,"lockDocument"),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){this[n.$content]=(0,c.getStringOption)(this[n.$content],["auto","0","1"])}}class He extends o.XFAObject{constructor(e){super(f,"manifest",!0),this.action=(0,c.getStringOption)(e.action,["include","all","exclude"]),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.ref=new o.XFAObjectArray}}class qe extends o.XFAObject{constructor(e){super(f,"margin",!0),this.bottomInset=(0,c.getMeasurement)(e.bottomInset,"0"),this.id=e.id||"",this.leftInset=(0,c.getMeasurement)(e.leftInset,"0"),this.rightInset=(0,c.getMeasurement)(e.rightInset,"0"),this.topInset=(0,c.getMeasurement)(e.topInset,"0"),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}[n.$toStyle](){return{margin:(0,s.measureToString)(this.topInset)+" "+(0,s.measureToString)(this.rightInset)+" "+(0,s.measureToString)(this.bottomInset)+" "+(0,s.measureToString)(this.leftInset)}}}class ze extends o.XFAObject{constructor(e){super(f,"mdp"),this.id=e.id||"",this.permissions=(0,c.getInteger)({data:e.permissions,defaultValue:2,validate:e=>1===e||3===e}),this.signatureType=(0,c.getStringOption)(e.signatureType,["filler","author"]),this.use=e.use||"",this.usehref=e.usehref||""}}class Ge extends o.XFAObject{constructor(e){super(f,"medium"),this.id=e.id||"",this.imagingBBox=(0,c.getBBox)(e.imagingBBox),this.long=(0,c.getMeasurement)(e.long),this.orientation=(0,c.getStringOption)(e.orientation,["portrait","landscape"]),this.short=(0,c.getMeasurement)(e.short),this.stock=e.stock||"",this.trayIn=(0,c.getStringOption)(e.trayIn,["auto","delegate","pageFront"]),this.trayOut=(0,c.getStringOption)(e.trayOut,["auto","delegate"]),this.use=e.use||"",this.usehref=e.usehref||""}}class We extends o.XFAObject{constructor(e){super(f,"message",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.text=new o.XFAObjectArray}}class Ve extends o.XFAObject{constructor(e){super(f,"numericEdit",!0),this.hScrollPolicy=(0,c.getStringOption)(e.hScrollPolicy,["auto","off","on"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.comb=null,this.extras=null,this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin"),a=this[n.$getParent]()[n.$getParent](),r={name:"input",attributes:{type:"text",fieldId:a[n.$uid],dataId:a[n.$data]?.[n.$uid]||a[n.$uid],class:["xfaTextfield"],style:t,"aria-label":v(a),"aria-required":!1}};return A(a)&&(r.attributes["aria-required"]=!0,r.attributes.required=!0),c.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[r]})}}class Ke extends o.XFAObject{constructor(e){super(f,"occur",!0),this.id=e.id||"",this.initial=""!==e.initial?(0,c.getInteger)({data:e.initial,defaultValue:"",validate:e=>!0}):"",this.max=""!==e.max?(0,c.getInteger)({data:e.max,defaultValue:1,validate:e=>!0}):"",this.min=""!==e.min?(0,c.getInteger)({data:e.min,defaultValue:1,validate:e=>!0}):"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}[n.$clean](){const e=this[n.$getParent](),t=this.min;""===this.min&&(this.min=e instanceof Qe||e instanceof et?0:1),""===this.max&&(this.max=""===t?e instanceof Qe||e instanceof et?-1:1:this.min),-1!==this.max&&this.max<this.min&&(this.max=this.min),""===this.initial&&(this.initial=e instanceof Ct?1:this.min)}}class Ye extends o.StringObject{constructor(e){super(f,"oid"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class Je extends o.XFAObject{constructor(e){super(f,"oids",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.oid=new o.XFAObjectArray}}class Ze extends o.XFAObject{constructor(e){super(f,"overflow"),this.id=e.id||"",this.leader=e.leader||"",this.target=e.target||"",this.trailer=e.trailer||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$getExtra](){if(!this[n.$extra]){const e=this[n.$getParent](),t=this[n.$getTemplateRoot](),a=t[n.$searchNode](this.target,e),r=t[n.$searchNode](this.leader,e),i=t[n.$searchNode](this.trailer,e);this[n.$extra]={target:a?.[0]||null,leader:r?.[0]||null,trailer:i?.[0]||null,addLeader:!1,addTrailer:!1}}return this[n.$extra]}}class Qe extends o.XFAObject{constructor(e){super(f,"pageArea",!0),this.blankOrNotBlank=(0,c.getStringOption)(e.blankOrNotBlank,["any","blank","notBlank"]),this.id=e.id||"",this.initialNumber=(0,c.getInteger)({data:e.initialNumber,defaultValue:1,validate:e=>!0}),this.name=e.name||"",this.numbered=(0,c.getInteger)({data:e.numbered,defaultValue:1,validate:e=>!0}),this.oddOrEven=(0,c.getStringOption)(e.oddOrEven,["any","even","odd"]),this.pagePosition=(0,c.getStringOption)(e.pagePosition,["any","first","last","only","rest"]),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.desc=null,this.extras=null,this.medium=null,this.occur=null,this.area=new o.XFAObjectArray,this.contentArea=new o.XFAObjectArray,this.draw=new o.XFAObjectArray,this.exclGroup=new o.XFAObjectArray,this.field=new o.XFAObjectArray,this.subform=new o.XFAObjectArray}[n.$isUsable](){return this[n.$extra]?!this.occur||-1===this.occur.max||this[n.$extra].numberOfUse<this.occur.max:(this[n.$extra]={numberOfUse:0},!0)}[n.$cleanPage](){delete this[n.$extra]}[n.$getNextPage](){this[n.$extra]||(this[n.$extra]={numberOfUse:0});const e=this[n.$getParent]();return"orderedOccurrence"===e.relation&&this[n.$isUsable]()?(this[n.$extra].numberOfUse+=1,this):e[n.$getNextPage]()}[n.$getAvailableSpace](){return this[n.$extra].space||{width:0,height:0}}[n.$toHTML](){this[n.$extra]||(this[n.$extra]={numberOfUse:1});const e=[];this[n.$extra].children=e;const t=Object.create(null);if(this.medium&&this.medium.short&&this.medium.long){if(t.width=(0,s.measureToString)(this.medium.short),t.height=(0,s.measureToString)(this.medium.long),this[n.$extra].space={width:this.medium.short,height:this.medium.long},"landscape"===this.medium.orientation){const e=t.width;t.width=t.height,t.height=e,this[n.$extra].space={width:this.medium.long,height:this.medium.short}}}else(0,l.warn)("XFA - No medium specified in pageArea: please file a bug.");return this[n.$childrenToHTML]({filter:new Set(["area","draw","field","subform"]),include:!0}),this[n.$childrenToHTML]({filter:new Set(["contentArea"]),include:!0}),c.HTMLResult.success({name:"div",children:e,attributes:{class:["xfaPage"],id:this[n.$uid],style:t,xfaName:this.name}})}}class et extends o.XFAObject{constructor(e){super(f,"pageSet",!0),this.duplexImposition=(0,c.getStringOption)(e.duplexImposition,["longEdge","shortEdge"]),this.id=e.id||"",this.name=e.name||"",this.relation=(0,c.getStringOption)(e.relation,["orderedOccurrence","duplexPaginated","simplexPaginated"]),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.occur=null,this.pageArea=new o.XFAObjectArray,this.pageSet=new o.XFAObjectArray}[n.$cleanPage](){for(const e of this.pageArea.children)e[n.$cleanPage]();for(const e of this.pageSet.children)e[n.$cleanPage]()}[n.$isUsable](){return!this.occur||-1===this.occur.max||this[n.$extra].numberOfUse<this.occur.max}[n.$getNextPage](){if(this[n.$extra]||(this[n.$extra]={numberOfUse:1,pageIndex:-1,pageSetIndex:-1}),"orderedOccurrence"===this.relation){if(this[n.$extra].pageIndex+1<this.pageArea.children.length){this[n.$extra].pageIndex+=1;return this.pageArea.children[this[n.$extra].pageIndex][n.$getNextPage]()}if(this[n.$extra].pageSetIndex+1<this.pageSet.children.length)return this[n.$extra].pageSetIndex+=1,this.pageSet.children[this[n.$extra].pageSetIndex][n.$getNextPage]();if(this[n.$isUsable]())return this[n.$extra].numberOfUse+=1,this[n.$extra].pageIndex=-1,this[n.$extra].pageSetIndex=-1,this[n.$getNextPage]();const e=this[n.$getParent]();return e instanceof et?e[n.$getNextPage]():(this[n.$cleanPage](),this[n.$getNextPage]())}const e=this[n.$getTemplateRoot]()[n.$extra].pageNumber,t=e%2==0?"even":"odd",a=0===e?"first":"rest";let r=this.pageArea.children.find((e=>e.oddOrEven===t&&e.pagePosition===a));return r||(r=this.pageArea.children.find((e=>"any"===e.oddOrEven&&e.pagePosition===a)),r||(r=this.pageArea.children.find((e=>"any"===e.oddOrEven&&"any"===e.pagePosition)),r||this.pageArea.children[0]))}}class tt extends o.XFAObject{constructor(e){super(f,"para",!0),this.hAlign=(0,c.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]),this.id=e.id||"",this.lineHeight=e.lineHeight?(0,c.getMeasurement)(e.lineHeight,"0pt"):"",this.marginLeft=e.marginLeft?(0,c.getMeasurement)(e.marginLeft,"0pt"):"",this.marginRight=e.marginRight?(0,c.getMeasurement)(e.marginRight,"0pt"):"",this.orphans=(0,c.getInteger)({data:e.orphans,defaultValue:0,validate:e=>e>=0}),this.preserve=e.preserve||"",this.radixOffset=e.radixOffset?(0,c.getMeasurement)(e.radixOffset,"0pt"):"",this.spaceAbove=e.spaceAbove?(0,c.getMeasurement)(e.spaceAbove,"0pt"):"",this.spaceBelow=e.spaceBelow?(0,c.getMeasurement)(e.spaceBelow,"0pt"):"",this.tabDefault=e.tabDefault?(0,c.getMeasurement)(this.tabDefault):"",this.tabStops=(e.tabStops||"").trim().split(/\s+/).map(((e,t)=>t%2==1?(0,c.getMeasurement)(e):e)),this.textIndent=e.textIndent?(0,c.getMeasurement)(e.textIndent,"0pt"):"",this.use=e.use||"",this.usehref=e.usehref||"",this.vAlign=(0,c.getStringOption)(e.vAlign,["top","bottom","middle"]),this.widows=(0,c.getInteger)({data:e.widows,defaultValue:0,validate:e=>e>=0}),this.hyphenation=null}[n.$toStyle](){const e=(0,s.toStyle)(this,"hAlign");return""!==this.marginLeft&&(e.paddingLeft=(0,s.measureToString)(this.marginLeft)),""!==this.marginRight&&(e.paddingight=(0,s.measureToString)(this.marginRight)),""!==this.spaceAbove&&(e.paddingTop=(0,s.measureToString)(this.spaceAbove)),""!==this.spaceBelow&&(e.paddingBottom=(0,s.measureToString)(this.spaceBelow)),""!==this.textIndent&&(e.textIndent=(0,s.measureToString)(this.textIndent),(0,s.fixTextIndent)(e)),this.lineHeight>0&&(e.lineHeight=(0,s.measureToString)(this.lineHeight)),""!==this.tabDefault&&(e.tabSize=(0,s.measureToString)(this.tabDefault)),this.tabStops.length,this.hyphenatation&&Object.assign(e,this.hyphenatation[n.$toStyle]()),e}}class at extends o.XFAObject{constructor(e){super(f,"passwordEdit",!0),this.hScrollPolicy=(0,c.getStringOption)(e.hScrollPolicy,["auto","off","on"]),this.id=e.id||"",this.passwordChar=e.passwordChar||"*",this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.extras=null,this.margin=null}}class nt extends o.XFAObject{constructor(e){super(f,"pattern",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["crossHatch","crossDiagonal","diagonalLeft","diagonalRight","horizontal","vertical"]),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";const t=this.color?this.color[n.$toStyle]():"#000000",a="repeating-linear-gradient",r=`${e},${e} 5px,${t} 5px,${t} 10px`;switch(this.type){case"crossHatch":return`${a}(to top,${r}) ${a}(to right,${r})`;case"crossDiagonal":return`${a}(45deg,${r}) ${a}(-45deg,${r})`;case"diagonalLeft":return`${a}(45deg,${r})`;case"diagonalRight":return`${a}(-45deg,${r})`;case"horizontal":return`${a}(to top,${r})`;case"vertical":return`${a}(to right,${r})`}return""}}class rt extends o.StringObject{constructor(e){super(f,"picture"),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||""}}class it extends o.XFAObject{constructor(e){super(f,"proto",!0),this.appearanceFilter=new o.XFAObjectArray,this.arc=new o.XFAObjectArray,this.area=new o.XFAObjectArray,this.assist=new o.XFAObjectArray,this.barcode=new o.XFAObjectArray,this.bindItems=new o.XFAObjectArray,this.bookend=new o.XFAObjectArray,this.boolean=new o.XFAObjectArray,this.border=new o.XFAObjectArray,this.break=new o.XFAObjectArray,this.breakAfter=new o.XFAObjectArray,this.breakBefore=new o.XFAObjectArray,this.button=new o.XFAObjectArray,this.calculate=new o.XFAObjectArray,this.caption=new o.XFAObjectArray,this.certificate=new o.XFAObjectArray,this.certificates=new o.XFAObjectArray,this.checkButton=new o.XFAObjectArray,this.choiceList=new o.XFAObjectArray,this.color=new o.XFAObjectArray,this.comb=new o.XFAObjectArray,this.connect=new o.XFAObjectArray,this.contentArea=new o.XFAObjectArray,this.corner=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.dateTimeEdit=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.defaultUi=new o.XFAObjectArray,this.desc=new o.XFAObjectArray,this.digestMethod=new o.XFAObjectArray,this.digestMethods=new o.XFAObjectArray,this.draw=new o.XFAObjectArray,this.edge=new o.XFAObjectArray,this.encoding=new o.XFAObjectArray,this.encodings=new o.XFAObjectArray,this.encrypt=new o.XFAObjectArray,this.encryptData=new o.XFAObjectArray,this.encryption=new o.XFAObjectArray,this.encryptionMethod=new o.XFAObjectArray,this.encryptionMethods=new o.XFAObjectArray,this.event=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.exObject=new o.XFAObjectArray,this.exclGroup=new o.XFAObjectArray,this.execute=new o.XFAObjectArray,this.extras=new o.XFAObjectArray,this.field=new o.XFAObjectArray,this.fill=new o.XFAObjectArray,this.filter=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.font=new o.XFAObjectArray,this.format=new o.XFAObjectArray,this.handler=new o.XFAObjectArray,this.hyphenation=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.imageEdit=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.issuers=new o.XFAObjectArray,this.items=new o.XFAObjectArray,this.keep=new o.XFAObjectArray,this.keyUsage=new o.XFAObjectArray,this.line=new o.XFAObjectArray,this.linear=new o.XFAObjectArray,this.lockDocument=new o.XFAObjectArray,this.manifest=new o.XFAObjectArray,this.margin=new o.XFAObjectArray,this.mdp=new o.XFAObjectArray,this.medium=new o.XFAObjectArray,this.message=new o.XFAObjectArray,this.numericEdit=new o.XFAObjectArray,this.occur=new o.XFAObjectArray,this.oid=new o.XFAObjectArray,this.oids=new o.XFAObjectArray,this.overflow=new o.XFAObjectArray,this.pageArea=new o.XFAObjectArray,this.pageSet=new o.XFAObjectArray,this.para=new o.XFAObjectArray,this.passwordEdit=new o.XFAObjectArray,this.pattern=new o.XFAObjectArray,this.picture=new o.XFAObjectArray,this.radial=new o.XFAObjectArray,this.reason=new o.XFAObjectArray,this.reasons=new o.XFAObjectArray,this.rectangle=new o.XFAObjectArray,this.ref=new o.XFAObjectArray,this.script=new o.XFAObjectArray,this.setProperty=new o.XFAObjectArray,this.signData=new o.XFAObjectArray,this.signature=new o.XFAObjectArray,this.signing=new o.XFAObjectArray,this.solid=new o.XFAObjectArray,this.speak=new o.XFAObjectArray,this.stipple=new o.XFAObjectArray,this.subform=new o.XFAObjectArray,this.subformSet=new o.XFAObjectArray,this.subjectDN=new o.XFAObjectArray,this.subjectDNs=new o.XFAObjectArray,this.submit=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.textEdit=new o.XFAObjectArray,this.time=new o.XFAObjectArray,this.timeStamp=new o.XFAObjectArray,this.toolTip=new o.XFAObjectArray,this.traversal=new o.XFAObjectArray,this.traverse=new o.XFAObjectArray,this.ui=new o.XFAObjectArray,this.validate=new o.XFAObjectArray,this.value=new o.XFAObjectArray,this.variables=new o.XFAObjectArray}}class st extends o.XFAObject{constructor(e){super(f,"radial",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["toEdge","toCenter"]),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](e){e=e?e[n.$toStyle]():"#FFFFFF";const t=this.color?this.color[n.$toStyle]():"#000000";return`radial-gradient(circle at center, ${"toEdge"===this.type?`${e},${t}`:`${t},${e}`})`}}class ot extends o.StringObject{constructor(e){super(f,"reason"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class ct extends o.XFAObject{constructor(e){super(f,"reasons",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.reason=new o.XFAObjectArray}}class lt extends o.XFAObject{constructor(e){super(f,"rectangle",!0),this.hand=(0,c.getStringOption)(e.hand,["even","left","right"]),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.corner=new o.XFAObjectArray(4),this.edge=new o.XFAObjectArray(4),this.fill=null}[n.$toHTML](){const e=this.edge.children.length?this.edge.children[0]:new ue({}),t=e[n.$toStyle](),a=Object.create(null);"visible"===this.fill?.presence?Object.assign(a,this.fill[n.$toStyle]()):a.fill="transparent",a.strokeWidth=(0,s.measureToString)("visible"===e.presence?e.thickness:0),a.stroke=t.color;const r=(this.corner.children.length?this.corner.children[0]:new te({}))[n.$toStyle](),i={name:"svg",children:[{name:"rect",attributes:{xmlns:g,width:"100%",height:"100%",x:0,y:0,rx:r.radius,ry:r.radius,style:a}}],attributes:{xmlns:g,style:{overflow:"visible"},width:"100%",height:"100%"}};return w(this[n.$getParent]()[n.$getParent]())?c.HTMLResult.success({name:"div",attributes:{style:{display:"inline",width:"100%",height:"100%"}},children:[i]}):(i.attributes.style.position="absolute",c.HTMLResult.success(i))}}class ht extends o.StringObject{constructor(e){super(f,"ref"),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||""}}class ut extends o.StringObject{constructor(e){super(f,"script"),this.binding=e.binding||"",this.contentType=e.contentType||"",this.id=e.id||"",this.name=e.name||"",this.runAt=(0,c.getStringOption)(e.runAt,["client","both","server"]),this.use=e.use||"",this.usehref=e.usehref||""}}class dt extends o.XFAObject{constructor(e){super(f,"setProperty"),this.connection=e.connection||"",this.ref=e.ref||"",this.target=e.target||""}}t.SetProperty=dt;class ft extends o.XFAObject{constructor(e){super(f,"signData",!0),this.id=e.id||"",this.operation=(0,c.getStringOption)(e.operation,["sign","clear","verify"]),this.ref=e.ref||"",this.target=e.target||"",this.use=e.use||"",this.usehref=e.usehref||"",this.filter=null,this.manifest=null}}class gt extends o.XFAObject{constructor(e){super(f,"signature",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["PDF1.3","PDF1.6"]),this.use=e.use||"",this.usehref=e.usehref||"",this.border=null,this.extras=null,this.filter=null,this.manifest=null,this.margin=null}}class pt extends o.XFAObject{constructor(e){super(f,"signing",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.certificate=new o.XFAObjectArray}}class mt extends o.XFAObject{constructor(e){super(f,"solid",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null}[n.$toStyle](e){return e?e[n.$toStyle]():"#FFFFFF"}}class bt extends o.StringObject{constructor(e){super(f,"speak"),this.disable=(0,c.getInteger)({data:e.disable,defaultValue:0,validate:e=>1===e}),this.id=e.id||"",this.priority=(0,c.getStringOption)(e.priority,["custom","caption","name","toolTip"]),this.rid=e.rid||"",this.use=e.use||"",this.usehref=e.usehref||""}}class yt extends o.XFAObject{constructor(e){super(f,"stipple",!0),this.id=e.id||"",this.rate=(0,c.getInteger)({data:e.rate,defaultValue:50,validate:e=>e>=0&&e<=100}),this.use=e.use||"",this.usehref=e.usehref||"",this.color=null,this.extras=null}[n.$toStyle](e){const t=this.rate/100;return l.Util.makeHexColor(Math.round(e.value.r*(1-t)+this.value.r*t),Math.round(e.value.g*(1-t)+this.value.g*t),Math.round(e.value.b*(1-t)+this.value.b*t))}}class wt extends o.XFAObject{constructor(e){super(f,"subform",!0),this.access=(0,c.getStringOption)(e.access,["open","nonInteractive","protected","readOnly"]),this.allowMacro=(0,c.getInteger)({data:e.allowMacro,defaultValue:0,validate:e=>1===e}),this.anchorType=(0,c.getStringOption)(e.anchorType,["topLeft","bottomCenter","bottomLeft","bottomRight","middleCenter","middleLeft","middleRight","topCenter","topRight"]),this.colSpan=(0,c.getInteger)({data:e.colSpan,defaultValue:1,validate:e=>e>=1||-1===e}),this.columnWidths=(e.columnWidths||"").trim().split(/\s+/).map((e=>"-1"===e?-1:(0,c.getMeasurement)(e))),this.h=e.h?(0,c.getMeasurement)(e.h):"",this.hAlign=(0,c.getStringOption)(e.hAlign,["left","center","justify","justifyAll","radix","right"]),this.id=e.id||"",this.layout=(0,c.getStringOption)(e.layout,["position","lr-tb","rl-row","rl-tb","row","table","tb"]),this.locale=e.locale||"",this.maxH=(0,c.getMeasurement)(e.maxH,"0pt"),this.maxW=(0,c.getMeasurement)(e.maxW,"0pt"),this.mergeMode=(0,c.getStringOption)(e.mergeMode,["consumeData","matchTemplate"]),this.minH=(0,c.getMeasurement)(e.minH,"0pt"),this.minW=(0,c.getMeasurement)(e.minW,"0pt"),this.name=e.name||"",this.presence=(0,c.getStringOption)(e.presence,["visible","hidden","inactive","invisible"]),this.relevant=(0,c.getRelevant)(e.relevant),this.restoreState=(0,c.getStringOption)(e.restoreState,["manual","auto"]),this.scope=(0,c.getStringOption)(e.scope,["name","none"]),this.use=e.use||"",this.usehref=e.usehref||"",this.w=e.w?(0,c.getMeasurement)(e.w):"",this.x=(0,c.getMeasurement)(e.x,"0pt"),this.y=(0,c.getMeasurement)(e.y,"0pt"),this.assist=null,this.bind=null,this.bookend=null,this.border=null,this.break=null,this.calculate=null,this.desc=null,this.extras=null,this.keep=null,this.margin=null,this.occur=null,this.overflow=null,this.pageSet=null,this.para=null,this.traversal=null,this.validate=null,this.variables=null,this.area=new o.XFAObjectArray,this.breakAfter=new o.XFAObjectArray,this.breakBefore=new o.XFAObjectArray,this.connect=new o.XFAObjectArray,this.draw=new o.XFAObjectArray,this.event=new o.XFAObjectArray,this.exObject=new o.XFAObjectArray,this.exclGroup=new o.XFAObjectArray,this.field=new o.XFAObjectArray,this.proto=new o.XFAObjectArray,this.setProperty=new o.XFAObjectArray,this.subform=new o.XFAObjectArray,this.subformSet=new o.XFAObjectArray}[n.$getSubformParent](){const e=this[n.$getParent]();return e instanceof xt?e[n.$getSubformParent]():e}[n.$isBindable](){return!0}[n.$isThereMoreWidth](){return this.layout.endsWith("-tb")&&0===this[n.$extra].attempt&&this[n.$extra].numberInLine>0||this[n.$getParent]()[n.$isThereMoreWidth]()}*[n.$getContainedChildren](){yield*S(this)}[n.$flushHTML](){return(0,i.flushHTML)(this)}[n.$addHTML](e,t){(0,i.addHTML)(this,e,t)}[n.$getAvailableSpace](){return(0,i.getAvailableSpace)(this)}[n.$isSplittable](){const e=this[n.$getSubformParent]();return!!e[n.$isSplittable]()&&(void 0!==this[n.$extra]._isSplittable?this[n.$extra]._isSplittable:"position"===this.layout||this.layout.includes("row")||this.keep&&"none"!==this.keep.intact?(this[n.$extra]._isSplittable=!1,!1):(!e.layout?.endsWith("-tb")||0===e[n.$extra].numberInLine)&&(this[n.$extra]._isSplittable=!0,!0))}[n.$toHTML](e){if(k(this),this.break){if("auto"!==this.break.after||""!==this.break.afterTarget){const e=new X({targetType:this.break.after,target:this.break.afterTarget,startNew:this.break.startNew.toString()});e[n.$globalData]=this[n.$globalData],this[n.$appendChild](e),this.breakAfter.push(e)}if("auto"!==this.break.before||""!==this.break.beforeTarget){const e=new H({targetType:this.break.before,target:this.break.beforeTarget,startNew:this.break.startNew.toString()});e[n.$globalData]=this[n.$globalData],this[n.$appendChild](e),this.breakBefore.push(e)}if(""!==this.break.overflowTarget){const e=new Ze({target:this.break.overflowTarget,leader:this.break.overflowLeader,trailer:this.break.overflowTrailer});e[n.$globalData]=this[n.$globalData],this[n.$appendChild](e),this.overflow.push(e)}this[n.$removeChild](this.break),this.break=null}if("hidden"===this.presence||"inactive"===this.presence)return c.HTMLResult.EMPTY;if((this.breakBefore.children.length>1||this.breakAfter.children.length>1)&&(0,l.warn)("XFA - Several breakBefore or breakAfter in subforms: please file a bug."),this.breakBefore.children.length>=1){const e=this.breakBefore.children[0];if(T(e))return c.HTMLResult.breakNode(e)}if(this[n.$extra]?.afterBreakAfter)return c.HTMLResult.EMPTY;(0,s.fixDimensions)(this);const t=[],a={id:this[n.$uid],class:[]};(0,s.setAccess)(this,a.class),this[n.$extra]||(this[n.$extra]=Object.create(null)),Object.assign(this[n.$extra],{children:t,line:null,attributes:a,attempt:0,numberInLine:0,availableSpace:{width:Math.min(this.w||1/0,e.width),height:Math.min(this.h||1/0,e.height)},width:0,height:0,prevHeight:0,currentWidth:0});const r=this[n.$getTemplateRoot](),o=r[n.$extra].noLayoutFailure,h=this[n.$isSplittable]();if(h||O(this),!(0,i.checkDimensions)(this,e))return c.HTMLResult.FAILURE;const u=new Set(["area","draw","exclGroup","field","subform","subformSet"]);if(this.layout.includes("row")){const e=this[n.$getSubformParent]().columnWidths;Array.isArray(e)&&e.length>0&&(this[n.$extra].columnWidths=e,this[n.$extra].currentColumn=0)}const d=(0,s.toStyle)(this,"anchorType","dimensions","position","presence","border","margin","hAlign"),f=["xfaSubform"],g=(0,s.layoutClass)(this);if(g&&f.push(g),a.style=d,a.class=f,this.name&&(a.xfaName=this.name),this.overflow){const t=this.overflow[n.$getExtra]();t.addLeader&&(t.addLeader=!1,M(this,t.leader,e))}this[n.$pushPara]();const p="lr-tb"===this.layout||"rl-tb"===this.layout,m=p?2:1;for(;this[n.$extra].attempt<m;this[n.$extra].attempt++){p&&1===this[n.$extra].attempt&&(this[n.$extra].numberInLine=0);const e=this[n.$childrenToHTML]({filter:u,include:!0});if(e.success)break;if(e.isBreak())return this[n.$popPara](),e;if(p&&0===this[n.$extra].attempt&&0===this[n.$extra].numberInLine&&!r[n.$extra].noLayoutFailure){this[n.$extra].attempt=m;break}}if(this[n.$popPara](),h||I(this),r[n.$extra].noLayoutFailure=o,this[n.$extra].attempt===m)return this.overflow&&(this[n.$getTemplateRoot]()[n.$extra].overflowNode=this.overflow),h||delete this[n.$extra],c.HTMLResult.FAILURE;if(this.overflow){const t=this.overflow[n.$getExtra]();t.addTrailer&&(t.addTrailer=!1,M(this,t.trailer,e))}let b=0,y=0;this.margin&&(b=this.margin.leftInset+this.margin.rightInset,y=this.margin.topInset+this.margin.bottomInset);const w=Math.max(this[n.$extra].width+b,this.w||0),x=Math.max(this[n.$extra].height+y,this.h||0),S=[this.x,this.y,w,x];if(""===this.w&&(d.width=(0,s.measureToString)(w)),""===this.h&&(d.height=(0,s.measureToString)(x)),("0px"===d.width||"0px"===d.height)&&0===t.length)return c.HTMLResult.EMPTY;const A={name:"div",attributes:a,children:t};C(this,a);const v=c.HTMLResult.success((0,s.createWrapper)(this,A),S);if(this.breakAfter.children.length>=1){const e=this.breakAfter.children[0];if(T(e))return this[n.$extra].afterBreakAfter=v,c.HTMLResult.breakNode(e)}return delete this[n.$extra],v}}class xt extends o.XFAObject{constructor(e){super(f,"subformSet",!0),this.id=e.id||"",this.name=e.name||"",this.relation=(0,c.getStringOption)(e.relation,["ordered","choice","unordered"]),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.bookend=null,this.break=null,this.desc=null,this.extras=null,this.occur=null,this.overflow=null,this.breakAfter=new o.XFAObjectArray,this.breakBefore=new o.XFAObjectArray,this.subform=new o.XFAObjectArray,this.subformSet=new o.XFAObjectArray}*[n.$getContainedChildren](){yield*S(this)}[n.$getSubformParent](){let e=this[n.$getParent]();for(;!(e instanceof wt);)e=e[n.$getParent]();return e}[n.$isBindable](){return!0}}class St extends o.ContentObject{constructor(e){super(f,"subjectDN"),this.delimiter=e.delimiter||",",this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){this[n.$content]=new Map(this[n.$content].split(this.delimiter).map((e=>((e=e.split("=",2))[0]=e[0].trim(),e))))}}class At extends o.XFAObject{constructor(e){super(f,"subjectDNs",!0),this.id=e.id||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||"",this.subjectDN=new o.XFAObjectArray}}class kt extends o.XFAObject{constructor(e){super(f,"submit",!0),this.embedPDF=(0,c.getInteger)({data:e.embedPDF,defaultValue:0,validate:e=>1===e}),this.format=(0,c.getStringOption)(e.format,["xdp","formdata","pdf","urlencoded","xfd","xml"]),this.id=e.id||"",this.target=e.target||"",this.textEncoding=(0,c.getKeyword)({data:e.textEncoding?e.textEncoding.toLowerCase():"",defaultValue:"",validate:e=>["utf-8","big-five","fontspecific","gbk","gb-18030","gb-2312","ksc-5601","none","shift-jis","ucs-2","utf-16"].includes(e)||e.match(/iso-8859-\d{2}/)}),this.use=e.use||"",this.usehref=e.usehref||"",this.xdpContent=e.xdpContent||"",this.encrypt=null,this.encryptData=new o.XFAObjectArray,this.signData=new o.XFAObjectArray}}class Ct extends o.XFAObject{constructor(e){super(f,"template",!0),this.baseProfile=(0,c.getStringOption)(e.baseProfile,["full","interactiveForms"]),this.extras=null,this.subform=new o.XFAObjectArray}[n.$finalize](){0===this.subform.children.length&&(0,l.warn)("XFA - No subforms in template node."),this.subform.children.length>=2&&(0,l.warn)("XFA - Several subforms in template node: please file a bug."),this[n.$tabIndex]=5e3}[n.$isSplittable](){return!0}[n.$searchNode](e,t){return e.startsWith("#")?[this[n.$ids].get(e.slice(1))]:(0,d.searchNode)(this,t,e,!0,!0)}*[n.$toPages](){if(!this.subform.children.length)return c.HTMLResult.success({name:"div",children:[]});this[n.$extra]={overflowNode:null,firstUnsplittable:null,currentContentArea:null,currentPageArea:null,noLayoutFailure:!1,pageNumber:1,pagePosition:"first",oddOrEven:"odd",blankOrNotBlank:"nonBlank",paraStack:[]};const e=this.subform.children[0];e.pageSet[n.$cleanPage]();const t=e.pageSet.pageArea.children,a={name:"div",children:[]};let r=null,i=null,s=null;if(e.breakBefore.children.length>=1?(i=e.breakBefore.children[0],s=i.target):e.subform.children.length>=1&&e.subform.children[0].breakBefore.children.length>=1?(i=e.subform.children[0].breakBefore.children[0],s=i.target):e.break?.beforeTarget?(i=e.break,s=i.beforeTarget):e.subform.children.length>=1&&e.subform.children[0].break?.beforeTarget&&(i=e.subform.children[0].break,s=i.beforeTarget),i){const e=this[n.$searchNode](s,i[n.$getParent]());e instanceof Qe&&(r=e,i[n.$extra]={})}r||(r=t[0]),r[n.$extra]={numberOfUse:1};const o=r[n.$getParent]();let h;o[n.$extra]={numberOfUse:1,pageIndex:o.pageArea.children.indexOf(r),pageSetIndex:0};let u=null,d=null,f=!0,g=0,p=0;for(;;){if(f)g=0;else if(a.children.pop(),3==++g)return(0,l.warn)("XFA - Something goes wrong: please file a bug."),a;h=null,this[n.$extra].currentPageArea=r;const t=r[n.$toHTML]().html;a.children.push(t),u&&(this[n.$extra].noLayoutFailure=!0,t.children.push(u[n.$toHTML](r[n.$extra].space).html),u=null),d&&(this[n.$extra].noLayoutFailure=!0,t.children.push(d[n.$toHTML](r[n.$extra].space).html),d=null);const i=r.contentArea.children,s=t.children.filter((e=>e.attributes.class.includes("xfaContentarea")));f=!1,this[n.$extra].firstUnsplittable=null,this[n.$extra].noLayoutFailure=!1;const o=t=>{const a=e[n.$flushHTML]();a&&(f||=a.children?.length>0,s[t].children.push(a))};for(let t=p,r=i.length;t<r;t++){const r=this[n.$extra].currentContentArea=i[t],c={width:r.w,height:r.h};p=0,u&&(s[t].children.push(u[n.$toHTML](c).html),u=null),d&&(s[t].children.push(d[n.$toHTML](c).html),d=null);const l=e[n.$toHTML](c);if(l.success)return l.html?(f||=l.html.children?.length>0,s[t].children.push(l.html)):!f&&a.children.length>1&&a.children.pop(),a;if(l.isBreak()){const e=l.breakNode;if(o(t),"auto"===e.targetType)continue;e.leader&&(u=this[n.$searchNode](e.leader,e[n.$getParent]()),u=u?u[0]:null),e.trailer&&(d=this[n.$searchNode](e.trailer,e[n.$getParent]()),d=d?d[0]:null),"pageArea"===e.targetType?(h=e[n.$extra].target,t=1/0):e[n.$extra].target?(h=e[n.$extra].target,p=e[n.$extra].index+1,t=1/0):t=e[n.$extra].index}else if(this[n.$extra].overflowNode){const e=this[n.$extra].overflowNode;this[n.$extra].overflowNode=null;const a=e[n.$getExtra](),r=a.target;a.addLeader=null!==a.leader,a.addTrailer=null!==a.trailer,o(t);const s=t;if(t=1/0,r instanceof Qe)h=r;else if(r instanceof ee){const e=i.indexOf(r);-1!==e?e>s?t=e-1:p=e:(h=r[n.$getParent](),p=h.contentArea.children.indexOf(r))}}else o(t)}this[n.$extra].pageNumber+=1,h&&(h[n.$isUsable]()?h[n.$extra].numberOfUse+=1:h=null),r=h||r[n.$getNextPage](),yield null}}}t.Template=Ct;class vt extends o.ContentObject{constructor(e){super(f,"text"),this.id=e.id||"",this.maxChars=(0,c.getInteger)({data:e.maxChars,defaultValue:0,validate:e=>e>=0}),this.name=e.name||"",this.rid=e.rid||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$acceptWhitespace](){return!0}[n.$onChild](e){return e[n.$namespaceId]===r.NamespaceIds.xhtml.id?(this[n.$content]=e,!0):((0,l.warn)(`XFA - Invalid content in Text: ${e[n.$nodeName]}.`),!1)}[n.$onText](e){this[n.$content]instanceof o.XFAObject||super[n.$onText](e)}[n.$finalize](){"string"==typeof this[n.$content]&&(this[n.$content]=this[n.$content].replaceAll("\r\n","\n"))}[n.$getExtra](){return"string"==typeof this[n.$content]?this[n.$content].split(/[\u2029\u2028\n]/).reduce(((e,t)=>(t&&e.push(t),e)),[]).join("\n"):this[n.$content][n.$text]()}[n.$toHTML](e){if("string"==typeof this[n.$content]){const e=F(this[n.$content]).html;return this[n.$content].includes("\u2029")?(e.name="div",e.children=[],this[n.$content].split("\u2029").map((e=>e.split(/[\u2028\n]/).reduce(((e,t)=>(e.push({name:"span",value:t},{name:"br"}),e)),[]))).forEach((t=>{e.children.push({name:"p",children:t})}))):/[\u2028\n]/.test(this[n.$content])&&(e.name="div",e.children=[],this[n.$content].split(/[\u2028\n]/).forEach((t=>{e.children.push({name:"span",value:t},{name:"br"})}))),c.HTMLResult.success(e)}return this[n.$content][n.$toHTML](e)}}t.Text=vt;class Ft extends o.XFAObject{constructor(e){super(f,"textEdit",!0),this.allowRichText=(0,c.getInteger)({data:e.allowRichText,defaultValue:0,validate:e=>1===e}),this.hScrollPolicy=(0,c.getStringOption)(e.hScrollPolicy,["auto","off","on"]),this.id=e.id||"",this.multiLine=(0,c.getInteger)({data:e.multiLine,defaultValue:"",validate:e=>0===e||1===e}),this.use=e.use||"",this.usehref=e.usehref||"",this.vScrollPolicy=(0,c.getStringOption)(e.vScrollPolicy,["auto","off","on"]),this.border=null,this.comb=null,this.extras=null,this.margin=null}[n.$toHTML](e){const t=(0,s.toStyle)(this,"border","font","margin");let a;const r=this[n.$getParent]()[n.$getParent]();return""===this.multiLine&&(this.multiLine=r instanceof he?1:0),a=1===this.multiLine?{name:"textarea",attributes:{dataId:r[n.$data]?.[n.$uid]||r[n.$uid],fieldId:r[n.$uid],class:["xfaTextfield"],style:t,"aria-label":v(r),"aria-required":!1}}:{name:"input",attributes:{type:"text",dataId:r[n.$data]?.[n.$uid]||r[n.$uid],fieldId:r[n.$uid],class:["xfaTextfield"],style:t,"aria-label":v(r),"aria-required":!1}},A(r)&&(a.attributes["aria-required"]=!0,a.attributes.required=!0),c.HTMLResult.success({name:"label",attributes:{class:["xfaLabel"]},children:[a]})}}class Ot extends o.StringObject{constructor(e){super(f,"time"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}[n.$finalize](){const e=this[n.$content].trim();this[n.$content]=e?new Date(e):null}[n.$toHTML](e){return F(this[n.$content]?this[n.$content].toString():"")}}class It extends o.XFAObject{constructor(e){super(f,"timeStamp"),this.id=e.id||"",this.server=e.server||"",this.type=(0,c.getStringOption)(e.type,["optional","required"]),this.use=e.use||"",this.usehref=e.usehref||""}}class Tt extends o.StringObject{constructor(e){super(f,"toolTip"),this.id=e.id||"",this.rid=e.rid||"",this.use=e.use||"",this.usehref=e.usehref||""}}class Mt extends o.XFAObject{constructor(e){super(f,"traversal",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.traverse=new o.XFAObjectArray}}class Pt extends o.XFAObject{constructor(e){super(f,"traverse",!0),this.id=e.id||"",this.operation=(0,c.getStringOption)(e.operation,["next","back","down","first","left","right","up"]),this.ref=e.ref||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.script=null}get name(){return this.operation}[n.$isTransparent](){return!1}}class Nt extends o.XFAObject{constructor(e){super(f,"ui",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.picture=null,this.barcode=null,this.button=null,this.checkButton=null,this.choiceList=null,this.dateTimeEdit=null,this.defaultUi=null,this.imageEdit=null,this.numericEdit=null,this.passwordEdit=null,this.signature=null,this.textEdit=null}[n.$getExtra](){if(void 0===this[n.$extra]){for(const e of Object.getOwnPropertyNames(this)){if("extras"===e||"picture"===e)continue;const t=this[e];if(t instanceof o.XFAObject)return this[n.$extra]=t,t}this[n.$extra]=null}return this[n.$extra]}[n.$toHTML](e){const t=this[n.$getExtra]();return t?t[n.$toHTML](e):c.HTMLResult.EMPTY}}class Dt extends o.XFAObject{constructor(e){super(f,"validate",!0),this.formatTest=(0,c.getStringOption)(e.formatTest,["warning","disabled","error"]),this.id=e.id||"",this.nullTest=(0,c.getStringOption)(e.nullTest,["disabled","error","warning"]),this.scriptTest=(0,c.getStringOption)(e.scriptTest,["error","disabled","warning"]),this.use=e.use||"",this.usehref=e.usehref||"",this.extras=null,this.message=null,this.picture=null,this.script=null}}class Rt extends o.XFAObject{constructor(e){super(f,"value",!0),this.id=e.id||"",this.override=(0,c.getInteger)({data:e.override,defaultValue:0,validate:e=>1===e}),this.relevant=(0,c.getRelevant)(e.relevant),this.use=e.use||"",this.usehref=e.usehref||"",this.arc=null,this.boolean=null,this.date=null,this.dateTime=null,this.decimal=null,this.exData=null,this.float=null,this.image=null,this.integer=null,this.line=null,this.rectangle=null,this.text=null,this.time=null}[n.$setValue](e){const t=this[n.$getParent]();if(t instanceof ve&&t.ui?.imageEdit)return this.image||(this.image=new De({}),this[n.$appendChild](this.image)),void(this.image[n.$content]=e[n.$content]);const a=e[n.$nodeName];if(null===this[a]){for(const e of Object.getOwnPropertyNames(this)){const t=this[e];t instanceof o.XFAObject&&(this[e]=null,this[n.$removeChild](t))}this[e[n.$nodeName]]=e,this[n.$appendChild](e)}else this[a][n.$content]=e[n.$content]}[n.$text](){if(this.exData)return"string"==typeof this.exData[n.$content]?this.exData[n.$content].trim():this.exData[n.$content][n.$text]().trim();for(const e of Object.getOwnPropertyNames(this)){if("image"===e)continue;const t=this[e];if(t instanceof o.XFAObject)return(t[n.$content]||"").toString().trim()}return null}[n.$toHTML](e){for(const t of Object.getOwnPropertyNames(this)){const a=this[t];if(a instanceof o.XFAObject)return a[n.$toHTML](e)}return c.HTMLResult.EMPTY}}t.Value=Rt;class Et extends o.XFAObject{constructor(e){super(f,"variables",!0),this.id=e.id||"",this.use=e.use||"",this.usehref=e.usehref||"",this.boolean=new o.XFAObjectArray,this.date=new o.XFAObjectArray,this.dateTime=new o.XFAObjectArray,this.decimal=new o.XFAObjectArray,this.exData=new o.XFAObjectArray,this.float=new o.XFAObjectArray,this.image=new o.XFAObjectArray,this.integer=new o.XFAObjectArray,this.manifest=new o.XFAObjectArray,this.script=new o.XFAObjectArray,this.text=new o.XFAObjectArray,this.time=new o.XFAObjectArray}[n.$isTransparent](){return!0}}class Bt{static[r.$buildXFAObject](e,t){if(Bt.hasOwnProperty(e)){const a=Bt[e](t);return a[n.$setSetAttributes](t),a}}static appearanceFilter(e){return new P(e)}static arc(e){return new N(e)}static area(e){return new D(e)}static assist(e){return new R(e)}static barcode(e){return new E(e)}static bind(e){return new B(e)}static bindItems(e){return new $(e)}static bookend(e){return new L(e)}static boolean(e){return new _(e)}static border(e){return new j(e)}static break(e){return new U(e)}static breakAfter(e){return new X(e)}static breakBefore(e){return new H(e)}static button(e){return new q(e)}static calculate(e){return new z(e)}static caption(e){return new G(e)}static certificate(e){return new W(e)}static certificates(e){return new V(e)}static checkButton(e){return new K(e)}static choiceList(e){return new Y(e)}static color(e){return new J(e)}static comb(e){return new Z(e)}static connect(e){return new Q(e)}static contentArea(e){return new ee(e)}static corner(e){return new te(e)}static date(e){return new ae(e)}static dateTime(e){return new ne(e)}static dateTimeEdit(e){return new re(e)}static decimal(e){return new ie(e)}static defaultUi(e){return new se(e)}static desc(e){return new oe(e)}static digestMethod(e){return new ce(e)}static digestMethods(e){return new le(e)}static draw(e){return new he(e)}static edge(e){return new ue(e)}static encoding(e){return new de(e)}static encodings(e){return new fe(e)}static encrypt(e){return new ge(e)}static encryptData(e){return new pe(e)}static encryption(e){return new me(e)}static encryptionMethod(e){return new be(e)}static encryptionMethods(e){return new ye(e)}static event(e){return new we(e)}static exData(e){return new xe(e)}static exObject(e){return new Se(e)}static exclGroup(e){return new Ae(e)}static execute(e){return new ke(e)}static extras(e){return new Ce(e)}static field(e){return new ve(e)}static fill(e){return new Fe(e)}static filter(e){return new Oe(e)}static float(e){return new Ie(e)}static font(e){return new Te(e)}static format(e){return new Me(e)}static handler(e){return new Pe(e)}static hyphenation(e){return new Ne(e)}static image(e){return new De(e)}static imageEdit(e){return new Re(e)}static integer(e){return new Ee(e)}static issuers(e){return new Be(e)}static items(e){return new $e(e)}static keep(e){return new Le(e)}static keyUsage(e){return new _e(e)}static line(e){return new je(e)}static linear(e){return new Ue(e)}static lockDocument(e){return new Xe(e)}static manifest(e){return new He(e)}static margin(e){return new qe(e)}static mdp(e){return new ze(e)}static medium(e){return new Ge(e)}static message(e){return new We(e)}static numericEdit(e){return new Ve(e)}static occur(e){return new Ke(e)}static oid(e){return new Ye(e)}static oids(e){return new Je(e)}static overflow(e){return new Ze(e)}static pageArea(e){return new Qe(e)}static pageSet(e){return new et(e)}static para(e){return new tt(e)}static passwordEdit(e){return new at(e)}static pattern(e){return new nt(e)}static picture(e){return new rt(e)}static proto(e){return new it(e)}static radial(e){return new st(e)}static reason(e){return new ot(e)}static reasons(e){return new ct(e)}static rectangle(e){return new lt(e)}static ref(e){return new ht(e)}static script(e){return new ut(e)}static setProperty(e){return new dt(e)}static signData(e){return new ft(e)}static signature(e){return new gt(e)}static signing(e){return new pt(e)}static solid(e){return new mt(e)}static speak(e){return new bt(e)}static stipple(e){return new yt(e)}static subform(e){return new wt(e)}static subformSet(e){return new xt(e)}static subjectDN(e){return new St(e)}static subjectDNs(e){return new At(e)}static submit(e){return new kt(e)}static template(e){return new Ct(e)}static text(e){return new vt(e)}static textEdit(e){return new Ft(e)}static time(e){return new Ot(e)}static timeStamp(e){return new It(e)}static toolTip(e){return new Tt(e)}static traversal(e){return new Mt(e)}static traverse(e){return new Pt(e)}static ui(e){return new Nt(e)}static validate(e){return new Dt(e)}static value(e){return new Rt(e)}static variables(e){return new Et(e)}}t.TemplateNamespace=Bt},(e,t)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.NamespaceIds=t.$buildXFAObject=void 0;const a=Symbol();t.$buildXFAObject=a;t.NamespaceIds={config:{id:0,check:e=>e.startsWith("http://www.xfa.org/schema/xci/")},connectionSet:{id:1,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-connection-set/")},datasets:{id:2,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-data/")},form:{id:3,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-form/")},localeSet:{id:4,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-locale-set/")},pdf:{id:5,check:e=>"http://ns.adobe.com/xdp/pdf/"===e},signature:{id:6,check:e=>"http://www.w3.org/2000/09/xmldsig#"===e},sourceSet:{id:7,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-source-set/")},stylesheet:{id:8,check:e=>"http://www.w3.org/1999/XSL/Transform"===e},template:{id:9,check:e=>e.startsWith("http://www.xfa.org/schema/xfa-template/")},xdc:{id:10,check:e=>e.startsWith("http://www.xfa.org/schema/xdc/")},xdp:{id:11,check:e=>"http://ns.adobe.com/xdp/"===e},xfdf:{id:12,check:e=>"http://ns.adobe.com/xfdf/"===e},xhtml:{id:13,check:e=>"http://www.w3.org/1999/xhtml"===e},xmpmeta:{id:14,check:e=>"http://ns.adobe.com/xmpmeta/"===e}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.addHTML=function(e,t,a){const s=e[n.$extra],o=s.availableSpace,[c,l,h,u]=a;switch(e.layout){case"position":s.width=Math.max(s.width,c+h),s.height=Math.max(s.height,l+u),s.children.push(t);break;case"lr-tb":case"rl-tb":s.line&&1!==s.attempt||(s.line=i(e,[]),s.children.push(s.line),s.numberInLine=0),s.numberInLine+=1,s.line.children.push(t),0===s.attempt?(s.currentWidth+=h,s.height=Math.max(s.height,s.prevHeight+u)):(s.currentWidth=h,s.prevHeight=s.height,s.height+=u,s.attempt=0),s.width=Math.max(s.width,s.currentWidth);break;case"rl-row":case"row":{s.children.push(t),s.width+=h,s.height=Math.max(s.height,u);const e=(0,r.measureToString)(s.height);for(const t of s.children)t.attributes.style.height=e;break}case"table":case"tb":s.width=Math.min(o.width,Math.max(s.width,h)),s.height+=u,s.children.push(t)}},t.checkDimensions=function(e,t){if(null===e[n.$getTemplateRoot]()[n.$extra].firstUnsplittable)return!0;if(0===e.w||0===e.h)return!0;const a=e[n.$getSubformParent](),r=a[n.$extra]?.attempt||0,[,i,s,o]=function(e){let t,a,n=""===e.w?NaN:e.w,r=""===e.h?NaN:e.h,[i,s]=[0,0];switch(e.anchorType||""){case"bottomCenter":[i,s]=[n/2,r];break;case"bottomLeft":[i,s]=[0,r];break;case"bottomRight":[i,s]=[n,r];break;case"middleCenter":[i,s]=[n/2,r/2];break;case"middleLeft":[i,s]=[0,r/2];break;case"middleRight":[i,s]=[n,r/2];break;case"topCenter":[i,s]=[n/2,0];break;case"topRight":[i,s]=[n,0]}switch(e.rotate||0){case 0:[t,a]=[-i,-s];break;case 90:[t,a]=[-s,i],[n,r]=[r,-n];break;case 180:[t,a]=[i,s],[n,r]=[-n,-r];break;case 270:[t,a]=[s,-i],[n,r]=[-r,n]}return[e.x+t+Math.min(0,n),e.y+a+Math.min(0,r),Math.abs(n),Math.abs(r)]}(e);switch(a.layout){case"lr-tb":case"rl-tb":return 0===r?e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure?""!==e.w?Math.round(s-t.width)<=2:t.width>2:!(""!==e.h&&Math.round(o-t.height)>2)&&(""!==e.w?Math.round(s-t.width)<=2||0===a[n.$extra].numberInLine&&t.height>2:t.width>2):!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||!(""!==e.h&&Math.round(o-t.height)>2)&&((""===e.w||Math.round(s-t.width)<=2||!a[n.$isThereMoreWidth]())&&t.height>2);case"table":case"tb":return!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||(""===e.h||e[n.$isSplittable]()?(""===e.w||Math.round(s-t.width)<=2||!a[n.$isThereMoreWidth]())&&t.height>2:Math.round(o-t.height)<=2);case"position":if(e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure)return!0;if(""===e.h||Math.round(o+i-t.height)<=2)return!0;return o+i>e[n.$getTemplateRoot]()[n.$extra].currentContentArea.h;case"rl-row":case"row":return!!e[n.$getTemplateRoot]()[n.$extra].noLayoutFailure||(""===e.h||Math.round(o-t.height)<=2);default:return!0}},t.flushHTML=function(e){if(!e[n.$extra])return null;const t={name:"div",attributes:e[n.$extra].attributes,children:e[n.$extra].children};if(e[n.$extra].failingNode){const a=e[n.$extra].failingNode[n.$flushHTML]();a&&(e.layout.endsWith("-tb")?t.children.push(i(e,[a])):t.children.push(a))}if(0===t.children.length)return null;return t},t.getAvailableSpace=function(e){const t=e[n.$extra].availableSpace,a=e.margin?e.margin.topInset+e.margin.bottomInset:0,r=e.margin?e.margin.leftInset+e.margin.rightInset:0;switch(e.layout){case"lr-tb":case"rl-tb":return 0===e[n.$extra].attempt?{width:t.width-r-e[n.$extra].currentWidth,height:t.height-a-e[n.$extra].prevHeight}:{width:t.width-r,height:t.height-a-e[n.$extra].height};case"rl-row":case"row":return{width:e[n.$extra].columnWidths.slice(e[n.$extra].currentColumn).reduce(((e,t)=>e+t)),height:t.height-r};case"table":case"tb":return{width:t.width-r,height:t.height-a-e[n.$extra].height};default:return t}};var n=a(78),r=a(83);function i(e,t){return{name:"div",attributes:{class:["lr-tb"===e.layout?"xfaLr":"xfaRl"]},children:t}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.computeBbox=function(e,t,a){let r;if(""!==e.w&&""!==e.h)r=[e.x,e.y,e.w,e.h];else{if(!a)return null;let i=e.w;if(""===i){if(0===e.maxW){const t=e[n.$getSubformParent]();i="position"===t.layout&&""!==t.w?0:e.minW}else i=Math.min(e.maxW,a.width);t.attributes.style.width=l(i)}let s=e.h;if(""===s){if(0===e.maxH){const t=e[n.$getSubformParent]();s="position"===t.layout&&""!==t.h?0:e.minH}else s=Math.min(e.maxH,a.height);t.attributes.style.height=l(s)}r=[e.x,e.y,i,s]}return r},t.createWrapper=function(e,t){const{attributes:a}=t,{style:r}=a,i={name:"div",attributes:{class:["xfaWrapper"],style:Object.create(null)},children:[]};if(a.class.push("xfaWrapped"),e.border){const{widths:a,insets:s}=e.border[n.$extra];let o,c,l=s[0],h=s[3];const u=s[0]+s[2],f=s[1]+s[3];switch(e.border.hand){case"even":l-=a[0]/2,h-=a[3]/2,o=`calc(100% + ${(a[1]+a[3])/2-f}px)`,c=`calc(100% + ${(a[0]+a[2])/2-u}px)`;break;case"left":l-=a[0],h-=a[3],o=`calc(100% + ${a[1]+a[3]-f}px)`,c=`calc(100% + ${a[0]+a[2]-u}px)`;break;case"right":o=f?`calc(100% - ${f}px)`:"100%",c=u?`calc(100% - ${u}px)`:"100%"}const g=["xfaBorder"];d(e.border)&&g.push("xfaPrintOnly");const p={name:"div",attributes:{class:g,style:{top:`${l}px`,left:`${h}px`,width:o,height:c}},children:[]};for(const e of["border","borderWidth","borderColor","borderRadius","borderStyle"])void 0!==r[e]&&(p.attributes.style[e]=r[e],delete r[e]);i.children.push(p,t)}else i.children.push(t);for(const e of["background","backgroundClip","top","left","width","height","minWidth","minHeight","maxWidth","maxHeight","transform","transformOrigin","visibility"])void 0!==r[e]&&(i.attributes.style[e]=r[e],delete r[e]);i.attributes.style.position="absolute"===r.position?"absolute":"relative",delete r.position,r.alignSelf&&(i.attributes.style.alignSelf=r.alignSelf,delete r.alignSelf);return i},t.fixDimensions=function(e){const t=e[n.$getSubformParent]();if(t.layout?.includes("row")){const a=t[n.$extra],r=e.colSpan;let i;i=-1===r?a.columnWidths.slice(a.currentColumn).reduce(((e,t)=>e+t),0):a.columnWidths.slice(a.currentColumn,a.currentColumn+r).reduce(((e,t)=>e+t),0),isNaN(i)||(e.w=i)}t.layout&&"position"!==t.layout&&(e.x=e.y=0);"table"===e.layout&&""===e.w&&Array.isArray(e.columnWidths)&&(e.w=e.columnWidths.reduce(((e,t)=>e+t),0))},t.fixTextIndent=function(e){const t=(0,i.getMeasurement)(e.textIndent,"0px");if(t>=0)return;const a="padding"+("left"==("right"===e.textAlign?"right":"left")?"Left":"Right"),n=(0,i.getMeasurement)(e[a],"0px");e[a]=n-t+"px"},t.fixURL=function(e){const t=(0,r.createValidAbsoluteUrl)(e,null,{addDefaultProtocol:!0,tryConvertEncoding:!0});return t?t.href:null},t.isPrintOnly=d,t.layoutClass=function(e){switch(e.layout){case"position":default:return"xfaPosition";case"lr-tb":return"xfaLrTb";case"rl-row":return"xfaRlRow";case"rl-tb":return"xfaRlTb";case"row":return"xfaRow";case"table":return"xfaTable";case"tb":return"xfaTb"}},t.layoutNode=function(e,t){let a=null,r=null,i=!1;if((!e.w||!e.h)&&e.value){let s=0,o=0;e.margin&&(s=e.margin.leftInset+e.margin.rightInset,o=e.margin.topInset+e.margin.bottomInset);let c=null,l=null;e.para&&(l=Object.create(null),c=""===e.para.lineHeight?null:e.para.lineHeight,l.top=""===e.para.spaceAbove?0:e.para.spaceAbove,l.bottom=""===e.para.spaceBelow?0:e.para.spaceBelow,l.left=""===e.para.marginLeft?0:e.para.marginLeft,l.right=""===e.para.marginRight?0:e.para.marginRight);let h=e.font;if(!h){const t=e[n.$getTemplateRoot]();let a=e[n.$getParent]();for(;a&&a!==t;){if(a.font){h=a.font;break}a=a[n.$getParent]()}}const d=(e.w||t.width)-s,f=e[n.$globalData].fontFinder;if(e.value.exData&&e.value.exData[n.$content]&&"text/html"===e.value.exData.contentType){const t=u(e.value.exData[n.$content],h,l,c,f,d);r=t.width,a=t.height,i=t.isBroken}else{const t=e.value[n.$text]();if(t){const e=u(t,h,l,c,f,d);r=e.width,a=e.height,i=e.isBroken}}null===r||e.w||(r+=s),null===a||e.h||(a+=o)}return{w:r,h:a,isBroken:i}},t.measureToString=l,t.setAccess=function(e,t){switch(e.access){case"nonInteractive":t.push("xfaNonInteractive");break;case"readOnly":t.push("xfaReadOnly");break;case"protected":t.push("xfaDisabled")}},t.setFontFamily=function(e,t,a,n){if(!a)return void delete n.fontFamily;const r=(0,i.stripQuotes)(e.typeface);n.fontFamily=`"${r}"`;const o=a.find(r);if(o){const{fontFamily:a}=o.regular.cssFontInfo;a!==r&&(n.fontFamily=`"${a}"`);const i=f(t);if(i&&""!==i.lineHeight)return;if(n.lineHeight)return;const c=(0,s.selectFont)(e,o);c&&(n.lineHeight=Math.max(1.2,c.lineHeight))}},t.setMinMaxDimensions=function(e,t){"position"===e[n.$getSubformParent]().layout&&(e.minW>0&&(t.minWidth=l(e.minW)),e.maxW>0&&(t.maxWidth=l(e.maxW)),e.minH>0&&(t.minHeight=l(e.minH)),e.maxH>0&&(t.maxHeight=l(e.maxH)))},t.setPara=function(e,t,a){if(a.attributes.class?.includes("xfaRich")){t&&(""===e.h&&(t.height="auto"),""===e.w&&(t.width="auto"));const r=f(e);if(r){const e=a.attributes.style;switch(e.display="flex",e.flexDirection="column",r.vAlign){case"top":e.justifyContent="start";break;case"bottom":e.justifyContent="end";break;case"middle":e.justifyContent="center"}const t=r[n.$toStyle]();for(const[a,n]of Object.entries(t))a in e||(e[a]=n)}}},t.toStyle=function(e,...t){const a=Object.create(null);for(const i of t){const t=e[i];if(null!==t)if(h.hasOwnProperty(i))h[i](e,a);else if(t instanceof c.XFAObject){const e=t[n.$toStyle]();e?Object.assign(a,e):(0,r.warn)(`(DEBUG) - XFA - style for ${i} not implemented yet`)}}return a};var n=a(78),r=a(2),i=a(84),s=a(85),o=a(86),c=a(87);function l(e){return"string"==typeof e?"0px":Number.isInteger(e)?`${e}px`:`${e.toFixed(2)}px`}const h={anchorType(e,t){const a=e[n.$getSubformParent]();if(a&&(!a.layout||"position"===a.layout))switch("transform"in t||(t.transform=""),e.anchorType){case"bottomCenter":t.transform+="translate(-50%, -100%)";break;case"bottomLeft":t.transform+="translate(0,-100%)";break;case"bottomRight":t.transform+="translate(-100%,-100%)";break;case"middleCenter":t.transform+="translate(-50%,-50%)";break;case"middleLeft":t.transform+="translate(0,-50%)";break;case"middleRight":t.transform+="translate(-100%,-50%)";break;case"topCenter":t.transform+="translate(-50%,0)";break;case"topRight":t.transform+="translate(-100%,0)"}},dimensions(e,t){const a=e[n.$getSubformParent]();let r=e.w;const i=e.h;if(a.layout?.includes("row")){const t=a[n.$extra],i=e.colSpan;let s;-1===i?(s=t.columnWidths.slice(t.currentColumn).reduce(((e,t)=>e+t),0),t.currentColumn=0):(s=t.columnWidths.slice(t.currentColumn,t.currentColumn+i).reduce(((e,t)=>e+t),0),t.currentColumn=(t.currentColumn+e.colSpan)%t.columnWidths.length),isNaN(s)||(r=e.w=s)}t.width=""!==r?l(r):"auto",t.height=""!==i?l(i):"auto"},position(e,t){const a=e[n.$getSubformParent]();a?.layout&&"position"!==a.layout||(t.position="absolute",t.left=l(e.x),t.top=l(e.y))},rotate(e,t){e.rotate&&("transform"in t||(t.transform=""),t.transform+=`rotate(-${e.rotate}deg)`,t.transformOrigin="top left")},presence(e,t){switch(e.presence){case"invisible":t.visibility="hidden";break;case"hidden":case"inactive":t.display="none"}},hAlign(e,t){if("para"===e[n.$nodeName])switch(e.hAlign){case"justifyAll":t.textAlign="justify-all";break;case"radix":t.textAlign="left";break;default:t.textAlign=e.hAlign}else switch(e.hAlign){case"left":t.alignSelf="start";break;case"center":t.alignSelf="center";break;case"right":t.alignSelf="end"}},margin(e,t){e.margin&&(t.margin=e.margin[n.$toStyle]().margin)}};function u(e,t,a,r,i,s){const c=new o.TextMeasure(t,a,r,i);return"string"==typeof e?c.addString(e):e[n.$pushGlyphs](c),c.compute(s)}function d(e){return e.relevant.length>0&&!e.relevant[0].excluded&&"print"===e.relevant[0].viewname}function f(e){const t=e[n.$getTemplateRoot]()[n.$extra].paraStack;return t.length?t.at(-1):null}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.HTMLResult=void 0,t.getBBox=function(e){const t=-1;if(!e)return{x:t,y:t,width:t,height:t};const a=e.trim().split(/\s*,\s*/).map((e=>o(e,"-1")));if(a.length<4||a[2]<0||a[3]<0)return{x:t,y:t,width:t,height:t};const[n,r,i,s]=a;return{x:n,y:r,width:i,height:s}},t.getColor=function(e,t=[0,0,0]){let[a,n,r]=t;if(!e)return{r:a,g:n,b:r};const i=e.trim().split(/\s*,\s*/).map((e=>Math.min(Math.max(0,parseInt(e.trim(),10)),255))).map((e=>isNaN(e)?0:e));if(i.length<3)return{r:a,g:n,b:r};return[a,n,r]=i,{r:a,g:n,b:r}},t.getFloat=function({data:e,defaultValue:t,validate:a}){if(!e)return t;e=e.trim();const n=parseFloat(e);if(!isNaN(n)&&a(n))return n;return t},t.getInteger=function({data:e,defaultValue:t,validate:a}){if(!e)return t;e=e.trim();const n=parseInt(e,10);if(!isNaN(n)&&a(n))return n;return t},t.getKeyword=s,t.getMeasurement=o,t.getRatio=function(e){if(!e)return{num:1,den:1};const t=e.trim().split(/\s*:\s*/).map((e=>parseFloat(e))).filter((e=>!isNaN(e)));1===t.length&&t.push(1);if(0===t.length)return{num:1,den:1};const[a,n]=t;return{num:a,den:n}},t.getRelevant=function(e){if(!e)return[];return e.trim().split(/\s+/).map((e=>({excluded:"-"===e[0],viewname:e.substring(1)})))},t.getStringOption=function(e,t){return s({data:e,defaultValue:t[0],validate:e=>t.includes(e)})},t.stripQuotes=function(e){if(e.startsWith("'")||e.startsWith('"'))return e.slice(1,-1);return e};var n=a(2);const r={pt:e=>e,cm:e=>e/2.54*72,mm:e=>e/25.4*72,in:e=>72*e,px:e=>e},i=/([+-]?\d+\.?\d*)(.*)/;function s({data:e,defaultValue:t,validate:a}){return e&&a(e=e.trim())?e:t}function o(e,t="0"){if(t||="0",!e)return o(t);const a=e.trim().match(i);if(!a)return o(t);const[,n,s]=a,c=parseFloat(n);if(isNaN(c))return o(t);if(0===c)return 0;const l=r[s];return l?l(c):c}class c{static get FAILURE(){return(0,n.shadow)(this,"FAILURE",new c(!1,null,null,null))}static get EMPTY(){return(0,n.shadow)(this,"EMPTY",new c(!0,null,null,null))}constructor(e,t,a,n){this.success=e,this.html=t,this.bbox=a,this.breakNode=n}isBreak(){return!!this.breakNode}static breakNode(e){return new c(!1,null,null,e)}static success(e,t=null){return new c(!0,e,t,null)}}t.HTMLResult=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.FontFinder=void 0,t.getMetrics=function(e,t=!1){let a=null;if(e){const t=(0,r.stripQuotes)(e.typeface),i=e[n.$globalData].fontFinder.find(t);a=s(e,i)}if(!a)return{lineHeight:12,lineGap:2,lineNoGap:10};const i=e.size||10,o=a.lineHeight?Math.max(t?0:1.2,a.lineHeight):1.2,c=void 0===a.lineGap?.2:a.lineGap;return{lineHeight:o*i,lineGap:c*i,lineNoGap:Math.max(1,o-c)*i}},t.selectFont=s;var n=a(78),r=a(84),i=a(2);function s(e,t){return"italic"===e.posture?"bold"===e.weight?t.bolditalic:t.italic:"bold"===e.weight?t.bold:t.regular}t.FontFinder=class{constructor(e){this.fonts=new Map,this.cache=new Map,this.warned=new Set,this.defaultFont=null,this.add(e)}add(e,t=null){for(const t of e)this.addPdfFont(t);for(const e of this.fonts.values())e.regular||(e.regular=e.italic||e.bold||e.bolditalic);if(!t||0===t.size)return;const a=this.fonts.get("PdfJS-Fallback-PdfJS-XFA");for(const e of t)this.fonts.set(e,a)}addPdfFont(e){const t=e.cssFontInfo,a=t.fontFamily;let n=this.fonts.get(a);n||(n=Object.create(null),this.fonts.set(a,n),this.defaultFont||(this.defaultFont=n));let r="";const i=parseFloat(t.fontWeight);0!==parseFloat(t.italicAngle)?r=i>=700?"bolditalic":"italic":i>=700&&(r="bold"),r||((e.name.includes("Bold")||e.psName?.includes("Bold"))&&(r="bold"),(e.name.includes("Italic")||e.name.endsWith("It")||e.psName?.includes("Italic")||e.psName?.endsWith("It"))&&(r+="italic")),r||(r="regular"),n[r]=e}getDefault(){return this.defaultFont}find(e,t=!0){let a=this.fonts.get(e)||this.cache.get(e);if(a)return a;const n=/,|-|_| |bolditalic|bold|italic|regular|it/gi;let r=e.replaceAll(n,"");if(a=this.fonts.get(r),a)return this.cache.set(e,a),a;r=r.toLowerCase();const s=[];for(const[e,t]of this.fonts.entries())e.replaceAll(n,"").toLowerCase().startsWith(r)&&s.push(t);if(0===s.length)for(const[,e]of this.fonts.entries())e.regular.name?.replaceAll(n,"").toLowerCase().startsWith(r)&&s.push(e);if(0===s.length){r=r.replaceAll(/psmt|mt/gi,"");for(const[e,t]of this.fonts.entries())e.replaceAll(n,"").toLowerCase().startsWith(r)&&s.push(t)}if(0===s.length)for(const e of this.fonts.values())e.regular.name?.replaceAll(n,"").toLowerCase().startsWith(r)&&s.push(e);return s.length>=1?(1!==s.length&&t&&(0,i.warn)(`XFA - Too many choices to guess the correct font: ${e}`),this.cache.set(e,s[0]),s[0]):(t&&!this.warned.has(e)&&(this.warned.add(e),(0,i.warn)(`XFA - Cannot find the font: ${e}`)),null)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.TextMeasure=void 0;var n=a(85);class r{constructor(e,t,a,r){if(this.lineHeight=a,this.paraMargin=t||{top:0,bottom:0,left:0,right:0},!e)return void([this.pdfFont,this.xfaFont]=this.defaultFont(r));this.xfaFont={typeface:e.typeface,posture:e.posture,weight:e.weight,size:e.size,letterSpacing:e.letterSpacing};const i=r.find(e.typeface);i?(this.pdfFont=(0,n.selectFont)(e,i),this.pdfFont||([this.pdfFont,this.xfaFont]=this.defaultFont(r))):[this.pdfFont,this.xfaFont]=this.defaultFont(r)}defaultFont(e){const t=e.find("Helvetica",!1)||e.find("Myriad Pro",!1)||e.find("Arial",!1)||e.getDefault();if(t?.regular){const e=t.regular;return[e,{typeface:e.cssFontInfo.fontFamily,posture:"normal",weight:"normal",size:10,letterSpacing:0}]}return[null,{typeface:"Courier",posture:"normal",weight:"normal",size:10,letterSpacing:0}]}}class i{constructor(e,t,a,n){this.fontFinder=n,this.stack=[new r(e,t,a,n)]}pushData(e,t,a){const n=this.stack.at(-1);for(const t of["typeface","posture","weight","size","letterSpacing"])e[t]||(e[t]=n.xfaFont[t]);for(const e of["top","bottom","left","right"])isNaN(t[e])&&(t[e]=n.paraMargin[e]);const i=new r(e,t,a||n.lineHeight,this.fontFinder);i.pdfFont||(i.pdfFont=n.pdfFont),this.stack.push(i)}popFont(){this.stack.pop()}topFont(){return this.stack.at(-1)}}t.TextMeasure=class{constructor(e,t,a,n){this.glyphs=[],this.fontSelector=new i(e,t,a,n),this.extraHeight=0}pushData(e,t,a){this.fontSelector.pushData(e,t,a)}popFont(e){return this.fontSelector.popFont()}addPara(){const e=this.fontSelector.topFont();this.extraHeight+=e.paraMargin.top+e.paraMargin.bottom}addString(e){if(!e)return;const t=this.fontSelector.topFont(),a=t.xfaFont.size;if(t.pdfFont){const n=t.xfaFont.letterSpacing,r=t.pdfFont,i=r.lineHeight||1.2,s=t.lineHeight||Math.max(1.2,i)*a,o=i-(void 0===r.lineGap?.2:r.lineGap),c=Math.max(1,o)*a,l=a/1e3,h=r.defaultWidth||r.charsToGlyphs(" ")[0].width;for(const t of e.split(/[\u2029\n]/)){const e=r.encodeString(t).join(""),a=r.charsToGlyphs(e);for(const e of a){const t=e.width||h;this.glyphs.push([t*l+n,s,c,e.unicode,!1])}this.glyphs.push([0,0,0,"\n",!0])}this.glyphs.pop()}else{for(const t of e.split(/[\u2029\n]/)){for(const e of t.split(""))this.glyphs.push([a,1.2*a,a,e,!1]);this.glyphs.push([0,0,0,"\n",!0])}this.glyphs.pop()}}compute(e){let t=-1,a=0,n=0,r=0,i=0,s=0,o=!1,c=!0;for(let l=0,h=this.glyphs.length;l<h;l++){const[h,u,d,f,g]=this.glyphs[l],p=" "===f,m=c?d:u;g?(n=Math.max(n,i),i=0,r+=s,s=m,t=-1,a=0,c=!1):p?i+h>e?(n=Math.max(n,i),i=0,r+=s,s=m,t=-1,a=0,o=!0,c=!1):(s=Math.max(m,s),a=i,i+=h,t=l):i+h>e?(r+=s,s=m,-1!==t?(l=t,n=Math.max(n,a),i=0,t=-1,a=0):(n=Math.max(n,i),i=h),o=!0,c=!1):(i+=h,s=Math.max(m,s))}return n=Math.max(n,i),r+=s+this.extraHeight,{width:1.02*n,height:r,isBroken:o}}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XmlObject=t.XFAObjectArray=t.XFAObject=t.XFAAttribute=t.StringObject=t.OptionObject=t.Option10=t.Option01=t.IntegerObject=t.ContentObject=void 0;var n=a(78),r=a(84),i=a(2),s=a(3),o=a(81),c=a(88);const l=Symbol(),h=Symbol(),u=Symbol(),d=Symbol("_children"),f=Symbol(),g=Symbol(),p=Symbol(),m=Symbol(),b=Symbol(),y=Symbol(),w=Symbol(),x=Symbol(),S=Symbol(),A=Symbol("parent"),k=Symbol(),C=Symbol(),v=Symbol();let F=0;const O=o.NamespaceIds.datasets.id;class I{constructor(e,t,a=!1){this[n.$namespaceId]=e,this[n.$nodeName]=t,this[w]=a,this[A]=null,this[d]=[],this[n.$uid]=`${t}${F++}`,this[n.$globalData]=null}get isXFAObject(){return!0}get isXFAObjectArray(){return!1}createNodes(e){let t=this,a=null;for(const{name:r,index:i}of e){for(let e=0,s=isFinite(i)?i:0;e<=s;e++){const e=t[n.$namespaceId]===O?-1:t[n.$namespaceId];a=new P(e,r),t[n.$appendChild](a)}t=a}return a}[n.$onChild](e){if(!this[w]||!this[n.$onChildCheck](e))return!1;const t=e[n.$nodeName],a=this[t];if(!(a instanceof T))return null!==a&&this[n.$removeChild](a),this[t]=e,this[n.$appendChild](e),!0;if(a.push(e))return this[n.$appendChild](e),!0;let r="";return this.id?r=` (id: ${this.id})`:this.name&&(r=` (name: ${this.name} ${this.h.value})`),(0,i.warn)(`XFA - node "${this[n.$nodeName]}"${r} has already enough "${t}"!`),!1}[n.$onChildCheck](e){return this.hasOwnProperty(e[n.$nodeName])&&e[n.$namespaceId]===this[n.$namespaceId]}[n.$isNsAgnostic](){return!1}[n.$acceptWhitespace](){return!1}[n.$isCDATAXml](){return!1}[n.$isBindable](){return!1}[n.$popPara](){this.para&&this[n.$getTemplateRoot]()[n.$extra].paraStack.pop()}[n.$pushPara](){this[n.$getTemplateRoot]()[n.$extra].paraStack.push(this.para)}[n.$setId](e){this.id&&this[n.$namespaceId]===o.NamespaceIds.template.id&&e.set(this.id,this)}[n.$getTemplateRoot](){return this[n.$globalData].template}[n.$isSplittable](){return!1}[n.$isThereMoreWidth](){return!1}[n.$appendChild](e){e[A]=this,this[d].push(e),!e[n.$globalData]&&this[n.$globalData]&&(e[n.$globalData]=this[n.$globalData])}[n.$removeChild](e){const t=this[d].indexOf(e);this[d].splice(t,1)}[n.$hasSettableValue](){return this.hasOwnProperty("value")}[n.$setValue](e){}[n.$onText](e){}[n.$finalize](){}[n.$clean](e){delete this[w],this[n.$cleanup]&&(e.clean(this[n.$cleanup]),delete this[n.$cleanup])}[n.$indexOf](e){return this[d].indexOf(e)}[n.$insertAt](e,t){t[A]=this,this[d].splice(e,0,t),!t[n.$globalData]&&this[n.$globalData]&&(t[n.$globalData]=this[n.$globalData])}[n.$isTransparent](){return!this.name}[n.$lastAttribute](){return""}[n.$text](){return 0===this[d].length?this[n.$content]:this[d].map((e=>e[n.$text]())).join("")}get[u](){const e=Object.getPrototypeOf(this);if(!e._attributes){const t=e._attributes=new Set;for(const e of Object.getOwnPropertyNames(this)){if(null===this[e]||this[e]instanceof I||this[e]instanceof T)break;t.add(e)}}return(0,i.shadow)(this,u,e._attributes)}[n.$isDescendent](e){let t=this;for(;t;){if(t===e)return!0;t=t[n.$getParent]()}return!1}[n.$getParent](){return this[A]}[n.$getSubformParent](){return this[n.$getParent]()}[n.$getChildren](e=null){return e?this[e]:this[d]}[n.$dump](){const e=Object.create(null);this[n.$content]&&(e.$content=this[n.$content]);for(const t of Object.getOwnPropertyNames(this)){const a=this[t];null!==a&&(a instanceof I?e[t]=a[n.$dump]():a instanceof T?a.isEmpty()||(e[t]=a.dump()):e[t]=a)}return e}[n.$toStyle](){return null}[n.$toHTML](){return r.HTMLResult.EMPTY}*[n.$getContainedChildren](){for(const e of this[n.$getChildren]())yield e}*[m](e,t){for(const a of this[n.$getContainedChildren]())if(!e||t===e.has(a[n.$nodeName])){const e=this[n.$getAvailableSpace](),t=a[n.$toHTML](e);t.success||(this[n.$extra].failingNode=a),yield t}}[n.$flushHTML](){return null}[n.$addHTML](e,t){this[n.$extra].children.push(e)}[n.$getAvailableSpace](){}[n.$childrenToHTML]({filter:e=null,include:t=!0}){if(this[n.$extra].generator){const e=this[n.$getAvailableSpace](),t=this[n.$extra].failingNode[n.$toHTML](e);if(!t.success)return t;t.html&&this[n.$addHTML](t.html,t.bbox),delete this[n.$extra].failingNode}else this[n.$extra].generator=this[m](e,t);for(;;){const e=this[n.$extra].generator.next();if(e.done)break;const t=e.value;if(!t.success)return t;t.html&&this[n.$addHTML](t.html,t.bbox)}return this[n.$extra].generator=null,r.HTMLResult.EMPTY}[n.$setSetAttributes](e){this[C]=new Set(Object.keys(e))}[y](e){const t=this[u],a=this[C];return[...e].filter((e=>t.has(e)&&!a.has(e)))}[n.$resolvePrototypes](e,t=new Set){for(const a of this[d])a[k](e,t)}[k](e,t){const a=this[b](e,t);a?this[l](a,e,t):this[n.$resolvePrototypes](e,t)}[b](e,t){const{use:a,usehref:r}=this;if(!a&&!r)return null;let s=null,o=null,h=null,u=a;if(r?(u=r,r.startsWith("#som(")&&r.endsWith(")")?o=r.slice(5,-1):r.startsWith(".#som(")&&r.endsWith(")")?o=r.slice(6,-1):r.startsWith("#")?h=r.slice(1):r.startsWith(".#")&&(h=r.slice(2))):a.startsWith("#")?h=a.slice(1):o=a,this.use=this.usehref="",h?s=e.get(h):(s=(0,c.searchNode)(e.get(n.$root),this,o,!0,!1),s&&(s=s[0])),!s)return(0,i.warn)(`XFA - Invalid prototype reference: ${u}.`),null;if(s[n.$nodeName]!==this[n.$nodeName])return(0,i.warn)(`XFA - Incompatible prototype: ${s[n.$nodeName]} !== ${this[n.$nodeName]}.`),null;if(t.has(s))return(0,i.warn)("XFA - Cycle detected in prototypes use."),null;t.add(s);const d=s[b](e,t);return d&&s[l](d,e,t),s[n.$resolvePrototypes](e,t),t.delete(s),s}[l](e,t,a){if(a.has(e))return void(0,i.warn)("XFA - Cycle detected in prototypes use.");!this[n.$content]&&e[n.$content]&&(this[n.$content]=e[n.$content]);new Set(a).add(e);for(const t of this[y](e[C]))this[t]=e[t],this[C]&&this[C].add(t);for(const r of Object.getOwnPropertyNames(this)){if(this[u].has(r))continue;const i=this[r],s=e[r];if(i instanceof T){for(const e of i[d])e[k](t,a);for(let r=i[d].length,o=s[d].length;r<o;r++){const s=e[d][r][n.$clone]();if(!i.push(s))break;s[A]=this,this[d].push(s),s[k](t,a)}}else if(null===i){if(null!==s){const e=s[n.$clone]();e[A]=this,this[r]=e,this[d].push(e),e[k](t,a)}}else i[n.$resolvePrototypes](t,a),s&&i[l](s,t,a)}}static[f](e){return Array.isArray(e)?e.map((e=>I[f](e))):"object"==typeof e&&null!==e?Object.assign({},e):e}[n.$clone](){const e=Object.create(Object.getPrototypeOf(this));for(const t of Object.getOwnPropertySymbols(this))try{e[t]=this[t]}catch{(0,i.shadow)(e,t,this[t])}e[n.$uid]=`${e[n.$nodeName]}${F++}`,e[d]=[];for(const t of Object.getOwnPropertyNames(this)){if(this[u].has(t)){e[t]=I[f](this[t]);continue}const a=this[t];e[t]=a instanceof T?new T(a[x]):null}for(const t of this[d]){const a=t[n.$nodeName],r=t[n.$clone]();e[d].push(r),r[A]=e,null===e[a]?e[a]=r:e[a][d].push(r)}return e}[n.$getChildren](e=null){return e?this[d].filter((t=>t[n.$nodeName]===e)):this[d]}[n.$getChildrenByClass](e){return this[e]}[n.$getChildrenByName](e,t,a=!0){return Array.from(this[n.$getChildrenByNameIt](e,t,a))}*[n.$getChildrenByNameIt](e,t,a=!0){if("parent"!==e){for(const a of this[d])a[n.$nodeName]===e&&(yield a),a.name===e&&(yield a),(t||a[n.$isTransparent]())&&(yield*a[n.$getChildrenByNameIt](e,t,!1));a&&this[u].has(e)&&(yield new M(this,e,this[e]))}else yield this[A]}}t.XFAObject=I;class T{constructor(e=1/0){this[x]=e,this[d]=[]}get isXFAObject(){return!1}get isXFAObjectArray(){return!0}push(e){return this[d].length<=this[x]?(this[d].push(e),!0):((0,i.warn)(`XFA - node "${e[n.$nodeName]}" accepts no more than ${this[x]} children`),!1)}isEmpty(){return 0===this[d].length}dump(){return 1===this[d].length?this[d][0][n.$dump]():this[d].map((e=>e[n.$dump]()))}[n.$clone](){const e=new T(this[x]);return e[d]=this[d].map((e=>e[n.$clone]())),e}get children(){return this[d]}clear(){this[d].length=0}}t.XFAObjectArray=T;class M{constructor(e,t,a){this[A]=e,this[n.$nodeName]=t,this[n.$content]=a,this[n.$consumed]=!1,this[n.$uid]="attribute"+F++}[n.$getParent](){return this[A]}[n.$isDataValue](){return!0}[n.$getDataValue](){return this[n.$content].trim()}[n.$setValue](e){e=e.value||"",this[n.$content]=e.toString()}[n.$text](){return this[n.$content]}[n.$isDescendent](e){return this[A]===e||this[A][n.$isDescendent](e)}}t.XFAAttribute=M;class P extends I{constructor(e,t,a={}){if(super(e,t),this[n.$content]="",this[g]=null,"#text"!==t){const e=new Map;this[h]=e;for(const[t,n]of Object.entries(a))e.set(t,new M(this,t,n));if(a.hasOwnProperty(n.$nsAttributes)){const e=a[n.$nsAttributes].xfa.dataNode;void 0!==e&&("dataGroup"===e?this[g]=!1:"dataValue"===e&&(this[g]=!0))}}this[n.$consumed]=!1}[n.$toString](e){const t=this[n.$nodeName];if("#text"===t)return void e.push((0,s.encodeToXmlString)(this[n.$content]));const a=(0,i.utf8StringToString)(t),r=this[n.$namespaceId]===O?"xfa:":"";e.push(`<${r}${a}`);for(const[t,a]of this[h].entries()){const r=(0,i.utf8StringToString)(t);e.push(` ${r}="${(0,s.encodeToXmlString)(a[n.$content])}"`)}if(null!==this[g]&&(this[g]?e.push(' xfa:dataNode="dataValue"'):e.push(' xfa:dataNode="dataGroup"')),this[n.$content]||0!==this[d].length){if(e.push(">"),this[n.$content])"string"==typeof this[n.$content]?e.push((0,s.encodeToXmlString)(this[n.$content])):this[n.$content][n.$toString](e);else for(const t of this[d])t[n.$toString](e);e.push(`</${r}${a}>`)}else e.push("/>")}[n.$onChild](e){if(this[n.$content]){const e=new P(this[n.$namespaceId],"#text");this[n.$appendChild](e),e[n.$content]=this[n.$content],this[n.$content]=""}return this[n.$appendChild](e),!0}[n.$onText](e){this[n.$content]+=e}[n.$finalize](){if(this[n.$content]&&this[d].length>0){const e=new P(this[n.$namespaceId],"#text");this[n.$appendChild](e),e[n.$content]=this[n.$content],delete this[n.$content]}}[n.$toHTML](){return"#text"===this[n.$nodeName]?r.HTMLResult.success({name:"#text",value:this[n.$content]}):r.HTMLResult.EMPTY}[n.$getChildren](e=null){return e?this[d].filter((t=>t[n.$nodeName]===e)):this[d]}[n.$getAttributes](){return this[h]}[n.$getChildrenByClass](e){const t=this[h].get(e);return void 0!==t?t:this[n.$getChildren](e)}*[n.$getChildrenByNameIt](e,t){const a=this[h].get(e);a&&(yield a);for(const a of this[d])a[n.$nodeName]===e&&(yield a),t&&(yield*a[n.$getChildrenByNameIt](e,t))}*[n.$getAttributeIt](e,t){const a=this[h].get(e);!a||t&&a[n.$consumed]||(yield a);for(const a of this[d])yield*a[n.$getAttributeIt](e,t)}*[n.$getRealChildrenByNameIt](e,t,a){for(const r of this[d])r[n.$nodeName]!==e||a&&r[n.$consumed]||(yield r),t&&(yield*r[n.$getRealChildrenByNameIt](e,t,a))}[n.$isDataValue](){return null===this[g]?0===this[d].length||this[d][0][n.$namespaceId]===o.NamespaceIds.xhtml.id:this[g]}[n.$getDataValue](){return null===this[g]?0===this[d].length?this[n.$content].trim():this[d][0][n.$namespaceId]===o.NamespaceIds.xhtml.id?this[d][0][n.$text]().trim():null:this[n.$content].trim()}[n.$setValue](e){e=e.value||"",this[n.$content]=e.toString()}[n.$dump](e=!1){const t=Object.create(null);e&&(t.$ns=this[n.$namespaceId]),this[n.$content]&&(t.$content=this[n.$content]),t.$name=this[n.$nodeName],t.children=[];for(const a of this[d])t.children.push(a[n.$dump](e));t.attributes=Object.create(null);for(const[e,a]of this[h])t.attributes[e]=a[n.$content];return t}}t.XmlObject=P;class N extends I{constructor(e,t){super(e,t),this[n.$content]=""}[n.$onText](e){this[n.$content]+=e}[n.$finalize](){}}t.ContentObject=N;class D extends N{constructor(e,t,a){super(e,t),this[S]=a}[n.$finalize](){this[n.$content]=(0,r.getKeyword)({data:this[n.$content],defaultValue:this[S][0],validate:e=>this[S].includes(e)})}[n.$clean](e){super[n.$clean](e),delete this[S]}}t.OptionObject=D;class R extends N{[n.$finalize](){this[n.$content]=this[n.$content].trim()}}t.StringObject=R;class E extends N{constructor(e,t,a,n){super(e,t),this[p]=a,this[v]=n}[n.$finalize](){this[n.$content]=(0,r.getInteger)({data:this[n.$content],defaultValue:this[p],validate:this[v]})}[n.$clean](e){super[n.$clean](e),delete this[p],delete this[v]}}t.IntegerObject=E;t.Option01=class extends E{constructor(e,t){super(e,t,0,(e=>1===e))}};t.Option10=class extends E{constructor(e,t){super(e,t,1,(e=>0===e))}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.createDataNode=function(e,t,a){const i=h(a);if(!i)return null;if(i.some((e=>e.operator===o.dotDot)))return null;const s=c.get(i[0].name);let l=0;s?(e=s(e,t),l=1):e=t||e;for(let t=i.length;l<t;l++){const{name:t,operator:a,index:s}=i[l];if(!isFinite(s))return i[l].index=0,e.createNodes(i.slice(l));let c;switch(a){case o.dot:c=e[n.$getChildrenByName](t,!1);break;case o.dotDot:c=e[n.$getChildrenByName](t,!0);break;case o.dotHash:c=e[n.$getChildrenByClass](t),c=c.isXFAObjectArray?c.children:[c]}if(0===c.length)return e.createNodes(i.slice(l));if(!(s<c.length))return i[l].index=s-c.length,e.createNodes(i.slice(l));{const t=c[s];if(!t.isXFAObject)return(0,r.warn)("XFA - Cannot create a node."),null;e=t}}return null},t.searchNode=function(e,t,a,r=!0,i=!0){const s=h(a,r);if(!s)return null;const u=c.get(s[0].name);let d,f=0;u?(d=!0,e=[u(e,t)],f=1):(d=null===t,e=[t||e]);for(let a=s.length;f<a;f++){const{name:a,cacheName:r,operator:c,index:h}=s[f],u=[];for(const t of e){if(!t.isXFAObject)continue;let e,s;if(i&&(s=l.get(t),s||(s=new Map,l.set(t,s)),e=s.get(r)),!e){switch(c){case o.dot:e=t[n.$getChildrenByName](a,!1);break;case o.dotDot:e=t[n.$getChildrenByName](a,!0);break;case o.dotHash:e=t[n.$getChildrenByClass](a),e=e.isXFAObjectArray?e.children:[e]}i&&s.set(r,e)}e.length>0&&u.push(e)}if(0!==u.length||d||0!==f)e=isFinite(h)?u.filter((e=>h<e.length)).map((e=>e[h])):u.flat();else{const a=t[n.$getParent]();if(!(t=a))return null;f=-1,e=[t]}}if(0===e.length)return null;return e};var n=a(78),r=a(2);const i=/^[^.[]+/,s=/^[^\]]+/,o={dot:0,dotDot:1,dotHash:2,dotBracket:3,dotParen:4},c=new Map([["$data",(e,t)=>e.datasets?e.datasets.data:e],["$record",(e,t)=>(e.datasets?e.datasets.data:e)[n.$getChildren]()[0]],["$template",(e,t)=>e.template],["$connectionSet",(e,t)=>e.connectionSet],["$form",(e,t)=>e.form],["$layout",(e,t)=>e.layout],["$host",(e,t)=>e.host],["$dataWindow",(e,t)=>e.dataWindow],["$event",(e,t)=>e.event],["!",(e,t)=>e.datasets],["$xfa",(e,t)=>e],["xfa",(e,t)=>e],["$",(e,t)=>t]]),l=new WeakMap;function h(e,t,a=!0){let n=e.match(i);if(!n)return null;let[c]=n;const l=[{name:c,cacheName:"."+c,index:0,js:null,formCalc:null,operator:o.dot}];let h=c.length;for(;h<e.length;){const d=h;if("["===e.charAt(h++)){if(n=e.slice(h).match(s),!n)return(0,r.warn)("XFA - Invalid index in SOM expression"),null;l.at(-1).index="*"===(u=(u=n[0]).trim())?1/0:parseInt(u,10)||0,h+=n[0].length+1;continue}let f;switch(e.charAt(h)){case".":if(!t)return null;h++,f=o.dotDot;break;case"#":h++,f=o.dotHash;break;case"[":if(a)return(0,r.warn)("XFA - SOM expression contains a FormCalc subexpression which is not supported for now."),null;f=o.dotBracket;break;case"(":if(a)return(0,r.warn)("XFA - SOM expression contains a JavaScript subexpression which is not supported for now."),null;f=o.dotParen;break;default:f=o.dot}if(n=e.slice(h).match(i),!n)break;[c]=n,h+=c.length,l.push({name:c,cacheName:e.slice(d,h),operator:f,index:0,js:null,formCalc:null})}var u;return l}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.DataHandler=void 0;var n=a(78);t.DataHandler=class{constructor(e,t){this.data=t,this.dataset=e.datasets||null}serialize(e){const t=[[-1,this.data[n.$getChildren]()]];for(;t.length>0;){const a=t.at(-1),[r,i]=a;if(r+1===i.length){t.pop();continue}const s=i[++a[0]],o=e.get(s[n.$uid]);if(o)s[n.$setValue](o);else{const t=s[n.$getAttributes]();for(const a of t.values()){const t=e.get(a[n.$uid]);if(t){a[n.$setValue](t);break}}}const c=s[n.$getChildren]();c.length>0&&t.push([-1,c])}const a=['<xfa:datasets xmlns:xfa="http://www.xfa.org/schema/xfa-data/1.0/">'];if(this.dataset)for(const e of this.dataset[n.$getChildren]())"data"!==e[n.$nodeName]&&e[n.$toString](a);return this.data[n.$toString](a),a.push("</xfa:datasets>"),a.join("")}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XFAParser=void 0;var n=a(78),r=a(71),i=a(91),s=a(2);class o extends r.XMLParserBase{constructor(e=null,t=!1){super(),this._builder=new i.Builder(e),this._stack=[],this._globalData={usedTypefaces:new Set},this._ids=new Map,this._current=this._builder.buildRoot(this._ids),this._errorCode=r.XMLParserErrorCode.NoError,this._whiteRegex=/^\s+$/,this._nbsps=/\xa0+/g,this._richText=t}parse(e){if(this.parseXml(e),this._errorCode===r.XMLParserErrorCode.NoError)return this._current[n.$finalize](),this._current.element}onText(e){e=e.replace(this._nbsps,(e=>e.slice(1)+" ")),this._richText||this._current[n.$acceptWhitespace]()?this._current[n.$onText](e,this._richText):this._whiteRegex.test(e)||this._current[n.$onText](e.trim())}onCdata(e){this._current[n.$onText](e)}_mkAttributes(e,t){let a=null,r=null;const i=Object.create({});for(const{name:o,value:c}of e)if("xmlns"===o)a?(0,s.warn)(`XFA - multiple namespace definition in <${t}>`):a=c;else if(o.startsWith("xmlns:")){const e=o.substring(6);r||(r=[]),r.push({prefix:e,value:c})}else{const e=o.indexOf(":");if(-1===e)i[o]=c;else{let t=i[n.$nsAttributes];t||(t=i[n.$nsAttributes]=Object.create(null));const[a,r]=[o.slice(0,e),o.slice(e+1)];(t[a]||=Object.create(null))[r]=c}}return[a,r,i]}_getNameAndPrefix(e,t){const a=e.indexOf(":");return-1===a?[e,null]:[e.substring(a+1),t?"":e.substring(0,a)]}onBeginElement(e,t,a){const[r,i,s]=this._mkAttributes(t,e),[o,c]=this._getNameAndPrefix(e,this._builder.isNsAgnostic()),l=this._builder.build({nsPrefix:c,name:o,attributes:s,namespace:r,prefixes:i});if(l[n.$globalData]=this._globalData,a)return l[n.$finalize](),this._current[n.$onChild](l)&&l[n.$setId](this._ids),void l[n.$clean](this._builder);this._stack.push(this._current),this._current=l}onEndElement(e){const t=this._current;if(t[n.$isCDATAXml]()&&"string"==typeof t[n.$content]){const e=new o;e._globalData=this._globalData;const a=e.parse(t[n.$content]);t[n.$content]=null,t[n.$onChild](a)}t[n.$finalize](),this._current=this._stack.pop(),this._current[n.$onChild](t)&&t[n.$setId](this._ids),t[n.$clean](this._builder)}onError(e){this._errorCode=e}}t.XFAParser=o},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.Builder=void 0;var n=a(81),r=a(78),i=a(92),s=a(80),o=a(101),c=a(2),l=a(87);class h extends l.XFAObject{constructor(e){super(-1,"root",Object.create(null)),this.element=null,this[r.$ids]=e}[r.$onChild](e){return this.element=e,!0}[r.$finalize](){super[r.$finalize](),this.element.template instanceof s.Template&&(this[r.$ids].set(r.$root,this.element),this.element.template[r.$resolvePrototypes](this[r.$ids]),this.element.template[r.$ids]=this[r.$ids])}}class u extends l.XFAObject{constructor(){super(-1,"",Object.create(null))}[r.$onChild](e){return!1}}t.Builder=class{constructor(e=null){this._namespaceStack=[],this._nsAgnosticLevel=0,this._namespacePrefixes=new Map,this._namespaces=new Map,this._nextNsId=Math.max(...Object.values(n.NamespaceIds).map((({id:e})=>e))),this._currentNamespace=e||new o.UnknownNamespace(++this._nextNsId)}buildRoot(e){return new h(e)}build({nsPrefix:e,name:t,attributes:a,namespace:s,prefixes:o}){const c=null!==s;if(c&&(this._namespaceStack.push(this._currentNamespace),this._currentNamespace=this._searchNamespace(s)),o&&this._addNamespacePrefix(o),a.hasOwnProperty(r.$nsAttributes)){const e=i.NamespaceSetUp.datasets,t=a[r.$nsAttributes];let n=null;for(const[a,r]of Object.entries(t)){if(this._getNamespaceToUse(a)===e){n={xfa:r};break}}n?a[r.$nsAttributes]=n:delete a[r.$nsAttributes]}const l=this._getNamespaceToUse(e),h=l?.[n.$buildXFAObject](t,a)||new u;return h[r.$isNsAgnostic]()&&this._nsAgnosticLevel++,(c||o||h[r.$isNsAgnostic]())&&(h[r.$cleanup]={hasNamespace:c,prefixes:o,nsAgnostic:h[r.$isNsAgnostic]()}),h}isNsAgnostic(){return this._nsAgnosticLevel>0}_searchNamespace(e){let t=this._namespaces.get(e);if(t)return t;for(const[a,{check:r}]of Object.entries(n.NamespaceIds))if(r(e)){if(t=i.NamespaceSetUp[a],t)return this._namespaces.set(e,t),t;break}return t=new o.UnknownNamespace(++this._nextNsId),this._namespaces.set(e,t),t}_addNamespacePrefix(e){for(const{prefix:t,value:a}of e){const e=this._searchNamespace(a);let n=this._namespacePrefixes.get(t);n||(n=[],this._namespacePrefixes.set(t,n)),n.push(e)}}_getNamespaceToUse(e){if(!e)return this._currentNamespace;const t=this._namespacePrefixes.get(e);return t?.length>0?t.at(-1):((0,c.warn)(`Unknown namespace prefix: ${e}.`),null)}clean(e){const{hasNamespace:t,prefixes:a,nsAgnostic:n}=e;t&&(this._currentNamespace=this._namespaceStack.pop()),a&&a.forEach((({prefix:e})=>{this._namespacePrefixes.get(e).pop()})),n&&this._nsAgnosticLevel--}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.NamespaceSetUp=void 0;var n=a(93),r=a(94),i=a(95),s=a(96),o=a(97),c=a(98),l=a(80),h=a(99),u=a(100);const d={config:n.ConfigNamespace,connection:r.ConnectionSetNamespace,datasets:i.DatasetsNamespace,localeSet:s.LocaleSetNamespace,signature:o.SignatureNamespace,stylesheet:c.StylesheetNamespace,template:l.TemplateNamespace,xdp:h.XdpNamespace,xhtml:u.XhtmlNamespace};t.NamespaceSetUp=d},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigNamespace=void 0;var n=a(81),r=a(78),i=a(87),s=a(84),o=a(2);const c=n.NamespaceIds.config.id;class l extends i.XFAObject{constructor(e){super(c,"acrobat",!0),this.acrobat7=null,this.autoSave=null,this.common=null,this.validate=null,this.validateApprovalSignatures=null,this.submitUrl=new i.XFAObjectArray}}class h extends i.XFAObject{constructor(e){super(c,"acrobat7",!0),this.dynamicRender=null}}class u extends i.OptionObject{constructor(e){super(c,"ADBE_JSConsole",["delegate","Enable","Disable"])}}class d extends i.OptionObject{constructor(e){super(c,"ADBE_JSDebugger",["delegate","Enable","Disable"])}}class f extends i.Option01{constructor(e){super(c,"addSilentPrint")}}class g extends i.Option01{constructor(e){super(c,"addViewerPreferences")}}class p extends i.Option10{constructor(e){super(c,"adjustData")}}class m extends i.IntegerObject{constructor(e){super(c,"adobeExtensionLevel",0,(e=>e>=1&&e<=8))}}class b extends i.XFAObject{constructor(e){super(c,"agent",!0),this.name=e.name?e.name.trim():"",this.common=new i.XFAObjectArray}}class y extends i.ContentObject{constructor(e){super(c,"alwaysEmbed")}}class w extends i.StringObject{constructor(e){super(c,"amd")}}class x extends i.XFAObject{constructor(e){super(c,"area"),this.level=(0,s.getInteger)({data:e.level,defaultValue:0,validate:e=>e>=1&&e<=3}),this.name=(0,s.getStringOption)(e.name,["","barcode","coreinit","deviceDriver","font","general","layout","merge","script","signature","sourceSet","templateCache"])}}class S extends i.OptionObject{constructor(e){super(c,"attributes",["preserve","delegate","ignore"])}}class A extends i.OptionObject{constructor(e){super(c,"autoSave",["disabled","enabled"])}}class k extends i.StringObject{constructor(e){super(c,"base")}}class C extends i.XFAObject{constructor(e){super(c,"batchOutput"),this.format=(0,s.getStringOption)(e.format,["none","concat","zip","zipCompress"])}}class v extends i.ContentObject{constructor(e){super(c,"behaviorOverride")}[r.$finalize](){this[r.$content]=new Map(this[r.$content].trim().split(/\s+/).filter((e=>e.includes(":"))).map((e=>e.split(":",2))))}}class F extends i.XFAObject{constructor(e){super(c,"cache",!0),this.templateCache=null}}class O extends i.Option01{constructor(e){super(c,"change")}}class I extends i.XFAObject{constructor(e){super(c,"common",!0),this.data=null,this.locale=null,this.localeSet=null,this.messaging=null,this.suppressBanner=null,this.template=null,this.validationMessaging=null,this.versionControl=null,this.log=new i.XFAObjectArray}}class T extends i.XFAObject{constructor(e){super(c,"compress"),this.scope=(0,s.getStringOption)(e.scope,["imageOnly","document"])}}class M extends i.Option01{constructor(e){super(c,"compressLogicalStructure")}}class P extends i.Option10{constructor(e){super(c,"compressObjectStream")}}class N extends i.XFAObject{constructor(e){super(c,"compression",!0),this.compressLogicalStructure=null,this.compressObjectStream=null,this.level=null,this.type=null}}class D extends i.XFAObject{constructor(e){super(c,"config",!0),this.acrobat=null,this.present=null,this.trace=null,this.agent=new i.XFAObjectArray}}class R extends i.OptionObject{constructor(e){super(c,"conformance",["A","B"])}}class E extends i.Option01{constructor(e){super(c,"contentCopy")}}class B extends i.IntegerObject{constructor(e){super(c,"copies",1,(e=>e>=1))}}class $ extends i.StringObject{constructor(e){super(c,"creator")}}class L extends i.IntegerObject{constructor(e){super(c,"currentPage",0,(e=>e>=0))}}class _ extends i.XFAObject{constructor(e){super(c,"data",!0),this.adjustData=null,this.attributes=null,this.incrementalLoad=null,this.outputXSL=null,this.range=null,this.record=null,this.startNode=null,this.uri=null,this.window=null,this.xsl=null,this.excludeNS=new i.XFAObjectArray,this.transform=new i.XFAObjectArray}}class j extends i.XFAObject{constructor(e){super(c,"debug",!0),this.uri=null}}class U extends i.ContentObject{constructor(e){super(c,"defaultTypeface"),this.writingScript=(0,s.getStringOption)(e.writingScript,["*","Arabic","Cyrillic","EastEuropeanRoman","Greek","Hebrew","Japanese","Korean","Roman","SimplifiedChinese","Thai","TraditionalChinese","Vietnamese"])}}class X extends i.OptionObject{constructor(e){super(c,"destination",["pdf","pcl","ps","webClient","zpl"])}}class H extends i.Option01{constructor(e){super(c,"documentAssembly")}}class q extends i.XFAObject{constructor(e){super(c,"driver",!0),this.name=e.name?e.name.trim():"",this.fontInfo=null,this.xdc=null}}class z extends i.OptionObject{constructor(e){super(c,"duplexOption",["simplex","duplexFlipLongEdge","duplexFlipShortEdge"])}}class G extends i.OptionObject{constructor(e){super(c,"dynamicRender",["forbidden","required"])}}class W extends i.Option01{constructor(e){super(c,"embed")}}class V extends i.Option01{constructor(e){super(c,"encrypt")}}class K extends i.XFAObject{constructor(e){super(c,"encryption",!0),this.encrypt=null,this.encryptionLevel=null,this.permissions=null}}class Y extends i.OptionObject{constructor(e){super(c,"encryptionLevel",["40bit","128bit"])}}class J extends i.StringObject{constructor(e){super(c,"enforce")}}class Z extends i.XFAObject{constructor(e){super(c,"equate"),this.force=(0,s.getInteger)({data:e.force,defaultValue:1,validate:e=>0===e}),this.from=e.from||"",this.to=e.to||""}}class Q extends i.XFAObject{constructor(e){super(c,"equateRange"),this.from=e.from||"",this.to=e.to||"",this._unicodeRange=e.unicodeRange||""}get unicodeRange(){const e=[],t=/U\+([0-9a-fA-F]+)/,a=this._unicodeRange;for(let n of a.split(",").map((e=>e.trim())).filter((e=>!!e)))n=n.split("-",2).map((e=>{const a=e.match(t);return a?parseInt(a[1],16):0})),1===n.length&&n.push(n[0]),e.push(n);return(0,o.shadow)(this,"unicodeRange",e)}}class ee extends i.ContentObject{constructor(e){super(c,"exclude")}[r.$finalize](){this[r.$content]=this[r.$content].trim().split(/\s+/).filter((e=>e&&["calculate","close","enter","exit","initialize","ready","validate"].includes(e)))}}class te extends i.StringObject{constructor(e){super(c,"excludeNS")}}class ae extends i.OptionObject{constructor(e){super(c,"flipLabel",["usePrinterSetting","on","off"])}}class ne extends i.XFAObject{constructor(e){super(c,"fontInfo",!0),this.embed=null,this.map=null,this.subsetBelow=null,this.alwaysEmbed=new i.XFAObjectArray,this.defaultTypeface=new i.XFAObjectArray,this.neverEmbed=new i.XFAObjectArray}}class re extends i.Option01{constructor(e){super(c,"formFieldFilling")}}class ie extends i.StringObject{constructor(e){super(c,"groupParent")}}class se extends i.OptionObject{constructor(e){super(c,"ifEmpty",["dataValue","dataGroup","ignore","remove"])}}class oe extends i.StringObject{constructor(e){super(c,"includeXDPContent")}}class ce extends i.OptionObject{constructor(e){super(c,"incrementalLoad",["none","forwardOnly"])}}class le extends i.Option01{constructor(e){super(c,"incrementalMerge")}}class he extends i.Option01{constructor(e){super(c,"interactive")}}class ue extends i.OptionObject{constructor(e){super(c,"jog",["usePrinterSetting","none","pageSet"])}}class de extends i.XFAObject{constructor(e){super(c,"labelPrinter",!0),this.name=(0,s.getStringOption)(e.name,["zpl","dpl","ipl","tcpl"]),this.batchOutput=null,this.flipLabel=null,this.fontInfo=null,this.xdc=null}}class fe extends i.OptionObject{constructor(e){super(c,"layout",["paginate","panel"])}}class ge extends i.IntegerObject{constructor(e){super(c,"level",0,(e=>e>0))}}class pe extends i.Option01{constructor(e){super(c,"linearized")}}class me extends i.StringObject{constructor(e){super(c,"locale")}}class be extends i.StringObject{constructor(e){super(c,"localeSet")}}class ye extends i.XFAObject{constructor(e){super(c,"log",!0),this.mode=null,this.threshold=null,this.to=null,this.uri=null}}class we extends i.XFAObject{constructor(e){super(c,"map",!0),this.equate=new i.XFAObjectArray,this.equateRange=new i.XFAObjectArray}}class xe extends i.XFAObject{constructor(e){super(c,"mediumInfo",!0),this.map=null}}class Se extends i.XFAObject{constructor(e){super(c,"message",!0),this.msgId=null,this.severity=null}}class Ae extends i.XFAObject{constructor(e){super(c,"messaging",!0),this.message=new i.XFAObjectArray}}class ke extends i.OptionObject{constructor(e){super(c,"mode",["append","overwrite"])}}class Ce extends i.Option01{constructor(e){super(c,"modifyAnnots")}}class ve extends i.IntegerObject{constructor(e){super(c,"msgId",1,(e=>e>=1))}}class Fe extends i.StringObject{constructor(e){super(c,"nameAttr")}}class Oe extends i.ContentObject{constructor(e){super(c,"neverEmbed")}}class Ie extends i.IntegerObject{constructor(e){super(c,"numberOfCopies",null,(e=>e>=2&&e<=5))}}class Te extends i.XFAObject{constructor(e){super(c,"openAction",!0),this.destination=null}}class Me extends i.XFAObject{constructor(e){super(c,"output",!0),this.to=null,this.type=null,this.uri=null}}class Pe extends i.StringObject{constructor(e){super(c,"outputBin")}}class Ne extends i.XFAObject{constructor(e){super(c,"outputXSL",!0),this.uri=null}}class De extends i.OptionObject{constructor(e){super(c,"overprint",["none","both","draw","field"])}}class Re extends i.StringObject{constructor(e){super(c,"packets")}[r.$finalize](){"*"!==this[r.$content]&&(this[r.$content]=this[r.$content].trim().split(/\s+/).filter((e=>["config","datasets","template","xfdf","xslt"].includes(e))))}}class Ee extends i.XFAObject{constructor(e){super(c,"pageOffset"),this.x=(0,s.getInteger)({data:e.x,defaultValue:"useXDCSetting",validate:e=>!0}),this.y=(0,s.getInteger)({data:e.y,defaultValue:"useXDCSetting",validate:e=>!0})}}class Be extends i.StringObject{constructor(e){super(c,"pageRange")}[r.$finalize](){const e=this[r.$content].trim().split(/\s+/).map((e=>parseInt(e,10))),t=[];for(let a=0,n=e.length;a<n;a+=2)t.push(e.slice(a,a+2));this[r.$content]=t}}class $e extends i.OptionObject{constructor(e){super(c,"pagination",["simplex","duplexShortEdge","duplexLongEdge"])}}class Le extends i.OptionObject{constructor(e){super(c,"paginationOverride",["none","forceDuplex","forceDuplexLongEdge","forceDuplexShortEdge","forceSimplex"])}}class _e extends i.IntegerObject{constructor(e){super(c,"part",1,(e=>!1))}}class je extends i.XFAObject{constructor(e){super(c,"pcl",!0),this.name=e.name||"",this.batchOutput=null,this.fontInfo=null,this.jog=null,this.mediumInfo=null,this.outputBin=null,this.pageOffset=null,this.staple=null,this.xdc=null}}class Ue extends i.XFAObject{constructor(e){super(c,"pdf",!0),this.name=e.name||"",this.adobeExtensionLevel=null,this.batchOutput=null,this.compression=null,this.creator=null,this.encryption=null,this.fontInfo=null,this.interactive=null,this.linearized=null,this.openAction=null,this.pdfa=null,this.producer=null,this.renderPolicy=null,this.scriptModel=null,this.silentPrint=null,this.submitFormat=null,this.tagged=null,this.version=null,this.viewerPreferences=null,this.xdc=null}}class Xe extends i.XFAObject{constructor(e){super(c,"pdfa",!0),this.amd=null,this.conformance=null,this.includeXDPContent=null,this.part=null}}class He extends i.XFAObject{constructor(e){super(c,"permissions",!0),this.accessibleContent=null,this.change=null,this.contentCopy=null,this.documentAssembly=null,this.formFieldFilling=null,this.modifyAnnots=null,this.plaintextMetadata=null,this.print=null,this.printHighQuality=null}}class qe extends i.Option01{constructor(e){super(c,"pickTrayByPDFSize")}}class ze extends i.StringObject{constructor(e){super(c,"picture")}}class Ge extends i.Option01{constructor(e){super(c,"plaintextMetadata")}}class We extends i.OptionObject{constructor(e){super(c,"presence",["preserve","dissolve","dissolveStructure","ignore","remove"])}}class Ve extends i.XFAObject{constructor(e){super(c,"present",!0),this.behaviorOverride=null,this.cache=null,this.common=null,this.copies=null,this.destination=null,this.incrementalMerge=null,this.layout=null,this.output=null,this.overprint=null,this.pagination=null,this.paginationOverride=null,this.script=null,this.validate=null,this.xdp=null,this.driver=new i.XFAObjectArray,this.labelPrinter=new i.XFAObjectArray,this.pcl=new i.XFAObjectArray,this.pdf=new i.XFAObjectArray,this.ps=new i.XFAObjectArray,this.submitUrl=new i.XFAObjectArray,this.webClient=new i.XFAObjectArray,this.zpl=new i.XFAObjectArray}}class Ke extends i.Option01{constructor(e){super(c,"print")}}class Ye extends i.Option01{constructor(e){super(c,"printHighQuality")}}class Je extends i.OptionObject{constructor(e){super(c,"printScaling",["appdefault","noScaling"])}}class Ze extends i.StringObject{constructor(e){super(c,"printerName")}}class Qe extends i.StringObject{constructor(e){super(c,"producer")}}class et extends i.XFAObject{constructor(e){super(c,"ps",!0),this.name=e.name||"",this.batchOutput=null,this.fontInfo=null,this.jog=null,this.mediumInfo=null,this.outputBin=null,this.staple=null,this.xdc=null}}class tt extends i.ContentObject{constructor(e){super(c,"range")}[r.$finalize](){this[r.$content]=this[r.$content].trim().split(/\s*,\s*/,2).map((e=>e.split("-").map((e=>parseInt(e.trim(),10))))).filter((e=>e.every((e=>!isNaN(e))))).map((e=>(1===e.length&&e.push(e[0]),e)))}}class at extends i.ContentObject{constructor(e){super(c,"record")}[r.$finalize](){this[r.$content]=this[r.$content].trim();const e=parseInt(this[r.$content],10);!isNaN(e)&&e>=0&&(this[r.$content]=e)}}class nt extends i.ContentObject{constructor(e){super(c,"relevant")}[r.$finalize](){this[r.$content]=this[r.$content].trim().split(/\s+/)}}class rt extends i.ContentObject{constructor(e){super(c,"rename")}[r.$finalize](){this[r.$content]=this[r.$content].trim(),(this[r.$content].toLowerCase().startsWith("xml")||new RegExp("[\\p{L}_][\\p{L}\\d._\\p{M}-]*","u").test(this[r.$content]))&&(0,o.warn)("XFA - Rename: invalid XFA name")}}class it extends i.OptionObject{constructor(e){super(c,"renderPolicy",["server","client"])}}class st extends i.OptionObject{constructor(e){super(c,"runScripts",["both","client","none","server"])}}class ot extends i.XFAObject{constructor(e){super(c,"script",!0),this.currentPage=null,this.exclude=null,this.runScripts=null}}class ct extends i.OptionObject{constructor(e){super(c,"scriptModel",["XFA","none"])}}class lt extends i.OptionObject{constructor(e){super(c,"severity",["ignore","error","information","trace","warning"])}}class ht extends i.XFAObject{constructor(e){super(c,"silentPrint",!0),this.addSilentPrint=null,this.printerName=null}}class ut extends i.XFAObject{constructor(e){super(c,"staple"),this.mode=(0,s.getStringOption)(e.mode,["usePrinterSetting","on","off"])}}class dt extends i.StringObject{constructor(e){super(c,"startNode")}}class ft extends i.IntegerObject{constructor(e){super(c,"startPage",0,(e=>!0))}}class gt extends i.OptionObject{constructor(e){super(c,"submitFormat",["html","delegate","fdf","xml","pdf"])}}class pt extends i.StringObject{constructor(e){super(c,"submitUrl")}}class mt extends i.IntegerObject{constructor(e){super(c,"subsetBelow",100,(e=>e>=0&&e<=100))}}class bt extends i.Option01{constructor(e){super(c,"suppressBanner")}}class yt extends i.Option01{constructor(e){super(c,"tagged")}}class wt extends i.XFAObject{constructor(e){super(c,"template",!0),this.base=null,this.relevant=null,this.startPage=null,this.uri=null,this.xsl=null}}class xt extends i.OptionObject{constructor(e){super(c,"threshold",["trace","error","information","warning"])}}class St extends i.OptionObject{constructor(e){super(c,"to",["null","memory","stderr","stdout","system","uri"])}}class At extends i.XFAObject{constructor(e){super(c,"templateCache"),this.maxEntries=(0,s.getInteger)({data:e.maxEntries,defaultValue:5,validate:e=>e>=0})}}class kt extends i.XFAObject{constructor(e){super(c,"trace",!0),this.area=new i.XFAObjectArray}}class Ct extends i.XFAObject{constructor(e){super(c,"transform",!0),this.groupParent=null,this.ifEmpty=null,this.nameAttr=null,this.picture=null,this.presence=null,this.rename=null,this.whitespace=null}}class vt extends i.OptionObject{constructor(e){super(c,"type",["none","ascii85","asciiHex","ccittfax","flate","lzw","runLength","native","xdp","mergedXDP"])}}class Ft extends i.StringObject{constructor(e){super(c,"uri")}}class Ot extends i.OptionObject{constructor(e){super(c,"validate",["preSubmit","prePrint","preExecute","preSave"])}}class It extends i.ContentObject{constructor(e){super(c,"validateApprovalSignatures")}[r.$finalize](){this[r.$content]=this[r.$content].trim().split(/\s+/).filter((e=>["docReady","postSign"].includes(e)))}}class Tt extends i.OptionObject{constructor(e){super(c,"validationMessaging",["allMessagesIndividually","allMessagesTogether","firstMessageOnly","noMessages"])}}class Mt extends i.OptionObject{constructor(e){super(c,"version",["1.7","1.6","1.5","1.4","1.3","1.2"])}}class Pt extends i.XFAObject{constructor(e){super(c,"VersionControl"),this.outputBelow=(0,s.getStringOption)(e.outputBelow,["warn","error","update"]),this.sourceAbove=(0,s.getStringOption)(e.sourceAbove,["warn","error"]),this.sourceBelow=(0,s.getStringOption)(e.sourceBelow,["update","maintain"])}}class Nt extends i.XFAObject{constructor(e){super(c,"viewerPreferences",!0),this.ADBE_JSConsole=null,this.ADBE_JSDebugger=null,this.addViewerPreferences=null,this.duplexOption=null,this.enforce=null,this.numberOfCopies=null,this.pageRange=null,this.pickTrayByPDFSize=null,this.printScaling=null}}class Dt extends i.XFAObject{constructor(e){super(c,"webClient",!0),this.name=e.name?e.name.trim():"",this.fontInfo=null,this.xdc=null}}class Rt extends i.OptionObject{constructor(e){super(c,"whitespace",["preserve","ltrim","normalize","rtrim","trim"])}}class Et extends i.ContentObject{constructor(e){super(c,"window")}[r.$finalize](){const e=this[r.$content].trim().split(/\s*,\s*/,2).map((e=>parseInt(e,10)));e.some((e=>isNaN(e)))?this[r.$content]=[0,0]:(1===e.length&&e.push(e[0]),this[r.$content]=e)}}class Bt extends i.XFAObject{constructor(e){super(c,"xdc",!0),this.uri=new i.XFAObjectArray,this.xsl=new i.XFAObjectArray}}class $t extends i.XFAObject{constructor(e){super(c,"xdp",!0),this.packets=null}}class Lt extends i.XFAObject{constructor(e){super(c,"xsl",!0),this.debug=null,this.uri=null}}class _t extends i.XFAObject{constructor(e){super(c,"zpl",!0),this.name=e.name?e.name.trim():"",this.batchOutput=null,this.flipLabel=null,this.fontInfo=null,this.xdc=null}}class jt{static[n.$buildXFAObject](e,t){if(jt.hasOwnProperty(e))return jt[e](t)}static acrobat(e){return new l(e)}static acrobat7(e){return new h(e)}static ADBE_JSConsole(e){return new u(e)}static ADBE_JSDebugger(e){return new d(e)}static addSilentPrint(e){return new f(e)}static addViewerPreferences(e){return new g(e)}static adjustData(e){return new p(e)}static adobeExtensionLevel(e){return new m(e)}static agent(e){return new b(e)}static alwaysEmbed(e){return new y(e)}static amd(e){return new w(e)}static area(e){return new x(e)}static attributes(e){return new S(e)}static autoSave(e){return new A(e)}static base(e){return new k(e)}static batchOutput(e){return new C(e)}static behaviorOverride(e){return new v(e)}static cache(e){return new F(e)}static change(e){return new O(e)}static common(e){return new I(e)}static compress(e){return new T(e)}static compressLogicalStructure(e){return new M(e)}static compressObjectStream(e){return new P(e)}static compression(e){return new N(e)}static config(e){return new D(e)}static conformance(e){return new R(e)}static contentCopy(e){return new E(e)}static copies(e){return new B(e)}static creator(e){return new $(e)}static currentPage(e){return new L(e)}static data(e){return new _(e)}static debug(e){return new j(e)}static defaultTypeface(e){return new U(e)}static destination(e){return new X(e)}static documentAssembly(e){return new H(e)}static driver(e){return new q(e)}static duplexOption(e){return new z(e)}static dynamicRender(e){return new G(e)}static embed(e){return new W(e)}static encrypt(e){return new V(e)}static encryption(e){return new K(e)}static encryptionLevel(e){return new Y(e)}static enforce(e){return new J(e)}static equate(e){return new Z(e)}static equateRange(e){return new Q(e)}static exclude(e){return new ee(e)}static excludeNS(e){return new te(e)}static flipLabel(e){return new ae(e)}static fontInfo(e){return new ne(e)}static formFieldFilling(e){return new re(e)}static groupParent(e){return new ie(e)}static ifEmpty(e){return new se(e)}static includeXDPContent(e){return new oe(e)}static incrementalLoad(e){return new ce(e)}static incrementalMerge(e){return new le(e)}static interactive(e){return new he(e)}static jog(e){return new ue(e)}static labelPrinter(e){return new de(e)}static layout(e){return new fe(e)}static level(e){return new ge(e)}static linearized(e){return new pe(e)}static locale(e){return new me(e)}static localeSet(e){return new be(e)}static log(e){return new ye(e)}static map(e){return new we(e)}static mediumInfo(e){return new xe(e)}static message(e){return new Se(e)}static messaging(e){return new Ae(e)}static mode(e){return new ke(e)}static modifyAnnots(e){return new Ce(e)}static msgId(e){return new ve(e)}static nameAttr(e){return new Fe(e)}static neverEmbed(e){return new Oe(e)}static numberOfCopies(e){return new Ie(e)}static openAction(e){return new Te(e)}static output(e){return new Me(e)}static outputBin(e){return new Pe(e)}static outputXSL(e){return new Ne(e)}static overprint(e){return new De(e)}static packets(e){return new Re(e)}static pageOffset(e){return new Ee(e)}static pageRange(e){return new Be(e)}static pagination(e){return new $e(e)}static paginationOverride(e){return new Le(e)}static part(e){return new _e(e)}static pcl(e){return new je(e)}static pdf(e){return new Ue(e)}static pdfa(e){return new Xe(e)}static permissions(e){return new He(e)}static pickTrayByPDFSize(e){return new qe(e)}static picture(e){return new ze(e)}static plaintextMetadata(e){return new Ge(e)}static presence(e){return new We(e)}static present(e){return new Ve(e)}static print(e){return new Ke(e)}static printHighQuality(e){return new Ye(e)}static printScaling(e){return new Je(e)}static printerName(e){return new Ze(e)}static producer(e){return new Qe(e)}static ps(e){return new et(e)}static range(e){return new tt(e)}static record(e){return new at(e)}static relevant(e){return new nt(e)}static rename(e){return new rt(e)}static renderPolicy(e){return new it(e)}static runScripts(e){return new st(e)}static script(e){return new ot(e)}static scriptModel(e){return new ct(e)}static severity(e){return new lt(e)}static silentPrint(e){return new ht(e)}static staple(e){return new ut(e)}static startNode(e){return new dt(e)}static startPage(e){return new ft(e)}static submitFormat(e){return new gt(e)}static submitUrl(e){return new pt(e)}static subsetBelow(e){return new mt(e)}static suppressBanner(e){return new bt(e)}static tagged(e){return new yt(e)}static template(e){return new wt(e)}static templateCache(e){return new At(e)}static threshold(e){return new xt(e)}static to(e){return new St(e)}static trace(e){return new kt(e)}static transform(e){return new Ct(e)}static type(e){return new vt(e)}static uri(e){return new Ft(e)}static validate(e){return new Ot(e)}static validateApprovalSignatures(e){return new It(e)}static validationMessaging(e){return new Tt(e)}static version(e){return new Mt(e)}static versionControl(e){return new Pt(e)}static viewerPreferences(e){return new Nt(e)}static webClient(e){return new Dt(e)}static whitespace(e){return new Rt(e)}static window(e){return new Et(e)}static xdc(e){return new Bt(e)}static xdp(e){return new $t(e)}static xsl(e){return new Lt(e)}static zpl(e){return new _t(e)}}t.ConfigNamespace=jt},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.ConnectionSetNamespace=void 0;var n=a(81),r=a(87);const i=n.NamespaceIds.connectionSet.id;class s extends r.XFAObject{constructor(e){super(i,"connectionSet",!0),this.wsdlConnection=new r.XFAObjectArray,this.xmlConnection=new r.XFAObjectArray,this.xsdConnection=new r.XFAObjectArray}}class o extends r.XFAObject{constructor(e){super(i,"effectiveInputPolicy"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class c extends r.XFAObject{constructor(e){super(i,"effectiveOutputPolicy"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class l extends r.StringObject{constructor(e){super(i,"operation"),this.id=e.id||"",this.input=e.input||"",this.name=e.name||"",this.output=e.output||"",this.use=e.use||"",this.usehref=e.usehref||""}}class h extends r.StringObject{constructor(e){super(i,"rootElement"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class u extends r.StringObject{constructor(e){super(i,"soapAction"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class d extends r.StringObject{constructor(e){super(i,"soapAddress"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class f extends r.StringObject{constructor(e){super(i,"uri"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class g extends r.StringObject{constructor(e){super(i,"wsdlAddress"),this.id=e.id||"",this.name=e.name||"",this.use=e.use||"",this.usehref=e.usehref||""}}class p extends r.XFAObject{constructor(e){super(i,"wsdlConnection",!0),this.dataDescription=e.dataDescription||"",this.name=e.name||"",this.effectiveInputPolicy=null,this.effectiveOutputPolicy=null,this.operation=null,this.soapAction=null,this.soapAddress=null,this.wsdlAddress=null}}class m extends r.XFAObject{constructor(e){super(i,"xmlConnection",!0),this.dataDescription=e.dataDescription||"",this.name=e.name||"",this.uri=null}}class b extends r.XFAObject{constructor(e){super(i,"xsdConnection",!0),this.dataDescription=e.dataDescription||"",this.name=e.name||"",this.rootElement=null,this.uri=null}}class y{static[n.$buildXFAObject](e,t){if(y.hasOwnProperty(e))return y[e](t)}static connectionSet(e){return new s(e)}static effectiveInputPolicy(e){return new o(e)}static effectiveOutputPolicy(e){return new c(e)}static operation(e){return new l(e)}static rootElement(e){return new h(e)}static soapAction(e){return new u(e)}static soapAddress(e){return new d(e)}static uri(e){return new f(e)}static wsdlAddress(e){return new g(e)}static wsdlConnection(e){return new p(e)}static xmlConnection(e){return new m(e)}static xsdConnection(e){return new b(e)}}t.ConnectionSetNamespace=y},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.DatasetsNamespace=void 0;var n=a(78),r=a(81),i=a(87);const s=r.NamespaceIds.datasets.id;class o extends i.XmlObject{constructor(e){super(s,"data",e)}[n.$isNsAgnostic](){return!0}}class c extends i.XFAObject{constructor(e){super(s,"datasets",!0),this.data=null,this.Signature=null}[n.$onChild](e){const t=e[n.$nodeName];("data"===t&&e[n.$namespaceId]===s||"Signature"===t&&e[n.$namespaceId]===r.NamespaceIds.signature.id)&&(this[t]=e),this[n.$appendChild](e)}}class l{static[r.$buildXFAObject](e,t){if(l.hasOwnProperty(e))return l[e](t)}static datasets(e){return new c(e)}static data(e){return new o(e)}}t.DatasetsNamespace=l},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.LocaleSetNamespace=void 0;var n=a(81),r=a(87),i=a(84);const s=n.NamespaceIds.localeSet.id;class o extends r.XFAObject{constructor(e){super(s,"calendarSymbols",!0),this.name="gregorian",this.dayNames=new r.XFAObjectArray(2),this.eraNames=null,this.meridiemNames=null,this.monthNames=new r.XFAObjectArray(2)}}class c extends r.StringObject{constructor(e){super(s,"currencySymbol"),this.name=(0,i.getStringOption)(e.name,["symbol","isoname","decimal"])}}class l extends r.XFAObject{constructor(e){super(s,"currencySymbols",!0),this.currencySymbol=new r.XFAObjectArray(3)}}class h extends r.StringObject{constructor(e){super(s,"datePattern"),this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class u extends r.XFAObject{constructor(e){super(s,"datePatterns",!0),this.datePattern=new r.XFAObjectArray(4)}}class d extends r.ContentObject{constructor(e){super(s,"dateTimeSymbols")}}class f extends r.StringObject{constructor(e){super(s,"day")}}class g extends r.XFAObject{constructor(e){super(s,"dayNames",!0),this.abbr=(0,i.getInteger)({data:e.abbr,defaultValue:0,validate:e=>1===e}),this.day=new r.XFAObjectArray(7)}}class p extends r.StringObject{constructor(e){super(s,"era")}}class m extends r.XFAObject{constructor(e){super(s,"eraNames",!0),this.era=new r.XFAObjectArray(2)}}class b extends r.XFAObject{constructor(e){super(s,"locale",!0),this.desc=e.desc||"",this.name="isoname",this.calendarSymbols=null,this.currencySymbols=null,this.datePatterns=null,this.dateTimeSymbols=null,this.numberPatterns=null,this.numberSymbols=null,this.timePatterns=null,this.typeFaces=null}}class y extends r.XFAObject{constructor(e){super(s,"localeSet",!0),this.locale=new r.XFAObjectArray}}class w extends r.StringObject{constructor(e){super(s,"meridiem")}}class x extends r.XFAObject{constructor(e){super(s,"meridiemNames",!0),this.meridiem=new r.XFAObjectArray(2)}}class S extends r.StringObject{constructor(e){super(s,"month")}}class A extends r.XFAObject{constructor(e){super(s,"monthNames",!0),this.abbr=(0,i.getInteger)({data:e.abbr,defaultValue:0,validate:e=>1===e}),this.month=new r.XFAObjectArray(12)}}class k extends r.StringObject{constructor(e){super(s,"numberPattern"),this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class C extends r.XFAObject{constructor(e){super(s,"numberPatterns",!0),this.numberPattern=new r.XFAObjectArray(4)}}class v extends r.StringObject{constructor(e){super(s,"numberSymbol"),this.name=(0,i.getStringOption)(e.name,["decimal","grouping","percent","minus","zero"])}}class F extends r.XFAObject{constructor(e){super(s,"numberSymbols",!0),this.numberSymbol=new r.XFAObjectArray(5)}}class O extends r.StringObject{constructor(e){super(s,"timePattern"),this.name=(0,i.getStringOption)(e.name,["full","long","med","short"])}}class I extends r.XFAObject{constructor(e){super(s,"timePatterns",!0),this.timePattern=new r.XFAObjectArray(4)}}class T extends r.XFAObject{constructor(e){super(s,"typeFace",!0),this.name=""|e.name}}class M extends r.XFAObject{constructor(e){super(s,"typeFaces",!0),this.typeFace=new r.XFAObjectArray}}class P{static[n.$buildXFAObject](e,t){if(P.hasOwnProperty(e))return P[e](t)}static calendarSymbols(e){return new o(e)}static currencySymbol(e){return new c(e)}static currencySymbols(e){return new l(e)}static datePattern(e){return new h(e)}static datePatterns(e){return new u(e)}static dateTimeSymbols(e){return new d(e)}static day(e){return new f(e)}static dayNames(e){return new g(e)}static era(e){return new p(e)}static eraNames(e){return new m(e)}static locale(e){return new b(e)}static localeSet(e){return new y(e)}static meridiem(e){return new w(e)}static meridiemNames(e){return new x(e)}static month(e){return new S(e)}static monthNames(e){return new A(e)}static numberPattern(e){return new k(e)}static numberPatterns(e){return new C(e)}static numberSymbol(e){return new v(e)}static numberSymbols(e){return new F(e)}static timePattern(e){return new O(e)}static timePatterns(e){return new I(e)}static typeFace(e){return new T(e)}static typeFaces(e){return new M(e)}}t.LocaleSetNamespace=P},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.SignatureNamespace=void 0;var n=a(81),r=a(87);const i=n.NamespaceIds.signature.id;class s extends r.XFAObject{constructor(e){super(i,"signature",!0)}}class o{static[n.$buildXFAObject](e,t){if(o.hasOwnProperty(e))return o[e](t)}static signature(e){return new s(e)}}t.SignatureNamespace=o},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.StylesheetNamespace=void 0;var n=a(81),r=a(87);const i=n.NamespaceIds.stylesheet.id;class s extends r.XFAObject{constructor(e){super(i,"stylesheet",!0)}}class o{static[n.$buildXFAObject](e,t){if(o.hasOwnProperty(e))return o[e](t)}static stylesheet(e){return new s(e)}}t.StylesheetNamespace=o},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XdpNamespace=void 0;var n=a(81),r=a(78),i=a(87);const s=n.NamespaceIds.xdp.id;class o extends i.XFAObject{constructor(e){super(s,"xdp",!0),this.uuid=e.uuid||"",this.timeStamp=e.timeStamp||"",this.config=null,this.connectionSet=null,this.datasets=null,this.localeSet=null,this.stylesheet=new i.XFAObjectArray,this.template=null}[r.$onChildCheck](e){const t=n.NamespaceIds[e[r.$nodeName]];return t&&e[r.$namespaceId]===t.id}}class c{static[n.$buildXFAObject](e,t){if(c.hasOwnProperty(e))return c[e](t)}static xdp(e){return new o(e)}}t.XdpNamespace=c},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XhtmlNamespace=void 0;var n=a(78),r=a(81),i=a(83),s=a(84),o=a(87);const c=r.NamespaceIds.xhtml.id,l=Symbol(),h=new Set(["color","font","font-family","font-size","font-stretch","font-style","font-weight","margin","margin-bottom","margin-left","margin-right","margin-top","letter-spacing","line-height","orphans","page-break-after","page-break-before","page-break-inside","tab-interval","tab-stop","text-align","text-decoration","text-indent","vertical-align","widows","kerning-mode","xfa-font-horizontal-scale","xfa-font-vertical-scale","xfa-spacerun","xfa-tab-stops"]),u=new Map([["page-break-after","breakAfter"],["page-break-before","breakBefore"],["page-break-inside","breakInside"],["kerning-mode",e=>"none"===e?"none":"normal"],["xfa-font-horizontal-scale",e=>`scaleX(${Math.max(0,Math.min(parseInt(e)/100)).toFixed(2)})`],["xfa-font-vertical-scale",e=>`scaleY(${Math.max(0,Math.min(parseInt(e)/100)).toFixed(2)})`],["xfa-spacerun",""],["xfa-tab-stops",""],["font-size",(e,t)=>(e=t.fontSize=(0,s.getMeasurement)(e),(0,i.measureToString)(.99*e))],["letter-spacing",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["line-height",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-bottom",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-left",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-right",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["margin-top",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["text-indent",e=>(0,i.measureToString)((0,s.getMeasurement)(e))],["font-family",e=>e],["vertical-align",e=>(0,i.measureToString)((0,s.getMeasurement)(e))]]),d=/\s+/g,f=/[\r\n]+/g,g=/\r\n?/g;function p(e,t,a){const r=Object.create(null);if(!e)return r;const o=Object.create(null);for(const[t,a]of e.split(";").map((e=>e.split(":",2)))){const e=u.get(t);if(""===e)continue;let n=a;e&&(n="string"==typeof e?e:e(a,o)),t.endsWith("scale")?r.transform=r.transform?`${r[t]} ${n}`:n:r[t.replaceAll(/-([a-zA-Z])/g,((e,t)=>t.toUpperCase()))]=n}if(r.fontFamily&&(0,i.setFontFamily)({typeface:r.fontFamily,weight:r.fontWeight||"normal",posture:r.fontStyle||"normal",size:o.fontSize||0},t,t[n.$globalData].fontFinder,r),a&&r.verticalAlign&&"0px"!==r.verticalAlign&&r.fontSize){const e=.583,t=.333,a=(0,s.getMeasurement)(r.fontSize);r.fontSize=(0,i.measureToString)(a*e),r.verticalAlign=(0,i.measureToString)(Math.sign((0,s.getMeasurement)(r.verticalAlign))*a*t)}return a&&r.fontSize&&(r.fontSize=`calc(${r.fontSize} * var(--scale-factor))`),(0,i.fixTextIndent)(r),r}const m=new Set(["body","html"]);class b extends o.XmlObject{constructor(e,t){super(c,t),this[l]=!1,this.style=e.style||""}[n.$clean](e){var t;super[n.$clean](e),this.style=(t=this).style?t.style.trim().split(/\s*;\s*/).filter((e=>!!e)).map((e=>e.split(/\s*:\s*/,2))).filter((([e,a])=>("font-family"===e&&t[n.$globalData].usedTypefaces.add(a),h.has(e)))).map((e=>e.join(":"))).join(";"):""}[n.$acceptWhitespace](){return!m.has(this[n.$nodeName])}[n.$onText](e,t=!1){t?this[l]=!0:(e=e.replaceAll(f,""),this.style.includes("xfa-spacerun:yes")||(e=e.replaceAll(d," "))),e&&(this[n.$content]+=e)}[n.$pushGlyphs](e,t=!0){const a=Object.create(null),r={top:NaN,bottom:NaN,left:NaN,right:NaN};let i=null;for(const[e,t]of this.style.split(";").map((e=>e.split(":",2))))switch(e){case"font-family":a.typeface=(0,s.stripQuotes)(t);break;case"font-size":a.size=(0,s.getMeasurement)(t);break;case"font-weight":a.weight=t;break;case"font-style":a.posture=t;break;case"letter-spacing":a.letterSpacing=(0,s.getMeasurement)(t);break;case"margin":const e=t.split(/ \t/).map((e=>(0,s.getMeasurement)(e)));switch(e.length){case 1:r.top=r.bottom=r.left=r.right=e[0];break;case 2:r.top=r.bottom=e[0],r.left=r.right=e[1];break;case 3:r.top=e[0],r.bottom=e[2],r.left=r.right=e[1];break;case 4:r.top=e[0],r.left=e[1],r.bottom=e[2],r.right=e[3]}break;case"margin-top":r.top=(0,s.getMeasurement)(t);break;case"margin-bottom":r.bottom=(0,s.getMeasurement)(t);break;case"margin-left":r.left=(0,s.getMeasurement)(t);break;case"margin-right":r.right=(0,s.getMeasurement)(t);break;case"line-height":i=(0,s.getMeasurement)(t)}if(e.pushData(a,r,i),this[n.$content])e.addString(this[n.$content]);else for(const t of this[n.$getChildren]())"#text"!==t[n.$nodeName]?t[n.$pushGlyphs](e):e.addString(t[n.$content]);t&&e.popFont()}[n.$toHTML](e){const t=[];if(this[n.$extra]={children:t},this[n.$childrenToHTML]({}),0===t.length&&!this[n.$content])return s.HTMLResult.EMPTY;let a;return a=this[l]?this[n.$content]?this[n.$content].replaceAll(g,"\n"):void 0:this[n.$content]||void 0,s.HTMLResult.success({name:this[n.$nodeName],attributes:{href:this.href,style:p(this.style,this,this[l])},children:t,value:a})}}class y extends b{constructor(e){super(e,"a"),this.href=(0,i.fixURL)(e.href)||""}}class w extends b{constructor(e){super(e,"b")}[n.$pushGlyphs](e){e.pushFont({weight:"bold"}),super[n.$pushGlyphs](e),e.popFont()}}class x extends b{constructor(e){super(e,"body")}[n.$toHTML](e){const t=super[n.$toHTML](e),{html:a}=t;return a?(a.name="div",a.attributes.class=["xfaRich"],t):s.HTMLResult.EMPTY}}class S extends b{constructor(e){super(e,"br")}[n.$text](){return"\n"}[n.$pushGlyphs](e){e.addString("\n")}[n.$toHTML](e){return s.HTMLResult.success({name:"br"})}}class A extends b{constructor(e){super(e,"html")}[n.$toHTML](e){const t=[];if(this[n.$extra]={children:t},this[n.$childrenToHTML]({}),0===t.length)return s.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:{}},value:this[n.$content]||""});if(1===t.length){const e=t[0];if(e.attributes?.class.includes("xfaRich"))return s.HTMLResult.success(e)}return s.HTMLResult.success({name:"div",attributes:{class:["xfaRich"],style:{}},children:t})}}class k extends b{constructor(e){super(e,"i")}[n.$pushGlyphs](e){e.pushFont({posture:"italic"}),super[n.$pushGlyphs](e),e.popFont()}}class C extends b{constructor(e){super(e,"li")}}class v extends b{constructor(e){super(e,"ol")}}class F extends b{constructor(e){super(e,"p")}[n.$pushGlyphs](e){super[n.$pushGlyphs](e,!1),e.addString("\n"),e.addPara(),e.popFont()}[n.$text](){return this[n.$getParent]()[n.$getChildren]().at(-1)===this?super[n.$text]():super[n.$text]()+"\n"}}class O extends b{constructor(e){super(e,"span")}}class I extends b{constructor(e){super(e,"sub")}}class T extends b{constructor(e){super(e,"sup")}}class M extends b{constructor(e){super(e,"ul")}}class P{static[r.$buildXFAObject](e,t){if(P.hasOwnProperty(e))return P[e](t)}static a(e){return new y(e)}static b(e){return new w(e)}static body(e){return new x(e)}static br(e){return new S(e)}static html(e){return new A(e)}static i(e){return new k(e)}static li(e){return new C(e)}static ol(e){return new v(e)}static p(e){return new F(e)}static span(e){return new O(e)}static sub(e){return new I(e)}static sup(e){return new T(e)}static ul(e){return new M(e)}}t.XhtmlNamespace=P},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.UnknownNamespace=void 0;var n=a(81),r=a(87);class i{constructor(e){this.namespaceId=e}[n.$buildXFAObject](e,t){return new r.XmlObject(this.namespaceId,e,t)}}t.UnknownNamespace=i},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.DatasetReader=void 0;var n=a(2),r=a(3),i=a(71);function s(e){try{return(0,n.stringToUTF8String)(e)}catch(t){return(0,n.warn)(`UTF-8 decoding failed: "${t}".`),e}}class o extends i.SimpleXMLParser{constructor(e){super(e),this.node=null}onEndElement(e){const t=super.onEndElement(e);if(t&&"xfa:datasets"===e)throw this.node=t,new Error("Aborting DatasetXMLParser.")}}t.DatasetReader=class{constructor(e){if(e.datasets)this.node=new i.SimpleXMLParser({hasAttributes:!0}).parseFromString(e.datasets).documentElement;else{const t=new o({hasAttributes:!0});try{t.parseFromString(e["xdp:xdp"])}catch{}this.node=t.node}}getValue(e){if(!this.node||!e)return"";const t=this.node.searchNode((0,r.parseXFAPath)(e),0);if(!t)return"";const a=t.firstChild;return"value"===a?.nodeName?t.children.map((e=>s(e.textContent))):s(t.textContent)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.XRef=void 0;var n=a(2),r=a(4),i=a(16),s=a(3),o=a(5),c=a(74);t.XRef=class{#D=null;constructor(e,t){this.stream=e,this.pdfManager=t,this.entries=[],this._xrefStms=new Set,this._cacheMap=new Map,this._pendingRefs=new r.RefSet,this._newPersistentRefNum=null,this._newTemporaryRefNum=null}getNewPersistentRef(e){null===this._newPersistentRefNum&&(this._newPersistentRefNum=this.entries.length||1);const t=this._newPersistentRefNum++;return this._cacheMap.set(t,e),r.Ref.get(t,0)}getNewTemporaryRef(){return null===this._newTemporaryRefNum&&(this._newTemporaryRefNum=this.entries.length||1),r.Ref.get(this._newTemporaryRefNum++,0)}resetNewTemporaryRef(){this._newTemporaryRefNum=null}setStartXRef(e){this.startXRefQueue=[e]}parse(e=!1){let t,a,i;e?((0,n.warn)("Indexing all PDF objects"),t=this.indexObjects()):t=this.readXRef(),t.assignXref(this),this.trailer=t;try{a=t.get("Encrypt")}catch(e){if(e instanceof s.MissingDataException)throw e;(0,n.warn)(`XRef.parse - Invalid "Encrypt" reference: "${e}".`)}if(a instanceof r.Dict){const e=t.get("ID"),n=e?.length?e[0]:"";a.suppressEncryption=!0,this.encrypt=new c.CipherTransformFactory(a,n,this.pdfManager.password)}try{i=t.get("Root")}catch(e){if(e instanceof s.MissingDataException)throw e;(0,n.warn)(`XRef.parse - Invalid "Root" reference: "${e}".`)}if(i instanceof r.Dict)try{if(i.get("Pages")instanceof r.Dict)return void(this.root=i)}catch(e){if(e instanceof s.MissingDataException)throw e;(0,n.warn)(`XRef.parse - Invalid "Pages" reference: "${e}".`)}if(!e)throw new s.XRefParseException;throw new n.InvalidPDFException("Invalid Root reference.")}processXRefTable(e){"tableState"in this||(this.tableState={entryNum:0,streamPos:e.lexer.stream.pos,parserBuf1:e.buf1,parserBuf2:e.buf2});const t=this.readXRefTable(e);if(!(0,r.isCmd)(t,"trailer"))throw new n.FormatError("Invalid XRef table: could not find trailer dictionary");let a=e.getObj();if(a instanceof r.Dict||!a.dict||(a=a.dict),!(a instanceof r.Dict))throw new n.FormatError("Invalid XRef table: could not parse trailer dictionary");return delete this.tableState,a}readXRefTable(e){const t=e.lexer.stream,a=this.tableState;let i;for(t.pos=a.streamPos,e.buf1=a.parserBuf1,e.buf2=a.parserBuf2;;){if(!("firstEntryNum"in a)||!("entryCount"in a)){if((0,r.isCmd)(i=e.getObj(),"trailer"))break;a.firstEntryNum=i,a.entryCount=e.getObj()}let s=a.firstEntryNum;const o=a.entryCount;if(!Number.isInteger(s)||!Number.isInteger(o))throw new n.FormatError("Invalid XRef table: wrong types in subsection header");for(let i=a.entryNum;i<o;i++){a.streamPos=t.pos,a.entryNum=i,a.parserBuf1=e.buf1,a.parserBuf2=e.buf2;const c={};c.offset=e.getObj(),c.gen=e.getObj();const l=e.getObj();if(l instanceof r.Cmd)switch(l.cmd){case"f":c.free=!0;break;case"n":c.uncompressed=!0}if(!Number.isInteger(c.offset)||!Number.isInteger(c.gen)||!c.free&&!c.uncompressed)throw new n.FormatError(`Invalid entry in XRef subsection: ${s}, ${o}`);0===i&&c.free&&1===s&&(s=0),this.entries[i+s]||(this.entries[i+s]=c)}a.entryNum=0,a.streamPos=t.pos,a.parserBuf1=e.buf1,a.parserBuf2=e.buf2,delete a.firstEntryNum,delete a.entryCount}if(this.entries[0]&&!this.entries[0].free)throw new n.FormatError("Invalid XRef table: unexpected first object");return i}processXRefStream(e){if(!("streamState"in this)){const t=e.dict,a=t.get("W");let n=t.get("Index");n||(n=[0,t.get("Size")]),this.streamState={entryRanges:n,byteWidths:a,entryNum:0,streamPos:e.pos}}return this.readXRefStream(e),delete this.streamState,e.dict}readXRefStream(e){const t=this.streamState;e.pos=t.streamPos;const[a,r,i]=t.byteWidths,s=t.entryRanges;for(;s.length>0;){const[o,c]=s;if(!Number.isInteger(o)||!Number.isInteger(c))throw new n.FormatError(`Invalid XRef range fields: ${o}, ${c}`);if(!Number.isInteger(a)||!Number.isInteger(r)||!Number.isInteger(i))throw new n.FormatError(`Invalid XRef entry fields length: ${o}, ${c}`);for(let s=t.entryNum;s<c;++s){t.entryNum=s,t.streamPos=e.pos;let c=0,l=0,h=0;for(let t=0;t<a;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'type'.");c=c<<8|t}0===a&&(c=1);for(let t=0;t<r;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'offset'.");l=l<<8|t}for(let t=0;t<i;++t){const t=e.getByte();if(-1===t)throw new n.FormatError("Invalid XRef byteWidths 'generation'.");h=h<<8|t}const u={};switch(u.offset=l,u.gen=h,c){case 0:u.free=!0;break;case 1:u.uncompressed=!0;break;case 2:break;default:throw new n.FormatError(`Invalid XRef entry type: ${c}`)}this.entries[o+s]||(this.entries[o+s]=u)}t.entryNum=0,t.streamPos=e.pos,s.splice(0,2)}}indexObjects(){function e(e,t){let a="",n=e[t];for(;10!==n&&13!==n&&60!==n&&!(++t>=e.length);)a+=String.fromCharCode(n),n=e[t];return a}function t(e,t,a){const n=a.length,r=e.length;let i=0;for(;t<r;){let r=0;for(;r<n&&e[t+r]===a[r];)++r;if(r>=n)break;t++,i++}return i}const a=/\b(endobj|\d+\s+\d+\s+obj|xref|trailer\s*<<)\b/g,o=/\b(startxref|\d+\s+\d+\s+obj)\b/g,c=/^(\d+)\s+(\d+)\s+obj\b/,l=new Uint8Array([116,114,97,105,108,101,114]),h=new Uint8Array([115,116,97,114,116,120,114,101,102]),u=new Uint8Array([47,88,82,101,102]);this.entries.length=0,this._cacheMap.clear();const d=this.stream;d.pos=0;const f=d.getBytes(),g=(0,n.bytesToString)(f),p=f.length;let m=d.start;const b=[],y=[];for(;m<p;){let r=f[m];if(9===r||10===r||13===r||32===r){++m;continue}if(37===r){do{if(++m,m>=p)break;r=f[m]}while(10!==r&&13!==r);continue}const w=e(f,m);let x;if(w.startsWith("xref")&&(4===w.length||/\s/.test(w[4])))m+=t(f,m,l),b.push(m),m+=t(f,m,h);else if(x=c.exec(w)){const e=0|x[1],r=0|x[2],o=m+w.length;let c,l=!1;if(this.entries[e]){if(this.entries[e].gen===r)try{new i.Parser({lexer:new i.Lexer(d.makeSubStream(o))}).getObj(),l=!0}catch(e){e instanceof s.ParserEOFException?(0,n.warn)(`indexObjects -- checking object (${w}): "${e}".`):l=!0}}else l=!0;l&&(this.entries[e]={offset:m-d.start,gen:r,uncompressed:!0}),a.lastIndex=o;const h=a.exec(g);if(h){c=a.lastIndex+1-m,"endobj"!==h[1]&&((0,n.warn)(`indexObjects: Found "${h[1]}" inside of another "obj", caused by missing "endobj" -- trying to recover.`),c-=h[1].length+1)}else c=p-m;const b=f.subarray(m,m+c),S=t(b,0,u);S<c&&b[S+5]<64&&(y.push(m-d.start),this._xrefStms.add(m-d.start)),m+=c}else if(w.startsWith("trailer")&&(7===w.length||/\s/.test(w[7]))){b.push(m);const e=m+w.length;let t;o.lastIndex=e;const a=o.exec(g);if(a){t=o.lastIndex+1-m,"startxref"!==a[1]&&((0,n.warn)(`indexObjects: Found "${a[1]}" after "trailer", caused by missing "startxref" -- trying to recover.`),t-=a[1].length+1)}else t=p-m;m+=t}else m+=w.length+1}for(const e of y)this.startXRefQueue.push(e),this.readXRef(!0);const w=[];let x,S,A=!1;for(const e of b){d.pos=e;const t=new i.Parser({lexer:new i.Lexer(d),xref:this,allowStreams:!0,recoveryMode:!0}),a=t.getObj();if(!(0,r.isCmd)(a,"trailer"))continue;const n=t.getObj();n instanceof r.Dict&&(w.push(n),n.has("Encrypt")&&(A=!0))}for(const e of[...w,"genFallback",...w]){if("genFallback"===e){if(!S)break;this._generationFallback=!0;continue}let t=!1;try{const a=e.get("Root");if(!(a instanceof r.Dict))continue;const n=a.get("Pages");if(!(n instanceof r.Dict))continue;const i=n.get("Count");Number.isInteger(i)&&(t=!0)}catch(e){S=e;continue}if(t&&(!A||e.has("Encrypt"))&&e.has("ID"))return e;x=e}if(x)return x;if(this.topDict)return this.topDict;throw new n.InvalidPDFException("Invalid PDF structure.")}readXRef(e=!1){const t=this.stream,a=new Set;for(;this.startXRefQueue.length;){try{const e=this.startXRefQueue[0];if(a.has(e)){(0,n.warn)("readXRef - skipping XRef table since it was already parsed."),this.startXRefQueue.shift();continue}a.add(e),t.pos=e+t.start;const s=new i.Parser({lexer:new i.Lexer(t),xref:this,allowStreams:!0});let c,l=s.getObj();if((0,r.isCmd)(l,"xref"))c=this.processXRefTable(s),this.topDict||(this.topDict=c),l=c.get("XRefStm"),Number.isInteger(l)&&!this._xrefStms.has(l)&&(this._xrefStms.add(l),this.startXRefQueue.push(l),this.#D??=l);else{if(!Number.isInteger(l))throw new n.FormatError("Invalid XRef stream header");if(!(Number.isInteger(s.getObj())&&(0,r.isCmd)(s.getObj(),"obj")&&(l=s.getObj())instanceof o.BaseStream))throw new n.FormatError("Invalid XRef stream");if(c=this.processXRefStream(l),this.topDict||(this.topDict=c),!c)throw new n.FormatError("Failed to read XRef stream")}l=c.get("Prev"),Number.isInteger(l)?this.startXRefQueue.push(l):l instanceof r.Ref&&this.startXRefQueue.push(l.num)}catch(e){if(e instanceof s.MissingDataException)throw e;(0,n.info)("(while reading XRef): "+e)}this.startXRefQueue.shift()}if(this.topDict)return this.topDict;if(!e)throw new s.XRefParseException}get lastXRefStreamPos(){return this.#D??(this._xrefStms.size>0?Math.max(...this._xrefStms):null)}getEntry(e){const t=this.entries[e];return t&&!t.free&&t.offset?t:null}fetchIfRef(e,t=!1){return e instanceof r.Ref?this.fetch(e,t):e}fetch(e,t=!1){if(!(e instanceof r.Ref))throw new Error("ref object is not a reference");const a=e.num,i=this._cacheMap.get(a);if(void 0!==i)return i instanceof r.Dict&&!i.objId&&(i.objId=e.toString()),i;let s=this.getEntry(a);if(null===s)return this._cacheMap.set(a,s),s;if(this._pendingRefs.has(e))return this._pendingRefs.remove(e),(0,n.warn)(`Ignoring circular reference: ${e}.`),r.CIRCULAR_REF;this._pendingRefs.put(e);try{s=s.uncompressed?this.fetchUncompressed(e,s,t):this.fetchCompressed(e,s,t),this._pendingRefs.remove(e)}catch(t){throw this._pendingRefs.remove(e),t}return s instanceof r.Dict?s.objId=e.toString():s instanceof o.BaseStream&&(s.dict.objId=e.toString()),s}fetchUncompressed(e,t,a=!1){const c=e.gen;let l=e.num;if(t.gen!==c){const i=`Inconsistent generation in XRef: ${e}`;if(this._generationFallback&&t.gen<c)return(0,n.warn)(i),this.fetchUncompressed(r.Ref.get(l,t.gen),t,a);throw new s.XRefEntryException(i)}const h=this.stream.makeSubStream(t.offset+this.stream.start),u=new i.Parser({lexer:new i.Lexer(h),xref:this,allowStreams:!0}),d=u.getObj(),f=u.getObj(),g=u.getObj();if(d!==l||f!==c||!(g instanceof r.Cmd))throw new s.XRefEntryException(`Bad (uncompressed) XRef entry: ${e}`);if("obj"!==g.cmd){if(g.cmd.startsWith("obj")&&(l=parseInt(g.cmd.substring(3),10),!Number.isNaN(l)))return l;throw new s.XRefEntryException(`Bad (uncompressed) XRef entry: ${e}`)}return(t=this.encrypt&&!a?u.getObj(this.encrypt.createCipherTransform(l,c)):u.getObj())instanceof o.BaseStream||this._cacheMap.set(l,t),t}fetchCompressed(e,t,a=!1){const c=t.offset,l=this.fetch(r.Ref.get(c,0));if(!(l instanceof o.BaseStream))throw new n.FormatError("bad ObjStm stream");const h=l.dict.get("First"),u=l.dict.get("N");if(!Number.isInteger(h)||!Number.isInteger(u))throw new n.FormatError("invalid first and n parameters for ObjStm stream");let d=new i.Parser({lexer:new i.Lexer(l),xref:this,allowStreams:!0});const f=new Array(u),g=new Array(u);for(let e=0;e<u;++e){const t=d.getObj();if(!Number.isInteger(t))throw new n.FormatError(`invalid object number in the ObjStm stream: ${t}`);const a=d.getObj();if(!Number.isInteger(a))throw new n.FormatError(`invalid object offset in the ObjStm stream: ${a}`);f[e]=t,g[e]=a}const p=(l.start||0)+h,m=new Array(u);for(let e=0;e<u;++e){const t=e<u-1?g[e+1]-g[e]:void 0;if(t<0)throw new n.FormatError("Invalid offset in the ObjStm stream.");d=new i.Parser({lexer:new i.Lexer(l.makeSubStream(p+g[e],t,l.dict)),xref:this,allowStreams:!0});const a=d.getObj();if(m[e]=a,a instanceof o.BaseStream)continue;const r=f[e],s=this.entries[r];s&&s.offset===c&&s.gen===e&&this._cacheMap.set(r,a)}if(void 0===(t=m[t.gen]))throw new s.XRefEntryException(`Bad (compressed) XRef entry: ${e}`);return t}async fetchIfRefAsync(e,t){return e instanceof r.Ref?this.fetchAsync(e,t):e}async fetchAsync(e,t){try{return this.fetch(e,t)}catch(a){if(!(a instanceof s.MissingDataException))throw a;return await this.pdfManager.requestRange(a.begin,a.end),this.fetchAsync(e,t)}}getCatalogObj(){return this.root}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.MessageHandler=void 0;var n=a(2);const r=1,i=2,s=1,o=2,c=3,l=4,h=5,u=6,d=7,f=8;function g(e){switch(e instanceof Error||"object"==typeof e&&null!==e||(0,n.unreachable)('wrapReason: Expected "reason" to be a (possibly cloned) Error.'),e.name){case"AbortException":return new n.AbortException(e.message);case"MissingPDFException":return new n.MissingPDFException(e.message);case"PasswordException":return new n.PasswordException(e.message,e.code);case"UnexpectedResponseException":return new n.UnexpectedResponseException(e.message,e.status);case"UnknownErrorException":return new n.UnknownErrorException(e.message,e.details);default:return new n.UnknownErrorException(e.message,e.toString())}}t.MessageHandler=class{constructor(e,t,a){this.sourceName=e,this.targetName=t,this.comObj=a,this.callbackId=1,this.streamId=1,this.streamSinks=Object.create(null),this.streamControllers=Object.create(null),this.callbackCapabilities=Object.create(null),this.actionHandler=Object.create(null),this._onComObjOnMessage=e=>{const t=e.data;if(t.targetName!==this.sourceName)return;if(t.stream)return void this.#R(t);if(t.callback){const e=t.callbackId,a=this.callbackCapabilities[e];if(!a)throw new Error(`Cannot resolve callback ${e}`);if(delete this.callbackCapabilities[e],t.callback===r)a.resolve(t.data);else{if(t.callback!==i)throw new Error("Unexpected callback case");a.reject(g(t.reason))}return}const n=this.actionHandler[t.action];if(!n)throw new Error(`Unknown action from worker: ${t.action}`);if(t.callbackId){const e=this.sourceName,s=t.sourceName;new Promise((function(e){e(n(t.data))})).then((function(n){a.postMessage({sourceName:e,targetName:s,callback:r,callbackId:t.callbackId,data:n})}),(function(n){a.postMessage({sourceName:e,targetName:s,callback:i,callbackId:t.callbackId,reason:g(n)})}))}else t.streamId?this.#E(t):n(t.data)},a.addEventListener("message",this._onComObjOnMessage)}on(e,t){const a=this.actionHandler;if(a[e])throw new Error(`There is already an actionName called "${e}"`);a[e]=t}send(e,t,a){this.comObj.postMessage({sourceName:this.sourceName,targetName:this.targetName,action:e,data:t},a)}sendWithPromise(e,t,a){const r=this.callbackId++,i=new n.PromiseCapability;this.callbackCapabilities[r]=i;try{this.comObj.postMessage({sourceName:this.sourceName,targetName:this.targetName,action:e,callbackId:r,data:t},a)}catch(e){i.reject(e)}return i.promise}sendWithStream(e,t,a,r){const i=this.streamId++,o=this.sourceName,c=this.targetName,l=this.comObj;return new ReadableStream({start:a=>{const s=new n.PromiseCapability;return this.streamControllers[i]={controller:a,startCall:s,pullCall:null,cancelCall:null,isClosed:!1},l.postMessage({sourceName:o,targetName:c,action:e,streamId:i,data:t,desiredSize:a.desiredSize},r),s.promise},pull:e=>{const t=new n.PromiseCapability;return this.streamControllers[i].pullCall=t,l.postMessage({sourceName:o,targetName:c,stream:u,streamId:i,desiredSize:e.desiredSize}),t.promise},cancel:e=>{(0,n.assert)(e instanceof Error,"cancel must have a valid reason");const t=new n.PromiseCapability;return this.streamControllers[i].cancelCall=t,this.streamControllers[i].isClosed=!0,l.postMessage({sourceName:o,targetName:c,stream:s,streamId:i,reason:g(e)}),t.promise}},a)}#E(e){const t=e.streamId,a=this.sourceName,r=e.sourceName,i=this.comObj,s=this,o=this.actionHandler[e.action],u={enqueue(e,s=1,o){if(this.isCancelled)return;const c=this.desiredSize;this.desiredSize-=s,c>0&&this.desiredSize<=0&&(this.sinkCapability=new n.PromiseCapability,this.ready=this.sinkCapability.promise),i.postMessage({sourceName:a,targetName:r,stream:l,streamId:t,chunk:e},o)},close(){this.isCancelled||(this.isCancelled=!0,i.postMessage({sourceName:a,targetName:r,stream:c,streamId:t}),delete s.streamSinks[t])},error(e){(0,n.assert)(e instanceof Error,"error must have a valid reason"),this.isCancelled||(this.isCancelled=!0,i.postMessage({sourceName:a,targetName:r,stream:h,streamId:t,reason:g(e)}))},sinkCapability:new n.PromiseCapability,onPull:null,onCancel:null,isCancelled:!1,desiredSize:e.desiredSize,ready:null};u.sinkCapability.resolve(),u.ready=u.sinkCapability.promise,this.streamSinks[t]=u,new Promise((function(t){t(o(e.data,u))})).then((function(){i.postMessage({sourceName:a,targetName:r,stream:f,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:a,targetName:r,stream:f,streamId:t,reason:g(e)})}))}#R(e){const t=e.streamId,a=this.sourceName,r=e.sourceName,i=this.comObj,p=this.streamControllers[t],m=this.streamSinks[t];switch(e.stream){case f:e.success?p.startCall.resolve():p.startCall.reject(g(e.reason));break;case d:e.success?p.pullCall.resolve():p.pullCall.reject(g(e.reason));break;case u:if(!m){i.postMessage({sourceName:a,targetName:r,stream:d,streamId:t,success:!0});break}m.desiredSize<=0&&e.desiredSize>0&&m.sinkCapability.resolve(),m.desiredSize=e.desiredSize,new Promise((function(e){e(m.onPull?.())})).then((function(){i.postMessage({sourceName:a,targetName:r,stream:d,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:a,targetName:r,stream:d,streamId:t,reason:g(e)})}));break;case l:if((0,n.assert)(p,"enqueue should have stream controller"),p.isClosed)break;p.controller.enqueue(e.chunk);break;case c:if((0,n.assert)(p,"close should have stream controller"),p.isClosed)break;p.isClosed=!0,p.controller.close(),this.#B(p,t);break;case h:(0,n.assert)(p,"error should have stream controller"),p.controller.error(g(e.reason)),this.#B(p,t);break;case o:e.success?p.cancelCall.resolve():p.cancelCall.reject(g(e.reason)),this.#B(p,t);break;case s:if(!m)break;new Promise((function(t){t(m.onCancel?.(g(e.reason)))})).then((function(){i.postMessage({sourceName:a,targetName:r,stream:o,streamId:t,success:!0})}),(function(e){i.postMessage({sourceName:a,targetName:r,stream:o,streamId:t,reason:g(e)})})),m.sinkCapability.reject(g(e.reason)),m.isCancelled=!0,delete this.streamSinks[t];break;default:throw new Error("Unexpected stream case")}}async#B(e,t){await Promise.allSettled([e.startCall?.promise,e.pullCall?.promise,e.cancelCall?.promise]),delete this.streamControllers[t]}destroy(){this.comObj.removeEventListener("message",this._onComObjOnMessage)}}},(e,t,a)=>{Object.defineProperty(t,"__esModule",{value:!0}),t.PDFWorkerStream=void 0;var n=a(2);t.PDFWorkerStream=class{constructor(e){this._msgHandler=e,this._contentLength=null,this._fullRequestReader=null,this._rangeRequestReaders=[]}getFullReader(){return(0,n.assert)(!this._fullRequestReader,"PDFWorkerStream.getFullReader can only be called once."),this._fullRequestReader=new r(this._msgHandler),this._fullRequestReader}getRangeReader(e,t){const a=new i(e,t,this._msgHandler);return this._rangeRequestReaders.push(a),a}cancelAllRequests(e){this._fullRequestReader?.cancel(e);for(const t of this._rangeRequestReaders.slice(0))t.cancel(e)}};class r{constructor(e){this._msgHandler=e,this.onProgress=null,this._contentLength=null,this._isRangeSupported=!1,this._isStreamingSupported=!1;const t=this._msgHandler.sendWithStream("GetReader");this._reader=t.getReader(),this._headersReady=this._msgHandler.sendWithPromise("ReaderHeadersReady").then((e=>{this._isStreamingSupported=e.isStreamingSupported,this._isRangeSupported=e.isRangeSupported,this._contentLength=e.contentLength}))}get headersReady(){return this._headersReady}get contentLength(){return this._contentLength}get isStreamingSupported(){return this._isStreamingSupported}get isRangeSupported(){return this._isRangeSupported}async read(){const{value:e,done:t}=await this._reader.read();return t?{value:void 0,done:!0}:{value:e.buffer,done:!1}}cancel(e){this._reader.cancel(e)}}class i{constructor(e,t,a){this._msgHandler=a,this.onProgress=null;const n=this._msgHandler.sendWithStream("GetRangeReader",{begin:e,end:t});this._reader=n.getReader()}get isStreamingSupported(){return!1}async read(){const{value:e,done:t}=await this._reader.read();return t?{value:void 0,done:!0}:{value:e.buffer,done:!1}}cancel(e){this._reader.cancel(e)}}}],t={};function a(n){var r=t[n];if(void 0!==r)return r.exports;var i=t[n]={exports:{}};return e[n](i,i.exports,a),i.exports}var n={};return(()=>{var e=n;Object.defineProperty(e,"__esModule",{value:!0}),Object.defineProperty(e,"WorkerMessageHandler",{enumerable:!0,get:function(){return t.WorkerMessageHandler}});var t=a(1)})(),n})()));